;;; Sierra Script 1.0 - (do not remove this comment)
(script# 700)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TargActor)
(use Intrface)
(use n702)
(use LoadMany)
(use Grooper)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)


(local
	newActor
	newActor_2
	theIsMoving
	theGEgoLocXCoord_2
	theGEgoLocYCoord_2
	local5
	local6
	[local7 26] = [92 174 100 156 108 139 115 128 121 115 126 105 129 97 131 90 134 84 136 81 138 74 139 69 140 66]
	[local33 26] = [226 174 218 154 210 139 206 128 201 116 197 106 194 97 191 92 188 86 185 82 182 76 179 72 176 67]
	[local59 26] = [92 174 100 156 108 139 114 127 120 116 124 105 129 97 131 92 134 84 136 81 138 76 139 72 140 67]
	[local85 26] = [226 174 218 154 210 139 206 128 201 116 197 106 194 97 191 92 188 86 185 82 182 76 179 72 176 67]
	[local111 39] = [95 224 85 102 216 79 110 209 73 115 204 69 120 199 64 124 194 60 127 192 56 128 190 54 129 190 52 130 188 51 131 187 49 134 184 47 136 183 45]
	[local150 24] = [701 0 700 4 700 2 700 0 700 0 701 2 701 4 708 0 700 0 701 8 700 1 700 6]
	[local174 12] = [{ AFDoor} { AFCorner} { AFEnd} { AFEndDoorway} { AFEndDoor} { AFPassage} { AFSconce} { AFPlaza} { AFHorzCrack} { AFFrontCorner} { AFEndSideDoor} { AFBarricade}]
	[theLookStr 6] = [{Someone probably lives behind this door.} {It's a door.__No doubt about it.} {Through this door lies the other side.} {I'll take what's behind door number 3.} {Huh?__It's only PAINTED on.} {If you lived here, you'd be home now.}]
	[theLookStr_2 6] = [{The flame in the sconce gives a steady light.} {The wall is carrying a torch for you.} {Meager light, but ample.} {The light helps to relieve the gloom of this street.} {Just another sconce.} {Just another flame.}]
	[local198 6] = [{You can hear termites chewing.} {You hear door-like sounds.} {Behind the locked door, you hear a family quarrel.__Better not get involved._} {Someone is whistling a familiar tune in an odd key behind this door.} {Someone behind this door is repeatedly saying 'Ma fhimt.'__You don't understand.} {Sounds like work going on behind this door.}]
	[local204 300]
	[local504 100]
)
(procedure (localproc_170a param1 param2 param3 param4)
	(if (> param1 0)
		(param2 streetName: param3 param4)
		(return)
	else
		(switch (- param1)
			(269 {Zrir Darb})
			(120 {Money Changer})
			(200 {Astrologer})
			(199 {Sitt Tarik})
			(229 {Sahir Tarik})
			(271 {Saif Darb})
			(440
				{Ignorance of the law is no excuse}
			)
			(429
				{You must carry your Visa at all times}
			)
			(else  0)
		)
		(return)
	)
)

(class AFeat of View
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description {a door}
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $6004
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		type $0000
		side 0
		pos 0
		fake 0
		illegalBits $0000
	)
	
	(method (new param1 param2 param3)
		((super new:)
			type: param1
			side: param2
			pos: param3
			view: [local150 (+ (* param1 2) 0)]
			loop: (+ [local150 (+ (* param1 2) 1)] (== param2 1))
			palette:
				(if
				(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
					1
				else
					2
				)
		)
	)
	
	(method (init)
		(cond 
			((OneOf type 0 10)
				(= description {the door})
				(= noun '/door')
				(= lookStr [theLookStr (Random 0 4)])
			)
			((== type 6)
				(= description {the sconce})
				(= noun '/sconce,light,lamp')
				(= lookStr [theLookStr_2 (Random 0 5)])
			)
			((== type 11)
				(= description {the barricade})
				(= noun '/board,barricade,sign')
				(= lookStr
					{This street has been barricaded off.__The sign reads 'Road closed by order of Khaveen'.}
				)
			)
		)
		(cond 
			((OneOf type 1 2 3 7 10 11) (self posn: 160 79 setPri: 2))
			((== type 4) (self posn: 174 75 setPri: 2))
			((== type 6) (self setPri: 15))
			((== type 8) (self setPri: 0 x: 160))
		)
		(super init:)
	)
	
	(method (showSelf)
		(if (== type 8) (return))
		(curRoom pos2Coords: pos)
		(Print
			(Format
				@local204
				700
				2
				pos
				(switch side
					(0 {Left})
					(1 {Right})
					(2 {Center})
				)
				theGEgoLocXCoord_2
				theGEgoLocYCoord_2
				cel
				priority
			)
			#icon
			view
			loop
			cel
			#title
			[local174 type]
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== type 11) (if (Said 'read/sign') (super doVerb: 1)))
			((not (OneOf type 0 10)))
			(
				(or
					(Said 'lockpick[/lock]')
					(Said 'use/(lockpick[<lock]),lockpick')
					(Said 'unlock')
				)
				(cond 
					((not (CanPickLocks 1)))
					((> cel 1) (HighPrint 700 0))
					(else (ego setScript: pickLock 0 self))
				)
			)
			((Said 'listen') (HighPrint [local198 (Random 0 5)]))
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(if (OneOf type 0 10) (HighPrint 700 1))
			)
			(else  (super doVerb: theVerb))
		)
	)
	
	(method (onMe)
		(return
			(if (OneOf type 0 10 6 11)
				(return (super onMe: &rest))
			else
				(return 0)
			)
		)
	)
	
	(method (hide)
		(if (not (& signal $0088)) (super hide:))
	)
	
	(method (redraw param1 &tmp temp0 temp1 temp2 temp3)
		(if
			(not
				(if (< -1 (= temp0 (- pos param1))) (< temp0 13))
			)
			(if (== type 8)
				(= pos (+ pos 11))
				(= temp0 (- pos param1))
			else
				(self hide:)
				(return)
			)
		)
		(cond 
			((OneOf type 0 5 9)
				(cond 
					((== type 0)
						(if (== side 0)
							(= temp2 [local7 (* temp0 2)])
							(= temp3 [local7 (+ (* temp0 2) 1)])
						else
							(= temp2 [local33 (* temp0 2)])
							(= temp3 [local33 (+ (* temp0 2) 1)])
						)
					)
					((== side 0)
						(= temp2 [local59 (* temp0 2)])
						(= temp3 [local59 (+ (* temp0 2) 1)])
					)
					(else
						(= temp2 [local85 (* temp0 2)])
						(= temp3 [local85 (+ (* temp0 2) 1)])
					)
				)
				(self posn: temp2 temp3 cel: temp0 setPri: -1)
				(cond 
					((== cel 0)
						(self setPri: 12)
						(= temp1 (if side 8192 else 512))
						(if (not fake) (ego ignoreControl: temp1))
					)
					((== cel 1)
						(self setPri: 10)
						(= temp1 (if side 16384 else 2048))
						(if (not fake) (ego ignoreControl: temp1))
					)
				)
			)
			((OneOf type 1 2 3 7 10 11)
				(if (> temp0 9)
					(= cel (- (self lastCel:) (- temp0 9)))
				else
					(= cel (self lastCel:))
					(if (== type 1)
						(= temp1 (if side 4096 else 1024))
						(ego ignoreControl: temp1)
					)
				)
				(if (OneOf type 3 7) (ego ignoreControl: 128))
			)
			((== type 4) (if (> temp0 9) (self hide:) (return) else (= cel 0)))
			((== type 6)
				(self
					posn: [local111 (+ (* temp0 3) side)] [local111 (+ (* temp0 3) 2)]
					cel: temp0
				)
			)
			((== type 8)
				(if
					((curRoom alleyFeatures?)
						firstTrue: #perform isOpeningHere pos
					)
					(self hide:)
					(return)
				else
					(self y: [local7 (+ (* temp0 2) 1)])
				)
			)
		)
		(self forceUpd: show:)
	)
	
	(method (showFront param1)
		(if (>= pos (- param1 1)) (self showSelf:))
	)
)

(instance isOpeningHere of Code
	(properties)
	
	(method (doit param1 param2)
		(if (== (param1 pos?) param2)
			(OneOf (param1 type?) 0 5 9)
		)
	)
)

(class AlleyRoom of Rm
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		picture 700
		style $000f
		horizon 0
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY 50
		obstacles 0
		alley 0
		length 0
		scrBotPos 0
		dX 0
		dY 0
		alleyFeatures 0
		facingX 0
		facingY 0
		facingHeading 0
		orientation 0
		isScrolling 0
		isMoving 0
		nextTee 0
	)
	
	(method (init)
		(LoadMany 128 700 701 708 711)
		(LoadMany 130 701 702)
		(exploder init:)
		(gKeyH addToFront: self)
		(gMouseH addToFront: self)
		(gDirH addToFront: self)
		(= facingHeading gTopExit)
		(= gGDftSC gAllSC)
		(ego edgeHit: 0 init:)
		(self newAlley: (proc702_0))
		(super init:)
	)
	
	(method (doit &tmp temp0 temp1 egoCycler temp3 temp4)
		(super doit:)
		(= temp4 (IsObject (= egoCycler (ego cycler?))))
		(cond 
			((or script local5 (ego script?)))
			((and temp4 (egoCycler isMemberOf: Grycler)))
			((& $7e80 (ego onControl:))
				(if (& $7e80 (= temp0 (ego onControl: 1)))
					(self exitAlley: temp0)
				)
			)
			(
				(and
					(>= (ego y?) 179)
					(!= (theGame script?) randomCrossers)
				)
				(self turnAround:)
			)
			((not isScrolling))
			((not isMoving) (if theIsMoving (ChangeEgoWalk -1 0)))
			((!= (ego loop?) 3) (if (not temp4) (ChangeEgoWalk -1 0)))
			((and isScrolling (<= (- length scrBotPos) 9))
				(= isScrolling 0)
				(ChangeEgoWalk -1 0)
				(ego setDirection: 1)
				(if (and (== scrBotPos nextTee) nextTee)
					(self crossIntersection:)
				)
			)
			(else
				(if (ego mover?) (ego setMotion: 0))
				(if (== (ego view?) 4) (ChangeEgoWalk -1 0))
				(if (IsObject (ego cycler?)) (ego setCycle: 0))
				(if
				(> (= temp1 (+ (ego cel?) 1)) (ego lastCel:))
					(= temp1 0)
				)
				(ego cel: temp1 forceUpd:)
				(= temp3 0)
				(cond 
					((or (== egoWalkMode 2) (== (ego xStep?) 1)) (if (not temp1) (= temp3 1)))
					((== egoWalkMode 1) (= temp3 1))
					((not (& temp1 $0001)) (= temp3 1))
				)
				(if temp3
					(ego observeControl: -384)
					(alleyFeatures eachElementDo: #redraw scrBotPos)
					(++ scrBotPos)
				)
			)
		)
		(= theIsMoving isMoving)
		(if suckBlueFrog
			(self egoPos2Coords:)
			(DrawStatus
				(Format
					@local204
					700
					9
					(alley name?)
					(StrAt {NESW} (- facingHeading 1))
					gEgoLocXCoord
					gEgoLocYCoord
				)
			)
		)
	)
	
	(method (dispose)
		(gKeyH delete: self)
		(gMouseH delete: self)
		(gDirH delete: self)
		(DisposeScript AlleyRoom)
		(DisposeScript 701)
		(alleyFeatures dispose:)
		(super dispose:)
	)
	
	(method (showSelf)
		(Print
			(Format
				@local204
				700
				6
				length
				scrBotPos
				dX
				dY
				facingX
				facingY
				facingHeading
				orientation
				(ego priority?)
			)
			#title
			(alley name?)
		)
	)
	
	(method (handleEvent pEvent)
		(if
		(and suckBlueFrog (== (pEvent message?) KEY_ALT_f))
			(self showFront:)
			(pEvent claimed: 1)
			(return)
		)
		(if
		(and suckBlueFrog (== (pEvent message?) KEY_ALT_a))
			(self showAll:)
			(pEvent claimed: 1)
			(return)
		)
		(if
			(and
				(OneOf (pEvent type?) 1 64)
				(or (not isScrolling) (not (User controls?)))
			)
			(pEvent claimed: 0)
			(return)
		)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(if (not (pEvent modifiers?))
					(if (< 137 (pEvent y?))
						(if isMoving (= isMoving 0) (pEvent claimed: 1))
					else
						(= isMoving 1)
						(ego loop: 3)
						(pEvent claimed: 1)
					)
				)
			)
			(evJOYSTICK
				(cond 
					((OneOf (pEvent message?) 1 2 8)
						(if (and isMoving (== (ego loop?) 3))
							(= isMoving 0)
						else
							(= isMoving 1)
							(ego loop: 3)
						)
						(pEvent claimed: 1)
					)
					((== (pEvent message?) JOY_NULL)
						(= isMoving 0)
						(ego setMotion: 0 setCycle: 0)
						(pEvent claimed: 1)
					)
					(else (= isMoving 1))
				)
			)
			(evSAID
				(cond 
					((Said 'look,examine,read/sign') (if (not (self showSign:)) (HighPrint 700 7)))
					(
						(and
							(Said
								'look,examine[/alley,passage,street,road,wall,ground]'
							)
							(not (self showSign:))
						)
						(HighPrint 700 8)
					)
				)
			)
		)
		(pEvent claimed?)
	)
	
	(method (add param1 param2 param3 param4)
		(if
		(and (not param3) (OneOf param1 2 3 4 7 11 10))
			(return)
		)
		(if (!= orientation facingHeading)
			(= param2
				(switch param2
					(0 1)
					(1 0)
					(else  param2)
				))
		)
		(alleyFeatures
			add:
				((self newFeature: param1 param2 param3)
					fake: (if (< argc 4) 0 else param4)
					init:
					redraw: scrBotPos
					yourself:
				)
		)
	)
	
	(method (addFeatures param1 param2 &tmp temp0)
		(if (& param1 $0004)
			(self add: 6 0 param2)
			(= param1 (& param1 $fffb))
		)
		(if (& param1 $0008)
			(self add: 6 1 param2)
			(= param1 (& param1 $fff7))
		)
		(if (& param1 $0010) (= param1 (& param1 $ffef)))
		(if (& param1 $0020) (= param1 (& param1 $ffdf)))
		(if (& param1 $0400)
			(= param1 (& param1 $fbff))
			(= temp0 1)
		else
			(= temp0 0)
		)
		(switch param1
			(1 (self add: 0 0 param2 temp0))
			(2 (self add: 0 1 param2 temp0))
			(257 (self add: 5 0 param2))
			(258 (self add: 5 1 param2))
			(259
				(self add: 5 0 param2)
				(self add: 5 1 param2)
			)
			(769
				(if param2
					(self add: 1 0 param2)
					(self add: 2 1 param2)
				else
					(self add: 9 0 param2)
				)
			)
			(770
				(if param2
					(self add: 2 0 param2)
					(self add: 1 1 param2)
				else
					(self add: 9 1 param2)
				)
			)
			(771
				(if param2
					(self add: 1 0 param2)
					(self add: 1 1 param2)
				else
					(self add: 9 0 param2)
					(self add: 9 1 param2)
				)
			)
			(576 (self add: 7 2 param2))
			(4096 (self add: 11 2 param2))
			(128
				(self add: 2 0 param2)
				(self add: 2 1 param2)
			)
			(513
				(self add: 2 1 param2)
				(self add: 10 2 param2)
			)
		)
	)
	
	(method (exitAlley param1 &tmp alleyAtLoc)
		(= local5 1)
		(cond 
			((OneOf param1 1024 4096 512 2048 8192 16384)
				(if (OneOf param1 1024 512 2048)
					(= facingHeading (self changeHeading: facingHeading -1))
				else
					(= facingHeading (self changeHeading: facingHeading 1))
				)
				(self egoPos2Coords:)
				(alley at: gEgoLocXCoord gEgoLocYCoord)
				(if (not (= alleyAtLoc (alley atLoc?)))
					(Printf 700 5 (alley name?) gEgoLocXCoord gEgoLocYCoord)
					(= quit 1)
					(return)
				)
				(if (< alleyAtLoc 0)
					(= gTopExit facingHeading)
					(self newRoom: (- alleyAtLoc))
				else
					(DisposeScript AlleyRoom)
					(self newAlley: (proc702_1 alleyAtLoc))
				)
			)
			((== param1 128)
				(alley at: facingX facingY)
				(if (not (= alleyAtLoc (alley atLoc?)))
					(Printf 700 5 (alley name?) gEgoLocXCoord gEgoLocYCoord)
					(= quit 1)
					(return)
				)
				(= gTopExit facingHeading)
				(self newRoom: (- alleyAtLoc))
			)
		)
	)
	
	(method (newAlley theAlley &tmp temp0 theTheGEgoLocXCoord theTheGEgoLocYCoord temp3 temp4 temp5 alleyTopType theGEgoLocXCoord theGEgoLocYCoord temp9 temp10)
		(if (not (IsObject theAlley))
			(Print 700 3)
			(= quit 1)
			(return)
		)
		(UnlockEgo)
		(proc1_19)
		(ego loop: 3 setMotion: 0 illegalBits: -384 x: 160 y: 147)
		(= alley theAlley)
		(= isScrolling 1)
		(= local5 0)
		(User prevDir: 0)
		(if alleyFeatures
			(self drawPic: picture 15)
			(= theIsMoving (= isMoving 1))
			(alleyFeatures dispose:)
			(= temp9 0)
		else
			(= theIsMoving 0)
			(= isMoving 0)
			(= temp9 1)
		)
		((= alleyFeatures (Collect new:)) add:)
		(if (== (alley botX?) (alley topX?))
			(= orientation 1)
		else
			(= orientation 2)
		)
		(= temp10 0)
		(if
		(!= (& orientation $0001) (& facingHeading $0001))
			(= facingHeading orientation)
			(if
				(and
					temp9
					prevRoomNum
					(!= prevRoomNum 440)
					(!= prevRoomNum 500)
				)
				(= temp10 1)
			)
		)
		(if (== facingHeading orientation)
			(= facingX (alley topX?))
			(= facingY (alley topY?))
			(= alleyTopType (alley topType?))
		else
			(= facingX (alley botX?))
			(= facingY (alley botY?))
			(= alleyTopType (alley botType?))
		)
		(= dX (= dY 0))
		(cond 
			((== orientation 1)
				(if (== facingY (alley topY?))
					(= dY 1)
				else
					(= dY -1)
				)
			)
			((== facingX (alley topX?)) (= dX 1))
			(else (= dX -1))
		)
		(= theGEgoLocXCoord gEgoLocXCoord)
		(= theGEgoLocYCoord gEgoLocYCoord)
		(if
			(<
				(= temp0
					(+
						1
						(Abs (- facingX theGEgoLocXCoord))
						(Abs (- facingY theGEgoLocYCoord))
					)
				)
				3
			)
			(= temp0 3)
			(= theGEgoLocXCoord (- facingX (* dX 2)))
			(= theGEgoLocYCoord (- facingY (* dY 2)))
			(ego y: 100)
		)
		(= length (- (* temp0 4) 3))
		(= nextTee (= scrBotPos 0))
		(= theTheGEgoLocXCoord theGEgoLocXCoord)
		(= theTheGEgoLocYCoord theGEgoLocYCoord)
		(= temp4 0)
		(= temp3 0)
		(while (< temp3 temp0)
			(if
				(= temp5
					(alley at: theTheGEgoLocXCoord theTheGEgoLocYCoord)
				)
				(self addFeatures: temp5 temp4)
				(if (and (>= temp4 8) (== temp5 771))
					(= nextTee (- temp4 8))
				)
			)
			(= theTheGEgoLocXCoord (+ theTheGEgoLocXCoord dX))
			(= theTheGEgoLocYCoord (+ theTheGEgoLocYCoord dY))
			(= temp4 (+ temp4 4))
			(++ temp3)
		)
		(if
			(or
				(!= (- theTheGEgoLocXCoord dX) facingX)
				(!= (- theTheGEgoLocYCoord dY) facingY)
			)
			(Printf 700 4)
		)
		(self add: 8 2 8)
		(self add: 8 2 6)
		(self add: 8 2 4)
		(self add: 8 2 2)
		(self add: 8 2 0)
		(if temp10
			(self setScript: enterFromSide)
		else
			(LockEgo)
		)
	)
	
	(method (turnAround &tmp egoX)
		(= egoX (ego x?))
		(= facingHeading (self changeHeading: facingHeading 2))
		(self egoPos2Coords:)
		(self newAlley: alley)
		(ego x: 160)
	)
	
	(method (pos2Coords param1 &tmp temp0)
		(= temp0 (/ (- length param1) 4))
		(= theGEgoLocXCoord_2 (- facingX (* temp0 dX)))
		(= theGEgoLocYCoord_2 (- facingY (* temp0 dY)))
	)
	
	(method (egoPos2Coords)
		(self pos2Coords: scrBotPos)
		(= gEgoLocXCoord theGEgoLocXCoord_2)
		(= gEgoLocYCoord theGEgoLocYCoord_2)
		(if (<= (ego y?) 116)
			(= gEgoLocXCoord (+ gEgoLocXCoord (* dX 2)))
			(= gEgoLocYCoord (+ gEgoLocYCoord (* dY 2)))
		)
	)
	
	(method (changeHeading param1 param2 &tmp temp0)
		(cond 
			((> (= temp0 (+ param1 param2)) 4) (= temp0 (- temp0 4)))
			((< temp0 1) (= temp0 (+ temp0 4)))
		)
		(return temp0)
	)
	
	(method (showFront)
		(self showSelf:)
		(alleyFeatures eachElementDo: #showFront scrBotPos)
	)
	
	(method (showAll)
		(self showSelf:)
		(alleyFeatures eachElementDo: #showSelf)
	)
	
	(method (newFeature param1 param2 param3)
		(AFeat new: param1 param2 param3)
	)
	
	(method (showSign &tmp alleyFeaturesFirst temp1 temp2 alleyAtLoc temp4 temp5 theTheTheTheGEgoLocXCoord_2 theTheTheTheGEgoLocYCoord_2 theTheGEgoLocXCoord_2 theTheGEgoLocYCoord_2 temp10 theAlleyRoom temp12 temp13 theTheTheGEgoLocXCoord_2 theTheTheGEgoLocYCoord_2 temp16 temp17)
		(= temp16 0)
		(= temp17 1)
		(= local204 0)
		(= alleyFeaturesFirst (alleyFeatures first:))
		(while alleyFeaturesFirst
			(if
				(and
					(not
						(&
							((= temp1 (NodeValue alleyFeaturesFirst)) signal?)
							$0088
						)
					)
					(OneOf (temp1 type?) 1 5 9)
				)
				(= temp2 (temp1 pos?))
				(= theAlleyRoom AlleyRoom)
				(self pos2Coords: temp2)
				(alley at: theGEgoLocXCoord_2 theGEgoLocYCoord_2)
				(if (> (= alleyAtLoc (alley atLoc?)) 0)
					(= temp10 (proc702_1 alleyAtLoc))
					(if (not (IsObject temp10))
						(return (Printf 700 10 theGEgoLocXCoord_2 theGEgoLocYCoord_2))
					)
				)
				(= theTheTheTheGEgoLocXCoord_2
					(= theTheGEgoLocXCoord_2 theGEgoLocXCoord_2)
				)
				(= theTheTheTheGEgoLocYCoord_2
					(= theTheGEgoLocYCoord_2 theGEgoLocYCoord_2)
				)
				(switch facingHeading
					(1
						(= theTheTheTheGEgoLocXCoord_2
							(- theTheTheTheGEgoLocXCoord_2 1)
						)
						(= theTheGEgoLocXCoord_2 (+ theTheGEgoLocXCoord_2 1))
					)
					(3
						(= theTheTheTheGEgoLocXCoord_2
							(+ theTheTheTheGEgoLocXCoord_2 1)
						)
						(= theTheGEgoLocXCoord_2 (- theTheGEgoLocXCoord_2 1))
					)
					(2
						(= theTheTheTheGEgoLocYCoord_2
							(+ theTheTheTheGEgoLocYCoord_2 1)
						)
						(= theTheGEgoLocYCoord_2 (- theTheGEgoLocYCoord_2 1))
					)
					(4
						(= theTheTheTheGEgoLocYCoord_2
							(- theTheTheTheGEgoLocYCoord_2 1)
						)
						(= theTheGEgoLocYCoord_2 (+ theTheGEgoLocYCoord_2 1))
					)
				)
				(if
					(!=
						(+ theGEgoLocXCoord_2 theGEgoLocYCoord_2)
						(+ gEgoLocXCoord gEgoLocYCoord)
					)
					(if (<= (ego y?) 116)
						(= temp12 { down the street_})
					else
						(= temp12 { up the street_})
					)
				else
					(= temp12 {_})
				)
				(if (== (temp1 side?) 0)
					(= theTheTheGEgoLocXCoord_2 theTheTheTheGEgoLocXCoord_2)
					(= theTheTheGEgoLocYCoord_2 theTheTheTheGEgoLocYCoord_2)
					(= temp13 {left})
				else
					(= theTheTheGEgoLocXCoord_2 theTheGEgoLocXCoord_2)
					(= theTheTheGEgoLocYCoord_2 theTheGEgoLocYCoord_2)
					(= temp13 {right})
				)
				(= temp4
					(alley streetName: theGEgoLocXCoord_2 theGEgoLocYCoord_2)
				)
				(if
					(= temp5
						(localproc_170a
							alleyAtLoc
							temp10
							theTheTheGEgoLocXCoord_2
							theTheTheGEgoLocYCoord_2
						)
					)
					(StrCat
						@local204
						(Format
							@local504
							700
							11
							(if temp16 {Another} else {There is a})
							temp12
							temp13
							(if temp16 {_} else {, which_})
							temp5
						)
					)
				else
					(StrCat
						@local204
						(Format @local504 700 12 temp12 temp13)
					)
				)
				(if (and temp4 temp5 (not (StrCmp temp4 temp5)))
					(= temp17 0)
				)
				(= temp16 1)
				(if (!= AlleyRoom theAlleyRoom)
					(DisposeScript AlleyRoom)
					(= AlleyRoom theAlleyRoom)
				)
			)
			(= alleyFeaturesFirst
				(alleyFeatures next: alleyFeaturesFirst)
			)
		)
		(if temp16
			(= temp4
				(alley streetName: theGEgoLocXCoord_2 theGEgoLocYCoord_2)
			)
			(if (and temp17 temp4)
				(StrCat
					@local204
					(Format
						@local504
						700
						13
						(alley streetName: theGEgoLocXCoord_2 theGEgoLocYCoord_2)
					)
				)
			)
			(HighPrint @local204)
		)
		(return temp16)
	)
	
	(method (crossIntersection)
		(if (and (Random 0 1) (> gSeconds 0))
			(theGame setScript: randomCrossers)
		)
	)
)

(instance randomCrossers of Script
	(properties)
	
	(method (changeState newState &tmp temp0 [temp1 4] temp5 temp6 temp7 temp8 temp9 temp10 temp11)
		(switch (= state newState)
			(0 (= cycles 2))
			(1
				(curRoom isMoving: 0)
				(ego setMotion: 0)
				(= cycles 2)
			)
			(2
				(= temp8 (Random 1 2))
				(= temp0 0)
				(while (< temp0 temp8)
					(if (not temp0)
						(= temp9 (= newActor (Actor new:)))
					else
						(= temp9 (= newActor_2 (Actor new:)))
					)
					(curRoom makeCrosser: temp9)
					(if (Random 0 1)
						(= temp7 0)
						(= temp10 90)
						(= temp5 107)
						(if (== temp0 1) (= temp5 (- temp5 (Random 5 20))))
						(= temp11 191)
					else
						(= temp7 1)
						(= temp10 270)
						(= temp5 191)
						(if (== temp0 1) (= temp5 (+ temp5 (Random 5 20))))
						(= temp11 100)
					)
					(= temp6 81)
					(if (== temp0 1) (= temp6 (+ temp6 2)))
					(temp9
						loop: temp7
						x: temp5
						y: temp6
						heading: temp10
						signal: 16384
						illegalBits: 0
						init:
						setCycle: Walk
						setMotion: MoveTo temp11 temp6
					)
					(if (or (== temp0 1) (== temp8 1))
						((temp9 mover?) caller: self)
					)
					(cast delete: temp9)
					(cast addToFront: temp9)
					(++ temp0)
				)
			)
			(3
				(newActor dispose:)
				(= newActor 0)
				(if (IsObject newActor_2)
					(newActor_2 dispose:)
					(= newActor_2 0)
				)
				(self dispose:)
			)
		)
	)
)

(instance enterFromSide of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(if (== (- gTopExit (curRoom facingHeading?)) 1)
					(= temp0 -1)
					(= temp1 90)
				else
					(= temp0 1)
					(= temp1 270)
				)
				(ego x: (+ 160 (* 70 temp0)) y: 164)
				(ego setMotion: MoveTo 160 (ego y?) self)
			)
			(1
				(ego setMotion: MoveTo (ego x?) 147 self)
			)
			(2 (LockEgo 1) (self dispose:))
		)
	)
)

(instance exploder of TargActor
	(properties)
	
	(method (init)
		(super init: &rest)
		(self hide:)
	)
	
	(method (onMe)
		(return 0)
	)
	
	(method (hurtMe)
		(return 1)
	)
)

(instance pickLock of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local6 (== (register side?) 0))
				(ego
					setMotion:
						MoveTo
						(+ (register x?) (if local6 13 else -13))
						(- (register y?) 2)
						self
				)
			)
			(1
				(ego
					view: 47
					loop: (+ 4 local6)
					cel: 0
					setCycle: End self
				)
				(Bset 117)
			)
			(2 (= cycles 20))
			(3 (ego setCycle: Beg self))
			(4 (= cycles 10))
			(5
				(proc1_19)
				(ego loop: (if local6 7 else 6))
				(Bclr 117)
				(if (PickLock 80 1 1) (HighPrint 700 14))
				(self dispose:)
			)
		)
	)
)
