;;; Sierra Script 1.0 - (do not remove this comment)
(script# 610)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use TargActor)
(use Intrface)
(use LoadMany)
(use Path)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm610 0
)

(local
	local0
	local1 =  1
	local2 =  1
	[local3 12] = [134 110 88 104 72 99 52 88 39 87 -32768 -32768]
	[local15 20] = [58 93 80 94 110 92 150 87 165 83 168 79 159 73 135 63 130 62 -32768 -32768]
	[local35 16] = [159 73 168 79 165 83 150 87 110 92 80 94 58 93 -32768 -32768]
	[local51 12] = [39 87 52 88 72 99 88 104 134 110 -32768 -32768]
	[local63 38] = [1 2 3 4 5 6 7 8 9 0 10 0 0 0 11 0 12 0 13 0 0 0 0 0 14 0 0 0 0 0 15 0 16]
	[local101 24] = [17 '//teleport,leaving,escape' 18 '//iblis,statue' 19 '//ability,ability' 20 '//health,injury' 21 '//bendaoud,prophet' 22 '//ring' 23 '//prediction' 25 '//wish' 26 '//master,lord,boss' 27 '//city,grave' 28 '//job,purpose,goal,replace']
	newRock
	newRock_2
	newRock_3
	newRock_4
	newRock_5
	newRock_6
	newRock_7
	local132
	[local133 15] = [0 267 87 5 250 88 3 244 76 0 244 65 5 262 71]
	local148
	local149
	local150
	local151
	local152
	local153
	[local154 20]
)
(procedure (localproc_24cc)
	(localproc_2510 610 58)
	(if (cast contains: dj) (Say dj 610 59))
)

(procedure (localproc_24f4)
	(loWindow color: 10 back: 0)
	(Print &rest #window loWindow)
)

(procedure (localproc_2510)
	(hiWindow color: 9 back: 0)
	(Print &rest #window hiWindow)
)

(procedure (localproc_252c)
	(if (or (> [skills 0] 140) [local154 0])
		(localproc_2510 610 60)
	else
		(localproc_2510 610 61)
	)
)

(instance rm610 of Rm
	(properties
		picture 610
		style $0001
	)
	
	(method (init)
		(LoadMany 128 610 613 615 183 47 32 615 22 612 586)
		(Load rsTEXT 615)
		(Load rsSOUND 12 15 16 34)
		(AddToScore 640 5)
		(Bset 116)
		(= egoWalkMode 4)
		(proc1_19)
		(ego loop: 5 posn: 244 120 init:)
		(= gGDftSC gAllSC)
		(= defaultPalette 0)
		(super init:)
		(floorShine init:)
		(dr init:)
		(iblis init: stopUpd:)
		((= newRock (rock new:)) cel: 1 posn: 240 47 init:)
		((= newRock_2 (rock new:)) cel: 2 posn: 239 58 init:)
		((= newRock_3 (rock new:)) cel: 4 posn: 283 59 init:)
		((= newRock_4 (rock new:)) cel: 3 posn: 259 57 init:)
		((= newRock_5 (rock new:)) cel: 5 posn: 280 68 init:)
		((= newRock_6 (rock new:)) cel: 6 posn: 232 74 init:)
		(newRock stopUpd:)
		(newRock_2 stopUpd:)
		(newRock_3 stopUpd:)
		(newRock_4 stopUpd:)
		(newRock_5 stopUpd:)
		(newRock_6 stopUpd:)
		(rock init:)
		(rock stopUpd:)
		(self setScript: comeIn)
	)
	
	(method (doit)
		(super doit:)
		(if (not script)
			(switch (= local0 (ego onControl: 1))
				(16
					(self setScript: climbDownS)
				)
				(2 (self setScript: climbUpS))
			)
		)
	)
	
	(method (dispose)
		(gCMusic fade:)
		(DisposeScript 983)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/cave')
				)
				(localproc_2510 610 0)
			)
			((Said 'force,move,open,open/door,boulder') (localproc_252c))
			((Said 'put,deposit,extinguish/lamp,light') (localproc_2510 610 1))
			((Said 'cast') (pEvent claimed: 0))
			((cast contains: dj) (pEvent claimed: 1) (Say dj 610 2))
			((Said '/statue,iblis') (localproc_2510 610 3))
			((Said 'walk') (HighPrint 610 4))
			((Said 'run,sneak') (HighPrint 610 5))
		)
	)
)

(instance comeIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(if (and (< 22 newState) (< newState 29))
			(ShakeScreen 2 2)
		)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 232 124 self)
			)
			(1 (dr setCycle: Beg self))
			(2
				(localproc_24f4 610 6)
				(localproc_24f4 610 7)
				(ego
					setPri: 4
					moveSpeed: 1
					cycleSpeed: 1
					setMotion: MoveTo 176 116 self
				)
			)
			(3
				(localproc_24f4 610 8)
				(floorShine dispose:)
				(ego setLoop: 5 setMotion: lowPath self setCycle: Fwd)
			)
			(4
				(proc1_19)
				(ego setPri: 8 illegalBits: 0 setMotion: highPath self)
			)
			(5
				(localproc_24f4 610 9)
				(localproc_24f4 610 10)
				(ego view: 47 loop: 1 cel: 0)
				(sparkle init: setCycle: End)
				(= cycles 8)
			)
			(6
				(sparkle dispose:)
				(SetUpEgo)
				(localproc_24f4 610 11)
				(gSpareMusic number: 34 loop: 0 vol: 60 play:)
				(adAvis
					init:
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(7
				(adAvis setLoop: 1 cel: 0 setCycle: End self)
			)
			(8
				(iblis dispose:)
				(adAvis setLoop: 2 cel: 0 setCycle: End self)
			)
			(9
				(Say adAvis self 610 12 610 13)
			)
			(10
				(adAvis setLoop: 4 cel: 0 setCycle: CT 2 1 self)
			)
			(11
				(adAvis cel: 1)
				(= cycles 10)
			)
			(12 (adAvis setCycle: Beg self))
			(13
				(adAvis talkSpeed: 2)
				(Say adAvis self 610 14)
			)
			(14
				(adAvis setLoop: 2 cel: 255 setCycle: CT 1 -1 self)
			)
			(15 (= cycles 8))
			(16 (adAvis setCycle: End self))
			(17
				(adAvis talkSpeed: 1)
				(Say adAvis self 610 15 610 16)
			)
			(18
				(adAvis
					setLoop: 4
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(19
				(whamo init: setCycle: Fwd setMotion: MoveTo 264 43 whamo)
				(adAvis cel: 1 setCycle: Beg)
			)
			(20
				(whamo view: 32 loop: 5 cel: 0 setCycle: CT 2 1 self)
			)
			(21
				(ShakeScreen 1 5)
				(ego
					view: 22
					setLoop: 0
					cel: 0
					setStep: 2 2
					setCycle: End
				)
				(whamo setCycle: End self)
			)
			(22
				(whamo dispose:)
				(newRock startUpd:)
				(newRock_2 startUpd:)
				(newRock_3 startUpd:)
				(newRock_4 startUpd:)
				(newRock_5 startUpd:)
				(newRock_6 startUpd:)
				(rock setPri: 4 setMotion: MoveTo 255 114 self)
			)
			(23
				(addToPile init: rock)
				(newRock setPri: 4 setMotion: MoveTo 233 112 self)
			)
			(24
				(addToPile2 init: newRock)
				(newRock_2 setPri: 4 setMotion: MoveTo 242 100 self)
			)
			(25
				(dr
					lookStr: {The door is blocked by tons of rocks -- apparently for good.}
				)
				(addToPile3 init: newRock_2)
				(newRock_3 setPri: 4 setMotion: MoveTo 268 123 self)
			)
			(26
				(addToPile4 init: newRock_3)
				(newRock_4 setPri: 4 setMotion: MoveTo 270 114 self)
			)
			(27
				(addToPile5 init: newRock_4)
				(newRock_5 setPri: 4 setMotion: MoveTo 263 101 self)
			)
			(28
				(addToPile6 init: newRock_5)
				(newRock_6 setPri: 4 setMotion: MoveTo 239 87 self)
			)
			(29
				(addToPile7 init: newRock_6)
				(Say adAvis self 610 17)
			)
			(30
				(adAvis setLoop: 4 cel: 0 setCycle: End self)
			)
			(31
				(whamo
					view: 615
					loop: 5
					posn: 107 31
					init:
					setCycle: Fwd
					setMotion: MoveTo 264 24 whamo
				)
				(adAvis cel: 1 setCycle: Beg)
			)
			(32
				(whamo view: 32 loop: 5 cel: 0 setCycle: End self)
			)
			(33
				(ShakeScreen 2 2)
				(whamo dispose:)
				(adAvis setLoop: 6 cel: 0 setCycle: End self)
			)
			(34
				(= defaultPalette 1)
				(curRoom drawPic: 610)
				(addToPics
					add:
						addToPile
						addToPile2
						addToPile3
						addToPile4
						addToPile5
						addToPile6
						addToPile7
					eachElementDo: #palette 2
					doit:
				)
				(dr palette: 2 forceUpd:)
				(adAvis setLoop: 0 cel: 4 setCycle: Beg self)
			)
			(35
				(rock palette: 2)
				(= cycles 4)
			)
			(36
				(rock setScript: moreRockS self)
			)
			(37 (= cycles 18))
			(38
				(ego setLoop: 1 cel: 0 cycleSpeed: 3 setCycle: End self)
			)
			(39
				(proc1_19)
				(floorShine init:)
				(ego setPri: 8 loop: 3 cel: 2 heading: 0)
				(adAvis dispose:)
				(ring init:)
				(self dispose:)
			)
		)
	)
)

(instance moreRockS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(if newState (ShakeScreen 2 1))
		(switch (= state newState)
			(0
				((= newRock_7 (rock new:))
					init:
					setPri: 4
					setStep: 3 18
					cel: [local133 local132]
					posn: [local133 (++ local132)] -10
					setMotion: MoveTo [local133 local132] [local133 (++ local132)] self
				)
			)
			(1
				(gSpareMusic number: 12 loop: 1 vol: 70 play:)
				(newRock_7 stopUpd:)
				(if (< (++ local132) 13)
					(self changeState: 0)
				else
					(self dispose:)
				)
			)
		)
	)
)

(instance climbUpS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setPri: 4 setMotion: lowPath self)
			)
			(1
				(ego setPri: 8 setMotion: highPath self)
			)
			(2
				(proc1_19)
				(ego setPri: 8)
				(self dispose:)
			)
		)
	)
)

(instance climbDownS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setPri: 8 setMotion: downHighPath self)
			)
			(1
				(ego setPri: 4 setMotion: downLowPath self)
			)
			(2
				(ego setMotion: MoveTo 206 123 self)
			)
			(3
				(proc1_19)
				(ego setPri: 4)
				(self dispose:)
			)
		)
	)
)

(instance djComesS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(ego setMotion: MoveTo 212 150 self)
			)
			(1 (ego setHeading: 135 self))
			(2
				(ego
					view: 612
					setLoop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(3
				(AddToScore 639 7)
				(ring dispose:)
				(ego
					get: 44
					setLoop: 4
					cel: 0
					cycleSpeed: 3
					setCycle: CT 2 1 self
				)
			)
			(4
				(localproc_2510 610 18)
				(ego setCycle: CT 8 1 self)
			)
			(5
				(dj init: posn: 237 119 setCycle: End self)
			)
			(6
				(ego cycleSpeed: 1 setCycle: End)
				(dj
					setLoop: 2
					cycleSpeed: 2
					setCycle: Fwd
					posn: 245 114
					setMotion: MoveTo 252 102
				)
				(= cycles 14)
			)
			(7 (Say dj self 610 19))
			(8
				(SetInput 0)
				(self dispose:)
			)
		)
	)
)

(instance healedS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local148 1)
				(Say dj self 610 20)
			)
			(1
				(localproc_2510 610 21)
				(= [skills 16] (GetMaxHealth))
				(= [skills 18] (GetMaxMana))
				(= [skills 17] (GetMaxStamina))
				(Bclr 7)
				(= cycles 8)
			)
			(2 (Say dj self 610 22))
			(3
				(switch (++ local149)
					(1 (Say dj self 610 23))
					(2 (Say dj self 610 24))
					(else 
						(Die 1 610 25 80 {C'mon.__Just One More Little Wish...})
					)
				)
			)
			(4 (self dispose:))
		)
	)
)

(instance skillS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say dj self 610 26))
			(1
				(localproc_2510 610 27)
				(= cycles 8)
			)
			(2 (Say dj self 610 28))
			(3
				(switch (++ local149)
					(1 (Say dj self 610 23))
					(2 (Say dj self 610 24))
					(else 
						(Die 1 610 25 80 {C'mon.__Just One More Little Wish...})
					)
				)
			)
			(4 (self dispose:))
		)
	)
)

(instance nothingS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch (++ local150)
					(1 (Say dj self 610 29))
					(2 (Say dj self 610 30))
					(3 (Say dj self 610 31))
					(else  (Say dj self 610 32))
				)
			)
			(1
				(switch local150
					(1
						(localproc_2510 610 33)
						(Say dj self 610 34)
					)
					(2
						(localproc_2510 610 35)
						(Say dj self 610 36)
					)
					(3
						(localproc_2510 610 37)
						(Say dj self 610 38)
					)
					(else 
						(localproc_2510 610 39)
						(Say dj self 610 40)
					)
				)
			)
			(2 (self dispose:))
		)
	)
)

(instance zapOutS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if register (Say dj self 610 41) else (self cue:))
			)
			(1 (Say dj self 610 42))
			(2
				(sparkle
					init:
					cel: 0
					posn: 202 120
					cycleSpeed: 1
					setCycle: CT 2 1 self
				)
			)
			(3
				(sparkle setCycle: End)
				(ego dispose:)
				(floorShine dispose:)
				(dj setLoop: 6 cel: 0 setCycle: End self)
			)
			(4
				(dj hide:)
				(sparkle
					posn: (- (dj x?) 14) (- (dj y?) 26)
					cel: 0
					setCycle: End self
				)
			)
			(5
				(= egoWalkMode 0)
				(Bset 96)
				(curRoom newRoom: 460)
			)
		)
	)
)

(instance dr of TargActor
	(properties
		x 243
		y 105
		noun '/door'
		description {the door}
		lookStr {The door is very old.__And ancient, very ancient.}
		view 610
		cel 1
		priority 2
		signal $0010
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 2)
			(localproc_252c)
		else
			(super doVerb: theVerb)
		)
	)
	
	(method (fetchMe)
		(localproc_24cc)
		(return 0)
	)
	
	(method (hurtMe)
		(localproc_24cc)
		(return 1)
	)
	
	(method (openMe)
		(localproc_24cc)
		(return 0)
	)
)

(instance iblis of View
	(properties
		x 110
		y 35
		view 613
		priority 8
		signal $4010
	)
)

(instance myWin of BotWindow
	(properties)
)

(instance ring of TargActor
	(properties
		x 222
		y 154
		z 27
		noun '/ring,flash,glimmer'
		description {flash}
		view 612
		loop 5
		priority 15
		signal $4010
		cycleSpeed 1
		illegalBits $0000
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(cond 
			(cel)
			((== local0 4)
				(if
					(>
						(= temp0
							(Abs
								(- (GetAngle (ego x?) (ego y?) x y) (ego heading?))
							)
						)
						180
					)
					(= temp0 (- 360 temp0))
				)
				(if (<= temp0 75) (self setCycle: CT 0 1 self))
			)
			((== local0 256) (self setCycle: CT 0 1 self))
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if (== local0 256)
					(FaceObject ego self)
					(localproc_2510 610 44)
				else
					(localproc_2510 610 43)
				)
				(self setCycle: CT 0 1)
			)
			(7
				(if (== local0 256)
					(curRoom setScript: djComesS)
				else
					(PrintNotCloseEnough)
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
	
	(method (cue &tmp temp0)
		(self setCycle: CT 0 1)
		(cond 
			((not local2))
			((and local1 (> (ego distanceTo: ring) 24))
				(ego setMotion: 0)
				(FaceObject ego self)
				(= local1 0)
				(localproc_2510 610 43)
			)
			((<= (ego distanceTo: ring) 24)
				(ego setMotion: 0)
				(FaceObject ego self)
				(= local2 0)
				(localproc_2510 610 44)
			)
		)
		(super cue:)
	)
	
	(method (detectMe)
		(localproc_2510 610 45)
	)
)

(instance dj of Talker
	(properties
		description {the djinni}
		lookStr {Do you mind if I'm smoke?}
		yStep 1
		view 612
		loop 1
		priority 12
		signal $4810
		cycleSpeed 2
		illegalBits $0000
		xStep 1
		tLoop 3
		talkSpeed 1
		myName '//djinn'
		title {Djinni:}
		color 1
		back 13
		msgFile 615
	)
	
	(method (init)
		(cast addToFront: self)
		(super init: &rest)
		(= tWindow myWin)
	)
	
	(method (handleEvent pEvent &tmp [temp0 60])
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					local153
					(== (pEvent type?) evSAID)
					(not (Said 'wish>'))
				)
				(if
					(or
						(Said
							'/strength,intelligence,agility,vitality,luck,attack,weapon,parry,dodge,stealth,lockpick,throw,climb,scale,magic,communication,honor'
						)
						(Said 'throw,lockpick,dodge,climb,scale,parry,attack')
					)
					(= local153 0)
					(Parse
						(Format @temp0 610 50 (User inputLineAddr?))
						pEvent
					)
					(pEvent type: 128)
					(pEvent claimed: 0)
					(User said: pEvent)
				else
					(PrintWarning 610 51)
					(pEvent claimed: 1)
				)
			)
			((Said 'wish//healing,health')
				(if local148
					(Say dj 610 52)
				else
					(curRoom setScript: healedS)
				)
			)
			(
				(or
					(Said
						'wish//strength,intelligence,agility,vitality,luck,attack,weapon,parry,dodge,stealth,lockpick,throw,climb,scale,magic,communication,honor>'
					)
					(Said
						'wish//ability<strength,intelligence,agility,vitality,luck,attack,weapon,parry,dodge,stealth,lockpick,throw,climb,scale,magic,magical,communication,honor>'
					)
					(Said 'throw,lockpick,dodge,climb,scale,parry,attack>')
				)
				(cond 
					(
						(==
							(= local152
								(cond 
									(
									(or (Said '//strength') (Said '//ability<strength')) 0)
									(
										(or
											(Said '//intelligence')
											(Said '//ability<intelligence')
										)
										1
									)
									(
									(or (Said '//agility') (Said '//ability<agility')) 2)
									(
									(or (Said '//vitality') (Said '//ability<vitality')) 3)
									((or (Said '//luck') (Said '//ability<luck')) 4)
									(
										(or
											(Said '//weapon,attack')
											(Said '//ability<weapon,attack')
											(Said 'attack')
										)
										5
									)
									(
										(or
											(Said '//parry')
											(Said '//ability<parry')
											(Said 'parry')
										)
										6
									)
									(
										(or
											(Said '//dodge')
											(Said '//ability<dodge')
											(Said 'dodge')
										)
										7
									)
									(
									(or (Said '//stealth') (Said '//ability<stealth')) 8)
									(
										(or
											(Said '//lockpick')
											(Said '/ability/<lockpick')
											(Said 'lockpick')
										)
										9
									)
									(
										(or
											(Said '//throw')
											(Said '//ability<throw')
											(Said 'throw')
										)
										10
									)
									(
										(or
											(Said '//climb,scale')
											(Said '//ability<climb,scale')
										)
										11
									)
									(
									(or (Said '//magic') (Said '//ability<magic,magical')) 12)
									(
										(or
											(Said '//communication')
											(Said '//ability<communication')
										)
										13
									)
									((or (Said '//honor') (Said '//ability<honor')) 14)
								)
							)
							14
						)
						(Say dj 610 53)
					)
					([local154 local152] (Say dj 610 52))
					(else
						(= [local154 local152] 1)
						(= [skills local152] (+ [skills local152] 50))
						(curRoom setScript: skillS)
					)
				)
			)
			((Said 'wish//ability,ability') (Say dj 610 54) (= local153 1))
			(
				(or
					(Said
						'wish//done,done,teleport,teleportation,teleportation,teleportation'
					)
					(Said 'teleport,done')
					(Said 'get,acquire<out')
					(Said 'wish//safety,escape>')
					(Said 'escape>')
				)
				(if (or local151 (== local149 2))
					(if (not (pEvent claimed?))
						(zapOutS register: 1)
						(pEvent claimed: 1)
					)
					(curRoom setScript: zapOutS)
				else
					(Say dj 610 55 610 56)
					(= local151 1)
					(pEvent claimed: 1)
				)
			)
			((Said 'wish//iblis') (Say dj 610 57))
			((Said 'wish') (curRoom setScript: nothingS))
		)
	)
	
	(method (calmMe)
		(localproc_2510 610 49)
	)
	
	(method (detectMe)
		(localproc_2510 610 48)
	)
	
	(method (fetchMe)
		(Say self 610 47)
		(return 0)
	)
	
	(method (hurtMe)
		(Say self 610 46)
	)
	
	(method (openMe)
		(localproc_24cc)
	)
	
	(method (atSpec param1)
		(return [local101 param1])
	)
	
	(method (atGen param1)
		(return [local63 param1])
	)
	
	(method (showText param1)
		(if (== param1 25) (AddToScore 638 7))
		(super showText: param1 &rest)
	)
	
	(method (messages param1)
		(super messages: param1 &rest)
		(self setMotion: MoveTo 262 86)
	)
	
	(method (endTalk)
		(super endTalk:)
		(self setMotion: MoveTo 252 99)
	)
)

(instance adAvis of Talker
	(properties
		x 93
		y 56
		view 615
		loop 7
		priority 8
		signal $4010
		illegalBits $0000
		tLoop 3
		talkSpeed 1
		myName '//ad,man'
		title {Ad Avis:}
		color 13
		back 0
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow myWin)
	)
)

(instance whamo of Actor
	(properties
		x 107
		y 31
		yStep 5
		view 615
		loop 5
		priority 7
		signal $4810
		illegalBits $0000
		xStep 16
	)
	
	(method (init)
		(gMiscMusic number: 15 loop: 1 play:)
		(super init: &rest)
	)
	
	(method (cue)
		(gMiscMusic number: 16 loop: 1 play:)
		(comeIn cue: &rest)
	)
)

(instance sparkle of Prop
	(properties
		x 133
		y 31
		view 615
		loop 7
		priority 12
		signal $0010
	)
)

(instance floorShine of Actor
	(properties
		view 586
		signal $5810
		illegalBits $0000
	)
	
	(method (doit)
		(self setPri: (- (ego priority?) 1))
		(switch (ego loop?)
			(0
				(self posn: (+ (ego x?) 10) (+ (ego y?) 5))
			)
			(1
				(self posn: (- (ego x?) 10) (+ (ego y?) 5))
			)
			(2
				(self posn: (ego x?) (+ (ego y?) 5))
			)
			(3
				(self posn: (ego x?) (- (ego y?) 5))
			)
			(4
				(self posn: (+ (ego x?) 12) (ego y?))
			)
			(5
				(self posn: (- (ego x?) 20) (+ (ego y?) 5))
			)
			(6
				(self posn: (+ (ego x?) 12) (ego y?))
			)
			(else 
				(self posn: (- (ego x?) 20) (+ (ego y?) 5))
			)
		)
		(super doit:)
	)
)

(instance rock of Actor
	(properties
		x 260
		y 45
		noun '/boulder,boulder,brick'
		description {the boulder}
		lookStr {Large boulders surround the door.}
		yStep 15
		view 610
		loop 1
		priority 3
		signal $7810
		illegalBits $0000
		xStep 4
	)
	
	(method (doVerb theVerb)
		(if (OneOf theVerb 5 7)
			(localproc_252c)
		else
			(super doVerb: theVerb)
		)
	)
)

(class AddToPile of PicView
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		view 610
		loop 1
		cel 0
		priority -1
		signal $0000
		palette 0
	)
	
	(method (init param1)
		(gSpareMusic number: 12 loop: 1 play:)
		(= cel (param1 cel?))
		(= x (param1 x?))
		(= y (param1 y?))
		(= priority (param1 priority?))
		(addToPics add: self doit:)
		(param1 dispose:)
	)
)

(instance addToPile of AddToPile
	(properties)
)

(instance addToPile2 of AddToPile
	(properties)
)

(instance addToPile3 of AddToPile
	(properties)
)

(instance addToPile4 of AddToPile
	(properties)
)

(instance addToPile5 of AddToPile
	(properties)
)

(instance addToPile6 of AddToPile
	(properties)
)

(instance addToPile7 of AddToPile
	(properties)
)

(instance lowPath of Path
	(properties)
	
	(method (at param1)
		(return [local3 param1])
	)
)

(instance highPath of Path
	(properties)
	
	(method (at param1)
		(return [local15 param1])
	)
)

(instance downHighPath of Path
	(properties)
	
	(method (at param1)
		(return [local35 param1])
	)
)

(instance downLowPath of Path
	(properties)
	
	(method (at param1)
		(return [local51 param1])
	)
)

(instance loWindow of BotWindow
	(properties)
)

(instance hiWindow of TopWindow
	(properties)
)
