;;; Sierra Script 1.0 - (do not remove this comment)
(script# 315)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Plaza)
(use FountainPlaza)
(use Merchant)
(use MsgMerchant)
(use PlazaDoor)
(use Intrface)
(use Polygon)
(use Extra)
(use Save)
(use Motion)
(use Actor)
(use System)

(public
	FPS 0
)

(local
	local0
	[local1 12] = [83 86 87 90 91 92 93 94 95 96 97 100]
	[local13 27] = [112 115 '//bread' 108 111 '//falafel,lamb,pita' 116 119 '//date,almond[<about,honeyed]' 120 123 '//honey' 124 129 '//saurii,paprika' 130 137 '//jerky,lizard,provision' 83 86 '//food,merchandise' -1 0 '//nephew,sloree,identity,lifemate,husband,wife,(merchant[<food,meat,about])']
	[local40 6] = [81 '//pan,merchandise' 82 '//clay']
	[local46 38] = [0 26 28 31 33 35 37 39 41 43 45 47 49 51 53 55 57 2 72 59 61 63 65 67 69 72 74 76 78 80 69 82 78 2 2 2 2 2]
	[local84 8] = [4 '//jaafar' 6 '//rakeesh' 8 '//paladin']
)
(instance FPS of FountainPlaza
	(properties
		north 704
		south 310
		west 704
		topExit 3
		bottomExit 1
		leftExit 2
	)
	
	(method (init)
		(super init:)
		(self
			addObstacle:
				(poly1
					init:
						0
						161
						0
						0
						319
						0
						319
						170
						313
						169
						290
						138
						286
						140
						237
						140
						174
						102
						173
						94
						169
						6
						150
						6
						150
						95
						140
						108
						115
						127
						107
						131
						78
						148
						23
						157
						14
						159
					yourself:
				)
				(poly2
					init: 105 189 92 172 120 150 159 140 200 149 220 169 220 181 213 189
					yourself:
				)
		)
		(if (Btst 136) (purse init:))
		(if (and (== currentDay 7) (< global303 700))
			(omar init: hide:)
			(jaAfar init: hide:)
			(DrawFeature omarRug)
		)
		(if
			(and
				(<= 0 currentTimeZone)
				(<= currentTimeZone 4)
				(not (proc80_0))
			)
			(scoree init:)
			(sloree init:)
			(toshur init:)
			(= saveIllegal -18432)
			(if (== currentDay 3)
				((ScriptID 302 0) init: posn: 116 97)
				(= entranceScript (ScriptID 302 1))
			)
		)
		(apothDoor init:)
		(DrawFeature rightWindow alleySign apothSign)
	)
	
	(method (dispose)
		(= global303 (+ (* currentDay 100) currentTimeZone))
		(DisposeScript 302)
		(super dispose:)
	)
)

(instance apothDoor of PlazaDoor
	(properties
		x 67
		y 116
		noun '/door'
		description {the door to the Apothecary Shop}
		lookStr {Judging by the sign of the Mortar and Pestle above the door, this must be the entrance to the Apothecary.}
		view 301
		loop 6
		priority 6
		signal $4010
		entranceTo 130
		exitDir 3
		xOut 39
		yOut 111
		xIn 87
		yIn 111
		barred 1
	)
)

(class AlternatingTalkerScript of HandsOffScript
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		oldIllBits 0
		saveIgnrAct 0
		lastMsg 0
		curMsg 0
		talker 0
	)
	
	(method (init param1 param2 theCurMsg theLastMsg)
		(= curMsg theCurMsg)
		(= lastMsg theLastMsg)
		(= talker scoree)
		(super init: param1 param2)
	)
	
	(method (changeState)
		(if (> curMsg lastMsg)
			(self dispose:)
		else
			(Say talker self (client msgFile?) curMsg)
			(= talker (if (== talker sloree) scoree else sloree))
			(++ curMsg)
		)
	)
)

(class AlternatingTalker of MsgMerchant
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 350
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $4000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 15
		back 6
		msgFile 350
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
		wares 0
		curWare 0
		cueMethod 0
		isSeated 1
		isOnLeft 1
		clothesColor 0
		firstMsgNum 0
		lastMsgSaid 0
		saidMsg 0
		firstMsg -1
		lastMsg 0
	)
	
	(method (init)
		(super init:)
		(self
			addWares: bread Saurus-On-A-Stick dates falafel lizard_jerky
		)
	)
	
	(method (showSelf)
		(AlternatingTalker say: 138 141)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'tell')
			(self say: 144 145)
		else
			(super handleEvent: pEvent)
		)
		(pEvent claimed?)
	)
	
	(method (scanSaidSpecs param1 &tmp temp0 temp1 temp2)
		(if (!= param1 669)
			(return (super scanSaidSpecs: param1))
		)
		(= firstMsg -1)
		(= temp1 32767)
		(= temp0 0)
		(while (= temp2 (self param1: (+ temp0 2)))
			(if (Said temp2)
				(= firstMsg (= temp1 (self param1: temp0)))
				(= lastMsg (self param1: (+ temp0 1)))
				(break)
			)
			(= temp0 (+ temp0 3))
		)
		(return temp1)
	)
	
	(method (showText param1)
		(cond 
			((== param1 -1) (self showSelf:))
			((!= firstMsg -1) (self say: firstMsg lastMsg))
			(else (super showText: param1))
		)
		(= firstMsg -1)
	)
	
	(method (has &tmp temp0)
		(return
			(cond 
				((or (Said '/food') (Said '//food')) (Say self 315 0) (return -1))
				(
					(and
						(= temp0 (super has: &rest))
						(!= temp0 -1)
						(!= temp0 lizard_jerky)
						mealsPreEaten
					)
					(HighPrint 315 1)
					(return -1)
				)
				(else (return temp0))
			)
		)
	)
	
	(method (saySoldBegin)
		(self say: 142 143 self)
	)
	
	(method (saySoldEnd)
		(if (== curWare lizard_jerky)
			(ego get: 3 5)
			(HighPrint 315 2)
		else
			(HighPrint 315 3)
			(= mealsPreEaten 1)
			(Bclr 4)
			(Bclr 5)
		)
	)
	
	(method (sayBargainSuccess)
		(self say: 101 105 self)
	)
	
	(method (sayBargainFailure)
		(self say: 106 107 self)
	)
	
	(method (atIndividualSpec param1)
		(return [local13 param1])
	)
	
	(method (sayMsg param1)
		(self
			say: [local1 (* param1 2)] [local1 (+ (* param1 2) 1)]
		)
	)
	
	(method (getLastMsgSaid)
		(return global286)
	)
	
	(method (updLastMsgSaid param1)
		(= global286 param1)
	)
	
	(method (getSaidMsg)
		(return local0)
	)
	
	(method (setSaidMsg)
		(= local0 1)
	)
	
	(method (say param1 param2 param3 &tmp temp0)
		(= temp0 (if (>= argc 3) param3 else 0))
		(self
			setScript: (AlternatingTalkerScript new:) temp0 param1 param2
		)
	)
)

(instance falafel of Class_84_1
	(properties
		noun '//falafel,lamb,pita>'
		price 70
		lowPrice 60
	)
)

(instance Saurus-On-A-Stick of Class_84_1
	(properties
		noun '//saurii>'
		price 70
		lowPrice 60
	)
)

(instance lizard_jerky of Class_84_1
	(properties
		noun '//lizard,jerky,provision>'
		price 100
		lowPrice 90
		name "lizard jerky"
	)
)

(instance bread of Class_84_1
	(properties
		noun '//bread>'
		price 30
		lowPrice 20
	)
)

(instance dates of Class_84_1
	(properties
		noun '//date>'
		price 30
		lowPrice 20
	)
)

(instance scoree of AlternatingTalker
	(properties
		x 240
		y 116
		description {Scoree}
		lookStr {Scoree is the local food merchant.}
		priority 7
		signal $4010
		myName '//nephew,(merchant[<food]),catperson'
		title {Scoree:}
		isSeated 0
		isOnLeft 0
		clothesColor 3
	)
	
	(method (init)
		(super init:)
		(= tWindow ScoreeWindow)
		(DrawFeature foodShelf2 foodShelf foodStand)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//pan,clay') (Say self 315 4))
			((Said 'ask//toshur') (Say self 315 5))
			(
			(Said 'ask//attar,attar,drug,pill,potion,apothecary') (Say self 315 6))
			(else (super handleEvent: pEvent))
		)
	)
)

(instance foodStand of PicView
	(properties
		x 234
		y 117
		noun '/stand[<food]'
		description {the food stand of Scoree}
		lookStr {The stand contains mostly broiled meats.}
		view 315
		loop 1
		priority 8
		signal $4010
	)
)

(instance foodShelf of PicView
	(properties
		x 221
		y 103
		noun '/stand[<food]'
		description {the food stand of Scoree}
		lookStr {The stand contains mostly broiled meats.}
		view 315
		loop 1
		cel 1
		priority 7
		signal $4010
	)
)

(instance foodShelf2 of PicView
	(properties
		x 257
		y 118
		noun '/shelf[<food]'
		description {the food stand of Scoree}
		lookStr {The food smells delicious.}
		view 315
		loop 1
		cel 2
		priority 8
		signal $4010
	)
)

(instance sloree of AlternatingTalker
	(properties
		x 257
		y 130
		description {Sloree}
		lookStr {Sloree is the local meat merchant.}
		priority 9
		signal $4010
		myName '//sloree,(merchant[<meat]),catperson'
		title {Sloree:}
		isSeated 0
		isOnLeft 0
		clothesColor 4
	)
	
	(method (init)
		(super init:)
		(= tWindow SloreeWindow)
		(DrawFeature brazier meatRug)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//pan,clay') (Say self 315 4))
			((Said 'ask//toshur') (Say self 315 5))
			(
			(Said 'ask//attar,attar,drug,pill,potion,apothecary') (Say self 315 6))
			(else (super handleEvent: pEvent))
		)
	)
)

(instance brazier of PicView
	(properties
		x 276
		y 132
		noun '/brazier'
		description {the brazier}
		lookStr {The brazier is merrily cooking saurus meat.}
		view 315
		loop 2
		signal $4000
	)
	
	(method (init)
		(super init:)
		(coals init:)
	)
)

(instance coals of Extra
	(properties
		view 315
		loop 6
		priority 9
		signal $4210
		cycleSpeed 6
	)
	
	(method (init)
		(super init:)
		(self posn: (- (brazier x?) 2) (- (brazier y?) 6))
	)
	
	(method (handleEvent)
		(brazier handleEvent: &rest)
	)
)

(instance meatRug of PicView
	(properties
		x 254
		y 136
		noun '/carpet'
		description {the rug}
		lookStr {You can't imagine carpeting a meat market, but the rug under this meat stand is immaculate.}
		view 315
		loop 3
		signal $4010
	)
)

(instance toshur of MsgMerchant
	(properties
		x 67
		y 138
		description {Toshur}
		lookStr {Toshur is the local pottery merchant.}
		priority 9
		signal $4010
		myName '//toshur,potter,catperson'
		title {Toshur:}
		clothesColor 2
		firstMsgNum 75
	)
	
	(method (init)
		(super init:)
		(DrawFeature potterStand)
		(self addWares: pot)
		(= lastMsgSaid gLastMsgSaid_4)
	)
	
	(method (dispose)
		(= gLastMsgSaid_4 lastMsgSaid)
		(super dispose:)
	)
	
	(method (showSelf)
		(Say self 315 7)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//food') (Say self 315 11))
			((Said 'ask//sloree,nephew') (Say self 315 12))
			(
			(Said 'ask//attar,attar,drug,pill,potion,apothecary') (Say self 315 6))
			((Said 'tell,talk,chat//elemental<air') (Say self 315 13 315 14))
			(else (super handleEvent: pEvent))
		)
		(pEvent claimed?)
	)
	
	(method (saySoldBegin)
		(Say self self 315 8)
	)
	
	(method (sayBargainSuccess)
		(Say self self 315 9)
	)
	
	(method (sayBargainFailure)
		(Say self self 315 10)
	)
	
	(method (atIndividualSpec param1)
		(return [local40 param1])
	)
)

(instance pot of Class_84_1
	(properties
		invItem 35
		noun '//pan>'
		price 300
		lowPrice 200
	)
)

(instance potterStand of PicView
	(properties
		x 58
		y 139
		noun '/pan,stand[<toshur,potter]'
		description {the pottery stand of Toshur}
		lookStr {Toshur's stand contains some fine and sturdy specimens of pottery.}
		view 310
		loop 3
		cel 1
		priority 9
		signal $4010
	)
)

(instance apothSign of PicView
	(properties
		x 65
		y 43
		noun '/sign'
		description {the Apothecary sign}
		lookStr {The sign of the Mortar and Pestle usually indicates the entrance to the Apothecary.}
		view 301
		cel 3
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance alleySign of PicView
	(properties
		x 160
		y 46
		noun '/sign[<alley,bearing,street]'
		description {the alley sign}
		shiftClick 0
		view 310
		loop 2
		cel 3
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rightWindow of PicView
	(properties
		x 252
		y 51
		noun '/window'
		description {the window}
		lookStr {From this window all the activity on the Plaza can be seen.}
		view 300
		loop 2
		cel 3
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(class ScoreeWindow of SysWindow
	(properties
		top 0
		left 0
		bottom 0
		right 0
		color 0
		back 15
		priority -1
		window 0
		type $0000
		title 0
		brTop 10
		brLeft 10
		brBottom 60
		brRight 140
	)
)

(class SloreeWindow of SysWindow
	(properties
		top 0
		left 0
		bottom 0
		right 0
		color 0
		back 15
		priority -1
		window 0
		type $0000
		title 0
		brTop 40
		brLeft 30
		brBottom 90
		brRight 160
	)
)

(instance poemS of Script
	(properties
		seconds 2
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1 (Say omar self 315 15))
			(2 (Say omar self 315 16))
			(3 (Say omar self 315 17))
			(4 (Say omar self 315 18))
			(5
				(Bset 136)
				(AddToScore 603 3)
				(self dispose:)
			)
		)
	)
)

(instance omarJaAfarTalk of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Say omar self 106 register)
				(++ register)
			)
			(1
				(Say jaAfar self 106 register)
			)
			(2 (self dispose:))
		)
	)
)

(instance getThePurse of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setMotion: MoveTo (+ (purse x?) 14) (+ (purse y?) 4) self
				)
			)
			(1
				(ego view: 47 setLoop: 1 setCel: 0 setCycle: End self)
			)
			(2
				(purse dispose:)
				(ego setCycle: Beg self)
			)
			(3 (proc1_19) (= cycles 2))
			(4
				(HighPrint 315 19)
				(Bclr 136)
				(ego get: 55)
				(= cycles 1)
			)
			(5
				(ego setHeading: 180)
				(self dispose:)
			)
		)
	)
)

(instance omarBody of Prop
	(properties
		x 104
		y 100
		noun '/omar,poet,man'
		description {Omar}
		view 316
	)
)

(instance omar of Talker
	(properties
		x 103
		y 78
		description {Omar}
		view 316
		loop 1
		priority 9
		signal $0010
		illegalBits $0000
		tLoop 1
		talkSpeed 1
		myName '//omar,poet,man'
		title {Omar:}
		color 5
		msgFile 106
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow BotWindow)
		(omarBody init:)
		(self setScript: poemS)
	)
	
	(method (atSpec param1)
		(return [local84 param1])
	)
	
	(method (atGen param1)
		(return [local46 param1])
	)
	
	(method (showText param1)
		(self setScript: omarJaAfarTalk 0 param1)
	)
	
	(method (messages)
		(self setPri: (+ (omarBody priority?) 1))
		((ScriptID 81 0) hide:)
		(super messages: &rest)
	)
	
	(method (talk &tmp theSeconds theS1 theS2 [temp3 500] [temp503 4] temp507)
		(switch state
			(1 (= theS1 s1) (= theS2 s2))
			(2 (= theS1 s3) (= theS2 s4))
			(3 (= theS1 s5) (= theS2 s6))
			(4 (= theS1 s7) (= theS2 s8))
		)
		(cond 
			((u< theS1 1000) (GetFarText theS1 theS2 @temp3))
			(theS1 (StrCpy @temp3 theS1))
		)
		(if (< colorCount 8)
			(tWindow color: 0 back: 15)
		else
			(tWindow color: color back: back)
		)
		(TextSize @[temp503 0] @temp3 userFont 0)
		(= temp507 (+ [temp503 3] 30))
		(Print
			@temp3
			#font
			userFont
			#title
			title
			#window
			tWindow
			#at
			0
			0
			#width
			temp507
			#mode
			0
			#dispose
		)
		(if (< (= theSeconds (/ (StrLen @temp3) 9)) 4)
			(= theSeconds 4)
		)
		(if suckBlueFrog
			(= endCycles 0)
		else
			(= endCycles (+ 1 (* gSeconds 1)))
		)
		(= cycles 0)
		(= seconds theSeconds)
	)
	
	(method (endTalk)
		(self setPri: 0)
		((ScriptID 81 0) show:)
		(super endTalk: &rest)
	)
)

(instance jaAfarBody of View
	(properties
		x 128
		y 98
		noun '/jaafar,man'
		description {Ja'Afar}
		view 318
	)
)

(instance jaAfar of Talker
	(properties
		x 129
		y 59
		description {Ja'Afar}
		view 318
		loop 1
		priority 9
		signal $0010
		illegalBits $0000
		tLoop 1
		talkSpeed 1
		myName '//jaafar,man'
		title {Ja'Afar:}
		color 4
		msgFile 106
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow BotWindow)
		(jaAfarBody init:)
	)
	
	(method (atSpec param1)
		(return [local84 param1])
	)
	
	(method (atGen param1)
		(return [local46 param1])
	)
	
	(method (messages)
		(self show:)
		(super messages: &rest)
	)
	
	(method (talk &tmp theSeconds theS1 theS2 [temp3 500] [temp503 4] temp507)
		(switch state
			(1 (= theS1 s1) (= theS2 s2))
			(2 (= theS1 s3) (= theS2 s4))
			(3 (= theS1 s5) (= theS2 s6))
			(4 (= theS1 s7) (= theS2 s8))
		)
		(cond 
			((u< theS1 1000) (GetFarText theS1 theS2 @temp3))
			(theS1 (StrCpy @temp3 theS1))
		)
		(if (< colorCount 8)
			(tWindow color: 0 back: 15)
		else
			(tWindow color: color back: back)
		)
		(TextSize @[temp503 0] @temp3 userFont 0)
		(= temp507 (+ [temp503 3] 30))
		(Print
			@temp3
			#font
			userFont
			#title
			title
			#window
			tWindow
			#at
			(- 300 temp507)
			0
			#width
			temp507
			#mode
			1
			#dispose
		)
		(if (< (= theSeconds (/ (StrLen @temp3) 9)) 4)
			(= theSeconds 4)
		)
		(if suckBlueFrog
			(= endCycles 0)
		else
			(= endCycles (+ 1 (* gSeconds 1)))
		)
		(= cycles 0)
		(= seconds theSeconds)
	)
	
	(method (endTalk)
		(self hide:)
		(super endTalk: &rest)
	)
)

(instance purse of View
	(properties
		x 115
		y 97
		noun '/purse,bag,pouch'
		description {the purse}
		lookStr {You see a small leather purse on the plaza floor.}
		view 318
		loop 2
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(ego setScript: getThePurse)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance omarRug of PicView
	(properties
		x 115
		y 102
		noun '/carpet,carpet'
		description {the rug}
		lookStr {Omar's rug is, naturally, very ornate.}
		view 315
		loop 4
		priority 0
		signal $4010
	)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)

(instance poly2 of Polygon
	(properties
		type $0002
	)
)
