;;; Sierra Script 1.0 - (do not remove this comment)
(script# 840)
(include sci.sh)
(use Main)
(use n001)
(use Intrface)
(use Save)
(use File)
(use Game)
(use User)
(use Actor)
(use System)

(public
	CharSave 0
)

(local
	local0 =  83
	local1
	local2
	local3
	local4
	local5
	[local6 30]
	local36
	local37
	local38
	local39
	local40
	local41 =  160
	local42 =  62
	local43
	local44
	local45 =  47
	local46 =  144
	local47 =  25
	local48 =  163
	local49 =  218
	local50
	local51
	[local52 10]
	[local62 44]
	[local106 400]
	local506
	[local507 40]
	local547
)
(instance CharSave of Rm
	(properties
		picture 900
		style $0007
	)
	
	(method (init)
		(SL code: endStatus enable:)
		(gKeyH add: self)
		(super init: &rest)
		(gCWin back: 0 color: 15)
		(songObj init: hide:)
		(addToPics
			add: frame1 frame2 frame3 frame4 frame5 frame6 frame7 frame8
			eachElementDo: #init
			doit:
		)
		(gCMusic number: 830 loop: -1 priority: 5 play:)
		(User canControl: 0 canInput: 0)
		(self setScript: saveHero)
		(songObj setScript: songScript)
	)
	
	(method (dispose)
		(SL code: gStatLn)
		(gKeyH delete: self)
		(super dispose:)
	)
)

(instance glory2_sav of Class_993_0
	(properties
		name "glory2.sav"
	)
)

(instance saveHero of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1 temp2 temp3 temp4)
		(asm
			lap      newState
			aTop     state
			push    
			dup     
			ldi      0
			eq?     
			bnt      code_01db
			pushi    3
			lea      @local62
			push    
			pushi    840
			pushi    0
			callk    Format,  6
			lsg      score
			lag      possibleScore
			ge?     
			bnt      code_01ae
			pushi    5
			lea      @local106
			push    
			pushi    840
			pushi    1
			lsg      possibleScore
			dup     
			callk    Format,  10
			pushi    8
			lea      @local106
			push    
			pushi    35
			lsg      gCWin
			pushi    30
			pushi    1
			pushi    70
			pushi    220
			pushi    103
			calle    Print,  16
			jmp      code_01d4
code_01ae:
			pushi    8
			pushi    5
			lea      @local106
			push    
			pushi    840
			pushi    2
			lsg      score
			lsg      possibleScore
			callk    Format,  10
			push    
			pushi    35
			lsg      gCWin
			pushi    30
			pushi    1
			pushi    70
			pushi    220
			pushi    103
			calle    Print,  16
code_01d4:
			ldi      1
			aTop     register
			jmp      code_072e
code_01db:
			dup     
			ldi      1
			eq?     
			bnt      code_0202
			pushi    9
			pushi    840
			pushi    3
			pushi    35
			lsg      gCWin
			pushi    30
			pushi    1
			pushi    70
			pushi    220
			pushi    103
			calle    Print,  18
			ldi      1
			aTop     register
			jmp      code_072e
code_0202:
			dup     
			ldi      2
			eq?     
			bnt      code_0229
			pushi    9
			pushi    840
			pushi    4
			pushi    35
			lsg      gCWin
			pushi    30
			pushi    1
			pushi    70
			pushi    220
			pushi    103
			calle    Print,  18
			ldi      1
			aTop     register
			jmp      code_072e
code_0229:
			dup     
			ldi      3
			eq?     
			bnt      code_0270
			pushi    0
			calle    DisposeDialog,  0
			pushi    9
			pushi    840
			pushi    5
			pushi    35
			lsg      gCWin
			pushi    30
			pushi    1
			pushi    41
			lea      @local62
			push    
			pushi    30
			calle    Print,  18
			bnt      code_0265
			pushi    #name
			pushi    1
			lea      @local62
			push    
			lofsa    glory2_sav
			send     6
			ldi      2
			aTop     cycles
			jmp      code_072e
code_0265:
			pushi    #changeState
			pushi    1
			pushi    9
			self     6
			jmp      code_072e
code_0270:
			dup     
			ldi      4
			eq?     
			bnt      code_02ec
			ldi      0
			sal      local547
			pushi    #open
			pushi    1
			pushi    1
			lofsa    glory2_sav
			send     6
			push    
			ldi      0
			ne?     
			bnt      code_02e5
code_028d:
			pushi    14
			pushi    840
			pushi    6
			pushi    80
			lofsa    { WARNING!_}
			push    
			pushi    30
			pushi    1
			pushi    35
			lofsa    Warning
			push    
			pushi    81
			lofsa    { NO_}
			push    
			pushi    1
			pushi    81
			lofsa    { YES_}
			push    
			pushi    2
			calle    Print,  28
			sal      local547
			bnt      code_02be
			jmp      code_02c1
code_02be:
			jmp      code_028d
code_02c1:
			lsl      local547
			dup     
			ldi      1
			eq?     
			bnt      code_02d6
			pushi    #changeState
			pushi    1
			pushi    3
			self     6
			jmp      code_02e1
code_02d6:
			dup     
			ldi      2
			eq?     
			bnt      code_02e1
			ldi      1
			aTop     cycles
code_02e1:
			toss    
			jmp      code_072e
code_02e5:
			ldi      1
			aTop     cycles
			jmp      code_072e
code_02ec:
			dup     
			ldi      5
			eq?     
			bnt      code_0347
			pushi    #open
			pushi    1
			pushi    2
			lofsa    glory2_sav
			send     6
			bnt      code_0310
			pushi    #close
			pushi    0
			lofsa    glory2_sav
			send     4
			ldi      2
			aTop     seconds
			jmp      code_072e
code_0310:
			pushi    7
			pushi    4
			lea      @local106
			push    
			pushi    840
			pushi    7
			pushi    #name
			pushi    0
			lofsa    glory2_sav
			send     4
			push    
			callk    Format,  8
			push    
			pushi    35
			lofsa    Warning
			push    
			pushi    30
			pushi    1
			pushi    70
			pushi    220
			calle    Print,  14
			pushi    #changeState
			pushi    1
			pushi    9
			self     6
			jmp      code_072e
code_0347:
			dup     
			ldi      6
			eq?     
			bnt      code_05f2
			pushi    #open
			pushi    1
			pushi    0
			lofsa    glory2_sav
			send     6
			not     
			bnt      code_0365
			pushi    #changeState
			pushi    1
			pushi    9
			self     6
			ret     
code_0365:
			pushi    7
			pushi    840
			pushi    8
			pushi    35
			lsg      gCWin
			pushi    30
			pushi    1
			pushi    103
			calle    Print,  14
			ldi      0
			sat      temp0
code_037d:
			lst      temp0
			ldi      30
			lt?     
			bnt      code_0391
			lat      temp0
			lsgi     skills
			sali     local6
			+at      temp0
			jmp      code_037d
code_0391:
			ldi      2
			lagi     invNum
			sat      temp1
			lag      heroType
			sal      local1
			lst      temp1
			ldi      100
			div     
			sal      local2
			lst      temp1
			ldi      100
			mod     
			sal      local3
			lag      score
			sal      local4
			ldi      0
			sal      local5
			pushi    #has
			pushi    1
			pushi    24
			lag      ego
			send     6
			bnt      code_03c6
			lsl      local5
			ldi      1
			or      
			sal      local5
code_03c6:
			pushi    #has
			pushi    1
			pushi    31
			lag      ego
			send     6
			bnt      code_03da
			lsl      local5
			ldi      2
			or      
			sal      local5
code_03da:
			pushi    #has
			pushi    1
			pushi    23
			lag      ego
			send     6
			bnt      code_03ee
			lsl      local5
			ldi      3
			or      
			sal      local5
code_03ee:
			pushi    #has
			pushi    1
			pushi    27
			lag      ego
			send     6
			bnt      code_0402
			lsl      local5
			ldi      4
			or      
			sal      local5
code_0402:
			pushi    #has
			pushi    1
			pushi    33
			lag      ego
			send     6
			bnt      code_0416
			lsl      local5
			ldi      8
			or      
			sal      local5
code_0416:
			pushi    #has
			pushi    1
			pushi    40
			lag      ego
			send     6
			bnt      code_042a
			lsl      local5
			ldi      16
			or      
			sal      local5
code_042a:
			pushi    #has
			pushi    1
			pushi    54
			lag      ego
			send     6
			bnt      code_043e
			lsl      local5
			ldi      32
			or      
			sal      local5
code_043e:
			pushi    1
			pushi    156
			calle    Btst,  2
			bnt      code_0450
			lsl      local5
			ldi      48
			or      
			sal      local5
code_0450:
			pushi    #has
			pushi    1
			pushi    4
			lag      ego
			send     6
			bnt      code_0464
			lsl      local5
			ldi      64
			or      
			sal      local5
code_0464:
			pushi    #has
			pushi    1
			pushi    15
			lag      ego
			send     6
			bnt      code_0479
			lsl      local5
			ldi      128
			or      
			sal      local5
code_0479:
			pushi    #has
			pushi    1
			pushi    10
			lag      ego
			send     6
			bnt      code_048e
			lsl      local5
			ldi      256
			or      
			sal      local5
code_048e:
			pushi    #has
			pushi    1
			pushi    11
			lag      ego
			send     6
			bnt      code_04a3
			lsl      local5
			ldi      512
			or      
			sal      local5
code_04a3:
			ldi      5
			lagi     invNum
			sal      local36
			ldi      18
			lagi     invNum
			sal      local37
			ldi      19
			lagi     invNum
			sal      local38
			ldi      20
			lagi     invNum
			sal      local39
			ldi      48
			lagi     invNum
			sal      local40
			lal      local49
			sal      local50
			ldi      0
			sat      temp0
code_04ce:
			lst      temp0
			ldi      40
			lt?     
			bnt      code_04ff
			lst      temp0
			ldi      1
			add     
			lsli     local0
			ldi      255
			and     
			push    
			lst      temp0
			ldi      1
			add     
			sali     local0
			lsl      local50
			lst      temp0
			ldi      1
			add     
			lali     local0
			add     
			sal      local50
			lst      temp0
			ldi      2
			add     
			sat      temp0
			jmp      code_04ce
code_04ff:
			ldi      0
			sal      local51
			ldi      1
			sat      temp0
code_0507:
			lst      temp0
			ldi      40
			lt?     
			bnt      code_0538
			lst      temp0
			ldi      1
			add     
			lsli     local0
			ldi      255
			and     
			push    
			lst      temp0
			ldi      1
			add     
			sali     local0
			lsl      local51
			lst      temp0
			ldi      1
			add     
			lali     local0
			add     
			sal      local51
			lst      temp0
			ldi      2
			add     
			sat      temp0
			jmp      code_0507
code_0538:
			lsl      local50
			ldi      255
			and     
			sal      local50
			lsl      local51
			ldi      255
			and     
			sal      local51
			lal      local50
			sal      local43
			lal      local51
			sal      local44
			ldi      0
			sat      temp0
code_0554:
			lst      temp0
			ldi      48
			lt?     
			bnt      code_0588
			lst      temp0
			ldi      1
			add     
			lsli     local0
			ldi      255
			and     
			push    
			lst      temp0
			ldi      1
			add     
			sali     local0
			lst      temp0
			ldi      1
			add     
			lsli     local0
			lat      temp0
			lali     local0
			xor     
			push    
			lst      temp0
			ldi      1
			add     
			sali     local0
			+at      temp0
			jmp      code_0554
code_0588:
			lofsa    {*}
			sat      temp2
			pushi    3
			push    
			pushi    0
			pushi    10
			callk    StrAt,  6
			pushi    #writeString
			pushi    2
			lea      @userName
			push    
			lst      temp2
			lofsa    glory2_sav
			send     8
			ldi      1
			sat      temp0
code_05ab:
			lst      temp0
			ldi      49
			lt?     
			bnt      code_05d7
			pushi    4
			lea      @local106
			push    
			pushi    840
			pushi    9
			lat      temp0
			lsli     local0
			callk    Format,  8
			pushi    #writeString
			pushi    1
			lea      @local106
			push    
			lofsa    glory2_sav
			send     6
			+at      temp0
			jmp      code_05ab
code_05d7:
			pushi    #writeString
			pushi    1
			lst      temp2
			lofsa    glory2_sav
			send     6
			pushi    #close
			pushi    0
			lofsa    glory2_sav
			send     4
			ldi      2
			aTop     seconds
			jmp      code_072e
code_05f2:
			dup     
			ldi      7
			eq?     
			bnt      code_0623
			lag      modelessDialog
			bnt      code_0603
			pushi    #dispose
			pushi    0
			send     4
code_0603:
			pushi    9
			pushi    840
			pushi    10
			pushi    35
			lsg      gCWin
			pushi    70
			pushi    220
			pushi    30
			pushi    1
			pushi    103
			calle    Print,  18
			ldi      1
			aTop     register
			jmp      code_072e
code_0623:
			dup     
			ldi      8
			eq?     
			bnt      code_063a
			ldi      1
			sal      local506
			pushi    #changeState
			pushi    1
			pushi    10
			self     6
			jmp      code_072e
code_063a:
			dup     
			ldi      9
			eq?     
			bnt      code_06b1
code_0641:
			pushi    12
			pushi    840
			pushi    11
			pushi    81
			lofsa    { No_}
			push    
			pushi    1
			pushi    81
			lofsa    { Yes_}
			push    
			pushi    2
			pushi    35
			lsg      gCWin
			pushi    30
			pushi    1
			calle    Print,  24
			sat      temp4
			bnt      code_0641
			push    
			dup     
			ldi      1
			eq?     
			bnt      code_0678
			ldi      10
			sat      temp4
			jmp      code_06a6
			jmp      code_06a2
code_0678:
			dup     
			ldi      2
			eq?     
			bnt      code_06a2
			ldi      3
			sat      temp4
			ldi      121
			sal      local41
			ldi      134
			sal      local42
			ldi      67
			sal      local45
			ldi      136
			sal      local46
			ldi      173
			sal      local47
			ldi      240
			sal      local48
			jmp      code_06a6
code_06a2:
			toss    
			jmp      code_0641
code_06a6:
			pushi    #changeState
			pushi    1
			lst      temp4
			self     6
			jmp      code_072e
code_06b1:
			dup     
			ldi      10
			eq?     
			bnt      code_06d6
			pushi    8
			pushi    840
			pushi    12
			pushi    35
			lsg      gCWin
			pushi    70
			pushi    220
			pushi    30
			pushi    1
			calle    Print,  16
			ldi      4
			aTop     seconds
			jmp      code_072e
code_06d6:
			dup     
			ldi      11
			eq?     
			bnt      code_0701
			pushi    #number
			pushi    0
			lag      gMiscMusic
			send     4
			push    
			ldi      831
			eq?     
			bnt      code_06f3
			ldi      1
			aTop     cycles
			jmp      code_072e
code_06f3:
			pushi    #setScript
			pushi    2
			lofsa    waitForSong
			push    
			pushSelf
			self     8
			jmp      code_072e
code_0701:
			dup     
			ldi      12
			eq?     
			bnt      code_071c
			pushi    #drawPic
			pushi    2
			pushi    900
			pushi    7
			lag      curRoom
			send     8
			ldi      1
			aTop     cycles
			jmp      code_072e
code_071c:
			dup     
			ldi      13
			eq?     
			bnt      code_072e
			pushi    #newRoom
			pushi    1
			pushi    850
			lag      curRoom
			send     6
code_072e:
			toss    
			ret     
		)
	)
	
	(method (handleEvent pEvent)
		(if
			(and
				(== (pEvent type?) evKEYBOARD)
				(== (pEvent message?) KEY_RETURN)
				register
			)
			(= register 0)
			(= cycles 1)
			(pEvent claimed: 1)
		)
	)
)

(instance endStatus of Code
	(properties)
	
	(method (doit param1)
		(if (== heroType 3)
			(Format param1 840 13 score possibleScore)
		else
			(Format param1 840 14 score possibleScore)
		)
	)
)

(instance frame1 of PicView
	(properties
		x 81
		y 33
		view 242
	)
)

(instance frame2 of PicView
	(properties
		x 239
		y 33
		view 242
		loop 1
	)
)

(instance frame3 of PicView
	(properties
		x 19
		y 94
		view 242
		cel 1
	)
)

(instance frame4 of PicView
	(properties
		x 20
		y 156
		view 242
		cel 2
	)
)

(instance frame5 of PicView
	(properties
		x 81
		y 189
		view 242
		cel 3
	)
)

(instance frame6 of PicView
	(properties
		x 238
		y 189
		view 242
		loop 1
		cel 3
	)
)

(instance frame7 of PicView
	(properties
		x 300
		y 156
		view 242
		loop 1
		cel 2
	)
)

(instance frame8 of PicView
	(properties
		x 301
		y 94
		view 242
		loop 1
		cel 1
	)
)

(instance Warning of SysWindow
	(properties
		color 14
		back 4
	)
)

(instance songObj of Prop
	(properties)
)

(instance songScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 8))
			(1
				(gSpareMusic number: 833 priority: 10 loop: -1 play:)
				(= seconds 8)
			)
			(2
				(if (== (saveHero script?) waitForSong)
					(waitForSong cue:)
				else
					(waitForSong start: 1)
				)
				(gMiscMusic number: 831 loop: -1 priority: 11 play:)
				(= cycles 1)
			)
			(3 (self dispose:))
		)
	)
)

(instance waitForSong of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 0)
			(1 (self dispose:))
		)
	)
)
