;;; Sierra Script 1.0 - (do not remove this comment)
(script# 70)
(include sci.sh)
(use Main)
(use System)

(public
	theCharSheet 0
)

(local
	[local0 4] = [7 25 19 30]
	[local4 4] = [30 32 36 32]
)
(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 30)
		(= [lastViewedSkills temp0] [skills temp0])
		(++ temp0)
	)
)

(procedure (localproc_0028 param1 param2 &tmp temp0)
	(= temp0 (if (< colorCount 16) 0 else 1))
	(Display
		&rest
		dsCOORD
		param1
		param2
		dsALIGN
		0
		dsFONT
		300
		dsCOLOR
		temp0
	)
)

(procedure (localproc_0054 param1 param2 param3)
	(Display
		&rest
		dsCOORD
		param1
		param2
		dsALIGN
		0
		dsFONT
		300
		dsCOLOR
		param3
		dsBACKGROUND
		15
	)
)

(procedure (localproc_0072 param1)
	(return
		(if (== [skills param1] [lastViewedSkills param1])
			statColor
		else
			statColorNew
		)
	)
)

(procedure (localproc_0086 param1 param2 param3 param4 &tmp temp0 [temp1 6])
	(= temp0
		(if param4 (localproc_0072 param3) else statColor)
	)
	(localproc_0054
		param1
		param2
		temp0
		(Format @temp1 70 0 [skills param3])
		106
		22
	)
)

(class CharSheet of Obj
	(properties
		nsTop 0
		nsLeft 0
		nsBottom 189
		nsRight 319
		theWindow 0
		useWindow 0
		showBars 0
		oldValid 0
	)
	
	(method (init &tmp temp0)
		(super init:)
		(Load rsVIEW 805)
		(= oldValid (PicNotValid 0))
		(if useWindow
			(= temp0 {*})
			(StrAt temp0 0 0)
			(= theWindow
				(NewWindow nsTop nsLeft nsBottom nsRight temp0 0 -1 0 15)
			)
		)
		(DrawCel
			805
			0
			heroType
			[local0 heroType]
			[local4 (DrawCel 805 2 0 10 23 -1)]
			-1
		)
		(localproc_0028 10 8 70 1)
		(localproc_0028 83 28 70 2)
		(localproc_0028 83 40 70 3)
		(localproc_0028 83 52 70 4)
		(localproc_0028 83 64 70 5)
		(localproc_0028 83 76 70 6)
		(if showBars
			(localproc_0028 83 88 70 7)
			(localproc_0028 10 112 70 8)
			(localproc_0028 10 124 70 9)
		)
		(localproc_0028 10 148 70 10)
		(localproc_0028 10 160 70 11)
		(localproc_0028 10 172 70 12)
		(localproc_0028 207 28 70 13)
		(localproc_0028 207 40 70 14)
		(localproc_0028 207 52 70 15)
		(localproc_0028 207 64 70 16)
		(localproc_0028 207 76 70 17)
		(localproc_0028 207 88 70 18)
		(localproc_0028 207 100 70 19)
		(localproc_0028 207 112 70 20)
		(if showBars (localproc_0028 207 124 70 21))
		(self update:)
	)
	
	(method (doit &tmp newEvent newEventType)
		(= newEventType 0)
		(while (not newEventType)
			(GlobalToLocal (= newEvent (Event new:)))
			(= newEventType (newEvent type?))
			(newEvent dispose:)
		)
		(self dispose:)
	)
	
	(method (dispose)
		(localproc_000c)
		(if theWindow (DisposeWindow theWindow))
		(PicNotValid oldValid)
		(super dispose:)
	)
	
	(method (update &tmp temp0 [temp1 20])
		(if showBars
			(Display
				@userName
				dsWIDTH
				260
				dsCOORD
				58
				8
				dsALIGN
				0
				dsFONT
				300
				dsCOLOR
				statColor
			)
		)
		(localproc_0086 170 28 0 showBars)
		(localproc_0086 170 40 1 showBars)
		(localproc_0086 170 52 2 showBars)
		(localproc_0086 170 64 3 showBars)
		(localproc_0086 170 76 4 showBars)
		(if showBars
			(localproc_0086 170 88 14 showBars)
			(= temp0
				(if (== score score_2) statColor else statColorNew)
			)
			(= score_2 score)
			(localproc_0054
				103
				112
				temp0
				(Format @temp1 70 0 score)
				106
				50
			)
			(localproc_0054
				103
				124
				(localproc_0072 15)
				(Format @temp1 70 0 [skills 15])
				106
				50
			)
		)
		(= temp0
			(if showBars (localproc_0072 16) else statColor)
		)
		(localproc_0054
			103
			148
			temp0
			(Format
				@temp1
				70
				22
				(/ (+ [skills 16] 1) 2)
				(/ (+ (GetMaxHealth) 1) 2)
			)
			106
			60
		)
		(= temp0
			(if showBars (localproc_0072 17) else statColor)
		)
		(localproc_0054
			103
			160
			temp0
			(Format
				@temp1
				70
				22
				(/ (+ [skills 17] 3) 4)
				(/ (+ (GetMaxStamina) 3) 4)
			)
			106
			60
		)
		(= temp0
			(if showBars (localproc_0072 18) else statColor)
		)
		(localproc_0054
			103
			172
			temp0
			(Format @temp1 70 22 [skills 18] (GetMaxMana))
			106
			60
		)
		(localproc_0086 288 28 5 showBars)
		(localproc_0086 288 40 6 showBars)
		(localproc_0086 288 52 7 showBars)
		(localproc_0086 288 64 8 showBars)
		(localproc_0086 288 76 9 showBars)
		(localproc_0086 288 88 10 showBars)
		(localproc_0086 288 100 11 showBars)
		(localproc_0086 288 112 12 showBars)
		(if showBars (localproc_0086 288 124 13 showBars))
	)
)

(instance theCharSheet of CharSheet
	(properties)
)
