;;; Sierra Script 1.0 - (do not remove this comment)
(script# 141)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Intrface)
(use MoveFwd)
(use Reverse)
(use Timer)
(use Motion)
(use Actor)
(use System)

(public
	busted 0
	outaHere 1
	sneakIn 2
	IssurFlex 3
	thrownOut 4
	Issur 5
	enterScript 6
	bustTimer 7
	pendant 8
	gShield 9
	shrine 10
	rShield 11
	rack 12
	lMace 13
	dblAxe 14
	lAxe 15
	rSword 16
	cleaver 17
	rMace 18
	saber 19
	lSword 20
	mail 21
	plaque 22
)

(local
	[local0 34] = [1 2 0 0 3 0 0 4 5 6 0 7 0 0 0 0 8 0 9 10 11 0 12 0 13 14 0 0 0 0 0 0 15 16]
	[local34 35] = [26 '//weapon' 27 '//dagger' 28 '//blade' 29 '//wrestle,bet' 30 '//strength' 31 '//muscle' 32 '//defeat' 33 '//eof' 34 '//paladin' 35 '//shield' 36 '//ax' 37 '//anvil' 38 '//mace' 39 '//chainmail' 40 '//fire' 41 '//bellows']
	local69
	local70
)
(instance Issur of Talker
	(properties
		x 114
		y 96
		description {the owner of the Weapon Shop of Issur}
		view 145
		illegalBits $0000
		tLoop 3
		talkSpeed 1
		myName '//issur,man,armorer,keeper,clerk'
		title {Issur:}
		back 11
		msgFile 145
	)
	
	(method (init)
		(Load rsTEXT 145)
		(super init:)
	)
	
	(method (doit)
		(cond 
			((!= prevRoomNum 150)
				(if
				(and (ego inRect: 90 98 140 110) (not (ego script?)))
					(Say self backOff 141 0)
					(ego setScript: backOff)
				)
			)
			(
			(and (< (ego x?) (+ (self x?) 15)) (not local70)) (= local70 1) (ego setScript: getBack))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'get,acquire/blade,weapon,mace,shield,ax,dagger') (HighPrint 141 1))
			((Said 'buy>')
				(cond 
					((Said '/ax') (Say Issur self 145 36))
					((Said '/mace') (Say Issur self 145 38))
					((Said '/shield') (Say Issur self 145 35))
					((Said '/chainmail') (Say Issur self 145 39))
					((Said '/dagger') (self setScript: (ScriptID 140 2) 0 4))
				)
			)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 141 2))
			(9
				(cond 
					(script (HighPrint 141 3))
					((TestSkill 13 80) (Say Issur 141 4))
					(else (Say Issur 141 5))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (calmMe)
		(if (Btst 165)
			(HighPrint 141 13)
		else
			(Bset 165)
			(HighPrint 141 14)
		)
		(return 1)
	)
	
	(method (dazzleMe)
		(ego setScript: thrownOut)
		(return 1)
	)
	
	(method (hurtMe)
		(ego setScript: thrownOut)
		(return 1)
	)
	
	(method (respond param1)
		(if
			(and
				(not (ego inRect: 40 95 180 150))
				(!= prevRoomNum 150)
			)
			(FaceObject ego Issur)
			(Say Issur 141 6)
			(param1 claimed: 1)
		else
			(if script
				(self setCycle: 0 setLoop: 3 setCel: 0 setScript: 0)
			)
			(super respond: param1 &rest)
		)
	)
	
	(method (atSpec param1)
		(return [local34 param1])
	)
	
	(method (atGen param1)
		(return [local0 param1])
	)
	
	(method (showText param1)
		(switch param1
			(0 (++ local69))
			(1 (++ local69))
			(else  (= local69 0))
		)
		(cond 
			((== param1 41)
				(cond 
					((ego has: 25) (Say Issur 141 7))
					((not (Btst 22)) (Say Issur 141 8))
					((Btst 165)
						(AddToScore 609 7)
						(Say Issur 141 9)
						(Print 141 10)
						((ScriptID 140 1) dispose:)
						(ego get: 25)
					)
					(else (Say Issur 141 11) (= issurBet 20))
				)
			)
			((>= local69 4) (ego setScript: thrownOut))
			((>= local69 3) (Say Issur 141 12))
			(else (super showText: param1))
		)
	)
	
	(method (messages)
		(if script
			(self setCycle: 0 setLoop: 3 setCel: 0 setScript: 0)
		)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(self setCycle: Beg)
		(super endTalk:)
	)
)

(instance busted of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(theGuard
					init:
					setCycle: Walk
					setMotion: MoveTo 290 148 self
				)
			)
			(1
				(if register
					(Die 1 141 15 80 {Caught red-handed})
				else
					(Die 1 141 16 80 {Return to the scene of the crime})
				)
			)
		)
	)
)

(instance outaHere of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego inRect: 0 128 108 164)
					(ego setMotion: MoveTo 123 119 self)
				else
					(self cue:)
				)
			)
			(1
				(ego setMotion: MoveTo 277 144 self)
			)
			(2
				(ego setMotion: MoveTo 315 155)
				(self dispose:)
			)
		)
	)
)

(instance sneakIn of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(ego illegalBits: -32764)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 215 104 self)
			)
			(1
				(ego setHeading: 0)
				(if (Btst 26)
					(ego setScript: busted 0 0)
				else
					(proc1_32 bustTimer 150)
				)
				(self dispose:)
			)
		)
	)
)

(instance IssurFlex of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Issur loop: 0 cel: 0 cycleSpeed: 3 setCycle: End self)
			)
			(1
				(Issur loop: 1 cel: 0 cycleSpeed: 2 setCycle: End self)
			)
			(2
				(Issur loop: 2 cel: 0 setCycle: End self)
			)
			(3
				(Issur loop: 2 setCycle: Beg self)
			)
			(4
				(Issur loop: 1 cel: 5 setCycle: Beg self)
			)
			(5
				(Issur loop: 0 cel: 0 cycleSpeed: 2 setCycle: End self)
			)
			(6 (self dispose:))
		)
	)
)

(instance shopWindow of TopWindow
	(properties)
)

(instance thrownOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 25)
				(shopWindow color: 0 back: 11)
				(HighPrint 141 17 35 shopWindow 103)
				(Issur setLoop: 6 cel: 0 setCycle: CT 2 1)
				(FaceObject ego Issur)
				(= cycles 10)
			)
			(1
				(ego
					view: 0
					illegalBits: -32768
					setLoop: (ego loop?)
					moveSpeed: 1
					cycleSpeed: 1
					setCycle: Rev
					setMotion: MoveFwd -25
				)
				(= cycles 8)
			)
			(2
				(DisposeDialog)
				(Issur setCycle: End)
				(= cycles 12)
			)
			(3
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 2)
			)
			(4 (curRoom newRoom: 330))
		)
	)
)

(instance theGuard of Actor
	(properties
		x 320
		y 135
		noun '/guard'
		description {the guard}
		lookStr {This is a real guard.}
		view 294
		illegalBits $0000
	)
)

(instance backOff of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0)
			(1
				(ego
					setHeading: (GetAngle (Issur x?) (Issur y?) (ego x?) (ego y?)) self
				)
			)
			(2
				(ego setMotion: MoveFwd 15 self)
			)
			(3
				(FaceObject ego Issur)
				(self dispose:)
			)
		)
	)
)

(instance enterScript of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(ego illegalBits: -32764)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 176 136 self)
			)
			(1 (ego setHeading: 315 self))
			(2
				(cond 
					((== global259 1) (Say Issur self 145 16))
					((Btst 25) (Say Issur self 141 18) (Bclr 25))
					((Btst 23) (Say Issur self 141 19))
					((Btst 17)
						(= temp0 (proc1_5 global259 18 25))
						(Say Issur self 145 temp0)
					)
					(else (Say Issur self 145 17))
				)
			)
			(3
				(cond 
					((== 1 global259) (Issur setScript: IssurFlex))
					((== 0 (mod global259 3)) (Issur setScript: IssurFlex))
				)
				(self dispose:)
			)
		)
	)
)

(instance getBack of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say Issur self 141 20))
			(1
				(ego setMotion: MoveTo (+ (ego x?) 20) (ego y?) self)
			)
			(2
				(FaceObject ego Issur)
				(= local70 0)
				(self dispose:)
			)
		)
	)
)

(instance bustTimer of Timer
	(properties)
	
	(method (cue)
		(if (< ((ScriptID 140 3) cel?) 2)
			(ego setScript: busted 0 1)
		)
		(self dispose:)
	)
)

(instance pendant of PicView
	(properties
		x 46
		y 33
		noun '/trophy'
		description {the trophy}
		lookStr {One of the many trophies won at the Desert Wrist-wrestling Championships in Petalumeir.}
		view 140
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 21)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance gShield of PicView
	(properties
		x 15
		y 55
		noun '/shield[<black]'
		description {the Shield of Falworth}
		lookStr {It's the Black Shield of Falworth.__It's been repainted.}
		view 140
		cel 1
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 22)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance shrine of PicView
	(properties
		x 96
		y 79
		noun '/shrine,cover[<errand]'
		description {the "Shrine of Hero's Quest"}
		lookStr {It's the cover from the "Shrine of Hero's Quest," gone but not forgotten.}
		view 140
		cel 2
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 23)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance rShield of PicView
	(properties
		x 93
		y 46
		noun '/shield[<banzai,bronze]'
		description {the shield}
		lookStr {It's a burnished bronze banzai shield.}
		view 140
		cel 3
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 22)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance rack of PicView
	(properties
		x 191
		y 95
		noun '/rack'
		description {the rack of swords}
		lookStr {The rack is used to organize Issur's many swords.}
		view 140
		cel 4
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 24)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance lMace of PicView
	(properties
		x 201
		y 40
		noun '/mace[<big]'
		description {the large mace}
		lookStr {A mace in the face will make you race with haste to the nearest plastic surgeon's place.}
		view 140
		loop 1
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 25)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance dblAxe of PicView
	(properties
		x 174
		y 43
		noun '/ax<double,(bladed<2)'
		description {the two-bladed axe}
		lookStr {The double-bladed axe, a precursor of Gilette blades.}
		view 140
		loop 1
		cel 1
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 26)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance lAxe of PicView
	(properties
		x 221
		y 49
		noun '/ax[<bladed<single]'
		description {the single-bladed axe}
		lookStr {You could make short work of the Wood Elemental with this baby.}
		view 140
		loop 1
		cel 2
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 26)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance rSword of PicView
	(properties
		x 146
		y 43
		noun '/blade'
		description {the sword}
		lookStr {A sword for the few...the proud...the mercenaries.}
		view 140
		loop 1
		cel 3
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 27)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance cleaver of PicView
	(properties
		x 201
		y 61
		noun '/dagger,scimitar,(blade<little)'
		description {the scimitar}
		lookStr {A sword for the wee people.}
		view 140
		loop 1
		cel 4
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 28)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance rMace of PicView
	(properties
		x 185
		y 68
		noun '/mace[<little]'
		description {the small mace}
		lookStr {A mace in the face will make you race with haste to the nearest plastic surgeon's place.}
		view 140
		loop 2
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 29)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance saber of PicView
	(properties
		x 171
		y 69
		noun '/tusk,(blade<ivory)'
		description {the ivory tusk}
		lookStr {Put on layaway by a desert brigand, this appears to be a sword made from the tusk of the fierce desert creature known as a Tisk.__Obtaining a Tisk tusk is a task, because of the risk of getting a Tisk ticked.}
		view 140
		loop 2
		cel 1
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 30)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance lSword of PicView
	(properties
		x 222
		y 64
		noun '/sheath'
		description {the sheath}
		lookStr {Let's face it...how many swords can one guy own?}
		view 140
		loop 2
		cel 2
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 31)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance mail of PicView
	(properties
		x 132
		y 96
		noun '/chainmail,(shirt,chainmail,coat<chainmail)'
		description {the coat of mail}
		lookStr {The silvery, shimmering coat of costly mail glistens in the glimmering glow of the fire.}
		view 140
		loop 3
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 32)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance plaque of PicView
	(properties
		x 278
		y 79
		noun '/sign'
		description {the sign}
		lookStr {It is the shop's sign which hangs in the plaza.}
		view 140
		loop 2
		cel 4
		priority 15
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(HighPrint 141 33)
		else
			(super doVerb: theVerb &rest)
		)
	)
)
