;;; Sierra Script 1.0 - (do not remove this comment)
(script# 85)
(include sci.sh)
(use Main)
(use n001)
(use Merchant)
(use Timer)
(use Motion)


(local
	[local0 32] = [1 2 3 0 4 5 6 7 8 0 9 10 11 0 12 0 13 0 14 0 15 16 17 18 19 20 0 21 22 23 24]
	[local32 10] = [25 '//shameen' 26 '//shema' 27 '//cousin' 28 '//bazaar']
)
(class KattaMerchant of Merchant
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 350
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $4000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 15
		back 6
		msgFile 350
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
		wares 0
		curWare 0
		cueMethod 0
		isSeated 1
		isOnLeft 1
		clothesColor 0
	)
	
	(method (init)
		(super init:)
		(= loop (+ (* 2 (not isSeated)) (not isOnLeft)))
		(= tLoop (+ 2 (not isOnLeft)))
		(= timer (SitDownTimer new:))
		(= palette (proc1_5 (+ clothesColor currentDay) 1 6))
	)
	
	(method (saidMe param1 &tmp temp0)
		(if (not (= temp0 (super saidMe: param1)))
			(= temp0 (Said '[/catperson]>'))
		)
		(return temp0)
	)
	
	(method (atSpecAnswer &tmp superAtSpecAnswer)
		(return
			(if
			(== (= superAtSpecAnswer (super atSpecAnswer:)) 32767)
				(return (self scanSaidSpecs: 669))
			else
				(return superAtSpecAnswer)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local32 param1])
	)
	
	(method (atGen param1)
		(return [local0 param1])
	)
	
	(method (messages)
		(timer seconds: -1)
		(if (and isSeated (not cel))
			(self state: -1 setCycle: End self)
		)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(super endTalk:)
		(if cel (timer setReal: self 5))
		(if isSeated (self startUpd:))
	)
	
	(method (atIndividualSpec)
		(return 0)
	)
)

(class SitDownTimer of Timer
	(properties
		cycleCnt -1
		seconds -1
		lastTime -1
		client 0
		caller 0
	)
	
	(method (init theCaller)
		(super init: theCaller &rest)
		(= client self)
		(= caller theCaller)
	)
	
	(method (cue)
		(caller setCycle: Beg)
	)
)
