;;; Sierra Script 1.0 - (do not remove this comment)
(script# 997)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use _MapLocation)
(use Intrface)
(use Printd)
(use Save)
(use User)
(use System)

(public
	ToggleSound 0
	proc997_1 1
)

(procedure (ToggleSound)
	(if (GetMenu 774 113)
		(DoSound sndPLAY 0)
		(SetMenu 774 113 0 110 {Turn on})
	else
		(DoSound sndPLAY 1)
		(SetMenu 774 113 1 110 {Turn off})
	)
)

(procedure (proc997_1 param1 &tmp temp0)
	(= temp0 (if param1 0 else 1))
	(SetMenu 513 112 temp0)
	(SetMenu 769 112 temp0)
	(SetMenu 770 112 temp0)
	(SetMenu 771 112 temp0)
	(SetMenu 776 112 temp0)
	(SetMenu 777 112 temp0)
	(SetMenu 1025 112 temp0)
	(SetMenu 1026 112 temp0)
	(SetMenu 1027 112 temp0)
	(SetMenu 1030 112 temp0)
	(SetMenu 1281 112 temp0)
	(SetMenu 1282 112 temp0)
	(SetMenu 1284 112 temp0)
	(SetMenu 1285 112 temp0)
	(SetMenu 1286 112 temp0)
	(SetMenu 1287 112 temp0)
	(SetMenu 1289 112 temp0)
	(SetMenu 1290 112 temp0)
)

(procedure (localproc_004c param1)
	(if (> argc 1) (Format (User inputLineAddr?) &rest))
	(param1 claimed: 0 type: 4 message: (User echo?))
)

(procedure (localproc_007d &tmp [temp0 30])
	(PrintGameTime @temp0)
	(HighPrint @temp0)
)

(procedure (localproc_0092 &tmp temp0)
	(if (ego has: 23)
		(compassWindow back: (Random 0 15))
		(= temp0
			(cond 
				((== curRoomNum 665) (if (>= gTheGNorth 5000) 3 else 1))
				((OneOf curRoomNum 703 704) (curRoom facingHeading?))
				((curRoom respondsTo: #topExit) (curRoom topExit?))
				((OneOf curRoomNum 270 380 480 530 550) 3)
				(
					(OneOf
						curRoomNum
						120
						161
						170
						190
						199
						260
						360
						370
						400
						410
						490
					)
					4
				)
				((OneOf curRoomNum 100 112 118 140 271) 2)
				(else 1)
			)
		)
		(Print
			997
			0
			82
			711
			0
			(- temp0 1)
			35
			compassWindow
			67
			270
			0
		)
	else
		(HighPrint 997 1)
	)
)

(class MenuBar of Class_255_0
	(properties
		state $0000
	)
	
	(method (init)
		(AddMenu
			{ \01_}
			{About Quest for Glory II`^g:Help`#1:Silly Clowns`^y=0}
		)
		(AddMenu
			{ File_}
			{Save Game`#5:Restore Game`#7:--!:Restart Game`#9:Quit`^q}
		)
		(AddMenu
			{ Game_}
			{Faster Animation`+:Normal Animation`=:Slower Animation`-:--!:Sound Volume...`^v:Turn Off Sound`#2=1:--!:Arcade Difficulty`#4:Game Detail`#6:Game Time Scale`#8}
		)
		(AddMenu
			{ Action_}
			{Cast Spell`^c:Fight`^f:Escape`^e:--!:Pause Game`^p:Repeat`#3}
		)
		(AddMenu
			{ Information_}
			{Inventory`^i:Char Sheet`^s:--!:Time/Day`^d:Ask about`^a:Tell about`^t:Look at`^l:--!:Read Map`^r:Compass Heading`^h}
		)
		(SetMenu 513 109 'save[/game]')
		(SetMenu 514 109 'restore[/game]')
		(SetMenu 516 109 'restart[/game]')
		(SetMenu 1029 109 'pause[/game]')
		(SetMenu 770 109 'normal[/speed]')
		(SetMenu 1281 109 '/inventory')
		(SetMenu 1284 109 'display/date,day,time')
		(SetMenu 1289 109 'use,look,examine,read,display/map')
		(SetMenu
			1290
			109
			'use,look,examine,read,display/compass,bearing'
		)
	)
	
	(method (handleEvent pEvent &tmp [temp0 3] theGSeconds temp4 temp5 temp6 temp7 temp8)
		(switch (super handleEvent: pEvent)
			(257 (AboutGame))
			(258 (PrintHelp))
			(259
				(if
					(= theGSeconds
						(Printd
							80
							{Silly Clowns}
							81
							{Off}
							81
							{On}
							81
							{Auto}
							116
							sillyClowns
						)
					)
					(= sillyClowns (- theGSeconds 2))
				)
			)
			(513
				(if (Btst 1) (theGame save:))
			)
			(514 (theGame restore:))
			(516 (AskRestart))
			(517 (AskQuit))
			(769
				(if (> gSaveSpeed 0)
					(theGame setSpeed: (-- gSaveSpeed))
				)
			)
			(770 (theGame setSpeed: 6))
			(771
				(if (< gSaveSpeed 16)
					(theGame setSpeed: (++ gSaveSpeed))
				)
			)
			(773
				(= temp4 (+ 1 (DoSound sndINIT)))
				(if (= temp4 (GetNumber {Volume (1 - 16)?} temp4))
					(DoSound sndINIT (- temp4 1))
				)
			)
			(774 (ToggleSound))
			(776
				(if
					(= theGSeconds
						(Printd
							80
							{Arcade Difficulty Level}
							81
							{Easiest}
							81
							{Normal}
							81
							{Hardest}
							116
							(- arcadeDifficultyLevel 1)
						)
					)
					(= arcadeDifficultyLevel (- theGSeconds 1))
				)
			)
			(777
				(= temp6 {Low})
				(= temp7 {Medium})
				(= temp8 {High})
				(switch detailLevel
					(0 (= temp6 {Optimal}))
					(1 (= temp7 {Optimal}))
					(else  (= temp8 {Optimal}))
				)
				(if (== (= theGSeconds gSeconds) 3) (= theGSeconds 2))
				(if
					(and
						(= theGSeconds
							(Printd
								80
								{Game Detail Level}
								81
								temp6
								81
								temp7
								81
								temp8
								116
								theGSeconds
							)
						)
						(== (= gSeconds (- theGSeconds 2)) 2)
						(>= detailLevel 3)
					)
					(= gSeconds detailLevel)
				)
			)
			(778
				(if
					(= theGSeconds
						(Printd
							80
							{Game Time Scale}
							81
							{Normal}
							81
							{Faster}
							81
							{Fastest}
							116
							(- gameTimeScale 1)
						)
					)
					(= gameTimeScale (- theGSeconds 1))
				)
			)
			(1025
				(localproc_004c pEvent {cast_})
			)
			(1026
				(localproc_004c pEvent {fight_})
			)
			(1027
				(localproc_004c pEvent {escape_})
			)
			(1029 (PauseGame))
			(1030 (localproc_004c pEvent))
			(1281
				(cond 
					((not (IsHeapFree 1500)) (HighPrint 997 2))
					((not isEgoLocked) ((ScriptID 71 0) init: doit:))
				)
			)
			(1282
				(cond 
					((not (IsHeapFree 1500)) (HighPrint 997 2))
					((not isEgoLocked) ((ScriptID 70 0) useWindow: 1 showBars: 1 init: doit:))
				)
			)
			(1284 (localproc_007d))
			(1285
				(localproc_004c pEvent {ask about_})
			)
			(1286
				(localproc_004c pEvent {tell about_})
			)
			(1287
				(localproc_004c pEvent {look at_})
			)
			(1289
				(cond 
					(modelessDialog)
					((not (ego has: 22)) (HighPrint 997 3))
					(
						(not
							(if (OneOf curRoomNum 300 310 315 335 240 320 330)
							else
								(OneOf curRoomNum 704 120 199 229 269 271 303)
							)
						)
						(HighPrint 997 4)
					)
					(else (Map init:))
				)
			)
			(1290 (localproc_0092))
		)
	)
)

(instance compassWindow of SysWindow
	(properties)
)
