;;; Sierra Script 1.0 - (do not remove this comment)
(script# 63)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use Music)
(use Motion)
(use Actor)
(use System)


(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	[local7 18] = [0 0 0 -8 8 -8 8 0 8 8 0 8 -8 8 -8 0 -8 -8]
	[local25 4] = [2 0 1 3]
	[local29 4] = [17 10 -10 -17]
	[local33 4] = [-40 -28 -28 -40]
	local37
	newEventY
	gEgoLooper
)
(procedure (localproc_09d2 param1)
	(switch param1
		(1
			(= local1 9)
			(= local2 4)
			(= local3 4)
			(= local4 25)
			(= local5 27)
			(= local6 404)
		)
		(2
			(= local1 9)
			(= local2 4)
			(= local3 4)
			(= local4 25)
			(= local5 27)
			(= local6 404)
		)
		(4
			(= local1 9)
			(= local2 4)
			(= local3 4)
			(= local4 25)
			(= local5 27)
			(= local6 404)
		)
		(3
			(= local1 9)
			(= local2 4)
			(= local3 4)
			(= local4 25)
			(= local5 14)
			(= local6 404)
		)
		(5
			(= local1 9)
			(= local2 5)
			(= local3 5)
			(= local4 25)
			(= local5 26)
			(= local6 404)
		)
		(19
			(= local1 32)
			(= local2 9)
			(= local3 9)
			(= local4 30)
			(= local5 20)
			(= local6 405)
		)
		(21
			(= local1 32)
			(= local2 9)
			(= local3 9)
			(= local4 31)
			(= local5 20)
			(= local6 406)
		)
		(25
			(= local1 32)
			(= local2 4)
			(= local3 5)
			(= local4 13)
			(= local5 14)
			(= local6 404)
		)
		(26
			(= local1 32)
			(= local2 8)
			(= local3 8)
			(= local4 17)
			(= local5 18)
			(= local6 403)
		)
		(27
			(= local1 32)
			(= local2 6)
			(= local3 7)
			(= local4 15)
			(= local5 16)
			(= local6 404)
		)
		(else 
			(= local1
				(= local2
					(= local3 (= local4 (= local5 (= local6 -1))))
				)
			)
		)
	)
)

(class ProjClient of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		type $0000
		xStart 0
		yStart 0
		x 0
		y 0
		targetHit 0
	)
	
	(method (init)
		(UnlockEgo)
		(= gEgoLooper (ego looper?))
		(ego looper: 0)
		(super init: &rest)
	)
	
	(method (dispose)
		(ego looper: gEgoLooper)
		(LockEgo)
		(super dispose:)
	)
)

(class ProjScript of ProjClient
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		type $0000
		xStart 0
		yStart 0
		x 0
		y 0
		targetHit 0
		hitBonus 0
		damage 0
		theLasso 0
		soundObj 0
	)
	
	(method (dispose &tmp egoLoop)
		(if targetHit (targetHit dispose:))
		(if theLasso (theLasso dispose:))
		(if soundObj (soundObj stop: dispose:))
		(if script (script caller: 0))
		(= targetHit (= theLasso (= soundObj 0)))
		(= egoLoop (ego loop?))
		(ChangeEgoWalk -1 0)
		(ego loop: (+ egoLoop 4) setLoop: -1)
		(Bclr 87)
		(Bclr 92)
		(super dispose:)
	)
	
	(method (changeState newState &tmp temp0 temp1 temp2 temp3 temp4 temp5 temp6 temp7)
		(asm
			lap      newState
			aTop     state
			push    
			dup     
			ldi      0
			eq?     
			bnt      code_0144
			pushi    1
			pushi    87
			calle    Bset,  2
			pushi    #setScript
			pushi    3
			pushi    #new
			pushi    0
			lofsa    AimSpell
			send     4
			push    
			pushSelf
			pTos     type
			self     10
			jmp      code_04a9
code_0144:
			dup     
			ldi      1
			eq?     
			bnt      code_01e7
			pushi    4
			dup     
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			ldi      30
			sub     
			push    
			pTos     x
			pTos     y
			callk    GetAngle,  8
			sat      temp4
			pushi    #setHeading
			pushi    1
			push    
			lag      ego
			send     6
			ldi      0
			sat      temp6
			ldi      90
			sat      temp5
code_017a:
			lst      temp5
			ldi      360
			le?     
			bnt      code_01be
			lst      temp4
			lat      temp5
			lt?     
			bnt      code_01b2
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			lat      temp6
			lali     local29
			add     
			aTop     xStart
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			lat      temp6
			lali     local33
			add     
			aTop     yStart
			lat      temp6
			lali     local25
			sat      temp3
			jmp      code_01be
code_01b2:
			+at      temp6
			lst      temp5
			ldi      90
			add     
			sat      temp5
			jmp      code_017a
code_01be:
			pushi    1
			pTos     type
			call     localproc_09d2,  2
			pushi    #view
			pushi    1
			lsl      local1
			pushi    241
			pushi    1
			lst      temp3
			pushi    7
			pushi    1
			pushi    0
			pushi    139
			pushi    4
			class    CT
			push    
			pushi    4
			pushi    1
			pushSelf
			lag      ego
			send     30
			jmp      code_04a9
code_01e7:
			dup     
			ldi      2
			eq?     
			bnt      code_0322
			pushi    5
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			ldi      30
			sub     
			push    
			pTos     x
			pTos     y
			lsg      perspective
			callk    GetDistance,  10
			sat      temp0
			ldi      0
			sat      temp1
			pushi    4
			pTos     type
			pushi    26
			pushi    19
			pushi    21
			calle    OneOf,  8
			bnt      code_0229
			jmp      code_0283
code_0229:
			pushi    4
			pTos     type
			pushi    1
			pushi    4
			pushi    5
			calle    OneOf,  8
			not     
			bnt      code_0259
			pushi    3
			pushi    12
			pushi    0
			pushi    100
			lst      temp0
			ldi      5
			div     
			sub     
			push    
			calle    TestSkill,  6
			not     
			bnt      code_0283
			ldi      25
			sat      temp1
			jmp      code_0283
code_0259:
			ldi      10
			lagi     skills
			not     
			bnt      code_0269
			ldi      50
			sat      temp1
			jmp      code_0283
code_0269:
			pushi    3
			pushi    10
			pushi    0
			pushi    100
			lst      temp0
			ldi      5
			div     
			sub     
			push    
			calle    TestSkill,  6
			not     
			bnt      code_0283
			ldi      25
			sat      temp1
code_0283:
			lat      temp1
			bnt      code_02ad
			pTos     x
			pushi    2
			pushi    0
			push    
			add     
			push    
			callk    Random,  4
			push    
			lat      temp1
			sub     
			add     
			aTop     x
			pTos     y
			pushi    2
			pushi    0
			lst      temp1
			lat      temp1
			add     
			push    
			callk    Random,  4
			push    
			lat      temp1
			sub     
			add     
			aTop     y
code_02ad:
			pushi    #type
			pushi    1
			pTos     type
			pushi    444
			pushi    1
			pTos     damage
			pushi    440
			pushi    1
			pTos     xStart
			pushi    441
			pushi    1
			pTos     yStart
			pushi    4
			pushi    1
			pTos     x
			pushi    3
			pushi    1
			pTos     y
			pushi    #new
			pushi    0
			lofsa    Projectile
			send     4
			sat      temp2
			send     36
			pushi    1
			pTos     type
			call     localproc_09d2,  2
			lal      local4
			bnt      code_0304
			pushi    #number
			pushi    1
			push    
			pushi    6
			pushi    1
			pushi    1
			pushi    63
			pushi    1
			pushi    6
			pushi    102
			pushi    0
			pushi    42
			pushi    0
			pushi    #new
			pushi    0
			class    Sound
			send     4
			aTop     soundObj
			send     26
code_0304:
			pTos     type
			ldi      25
			eq?     
			bnt      code_0314
			pushi    #show
			pushi    0
			lag      ego
			send     4
code_0314:
			pushi    #setScript
			pushi    3
			lst      temp2
			pushSelf
			pushi    0
			self     10
			jmp      code_04a9
code_0322:
			dup     
			ldi      3
			eq?     
			bnt      code_0426
			pTos     type
			ldi      26
			eq?     
			bnt      code_03e1
			pushi    1
			pushi    92
			calle    Bset,  2
			pushi    1
			pTos     type
			call     localproc_09d2,  2
			pToa     targetHit
			bnt      code_0391
			pToa     soundObj
			not     
			bnt      code_0358
			pushi    #init
			pushi    0
			pushi    #new
			pushi    0
			class    Sound
			send     4
			aTop     soundObj
			send     4
code_0358:
			pushi    #number
			pushi    1
			lsl      local5
			pushi    6
			pushi    1
			pushi    1
			pushi    63
			pushi    1
			pushi    7
			pushi    42
			pushi    0
			pToa     soundObj
			send     22
			pushi    #illegalBits
			pushi    1
			pushi    0
			pushi    243
			pushi    0
			pushi    254
			pushi    0
			pushi    262
			pushi    2
			pushi    12
			pushi    8
			pushi    252
			pushi    3
			class    MoveTo
			push    
			pTos     xStart
			pTos     yStart
			pToa     targetHit
			send     32
code_0391:
			pushi    #view
			pushi    1
			lsl      local1
			pushi    241
			pushi    1
			lsl      local2
			pushi    7
			pushi    1
			pushi    0
			pushi    18
			pushi    1
			pushi    0
			pushi    243
			pushi    0
			pushi    254
			pushi    0
			pushi    262
			pushi    2
			pushi    12
			pushi    8
			pushi    102
			pushi    0
			pushi    237
			pushi    2
			pTos     x
			pTos     y
			pushi    139
			pushi    1
			class    Fwd
			push    
			pushi    252
			pushi    4
			class    MoveTo
			push    
			pTos     xStart
			pTos     yStart
			pushSelf
			pushi    #new
			pushi    0
			class    Actor
			send     4
			aTop     theLasso
			send     70
			jmp      code_04a9
code_03e1:
			pTos     type
			ldi      5
			eq?     
			bnt      code_0417
			lag      curRoomNum
			sat      temp7
			push    
			ldi      665
			eq?     
			bnt      code_03fb
			lag      gTheGNorth
			neg     
			sat      temp7
code_03fb:
			lst      temp7
			lag      global148
			ne?     
			bnt      code_040b
			lat      temp7
			sag      global148
			ldi      0
			sag      gTheInvNum
code_040b:
			pToa     targetHit
			bnt      code_0415
			+ag      daggersInMonster
			jmp      code_0417
code_0415:
			+ag      gTheInvNum
code_0417:
			ldi      0
			aTop     theLasso
			aTop     targetHit
			pushi    #cue
			pushi    0
			self     4
			jmp      code_04a9
code_0426:
			dup     
			ldi      4
			eq?     
			bnt      code_045d
			pToa     targetHit
			bnt      code_0437
			pushi    #dispose
			pushi    0
			send     4
code_0437:
			pToa     theLasso
			bnt      code_0441
			pushi    #dispose
			pushi    0
			send     4
code_0441:
			ldi      0
			aTop     theLasso
			aTop     targetHit
			pushi    1
			pushi    92
			calle    Bclr,  2
			pushi    #setCycle
			pushi    2
			class    End
			push    
			pushSelf
			lag      ego
			send     8
			jmp      code_04a9
code_045d:
			dup     
			ldi      5
			eq?     
			bnt      code_04a9
			lal      local0
			bnt      code_04a4
			pushi    5
			pTos     type
			pushi    25
			pushi    27
			pushi    5
			pushi    4
			calle    OneOf,  10
			bnt      code_0489
			pushi    2
			pushi    63
			pushi    0
			calle    HighPrint,  4
			jmp      code_04a4
code_0489:
			pTos     type
			ldi      3
			eq?     
			bnt      code_049c
			pushi    2
			pushi    63
			pushi    1
			calle    HighPrint,  4
			jmp      code_04a4
code_049c:
			pushi    2
			pushi    63
			pushi    2
			calle    HighPrint,  4
code_04a4:
			pushi    #dispose
			pushi    0
			self     4
code_04a9:
			toss    
			ret     
		)
	)
)

(class AimSpell of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		DirKey 0
		x 0
		y 0
		oldNormCursor 0
	)
	
	(method (init &tmp newEvent)
		(UnlockEgo)
		(= local37 ((= newEvent (Event new:)) x?))
		(= newEventY (newEvent y?))
		(newEvent dispose:)
		(super init: &rest)
	)
	
	(method (doit &tmp temp0 newEvent)
		(if (!= DirKey 0)
			(= temp0 (+ DirKey DirKey))
			(= x (+ x [local7 temp0]))
			(= y (+ y [local7 (+ temp0 1)]))
			(if (< x 0) (= x (= DirKey 0)))
			(if (> x 319) (= DirKey 0) (= x 319))
			(if (< y 0) (= y (= DirKey 0)))
			(if (> y 189) (= DirKey 0) (= x 189))
			(theGame setCursor: 1 1 (- x 0) (- y 0))
			(= local37 (- x 0))
			(= newEventY (- y 0))
			(= newEvent (Event new:))
			(if
				(or
					(!= local37 (- (newEvent x?) 0))
					(!= newEventY (- (- (newEvent y?) 0) 10))
				)
				(= DirKey 0)
			)
			(newEvent dispose:)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseH delete: self)
		(gDirH delete: self)
		(gKeyH delete: self)
		(= normalCursor oldNormCursor)
		(theGame setCursor: normalCursor 1)
		(LockEgo)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gKeyH addToFront: self)
				(gDirH addToFront: self)
				(gMouseH addToFront: self)
				(= oldNormCursor normalCursor)
				(= normalCursor 1)
				(theGame setCursor: 1 1)
			)
			(1
				(if (client respondsTo: #x)
					(client x: x)
					(client y: y)
				)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp theDirKey)
		(= x (+ (pEvent x?) 0))
		(= y (+ (pEvent y?) 0))
		(switch (pEvent type?)
			(evJOYSTICK
				(pEvent claimed: 1)
				(if (== (= theDirKey (pEvent message?)) DirKey)
					(= DirKey 0)
				else
					(= DirKey theDirKey)
				)
			)
			(evMOUSEBUTTON
				(pEvent claimed: 1)
				(self cue:)
			)
			(evKEYBOARD
				(if (== (pEvent message?) KEY_RETURN)
					(pEvent claimed: 1)
					(self cue:)
				)
			)
		)
		(pEvent claimed?)
	)
)

(class Projectile of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		type $0000
		damage 0
		xStart 0
		yStart 0
		x 0
		y 0
		projObj 0
		soundObj 0
	)
	
	(method (dispose)
		(if projObj (projObj dispose:))
		(if soundObj (soundObj stop: dispose:))
		(= projObj (= soundObj 0))
		(super dispose:)
	)
	
	(method (changeState newState &tmp temp0 temp1 temp2)
		(switch (= state newState)
			(0
				(localproc_09d2 type)
				((= projObj (Actor new:))
					view: local1
					setLoop: local2
					cel: 0
					illegalBits: 0
					ignoreActors:
					ignoreHorizon:
					setStep: 12 8
					setPri: 14
					posn: xStart yStart
					init:
					setCycle: Fwd
					setMotion: MoveTo x y self
				)
			)
			(1
				(localproc_09d2 type)
				(= temp1 0)
				(= local0
					(== (= temp0 (cast firstTrue: #onMe projObj)) ego)
				)
				(if (and temp0 (!= temp0 projObj))
					(if (temp0 respondsTo: #hitX)
						(temp0 hitX: x)
						(temp0 hitY: y)
					)
					(if
						(and
							(temp0 respondsTo: local6)
							(proc1_17 temp0 local6 damage self)
						)
						(= temp1 temp0)
						(if (client respondsTo: #targetHit)
							(client targetHit: temp0)
						)
						(if local5
							((= soundObj (Sound new:))
								number: local5
								loop: 1
								init:
								priority: 7
								play:
							)
						)
						(if (== local3 -1)
							(self cue:)
						else
							(projObj setLoop: local3 cel: 0 setCycle: End self)
						)
					)
				)
				(if (not temp1)
					(if (client respondsTo: #targetHit)
						(client targetHit: 0)
					)
					(self dispose:)
				)
			)
			(2 (self dispose:))
		)
	)
)
