;;; Sierra Script 1.0 - (do not remove this comment)
(script# 381)
(include sci.sh)
(use Monster)
(use Motion)
(use System)


(local
	[local0 8] = [0 0 2 1 0 2 0 2]
	[local8 8] = [1 1 1 2 2 2 3 3]
)
(class RaseirGuard of Monster
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 381
		loop 0
		cel 0
		priority 10
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		strength 65
		intell 40
		agil 80
		vit 60
		luck 60
		weap 70
		parry 60
		dodge 40
		magic 0
		stamina 0
		mana 0
		armorValue 8
		armorEnc 8
		shieldValue 8
		weapValue 8
		canFight 0
		action 0
		nextMove -1
		attDirection 0
		opponent 0
		barX 240
		barY 8
		barTitle 0
		barHealth 0
		barStamina 0
		barMana 0
		barMessage 0
		type $0035
		mode 0
		combatScript 0
		hurtScript 0
		deathScript 0
		ateEgo 0
		chaseDelay 0
		attackRange 60
		battleMusic 52
		endMusic 53
		ambushScript 0
		chaseScript 0
	)
	
	(method (initCombat)
		(= noun '/fighter,fighter,swordsman,guard')
		(= description {the bloodthirsty guard})
		(= lookStr
			{The flailing, bloodthirsty guard looks like he means business.}
		)
		(= combatScript rasGuardScript)
		(super initCombat: &rest)
	)
)

(instance rasGuardScript of Script
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1)
		(switch (= state newState)
			(0 (= cycles 5))
			(1
				(= temp1 (Random 3 10))
				(client
					action: [local8 (- temp1 3)]
					attDirection: [local0 (- temp1 3)]
					setLoop: temp1
					cel: 0
					setCycle: End self
				)
			)
			(2
				(= clientOpponent (client opponent?))
				(if
					(and
						(== (client action?) 1)
						(client tryAttack: clientOpponent 0)
					)
					(client doDamage: clientOpponent 0 1)
				)
				(= cycles 2)
			)
			(3 (client setCycle: Beg self))
			(4
				(client action: 0 setLoop: 0)
				(self changeState: 1)
			)
		)
	)
)
