;;; Sierra Script 1.0 - (do not remove this comment)
(script# 64)
(include sci.sh)
(use Main)
(use n001)
(use Music)
(use Motion)
(use Actor)
(use System)


(local
	gEgoLooper
	[local1 8] = [2 3 0 2 0 1 2 3]
)
(class SpellScript of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		type $0000
		soundObj 0
		spellSparkles 0
	)
	
	(method (dispose &tmp egoLoop)
		(if soundObj (soundObj stop: dispose:))
		(if spellSparkles (spellSparkles stop: dispose:))
		(= soundObj (= spellSparkles 0))
		(= egoLoop (ego loop?))
		(ChangeEgoWalk -1 0)
		(ego loop: (+ egoLoop 4) setLoop: -1)
		(ego looper: gEgoLooper)
		(Bclr 87)
		(LockEgo)
		(super dispose:)
	)
	
	(method (changeState newState &tmp temp0 temp1 temp2 temp3 temp4)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(Bset 87)
				(= gEgoLooper (ego looper?))
				(ego looper: 0)
				(ego
					view: 31
					setLoop: [local1 (ego loop?)]
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
				(if
					(= temp0
						(switch type
							(20 19)
							(23
								(ego setCycle: CT 3 1 self)
								13
							)
							(22 22)
							(24 21)
							(29 34)
							(else  0)
						)
					)
					((= soundObj (Sound new:))
						number: temp0
						loop: 1
						priority: 6
						init:
						play: self
					)
				else
					(self cue:)
				)
			)
			(2
				(= register 0)
				(cond 
					(
						(= temp4
							(switch type
								(20 402)
								(22 401)
								(24 400)
								(else  0)
							)
						)
						(= temp1 (FirstNode (cast elements?)))
						(while temp1
							(= temp2 (NextNode temp1))
							(if
								(and
									((= temp3 (NodeValue temp1)) respondsTo: temp4)
									(proc1_17 temp3 temp4)
								)
								(= register 1)
							)
							(= temp1 temp2)
						)
						(= cycles 3)
					)
					((== type 29)
						((= spellSparkles (Prop new:))
							view: 31
							loop: 4
							cel: 0
							ignoreActors: 1
							posn: (ego x?) (ego y?)
							setPri: (+ (ego priority?) 1)
							init:
							setCycle: End self
						)
					)
					(else (= cycles 1))
				)
			)
			(3
				(if spellSparkles
					(spellSparkles dispose:)
					(= spellSparkles 0)
				)
				(ego setCycle: Beg self)
			)
			(4
				(switch type
					(20
						(if (not register) (HighPrint 64 0))
					)
					(23
						(= zapMeleeBonus (+ 5 (/ [skills 23] 10)))
						(HighPrint 64 1)
					)
					(29
						(Bset 86)
						(= reversalTimer [skills 29])
						(HighPrint 64 2)
					)
				)
				(self dispose:)
			)
		)
	)
)
