;;; Sierra Script 1.0 - (do not remove this comment)
(script# 21)
(include sci.sh)
(use Main)
(use HandsOffScript)
(use Motion)


(class StairScript of HandsOffScript
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		oldIllBits 0
		saveIgnrAct 0
		stairSize 0
		numStairs 0
		goingUp 0
		oldView 0
		oldCycle 0
		stairNumber 0
	)
	
	(method (init)
		(= oldView (ego view?))
		(= oldCycle (ego cycler?))
		(ego cycler: 0)
		(= stairNumber (/ numStairs 2))
		(super init: &rest)
	)
	
	(method (dispose)
		(ego
			view: oldView
			loop: (if goingUp 3 else 2)
			setCycle: oldCycle
		)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 3 loop: goingUp cel: 0)
				(if goingUp
					(ego y: (- (ego y?) (* stairSize 2)))
				else
					(ego y: (+ (ego y?) (* stairSize 2)))
				)
				(= cycles 1)
			)
			(1 (ego setCycle: End self))
			(2
				(cond 
					((not (-- stairNumber)) (self changeState: 3))
					(goingUp (ego y: (- (ego y?) (* stairSize 2))))
					(else (ego y: (+ (ego y?) (* stairSize 2))))
				)
				(= state 0)
				(= cycles 1)
			)
			(3 (self dispose:))
		)
	)
)
