;;; Sierra Script 1.0 - (do not remove this comment)
(script# 32)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Bar)
(use Combatant)
(use n065)
(use Motion)
(use User)
(use Actor)
(use System)

(public
	warrior 0
	spellObj 1
)

(local
	[theAttDirection 9] = [0 0 2 2 2 0 1 1 1]
	[theAction 9] = [2 1 1 2 3 3 3 2 1]
	[theLoop 9] = [7 4 5 8 11 10 9 6 3]
	[theNextMove 3] = [8 1 2]
	[theNextMove_2 3] = [7 0 3]
	[theNextMove_3 3] = [6 5 4]
)
(class Warrior of Combatant
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 1
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		strength 0
		intell 0
		agil 0
		vit 0
		luck 0
		weap 0
		parry 0
		dodge 0
		magic 0
		stamina 0
		mana 0
		armorValue 0
		armorEnc 0
		shieldValue 0
		weapValue 0
		canFight 0
		action 0
		nextMove -1
		attDirection 0
		opponent 0
		barX 25
		barY 8
		barTitle 0
		barHealth 0
		barStamina 0
		barMana 0
		barMessage 0
		type $0035
		mode 55
		combatScript 0
		hurtScript 0
		deathScript 0
		weaponView 0
		usingSword 0
		aimTime 0
		lastSeconds 0
		restSeconds 0
		oldChecker 0
		attackScript 0
		defenseScript 0
		spellScript 0
	)
	
	(method (doit &tmp theLastSeconds)
		(if
		(!= lastSeconds (= theLastSeconds (GetTime 1)))
			(= lastSeconds theLastSeconds)
			(if (!= action 1) (++ restSeconds))
		)
		(if (not canFight) (= nextMove -1))
		(if (and (== action 0) (!= nextMove -1))
			(= action nextMove)
			(if (OneOf action 23 22 21 25 27 29)
				(= nextMove -1)
				(self setScript: spellScript 0 action)
				(= action 6)
			else
				(= attDirection [theAttDirection nextMove])
				(= action [theAction nextMove])
				(= loop [theLoop nextMove])
				(= cel 0)
				(= nextMove -1)
				(switch action
					(1
						(self setScript: attackScript 0 restSeconds)
						(= restSeconds 0)
					)
					(2
						(self setScript: defenseScript)
					)
					(3
						(self setScript: defenseScript)
					)
					(else  (= action 0))
				)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent &tmp newEvent [temp1 2] pEventType theNextMove_4)
		(= pEventType (pEvent type?))
		(cond 
			((super handleEvent: pEvent))
			((not canFight) (pEvent claimed: 1))
			((== pEventType evJOYSTICK)
				(pEvent claimed: 1)
				(if (User controls?)
					(= nextMove (pEvent message?))
					(while ((= newEvent (Event new:)) type?)
						(newEvent dispose:)
					)
					(newEvent dispose:)
				)
			)
			((== pEventType evSAID)
				(DisposeDialog)
				(cond 
					((Said 'look,examine') (HighPrint 32 0))
					(
						(or
							(Said 'attack,kill,beat,chop')
							(Said 'use/blade,dagger,weapon')
						)
						(= nextMove [theNextMove (Random 0 2)])
					)
					(
					(or (Said 'parry,defend,block') (Said 'use/shield')) (= nextMove [theNextMove_2 (Random 0 2)]))
					((Said 'dodge,hop') (= nextMove [theNextMove_3 (Random 0 2)]))
					((Said 'throw') (HighPrint 32 1))
					((Said 'escape,escape,(run<away)') (curRoom notify: 59))
					((Said 'cast>')
						(= theNextMove_4 (proc65_0 pEvent))
						(cond 
							(shieldValue (HighPrint 32 2))
							((CastSpell theNextMove_4) (= nextMove theNextMove_4) (self setMana: [skills 18]))
						)
					)
					(else (pEvent claimed: 1) (HighPrint 32 3))
				)
			)
		)
	)
	
	(method (attackLevel param1)
		(if (== attDirection 0) (= param1 (+ param1 10)))
		(= param1 (- param1 (* daysWithoutSleep 10)))
		(super attackLevel: param1)
	)
	
	(method (defenseLevel param1)
		(if (and (== action 1) (== attDirection 0))
			(= param1 (- param1 5))
		)
		(= param1 (- param1 (* daysWithoutSleep 10)))
		(super defenseLevel: param1)
	)
	
	(method (setHealth theSkills)
		(= [skills 16] theSkills)
		(super setHealth: theSkills)
	)
	
	(method (setStamina theSkills)
		(= [skills 17] theSkills)
		(super setStamina: theSkills)
		(if (<= stamina 0) (curRoom notify: 60))
	)
	
	(method (drawStatus)
		(super drawStatus: &rest)
		(if (not barMessage) (return))
		((= barStamina (Bar new:))
			x: barX
			y: (+ barY 34)
			cel: 1
			priority: 10
			max: (self calcStamina:)
			value: stamina
			init:
		)
		(if magic
			((= barMana (Bar new:))
				x: barX
				y: (+ barY 48)
				cel: 2
				priority: 10
				max: (self calcMana:)
				value: mana
				init:
			)
		)
	)
	
	(method (initCombat &tmp theArmorEnc)
		(Bclr 1)
		(= strength [skills 0])
		(= intell [skills 1])
		(= agil [skills 2])
		(= vit [skills 3])
		(= luck [skills 4])
		(= weap [skills 5])
		(= parry [skills 6])
		(= dodge [skills 7])
		(= magic [skills 12])
		(= stamina [skills 17])
		(= health [skills 16])
		(= mana [skills 18])
		(= shieldValue 0)
		(if (ego has: 7) (= shieldValue 10))
		(= armorEnc (/ (= theArmorEnc (proc1_22)) 2))
		(if (> theArmorEnc (GetMaxWeight))
			(= armorEnc theArmorEnc)
		)
		(= armorValue 0)
		(cond 
			((ego has: 15) (= armorValue 5))
			((ego has: 6) (= armorValue 3))
		)
		(cond 
			(
			(and (ego has: 31) opponent (== (opponent view?) 345))
				(= type 52)
				(= weaponView 80)
				(= palette 2)
				(= weapValue 15)
			)
			((or (ego has: 24) (ego has: 31))
				(= type 51)
				(= weaponView 80)
				(= palette 1)
				(= weapValue 10)
			)
			((ego has: 4)
				(= type 51)
				(= weaponView 80)
				(= palette 1)
				(= weapValue 8)
			)
			((ego has: 56) (= type 50) (= weaponView 81) (= weapValue 7))
			((ego has: 5) (= type 50) (= weaponView 81) (= weapValue 5))
			(else (= type 50) (= weaponView 81) (= weapValue 0))
		)
		(= oldChecker gGDftSC)
		(= gGDftSC combatChecker)
		(if (and (not shieldValue) (== weaponView 80))
			(= weaponView 81)
			(= palette (+ palette 1))
		)
		(= view weaponView)
		(= cel (= loop 0))
		(= hurtScript warriorHurt)
		(= attackScript egoAttacks)
		(= defenseScript egoDefends)
		(= spellScript egoSpells)
		(= deathScript warriorDeath)
		(super initCombat: &rest)
		(gDirH add: self)
	)
	
	(method (endCombat)
		(self setScript: 0)
		(= [skills 16] health)
		(= [skills 17] stamina)
		(= [skills 18] mana)
		(= gGDftSC oldChecker)
		(Bset 1)
		(gDirH delete: self)
		(super endCombat: &rest)
	)
)

(instance warrior of Warrior
	(properties
		x 120
		y 110
		barMessage {Hero}
	)
)

(instance egoAttacks of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1)
		(switch (= state newState)
			(0
				(client forceUpd:)
				(= cycles 1)
			)
			(1 (client setCycle: End self))
			(2
				(= cycles 2)
				(= clientOpponent (client opponent?))
				(if (> register 5) (= register 5))
				(= temp1 (- (* register 30) 50))
				(TestSkill 5 0 temp1)
				(client getTired: 5)
				(if
				(and client (client tryAttack: clientOpponent temp1))
					(client doDamage: clientOpponent zapMeleeBonus)
					(= zapMeleeBonus 0)
				)
			)
			(3 (client setCycle: Beg self))
			(4
				(client action: 0 setLoop: 0)
				(self dispose:)
			)
		)
	)
)

(instance egoDefends of HandsOffScript
	(properties)
	
	(method (doit &tmp clientNextMove)
		(= clientNextMove (client nextMove?))
		(cond 
			((or (!= state 2) (== clientNextMove -1)) (super doit:))
			(
				(and
					(== [theAction clientNextMove] (client action?))
					(== [theLoop clientNextMove] (client loop?))
				)
				(= cycles 7)
				(client nextMove: -1)
			)
			(else (= seconds 0) (self cue:))
		)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(client forceUpd:)
				(= cycles 1)
			)
			(1
				(TestSkill (if (== (client action?) 2) 6 else 7) 0 20)
				(client setCycle: End self getTired: 2)
			)
			(2 (= cycles 7))
			(3 (client setCycle: Beg self))
			(4
				(client action: 0 setLoop: 0)
				(self dispose:)
			)
		)
	)
)

(instance egoSpells of HandsOffScript
	(properties)
	
	(method (dispose)
		(client view: (client weaponView?))
		(super dispose:)
	)
	
	(method (changeState newState &tmp temp0 clientType)
		(switch (= state newState)
			(0
				(client
					view: 82
					setLoop: 0
					setCel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1
				(= cycles 3)
				(switch register
					(23 (= temp0 31))
					(22 (= temp0 22))
					(21 (= temp0 31))
					(25
						(spellObj
							loop: 5
							cel: 0
							setPri: (+ ((client opponent?) priority?) 1)
							init:
							setCycle: End self
						)
						(= cycles 0)
						(= temp0 14)
					)
					(27
						(spellObj
							loop: 7
							cel: 0
							setPri: (+ ((client opponent?) priority?) 1)
							init:
							setCycle: End self
						)
						(= cycles 0)
						(= temp0 16)
					)
					(29 (= temp0 34))
					(else  (= temp0 0))
				)
				(if temp0
					(gMiscMusic number: temp0 loop: 1 priority: 12 play:)
				)
			)
			(2
				(switch register
					(23
						(= zapMeleeBonus (+ 5 (/ [skills 23] 10)))
						(= temp0 31)
						(HighPrint 32 4)
					)
					(22
						(if (not ((client opponent?) dazzleMe:))
							(HighPrint 32 5)
						)
					)
					(21
						(if (not ((client opponent?) triggerMe:))
							(HighPrint 32 6)
						)
					)
					(25
						(spellObj dispose:)
						(= clientType (client type?))
						(client type: 25)
						((client opponent?)
							hurtMe: (+ 5 (/ [skills 25] 3)) client
						)
						(client type: clientType)
					)
					(27
						(spellObj dispose:)
						(= clientType (client type?))
						(client type: 27)
						((client opponent?)
							hurtMe: (+ 3 (/ [skills 27] 4)) client
						)
						(client type: clientType)
					)
					(29
						(Bset 86)
						(= reversalTimer [skills 29])
						(HighPrint 32 7)
					)
				)
				(if client
					(client
						cycleSpeed: (- 3 arcadeDifficultyLevel)
						setCycle: Beg self
					)
				else
					(= caller 0)
					(self dispose:)
				)
			)
			(3
				(client
					view: (client weaponView?)
					setLoop: 0
					cel: 0
					action: 0
					canFight: 1
				)
				(self dispose:)
			)
		)
	)
)

(instance spellObj of Prop
	(properties
		x 160
		y 80
		z 1
		view 32
		signal $6810
	)
)

(instance combatChecker of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (OneOf param1 22 23 21 25 27 29)
				(return 1)
			else
				(HighPrint 32 8)
				(return 0)
			)
		)
	)
)

(instance warriorHurt of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp clientCombatScript)
		(switch (= state newState)
			(0
				(client
					canFight: 0
					action: 7
					nextMove: 0
					setCycle: 0
					setLoop: 1
					setCel: 0
				)
				(= cycles 2)
			)
			(1
				(client setCel: 1)
				(= cycles
					(switch arcadeDifficultyLevel
						(1 2)
						(2 4)
						(3 6)
					)
				)
			)
			(2
				(if (<= (NumCels client) 2)
					(self cue:)
				else
					(client setCycle: End self)
				)
			)
			(3
				(client canFight: 1 action: 0 setLoop: 0)
				(if (= clientCombatScript (client combatScript?))
					(client setScript: clientCombatScript)
				else
					(self dispose:)
				)
			)
		)
	)
)

(instance warriorDeath of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					canFight: 0
					action: 0
					setLoop: 2
					setCel: 0
					cycleSpeed: 0
				)
				(= cycles 2)
			)
			(1 (client setCycle: End self))
			(2
				(if (not (curRoom notify: 61))
					(Die 0 32 9 80 {What a monster!} 82 999 1 5)
				)
				(self dispose:)
			)
		)
	)
)
