;;; Sierra Script 1.0 - (do not remove this comment)
(script# 117)
(include sci.sh)
(use Main)
(use Talker)
(use Full)
(use Motion)
(use System)

(public
	abdulla 0
	abdullaTalk 1
)

(local
	local0
	[local1 38] = [0 2 3 4 6 8 10 12 5 14 15 16 17 18 19 20 21 1 22 24 23 25 26 27 28 29 30 1 31 32 33 34 35 1 1 1 1 1]
	[local39 36] = [36 '//shema,dance' 37 '//shameen' 38 '//arus[<aldin,about]' 39 '//loot' 40 '//news' 41 '//spielburg' 42 '//bandit' 43 '//carpet' 44 '//month' 45 '//year' 46 '//omen' 47 '//explore,exploration' 48 '//food,breakfast,drink,tea,eat,chew' 49 '//problem,news' 50 '//land,enchantment' 51 '//flame,fire' 52 '//bazaar,courtyard']
)
(instance abdullaTalk of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(abdulla tLoop: 0 setCycle: Fwd)
				(Say abdulla self 117 0)
			)
			(1
				(abdulla tLoop: 1 setCycle: End)
				(Say abdulla self 117 1)
			)
			(2
				(abdulla tLoop: 0 setCycle: Fwd)
				(Say abdulla self 117 2)
			)
			(3
				(abdulla tLoop: 1 setCycle: End)
				(Say abdulla self 117 3)
			)
			(4 (= cycles 4))
			(5
				(= local0 200)
				(self dispose:)
			)
		)
	)
)

(instance abdullaEats of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(abdulla loop: 2 cycleSpeed: 2 setCycle: End self)
			)
			(1 (= cycles 3))
			(2
				(abdulla setCycle: Full 1 self)
			)
			(3
				(abdulla loop: 0 setCycle: 0 cycleSpeed: 0)
				(= local0 200)
				(self dispose:)
			)
		)
	)
)

(instance abdulla of Talker
	(properties
		x 63
		y 155
		description {Abdulla Doo}
		lookStr {It is your good friend, Abdulla Doo.}
		view 105
		priority 13
		signal $4010
		illegalBits $0000
		tLoop 1
		talkSpeed 1
		myName '//abdulla,man,merchant'
		title {Abdulla:}
		color 2
		back 0
		msgFile 105
	)
	
	(method (doit)
		(if (and local0 (not (-- local0)))
			(self setScript: abdullaEats)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (Said 'hello,greet') (Said '/hello,greet')) (Say self 117 4))
		)
	)
	
	(method (atSpec param1)
		(return [local39 param1])
	)
	
	(method (atGen param1)
		(return [local1 param1])
	)
	
	(method (showText param1)
		(cond 
			(
				(and
					(OneOf elementalsStatus 1 3 5 7)
					(<= 6 param1)
					(<= param1 12)
				)
				(self showMany: param1 (+ param1 1))
			)
			((== param1 51)
				(cond 
					((< elementalsStatus 1) (Say self 117 5))
					((>= elementalsStatus 2) (Say self 117 6))
					(else (super showText: param1 &rest))
				)
			)
			(else (super showText: param1 &rest))
		)
	)
	
	(method (endTalk)
		(super endTalk:)
		(= local0 200)
	)
)
