;;; Sierra Script 1.0 - (do not remove this comment)
(script# 241)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use n065)
(use TryToMoveTo)
(use Elemental)
(use LoadMany)
(use Timer)
(use Motion)
(use Actor)
(use System)

(public
	airElemental 0
)

(local
	[local0 68] = [0 0 0 0 5 185 308 253 96 163 217 284 31 140 255 315 126 130 212 337 202 130 114 337 298 140 60 317 233 163 115 282 314 185 25 252 315 249 12 181 224 271 103 150 289 294 65 119 194 304 108 97 118 304 206 97 22 294 260 117 87 271 205 152 6 249 295 182]
	[local68 10] = [0 0 -19 28 -22 13 22 13 19 28]
	[local78 5] = [0 5 3 4 6]
	local83
	local84
	local85 =  {dirt}
	local86
	local87
	local88
	local89
	local90
	[local91 100]
)
(procedure (localproc_000c param1)
	(= local83 (* param1 4))
	(airElemental
		newX: [local0 local83]
		newY:
			[local0 (+
				(if (== curRoomNum 335) (= local83 (+ local83 2)))
				1
			)]
	)
)

(procedure (localproc_003b param1 &tmp temp0 temp1 temp2 airElementalNewX airElementalNewY airElementalX airElementalY)
	(localproc_000c param1)
	(= airElementalNewX (airElemental newX?))
	(= airElementalNewY (airElemental newY?))
	(= airElementalX (airElemental x?))
	(= airElementalY (airElemental y?))
	(= temp1
		(GetAngle airElementalX airElementalY (ego x?) (ego y?))
	)
	(= temp2
		(GetAngle
			airElementalX
			airElementalY
			airElementalNewX
			airElementalNewY
		)
	)
	(if (> (= temp0 (Abs (- temp1 temp2))) 180)
		(= temp0 (- 360 temp0))
	)
	(return temp0)
)

(procedure (localproc_00b4)
	(airElemental
		following: 1
		wandering: 0
		cycleSpeed: 1
		ignoreActors: 0
		setMotion: 0
	)
	(airEyes init:)
	(= local86 1)
	(groundTimer setReal: groundTimer 15)
)

(instance airElemental of Elemental
	(properties
		x 160
		y 160
		noun '/cyclone,air,(elemental<air)'
		description {the Air Elemental}
		lookStr {You see a writhing funnel of air (what a windbag).}
		view 342
		signal $6800
		wandering 1
		wanderList 16
	)
	
	(method (init param1 param2)
		(asm
			pushi    4
			pushi    128
			pushi    342
			pushi    343
			pushi    50
			calle    LoadMany,  8
			lofsa    levRopeSaids
			sag      gLevMe
			lofsa    levRopeSaids
			sag      gGetBellows
			lsg      global292
			ldi      100
			mod     
			aTop     wandering
			lsg      global292
			ldi      100
			div     
			aTop     lastWander
			pTos     lastWander
			ldi      16
			gt?     
			bnt      code_012a
			pTos     lastWander
			ldi      16
			sub     
			aTop     lastWander
code_012a:
			lsg      prevRoomNum
			ldi      240
			eq?     
			bnt      code_013b
			pTos     wandering
			ldi      8
			gt?     
			bt       code_014c
code_013b:
			lsg      prevRoomNum
			ldi      335
			eq?     
			bnt      code_015d
			pTos     wandering
			ldi      9
			lt?     
			bnt      code_015d
code_014c:
			lsg      global292
			ldi      1699
			gt?     
			bnt      code_015d
			pToa     wandering
			sal      local84
			jmp      code_01c6
code_015d:
			lsg      prevRoomNum
			ldi      240
			eq?     
			bnt      code_016e
			pTos     wandering
			ldi      8
			gt?     
			bt       code_017f
code_016e:
			lsg      prevRoomNum
			ldi      335
			eq?     
			bnt      code_018a
			pTos     wandering
			ldi      9
			lt?     
			bnt      code_018a
code_017f:
			pToa     lastWander
			sal      local84
			pToa     lastWander
			aTop     wandering
			jmp      code_01c6
code_018a:
			lsg      prevRoomNum
			ldi      240
			eq?     
			bnt      code_019b
			pTos     wandering
			ldi      8
			gt?     
			bt       code_01a9
code_019b:
			lsg      prevRoomNum
			ldi      335
			eq?     
			bnt      code_01a9
			pTos     wandering
			ldi      9
			lt?     
code_01a9:
			not     
			bnt      code_01c2
			lsg      global292
			ldi      1699
			gt?     
			bnt      code_01c2
			pToa     lastWander
			sal      local84
			pToa     lastWander
			aTop     wandering
			jmp      code_01c6
code_01c2:
			pToa     wandering
			sal      local84
code_01c6:
			pushi    1
			lsl      local84
			call     localproc_000c,  2
			pToa     newX
			aTop     x
			pToa     newY
			aTop     y
			pushi    #init
			pushi    0
			&rest    param2
			super    Elemental,  4
			pushi    #baseSetter
			pushi    1
			lofsa    airBase
			push    
			self     6
			ret     
		)
	)
	
	(method (doit)
		(if
			(and
				(or (Btst 90) (Btst 88))
				(< (self distanceTo: ego) attackDist)
				(< (ego z?) 30)
			)
			(self attack:)
		)
		(super doit:)
	)
	
	(method (dispose)
		(if (> y 200)
			(= global292 (+ (* (+ lastWander 16) 100) wandering))
		)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(= gLevMe 0)
		(= gGetBellows 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'use/bellows')
				(if (ego has: 25)
					(ego setScript: bellowsScript)
				else
					(PrintDontHaveIt)
				)
			)
			((Said 'throw/dirt,earth,pan') (ego setScript: dirtScript 0 1))
			((Said 'throw/sand,bag') (ego setScript: dirtScript 0 0))
		)
	)
	
	(method (onMe param1 &tmp temp0 temp1)
		(= temp0 (param1 x?))
		(= temp1 (param1 y?))
		(return
			(if
				(and
					(<= nsLeft temp0)
					(<= temp0 nsRight)
					(<= (- nsTop 15) temp1)
					(<= temp1 nsBottom)
				)
				(if control
					(& control (OnControl 4 temp0 temp1))
				else
					1
				)
			else
				0
			)
		)
	)
	
	(method (fetchMe)
		(HighPrint 241 4)
		(return 0)
	)
	
	(method (hurtMe param1 param2)
		(cond 
			((OneOf (param2 type?) 25 27) (HighPrint 241 0))
			((== (param2 type?) 5) (HighPrint 241 1))
			((>= hitY (+ nsTop 15)) (HighPrint (Format @local91 241 2 local85)))
			((> y 220))
			(else
				(HighPrint (Format @local91 241 3 local85))
				(localproc_00b4)
			)
		)
		(return 0)
	)
	
	(method (attack)
		(cond 
			(local86)
			((> (ego z?) 30))
			((Btst 90) (ego setScript: (ScriptID 62 1)))
			((Btst 88) (ego setScript: (ScriptID 61 3)))
			((Btst 91))
			((Btst 95))
			((curRoom script?))
			(else (ReduceSP 20) (ego hurtScript: blowEgo) (super attack:))
		)
	)
	
	(method (wander &tmp temp0 temp1 temp2)
		(= temp2 0)
		(cond 
			((== currentDay 8)
				(= temp1 1)
				(while (and (< temp1 40) (< temp2 10))
					(super wander:)
					(= temp1 (localproc_003b wandering))
					(++ temp2)
				)
			)
			((== currentDay 9) (super wander:) (localproc_000c wandering))
			(else
				(= temp1 359)
				(while (and (> temp1 20) (< temp2 10))
					(super wander:)
					(= temp1 (localproc_003b wandering))
					(++ temp2)
				)
			)
		)
		(self setMotion: TryToMoveTo newX newY 500 self)
		(= global292 (+ (* lastWander 100) wandering))
	)
)

(instance airBase of Code
	(properties)
	
	(method (doit param1 &tmp temp0)
		(= temp0 (param1 x?))
		(BaseSetter param1)
		(param1 brLeft: (- temp0 9) brRight: (+ temp0 9))
	)
)

(instance airEyes of Prop
	(properties
		view 342
		loop 2
		signal $6010
	)
	
	(method (doit)
		(= y (- (airElemental y?) 38))
		(self setPri: (+ (airElemental priority?) 1))
		(switch (airElemental cel?)
			(0
				(= x (- (airElemental x?) 8))
			)
			(1
				(= x (- (airElemental x?) 6))
			)
			(2
				(= x (- (airElemental x?) 1))
			)
			(3
				(= x (+ (airElemental x?) 6))
			)
			(4
				(= x (+ (airElemental x?) 2))
			)
		)
		(cond 
			((== loop 1) (super doit:))
			((> (ego x?) (+ x 20)) (self setCel: 0))
			((< (ego x?) (- x 20)) (self setCel: 2))
			(else (self setCel: 1))
		)
	)
)

(instance groundTimer of Timer
	(properties)
	
	(method (cue)
		(if (!= (ego script?) bellowsScript)
			(airElemental
				following: 0
				wandering: 1
				cycleSpeed: 0
				ignoreActors: 1
			)
			(airEyes dispose:)
			(= local86 0)
		)
	)
)

(instance blowEgo of HandsOffScript
	(properties)
	
	(method (init &tmp curRoomScript)
		(if
		(== (= curRoomScript (curRoom script?)) dirtScript)
			(ego illegalBits: -32768)
			(curRoomScript dispose:)
		)
		(ego hurtScript: 0)
		(super init: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((TestSkill 0 125)
						(if (not local88) (HighPrint 241 10) (= local88 1))
						(SetInput 0)
						(airElemental
							following: 1
							wandering: 0
							setMotion: MoveTo (ego x?) (ego y?)
						)
						(= state 1)
						(= cycles 30)
					)
					((> [skills 0] 100)
						(if (not local89) (HighPrint 241 11) (= local89 1))
						(self cue:)
					)
					(else
						(if (not local90) (HighPrint 241 12) (= local90 1))
						(self cue:)
					)
				)
			)
			(1
				(ego view: 343 setLoop: 0 setCycle: Fwd)
				(= state 3)
				(= cycles 24)
			)
			(2
				(if (> (ego x?) 160)
					(ego setMotion: MoveTo (- (ego x?) 30) (ego y?) self)
				else
					(ego setMotion: MoveTo (+ (ego x?) 30) (ego y?) self)
				)
			)
			(3
				(FaceObject ego airElemental 0 self)
			)
			(4
				(if (not local86)
					(airElemental following: 0 wandering: 1 attackDist: 15)
				)
				(proc1_19)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'deposit,throw,use/dirt,earth')
				(SetInput 1)
				(if global293
					(HighPrint 241 5)
					(if (not (mod (-- global293) 6))
						(ego use: 32)
						(ego get: 35)
					)
					(localproc_00b4)
				else
					(HighPrint 241 6)
				)
				(= cycles 1)
			)
			((Said 'deposit,throw,use/sand')
				(SetInput 1)
				(if global318
					(HighPrint 241 7)
					(-- global318)
					(localproc_00b4)
					(if (not (mod global318 9))
						(ego use: 51)
						(ego get: 38)
					)
				else
					(HighPrint 241 8)
				)
				(= cycles 1)
			)
			(else (pEvent claimed: 1) (HighPrint 241 9))
		)
	)
)

(instance dirtScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					(register
						(if (proc65_3 1 self self 0 0 0)
							(= local85 {dirt})
						else
							(self changeState: 1)
						)
					)
					((proc65_3 2 self self 0 0 0) (= local85 {sand}))
					(else (self changeState: 1))
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance levRopeSaids of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(client cue:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'deposit,throw,use/dirt,earth')
				(if
				(and (< (ego distanceTo: airElemental) 20) global293)
					(HighPrint 241 13)
					(if (not (mod (-- global293) 6))
						(ego use: 32)
						(ego get: 35)
					)
					(localproc_00b4)
				else
					(HighPrint 241 14)
				)
			)
			((Said 'deposit,throw,use/sand')
				(if
				(and (< (ego distanceTo: airElemental) 20) global318)
					(HighPrint 241 15)
					(if (not (mod (-- global318) 9))
						(ego use: 51)
						(ego get: 38)
					)
					(localproc_00b4)
				else
					(HighPrint 241 14)
				)
			)
			((Said 'throw/dirt,earth,pan,sand,bag') (HighPrint 241 16))
			(else (pEvent claimed: 0))
		)
	)
)

(instance bellowsScript of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp airElementalX airElementalY temp2)
		(switch (= state newState)
			(0
				(= airElementalX (airElemental x?))
				(= airElementalY (airElemental y?))
				(cond 
					(
					(and (> airElementalX 160) (< airElementalY 150)) (= register 1))
					((> airElementalX 160) (= register 2))
					((> airElementalY 165) (= register 3))
					(else (= register 4))
				)
				(= cycles 1)
			)
			(1
				(if (not local86)
					(self cue:)
				else
					(= airElementalX (airElemental x?))
					(= airElementalY (airElemental y?))
					(= airElementalX
						(+ airElementalX [local68 (* register 2)])
					)
					(= airElementalY
						(+ airElementalY [local68 (+ (* register 2) 1)])
					)
					(ego setMotion: MoveTo airElementalX airElementalY self)
				)
			)
			(2
				(ego view: 342 setLoop: [local78 register])
				(if (not local86)
					(self changeState: 5)
				else
					(= cycles 8)
				)
			)
			(3
				(airEyes
					setLoop: 1
					setCel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(4 (= cycles 8))
			(5
				(ego cycleSpeed: 1 setCycle: Fwd)
				(if local86
					(airEyes dispose:)
					(airElemental
						view: 342
						setLoop: (if (< register 3) 9 else 10)
						setCel: 0
						setPri: (ego priority?)
						setCycle: End self
					)
				else
					(self changeState: 8)
				)
			)
			(6
				(airElemental
					posn: (airElemental x?) (- (airElemental y?) 17)
					setLoop: (if (< register 3) 7 else 8)
					setCel: 13
					setCycle: Beg self
				)
				(gMiscMusic number: 342 loop: 0 priority: 15 play:)
			)
			(7
				(airElemental dispose:)
				(++ elementalsStatus)
				(ego view: 50 setLoop: 0 setCel: 0 setCycle: End)
				(= cycles 16)
			)
			(8
				(if local86
					(AddToScore 626 20)
					(SkillUsed 14 100)
					(HighPrint 241 17)
				else
					(HighPrint 241 18)
				)
				(= cycles 1)
			)
			(9
				(ego view: 0)
				(proc1_19)
				(= cycles 1)
			)
			(10 (self dispose:))
		)
	)
)
