;;; Sierra Script 1.0 - (do not remove this comment)
(script# 322)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Intrface)
(use LoadMany)
(use Extra)
(use Save)
(use Motion)
(use Actor)
(use System)

(public
	rakeesh 0
	baby 1
)

(local
	[local0 33] = [46 47 48 49 50 51 52 53 54 55 56 57 59 45 60 61 62 45 63 64 65 66 67 68 69 70 71 80 74 75 76 77 78]
	[local33 62] = [0 '//nature' 2 '//flame' 5 '//attack,battle' 6 '//leg,bandage,injury' 8 '//demon' 10 '//kingdom' 12 '//wizard' 14 '//choice' 15 '//people,lion' 16 '//tarna' 17 '//power,fighter' 19 '//will,soul' 20 '//philosopher' 21 '//forge,soulforge[<soul,about]' 23 '//paladin' 27 '//blade[<flaming,about]' 28 '//guildmaster' 30 '//simba,baby,baby' 32 '//magic<dark' 34 '//adventurer,adventure,adventuring' 35 '//ask' 36 '//hero' 37 '//ghoul' 38 '//dinosaur,(saurii<terror)' 39 '//griffin' 40 '//bandit' 41 '//(man<jackal),jackal' 42 '//scorpion' 43 '//poison,pill,cure,tail' 44 '//moose']
	local95
	local96
	local97
	local98
)
(instance baby of Prop
	(properties
		x 231
		y 113
		noun '/baby,simba'
		description {the baby Simba}
		view 168
		loop 11
		priority 7
		signal $0010
		cycleSpeed 1
	)
	
	(method (init)
		(self setScript: welcomeBaby)
		(super init:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'grab,acquire/baby') (self doVerb: 7))
			((Said 'beat/baby,simba')
				(cond 
					(
					(and (ego inRect: 210 114 300 125) (not local98)) (= local98 1) (ego setScript: babyToss))
					(local98 (HighPrint 322 4))
					(else (HighPrint 322 5))
				)
			)
			((Said 'ask/simba,baby')
				(if (not (Btst 71))
					(Bset 71)
					(= local97 1)
					(baby setScript: babyTurns)
				else
					(HighPrint 322 2)
				)
			)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if
				(and (< (rakeeshBod loop?) 5) (cast contains: rakeesh))
					(HighPrint 322 0)
				else
					(HighPrint 322 1)
				)
			)
			(9
				(if (not (Btst 71))
					(Bset 71)
					(= local97 1)
					(baby setScript: babyTurns)
				else
					(HighPrint 322 2)
				)
			)
			(7 (HighPrint 322 3))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance rakeesh of Talker
	(properties
		x 195
		y 108
		z 30
		description {the Liontaur Rakeesh}
		lookStr {The leonine creature before you looks ferocious and kindly at the same time.}
		view 168
		loop 4
		priority 8
		signal $6010
		illegalBits $0000
		tLoop 4
		talkSpeed 1
		myName '//rakeesh,lion,man,fighter'
		title {Rakeesh:}
		back 11
		msgFile 168
	)
	
	(method (init)
		(LoadMany 128 168 6)
		(super init:)
		(= tWindow TopWindow)
		(rakeeshHead init:)
		(rakeeshBod init:)
		(rakeeshTail init:)
		(if
			(and
				(not (ego has: 31))
				(== currentDay 13)
				(> elementalsStatus 6)
			)
			(curRoom entranceScript: warningOfEarth)
		)
	)
	
	(method (doit)
		(cond 
			((not local95))
			((-- local95))
			((not (baby loop?)) (baby setScript: babyTurns))
			(else (baby setScript: babyResumes))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (Said 'hello,greet') (Said '/hello,greet')) (Say self 322 6))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(HighPrint 322 7)
			)
			((Said 'thank[/rakeesh]')
				(if (and (Btst 72) (not (Btst 186)))
					(Bset 186)
					(SkillUsed 14 50)
				)
				(SayThanks rakeesh 322 8)
			)
			((Said 'greet[/rakeesh]') (Say rakeesh 322 9))
			((Said 'tell//self,spielburg') (Say rakeesh 322 10))
			((Said 'tell//elemental[<earth]')
				(cond 
					((!= gHeroType 0)
						(if (> elementalsStatus 5)
							(Say rakeesh 322 11)
						else
							(Say rakeesh 322 12)
						)
					)
					((< elementalsStatus 5) (Say rakeesh 322 13))
					((== elementalsStatus 5)
						(if (not (Btst 72))
							(Bset 72)
							(rakeeshBod setScript: tellOfSword)
						else
							(Say rakeesh 322 14)
						)
					)
					((> elementalsStatus 5) (Say rakeesh 322 11))
				)
			)
			((Said 'attack') (Say rakeesh 322 15))
			(
				(Said
					'get,acquire,acquire,borrow/(blade[<flaming]),(forge<soul),soulforge'
				)
				(if (and (== currentDay 13) (== gHeroType 0))
					(if (Btst 72)
						(Say rakeesh 322 16)
					else
						(Bset 72)
						(rakeeshBod setScript: tellOfSword)
					)
				else
					(Say rakeesh 322 17)
				)
			)
			((Said 'bargain') (HighPrint 322 18))
			(
				(Said
					'gave,hand,offer,replace/blade,(forge<soul),soulforge[/rakeesh,lion]'
				)
				(cond 
					((not (ego has: 31)) (HighPrint 322 19))
					((< elementalsStatus 6) (Say rakeesh 322 20))
					((ego has: 31) (AddToScore 676 5 3) (ego setScript: egoGivesSword))
					(else (PrintDontHaveIt))
				)
			)
		)
	)
	
	(method (onMe)
		(if (rakeeshHead onMe: &rest)
		else
			(rakeeshBod onMe: &rest)
		)
	)
	
	(method (atSpec param1)
		(return [local33 param1])
	)
	
	(method (atGen param1)
		(return [local0 param1])
	)
	
	(method (showText param1)
		(cond 
			(
				(and
					(== param1 27)
					(not (Btst 72))
					(== gHeroType 0)
					(== currentDay 13)
				)
				(Bset 72)
				(rakeeshBod setScript: tellOfSword)
			)
			(
				(and
					(== param1 5)
					(<= 5 elementalsStatus)
					(<= elementalsStatus 6)
				)
				(= param1 3)
				(self showMany: param1 4)
			)
			(else
				(switch param1
					(78
						(Say self msgFile 78 msgFile 35)
					)
					(0 (self showMany: param1 1))
					(6 (self showMany: param1 7))
					(8 (self showMany: param1 9))
					(10 (self showMany: param1 11))
					(12 (self showMany: param1 13))
					(17 (self showMany: param1 18))
					(21 (self showMany: param1 22))
					(23
						(AddToScore 660 3 0)
						(self showMany: param1 26)
					)
					(28 (self showMany: param1 29))
					(32 (self showMany: param1 33))
					(57 (self showMany: param1 58))
					(else 
						(super showText: param1 &rest)
					)
				)
			)
		)
	)
	
	(method (messages)
		(if (& (ego onControl: 1) $0800) (ego setPri: 9))
		(if (rakeeshHead script?)
			(rakeeshHead cel: 0 setScript: 0)
		)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(self setCel: 0)
		(ego setPri: -1)
		(super endTalk: &rest)
	)
)

(instance rakeeshBod of Prop
	(properties
		x 196
		y 105
		view 168
		loop 1
		priority 7
		signal $0010
	)
)

(instance rakeeshHead of Prop
	(properties
		x 196
		y 108
		z 30
		view 168
		loop 3
		priority 7
		signal $0010
	)
)

(instance rakeeshTail of Extra
	(properties
		x 224
		y 89
		noun '/tail'
		description {the Liontaur's tail}
		view 168
		loop 2
		priority 7
		signal $0010
		cycleType 1
		hesitation 20
		minPause 40
		maxPause 80
		minCycles 1
		maxCycles 3
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (cast contains: baby)
				(HighPrint 322 21)
			else
				(HighPrint 322 22)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance babyTurns of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if local97 (HighPrint 322 23 80 {Hero}))
				(baby setCycle: Beg self)
			)
			(1
				(baby loop: 10 setCycle: CT 3 1 self)
			)
			(2
				(if local97
					(= local97 0)
					(Print
						322
						24
						#title
						{Baby Simba}
						#at
						-1
						25
						#window
						babyWindow
					)
					(= local95 5)
				else
					(if
					(and (not (rakeesh cycler?)) (== (++ local96) 4))
						(= local96 0)
						(Print
							322
							25
							#time
							5
							#title
							{Baby Simba}
							#at
							220
							50
							#window
							babyWindow
							#dispose
						)
					)
					(baby loop: 11 setCycle: Fwd)
					(= local95 50)
				)
				(self dispose:)
			)
		)
	)
)

(instance babyResumes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baby loop: 10 cel: 3 setCycle: Beg self)
			)
			(1
				(baby loop: 0)
				(= local95 (Random 200 400))
				(client setScript: playWithTail)
			)
		)
	)
)

(instance rakeeshLooks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(rakeeshHead setCycle: End self)
			)
			(1 (= cycles 15))
			(2
				(rakeeshHead setCycle: Beg self)
			)
			(3 (self dispose:))
		)
	)
)

(instance warningOfEarth of Script
	(properties)
	
	(method (init)
		(Say rakeesh self 322 26 322 27)
		(self dispose:)
		(super init:)
	)
)

(instance tellOfSword of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (< (ego distanceTo: rakeeshBod) 40)
					(ego setMotion: MoveTo 174 118 self)
				else
					(self cue:)
				)
			)
			(1
				(FaceObject ego rakeeshBod)
				(Say rakeesh self 322 28)
			)
			(2
				(rakeesh x: 194 z: 39)
				(rakeeshHead hide:)
				(rakeeshTail hide:)
				(rakeeshBod
					loop: 6
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(3 (Say rakeesh self 322 29))
			(4
				(rakeeshBod loop: 7 cel: 0 setCycle: CT 7 1 self)
			)
			(5
				(rakeeshBod cel: 8)
				(flame init: setCycle: Fwd)
				(= cycles 15)
			)
			(6
				(flame dispose:)
				(rakeeshBod setCycle: End self)
			)
			(7
				(rakeesh x: 196)
				(Say rakeesh self 322 30 322 31 322 32)
			)
			(8
				(if (or (!= (ego x?) 174) (!= (ego y?) 118))
					(ego setMotion: MoveTo 174 118 self)
				else
					(self cue:)
				)
			)
			(9
				(ego view: 168 loop: 8 cel: 0 setCycle: CT 2 1 self)
			)
			(10
				(ego setCycle: End self get: 31)
				(rakeeshBod loop: 5)
				(AddToScore 661 7 0)
				(HighPrint 322 33 25 4)
				(rakeesh x: 195)
			)
			(11
				(proc1_19)
				(FaceObject ego rakeeshBod)
				(self dispose:)
			)
		)
	)
)

(instance welcomeBaby of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(baby setCycle: Fwd)
				(= seconds 3)
			)
			(1
				(Say rakeesh 322 34)
				(client setScript: babyResumes)
			)
		)
	)
)

(instance playWithTail of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(== (rakeeshTail cel?) 7)
				(< (baby loop?) 10)
				(not (rakeesh cycler?))
			)
			(baby setCycle: Beg)
			(if (Random 0 1) (rakeeshHead setScript: rakeeshLooks))
		)
		(super doit:)
	)
)

(instance babyWindow of SysWindow
	(properties
		color 5
		back 14
	)
)

(instance flame of Prop
	(properties
		x 178
		y 105
		z 50
		view 168
		loop 12
		signal $4000
	)
)

(instance babyToss of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local95 0)
				(baby loop: 10 cel: 0 setCycle: End)
				(ego
					view: 22
					loop: 0
					cel: 0
					illegalBits: 0
					posn: (+ (ego x?) 3) (+ (ego y?) 8)
					setCycle: End
				)
				(= cycles 20)
			)
			(1
				(baby loop: 11 setCycle: Fwd)
				(HighPrint 322 35 80 {Baby Simba} 35 babyWindow 103)
				(= seconds 6)
			)
			(2
				(baby loop: 10 cel: 3 setCycle: Beg)
				(ego loop: 1 cel: 0 cycleSpeed: 1 setCycle: End self)
			)
			(3
				(= local95 100)
				(DisposeDialog)
				(proc1_19)
				(ego loop: 3)
				(self dispose:)
			)
		)
	)
)

(instance egoGivesSword of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setMotion: MoveTo (- (rakeesh x?) 5) (+ (rakeesh y?) 12) self
				)
			)
			(1
				(FaceObject ego rakeesh)
				(= cycles 2)
			)
			(2
				(HighPrint 322 36)
				(= cycles 2)
			)
			(3 (Say rakeesh self 322 37))
			(4
				(ego use: 31)
				(self dispose:)
			)
		)
	)
)
