;;; Sierra Script 1.0 - (do not remove this comment)
(script# 273)
(include sci.sh)
(use Main)
(use Monster)
(use Motion)
(use System)

(public
	badGuy 0
)

(local
	[local0 6] = [0 0 2 1 0 2]
	[local6 6] = [1 1 1 2 2 2]
)
(instance badGuy of Monster
	(properties
		x 178
		y 137
		noun '/fighter,fighter,swordsman'
		description {the bloodthirsty swordsman}
		lookStr {The flailing, bloodthirsty swordsman looks like he means business.}
		view 273
		loop 9
		priority 5
		strength 130
		intell 60
		agil 140
		vit 140
		luck 80
		weap 100
		parry 80
		dodge 20
		armorValue 2
		weapValue 8
		battleMusic 52
		endMusic 53
	)
	
	(method (hurtMe param1)
		(if (> stamina 0)
			(self getTired: (+ param1 param1) &rest)
		else
			(super hurtMe: param1 &rest)
		)
		(return 1)
	)
	
	(method (initCombat)
		(= combatScript eofScript)
		(super initCombat: &rest)
	)
)

(instance eofScript of Script
	(properties)
	
	(method (changeState newState &tmp clientOpponent clientAction temp2 temp3)
		(switch (= state newState)
			(0 (= cycles 5))
			(1
				(client action: 0 setLoop: 0 setCel: 0)
				(= cycles (Random 4 10))
			)
			(2
				(if (<= (Random 1 100) 80)
					(= temp3 (Random 3 5))
				else
					(= temp3 (Random 6 8))
				)
				(client
					action: [local6 (- temp3 3)]
					attDirection: [local0 (- temp3 3)]
					setLoop: temp3
					setCel: 0
				)
				(= cycles
					(+ (Random 4 10) (* 4 (- 3 arcadeDifficultyLevel)))
				)
			)
			(3 (client setCycle: End self))
			(4
				(if (== (= clientAction (client action?)) 1)
					(= temp2 15)
				else
					(= temp2 8)
				)
				(= clientOpponent (client opponent?))
				(if
					(and
						(== clientAction 1)
						(client tryAttack: clientOpponent 0)
					)
					(client doDamage: clientOpponent 0 0)
				)
				(client getTired: temp2 client)
				(= cycles 1)
			)
			(5 (self changeState: 1))
		)
	)
)
