;;; Sierra Script 1.0 - (do not remove this comment)
(script# 101)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use Intrface)
(use Game)
(use Actor)
(use System)

(public
	bedroom 0
)

(local
	local0
)
(instance sleeper of PicView
	(properties
		x 85
		y 113
		view 101
		priority 7
	)
)

(instance bedroom of Rm
	(properties
		picture 101
		style $0008
	)
	
	(method (init)
		(super init:)
		(sleeper init:)
		(addToPics doit:)
		(self setScript: bedSleep)
	)
)

(instance bedSleep of Script
	(properties)
	
	(method (changeState newState &tmp temp0 newDialog [temp2 50])
		(switch (= state newState)
			(0 (UnlockEgo) (= cycles 2))
			(1
				(PrintGameTime @temp2)
				(StrCat @temp2 {__How long do you wish to sleep?_})
				(sleepText text: @temp2)
				(gCWin color: 14 back: 5)
				(LockEgo)
				((= newDialog (Dialog new:))
					window: gCWin
					text: {Asleep at the Katta's Tail Inn}
					add: sleepText dawnButton eveButton napButton cancelButton
					eachElementDo: #setSize
					setSize:
					moveTo: 104 14
					open: 4 15
				)
				(if (= local0 (newDialog doit: cancelButton))
					(= local0 (local0 value?))
				else
					(= local0 3)
				)
				(UnlockEgo)
				(newDialog dispose:)
				(switch local0
					(3)
					(0 (Rest 0))
					(else 
						(Bclr 4)
						(Bclr 5)
						(= temp0 (if (== local0 1) 20 else 5))
						(Sleep temp0 0)
					)
				)
				(= seconds 2)
			)
			(2
				(if (and (!= local0 3) (!= currentDay 17))
					(HighPrint 101 0)
				)
				(LockEgo)
				(if (== currentDay 17)
					(Bclr 3)
					(Bclr 137)
					(Bclr 4)
					(Bclr 5)
					(ego get: 49 get: 3 12)
					(if (not (ego has: 37)) (ego get: 37))
					(++ mealsPreEaten)
					(= currentWater (* [invNum 37] 10))
					(client newRoom: 860)
				else
					(client newRoom: 100)
				)
			)
		)
	)
)

(instance sleepText of DText
	(properties
		nsTop 10
		nsLeft 10
		font 300
		mode 1
	)
)

(instance dawnButton of DButton
	(properties
		nsTop 45
		nsLeft 10
		value 2
		text {Until Dawn}
		font 300
	)
)

(instance eveButton of DButton
	(properties
		nsTop 45
		nsLeft 110
		value 1
		text {Until Evening}
		font 300
	)
)

(instance napButton of DButton
	(properties
		nsTop 65
		nsLeft 18
		text {One Hour}
		font 300
	)
)

(instance cancelButton of DButton
	(properties
		nsTop 65
		nsLeft 118
		value 3
		text {Stay Awake}
		font 300
	)
)
