;;; Sierra Script 1.0 - (do not remove this comment)
(script# 302)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use Talker)
(use LoadMany)
(use Motion)
(use System)

(public
	beggar 0
	beggarSpeech 1
)

(local
	[local0 33] = [1 2 3 0 0 0 0 0 0 0 0 4 5 0 6 0 0 0 7 0 8 9 10 11 12 13 14 0 15 0 16 0 17]
	[local33 10] = [18 '//effendi' 19 '//paladin' 20 '//labor' 21 '//begging,beggar']
)
(instance beggar of Talker
	(properties
		x 202
		y 99
		description {a street beggar}
		lookStr {The beggar is bawling for Dinars (but he might settle for Centimes).}
		view 308
		loop 1
		signal $4000
		illegalBits $0000
		tLoop 1
		myName '//shihhad,beggar'
		title {Beggar:}
		color 15
		back 6
		msgFile 308
	)
	
	(method (init)
		(super init:)
		(LoadMany 131 308)
		(curRoom saveIllegal: (| (curRoom saveIllegal?) $0400))
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'gave/[/beggar,shihhad]>')
				(cond 
					((not (< (ego distanceTo: beggar) 60)) (HighPrint 302 0) (pEvent claimed: 1))
					((Said '/alm,alm,cent') (giveToBeggar doit: 1 0))
					((Said '/dinar,gold') (giveToBeggar doit: 100 0))
					((Said '/food') (giveToBeggar doit: 0 1))
					((Said '/*') (HighPrint 302 1) (pEvent claimed: 1))
					(else (PrintDontUnderstand) (pEvent claimed: 1))
				)
			)
			((super handleEvent: pEvent) 0)
		)
		(pEvent claimed?)
	)
	
	(method (atSpec param1)
		(return [local33 param1])
	)
	
	(method (atGen param1)
		(return [local0 param1])
	)
)

(instance beggarSpeech of HandsOffScript
	(properties)
	
	(method (changeState)
		(beggar loop: 0 cel: 0 setCycle: End beggar state: -1)
		(Say beggar self 302 2)
	)
	
	(method (cue)
		(beggar loop: 1 cel: 0)
		(self dispose:)
	)
)

(instance giveToBeggar of Script
	(properties)
	
	(method (doit param1 &tmp temp0)
		(= temp0 0)
		(cond 
			(param1
				(switch (proc3_1 param1)
					(2
						(= temp0 1)
						(proc3_2 param1)
					)
					(1 (Say beggar 302 3))
					(else  (HighPrint 302 4))
				)
			)
			([invNum 3] (ego put: 3) (= temp0 1))
			(else (HighPrint 302 5))
		)
		(if temp0
			(beggar
				loop: 2
				cel: 0
				setCycle: End beggar
				cycleSpeed: 5
				state: -1
			)
			(if (Btst 619)
				(AddToScore 679 5 3)
			else
				(AddToScore 619 3)
			)
			(cond 
				((>= param1 100) (SkillUsed 14 (/ param1 4)) (Say beggar self 302 6))
				((> param1 0) (SkillUsed 14 (/ param1 4)) (Say beggar self 302 7))
				(else (SkillUsed 14 10) (Say beggar self 302 8))
			)
		)
	)
	
	(method (cue)
		(beggar loop: 1 cel: 0 cycleSpeed: 0)
	)
)
