;;; Sierra Script 1.0 - (do not remove this comment)
(script# 99)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use Intrface)
(use Printd)
(use PolyEdit)
(use WriteFtr)
(use Game)
(use User)
(use Actor)
(use System)

(public
	debugRm 0
)

(procedure (localproc_04b8 &tmp [temp0 10] [temp10 10] [temp20 10] [temp30 5] [temp35 5] [temp40 5])
	(Format @temp0 99 5 [invNum 2])
	(Format @temp10 99 5 [invNum 17])
	(Format @temp20 99 5 [skills 13])
	(= temp30 (= temp35 (= temp40 0)))
	(if
		(Printd
			80
			{Get Bucks}
			{Dinars}
			41
			@temp30
			5
			@temp0
			101
			{Gold}
			41
			@temp35
			5
			4
			14
			@temp10
			101
			{Comm}
			41
			@temp40
			5
			4
			2
			@temp20
		)
		(= [invNum 2] (ReadNumber @temp30))
		(= [invNum 17] (ReadNumber @temp35))
		(= [skills 13] (ReadNumber @temp40))
		(= [invNum 1] 0)
	)
)

(instance debugRm of Locale
	(properties)
	
	(method (init)
		(super init:)
		(gMouseH add: self)
		(gKeyH add: self)
	)
	
	(method (dispose)
		(gMouseH delete: self)
		(gKeyH delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp newEvent temp1 [temp2 2] castFirst temp5 temp6 theSkills temp8 [temp9 40] [temp49 5] [temp54 5])
		(if (or (not suckBlueFrog) (pEvent claimed?)) (return))
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(cond 
					((& (pEvent modifiers?) emCTRL)
						(pEvent claimed: 1)
						(SetControl 0)
						(while (!= 2 ((= newEvent (Event new:)) type?))
							(GlobalToLocal newEvent)
							(ego posn: (newEvent x?) (newEvent y?) setMotion: 0)
							(Animate (cast elements?) 0)
							(newEvent dispose:)
						)
						(newEvent dispose:)
					)
					((& (pEvent modifiers?) emSHIFT)
						(= temp1
							(Print
								(Format @temp9 99 0 (pEvent x?) (pEvent y?))
								#at
								150
								100
								#font
								999
								#dispose
							)
						)
						(while (!= 2 ((= newEvent (Event new:)) type?))
							(newEvent dispose:)
						)
						(temp1 dispose:)
						(newEvent dispose:)
					)
				)
			)
			(evKEYBOARD
				(pEvent claimed: 1)
				(switch (pEvent message?)
					(KEY_QUESTION (Print 99 1))
					(KEY_ALT_u
						(cast eachElementDo: #perform showUpdaters)
					)
					(KEY_ALT_s
						(= temp8 {*})
						(StrAt temp8 0 0)
						(= castFirst (cast first:))
						(while castFirst
							(= temp1 (NodeValue castFirst))
							(Print
								(Format
									@temp9
									99
									2
									(temp1 view?)
									(temp1 x?)
									(temp1 y?)
									(if (& (temp1 signal?) $0004) {stopUpd:\n} else temp8)
									(if (& (temp1 signal?) $4000)
										{ignoreActors:\n}
									else
										temp8
									)
									(if
										(or
											(== (temp1 superClass?) Actor)
											(== (temp1 superClass?) Ego)
										)
										(temp1 illegalBits?)
									else
										-1
									)
								)
								#title
								(temp1 name?)
								#icon
								(temp1 view?)
								(temp1 loop?)
								(temp1 cel?)
							)
							(= castFirst (cast next: castFirst))
						)
					)
					(KEY_ALT_e
						(Print
							(Format
								@temp9
								99
								3
								(ego x?)
								(ego y?)
								(ego loop?)
								(ego cel?)
								(ego priority?)
							)
							#title
							{Ego}
							#icon
							(ego view?)
							(ego loop?)
							(ego cel?)
						)
					)
					(KEY_ALT_i
						(= temp49 0)
						(StrCpy @temp54 {1})
						(if
							(Printd
								80
								{Get Inventory Item}
								{Inventory ID}
								41
								@temp49
								5
								{Quantity}
								41
								@temp54
								5
							)
							(= castFirst (ReadNumber @temp49))
							(= temp5 (ReadNumber @temp54))
							(ego get: castFirst temp5)
						)
					)
					(KEY_ALT_t
						(if (= temp5 (BlueFrogTP))
							(= curRoomNum 0)
							(curRoom newRoom: temp5)
						)
					)
					(KEY_ALT_v (Show 1))
					(KEY_ALT_p (Show 2))
					(KEY_ALT_c (Show 4))
					(KEY_ALT_f (theGame showMem:))
					(KEY_ALT_b (localproc_04b8))
					(KEY_ALT_k
						(= temp6 (GetNumber {Change which Stat/Skill?}))
						(= [skills temp6]
							(GetNumber {Enter new value:} [skills temp6])
						)
					)
					(KEY_ALT_h
						(= theSkills
							(GetNumber {What should each skill be?} 150)
						)
						(= temp6 0)
						(while (< temp6 30)
							(= [skills temp6] theSkills)
							(++ temp6)
						)
						(= [skills 15] 3500)
						(= [skills 16] (GetMaxHealth))
						(= [skills 17] (GetMaxStamina))
						(= [skills 18] (GetMaxMana))
						(Print 99 4)
					)
					(KEY_ALT_z (= quit 1))
					(KEY_ALT_x (= quit 1))
					(KEY_ALT_w (Class_948_1 doit:))
					(KEY_ALT_g (MakePath doit:))
					(23 ((ScriptID 92 0) init:))
					(else  (pEvent claimed: 0))
				)
			)
		)
	)
)

(instance showUpdaters of Code
	(properties)
	
	(method (doit param1 &tmp [temp0 100])
		(if (& (param1 signal?) $0003)
			(Print
				(Format @temp0 99 6 (param1 signal?))
				#icon
				(param1 view?)
				(param1 loop?)
				(param1 cel?)
				#title
				(param1 name?)
			)
		)
	)
)
