;;; Sierra Script 1.0 - (do not remove this comment)
(script# 660)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use TargActor)
(use Intrface)
(use gulfCycle)
(use PolyPath)
(use Polygon)
(use LoadMany)
(use Grooper)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	desertReg 0
	saurus 1
	duneIn 2
	duneOut 3
	proc660_4 4
	proc660_5 5
	mountSaurus 6
	dismountSaurus 7
	twoDunesIn 8
	twoDunesOut 9
	proc660_10 10
	saurusPoly 11
)

(local
	clientX
	local1
	[local2 8]
)
(procedure (proc660_4 param1 param2 param3 param4 &tmp temp0 temp1)
	(asm
		ldi      0
		sat      temp0
code_105c:
		pushi    0
		lap      param2
		lt?     
		bnt      code_10ae
		pprev   
		ldi      190
		lt?     
		bnt      code_10ae
		pushi    3
		pushi    4
		lsp      param1
		lsp      param2
		callk    OnControl,  6
		sat      temp1
		lat      temp0
		not     
		bnt      code_1091
		lst      temp1
		lap      param3
		and     
		bnt      code_109f
		ldi      1
		sat      temp0
		ldi      0
		sap      param4
		jmp      code_109f
code_1091:
		lst      temp1
		lap      param3
		and     
		bnt      code_10ae
		jmp      code_109f
		jmp      code_10ae
code_109f:
		lap      param4
		bnt      code_10a9
		-ap      param2
		jmp      code_105c
code_10a9:
		+ap      param2
		jmp      code_105c
code_10ae:
		lat      temp0
		not     
		bnt      code_10b8
		ldi      0
		sap      param2
code_10b8:
		lap      param2
		ret     
	)
)

(procedure (proc660_5 param1 &tmp temp0 egoX egoY)
	(= temp0 3)
	(cond 
		((!= (param1 type?) 128) (= temp0 0))
		((not (== egoWalkMode 3))
			(= temp0 0)
			(cond 
				(
					(Said
						'mount,ride,(climb,scale,get,acquire<on,up)[/saurii,roget]'
					)
					(if
					(or (cast contains: saurus) (== (ego view?) 12))
						(= temp0 2)
					else
						(HighPrint 660 21)
					)
				)
				(
					(Said
						'dismount,(climb,scale,get,acquire<off,down)[/saurii,roget]'
					)
					(HighPrint 660 22)
					(if (not (Btst 75))
						(Bset 75)
						(Print 660 23)
						(Print 660 24)
					)
				)
			)
		)
		(
			(Said
				'dismount,(climb,scale,get,acquire<off,down)[/saurii,roget]'
			)
			(= temp0 1)
		)
		(
			(Said
				'mount,ride,(climb,scale,get,acquire<on,up)[/saurii,roget]'
			)
			(HighPrint 660 25)
		)
		((Said 'quit,look,examine,ask>'))
		((Said 'go/home')
			(cond 
				((OneOf curRoomNum 780 880) (= egoX (ego x?)) (= egoY 0))
				((== curRoomNum 665)
					(= gTheGNorth (if (>= currentDay 27) 8699 else 1301))
					(= egoX -20)
					(= egoY (ego y?))
				)
				((curRoom respondsTo: #inOut)
					(curRoom west: (if (>= currentDay 27) 880 else 780))
					(= egoX -20)
					(= egoY (ego y?))
				)
				(else
					(curRoom west: (if (>= currentDay 27) 880 else 780))
					(= egoX -20)
					(= egoY (ego y?))
				)
			)
			(HighPrint 660 26)
			(ego setMotion: PolyPath egoX egoY)
		)
		((Said 'acquire,use,eat,chew/pill') (param1 claimed: 0))
		(else (param1 claimed: 1) (HighPrint 660 27))
	)
	(return temp0)
)

(procedure (proc660_10 &tmp temp0 temp1 temp2 temp3 theEgo curRoomObstacles)
	(if (== egoWalkMode 3)
		(= theEgo ego)
	else
		(= theEgo saurus)
	)
	(BaseSetter saurus)
	(= temp0 (- (theEgo brLeft?) 10))
	(= temp1 (- (theEgo brTop?) 10))
	(= temp2 (+ (theEgo brRight?) 10))
	(= temp3 (+ (theEgo brBottom?) 5))
	(= [local2 0] (= [local2 6] temp0))
	(= [local2 1] (= [local2 3] temp1))
	(= [local2 2] (= [local2 4] temp2))
	(= [local2 5] (= [local2 7] temp3))
	(saurusPoly points: @local2 size: 4)
	(if
		(or
			(not (= curRoomObstacles (curRoom obstacles?)))
			(not (curRoomObstacles contains: saurusPoly))
		)
		(curRoom addObstacle: saurusPoly)
	)
)

(instance desertReg of Rgn
	(properties)
	
	(method (init)
		(Load rsSCRIPT 985)
		(LoadMany 128 0 5 11 12 13 14 659)
		(if (not isNightTime) (sandPoof init:))
		(= useObstacles 1)
		(super init:)
		(if
			(and
				(== curRoomNum (- gGTheGNorth))
				(!= curRoomNum 290)
				(!= egoWalkMode 3)
				(ego has: 50)
			)
			(saurus view: 298 init:)
			(if (== curRoomNum 650)
				(saurus posn: 285 150 loop: 3)
			else
				(saurus posn: 50 150 loop: 2)
			)
			(proc660_10)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(not
						(if (cast contains: saurus) else (== (ego view?) 12))
					)
					(Said '/saurii')
				)
				(HighPrint 660 0)
			)
			((Said 'ask,talk,chat/saurii,roget') (HighPrint 660 1))
			((Said 'look,examine>')
				(cond 
					(
						(or
							(Said 'search,look,examine[<at,around][/room,area][/!*]')
							(Said 'look,examine/desert')
						)
						(HighPrint 660 2)
					)
					((Said '/saddle,bridle,rein,stirrup')
						(if
						(or (cast contains: saurus) (== (ego view?) 12))
							(HighPrint 660 3)
						else
							(HighPrint 660 4)
						)
					)
					((or (Said '<up') (Said '/sky,sun,star'))
						(if (& defaultPalette $0001)
							(HighPrint 660 5)
						else
							(HighPrint 660 6)
						)
					)
					(
					(or (Said '<down') (Said '/ground,sand,boulder'))
						(if (& defaultPalette $0001)
							(HighPrint 660 7)
						else
							(HighPrint 660 8)
						)
					)
				)
			)
			((== (= temp0 (proc660_5 pEvent)) 3))
			((== temp0 2)
				(if (and (== curRoomNum 620) (saurus script?))
					(HighPrint 660 9)
				else
					(curRoom setScript: mountSaurus)
				)
			)
			((== temp0 1) (curRoom setScript: dismountSaurus))
			((Said 'get,acquire,(lockpick<up)/boulder') (ego setScript: (ScriptID 60)))
			((Said 'get,acquire,(lockpick<up)/sand')
				(cond 
					((ego has: 38)
						(HighPrint 660 10)
						(= global318 (+ global318 9))
						(ego use: 38 1)
						(ego get: 51 1)
					)
					((ego has: 51) (HighPrint 660 11))
					(else (HighPrint 660 12))
				)
			)
		)
	)
)

(instance dismountSaurus of HandsOffScript
	(properties)
	
	(method (dispose)
		(cond 
			((== curRoomNum 665) (= oldIllBits -32512))
			((and (== curRoomNum 290) (!= egoWalkMode 3)) (curRoom notify:))
		)
		(super dispose:)
	)
	
	(method (changeState newState &tmp egoPriority)
		(switch (= state newState)
			(0
				(if
					(or
						(proc1_30 15)
						(and (== curRoomNum 665) (proc665_1))
						(and (== curRoomNum 290) (< (ego y?) 136))
					)
					(HighPrint 660 13)
					(self dispose:)
				else
					(self cue:)
				)
			)
			(1
				(if (== curRoomNum 620)
					(ego setMotion: PolyPath 50 140 self)
				else
					(self cue:)
				)
			)
			(2
				(if (> (ego loop?) 1) (ego loop: 0))
				(= cycles 2)
			)
			(3
				(ego view: 14 cel: 5 cycleSpeed: 1 setCycle: Beg self)
			)
			(4
				(= egoPriority (ego priority?))
				(saurus
					view: 11
					setLoop: Grooper
					loop: (ego loop?)
					setPri: (- egoPriority 1)
					ignoreActors: 1
					posn: (ego x?) (ego y?)
					init:
				)
				(= egoWalkMode 0)
				(proc1_19)
				(= cycles 1)
			)
			(5
				(ego
					setMotion: MoveTo (+ (ego x?) 10) (+ (ego y?) 7) self
				)
			)
			(6
				(saurus setLoop: -1 setCycle: Walk)
				(cond 
					((== curRoomNum 650) (saurus setMotion: PolyPath 285 150 self))
					((== curRoomNum 640) (saurus setMotion: PolyPath 22 125 self))
					((== curRoomNum 620) (self cue:))
					((== curRoomNum 630) (self changeState: 8))
					(else (self changeState: 9))
				)
			)
			(7
				(if (== curRoomNum 640)
					(saurus setHeading: 90 self)
				else
					(saurus setHeading: 270 self)
				)
			)
			(8
				(saurus
					view: 298
					setLoop: (+ (saurus loop?) 2)
					setPri: -1
				)
				(= cycles 1)
			)
			(9
				(if (== curRoomNum 665)
					(= gGTheGNorth gTheGNorth)
				else
					(= gGTheGNorth (- curRoomNum))
				)
				(saurus ignoreActors: 0)
				(proc660_10)
				(self dispose:)
			)
		)
	)
)

(instance mountSaurus of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 saurusLoop)
		(switch (= state newState)
			(0
				(if
					(not
						(= temp0 (if (== curRoomNum 665) (proc665_1) else 0))
					)
					(self cue:)
				else
					((curRoom obstacles?) delete: saurusPoly)
					(saurus
						view: 11
						setLoop: -1
						setPri: -1
						setCycle: Walk
						setMotion: PolyPath (- (saurus x?) temp0) (saurus y?) self
					)
				)
			)
			(1
				(if
				(not ((curRoom obstacles?) contains: saurusPoly))
					(proc660_10)
				)
				(ChangeEgoWalk 0 0)
				(if
					(and
						(== curRoomNum 650)
						(< (ego x?) 110)
						(< (ego y?) 170)
					)
					(ego setMotion: MoveTo 110 170 self)
				else
					(= cycles 1)
				)
			)
			(2
				(saurusPoly type: 1)
				(ego
					setMotion: PolyPath (saurus x?) (+ (saurus y?) 3) self
				)
			)
			(3
				(saurus setPri: (- (saurus priority?) 1))
				(ego setMotion: MoveTo (saurus x?) (saurus y?) self)
			)
			(4
				(saurusPoly type: 2)
				(= saurusLoop (saurus loop?))
				(ego
					view: 14
					setLoop: (if (OneOf saurusLoop 1 3) 1 else 0)
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
				(saurus dispose:)
				(= gGTheGNorth 0)
			)
			(5
				(if ((curRoom obstacles?) contains: saurusPoly)
					((curRoom obstacles?) delete: saurusPoly)
				)
				(= egoWalkMode 3)
				(proc1_19)
				(ego setHeading: (if (ego loop?) 270 else 90))
				(self dispose:)
			)
		)
	)
)

(instance duneOut of Script
	(properties)
	
	(method (dispose)
		(if (== client ego)
			(LockEgo)
			(if (== curRoomNum 665)
				(= gTopExit 1)
			else
				(= gTopExit (curRoom topExit?))
			)
			(super dispose:)
			(curRoom newRoom: (curRoom north?))
		else
			(super dispose:)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== client ego) (UnlockEgo))
				(= clientX (client x?))
				(= local1 (proc660_4 clientX (client y?) 4 1))
				(client setLoop: 3 setMotion: MoveTo clientX local1 self)
			)
			(1
				(client
					setPri: 2
					illegalBits: 0
					ignoreActors: 1
					setMotion: MoveTo (client x?) (+ (client y?) 65) self
				)
			)
			(2
				(if (== client ego)
					(proc1_19)
					(self dispose:)
				else
					(client dispose:)
				)
			)
		)
	)
)

(instance duneIn of Script
	(properties)
	
	(method (dispose)
		(if (== client ego)
			(LockEgo)
			(ego illegalBits: -32768 ignoreActors: 0)
			(User prevDir: 5)
		)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= clientX (client x?))
				(= local1 (proc660_4 clientX (client y?) 4 0))
				(if (== client ego)
					(UnlockEgo)
					(proc1_19)
					(ego illegalBits: 0 ignoreActors: 1)
				)
				(client
					posn: clientX (+ local1 65)
					setLoop: 2
					setPri: 2
					setMotion: MoveTo clientX local1 self
				)
			)
			(1
				(client
					setPri: -1
					setLoop: -1
					setMotion: PolyPath (client x?) (+ (client y?) 10) self
				)
			)
			(2
				(client setMotion: PolyPath (client x?) 200)
				(self dispose:)
			)
		)
	)
)

(instance twoDunesOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= clientX (client x?))
				(= local1 (proc660_4 clientX (client y?) 4 1))
				(client
					setLoop: 3
					setPri: 2
					illegalBits: 0
					ignoreActors: 1
					setMotion: MoveTo clientX (+ local1 65) self
				)
			)
			(1
				(if (== egoWalkMode 3)
					(client view: 13 setStep: 2 2)
				else
					(client view: 5 setStep: 1 1)
				)
				(cond 
					((< clientX 130) (= clientX 130))
					((> clientX 190) (= clientX 190))
				)
				(client x: clientX setMotion: MoveTo clientX local1 self)
			)
			(2
				(= local1 (proc660_4 clientX (client y?) 2 1))
				(client setMotion: MoveTo clientX local1 self)
			)
			(3
				(client
					setPri: 1
					setMotion: MoveTo clientX (+ local1 20) self
				)
			)
			(4
				(if (== curRoomNum 665)
					(= gTopExit 1)
				else
					(= gTopExit (curRoom topExit?))
				)
				(self dispose:)
				(curRoom newRoom: (curRoom north?))
			)
		)
	)
)

(instance twoDunesIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== egoWalkMode 3)
					(client view: 13 setStep: 2 2)
				else
					(client view: 5 setStep: 1 1)
				)
				(= clientX (client x?))
				(= local1 (proc660_4 clientX (client y?) 2 0))
				(client
					illegalBits: 0
					ignoreActors: 1
					setPri: 1
					setLoop: 2
				)
				(client
					posn: clientX (+ local1 20)
					setMotion: MoveTo clientX local1 self
				)
			)
			(1
				(= local1 (proc660_4 clientX local1 4 0))
				(client
					setPri: 2
					setMotion: MoveTo clientX (+ local1 65) self
				)
			)
			(2
				(ChangeEgoWalk -1 0)
				(client
					posn: clientX (+ local1 65)
					setLoop: 2
					setMotion: MoveTo clientX local1 self
				)
			)
			(3
				(proc1_19)
				(client
					illegalBits: 0
					setMotion: PolyPath clientX (+ local1 10) self
				)
			)
			(4
				(client setMotion: PolyPath clientX 200)
				(self dispose:)
			)
		)
	)
)

(instance saurusPoly of Polygon
	(properties
		type $0002
	)
)

(instance sandPoof of Prop
	(properties
		shiftClick 0
		contClick 0
		view 659
		signal $4000
	)
	
	(method (doit)
		(if
			(and
				(== (ego view?) 0)
				(ego mover?)
				(not (ego script?))
			)
			(= loop (ego loop?))
			(= cel (ego cel?))
			(= x (ego x?))
			(= y (ego y?))
			(self show:)
		else
			(self hide:)
		)
		(super doit:)
	)
)

(instance saurus of TargActor
	(properties
		noun '/saurii,roget'
		description {saurus}
		yStep 3
		view 11
		loop 1
		xStep 5
	)
	
	(method (doit)
		(if
		(and (not script) (& (self onControl:) $0004))
			(self setScript: duneOut)
		else
			(super doit:)
		)
	)
	
	(method (dispose)
		(if (not gGTheGNorth)
			(if (== curRoomNum 665)
				(= gGTheGNorth gTheGNorth)
			else
				(= gGTheGNorth (- curRoomNum))
			)
		)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(if
			(and
				(== curRoomNum 290)
				(Said 'get,acquire/saurii,roget')
			)
			(pEvent claimed: 0)
			(curRoom handleEvent: pEvent)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if (== egoWalkMode 3)
					(HighPrint 660 14)
				else
					(HighPrint 660 15)
				)
			)
			(7
				(if (== egoWalkMode 3)
					(HighPrint 660 16)
				else
					(HighPrint 660 17)
				)
			)
			(4 (HighPrint 660 18))
			(6 (HighPrint 660 19))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (hurtMe)
		(HighPrint 660 20)
	)
)
