;;; Sierra Script 1.0 - (do not remove this comment)
(script# 309)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Flame)
(use TryToMoveTo)
(use Elemental)
(use Reverse)
(use Chase)
(use Motion)
(use System)

(public
	fireElemental 0
)

(local
	local0
	local1
	local2
	[local3 9] = [0 {Ow!__Hey!} {Man, that's hot!} {Wowf!} {Yowp!} {Watch out!} {Ouch!} {Yikes!} {Geez!}]
	[local12 8] = [2 3 0 2 0 1 2 3]
	[local20 8] = [-15 -15 15 -15 -15 15 15 15]
	[local28 18] = [0 0 40 180 50 130 110 100 290 180 265 130 205 100 140 155 180 155]
	[local46 25]
)
(procedure (localproc_0578 param1)
	(= local1 (* param1 2))
	(fireElemental
		newX: [local28 local1]
		newY: [local28 (+ local1 1)]
	)
)

(instance beginIncense of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (< (fireElemental x?) (ego x?))
					(fireElemental setMotion: MoveTo 120 135)
				else
					(fireElemental setMotion: MoveTo 200 135)
				)
				(ego setMotion: MoveTo 160 135 self)
			)
			(1
				(ego setHeading: 0)
				(fireElemental setMotion: MoveTo 160 180)
				(= cycles 8)
			)
			(2
				(client illegalBits: 0 following: 1 wandering: 0 cue:)
				(ego view: 18 loop: 3 setCycle: gEgoSW 21)
				(self dispose:)
			)
		)
	)
)

(instance getBurned of HandsOffScript
	(properties)
	
	(method (init)
		(super init: &rest)
		(ego illegalBits: -32512)
	)
	
	(method (changeState newState &tmp temp0 temp1 temp2 temp3)
		(switch (= state newState)
			(0
				(FaceObject ego fireElemental 0 self)
			)
			(1
				(= local0 [local12 (ego loop?)])
				(ego view: 19 setLoop: local0 setCycle: End self)
			)
			(2
				(if (fireElemental following?)
					(= temp0 (- (ego x?) 5))
					(= temp1 (- (ego y?) 15))
					(= temp3 2)
				else
					(= local1 (* local0 2))
					(= temp0 (+ (ego x?) [local20 local1]))
					(= temp1 (+ (ego y?) [local20 (+ local1 1)]))
					(= temp3 (+ local0 4))
				)
				(ego
					view: 0
					setLoop: temp3
					setCycle: Rev
					setMotion: TryToMoveTo temp0 temp1 500 self
				)
			)
			(3
				(HighPrint
					(Format @local46 309 0 [local3 (Random 1 8)])
				)
				(= temp2 (+ 20 (* 20 (fireElemental following?))))
				(if (not (ReduceHP temp2))
					(Die
						0
						309
						1
						80
						{All your joints feel inflamed...}
						82
						19
						2
						4
					)
				else
					(self cue:)
				)
			)
			(4
				(proc1_19)
				(ego
					view: (if (fireElemental following?) 18 else 0)
					loop: (if (== local1 2) 2 else 3)
					hurtScript: 0
				)
				(fireElemental cue:)
				(self dispose:)
			)
		)
	)
)

(instance douseElemental of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp egoX egoY fireElementalX fireElementalY)
		(switch (= state newState)
			(0
				(= fireElementalX (fireElemental x?))
				(= fireElementalY (fireElemental y?))
				(= egoX (ego x?))
				(= egoY (ego y?))
				(cond 
					(
					(and (< egoX fireElementalX) (< egoY fireElementalY))
						(= egoX (- fireElementalX 30))
						(= egoY (- fireElementalY 8))
						(= local0 0)
					)
					(
					(and (>= egoX fireElementalX) (< egoY fireElementalY))
						(= egoX (+ fireElementalX 30))
						(= egoY (- fireElementalY 8))
						(= local0 1)
					)
					(
					(and (< egoX fireElementalX) (>= egoY fireElementalY))
						(= egoX (- fireElementalX 33))
						(= egoY (+ fireElementalY 8))
						(= local0 2)
					)
					(else
						(= egoX (+ fireElementalX 33))
						(= egoY (+ fireElementalY 8))
						(= local0 3)
					)
				)
				(if (< egoY 100) (= egoY (+ fireElementalY 8)))
				(if (> egoY 190) (= egoY (- fireElementalY 8)))
				(if (< egoX 25)
					(= egoX (+ fireElementalX (- fireElementalX egoX)))
				)
				(if (> egoX 295)
					(= egoX (- fireElementalX (- egoX fireElementalX)))
				)
				(ego setMotion: MoveTo egoX egoY self)
			)
			(1
				(ego view: 61 loop: local0 setCycle: Fwd)
				(fireElemental loop: 4 cel: 0 setCycle: End self)
			)
			(2
				(= fireElementalX (fireElemental x?))
				(= fireElementalY (fireElemental y?))
				(switch (ego loop?)
					(0
						(= egoX (+ fireElementalX 25))
						(= egoY (+ fireElementalY 25))
					)
					(1
						(= egoX (- fireElementalX 25))
						(= egoY (+ fireElementalY 25))
					)
					(2
						(= egoX (+ fireElementalX 25))
						(= egoY (- fireElementalY 25))
					)
					(3
						(= egoX (- fireElementalX 25))
						(= egoY (- fireElementalY 25))
					)
				)
				(fireElemental
					loop: 0
					illegalBits: (| (fireElemental illegalBits?) $0040)
					setCycle: Fwd
					setMotion: TryToMoveTo egoX egoY 500 self
				)
			)
			(3
				(fireElemental
					loop: 4
					cel: 6
					illegalBits: -32768
					setCycle: Beg self
				)
				(proc1_19)
				(= cycles 1)
			)
			(4
				(HighPrint 309 2)
				(fireElemental loop: 2 following: 0 setCycle: Fwd species)
				(ego loop: (+ local0 4))
				(self dispose:)
			)
		)
	)
)

(instance fireElemental of Elemental
	(properties
		x 160
		y 160
		noun '/elemental[<fire]'
		description {the Fire Elemental}
		lookStr {It is a magical mass of fire.}
		view 340
		loop 2
		signal $6800
		wandering 1
		wanderList 8
	)
	
	(method (init)
		(super init: &rest)
		(self baseSetter: fireBase)
		(if (== currentDay 6) (self setMotion: Chase ego 25))
		(= local2 (ScriptID 300 1))
	)
	
	(method (doit)
		(if
			(and
				(fireElemental inRect: 210 90 244 126)
				(== (local2 cel?) 5)
			)
			((littleFire new:)
				posn: 243 48
				priority: 8
				signal: 16
				init:
			)
			(local2
				view: 340
				loop: 9
				cel: 1
				description: {the very burnt sign}
				forceUpd:
			)
			(Bset 181)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(HighPrint 309 3)
			)
			(
				(Said
					'deposit,use,done,spread,sprinkle,strew,dust/trail,frankincense'
				)
				(if (not (OneOf (ego view?) 18 21))
					(if (not (ego has: 13))
						(HighPrint 309 4)
					else
						(self setScript: beginIncense)
					)
				else
					(HighPrint 309 5)
				)
			)
			(
				(or
					(Said
						'spray,squirt,splash/fire,(elemental[<fire]),water,waterbag'
					)
					(Said 'douse,(put<out)/fire,(elemental[<fire])')
					(Said 'throw,use/water,waterbag')
				)
				(cond 
					((<= currentWater 0) (HighPrint 309 6))
					((> (ego distanceTo: fireElemental) 50) (HighPrint 309 7))
					(else
						(if (< (= currentWater (- currentWater 3)) 0)
							(= currentWater 0)
						)
						(self setMotion: 0 following: 1 setScript: douseElemental)
					)
				)
			)
		)
	)
	
	(method (detectMe)
		(HighPrint 309 8)
	)
	
	(method (fetchMe)
		(HighPrint 309 11)
	)
	
	(method (hurtMe param1 param2)
		(switch param2
			(25 (HighPrint 309 9))
			(27 (HighPrint 309 10))
		)
	)
	
	(method (attack)
		(ego hurtScript: getBurned)
		(super attack:)
		(if (not following) (self wander:))
	)
	
	(method (wander)
		(super wander:)
		(localproc_0578 wandering)
		(self setMotion: TryToMoveTo newX newY 500 self)
	)
	
	(method (ignite)
		(gSpareMusic number: 561 loop: 1 vol: 60 play:)
		((littleFire new:) posn: x y init:)
	)
)

(instance fireBase of Code
	(properties)
	
	(method (doit param1 &tmp temp0)
		(= temp0 (param1 x?))
		(BaseSetter param1)
		(param1 brLeft: (- temp0 9) brRight: (+ temp0 9))
	)
)

(instance littleFire of Fire
	(properties
		noun '/fire'
		description {the baby fire}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (and (== x 243) (== y 48))
				(HighPrint 309 12)
			else
				(HighPrint 309 13)
			)
		)
	)
)
