/*************************************************************************
 * SCI Game Header
 *************************************************************************
 * Put all the defines specific to your game in here
 *************************************************************************/

// e.g.
// (define MAIN_SCRIPT			  0)
// (define MENU_ABOUT			$101)

////////////////////////////////////////////////////////
// Elemental status
////////////////////////////////////////////////////////
	(define fireACTIVE	1)
	(define fireCAUGHT	2)
	(define airACTIVE	3)
	(define airCAUGHT	4)
	(define earthACTIVE	5)
	(define earthCAUGHT	6)
	(define waterACTIVE	7)
	(define waterCAUGHT	8)

/////////////////////////////////////////////////////////
//Character Classes
/////////////////////////////////////////////////////////
	(define CLASS_FIGHTER 	0)
	(define CLASS_MAGICUSER 1)
	(define CLASS_WIZARD 	1)
	(define CLASS_THIEF 	2)
	(define CLASS_PALADIN 	3)

/////////////////////////////////////////////////////////
//Ego Moving Modes
/////////////////////////////////////////////////////////
	(define MOVE_NOCHANGE 	-1)
	(define MOVE_WALK 		0)
	(define MOVE_RUN 		1)
	(define MOVE_SNEAK 		2)
	(define MOVE_ONSAURUS	3)
	(define MOVE_LITLAMP	4)

/////////////////////////////////////////////////////////
//Skills
/////////////////////////////////////////////////////////
	(define skSTRENGTH		0)
	(define skINTELLIGENCE 	1)
	(define skAGILITY		2)
	(define skVITALITY 		3)
	(define skLUCK 			4)
	(define skWEAPONUSE 	5)
	(define skPARRY 		6)
	(define skDODGE 		7)
	(define skSTEALTH 		8)
	(define skLOCKPICKING 	9)
	(define skTHROWING 		10)
	(define skCLIMBING 		11)
	(define skMAGIC 		12)
	(define skCOMMUNICATION	13)
	(define skHONOR			14)
	(define skEXPERIENCE 	15)
	(define skHP 			16)
	(define skSP 			17)
	(define skMP 			18)

//Magic Spells
	(define skOPEN 			19)
	(define skDETECTMAGIC 	20)
	(define skTRIGGER 		21)
	(define skDAZZLE 		22)
	(define skZAP 			23)
	(define skCALM 			24)
	(define skFLAMEDART 	25)
	(define skFETCH 		26)
	(define skFORCEBOLT		27)
	(define skLEVITATE		28)
	(define skREVERSAL		29)

/////////////////////////////////////////////////////////
//Inventory
/////////////////////////////////////////////////////////
	(define invBrassCentime			1)
	(define invGoldenDinar 			2)
	(define invFoodRation			3)
	(define invBroadsword			4)
	(define invDagger				5)
	(define invLeatherArmor			6)
	(define invShield				7)
	(define invPieceOfPaper			8)
	(define invSmallRock			9)
	(define invLockPick				10)
	(define invThiefToolKit			11)
	(define invThievesGuildLicense	12)
	(define invPouchOfIncense		13)
	(define invWhirlOfBeard			14)
	(define invChainmailArmor		15)
	(define invMagicRope			16)
	(define invGoldCoin				17)
	(define invHealingPill			18)
	(define invManaPill				19)
	(define invVigorPill			20)
	(define invDispelPotion			21)
	(define invMap					22)
	(define invCompass				23)
	(define invFineSword			24)
	(define invBellows				25)
	(define invFlowerBouquet		26)
	(define invSapphirePin			27)
	(define invGriffinFeather		28)
	(define invScorpionTail			29)
	(define invGhoulClaw			30)
	(define invSoulforge			31)
	(define invPotOfDirt			32)
	(define invBrassLamp			33)
	(define invBasket				34)
	(define invEmptyPot				35)
	(define invCompassionFruit		36)
	(define invWaterskin			37)
	(define invClothBag				38)
	(define invPowderOfBurning		39)
	(define invEOFMembershipBadge	40)
	(define invRaseirianVisa		41)
	(define invContainerOfOil		42)
	(define invWaterElemental		43)
	(define invDjinniRing			44)
	(define invSilkScarf			45) //Unused
	(define invHandMirror			46)
	(define invBlackBird			47)
	(define invPoisonCurePill		48)
	(define invChangeOfClothing		49)
	(define invSaurus				50)
	(define invBagOfSand			51)
	(define invBagOfEarthElemental	52)
	(define invSilverTeaService		53)
	(define invXRayGlasses			54)
	(define invLeatherPurse			55)
	(define invSilverDagger			56)
	(define invEmeraldBowl			57)
	(define invRustyNail			58)
	
/////////////////////////////////////////////////////////
//Event Flags
/////////////////////////////////////////////////////////
	(define EVENT_SAVEENABLED				1)
	(define EVENT_PLAYINGTHEGAME			2)
	(define EVENT_HEROISTHIRSTY				3)
	(define EVENT_HEROISGETTINGHUNGRY		4)
	(define EVENT_HEROISSTARVING			5)
	(define EVENT_CARRYINGTOOMUCH			6)
	(define EVENT_NOSTAMINA					7)
	//Event 8 is unused
	(define VISITED_MONEYCHANGER_1			9)
	(define VISITED_MONEYCHANGER_2			10)
	(define EVENT_MADETHIEFSIGNTODINARZAD	11)
	(define EVENT_OFFEREDBURGLARYJOB		12)
	(define EVENT_KAREEMHOME				13)
	(define EVENT_INSHAPEIR					16)
	(define EVENT_ARMWRESTLED				17)
	(define EVENT_ASTROLOGERGOODFORTUNE		18)
	(define EVENT_ASTROLOGERBADFORTUNE		19)
	(define EVENT_THROWNOUTOFWEAPONSHOP		25)
	(define EVENT_GAVEFEATHERTOHARIK		33)
	(define EVENT_GAVEFRUITTOHARIK			34)
	(define EVENT_GOTPOWDEROFBURNING		37)
	(define EVENT_HAGGLEDISSURBET			38)
	(define VISITED_AZIZA					40)
	(define EVENT_HADTEAWITHAZIZA			41)
	(define EVENT_DISPELLEDBEAST			42)
	(define EVENT_HEARDABOUTJULANAR			44)
	(define EVENT_BOUGHTSAURUS				45)
	(define EVENT_METSHAPEIRGATEGUARD		46)
	(define EVENT_GUARDDESERTWARNING		48)
	(define EVENT_METTIRAM					49)
	(define EVENT_METSASHANAN				50)
	(define EVENT_STOLEBLUEPARROTOIL		55)
	(define EVENT_STOLESILVERDAGGER			59)
	(define EVENT_ATTACKEDDERVISH			70)
	(define EVENT_TALKEDTOSIMBA				71)
	(define EVENT_GOTSOULFORGE				72)
	(define EVENT_MOVEDGRIFFINROCK			73)
	(define EVENT_GAVEEARTHTOJULANAR		76)
	(define EVENT_GAVEWATERTOJULANAR		77)
	(define EVENT_TOLDJULANARABOUTSELF		78)
	(define EVENT_TOLDJULANARABOUTEARTH		79)
	(define EVENT_HUGGEDJULANAR				80)
	(define EVENT_JULANARKNOWSNAME			81)
	(define EVENT_GOTFREEWATERSKIN			83)
	(define EVENT_GOTFREECLOTHBAG			84)
	(define EVENT_GOTBELLOWS				85)
	(define EVENT_PROTECTEDBYREVERSAL		86)
	(define EVENT_LEVITATING				87)
	(define EVENT_LEARNEDABOUTDERVISHMESSAGE	93)
	(define EVENT_BEFREINDEDSHARAF			94)
	(define EVENT_FALLOFFROPE				95)
	(define EVENT_WARPEDBACKTORASEIR		96)
	(define EVENT_UGARTEARRESTED			97)
	//Event 98 is unused
	(define EVENT_MADETHIEFSIGNTOFERRARI	99)
	(define VISITED_RASEIRGATE				100)
	(define VISITED_FORBIDDENCITY			101)
	(define EVENT_FERRARIDJINNSLING			102)	
	(define EVENT_BLOCKEDWINDHOLE			107)
	(define EVENT_METALICHICA				108)
	(define EVENT_ORDEREDDRINKATBLUEPARROT	110)
	(define EVENT_PAIDUGARTEFORINFO			111)
	(define EVENT_BROKEINTOWEAPONSHOP		115)
	(define EVENT_MAGiCLAMPLIT				116)
	(define EVENT_PICKINGLOCK				117)
	(define EVENT_SUFFERINGINLAVAROOM		118)
	(define EVENT_KEAPONSEARCHEDFORITEM		120)
	(define EVENT_PROTECTEDBYPOISONCUREPILL	121)
	(define EVENT_GOTFRUITOFCOMPASSION		122)
	(define EVENT_JULANARTURNEDAROUND		123)
	(define EVENT_JULANARGROWNLEAVES		124)
	(define EVENT_WEARINGXRAYGLASSES		125)
	(define VISITED_GUILDHALL				127)
	(define VISITED_WEAPONSHOP				128)
	(define VISITED_AZIZADOOR				130)
	(define VISITED_ASTROLOGER				131)
	(define VISITED_SHAPEIRPALACEGATES		132)
	//Event 133 is unused
	(define EVENT_METKHAVEEN				134)
	(define EVENT_LOOTEDOMARSPURSE			135)
	(define EVENT_HEROISDEHYDRATED			137)
	(define VISITED_ZAYISHAHSHIDEOUT		138)
	(define EVENT_SIGNEDLOGBOOK				139)
	(define VISITED_ADAVISCHAMBER			140)
	(define VISITED_RASEIRCEREMONIALHALL	141)
	(define EVENT_SAWMAYZUNATALLEY			142)
	(define EVENT_KILLEDGRIFFIN				143)
	(define EVENT_SAWHARPOATALLEY			144)
	(define EVENT_CARAVANREMINDER_DAY_11	145)
	(define EVENT_CARAVANREMINDER_DAY_15	146)
	(define EVENT_TIPPEDBRAZIER				147)
	(define EVENT_GOTKATTAPIN				148)
	(define EVENT_RETURNINGSAURUSTOSTABLE	149)
	(define EVENT_SAURUSESCAPED_DAY_8		150)
	(define EVENT_SAURUSESCAPED_DAY_10		151)
	(define EVENT_PROCLAIMEDHONORLESS		153) //Disqualified from Paladinhood
	(define EVENT_SPAREDWALID				154)
	(define EVENT_SAURUSLOST				155)
	(define EVENT_THROWNOUTOFGUILDHALL		157)
	(define EVENT_INBATTLE					159)
	(define VISITED_GUILDHALLENTRANCE		160)
	(define EVENT_SEENSHEMADANCE			161)
	(define EVENT_OILEDANVIL				164)
	(define EVENT_ISSURISCALMED				165)
	(define EVENT_SLEPTATBLUEPARROT			166)
	//Event 167 is unused
	(define EVENT_LISTENEDTODERVISH			168)
	(define VISITED_OASIS					169)
	(define VISITED_BLUEPARROTINN			171)
	(define EVENT_SAURUSLASTCHANCE			172) //Terminal Stubbornness warning
	(define VISITED_AZIZA_DAY_16			182)
	(define EVENT_TOOKDERVISHBEARD			184)
	(define EVENT_GOTFREEFLOWERS			185)
	(define EVENT_RETURNEDSOULFORGE			186)