;;; Sierra Script 1.0 - (do not remove this comment)
(script# 261)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TargActor)
(use rm260)
(use Motion)
(use Actor)
(use System)

(public
	getUpS 1
	hideInCornerS 2
	proc261_3 3
	getOutS 4
	hideInWardrobeS 5
)

(local
	newDoorR
)
(procedure (proc261_3)
	(DrawFeature smallRug bigRug)
	(if (not (Btst 57)) (teapot init: stopUpd:))
	(doorR init: stopUpd:)
	((= newDoorR (doorR new:))
		loop: 1
		posn: 141 103
		init:
		stopUpd:
	)
)

(instance oilHingesS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo (+ (ego x?) 10) 113 self)
			)
			(1
				(ego setMotion: MoveTo 189 110 self)
			)
			(2
				(ego view: 47 loop: 1 cel: 0 setCycle: CT 1 1 self)
			)
			(3 (= cycles 14))
			(4
				(proc1_19)
				(ego setMotion: MoveTo 135 110 self)
			)
			(5
				(ego view: 47 loop: 0 cel: 0 setCycle: CT 1 1 self)
			)
			(6 (= cycles 14))
			(7
				(Bset 60)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance getUpS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetControl 0)
				(ego setCycle: Beg self)
			)
			(1
				(proc1_19)
				(ego setMotion: MoveTo 280 176 self)
			)
			(2
				(curRoom notify: 0)
				(self dispose:)
			)
		)
	)
)

(instance hideInCornerS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 305 180 self)
				(curRoom notify: 1)
			)
			(1
				(curRoom notify: 2)
				(ego view: 47 cel: 0 setCycle: End self)
			)
			(2
				(SetControl 1)
				(self dispose:)
			)
		)
	)
)

(instance getTeapotS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego inRect: 0 134 84 290)
					(ego setMotion: MoveTo 85 133 self)
				else
					(self cue:)
				)
			)
			(1
				(ego setMotion: MoveTo 99 114 self)
			)
			(2 (ego setHeading: 270 self))
			(3
				(AddToScore 702 3 2)
				(SkillUsed 14 -50)
				(ego get: 53)
				(Bset 57)
				(Bset 13)
				(teapot dispose:)
				(HighPrint 261 0)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance smallRug of PicView
	(properties
		x 31
		y 178
		noun '[<at]/carpet[<little,blue]'
		description {the small rug}
		lookStr {The small rug has an interesting pattern but not enough value to be worth lugging around.}
		view 260
		priority 2
		signal $4010
	)
)

(instance bigRug of PicView
	(properties
		x 213
		y 150
		view 260
		loop 2
		priority 1
		signal $4010
	)
)

(instance hideInWardrobeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 162 111 self)
			)
			(1
				(curRoom notify: 4)
				(if (newDoorR cel?)
					(self changeState: 3)
				else
					(ego view: 261 setLoop: 2 cel: 0 setCycle: CT 2 1)
					(newDoorR setCycle: CT 1 1)
					(doorR setCycle: CT 1 1)
					(= cycles 4)
				)
			)
			(2
				(if (not (Btst 60))
					(HighPrint 261 1)
					(HighPrint 261 2)
				)
				(newDoorR setCycle: End)
				(doorR setCycle: End self)
			)
			(3
				(ego
					view: 261
					cel: 2
					setLoop: 2
					setCycle: End
					setStep: 2 4
					setMotion: MoveTo 162 103
				)
				(= cycles 6)
			)
			(4
				(ego setPri: 3)
				(newDoorR setCycle: Beg)
				(doorR setCycle: Beg self)
			)
			(5
				(newDoorR stopUpd:)
				(doorR stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance openWardrobeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 162 109 self)
			)
			(1
				(ego view: 261 setLoop: 2 cel: 0 setCycle: CT 1 1)
				(newDoorR setCycle: CT 1 1)
				(doorR setCycle: CT 1 1)
				(= cycles 4)
			)
			(2
				(if (not (Btst 60))
					(HighPrint 261 3)
					(HighPrint 261 2)
				)
				(newDoorR cycleSpeed: 2 setCycle: End)
				(doorR cycleSpeed: 2 setCycle: End self)
			)
			(3
				(proc1_19)
				(ego heading: 0 loop: 3)
				(newDoorR stopUpd:)
				(doorR stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance spellWardrobeS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 1)
				(newDoorR setCycle: CT 1 1)
				(doorR setCycle: CT 1 1)
				(= cycles 4)
			)
			(1
				(if (not (Btst 60))
					(HighPrint 261 3)
					(HighPrint 261 2)
				)
				(newDoorR cycleSpeed: 2 setCycle: End)
				(doorR cycleSpeed: 2 setCycle: End self)
			)
			(2
				(newDoorR stopUpd:)
				(doorR stopUpd:)
				(SetInput 0)
				(self dispose:)
			)
		)
	)
)

(instance closeWardrobeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 162 109 self)
			)
			(1
				(ego view: 261 setLoop: 2 cel: 0)
				(newDoorR setCycle: Beg)
				(doorR setCycle: Beg self)
			)
			(2
				(if (not (Btst 60)) (HighPrint 261 4))
				(newDoorR stopUpd:)
				(doorR stopUpd:)
				(proc1_19)
				(ego heading: 0 loop: 3 setHeading: 180)
				(self dispose:)
			)
		)
	)
)

(instance getOutS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(newDoorR setCycle: End self)
				(doorR setCycle: End)
			)
			(1
				(ego
					view: 261
					setPri: -1
					cel: 5
					setLoop: 2
					setCycle: CT 1 1 self
					setMotion: MoveTo 162 111
				)
			)
			(2
				(curRoom notify: 0)
				(ego posn: 162 111 cycleSpeed: 2 setCycle: Beg)
				(newDoorR setCycle: Beg self)
				(doorR setCycle: Beg)
			)
			(3
				(proc1_19)
				(ego loop: 3 heading: 0 setMotion: MoveTo 159 116 self)
			)
			(4
				(if (not (Btst 60)) (HighPrint 261 4))
				(newDoorR stopUpd:)
				(doorR stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance doorR of TargActor
	(properties
		x 185
		y 103
		noun '/armoire,(door[<armoire])'
		description {the wardrobe doors}
		lookStr {The wardrobe doors are beautifully carved, but the hinges look a bit rusty.}
		view 261
		signal $4000
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'grease/hinge,door,armoire')
					(Said 'use/grease')
				)
				(cond 
					((< (ego x?) 70) (HighPrint 261 5))
					((not [invNum 42]) (HighPrint 261 6))
					(else
						(doorR
							lookStr: {The wardrobe doors are beautifully carved, but well-worn.}
						)
						(newDoorR
							lookStr: {The wardrobe doors are beautifully carved, but well-worn.}
						)
						(AddToScore 706 3 2)
						(proc260_1 oilHingesS)
					)
				)
			)
			((Said 'look,examine/hinge')
				(ego setMotion: 0)
				(cond 
					(
						(not
							(if (and (< 131 (ego x?)) (< (ego x?) 196))
								(< 124 (ego x?))
							)
						)
						(HighPrint 261 7)
					)
					((Btst 60) (ego loop: 3) (SetUpEgo) (HighPrint 261 8))
					(else (ego loop: 3) (SetUpEgo) (HighPrint 261 9))
				)
			)
			((Said 'search/armoire')
				(cond 
					(
						(or
							(== (curRoom notify:) 4)
							(and
								(< 146 (ego x?))
								(< (ego x?) 180)
								(< (ego y?) 124)
								cel
							)
						)
						(if (Btst 58)
							(HighPrint 261 10)
						else
							(HighPrint 261 11)
							(AddToScore 703 3 2)
							(Bset 58)
							(Bset 13)
							(SkillUsed 14 -50)
							(ego get: 57)
						)
					)
					(
						(and
							(< 146 (ego x?))
							(< (ego x?) 180)
							(< (ego y?) 124)
						)
						(HighPrint 261 12)
					)
					(else (PrintNotCloseEnough))
				)
			)
			(
				(and
					(< 146 (ego x?))
					(< (ego x?) 180)
					(< (ego y?) 124)
					(Said 'close,shut[/armoire]')
				)
				(cond 
					((== cel 0) (HighPrint 261 13))
					((ego script?) (HighPrint 261 14))
					(else (ego setScript: closeWardrobeS))
				)
			)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(3
				(if (or (== cel 0) (== (curRoom notify:) 4))
					(HighPrint 261 13)
				else
					(ego setScript: closeWardrobeS)
				)
			)
			(2
				(cond 
					((== (curRoom notify:) 4) (ego setScript: getOutS))
					(cel (PrintAlreadyDoneThat))
					((ego script?) (HighPrint 261 14))
					(else (ego setScript: openWardrobeS))
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
	
	(method (hurtMe)
		(Die 1 261 15 80 {No Stealing Aloud!})
	)
	
	(method (openMe)
		(if cel
			(PrintAlreadyDoneThat)
		else
			(self setScript: spellWardrobeS)
		)
	)
)

(instance teapot of TargActor
	(properties
		x 79
		y 77
		noun '/samovar,service,(pan<tea)'
		description {the silver tea service}
		lookStr {The tea service is made of silver and looks very valuable.}
		view 260
		loop 3
		priority 8
		signal $1810
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(if (Btst 57)
				(PrintAlreadyDoneThat)
			else
				(ego setScript: getTeapotS)
			)
		else
			(super doVerb: theVerb)
		)
	)
	
	(method (fetchMe)
		(AddToScore 702 3 2)
		(SkillUsed 14 -50)
		(ego get: 53)
		(Bset 57)
		(Bset 13)
		(return 1)
	)
)
