;;; Sierra Script 1.0 - (do not remove this comment)
(script# 116)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Full)
(use Intrface)
(use Motion)
(use Actor)
(use System)

(public
	omar 0
	giveReward 1
)

(local
	local0
	[local1 38] = [0 26 28 31 33 35 37 39 41 43 45 47 49 51 53 55 57 2 72 59 61 63 65 67 69 72 74 76 78 80 69 82 78 2 2 2 2 2]
	[local39 16] = [4 '//jaafar' 6 '//rakeesh' 8 '//paladin' 80 '//bazaar,courtyard' 20 '//hero' 22 '//dark,blackness' 84 '//poem']
)
(instance giveReward of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 100 160 self)
			)
			(1
				(FaceObject ego omar)
				(if (== currentDay 11)
					(AddToScore 600 3)
					(omar setScript: omarJaAfarTalk self 12)
				else
					(AddToScore 601 3)
					(AddToScore 602 3)
					(omar setScript: omarJaAfarTalk self 16)
				)
				(SkillUsed 14 50)
				(Bclr 158)
			)
			(2
				(jaAfar loop: 2 setCycle: End)
				(ego setMotion: MoveTo 105 142 self)
			)
			(3
				(if (== currentDay 11)
					(HighPrint 116 0)
					(ego get: 2 50)
				else
					(HighPrint 116 1)
					(ego get: 2 100)
				)
				(= cycles 12)
			)
			(4
				(FaceObject ego (ScriptID 100 1))
				((ScriptID 100 1)
					setLoop: 1
					cycleSpeed: 4
					setCycle: Full 1 self
				)
				(proc1_32 (ScriptID 100 3) 20)
			)
			(5 (self dispose:))
		)
	)
)

(instance omarJaAfarTalk of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(jaAfar setCycle: End)
				(Say omar self 106 register)
			)
			(1
				(if (OneOf register 28 69)
					(Say omar self 106 (++ register))
				else
					(self cue:)
				)
				(++ register)
			)
			(2 (jaAfar setCycle: Beg self))
			(3
				(omar loop: 3 setCycle: End)
				(Say jaAfar self 106 register)
			)
			(4 (omar setCycle: Beg self))
			(5
				(omar setLoop: 2)
				(self dispose:)
			)
		)
	)
)

(instance OWindow of TopWindow
	(properties
		brLeft 155
		brBottom 200
	)
)

(instance JWindow of TopWindow
	(properties
		brBottom 200
		brRight 110
	)
)

(instance omar of Talker
	(properties
		x 148
		y 107
		description {Omar the Poet}
		lookStr {It is Omar the Poet.}
		view 106
		loop 2
		priority 8
		signal $4010
		illegalBits $0000
		tLoop 2
		talkSpeed 1
		myName '//omar,poet'
		title {Omar:}
		color 5
		msgFile 106
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow OWindow)
		(omarBody init:)
		(jaAfar init:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'gave,replace/back,purse,alm')
				(cond 
					((not (ego use: 55)) (Say self 116 2))
					((Btst 135)
						(SkillUsed 14 -100)
						(ProclaimedHonorless)
						(self setScript: omarJaAfarTalk 0 14)
					)
					(else
						(AddToScore 675 7 3)
						(SkillUsed 14 50)
						(self setScript: omarJaAfarTalk 0 18)
					)
				)
			)
			(
				(and
					(not
						(if (== ((ScriptID 100 2) x?) 37)
							(== ((ScriptID 100 2) y?) 163)
						)
					)
					(Said 'thank')
				)
				(if (<= (++ roomThanks) 2)
					(SkillUsed 14 10)
					(SkillUsed 13 5)
				)
				(SkillUsed 14 2)
				(self setScript: omarJaAfarTalk 0 24)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local39 param1])
	)
	
	(method (atGen param1)
		(return [local1 param1])
	)
	
	(method (showText param1)
		(cond 
			((and (not local0) (< global257 global277)) (self setScript: omarJaAfarTalk 0 10) (= local0 1))
			((< global257 global277) (HighPrint 116 3))
			(else (self setScript: omarJaAfarTalk 0 param1))
		)
	)
	
	(method (talk &tmp theSeconds theS1 theS2 [temp3 500] [temp503 4] temp507)
		(switch state
			(1 (= theS1 s1) (= theS2 s2))
			(2 (= theS1 s3) (= theS2 s4))
			(3 (= theS1 s5) (= theS2 s6))
			(4 (= theS1 s7) (= theS2 s8))
		)
		(cond 
			((u< theS1 1000) (GetFarText theS1 theS2 @temp3))
			(theS1 (StrCpy @temp3 theS1))
		)
		(if (< colorCount 8)
			(tWindow color: 0 back: 15)
		else
			(tWindow color: color back: back)
		)
		(TextSize @[temp503 0] @temp3 userFont 0)
		(= temp507 (+ [temp503 3] 30))
		(Print
			@temp3
			#font
			userFont
			#title
			title
			#window
			tWindow
			#at
			(- 300 temp507)
			0
			#width
			temp507
			#mode
			0
			#dispose
		)
		(if (< (= theSeconds (/ (StrLen @temp3) 9)) 4)
			(= theSeconds 4)
		)
		(if suckBlueFrog
			(= endCycles 0)
		else
			(= endCycles (+ 1 (* gSeconds 1)))
		)
		(= cycles 0)
		(= seconds theSeconds)
	)
)

(instance omarBody of View
	(properties
		x 148
		y 127
		view 106
		priority 8
		signal $0010
	)
)

(instance jaAfar of Talker
	(properties
		x 110
		y 127
		description {Ja'Afar}
		lookStr {It is Omar's companion and translator, Ja'Afar.}
		view 108
		priority 8
		signal $0010
		illegalBits $0000
		tLoop 1
		talkSpeed 1
		myName '//jaafar'
		title {Ja'Afar:}
		color 4
		msgFile 106
	)
	
	(method (init)
		(= tWindow JWindow)
		(super init: &rest)
	)
	
	(method (handleEvent pEvent)
		(return
			(cond 
				((Said 'ask//jaafar') (self showText: 4))
				((super handleEvent: pEvent) 0)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local39 param1])
	)
	
	(method (atGen param1)
		(return [local1 param1])
	)
	
	(method (showText param1)
		(cond 
			((and (not local0) (< global257 global277)) (self setScript: omarJaAfarTalk 0 10) (= local0 1))
			((< global257 global277) (HighPrint 116 3))
			(else (self setScript: omarJaAfarTalk 0 param1))
		)
	)
	
	(method (talk &tmp theSeconds theS1 theS2 [temp3 500] [temp503 4] temp507)
		(switch state
			(1 (= theS1 s1) (= theS2 s2))
			(2 (= theS1 s3) (= theS2 s4))
			(3 (= theS1 s5) (= theS2 s6))
			(4 (= theS1 s7) (= theS2 s8))
		)
		(cond 
			((u< theS1 1000) (GetFarText theS1 theS2 @temp3))
			(theS1 (StrCpy @temp3 theS1))
		)
		(if (< colorCount 8)
			(tWindow color: 0 back: 15)
		else
			(tWindow color: color back: back)
		)
		(TextSize @[temp503 0] @temp3 userFont 0)
		(= temp507 (+ [temp503 3] 30))
		(Print
			@temp3
			#font
			userFont
			#title
			title
			#window
			tWindow
			#at
			0
			0
			#width
			temp507
			#mode
			1
			#dispose
		)
		(if (< (= theSeconds (/ (StrLen @temp3) 9)) 4)
			(= theSeconds 4)
		)
		(if suckBlueFrog
			(= endCycles 0)
		else
			(= endCycles (+ 1 (* gSeconds 1)))
		)
		(= cycles 0)
		(= seconds theSeconds)
	)
)
