;;; Sierra Script 1.0 - (do not remove this comment)
(script# 1)
(include sci.sh) (include game.sh)
(use Main)
(use Intrface)
(use Music)
(use User)

(public
	UnlockEgo 0
	LockEgo 1
	FaceObject 2
	IsObjectOnControl 3
	proc1_4 4
	proc1_5 5
	Btst 6
	Bset 7
	Bclr 8
	proc1_9 9
	MakeThiefSign 10
	DisposeDialog 11
	IsHeapFree 12
	HighPrint 13
	PrintWarning 14
	proc1_15 15
	PrintTimedMessage 16
	proc1_17 17
	proc1_18 18
	proc1_19 19
	ChangeEgoWalk 20
	proc1_21 21
	proc1_22 22
	GetMaxWeight 23
	Die 24
	AskQuit 25
	AskRestart 26
	PauseGame 27
	AboutGame 28
	PrintHelp 29
	proc1_30 30
	proc1_31 31
	proc1_32 32
	SetControl 33
	SetInput 34
	proc1_35 35
)

(local
	local0
	[local1 4]
	[local5 33] = [0 '//shapeir' '//raseir' '//djinn' '//elemental<fire' '//elemental<water' '//elemental<air' '//elemental<earth' '//elemental' '//monster' '//magic,spell' '//harun' '//emir' '//wit,institute,(club<magic,technocery)' '//castle,castle' '//caravan' '//desert' '//hill,hill' '//alm,alm,alm,gold,dinar' '//thief,(club<thief)' '//(hall<club),club' '//hotel,bar,(tail,fable,parrot<catperson,tail,fable,blue)' '//weather,climate' '//fount' '//rumor,secret' '//dinarzad,changer' '//astrologer,abu' '//enchantress,aziza' '//poet,omar' '//merchant' '//catperson,cat' '//dervish,ermit' '//identity']
	[local38 58] = ['/cent[<brass]' '/dinar[<golden]' '/food,provision' '/blade[<broad]' '/dagger[<!*]' '/leather,armor' '/shield' '/note,bulletin,scroll' '/boulder[<little]' '/lockpick[<lock]' '/kit[<thief,implement]' '/certificate[<thief,club]' '/frankincense,pouch' '/beard,whirl' '/chainmail,(chainmail<chain)' '/rope[<magic]' '/gold,(alm[<gold])' '/pill<healing,health' '/pill<mana,magic' '/pill<energy,stamina' '/potion<disenchant,disenchant' '/map' '/compass' '/blade[<fine]' '/bellows' '/bouquet,bouquet' '/pin,needle[<sapphire]' '/feather[<griffin]' '/tail[<scorpion]' '/claw[<ghoul]' '/soulforge,forge[<soul]' '/pan/dirt' '/lamp[<brass]' '/basket' '/pan<empty' '/fruit<compassion' '/(water[<!*]),waterbag,(skin<water)' '/bag<cloth' '/powder[<burn]' '/badge[<eof,member,secret]' '/visa' '/grease,(contain,bottle<grease)' '/(water<magic,elemental),(elemental<water)' '/ring[<djinn]' '/scarf[<silk]' '/mirror[<hand]' '/bird,falcon[<black]' '/pill<cure,poison' '/clothes' '/saurii' '/sand,bag[/sand]' '/(bag[<earth,elemental]),(earth,dirt<magic,elemental),(elemental<earth)[/earth,elemental]' '/samovar,(pan,service[<tea,silver])' '/glasses[<ray,fakir,ali,(fakir<ali)]' '/purse[<leather]' '/dagger<silver' '/bowl[<emerald,silver]' '/nail[<rusty]']
)
(procedure (UnlockEgo)
	(SetControl 1)
	(SetInput 1)
)

(procedure (LockEgo param1)
	(if (and argc param1)
		(= global161 1)
		(= isEgoLocked 1)
	)
	(SetControl 0)
	(SetInput 0)
)

(procedure (FaceObject param1 param2 param3 param4 &tmp temp0)
	(= temp0
		(GetAngle
			(param1 x?)
			(param1 y?)
			(param2 x?)
			(param2 y?)
		)
	)
	(if (and (>= argc 3) param3)
		(param2 setHeading: (+ 180 temp0))
	)
	(if (>= argc 4)
		(param1 setHeading: temp0 param4)
	else
		(param1 setHeading: temp0)
	)
)

(procedure (IsObjectOnControl param1 param2 param3 &tmp temp0)
	(if (= temp0 (MousedOn param1 param2 param3))
		(param2 claimed: 1)
	)
	(return temp0)
)

(procedure (proc1_4 param1 param2 param3 param4 param5 param6)
	(return
		(if
			(and
				(<= param3 param1)
				(< param1 param5)
				(<= param4 param2)
			)
			(< param2 param6)
		else
			0
		)
	)
)

(procedure (proc1_5 param1 param2 param3)
	(return (+ param2 (mod (- param1 1) (+ (- param3 param2) 1))))
)

(procedure (Btst flagEnum)
	(return
		(&
			[gameFlags (/ flagEnum 16)]
			(>> $8000 (mod flagEnum 16))
		)
	)
)

(procedure (Bset flagEnum &tmp oldState)
	(= oldState (Btst flagEnum))
	(= [gameFlags (/ flagEnum 16)]
		(|
			[gameFlags (/ flagEnum 16)]
			(>> $8000 (mod flagEnum 16))
		)
	)
	(return oldState)
)

(procedure (Bclr flagEnum &tmp oldState)
	(= oldState (Btst flagEnum))
	(= [gameFlags (/ flagEnum 16)]
		(&
			[gameFlags (/ flagEnum 16)]
			(~ (>> $8000 (mod flagEnum 16)))
		)
	)
	(return oldState)
)

(procedure (proc1_9)
	(return (+ 50 (Random 0 75) (Random 0 75)))
)

(procedure (MakeThiefSign)
	(return
		(if (or [skills 9] [skills 8])
			(HighPrint 1 10)
			(HighPrint 1 11)
			(return 1)
		else
			(switch (Random 0 3)
				(0 (HighPrint 1 12))
				(1 (HighPrint 1 13))
				(2
					(HighPrint 1 14)
					(HighPrint 1 15)
				)
				(3 (HighPrint 1 16))
			)
			(return 0)
		)
	)
)

(procedure (DisposeDialog)
	(if modelessDialog (modelessDialog dispose:))
)

(procedure (IsHeapFree param1)
	(return (u> (MemoryInfo 0) param1))
)

(procedure (HighPrint param1)
	(PrintTimedMessage param1 &rest 67 -1 12)
)

(procedure (PrintWarning param1 &tmp temp0)
	(localproc_0342 0 param1 &rest)
	(= temp0 [local1 2])
	(PrintTimedMessage param1 &rest 67 -1 (- 180 temp0))
)

(procedure (proc1_15 param1 param2)
	(if (not param1)
		(localproc_0342 1 param2 &rest)
		(if (< (= param1 (/ local0 9)) 3) (= param1 3))
	)
	(PrintTimedMessage param2 &rest 67 -1 12 103 25 param1)
)

(procedure (PrintTimedMessage param1 param2 &tmp temp0)
	(DisposeDialog)
	(localproc_0342 0 param1 param2)
	(= temp0 (if (> [local1 2] 24) 300 else 0))
	(cond 
		((== argc 1) (Print param1 #at -1 -1 #width temp0 #mode 1))
		((u< param1 1000) (Print param1 param2 67 -1 -1 70 temp0 30 1 &rest))
		(else (Print param1 #at -1 -1 #width temp0 #mode 1 param2 &rest))
	)
)

(procedure (proc1_17 param1 param2)
	(param1 param2: &rest)
)

(procedure (proc1_18 &tmp temp0)
	(= temp0 1)
	(while (< temp0 33)
		(if (Said [local5 temp0]) (break))
		(++ temp0)
	)
	(if (>= temp0 33) (= temp0 0))
	(return temp0)
)

(procedure (proc1_19)
	(ChangeEgoWalk -1 0)
	(ego
		setLoop: -1
		setLoop: gEgoGL
		setPri: -1
		setMotion: 0
		setAvoider: 0
		illegalBits: -32768
		baseSetter: gEgoBase
		ignoreHorizon:
		ignoreActors: 0
	)
)

(procedure (ChangeEgoWalk theEgoWalkMode param2 &tmp temp0 temp1 temp2)
	(if param2
		(cond 
			((not (User canControl:)) (HighPrint 1 0) (return))
			((== egoWalkMode theEgoWalkMode) (HighPrint 1 1) (return))
		)
	)
	(if (!= theEgoWalkMode -1)
		(= egoWalkMode theEgoWalkMode)
	)
	(= temp1 0)
	(= temp2 4)
	(ego cycleSpeed: 0 moveSpeed: 0)
	(switch egoWalkMode
		(1
			(ego view: 1 setStep: 6 3 setCycle: gEgoSW 4)
		)
		(2
			(ego view: 2 setStep: 2 2 setCycle: gEgoW)
		)
		(3
			(ego view: 12 setStep: 5 3 setCycle: gEgoW)
		)
		(4
			(ego view: 585 setStep: 4 2 setCycle: gEgoW)
		)
		(else 
			(ego view: temp1 setStep: 4 2 setCycle: gEgoSW temp2)
		)
	)
)

(procedure (proc1_21 param1 &tmp temp0 temp1)
	(= temp0 0)
	(while (< temp0 58)
		(if (Said [local38 temp0]) (break))
		(++ temp0)
	)
	(if (> (++ temp0) 58) (param1 claimed: 1) (= temp0 0))
	(return temp0)
)

(procedure (proc1_22 &tmp temp0 temp1)
	(= temp1 1)
	(= temp0 0)
	(while (<= temp1 58)
		(= temp0 (+ temp0 (* [invNum temp1] [invWeight temp1])))
		(++ temp1)
	)
	(= temp0
		(/ (+ (= temp0 (+ temp0 (* currentWater 12))) 59) 60)
	)
)

(procedure (GetMaxWeight)
	(return (+ 40 (/ [skills 0] 2)))
)

(procedure (Die param1 param2 &tmp temp0)
	(asm
		pushi    0
		call     UnlockEgo,  0
		pushi    1
		pushi    100
		callk    Wait,  2
		ldi      999
		sag      normalCursor
		pushi    #setCursor
		pushi    2
		push    
		pushi    1
		lag      theGame
		send     8
		pushi    #eachElementDo
		pushi    1
		pushi    145
		lag      sounds
		send     6
		lag      cSoundDeath
		bnt      code_0697
		pushi    #number
		pushi    1
		push    
		pushi    63
		pushi    1
		pushi    15
		pushi    6
		pushi    1
		pushi    1
		pushi    42
		pushi    0
		lag      gMiscMusic
		send     22
code_0697:
		lap      param1
		not     
		bnt      code_06c5
		pushi    11
		&rest    param2
		pushi    70
		pushi    250
		pushi    81
		lofsa    {Restore}
		push    
		pushi    1
		pushi    81
		lofsa    { Restart_}
		push    
		pushi    2
		pushi    81
		lofsa    { Quit_}
		push    
		pushi    3
		calle    Print,  22
		sat      temp0
		jmp      code_075d
code_06c5:
		lsg      sillyClowns
		ldi      0
		eq?     
		bt       code_06df
		lsg      sillyClowns
		ldi      2
		eq?     
		bnt      code_070e
		pushi    2
		pushi    0
		pushi    1
		callk    Random,  4
		not     
		bnt      code_070e
code_06df:
		pushi    15
		&rest    param2
		pushi    70
		pushi    250
		pushi    81
		lofsa    {Restore}
		push    
		pushi    1
		pushi    81
		lofsa    { Restart_}
		push    
		pushi    2
		pushi    81
		lofsa    { Quit_}
		push    
		pushi    3
		pushi    82
		pushi    998
		pushi    2
		pushi    0
		calle    Print,  30
		sat      temp0
		jmp      code_075d
code_070e:
		pushi    6
		pushi    1
		pushi    2
		pushi    0
		pushi    1
		callk    Random,  4
		push    
		pushi    7
		pushi    1
		pushi    0
		pushi    178
		pushi    1
		pushi    6
		ldi      1
		eq?     
		bnt      code_072d
		ldi      20
		jmp      code_072f
code_072d:
		ldi      10
code_072f:
		push    
		lag      gDeathIcon
		send     18
		pushi    13
		&rest    param2
		pushi    70
		pushi    250
		pushi    81
		lofsa    {Restore}
		push    
		pushi    1
		pushi    81
		lofsa    { Restart_}
		push    
		pushi    2
		pushi    81
		lofsa    { Quit_}
		push    
		pushi    3
		pushi    82
		lsg      gDeathIcon
		calle    Print,  26
		sat      temp0
code_075d:
		lst      temp0
		dup     
		ldi      1
		eq?     
		bnt      code_0770
		pushi    #restore
		pushi    0
		lag      theGame
		send     4
		jmp      code_0790
code_0770:
		dup     
		ldi      2
		eq?     
		bnt      code_0782
		pushi    #restart
		pushi    0
		lag      theGame
		send     4
		jmp      code_0790
code_0782:
		dup     
		ldi      3
		eq?     
		bnt      code_0790
		ldi      1
		sag      quit
		jmp      code_0794
code_0790:
		toss    
		jmp      code_0697
code_0794:
		ret     
	)
)

(procedure (AskQuit)
	(gDeathIcon loop: 2 cel: 0)
	(= quit
		(Print
			1
			2
			#title
			{If it's time to split...}
			#button
			{Quit}
			1
			#button
			{Don't Quit}
			0
			#icon
			gDeathIcon
			4
			0
		)
	)
)

(procedure (AskRestart &tmp temp0)
	(= temp0 (Sound pause: 1))
	(if
		(or
			suckBlueFrog
			(Print
				1
				3
				#button
				{Restart}
				1
				#button
				{Continue}
				0
				#icon
				998
				1
				0
			)
		)
		(theGame restart:)
	else
		(Sound pause: temp0)
	)
)

(procedure (PauseGame &tmp temp0)
	(= temp0 (Sound pause: 1))
	(Print
		1
		4
		#title
		{Game Paused}
		#icon
		998
		0
		0
		#button
		{Let's be glorious}
		1
	)
	(Sound pause: temp0)
)

(procedure (AboutGame &tmp [temp0 300])
	(gCWin color: 0 back: 15)
	(if (>= colorCount 8) (gCWin back: 12))
	(Print
		(Format @temp0 1 5)
		#title
		{ Quest for Glory 2:__Trial By Fire_}
		#width
		240
		#mode
		1
		#font
		smallFont
		#at
		-1
		20
		#window
		gCWin
	)
	(Print
		(Format @temp0 1 6 version)
		#title
		{ Quest for Glory 2:__Trial By Fire_}
		#width
		240
		#mode
		1
		#font
		smallFont
		#at
		-1
		20
		#window
		gCWin
	)
	(Print
		(Format @temp0 1 7)
		#title
		{ Quest for Glory 2:__Trial By Fire_}
		#width
		240
		#mode
		1
		#font
		smallFont
		#at
		-1
		20
		#window
		gCWin
	)
	(Print
		(Format @temp0 1 8)
		#title
		{And last, but not least...}
		#mode
		1
		#width
		180
		#font
		smallFont
		#at
		-1
		20
		#window
		gCWin
	)
)

(procedure (PrintHelp)
	(Print 1 9 #font smallFont)
)

(procedure (proc1_30 param1 param2 &tmp temp0 temp1)
	(= temp1 -32768)
	(= temp0 15)
	(if argc
		(= temp0 param1)
		(if (>= argc 2) (= temp1 param2))
	)
	(return
		(&
			(OnControl
				4
				(- (ego x?) temp0)
				(- (ego y?) temp0)
				(+ (ego x?) temp0)
				(+ (ego y?) temp0)
			)
			temp1
		)
	)
)

(procedure (proc1_31)
	(features add: &rest eachElementDo: #init doit:)
)

(procedure (proc1_32 param1 param2 param3 &tmp temp0)
	(= temp0
		(if (> argc 2) (Random param2 param3) else param2)
	)
	(param1 setReal: param1 temp0)
)

(procedure (SetControl param1 &tmp temp0)
	(= temp0 0)
	(cond 
		(param1
			(if (not global161) (User canControl: 0) (= temp0 1))
			(if (< argc 2) (ego setMotion: 0))
			(++ global161)
		)
		((<= (-- global161) 0) (= global161 0) (= temp0 1) (User canControl: 1))
	)
	(if temp0 (proc1_35))
)

(procedure (SetInput param1 &tmp temp0)
	(= temp0 0)
	(cond 
		(param1
			(if (not isEgoLocked)
				(User canInput: 0)
				(SetMenu 1289 112 0)
				(SetMenu 1290 112 0)
				(= temp0 1)
			)
			(++ isEgoLocked)
		)
		((<= (-- isEgoLocked) 0)
			(= isEgoLocked 0)
			(= temp0 1)
			(SetMenu 1289 112 1)
			(SetMenu 1290 112 1)
			(User canInput: 1)
		)
	)
	(if temp0 (proc1_35))
)

(procedure (proc1_35 param1 param2 &tmp theWaitCursor temp1)
	(= temp1 1)
	(cond 
		((and global161 isEgoLocked) (= theWaitCursor waitCursor))
		(global161 (= theWaitCursor gTheGOldNormCursor_2))
		(isEgoLocked (= theWaitCursor gTheGOldNormCursor_3))
		(else (= theWaitCursor normalCursor) (= temp1 (HaveMouse)))
	)
	(if argc
		(theGame setCursor: theWaitCursor temp1 param1 param2)
	else
		(theGame setCursor: theWaitCursor temp1)
	)
)

(procedure (localproc_0342 param1 param2 &tmp temp0 [temp1 500])
	(if (u< (= temp0 param2) 1000)
		(= temp0 @temp1)
		(Format @temp1 param2 &rest)
	)
	(if param1
		(= local0 (StrLen temp0))
	else
		(TextSize @[local1 0] temp0 userFont 0)
	)
)
