;;; Sierra Script 1.0 - (do not remove this comment)
(script# 65)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use ProjClient)
(use SpellScript)
(use System)

(public
	proc65_0 0
	CastSpell 1
	proc65_2 2
	proc65_3 3
)

(local
	[local0 6] = [32 51 39 9 5 16]
	[local6 6] = [{any dirt} {any sand} {any powder} {a rock} {a throwing knife} {the rope}]
	[local12 13] = ['/open,open,(spell<open,open)' '/detect,(spell,magic<detect),(spell<magic<detect)' '/trigger,(spell<trigger)' '/dazzle,(spell<dazzle)' '/zap,(spell<zap)' '/calm,(spell<calm)' '/flame,fire,dart,fireball,(spell<flame,fire,dart,fireball)' '/fetch,(spell<fetch)' '/force,bolt,(spell<force,bolt)' '/levitate,fly,(spell<levitate,fly)' '/reversal,reflection,mirror,(spell<reversal,reflection,mirror)']
)
(procedure (proc65_0 param1 &tmp temp0 temp1)
	(= temp0 0)
	(while (< temp0 11)
		(if (Said [local12 temp0]) (break))
		(++ temp0)
	)
	(if (>= temp0 11)
		(param1 claimed: 1)
		(= temp0 0)
	else
		(= temp0 (+ temp0 19))
	)
	(return temp0)
)

(procedure (CastSpell param1 &tmp temp0 temp1)
	(= temp1 0)
	(cond 
		((not param1) (HighPrint 65 0))
		((not [skills 12]) (HighPrint 65 1))
		((not (ego knows: param1)) (HighPrint 65 2))
		((and gGDftSC (not (gGDftSC doit: param1))))
		((< [skills 18] [spellCost (- param1 19)]) (HighPrint 65 3))
		(else
			(TestSkill param1 0)
			(ReduceMP [spellCost (- param1 19)])
			(= temp1 1)
		)
	)
	(return temp1)
)

(procedure (proc65_2 param1 param2 param3 param4 param5 &tmp temp0 temp1 newSpellScript [temp3 40])
	(= temp1 (= temp0 0))
	(if (>= argc 3)
		(= temp0 param4)
		(if (>= argc 4) (= temp1 param5))
	)
	(if (== curRoomNum 640) (= temp0 (+ temp0 200)))
	(cond 
		(
			(and
				(OneOf param1 20 24 22)
				(== (curRoom picture?) 700)
				(proc1_30 8 (ego illegalBits?))
			)
			(HighPrint 65 4)
			(return 0)
		)
		((== param1 28)
			(cond 
				(
					(and
						(!= curRoomNum 390)
						(proc1_30 15 (ego illegalBits?))
					)
					(HighPrint 65 4)
					(return 0)
				)
				((not (CastSpell param1)) (return 0))
				(else (param2 setScript: (ScriptID 62 0) param3) (return 1))
			)
		)
		((not (OneOf param1 1 2 3 4 5 6)) (if (not (CastSpell param1)) (return 0)))
		((and gGDftSC (not (gGDftSC doit: param1))) (return 0))
		((not (ego has: [local0 (- param1 1)]))
			(HighPrint (Format @temp3 65 5 [local6 (- param1 1)]))
			(return 0)
		)
		((== param1 1)
			(if global293
				(if (not (mod (-- global293) 6))
					(ego use: 32)
					(ego get: 35)
				)
			else
				(HighPrint 65 6)
				(return 0)
			)
		)
		((== param1 2)
			(if global318
				(if (not (mod (-- global318) 9))
					(ego use: 51)
					(ego get: 38)
				)
			else
				(HighPrint 65 7)
				(return 0)
			)
		)
		((== param1 3)
			(if (not (ego has: 39))
				(HighPrint 65 8)
				(return 0)
			else
				(ego use: 39)
			)
		)
		((== param1 6)
			(cond 
				(
					(and
						(!= curRoomNum 390)
						(proc1_30 15 (ego illegalBits?))
					)
					(HighPrint 65 4)
					(return 0)
				)
				((ego script?) (HighPrint 65 9) (return 0))
				(else
					(if (== magicRopeDuration 10) (HighPrint 65 10))
					(if (== magicRopeDuration 1) (HighPrint 65 11))
					(param2 setScript: (ScriptID 61 2) param3)
					(return 1)
				)
			)
		)
		(else (ego use: [local0 (- param1 1)]))
	)
	(switch param1
		(4 (++ temp1))
		(5
			(= temp1 (+ temp1 5 (/ [skills 0] 10)))
		)
		(25
			(= temp1 (+ temp1 5 (/ [skills 25] 3)))
		)
		(27
			(= temp1 (+ temp1 3 (/ [skills 27] 4)))
		)
	)
	(if (OneOf param1 20 23 24 22 29)
		((= newSpellScript (SpellScript new:)) type: param1)
	else
		((= newSpellScript (ProjScript new:))
			type: param1
			hitBonus: temp0
			damage: temp1
		)
	)
	(param2 setScript: newSpellScript param3)
	(return 1)
)

(procedure (proc65_3)
	(proc65_2 &rest)
)
