;;; Sierra Script 1.0 - (do not remove this comment)
(script# 130)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use Talker)
(use Stage)
(use Feature)
(use ForCount)
(use LoadMany)
(use Extra)
(use Motion)
(use Actor)
(use System)

(public
	rm130 0
)

(local
	[local0 100]
	[newACenser 8]
	[newASmoke 8]
	[local116 8] = [133 140 148 155 170 177 184 192]
	[local124 8] = [62 68 73 79 79 73 68 62]
	[local132 8] = [6 5 8 7 8 7 6 5]
	local140
	local141
	local142
	local143
	local144 =  20
	local145 =  70
	local146
	local147
	local148
	local149
	[local150 38] = [1 2 3 4 5 6 7 8 9 10 11 12 13 0 14 0 15 0 16 0 17 18 19 20 21 22 23 24 0 25 26 0 27]
	[local188 64] = [28 '//frankincense,frankincense' 30 '//(powder[<burn]),burn,powder' 34 '//pill<mana,magic' 35 '//energy,(pill<energy,stamina)' 36 '//pill<healing,health' 37 '//poison,cure,(pill<poison,cure)' -3 '//potion<disenchant' -5 '//cost<potion[<disenchant]' -4 '//cost<powder,burn' 33 '//potion' 38 '//pill,merchandise,cost' 39 '//water' 40 '//compassion,fruit' 41 '//plant' 43 '//component' 44 '//scorpion,venom' 45 '//drug' 46 '//griffin,feather' 47 '//victim,hair,fur' 49 '//prize,bulletin,courage' 50 '//ghoul,claw' 51 '//experiment' 52 '//capture' 53 '//grease' 54 '//lamp,brass' 56 '//apothecary,shop' 57 '//healing' 58 '//mana' 59 '//skull,book,bottle,urn,pan,hook,censer' -1 '//flame,fire' -2 '//earth']
	[local252 11] = [{a Doggie dish for a Fire Elemental.} {Halloween candy.} {Old Grandpaw's High-Risk Moonshine.} {Eye of Newt (does Wayne know about this?)} {10-20-40 weight.} {leftover cooking grease.} {the kind of fiery spices that are guaranteed to reduce taste buds to ash.} {a collection of collectible cologne bottles.} {burnt offerings.} {great green gobs of greasy grimy gopher guts.} {a small quantity of "Shake 'n' Bake"}]
	[local263 11] = [{"Creative Accounting for Left Brains and Numerilexics."} {"How to Build Your Own Brazier."} {"Elementary Elementals."} {"Herb's Herbs."} {"How to Make Pills Pay the Bills."} {"The Pizza Elemental: Fact or Fiction?."} {"By the Time I Am a Phoenix, I'll be Rising."} {"To Pill a Mockingbird."} {"Flame and Fortune."} {"How to Get Fired Without Losing Your Job."} {"Stupid Elemental Tricks."}]
	local274
)
(procedure (localproc_24a6)
	(return
		(cond 
			(
				(or
					(Said '/<health,healing')
					(Said '//<health,healing')
				)
				(= local146 1000)
				18
			)
			(
			(or (Said '/<mana,magic') (Said '//<mana,magic')) (= local146 1500) 19)
			(
				(or
					(Said '/<energy,stamina')
					(Said '//<energy,stamina')
				)
				(= local146 500)
				20
			)
			(
			(or (Said '/<poison,cure') (Said '//<poison,cure')) (= local146 1200) 48)
			(else 0)
		)
	)
)

(procedure (localproc_2529 &tmp temp0)
	(= temp0 0)
	(while (< temp0 8)
		((= [newASmoke temp0] (aSmoke new:))
			setLoop: [local132 temp0]
			x: [local116 (DrawFeature [newACenser temp0])]
			y:
				[local124 ((= [newACenser temp0] (aCenser new:))
					x: [local116 temp0]
					y: [local124 temp0]
				)]
			init:
		)
		(++ temp0)
	)
)

(instance rm130 of Stage
	(properties
		picture 130
		style $0004
		south 315
		bottomFromX 124
		bottomExit 1
		bottomToX 124
	)
	
	(method (init)
		(LoadMany 128 135 130)
		(Load rsSOUND 130)
		(LoadMany 131 135)
		(++ global264)
		(= local141 (!= gCurrentDay_2 currentDay))
		(= gCurrentDay_2 currentDay)
		(ego init:)
		(proc1_19)
		(brazSmoke init: setCycle: Fwd)
		(super init:)
		(DrawFeature braz urn bowl scale lamp1 lamp2)
		(mortar init:)
		(leftBottle init: hide:)
		(rightBottle init: hide:)
		(harik init: setScript: mixingS)
		(harikHead init:)
		(proc1_31
			(ScriptID 131 0)
			(ScriptID 131 1)
			(ScriptID 131 2)
			bookshelf
			(ScriptID 131 3)
			(ScriptID 131 4)
			(ScriptID 131 5)
			(ScriptID 131 6)
			(ScriptID 131 10)
			(ScriptID 131 11)
			(ScriptID 131 7)
			(ScriptID 131 8)
			(ScriptID 131 9)
			(ScriptID 131 12)
			(ScriptID 131 13)
			(ScriptID 131 14)
			(ScriptID 131 15)
			shelf
		)
		(localproc_2529)
		(= local274 (Random 0 10))
		(gCMusic number: 130 priority: 0 loop: -1 playBed:)
	)
	
	(method (dispose)
		(LoadMany 0 131)
		(gCMusic stop:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(= temp0 0)
		(if (and local143 (Said 'affirmative,n>'))
			(= local143 0)
			(if (Said 'affirmative')
				(pEvent claimed: 0)
				(= temp0 1)
			else
				(pEvent claimed: 1)
				(Say harikHead 130 0)
			)
		)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/apothecary,shop')
				)
				(HighPrint 130 1)
			)
			((Said 'hello')
				(if local140
					(Say harikHead 130 2)
				else
					(self setScript: welcome)
				)
			)
			((Said 'thank')
				(if local140
					(SayThanks harikHead 130 3)
				else
					(self setScript: welcome)
				)
			)
			(
				(or
					temp0
					(and
						(== elementalsStatus 5)
						(or
							(Said 'tell/elemental<earth')
							(Said 'tell//elemental<earth')
							(Said 'bargain//(powder[<burn]),burn,powder')
							(Said 'bargain/(powder[<burn]),burn,powder')
						)
					)
				)
				(= temp0 0)
				(pEvent claimed: 1)
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((Btst 37) (Say harikHead 130 4))
					((and (!= gHeroType 2) (== elementalsStatus 5)) (Say harikHead 130 5 130 6))
					((!= gHeroType 2) (Say harikHead 130 7))
					(
					(and (TestSkill 13 50) (== elementalsStatus 5)) (HighPrint 130 8) (self setScript: givePowderS))
					(else (Say harikHead 130 9))
				)
			)
			(
				(or
					(Said 'buy,bargain/burn,powder')
					(Said 'bargain//burn,powder')
				)
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((Btst 37) (Say harikHead 130 10))
					(else (Say harikHead 130 11 130 12) (= local143 1))
				)
			)
			(
				(or
					(Said 'tell/(powder<burn),(elemental<earth)')
					(Said 'tell//(powder<burn),(elemental<earth)')
				)
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((<= elementalsStatus 5) (Say harikHead 130 13))
					((TestSkill 13 60) (Say harikHead 130 14) (SkillUsed 13 10))
					(else (Say harikHead 130 15))
				)
			)
			(
				(or
					(Said 'tell/elemental<fire')
					(Said 'tell//elemental<fire')
				)
				(HighPrint 130 16)
				(if (not (Bset 178)) (SkillUsed 13 25))
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((< elementalsStatus 1) (Say harikHead 130 17))
					((== elementalsStatus 1) (Say harikHead 130 18))
					(else (Say harikHead 130 19))
				)
			)
			(
				(or
					(Said 'gave/elemental<fire[/attar,attar,clerk,clerk,man]')
					(Said 'gave[/attar,attar,clerk,clerk,man]/elemental<fire')
				)
				(if (>= elementalsStatus 2)
					(HighPrint 130 20)
				else
					(PrintDontHaveIt)
				)
			)
			(
				(or
					(Said 'tell/elemental<air')
					(Said 'tell//elemental<air')
				)
				(SkillUsed 13 5)
				(HighPrint 130 21)
				(Say harikHead 130 22)
			)
			(
				(or
					(Said 'tell/elemental<water')
					(Said 'tell//elemental<water')
				)
				(if (not (Bset 179)) (SkillUsed 13 20))
				(HighPrint 130 23)
				(if (== elementalsStatus 7)
					(Say harikHead 130 24)
				else
					(Say harikHead 130 25)
				)
			)
			((or (Said 'tell/beast') (Said 'tell//beast'))
				(SkillUsed 13 5)
				(HighPrint 130 26)
				(Say harikHead 130 27)
			)
			((Said 'tell')
				(if local140
					(Say harikHead 130 28)
				else
					(self setScript: welcome)
				)
			)
			((Said 'buy/pill>')
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((= local147 (localproc_24a6)) (= local149 0) (self setScript: walkOverS))
					(else (pEvent claimed: 1) (Say harikHead 130 29))
				)
			)
			(
			(or (Said 'bargain//pill>') (Said 'bargain/pill>'))
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((not (= local147 (localproc_24a6))) (pEvent claimed: 1) (Say harikHead 130 29))
					((TestSkill 13 60) (= local149 1) (self setScript: walkOverS))
					(else (pEvent claimed: 1) (Say harikHead 130 30))
				)
			)
			(
				(or
					(Said 'buy/medicine')
					(Said 'ask//medicine')
					(Said 'bargain//medicine')
					(Said 'bargain/medicine')
				)
				(Say harikHead 130 31)
			)
			((Said 'buy/frankincense>')
				(if (not local140)
					(pEvent claimed: 1)
					(self setScript: welcome)
				else
					(pEvent claimed: 1)
					(= local149 2)
					(self setScript: walkOverS)
				)
			)
			(
				(or
					(Said 'bargain//frankincense>')
					(Said 'bargain/frankincense>')
				)
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((TestSkill 13 80)
						(pEvent claimed: 1)
						(= local149 3)
						(self setScript: walkOverS)
					)
					(else (pEvent claimed: 1) (Say harikHead 130 32))
				)
			)
			((Said 'buy/grease>')
				(if (not local140)
					(pEvent claimed: 1)
					(self setScript: welcome)
				else
					(pEvent claimed: 1)
					(= local149 4)
					(self setScript: walkOverS)
				)
			)
			(
			(or (Said 'bargain//grease>') (Said 'bargain/grease>'))
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((TestSkill 13 80)
						(pEvent claimed: 1)
						(= local149 5)
						(self setScript: walkOverS)
					)
					(else (pEvent claimed: 1) (Say harikHead 130 33))
				)
			)
			(
				(or
					(Said 'bargain,buy//potion,disenchant')
					(Said 'bargain,buy/potion,disenchant')
				)
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((Btst 35) (Say harikHead 130 34))
					(else (Say harikHead 130 35 130 36))
				)
			)
			((Said 'bargain') (Say harikHead 130 37))
			((Said 'gave/feather')
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((not (ego has: 28)) (PrintDontHaveIt))
					(else
						(ego put: 28)
						(Bset 33)
						(if (Btst 34) (= local149 6) else (= local149 7))
						(self setScript: walkOverS)
					)
				)
			)
			((Said 'gave/fruit')
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((not (ego has: 36)) (PrintDontHaveIt))
					(else
						(ego put: 36)
						(Bset 34)
						(if (Btst 33) (= local149 6) else (= local149 8))
						(self setScript: walkOverS)
					)
				)
			)
			((Said 'gave/hair,fur')
				(if (not local140)
					(pEvent claimed: 1)
					(self setScript: welcome)
				else
					(Say harikHead 130 38)
				)
			)
			((Said 'acquire,use,eat,chew/pill>'))
			((Said 'grab') (SkillUsed 14 -50) (= local140 1) (Say harikHead 130 39))
			((Said 'get,acquire') (= local140 1) (Say harikHead 130 40))
			((Said 'made,gave,display/sign[<thief]')
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((MakeThiefSign) (Say harikHead 130 41))
					(else (Say harikHead 130 42))
				)
			)
			((Said 'attack/attar,attar,clerk,clerk,man') (= local140 1) (Say harikHead 130 43))
			((Said 'gave,sell/venom,tail[<scorpion]')
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((ego has: 29) (= local149 9) (self setScript: walkOverS))
					(else (PrintDontHaveIt))
				)
			)
			((Said 'sell/venom,claw[<ghoul]')
				(cond 
					((not local140) (pEvent claimed: 1) (self setScript: welcome))
					((ego has: 30) (= local149 10) (self setScript: walkOverS))
					(else (PrintDontHaveIt))
				)
			)
		)
	)
)

(instance askLamp of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say harikHead self 135 54))
			(1
				(if (and (== currentDay 6) (not (ego has: 33)))
					(Say harikHead self 135 55)
				else
					(self dispose:)
				)
			)
			(2
				(= local149 11)
				(client setScript: walkOverS)
			)
		)
	)
)

(instance putMoney of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(HighPrint 130 44)
				(self dispose:)
			)
		)
	)
)

(instance givePowderS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Say harikHead self 130 45 130 46 130 47 130 48)
			)
			(1
				(harik
					setScript: 0
					loop: 3
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(2
				(HighPrint 130 49)
				(harik cycleSpeed: 1 setScript: mixingS)
				(AddToScore 697 5 2)
				(ego get: 39 6)
				(Bset 37)
				(self dispose:)
			)
		)
	)
)

(instance welcome of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local140 1)
				(FaceObject ego harik)
				(Say harikHead self 130 50)
			)
			(1
				(cond 
					(
					(and local141 (<= 4 currentDay) (<= currentDay 6))
						(if (< elementalsStatus 2)
							(Say harikHead self 130 51)
						else
							(Say harikHead self 130 52)
						)
					)
					(
						(and
							local141
							(OneOf currentDay 12 13)
							(== elementalsStatus 5)
						)
						(Say harikHead self 130 53)
					)
					((and local141 (OneOf currentDay 15 16)) (Say harikHead self 130 54))
					(else
						(switch global264
							(1 (Say harikHead self 130 55))
							(else 
								(Say harikHead self 130 56)
							)
						)
					)
				)
			)
			(2 (self dispose:))
		)
	)
)

(instance mixingS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(harik loop: 2 cel: 0 cycleSpeed: 1 setCycle: End self)
				(leftBottle hide:)
				(rightBottle hide:)
			)
			(1
				(if (harikHead cycler?)
					(= cycles 15)
				else
					(harik
						loop: 6
						cel: 0
						setCycle: ForwardCounter (Random 3 5) self
					)
				)
			)
			(2
				(harik loop: 2 cel: 1 setCycle: Beg self)
			)
			(3
				(if local140
					(leftBottle show:)
					(rightBottle show:)
					(harik loop: 1 cel: 0 setCycle: End self)
					(mortar hide:)
				else
					(self changeState: 0)
				)
			)
			(4 (= cycles (Random 2 12)))
			(5 (harik setCycle: Beg self))
			(6
				(mortar show:)
				(= seconds (Random 2 8))
			)
			(7
				(self changeState: (if (Random 0 2) 0 else 3))
			)
		)
	)
)

(instance showFlame of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(harik setScript: 0 loop: 2 setCycle: Beg self)
				(leftBottle hide:)
				(rightBottle hide:)
				(mortar show:)
			)
			(1 (Say harikHead self 130 57))
			(2
				(leftBottle show:)
				(rightBottle show:)
				(harik loop: 4 cel: 0 setCycle: End self)
				(FaceObject ego brazSmoke)
			)
			(3 (= cycles 3))
			(4
				(harik loop: 5 cel: 0)
				(gSpareMusic number: 561 priority: 10 loop: 1 play:)
				(brazSmoke
					loop: 4
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(5
				(brazSmoke loop: 3 cycleSpeed: 1 setCycle: Fwd)
				(harik cycleSpeed: 1 setCycle: CT 3 1 self)
			)
			(6 (= cycles 2))
			(7 (harik cel: 2) (= cycles 2))
			(8 (harik cel: 3) (= cycles 6))
			(9 (harik setCycle: End self))
			(10 (= cycles 2))
			(11
				(harik loop: 2 cel: 0 cycleSpeed: 0)
				(leftBottle hide:)
				(rightBottle hide:)
				(= cycles 2)
			)
			(12
				(FaceObject ego harikHead)
				(switch local142
					(1 (Say harikHead self 130 58))
					(2 (Say harikHead self 130 59))
				)
			)
			(13 (= cycles 1))
			(14
				(switch local142
					(1
						(cond 
							((== elementalsStatus 1) (Say harikHead self 130 60))
							((< elementalsStatus 1) (Say harikHead self 130 61))
							(else (Say harikHead self 130 62))
						)
					)
					(2
						(if (and (== gHeroType 2) (not (Btst 37)))
							(Say harikHead self 130 63)
						else
							(self cue:)
						)
					)
				)
			)
			(15 (= cycles 1))
			(16 (Say harikHead self 130 64))
			(17
				(harik setScript: mixingS)
				(self dispose:)
			)
		)
	)
)

(instance walkOverS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp theInvNum)
		(switch (= state newState)
			(0
				(ego ignoreActors: 1)
				(cond 
					((ego inRect: 163 152 227 166) (self changeState: 4))
					((and (< (ego x?) 113) (> (ego y?) 127)) (self changeState: 2))
					((> (ego y?) 148) (self changeState: 3))
					(else (self changeState: 1))
				)
			)
			(1
				(ego setMotion: MoveTo 123 127 self)
			)
			(2
				(ego setMotion: MoveTo 113 160 self)
			)
			(3
				(ego setMotion: MoveTo 174 165 self)
			)
			(4
				(FaceObject ego harikHead)
				(ego ignoreActors: 0)
				(= cycles 1)
			)
			(5
				(switch local149
					(0
						(Format @local0 130 65 (/ local146 100))
						(Say harikHead payS @local0)
						(= local148 3)
						(client setScript: payS)
					)
					(1
						(Say harikHead payS 130 66)
						(= local148 4)
						(client setScript: payS)
					)
					(2
						(Say harikHead payS 130 67)
						(client setScript: payS)
					)
					(3
						(if (and (<= 3 currentDay) (<= currentDay 6))
							(Say harikHead payS 130 68)
						else
							(Say harikHead payS 130 69)
						)
						(= local145 0)
						(client setScript: payS)
					)
					(4
						(Say harikHead payS 130 70)
						(client setScript: payS)
					)
					(5
						(Say harikHead payS 130 71)
						(= local144 15)
						(client setScript: payS)
					)
					(6
						(client setScript: makeDispelS)
					)
					(7 (Say harikHead 130 72))
					(8 (Say harikHead 130 73))
					(9
						(= theInvNum [invNum 29])
						(cond 
							((>= scorpionTailsSold 5) (Say harikHead 130 74))
							((== scorpionTailsSold 4)
								(Say harikHead putMoney 130 75)
								(ego put: 29)
								(ego get: 2 20)
								(++ scorpionTailsSold)
								(client setScript: putMoney)
							)
							(else
								(Say
									harikHead
									putMoney
									(Format @local0 130 76 (* theInvNum 20))
								)
								(ego put: 29 theInvNum)
								(ego get: 2 (* theInvNum 20))
								(= scorpionTailsSold (+ scorpionTailsSold theInvNum))
								(client setScript: putMoney)
							)
						)
					)
					(10
						(= theInvNum [invNum 30])
						(cond 
							((>= ghoulClawsSold 10) (Say harikHead 130 77))
							((>= ghoulClawsSold 7)
								(Say harikHead putMoney 130 78)
								(if (> theInvNum 2) (= theInvNum 3))
								(ego put: 30 theInvNum)
								(ego get: 2 (* 15 theInvNum))
								(= ghoulClawsSold (+ ghoulClawsSold theInvNum))
								(client setScript: putMoney)
							)
							(else
								(Say
									harikHead
									putMoney
									(Format @local0 130 79 (* theInvNum 15))
								)
								(ego put: 30 theInvNum)
								(ego get: 2 (* 15 theInvNum))
								(= ghoulClawsSold (+ ghoulClawsSold theInvNum))
								(client setScript: putMoney)
							)
						)
					)
					(11
						(HighPrint 130 80)
						(AddToScore 624 7)
						(ego get: 33)
					)
				)
				(if client (self dispose:))
			)
		)
	)
)

(instance payS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1 temp2 temp3 temp4 temp5)
		(switch (= state newState)
			(1
				(cond 
					((or (== local149 0) (== local149 1))
						(= temp0 local147)
						(= temp1 local146)
						(= temp2 local148)
						(= temp3 1)
						(= temp4 0)
						(= temp5 0)
					)
					((or (== local149 2) (== local149 3))
						(= temp0 13)
						(= temp1 local145)
						(= local145 70)
						(= temp2 1)
						(= temp3 1)
						(= temp4 0)
						(= temp5 0)
					)
					(else
						(= temp0 42)
						(= temp1 local144)
						(= local144 20)
						(= temp2 1)
						(= temp3 1)
						(= temp4 0)
						(= temp5 0)
					)
				)
				(switch (proc3_0 temp0 temp1 temp2 temp3 temp4 temp5)
					(1 (Say harikHead self 130 81))
					(0 (Say harikHead self 130 82))
					(else 
						(cond 
							((or (== local149 0) (== local149 1))
								(if (== temp0 48) (AddToScore 657 3 0))
								(Say harikHead 130 83)
							)
							((or (== local149 2) (== local149 3)) (AddToScore 607 7))
							(else (AddToScore 696 3 2))
						)
						(client setScript: giveItemsS)
					)
				)
			)
			(2 (self dispose:))
		)
	)
)

(instance giveItemsS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(harik loop: 3 cel: 0 setScript: 0 setCycle: End self)
			)
			(1
				(harik setScript: mixingS)
				(self dispose:)
			)
		)
	)
)

(instance dispelS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((not (Btst 36)) (Bset 36) (Say harikHead self 130 84 130 85 130 86))
					((not (if (ego has: 28) (ego has: 36))) (Say harikHead self 130 87 130 88))
					((Btst 35) (Say harikHead self 130 89))
					(else
						(HighPrint 130 90)
						(ego put: 28)
						(ego put: 36)
						(self setScript: makeDispelS self)
					)
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance makeDispelS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say harikHead self 130 91))
			(1 (= seconds 3))
			(2
				(harik loop: 3 cel: 5)
				(Bset 35)
				(= cycles 10)
			)
			(3
				(harik setScript: 0 loop: 2 cel: 5)
				(Say harikHead self 130 92 130 93 130 94 130 95)
			)
			(4
				(HighPrint 130 96)
				(AddToScore 608 7)
				(ego get: 21 3)
				(Say harikHead self 130 97)
			)
			(5
				(harik setScript: mixingS)
				(self dispose:)
			)
		)
	)
)

(instance harik of Prop
	(properties
		x 188
		y 130
		description {Harik Attar}
		lookStr {The druggist seems to keep busy at his trade.}
		view 135
		loop 2
		priority 10
		signal $4010
		cycleSpeed 2
	)
)

(instance harikHead of Talker
	(properties
		x 192
		y 146
		z 30
		description {Harik Attar}
		view 135
		loop 7
		priority 11
		signal $4010
		illegalBits $0000
		talkSpeed 1
		myName '//attar,attar,clerk,clerk,man'
		title {Harik Attar:}
		color 14
		back 4
		msgFile 135
	)
	
	(method (atSpec param1)
		(return [local188 param1])
	)
	
	(method (atGen param1)
		(return [local150 param1])
	)
	
	(method (showText param1)
		(if (not local140)
			(= local140 1)
			(curRoom setScript: welcome)
		else
			(switch param1
				(-1
					(AddToScore 606 3)
					(= local142 1)
					(curRoom setScript: showFlame)
				)
				(-2
					(AddToScore 605 3)
					(= local142 2)
					(curRoom setScript: showFlame)
				)
				(-3
					(curRoom setScript: dispelS)
				)
				(-4
					(cond 
						((not local140) (self setScript: welcome))
						((Btst 37) (Say harikHead 130 10))
						(else (Say harikHead 130 11 130 12) (= local143 1))
					)
				)
				(-5
					(cond 
						((Btst 35) (Say harikHead 130 98))
						((Btst 34) (Say harikHead 130 99))
						((Btst 33) (Say harikHead 130 100))
						(else (Say harikHead 130 101))
					)
				)
				(54
					(curRoom setScript: askLamp)
				)
				(30 (self showMany: param1 32))
				(41 (self showMany: param1 42))
				(54 (self showMany: param1 55))
				(47 (self showMany: param1 48))
				(52
					(if (Btst 606)
						(super showText: param1)
					else
						(Say self 130 102)
					)
				)
				(28
					(if (Btst 606)
						(self showMany: param1 29)
					else
						(super showText: param1)
					)
				)
				(else  (super showText: param1))
			)
		)
	)
)

(instance aSmoke of Extra
	(properties
		shiftClick 0
		view 130
		cycleType 1
		minPause 2
		maxPause 5
		minCycles 1
		maxCycles 3
	)
)

(instance aCenser of PicView
	(properties
		shiftClick 0
		view 130
		loop 1
		signal $4000
	)
)

(instance brazSmoke of Prop
	(properties
		x 151
		y 131
		noun '/smoke'
		description {smoke}
		lookStr {The smoke from the brazier smells of sweet incense and halibut.}
		view 130
		loop 3
		priority 11
		signal $4010
		cycleSpeed 1
	)
)

(instance mortar of View
	(properties
		x 180
		y 135
		noun '/mortar'
		description {the mortar}
		lookStr {It needs a pestle to be useful.}
		view 130
		priority 11
		signal $4010
	)
)

(instance leftBottle of View
	(properties
		x 175
		y 133
		noun '/bottle'
		description {the bottle}
		lookStr {It's a bottle.__You can barely make out the label:\n"Servings per container....8\nCalories...."\nYou can't make out the rest.}
		view 130
		cel 4
		priority 11
		signal $4010
	)
)

(instance rightBottle of View
	(properties
		x 207
		y 134
		noun '/bottle'
		description {the bottle}
		lookStr {It's a bottle.__You can barely make out the label:\n"Servings per container....8\nCalories...."\nYou can't make out the rest.}
		view 130
		cel 6
		priority 11
		signal $4010
	)
)

(instance pillBag of View
	(properties
		x 199
		y 144
		noun '/bag'
		description {the pill bag}
		lookStr {It's a pill bag.}
		view 130
		cel 3
		priority 11
		signal $4010
	)
)

(instance bowl of PicView
	(properties
		x 192
		y 135
		noun '/pestle,bowl'
		description {the pestle}
		lookStr {It needs a mortar to be useful.}
		view 130
		cel 2
		priority 10
		signal $4010
	)
)

(instance urn of PicView
	(properties
		x 229
		y 132
		noun '/urn'
		description {the urn}
		lookStr {It's a funerary urn.__At the top is the hole for the ashes.}
		view 130
		cel 1
		priority 11
		signal $4010
	)
)

(instance scale of PicView
	(properties
		x 246
		y 128
		noun '/scale'
		description {the scale}
		view 130
		cel 5
		priority 11
		signal $4010
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 130 103))
			(7 (HighPrint 130 104))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance braz of PicView
	(properties
		x 149
		y 150
		noun '/brazier'
		description {the brazier}
		lookStr {It's a brazier, fully filled with flames.}
		view 130
		cel 7
		priority 11
		signal $0010
	)
)

(instance lamp1 of PicView
	(properties
		x 231
		y 41
		noun '/lamp'
		description {the lamp}
		lookStr {It's a ceiling lamp, although the ceiling is pretty bright by itself.}
		view 130
		cel 8
		signal $4010
	)
)

(instance lamp2 of PicView
	(properties
		x 71
		y 41
		noun '/lamp'
		description {the lamp}
		lookStr {It's a ceiling lamp, although the ceiling is pretty bright by itself.}
		view 130
		cel 8
		signal $4010
	)
)

(instance bookshelf of Feature
	(properties
		x 109
		y 69
		noun '/bookcase,shelf[<book]'
		nsTop 45
		nsLeft 96
		nsBottom 94
		nsRight 123
		description {the bookshelf full of books}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint (Format @local0 130 105 [local263 local274]))
			(if (> (++ local274) 10) (= local274 0))
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance shelf of Feature
	(properties
		x 232
		y 80
		noun '/shelf'
		nsTop 46
		nsLeft 202
		nsBottom 115
		nsRight 262
		description {shelves filled with unusual objects}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint (Format @local0 130 106 [local252 local274]))
			(if (> (++ local274) 10) (= local274 0))
		else
			(super doVerb: theVerb &rest)
		)
	)
)
