;;; Sierra Script 1.0 - (do not remove this comment)
(script# 161)
(include sci.sh)
(use Main)
(use n001)
(use Intrface)
(use Game)
(use Actor)
(use System)

(public
	rm161 0
)

(local
	newView
	local1
)
(procedure (localproc_000c param1 param2)
	(Print param2 #at -1 12 #mode 1 #width param1)
)

(procedure (localproc_0022)
	(switch local1
		(1
			(newView cel: 0 posn: 94 94 stopUpd:)
		)
		(2
			(newView cel: 2 posn: 166 94 stopUpd:)
		)
		(3
			(newView cel: 3 posn: 223 126 stopUpd:)
		)
		(4
			(newView cel: 4 posn: 164 139 stopUpd:)
		)
		(5
			(newView cel: 1 posn: 111 142 stopUpd:)
		)
		(6
			(newView cel: 5 posn: 270 188 stopUpd:)
		)
	)
)

(procedure (localproc_00e0 &tmp [temp0 4] [temp4 400])
	(switch local1
		(1
			(Format @temp4 161 0)
			(localproc_000c 185 @temp4)
		)
		(2
			(Format @temp4 161 1)
			(localproc_000c 260 @temp4)
		)
		(3
			(Format @temp4 161 2)
			(localproc_000c 200 @temp4)
		)
		(4
			(Format @temp4 161 3)
			(localproc_000c 300 @temp4)
		)
		(5
			(Format @temp4 161 4)
			(localproc_000c 200 @temp4)
		)
		(6 (curRoom newRoom: 160))
	)
)

(instance rm161 of Rm
	(properties
		picture 161
		style $0007
	)
	
	(method (init)
		(Load rsVIEW 161)
		(super init:)
		(gMouseH add: self)
		(gKeyH add: self)
		(gDirH add: self)
		(SL enable:)
		(SetControl 1)
		(= gGDftSC noSpells)
		(= local1 1)
		((= newView (View new:))
			view: 161
			loop: 2
			cel: 0
			posn: 94 94
			signal: 1
			init:
		)
	)
	
	(method (dispose)
		(gMouseH delete: self)
		(gKeyH delete: self)
		(gDirH delete: self)
		(SetControl 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(switch (pEvent type?)
			(evMOUSEBUTTON
				(= temp1 0)
				(switch (= temp0 (OnControl 4 (pEvent x?) (pEvent y?)))
					(512 (= temp1 1))
					(16384 (= temp1 2))
					(8192 (= temp1 3))
					(4096 (= temp1 4))
					(1024 (= temp1 5))
					(2048
						(= local1 6)
						(localproc_0022)
						(SetUpEgo)
						(pEvent claimed: 1)
						(curRoom newRoom: 160)
					)
				)
				(pEvent claimed: 1)
				(localproc_0022)
				(if temp1
					(= local1 temp1)
					(localproc_0022)
					(SetUpEgo)
					(localproc_00e0)
				)
			)
			(evSAID
				(cond 
					((Said 'cease,done,done,done') (pEvent claimed: 1) (curRoom newRoom: 160))
					((Said 'look,examine') (pEvent claimed: 1) (localproc_00e0))
				)
			)
			(evJOYSTICK
				(switch (pEvent message?)
					(JOY_UP
						(if (< (= local1 (- local1 3)) 1)
							(= local1 (+ local1 6))
						)
					)
					(JOY_RIGHT
						(if (> (++ local1) 6) (= local1 1))
					)
					(JOY_DOWN
						(if (> (= local1 (+ local1 3)) 6)
							(= local1 (- local1 6))
						)
					)
					(JOY_LEFT
						(if (< (-- local1) 1) (= local1 6))
					)
				)
				(pEvent claimed: 1)
				(localproc_0022)
			)
			(evKEYBOARD
				(if (== (pEvent message?) KEY_RETURN)
					(pEvent claimed: 1)
					(localproc_00e0)
					(if (> (++ local1) 6) (= local1 1))
					(localproc_0022)
				)
			)
		)
		(super handleEvent: pEvent)
	)
)

(instance noSpells of Code
	(properties)
	
	(method (doit param1)
		(cond 
			((OneOf param1 1 2 3 4 5) (HighPrint 161 5))
			((== param1 6) (HighPrint 161 6))
			(else (HighPrint 161 7))
		)
		(return 0)
	)
)
