;;; Sierra Script 1.0 - (do not remove this comment)
(script# 180)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Intrface)
(use Feature)
(use LoadMany)
(use Music)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm180 0
)

(local
	local0
	local1
	local2
	local3
	local4
	gEgoCycler
	gEgoMover
	local7
	theCurrentTimeZone
	local9
	local10
	local11
	local12
	local13
	local14
	local15
	local16
	[local17 100]
	[local117 38] = [25 26 27 28 0 1 3 2 4 32 33 34 35 36 24 37 38 24 24 39 24 40 24 41 42 24 43 44 45 24 46 47 48 24 24 24 24 24]
	[local155 50] = [5 '//plant,tree,compassion,fruit,julanar,pomegranate,(woman,woman<plant,about)' 8 '//blackness' 9 '//nature' 12 '//omen' 13 '//iblis' 14 '//bendaoud' 15 '//contain,capture' 18 '//element<contrary,about' 20 '//manner,judith,etiquette' 22 '//carp,carp,dolphin,aquarium,oasis,sea' 23 '//shelf,book,tapestry,stuff,knack' 49 '//rakeesh,lion' 50 '//paladin,life' 46 '//shema,shameen' 51 '//keapon,(shop<magic,about)' 52 '//water' 53 '//(see<far,about),(see<true,about)' 54 '//tea' 55 '//man' 56 '//ad' 57 '//potion<disenchant' 58 '//enchantment' 6 '//beast,creature[<desert,birdcage,enchant,about]' 7 '//spell']
	[local205 11] = [{some water-based paints.} {a jar of freeze-dried tea (just add water).} {a plate of watery tarts.} {some moisturizing cream.} {some unused bath towels} {two statues of immoral porpoises.} {the sheet music for Handel's "Water Music."} {Waterford Crystal.} {an autographed picture of Captain Nemo.} {a leftover submarine sandwich} {a leftover hero sandwich}]
	[local216 11] = [{"20,000 Leaks Under the Sink."} {"Mussel-Building with Barnacle Jones."} {"Learn to Program in Sea++."} {"Learn to Play 'Go Fish' like a Card Shark."} {"How to Teach Generosity to Shellfish People."} {"New Clear Fishin'."} {"Fear of Swimming."} {"Lure of the Flies."} {"The Tides of Marsh."} {"The Poseidon Adventure."} {"Clam of the Baskervilles."}]
	local227
	local228
	[local229 100]
)
(procedure (localproc_000c param1 param2)
	(switch param1
		(0 (++ local7) (-- global274))
		(1
			(-- local7)
			(++ global274)
			(= local14 1)
		)
		(2
			(= local7 (- local7 2))
			(= global274 3)
		)
	)
	(if (< global274 0) (= global274 0))
	(if (== global274 3)
		(curRoom setScript: egoThrownOut 0 param2)
	)
)

(procedure (localproc_006c)
	(switch local14
		(0 (HighPrint 180 0))
		(1
			(= local14 0)
			(Say aziza 180 1)
			(localproc_000c 0 0)
			(return 1)
		)
		(2 (Say aziza 180 2))
	)
	(return 0)
)

(instance rm180 of Rm
	(properties
		picture 180
		style $0008
		east 199
	)
	
	(method (init &tmp [temp0 20])
		(LoadMany 128 3 11 180 182 181 183 184 184)
		(LoadMany 131 182)
		(LoadMany 130 21)
		(LoadMany 132 180 181 182)
		(AddToScore 614 7)
		(= theCurrentTimeZone currentTimeZone)
		(= global277 (+ (* currentDay 100) theCurrentTimeZone))
		(= gGDftSC spellCode)
		(super init:)
		(fishy init: setCycle: Fwd)
		(door init:)
		(proc1_31 tank herBackDoor)
		(DrawFeature
			tapestry
			teaTable
			shelf
			shelfStuff1
			shelfStuff2
			shelfStuff3
			shelfStuff4
			shelfStuff5
			lilyPad1
			lilyPad2
		)
		(proc1_31 pond)
		(= local227 (Random 0 10))
		(= local228 (Random 0 10))
		(proc1_19)
		(tableSound init:)
		(if (== prevRoomNum 190)
			(tableSound play:)
			(= local12 1)
		else
			(gCMusic number: 180 loop: -1 priority: 2 playBed:)
		)
		(ChangeEgoWalk 0 0)
		(cond 
			((== prevRoomNum 190)
				(SetControl 1)
				(aziza loop: 6 cel: 0 posn: 66 149 init:)
				(ego view: 180 loop: 2 cel: 5 posn: 122 186 init:)
				(azizaMouth x: 68 y: 149 z: 11 cel: 0 setPri: 12 init:)
				(if (== currentDay 16)
					(saurus loop: 0 posn: 10 189 setPri: 15 init: stopUpd:)
					(self setScript: afterCeremony)
				)
			)
			((== currentDay 16)
				(aziza posn: 80 105 init:)
				(ego view: 4 loop: 1 posn: 310 130 init:)
				(AddToScore 613 7)
				(saurus init:)
				(self setScript: enterS)
			)
			(else
				(aziza init:)
				(ego view: 4 loop: 1 posn: 310 130 init:)
				(self setScript: enterS)
			)
		)
		(azizaMouth init:)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			((ego script?))
			((ego inRect: 260 120 320 140) (self setScript: openTheDoor))
			((& (ego onControl: 1) $0800) (self setScript: backDoor))
			(
				(and
					(& (ego onControl: 1) $2000)
					(> (ego y?) 125)
					(not local12)
				)
				(self setScript: downStairs)
			)
			(
			(and (& (ego onControl: 1) $2000) (< (ego y?) 126)) (self setScript: backStairs))
			(
			(and (& (ego onControl: 1) $4000) (not local11)) (= local11 1) (HighPrint 180 3))
		)
	)
	
	(method (dispose)
		(= global267 global277)
		(= local7 (* local7 25))
		(SkillUsed 14 local7)
		(if (!= newRoomNum 190) (gCMusic fade:))
		(tableSound stop: dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 10])
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 180 4))
			(
				(or
					(Said '/sorry')
					(Said 'apologize')
					(Said 'forgive,forgive')
				)
				(localproc_006c)
			)
			((Said 'drink,enjoy,gave[/tea]')
				(if (not (cast contains: teaSet))
					(HighPrint 180 5)
				else
					(HighPrint 180 6)
				)
			)
			((or (Said '/bye') (Said 'bye')) (= local16 1) (curRoom setScript: upStairs))
			((Said '(get,acquire<up),(stand[<up])')
				(if local12
					(curRoom setScript: upStairs)
				else
					(HighPrint 180 7)
				)
			)
			((and (not local12) (Said 'tell,bargain')) (if (not (== global274 3)) (Say aziza 180 8)))
			((Said 'thank[/aziza,enchantress,woman,ya]')
				(if (not local2) (localproc_000c 0 0) (= local2 1))
				(SayThanks aziza 180 9)
			)
			((or (Said 'greet') (Said 'hello'))
				(if (not local3) (localproc_000c 0 0) (= local3 1))
				(Say aziza 180 10)
			)
			(
				(or
					(Said
						'tell/beast,creature[<desert,birdcage,enchant,about]'
					)
					(Said
						'tell//beast,creature[<desert,birdcage,enchant,about]'
					)
				)
				(= local4 1)
				(if (not local1) (localproc_000c 0 0) (= local1 1))
				(if (Btst 42)
					(HighPrint 180 11)
					(Say aziza 180 12)
				else
					(HighPrint 180 13)
					(Say aziza 180 14)
				)
			)
			((Said 'tell')
				(= local4 1)
				(if (not local0) (localproc_000c 0 0) (= local0 1))
				(Say aziza 180 15)
			)
			(
				(or
					(Said 'kiss,hug')
					(Said 'ask/date,kiss,hug')
					(Said 'ask[/aziza]/date,kiss,hug')
				)
				(Say aziza 180 16)
			)
			((Said 'kill,attack,grab') (localproc_000c 2 0))
		)
	)
)

(instance enterS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (door setCycle: End self))
			(1
				(ego setMotion: MoveTo 265 130 self)
			)
			(2
				(ego setHeading: 0)
				(= cycles 3)
			)
			(3
				(door setCycle: Beg self)
				(ego setMotion: MoveTo 245 127)
			)
			(4
				(aziza cycleSpeed: 1 setCycle: CT 5 1)
				(= cycles 15)
			)
			(5 (aziza setCycle: End self))
			(6
				(aziza cycleSpeed: 0)
				(= local9 1)
				(cond 
					((== currentDay 16) (curRoom setScript: gronkScript))
					((== currentDay 15) (Say aziza self 180 17 180 18))
					((Btst 122) (Say aziza self 180 19 180 20))
					(
						(and
							(>= currentDay 11)
							(== gHeroType 1)
							(not [skills 29])
						)
						(Say aziza self 180 21)
					)
					(else (Say aziza self 180 20))
				)
			)
			(7 (self dispose:))
		)
	)
)

(instance gronkScript of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp botWindowBrRight botWindowBrLeft)
		(switch (= state newState)
			(0
				(if (== global274 3)
					(Say aziza self 180 22)
				else
					(Say
						aziza
						self
						180
						23
						(Format @local17 180 24 @userName)
						180
						25
						180
						26
					)
				)
				(= local9 1)
			)
			(1
				(aziza cel: 4 setCycle: Beg)
				(ego setMotion: MoveTo 100 130)
				(= cycles 6)
			)
			(2 (door setCycle: End self))
			(3
				(saurus
					init:
					setCycle: Walk
					setMotion: MoveTo 310 130 self
				)
			)
			(4
				(saurusBod init:)
				(saurus
					view: 182
					loop: 10
					cel: 0
					x: 291
					y: 130
					z: 42
					cycleSpeed: 2
					setCycle: End self
				)
				(aziza loop: 1 cel: 0 setCycle: CT 2 1)
				(ego
					view: 182
					loop: 9
					cel: 0
					x: (- (ego x?) 8)
					setMotion: 0
					cycleSpeed: 3
					setCycle: CT 1 1
				)
				(= botWindowBrRight (BotWindow brRight?))
				(= botWindowBrLeft (BotWindow brLeft?))
				(BotWindow color: 10 back: 0)
				(gMiscMusic number: 291 loop: 1 play:)
				(Print
					180
					27
					#font
					userFont
					#title
					{Roget The Saurus:}
					#window
					BotWindow
					#width
					(- botWindowBrRight (+ botWindowBrLeft 16))
					#dispose
				)
			)
			(5
				(ego setCycle: End)
				(saurus setCycle: Beg)
				(aziza setCycle: CT 4 1)
				(= cycles 30)
			)
			(6
				(DisposeDialog)
				(saurus view: 11 loop: 1 x: 310 y: 130 z: 0)
				(saurusBod dispose:)
				(aziza setCycle: CT 6 1 self)
			)
			(7
				(azizaMouth hide:)
				(Say aziza self 180 28)
			)
			(8
				(= botWindowBrRight (BotWindow brRight?))
				(= botWindowBrLeft (BotWindow brLeft?))
				(BotWindow color: 10 back: 0)
				(Print
					180
					29
					#font
					userFont
					#title
					{Roget The Saurus:}
					#window
					BotWindow
					#width
					(- botWindowBrRight (+ botWindowBrLeft 16))
					#dispose
				)
				(= seconds 5)
			)
			(9
				(DisposeDialog)
				(aziza setCycle: End self)
			)
			(10
				(azizaMouth show:)
				(Say aziza self 180 30)
			)
			(11
				(= gRegister -1)
				(curRoom newRoom: 190)
			)
		)
	)
)

(instance afterCeremony of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 5))
			(1
				(Say
					aziza
					self
					180
					31
					(Format @local17 180 32 @userName)
				)
			)
			(2 (ego setCycle: Beg self))
			(3
				(ego use: 50)
				(curRoom newRoom: 199)
			)
		)
	)
)

(instance egoThrownOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(asm
			lap      newState
			aTop     state
			push    
			dup     
			ldi      0
			eq?     
			bnt      code_0cbb
			pToa     register
			bnt      code_0ca8
			pushi    6
			dup     
			pushi    0
			lofsa    aziza
			send     4
			le?     
			bnt      code_0c8c
			pprev   
			ldi      7
			le?     
			bnt      code_0c8c
			pushi    #loop
			pushi    1
			pushi    8
			pushi    139
			pushi    1
			class    End
			push    
			lofsa    aziza
			send     12
code_0c8c:
			pushi    #hide
			pushi    0
			lofsa    azizaMouth
			send     4
			pushi    4
			lofsa    aziza
			push    
			pushSelf
			pushi    180
			pushi    33
			calle    Say,  8
			jmp      code_0d39
code_0ca8:
			pushi    4
			lofsa    aziza
			push    
			pushSelf
			pushi    180
			pushi    34
			calle    Say,  8
			jmp      code_0d39
code_0cbb:
			dup     
			ldi      1
			eq?     
			bnt      code_0d09
			pushi    0
			ldi      17
			sagi     skills
			pushi    237
			pushi    2
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			pushi    85
			pushi    1
			pushi    #view
			pushi    0
			lag      ego
			send     4
			push    
			ldi      180
			eq?     
			bnt      code_0cf3
			ldi      18
			jmp      code_0cf5
code_0cf3:
			ldi      36
code_0cf5:
			push    
			pushi    102
			pushi    0
			pushi    139
			pushi    2
			class    End
			push    
			pushSelf
			lofsa    sparkle
			send     26
			jmp      code_0d39
code_0d09:
			dup     
			ldi      2
			eq?     
			bnt      code_0d27
			pushi    #dispose
			pushi    0
			lofsa    sparkle
			send     4
			pushi    #hide
			pushi    0
			lag      ego
			send     4
			ldi      4
			aTop     cycles
			jmp      code_0d39
code_0d27:
			dup     
			ldi      3
			eq?     
			bnt      code_0d39
			pushi    #newRoom
			pushi    1
			pushi    199
			lag      curRoom
			send     6
code_0d39:
			toss    
			ret     
		)
	)
)

(instance backDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0)
				(if (not local10)
					(Say aziza self 180 35)
					(= local9 1)
				else
					(localproc_000c 2 0)
				)
			)
			(1
				(FaceObject ego aziza 0 self)
			)
			(2
				(ego setMotion: MoveTo 84 100 self)
				(= local10 1)
			)
			(3 (self dispose:))
		)
	)
)

(instance teaTalk of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not local15) (Say aziza 180 38))
				(Bset 41)
			)
			(1
				(SetInput 1)
				(aziza loop: 6 cycleSpeed: 1 setCycle: End self)
			)
			(2
				(gMiscMusic number: 17 loop: 1 play:)
				(teaSet init: cycleSpeed: 1 setCycle: End self)
			)
			(3
				(aziza cel: 0)
				(teaSet loop: 4 cel: 0 cycleSpeed: 2 setCycle: End self)
			)
			(4
				(HighPrint 180 39)
				(Say aziza self 180 40)
			)
			(5
				(SetInput 0)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'n')
				(localproc_000c 1 0)
				(if (== global274 3)
					(self dispose:)
				else
					(Say aziza self 180 36)
					(self changeState: 5)
				)
			)
			((Said 'affirmative,drink') (localproc_000c 0 0) (self cue:))
			((Said 'look,examine') (pEvent claimed: 0))
			(
				(or
					(Said '/sorry')
					(Said 'apologize')
					(Said 'forgive,forgive')
				)
				(if (localproc_006c) (self changeState: 0))
			)
			((== (pEvent type?) evSAID)
				(++ local15)
				(localproc_000c local15 0)
				(pEvent claimed: 1)
				(if (== global274 3)
					(self dispose:)
				else
					(= state -1)
					(Say aziza self 180 37)
				)
			)
		)
		(pEvent claimed?)
	)
)

(instance openTheDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 292 140 self)
			)
			(1 (ego setHeading: 0 self))
			(2 (door setCycle: End self))
			(3
				(ego
					view: 0
					setCycle: Walk
					setMotion: MoveTo (ego x?) (- (ego y?) 8) self
				)
			)
			(4
				(ego setMotion: MoveTo 330 (ego y?))
			)
			(5 (self dispose:))
		)
	)
)

(instance aCloserLook of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((and (>= 4 register) (>= register 0)) (Say aziza self 180 41))
					((and (== register 5) (Btst 43)) (Say aziza self 180 42))
					((and (== register 5) (Btst 44)) (Say aziza self 180 43))
					((== register 5) (Say aziza self 180 44))
				)
			)
			(1
				(= gRegister register)
				(curRoom newRoom: 190)
			)
		)
	)
)

(instance aziza of Talker
	(properties
		x 69
		y 150
		description {the Enchantress Aziza}
		lookStr {Aziza's beauty in no way masks her intensity, purposefulness, and the aura of power around her.__It is good when in her presence to be on your best behavior.}
		view 182
		loop 2
		illegalBits $0000
		tLoop -1
		talkSpeed 1
		myName '//aziza,enchantress,woman,girl'
		title {Aziza:}
		color 13
		back 0
		msgFile 182
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'sat')
				(if (== (ego view?) 180)
					(HighPrint 180 45)
				else
					(Say aziza 180 46)
				)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local155 param1])
	)
	
	(method (atGen param1)
		(return [local117 param1])
	)
	
	(method (showText param1)
		(= local4 1)
		(cond 
			((and local9 (not (== (ego view?) 180)))
				(localproc_000c 1 0)
				(if (not (== global274 3)) (Say self 180 8))
			)
			(
				(and
					(== (ego view?) 180)
					(not (Btst 41))
					(== global267 0)
				)
				(localproc_000c 1 0)
				(if (not (== global274 3)) (Say self 180 47))
			)
			((== param1 6) (if (Btst 42) (Say self 180 48) else (Say self 180 49)))
			((== param1 7) (= param1 33) (super showText: param1 &rest))
			((== param1 15) (self caller: self showMany: 15 17))
			((== param1 18) (self caller: self showMany: 18 19))
			((and (>= 5 param1) (>= param1 0)) (curRoom setScript: aCloserLook 0 param1))
			(else (super showText: param1 &rest))
		)
	)
	
	(method (messages)
		(switch loop
			(1
				(azizaMouth x: (+ x 2) y: y z: 40)
			)
			(2
				(azizaMouth x: (- x 2) y: y z: 40)
			)
			(6
				(azizaMouth x: (+ x 2) y: y z: 11)
			)
		)
		(super messages: &rest)
		(azizaMouth setCycle: Fwd)
	)
	
	(method (endTalk)
		(super endTalk: &rest)
		(azizaMouth setCycle: 0 setCel: 0)
	)
)

(instance azizaMouth of Prop
	(properties
		view 182
		cel 1
		signal $4000
		cycleSpeed 1
	)
	
	(method (doit)
		(if (== cel 0)
			(if
				(not
					(cond 
						(
							(or
								(and (== (aziza loop?) 1) (== (aziza cel?) 10))
								(and (== (aziza loop?) 2) (== (aziza cel?) 8))
							)
						)
						((== (aziza loop?) 6) (== (aziza cel?) 0))
					)
				)
				(self cel: 1)
			)
		)
		(super doit:)
	)
)

(instance saurus of Actor
	(properties
		x 340
		y 130
		noun '/saurii'
		description {your saurus}
		lookStr {The saurus seems curious and excited for some reason.}
		view 11
		loop 1
		cel 6
		signal $4000
		illegalBits $0000
	)
)

(instance fishy of Prop
	(properties
		x 127
		y 36
		noun '/carp,carp'
		description {the fish in the tank}
		view 180
		loop 1
		priority 14
		signal $0010
	)
	
	(method (doit)
		(if (Random 0 1) (super doit:))
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(if (Said 'capture/carp,carp') (HighPrint 180 50))
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 180 51))
			(6 (HighPrint 180 52))
			(7 (HighPrint 180 50))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance saurusBod of View
	(properties
		x 310
		y 130
		view 182
		loop 11
		priority 512
		signal $0010
	)
)

(instance door of Prop
	(properties
		x 287
		y 97
		noun '/door'
		description {the front door}
		lookStr {It's the front door.__It's how you got in here.}
		view 180
		loop 3
		priority 7
		signal $0010
	)
)

(instance tank of Feature
	(properties
		x 127
		y 27
		noun '/tank,aquarium'
		nsTop 17
		nsLeft 113
		nsBottom 37
		nsRight 142
		description {Aziza's fishtank}
		lookStr {Aziza had many more fishtanks during the Age of Aquariums.}
	)
)

(instance sparkle of Prop
	(properties
		shiftClick 0
		view 183
		priority 15
		signal $0010
	)
)

(instance teaSet of Prop
	(properties
		x 67
		y 159
		noun '/tea,(set<tea)'
		description {Aziza's tea set}
		lookStr {It's a most polite tea set.}
		view 182
		loop 5
		priority 15
		signal $0010
	)
	
	(method (init)
		(cast addToFront: self)
		(super init:)
	)
)

(instance downStairs of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(SetControl 1)
		(aziza setScript: teaTalk)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (< (ego x?) 95)
					(ego setMotion: MoveTo 105 (ego y?) self)
				else
					(self cue:)
				)
			)
			(1
				(ego
					view: 181
					loop: 0
					cel: 0
					y: (+ (ego y?) 14)
					setCycle: End self
				)
			)
			(2
				(ego y: (+ (ego y?) 14) setCycle: End self)
			)
			(3
				(ego
					view: 0
					setCycle: Walk
					setMotion: MoveTo 122 191 self
				)
			)
			(4
				(ego heading: 180 setHeading: 315 self)
			)
			(5
				(ego
					view: 180
					loop: 2
					cel: 0
					posn: (- (ego x?) 4) (- (ego y?) 3)
					setCycle: End
				)
				(aziza
					setLoop: 3
					setCycle: Walk
					setMotion: MoveTo 67 162 self
				)
			)
			(6
				(aziza setLoop: 7 cel: 0 cycleSpeed: 0 setCycle: End self)
			)
			(7
				(tableSound play:)
				(aziza setLoop: 6 cel: 0 y: (- (aziza y?) 12))
				(= local12 1)
				(self dispose:)
			)
		)
	)
)

(instance upStairs of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(SetControl 0)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(tableSound stop:)
				(if (aziza script?) ((aziza script?) dispose:))
				(if local16
					(localproc_000c 0 0)
					(if local4
						(Say aziza self 180 53)
					else
						(Say aziza self 180 54)
					)
				else
					(localproc_000c 1 0)
					(Say aziza self 180 55)
				)
			)
			(1
				(if local12
					(ego setCycle: Beg self)
				else
					(self changeState: 6)
				)
			)
			(2
				(ego
					view: 0
					posn: (+ (ego x?) 4) (+ (ego y?) 3)
					setCycle: Walk
					heading: 315
					setLoop: 7
					setMotion: MoveTo 106 155 self
				)
			)
			(3
				(ego
					setPri: -1
					view: 181
					setLoop: 1
					cel: 0
					setCycle: End self
				)
			)
			(4
				(ego y: (- (ego y?) 14) setCycle: End self)
			)
			(5
				(proc1_19)
				(ego y: (- (ego y?) 14) setHeading: 225 self)
			)
			(6
				(AddToScore 677 3 3)
				(curRoom newRoom: 199)
			)
		)
	)
)

(instance backStairs of HandsOffScript
	(properties)
	
	(method (init)
		(= gEgoCycler (ego cycler?))
		(ego cycler: 0)
		(= gEgoMover (ego mover?))
		(ego mover: 0)
		(super init: &rest)
	)
	
	(method (dispose)
		(ego
			view: 0
			loop: (if local13 2 else 3)
			y: (if local13 (ego y?) else (- (ego y?) 14))
			setCycle: gEgoCycler
			setMotion: gEgoMover
		)
		(= local13 (== local13 0))
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 181
					loop: (if local13 0 else 1)
					cel: 0
					y: (if local13 (+ (ego y?) 14) else (ego y?))
					setCycle: End self
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance herBackDoor of Feature
	(properties
		x 76
		y 51
		noun '/door[<back,bedroom,aziza,bed]'
		nsTop 22
		nsLeft 51
		nsBottom 81
		nsRight 101
		description {the door to Aziza's chambers}
		lookStr {The door at the far end of the room looks like it would lead to an inner chamber.}
	)
)

(instance teaTable of PicView
	(properties
		x 78
		y 189
		noun '/table'
		description {Aziza's table}
		lookStr {Every good Enchantress has a tea table to encourage polite conversation.}
		view 184
		signal $4000
	)
)

(instance tapestry of PicView
	(properties
		x 167
		y 106
		noun '/tapestry,hang,painting'
		description {Aziza's tapestry}
		lookStr {The tapestry is very old and very green.__The pattern appears to be abstract, but it resembles the waves in the ocean.}
		view 184
		loop 2
		priority 6
		signal $4010
	)
)

(instance shelf of PicView
	(properties
		x 128
		y 101
		noun '/shelf'
		description {a shelf full of odd things}
		view 184
		loop 1
		priority 5
		signal $4010
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint (Format @local229 180 56 [local205 local227]))
			(if (> (++ local227) 10) (= local227 0))
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance shelfStuff1 of PicView
	(properties
		x 223
		y 22
		noun '/shelf'
		description {a shelf full of odd things}
		view 184
		cel 3
		signal $4000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(switch (Random 0 3)
				(0 (HighPrint 180 57))
				(1 (HighPrint 180 58))
				(2 (HighPrint 180 59))
				(3 (HighPrint 180 60))
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance shelfStuff2 of PicView
	(properties
		x 224
		y 39
		noun '/shelf'
		description {a shelf full of odd things}
		view 184
		cel 4
		signal $4000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(switch (Random 0 3)
				(0 (HighPrint 180 61))
				(1 (HighPrint 180 62))
				(2 (HighPrint 180 63))
				(3 (HighPrint 180 64))
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance shelfStuff3 of PicView
	(properties
		x 227
		y 58
		noun '/shelf'
		description {a shelf full of odd things}
		view 184
		cel 5
		signal $4000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(switch (Random 0 3)
				(0 (HighPrint 180 65))
				(1 (HighPrint 180 66))
				(2 (HighPrint 180 67))
				(3 (HighPrint 180 68))
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance shelfStuff4 of PicView
	(properties
		x 230
		y 74
		noun '/shelf'
		description {a shelf full of odd things}
		view 184
		cel 7
		signal $4000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(switch (Random 0 2)
				(0 (HighPrint 180 69))
				(1 (HighPrint 180 70))
				(2 (HighPrint 180 71))
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance shelfStuff5 of PicView
	(properties
		x 224
		y 89
		noun '/shelf'
		description {a shelf full of odd things}
		view 184
		cel 6
		signal $4000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (<= local228 4)
				(HighPrint
					(Format
						@local229
						180
						72
						(+ local228 1)
						[local216 local228]
					)
				)
			else
				(HighPrint (Format @local229 180 73 [local216 local228]))
			)
			(if (> (++ local228) 10) (= local228 0))
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance lilyPad1 of PicView
	(properties
		x 260
		y 186
		noun '/lily'
		description {the lily pad}
		lookStr {Lily pads float in Aziza's indoor pond.}
		view 184
		loop 3
		priority 15
		signal $0010
	)
)

(instance lilyPad2 of PicView
	(properties
		x 295
		y 184
		noun '/lily'
		description {the lily pad}
		lookStr {Lily pads float in Aziza's indoor pond.}
		view 184
		loop 3
		priority 15
		signal $0010
	)
)

(instance pond of Feature
	(properties
		x 273
		y 181
		noun '/oasis,water'
		nsTop 173
		nsLeft 229
		nsBottom 189
		nsRight 318
		description {the pond}
		lookStr {Aziza keeps an indoor pond.}
	)
)

(instance tableSound of Sound
	(properties
		number 181
		priority 5
		loop -1
	)
)

(instance spellCode of Code
	(properties)
	
	(method (doit)
		(localproc_000c 2 1)
		(return 0)
	)
)
