;;; Sierra Script 1.0 - (do not remove this comment)
(script# 199)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use TargActor)
(use Intrface)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm199 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	[local7 20]
	local27 =  -130
	local28
	local29 =  7
	local30
	[local31 8] = [{rakeesh} {omar} {keapon} {laffin} {WIT} {Wizards Institute} {Institute of Technocery} {erasmus}]
)
(procedure (localproc_000c &tmp temp0 botWindowBrRight botWindowBrLeft)
	(= botWindowBrRight (BotWindow brRight?))
	(= botWindowBrLeft (BotWindow brLeft?))
	(BotWindow color: 13 back: 0)
	(Print
		&rest
		#font
		userFont
		#title
		{Woman's Voice:}
		#window
		BotWindow
		#width
		(- botWindowBrRight (+ botWindowBrLeft 16))
	)
)

(instance rm199 of Rm
	(properties
		picture 700
		style $000f
		vanishingY 50
	)
	
	(method (init &tmp [temp0 20])
		(LoadMany 128 0 6 183 702)
		(= local1 (< currentTimeZone 2))
		(= local2 (OneOf currentTimeZone 4 5))
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(super init: &rest)
		(DrawFeature backWall)
		(ego init: illegalBits: local27)
		(door
			cel: (if (and (== prevRoomNum 180) (< global274 3))
				3
			else
				0
			)
			init:
		)
		(if (and (== global274 3) (== prevRoomNum 180))
			(self setScript: zapScript)
		else
			(self setScript: enterS)
		)
		(Bset 130)
		(= gGDftSC gAllSC)
	)
	
	(method (doit)
		(if (and (>= (ego y?) 188) (not script))
			(= gTopExit 2)
			(self setScript: exitS)
		)
		(super doit:)
	)
	
	(method (dispose)
		(= global317 global277)
		(= gTopExit 1)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'open,open/door') (curRoom setScript: openScript))
			((Said 'knock[/door]') (curRoom setScript: knockScript))
			(
				(or
					(Said 'lockpick[/lock]')
					(Said 'use/(lockpick[<lock]),lockpick')
					(Said 'unlock')
				)
				(if (or (ego has: 10) (ego has: 11))
					(curRoom setScript: zapScript)
				else
					(HighPrint 199 0)
				)
			)
		)
	)
)

(instance enterS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== prevRoomNum 180)
					(door setCycle: Beg)
					(ego posn: 160 90 setMotion: MoveTo 160 110 self)
				else
					(ego posn: 158 200 setMotion: MoveTo 160 179 self)
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance exitS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 160 220 self)
			)
			(1 (curRoom newRoom: 704))
		)
	)
)

(instance doorScript of Script
	(properties)
	
	(method (doit)
		(if (and (not state) (not (ego script?)))
			(self cue:)
		)
		(super doit:)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(1
				(= temp0 (if (== client zapScript) 105 else 85))
				(if (not (< (ego y?) 101))
					(ego setMotion: MoveTo 158 temp0 self)
				else
					(self cue:)
				)
			)
			(2 (ego loop: 3) (= cycles 1))
			(3 (self dispose:))
		)
	)
)

(instance openScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: doorScript self)
			)
			(1
				(HighPrint 199 1)
				(self dispose:)
			)
		)
	)
)

(instance knockScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: doorScript self)
			)
			(1
				(cond 
					(
						(or
							local6
							(and (== global317 global277) global274)
							(Btst 182)
						)
						(HighPrint 199 2)
						(self changeState: 2)
					)
					((== currentDay 16) (Bset 182) (curRoom setScript: goInside))
					((and (Btst 40) (not (== global274 3)))
						(localproc_000c (Format @local7 199 3 @userName))
						(curRoom setScript: goInside)
					)
					(else (curRoom setScript: azizaTest))
				)
			)
			(2 (self dispose:))
		)
	)
)

(instance azizaTest of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local7 0)
				(= local3 0)
				(if (and (< 0 global274) (< global274 3))
					(= local5 (localproc_000c 199 4 41 @local7 41))
					(= global274 0)
				else
					(= local5 (localproc_000c 199 5 41 @local7 41))
				)
				(= cycles 1)
			)
			(1
				(cond 
					((AnswerQuestion @local7 @userName) (TestSkill 13 100) (self changeState: 3))
					((or (== local3 1) (== local5 0))
						(localproc_000c 199 6)
						(= local6 1)
						(++ global274)
						(self changeState: 5)
					)
					(else
						(= local7 0)
						(++ local3)
						(localproc_000c 199 7 41 @local7 41)
						(self changeState: 1)
					)
				)
			)
			(3
				(= local7 0)
				(localproc_000c 199 8 41 @local7 41)
				(= local28 0)
				(while (<= local28 local29)
					(if (AnswerQuestion @local7 [local31 local28]) (break))
					(++ local28)
				)
				(if (== local28 3) (= local28 2))
				(if (OneOf local28 5 6) (= local28 4))
				(= local7 0)
				(switch local28
					(0
						(localproc_000c 199 9 41 @local7 41)
						(= local30
							(if (AnswerQuestion @local7 {demon})
							else
								(AnswerQuestion @local7 {wizard})
							)
						)
					)
					(1
						(localproc_000c 199 10 41 @local7 41)
						(= local30 (AnswerQuestion @local7 {friend}))
					)
					(2
						(localproc_000c 199 11 41 @local7 41)
						(= local30 (AnswerQuestion @local7 {air}))
					)
					(4
						(localproc_000c 199 12 41 @local7 41)
						(= local30
							(if
								(and
									(AnswerQuestion @local7 {earth})
									(AnswerQuestion @local7 {air})
									(AnswerQuestion @local7 {fire})
									(AnswerQuestion @local7 {water})
								)
							else
								(AnswerQuestion @local7 {all})
							)
						)
					)
					(7
						(localproc_000c 199 13 41 @local7 41)
						(= local30
							(if
								(or
									(AnswerQuestion @local7 {rat})
									(AnswerQuestion @local7 {fenrus})
								)
							else
								(AnswerQuestion @local7 {mouse})
							)
						)
					)
					(8
						(localproc_000c 199 14)
						(= local6 1)
						(self changeState: 5)
					)
				)
				(if (not local30)
					(localproc_000c 199 15)
					(= local6 1)
					(self changeState: 5)
				else
					(self cue:)
				)
			)
			(4
				(= local7 0)
				(BotWindow brRight: 150)
				(localproc_000c 199 16 41 @local7 15)
				(BotWindow brRight: 320)
				(if (not (AnswerQuestion @local7 {aziza}))
					(localproc_000c 199 17)
					(= local6 1)
					(self cue:)
				else
					(localproc_000c (Format @local7 199 18 @userName))
					(curRoom setScript: goInside)
				)
			)
			(5 (self dispose:))
		)
	)
)

(instance goInside of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (door setCycle: End self))
			(1
				(ego setMotion: MoveTo 158 80 self)
			)
			(2
				(Bset 40)
				(curRoom newRoom: 180)
			)
		)
	)
)

(instance zapScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
				(not (if (== global274 3) (== prevRoomNum 180)))
					(self setScript: doorScript self)
				else
					(self cue:)
				)
			)
			(1
				(if (and (== global274 3) (== prevRoomNum 180))
					(ego posn: 158 95 loop: 3 init: hide:)
				)
				(if local4
					(= cycles 1)
				else
					(sparkle
						init:
						posn: (ego x?) (ego y?)
						setCycle: CT 3 1 self
					)
				)
			)
			(2
				(if local4
					(self cue:)
				else
					(sparkle setCycle: End self)
				)
				(if (and (== global274 3) (== prevRoomNum 180))
					(ego show:)
				)
			)
			(3
				(if (not local4)
					(SkillUsed 14 -200)
					(if (and (== global274 3) (== prevRoomNum 180))
						(localproc_000c 199 19)
					else
						(HighPrint 199 20)
						(localproc_000c 199 21)
					)
					(++ global274)
				)
				(= [skills 17] 0)
				(sparkle
					show:
					posn: (ego x?) (ego y?)
					setCycle: CT 3 1 self
				)
			)
			(4
				(sparkle setCycle: End)
				(ego view: 22 loop: 0 setCycle: End self)
				(if (< (ego y?) 85)
					(ego setMotion: MoveTo (ego x?) 85)
				)
			)
			(5
				(if local4 (self changeState: 9) else (= cycles 10))
			)
			(6
				(sparkle hide:)
				(ego loop: 1 cel: 0 cycleSpeed: 2 setCycle: End self)
			)
			(7
				(proc1_19)
				(ego illegalBits: local27)
				(++ local4)
				(= cycles 2)
			)
			(8
				(HighPrint 199 22)
				(if (and (== global274 3) (== prevRoomNum 180))
					(HighPrint 199 23)
				)
				(self changeState: 10)
			)
			(9
				(HighPrint 199 24)
				(Die 0 199 25 80 {It's taps for a zapped sap...} 82 6 3 0)
			)
			(10 (self dispose:))
		)
	)
)

(instance backWall of PicView
	(properties
		x 159
		y 79
		view 702
		cel 3
	)
)

(instance door of TargActor
	(properties
		x 173
		y 78
		noun '[/door]'
		description {door}
		lookStr {The door seems to be watching you.}
		view 702
		loop 1
		illegalBits $0000
	)
	
	(method (detectMe)
		(HighPrint 199 26)
		(return 1)
	)
	
	(method (hurtMe)
		(self setScript: zapScript)
		(return 1)
	)
	
	(method (openMe)
		(self setScript: zapScript)
		(return 1)
	)
	
	(method (triggerMe)
		(self setScript: zapScript)
		(return 1)
	)
)

(instance sparkle of Prop
	(properties
		z 36
		view 183
		priority 15
		signal $0010
	)
)
