;;; Sierra Script 1.0 - (do not remove this comment)
(script# 200)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Stage)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	rm200 0
)

(local
	[local0 3] = [157 212 248]
	[local3 3] = [40 32 38]
	[local6 4] = [248 212 157 186]
	[local10 4] = [142 154 139 131]
	theCurrentTimeZone
	local15
	local16
	local17
	[local18 30]
	[local48 120]
	[local168 38] = [1 2 3 4 5 6 7 8 9 0 10 11 12 0 13 14 0 0 15 0 0 0 16 0 17 0 18 0 0 0 19 0 20]
	[local206 52] = [21 '//pawn,destruction,danger,grave,temptation,despair,desolation' 22 '//hero' 23 '//blackness' 24 '//sign' 25 '//amal,salim' 26 '//dragon' 27 '//scorpion' 28 '//service,job' 29 '//portent,omen' 30 '//star' 31 '//astrology' 32 '//planet' 33 '//hand' 34 '//shadow,eye' 35 '//constellation' 36 '//ali,boy' 37 '//zodiac' 38 '//poison' 39 '//map,chart' 40 '//chart,rebus' 41 '//bed' 42 '//model,orrery,(system<planetary)' 43 '//dartboard,dart,(board<dart)' 15 '//cost,due,rate' -1 '//fortune,fortune,horoscope,reading']
	[local258 45] = [0 21 23 17 9 5 5 13 17 9 17 7 2 5 17 25 5 23 7 17 7 0 2 9 13 17 17 17 23 5 5 17 13 21 9 13 2 21 9 13 13 21 2 13 23]
)
(procedure (localproc_1280 &tmp temp0 newAFoot)
	(= temp0 0)
	(while (< temp0 4)
		((= newAFoot (aFoot new:))
			x: [local6 temp0]
			y: [local10 temp0]
		)
		(DrawFeature newAFoot)
		(++ temp0)
	)
)

(procedure (localproc_12b2 &tmp temp0 newBedKnob)
	(= temp0 0)
	(while (< temp0 3)
		((= newBedKnob (bedKnob new:))
			x: [local0 temp0]
			y: [local3 temp0]
		)
		(DrawFeature newBedKnob)
		(++ temp0)
	)
)

(instance rm200 of Stage
	(properties
		picture 200
		style $0009
		west 704
		topExit 0
		bottomExit 0
		rightExit 0
		leftFromX -12
		leftFromY 180
		leftExit 2
		leftToX 92
		leftToY 154
	)
	
	(method (init)
		(LoadMany 128 200 205)
		(LoadMany 131 205)
		(Load rsSOUND 200)
		(= theCurrentTimeZone currentTimeZone)
		(AddToScore 616 5)
		(astro setPri: 11 init:)
		(body init:)
		(dart init: hide:)
		(ego init:)
		(proc1_19)
		(model init: setCycle: Fwd)
		(= entranceScript welcome)
		(super init:)
		(localproc_1280)
		(localproc_12b2)
		(DrawFeature dartBoard chart bedRuffle canopy rug)
		(proc1_31 roofHole ladder map symbol bed)
		(gCMusic number: 200 loop: -1 priority: 0 playBed:)
	)
	
	(method (doit)
		(if
		(and (& (ego onControl: 1) $0002) (!= inOut 1))
			(if (not (Btst 131))
				(Bset 131)
				(self setScript: firstTimeOut)
			else
				(= edgeHit 4)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gCMusic loop: 0 fade:)
		(= gTopExit 1)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 200 0))
			(
				(Said
					'tell//self,past,life,accomplishment,experience,adventure,spielburg'
				)
				(if (== gCurrentDay_3 -1)
					(if (TestSkill 13 50)
						(Bset 18)
						(SkillUsed 4 100)
					else
						(Bset 19)
						(SkillUsed 4 -100)
					)
					(Say astro 200 1 200 2 200 3)
					(= gCurrentDay_3 currentDay)
				else
					(Say astro 200 4)
				)
			)
			(
				(or
					(Said 'gave/alm,dinar,cent')
					(Said 'gave[/man,abu,astrologer]/alm,dinar,cent')
					(Said 'pay')
				)
				(if (== (proc3_1 100) 2)
					(proc3_2 100)
					(SkillUsed 14 25)
					(Say astro 200 5)
					(handMotionS start: 25)
					(body setScript: handMotionS)
				else
					(HighPrint 200 6)
				)
			)
			((Said 'thank') (SayThanks astro 200 7))
		)
	)
)

(instance welcome of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(FaceObject ego astro)
				(astro tLoop: 5)
				(switch (++ global262)
					(1
						(Say astro self 200 8 200 9 200 10 200 11)
						(= local18 0)
						(= local16 120)
					)
					(2
						(if
							(and
								(or (Btst 19) (Btst 18))
								(!= gCurrentDay_3 currentDay)
							)
							(Say astro self 200 12 200 13)
						else
							(Say astro self 200 14)
						)
					)
					(3
						(LockEgo)
						(curRoom setScript: readBook)
					)
					(else 
						(cond 
							((and (<= 3 currentDay) (<= currentDay 6)) (Say astro self 200 15))
							((and (<= 8 currentDay) (<= currentDay 10)) (Say astro self 200 16))
							((and (<= 12 currentDay) (<= currentDay 13)) (Say astro self 200 17))
							((and (<= 14 currentDay) (<= currentDay 15)) (Say astro self 200 18))
							(else (Say astro self 200 19))
						)
					)
				)
			)
			(1
				(if (not local16)
					(self changeState: 4)
				else
					(Print
						200
						20
						#title
						{Abu al-Njun:}
						#window
						TopWindow
						#edit
						@local18
						41
					)
					(if (StrLen @local18)
						(SkillUsed 13 20)
						(self changeState: 3)
					else
						(SkillUsed 13 -10)
						(Say astro self 200 21)
					)
				)
			)
			(2 (self changeState: 1))
			(3
				(if (not (AnswerQuestion @local18 @userName))
					(SkillUsed 14 -20)
					(Format @local48 200 22 @local18)
				else
					(SkillUsed 14 30)
					(StrCpy @local18 @userName)
					(Format @local48 200 23 @local18)
				)
				(Say astro self @local48 200 24)
			)
			(4 (LockEgo 1) (self dispose:))
		)
	)
)

(instance readBook of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(astro tLoop: 5)
				(Say astro self 200 25)
			)
			(1 (= cycles 4))
			(2
				(= local17 1)
				(astro hide:)
				(body
					loop: 4
					cel: 6
					cycleSpeed: 2
					setCycle: Beg self
					startUpd:
				)
			)
			(3 (= seconds 3))
			(4 (body setCycle: End self))
			(5
				(body cycleSpeed: 3 loop: 2 cel: 1 setCycle: Beg self)
			)
			(6 (Say astro self 200 26))
			(7 (= seconds 2))
			(8 (body setCycle: End self))
			(9
				(body setCycle: CT 1 -1 self)
			)
			(10
				(body stopUpd:)
				(astro loop: 5 cel: 0 tLoop: 5 show: talkSpeed: 1)
				(Say astro self 200 27)
			)
			(11 (= cycles 6))
			(12
				(astro hide:)
				(body loop: 3 setCycle: End self)
			)
			(13
				(dart
					show:
					illegalBits: 0
					setPri: 10
					setMotion: MoveTo 40 112 self
				)
			)
			(14
				(dart stopUpd:)
				(body loop: 1 cycleSpeed: 2 setCycle: Fwd)
				(= seconds 3)
			)
			(15
				(body setCycle: 0 loop: 0 cel: 5)
				(astro show: loop: 5 cel: 0)
				(Say astro self 200 28)
			)
			(16
				(body setCycle: Beg)
				(Say astro self 200 29)
			)
			(17 (Say astro self 200 30))
			(18 (self dispose:))
		)
	)
)

(instance firstTimeOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say astro self 200 31))
			(1
				(curRoom edgeHit: 4)
				(self dispose:)
			)
		)
	)
)

(instance handMotionS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (body setCycle: CT 2 1 self))
			(1 (body stopUpd:))
			(2 (body setCycle: End self))
			(3
				(body cel: 0 setCycle: CT 2 1 self)
			)
			(4 (body stopUpd:))
			(5
				(body cel: 0 setCycle: CT 7 1 self)
			)
			(6 (body stopUpd:))
			(7 (body cel: 1) (= cycles 2))
			(8 (body cel: 8 stopUpd:))
			(9
				(body setCycle: CT (Random 6 8) 1 self)
			)
			(10 (= cycles 5))
			(11 (body setCycle: Beg self))
			(12 (self changeState: 9))
			(13
				(body cel: 4 setCycle: CT 5 1 self)
			)
			(14
				(body setCycle: CT 1 -1 self)
			)
			(15 (= cycles (Random 1 8)))
			(16 (self changeState: 13))
			(17
				(body setCycle: CT 7 1 self)
			)
			(18 (= cycles 6))
			(19 (body setCycle: Beg self))
			(20 (body stopUpd:))
			(21
				(body setCycle: CT 7 1 self)
			)
			(22 (body stopUpd:))
			(23 (body setCycle: End self))
			(24 (body stopUpd:))
			(25
				(body cycleSpeed: 1 setCycle: End self)
			)
			(26
				(body setCycle: CT 8 1 self)
			)
			(27 (body stopUpd:))
		)
	)
)

(instance body of Prop
	(properties
		x 176
		y 147
		noun '/abu,man,astrologer'
		description {Abu Al-njun, the astrologer}
		lookStr {Every day the Astrologer thanks his lucky stars that he has lucky stars.}
		view 205
		cycleSpeed 2
	)
)

(instance astro of Talker
	(properties
		x 192
		y 126
		description {Abu Al-njun, the astrologer}
		lookStr {Every day the Astrologer thanks his lucky stars that he has lucky stars.}
		view 205
		loop 5
		signal $4000
		illegalBits $0000
		tLoop 5
		talkSpeed 1
		myName '//astrologer,abu,abu,man'
		title {Abu al-Njun:}
		color 13
		back 1
		msgFile 205
	)
	
	(method (atSpec param1)
		(return [local206 param1])
	)
	
	(method (atGen param1)
		(return [local168 param1])
	)
	
	(method (showText param1)
		(if (== param1 -1)
			(if local15
				(Say astro 200 32)
			else
				(= local15 1)
				(cond 
					((not (if (Btst 18) else (Btst 19))) (Say astro 200 33 200 34))
					((== gCurrentDay_3 currentDay) (Say astro 200 35 200 36))
					((Btst 19) (AddToScore 615 5) (Say astro 200 37 200 38))
					((Btst 18) (AddToScore 615 5) (Say astro 200 39 200 40 200 41))
				)
			)
		else
			(super showText: param1 &rest)
		)
	)
	
	(method (messages param1)
		(if (not local17)
			(handMotionS start: [local258 [param1 1]])
			(body
				cel: 0
				cycleSpeed: 1
				startUpd:
				setScript: handMotionS
			)
		)
		(super messages: param1 &rest)
	)
	
	(method (endTalk)
		(super endTalk:)
		(if (body script?)
			((body script?) dispose:)
			(body setCycle: 0 cel: 0 stopUpd: forceUpd:)
		)
	)
)

(instance dart of Actor
	(properties
		x 174
		y 144
		z 12
		shiftClick 0
		yStep 4
		view 200
		loop 2
		signal $1800
		xStep 12
	)
)

(instance model of Prop
	(properties
		x 259
		y 150
		noun '/model,orrery,(system<planetary)'
		description {a model of an unknown planetary system}
		lookStr {It's only a model of a planetary system.__It isn't the real thing.}
		view 200
		loop 3
		cycleSpeed 1
	)
)

(instance dartBoard of PicView
	(properties
		x 33
		y 132
		noun '/dartboard,(board[<dart])'
		description {a Psychic Dartboard}
		lookStr {You used to have a "Magic 8-Ball" that performed much the same function as this dartboard.}
		view 200
	)
)

(instance bedRuffle of PicView
	(properties
		x 203
		y 104
		shiftClick 0
		view 200
		loop 5
		priority 15
		signal $0010
	)
)

(instance chart of PicView
	(properties
		x 277
		y 128
		noun '/rebus,chart'
		description {a Cryptic Chart of Mystical Origins}
		lookStr {Let's see....\n"P" plus "explosion"....\nno wait...............\nplus "Ka-Boom!"....\nOh heck, you never were any good at these things anyway.}
		view 200
		loop 1
	)
)

(instance canopy of PicView
	(properties
		x 203
		y 51
		noun '/awning'
		description {the bed's canopy}
		lookStr {Helps to keep the stardust off of the sleeping Astrologer.}
		view 200
		loop 4
		priority 15
		signal $0010
	)
)

(instance ladder of Feature
	(properties
		x 147
		y 77
		noun '/ladder'
		nsTop 17
		nsLeft 137
		nsBottom 138
		nsRight 158
		description {the ladder to the roof}
		lookStr {The ladder must lead to the roof, where the star gazing is better.}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 8)
			(Say astro 200 42)
		else
			(super doVerb: theVerb)
		)
	)
)

(instance map of Feature
	(properties
		x 90
		y 88
		noun '/chart,map'
		nsTop 55
		nsLeft 57
		nsBottom 122
		nsRight 124
		description {a Map of the Heavens}
		lookStr {The stars are all out of place compared to Spielburg.__Where the heck IS this place?}
	)
)

(instance rug of PicView
	(properties
		x 193
		y 151
		noun '/carpet,carpet'
		description {the Astrologer's rug}
		lookStr {Skillful weaving by willful weavers.}
		view 200
		loop 8
		priority 2
		signal $0010
	)
)

(instance bed of Feature
	(properties
		x 202
		y 89
		noun '/bed'
		nsTop 75
		nsLeft 154
		nsBottom 104
		nsRight 251
		description {the Astrologer's bed}
		lookStr {You've heard of four-poster beds, but this is ridiculous.}
	)
)

(instance symbol of Feature
	(properties
		x 152
		y 19
		noun '/rune,star,pattern,ceiling'
		nsTop 5
		nsLeft 102
		nsBottom 33
		nsRight 202
		description {the star symbol on the ceiling}
		lookStr {A star with a hole like a doughnut.__How interesting.}
	)
)

(instance roofHole of Feature
	(properties
		x 153
		y 20
		noun '/chasm,open,open'
		nsTop 16
		nsLeft 137
		nsBottom 25
		nsRight 169
		description {the hole in the roof}
		lookStr {Lookit the hole in the ceiling!\nGee!__What happens if it rains?}
	)
)

(instance aFoot of PicView
	(properties
		shiftClick 0
		view 200
		loop 6
	)
)

(instance bedKnob of PicView
	(properties
		shiftClick 0
		view 200
		loop 7
		priority 11
		signal $0010
	)
)
