;;; Sierra Script 1.0 - (do not remove this comment)
(script# 215)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use ProjClient)
(use n065)
(use Intrface)
(use Block)
(use ForCount)
(use LoadMany)
(use Wander)
(use Motion)
(use Game)
(use Menu)
(use Actor)
(use System)

(public
	rm215 0
)

(local
	local0
	local1
	local2
	[local3 6] = [{Erasmus:} 11 5 {Fenrus:} 5 11]
)
(procedure (localproc_12a0)
	(HighPrint 215 12)
	(localproc_12db 0 215 13)
	(localproc_12db 1 215 14)
	(localproc_12db 0 215 15)
	(curRoom setScript: zapEgoOutS)
)

(procedure (localproc_12db param1 &tmp temp0 temp1 temp2)
	(= temp0 (= temp1 (* param1 3)))
	(= temp2 (if (== param1 1) MidWindow else TopWindow))
	(temp2
		color: [local3 (++ temp0)]
		back: [local3 (++ temp0)]
	)
	(Print
		&rest
		#title
		[local3 temp1]
		#width
		300
		#window
		temp2
		#mode
		1
	)
)

(procedure (localproc_1324 param1)
	(return
		(cond 
			((leftBell onMe: param1) leftBell)
			((midBell onMe: param1) midBell)
			((rightBell onMe: param1) rightBell)
			(else 0)
		)
	)
)

(instance blackCage of Cage
	(properties
		top 48
		left 133
		bottom 50
		right 183
	)
)

(instance rm215 of Rm
	(properties
		picture 2
		style $000f
	)
	
	(method (init)
		(LoadMany 128 211 212 213 214 183)
		(Load rsSCRIPT 970)
		(Load rsSOUND 19 17 31 215)
		(MenuBar hide:)
		(super init:)
		(leftBell init: stopUpd:)
		(midBell init: stopUpd:)
		(rightBell init: stopUpd:)
		(DrawFeature bellStand)
		(ego
			view: 211
			loop: 0
			cel: 0
			posn: 159 189
			init:
			ignoreActors:
			stopUpd:
		)
		(= gGDftSC gAllSC)
		(self setScript: pretestS)
	)
	
	(method (dispose)
		(DisposeScript 949)
		(LockEgo 1)
		(super dispose:)
	)
)

(instance pretestS of ProjClient
	(properties)
	
	(method (changeState newState &tmp temp0 [temp1 100])
		(switch (= state newState)
			(0
				(HighPrint 215 0)
				(LockEgo 1)
				(UnlockEgo)
				(= cycles 4)
			)
			(1
				(if
				(not (if (and [skills 20] [skills 21]) [skills 26]))
					(localproc_12db 0 215 1)
					(client setScript: zapEgoOutS)
				else
					(SetInput 0)
				)
				(= local2 0)
			)
			(2
				(SetInput 1)
				(ego setLoop: 2 cycleSpeed: 2 setCycle: End self)
				(gMiscMusic number: 19 priority: 10 loop: 0 play:)
			)
			(3
				(if (not local0)
					(= local0
						(if local1
							(cond 
								((!= local1 rightBell) rightBell)
								((!= local1 leftBell) midBell)
							)
						else
							(switch (Random 1 3)
								(1 leftBell)
								(2 midBell)
								(3 rightBell)
							)
						)
					)
				)
				(local0 setCycle: ForwardCounter 6 self)
			)
			(4 (ego setCycle: Beg self))
			(5
				(ego setLoop: 0)
				(local0 setCel: 0 stopUpd:)
				(SetInput 0)
			)
			(6
				(SetInput 1)
				(ego setLoop: 1 cycleSpeed: 2)
				(self setScript: (AimSpell new:) self)
			)
			(7
				(if (= temp0 (localproc_1324 self)) (= local1 temp0))
				(ego setCycle: End self)
			)
			(8
				(if local1
					(gMiscMusic number: 17 priority: 10 loop: 0 play:)
					(lassoFor
						posn: 184 158
						cycleSpeed: 3
						setLoop: 7
						cel: 0
						init:
						setCycle: End
						setStep: 8 8
						setMotion: MoveTo (local1 x?) (+ (local1 y?) 8) self
					)
				else
					(localproc_12a0)
				)
			)
			(9
				(local1
					setLoop: 0
					setCycle: Fwd
					setMotion: MoveTo 158 40 self
				)
				(lassoFor
					setLoop: 6
					cycleSpeed: 0
					posn: (- (local1 x?) 27) (+ (local1 y?) 17)
					setCycle: Fwd
				)
				(lassoBack
					posn: (- (local1 x?) 27) (+ (local1 y?) 2)
					setCycle: Fwd
					init:
				)
			)
			(10
				(local1 moveSpeed: 2 setMotion: MoveTo 158 73 self)
			)
			(11
				(local1 setCel: 0 stopUpd:)
				(lassoFor dispose:)
				(lassoBack dispose:)
				(ego setCycle: Beg self)
			)
			(12
				(ego setLoop: 0)
				(SetInput 0)
			)
			(13
				(self setScript: (AimSpell new:) self)
				(SetInput 1)
			)
			(14
				(if
					(and
						(= temp0 (localproc_1324 self))
						(== temp0 local1)
						(== local1 local0)
					)
					(= local2 temp0)
					(local2 setLoop: 2 cel: 0 setCycle: End self)
					(ego setLoop: 1 setCycle: End)
					(gMiscMusic number: 31 priority: 10 loop: 0 play:)
					(switch local2
						(leftBell
							(zapBellS register: midBell)
							(rightBell setScript: zapBellS)
						)
						(rightBell
							(zapBellS register: midBell)
							(leftBell setScript: zapBellS)
						)
						(else 
							(zapBellS register: rightBell)
							(leftBell setScript: zapBellS)
						)
					)
				else
					(HighPrint 215 2)
					(localproc_12a0)
				)
			)
			(15
				(local2 setLoop: 3 cel: 0 setCycle: ForwardCounter 8 self)
				(gCMusic number: 215 loop: 1 priority: 0 playBed:)
			)
			(16
				(local2 setLoop: 2 cel: 0 setCycle: End self)
				(ego setCycle: Beg)
			)
			(17
				(local2
					setLoop: 4
					cel: 0
					cycleSpeed: 1
					setCycle: ForwardCounter 3 self
				)
				(ego setLoop: 0)
			)
			(18
				(AddToScore 686 7 1)
				(local2 loop: 8)
				(fenrus init:)
				(erasmus init: setCycle: CT 2 1 self)
			)
			(19
				(erasmus setCel: 3 setMotion: MoveTo 85 26 self)
			)
			(20
				(erasmus
					view: 214
					posn: 59 33
					setLoop: 0
					cel: 0
					setCycle: End self
				)
			)
			(21
				(erasmus setLoop: 1 cel: 0 setCycle: End self)
			)
			(22
				(black1 init: posn: 45 20 setMotion: MoveTo 45 63 self)
				(black2 init: posn: 89 20 setMotion: MoveTo 89 63)
			)
			(23
				(fenrus hide:)
				(local2
					setLoop: 5
					cycleSpeed: 0
					setCycle: ForwardCounter 3 self
				)
				(erasmus hide:)
			)
			(24
				(local2 setLoop: 8 stopUpd:)
				(fenrus show: setCycle: CT 2 1 self)
			)
			(25
				(fenrus setCel: 3 setMotion: MoveTo 221 27 self)
			)
			(26
				(fenrus
					posn: 240 33
					view: 214
					setLoop: 0
					cel: 0
					setCycle: End self
				)
			)
			(27
				(fenrus setLoop: 2 cel: 0 setCycle: End self)
			)
			(28
				(black1 init: posn: 225 20 setMotion: MoveTo 225 63 self)
				(black2 init: posn: 269 20 setMotion: MoveTo 269 63)
			)
			(29
				(fenrus dispose:)
				(black2 dispose:)
				(black1 hide:)
				(local2
					view: 213
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(30
				(sparkle
					view: 213
					loop: 1
					cel: 0
					posn: 154 76
					init:
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(31
				(local2 setCycle: Beg self)
				(erasmus view: 213 setLoop: 3 cel: 0 posn: 168 49 show:)
				(black1
					show:
					setStep: 1 1
					posn: 168 49
					setMotion: Wander
					observeBlocks: blackCage
				)
			)
			(32
				(sparkle dispose:)
				(= cycles 6)
			)
			(33
				(erasmus tLoop: 2)
				(Say
					erasmus
					self
					(Format
						@temp1
						{Very good, %s.__You have shown yourself very capable in figuring out the spells needed for the pretest.}
						@userName
					)
				)
			)
			(34
				(erasmus cel: 1 tLoop: 2)
				(Say erasmus self 215 3)
			)
			(35
				(erasmus tLoop: 2)
				(Say erasmus self 215 4)
			)
			(36
				(localproc_12db 1 215 5)
				(erasmus tLoop: 2)
				(Say erasmus self 215 6)
			)
			(37
				(erasmus loop: 3 cel: 2)
				(= cycles 8)
			)
			(38
				(localproc_12db 1 215 7)
				(erasmus tLoop: 2)
				(Say erasmus self 215 8)
			)
			(39
				(localproc_12db
					1
					(Format @temp1 {Good luck, %s.} @userName)
				)
				(gCMusic fade:)
				(curRoom newRoom: 210)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'save[/game]') (HighPrint 215 9))
			(
			(and (Said 'cast>') (= temp0 (proc65_0 pEvent)))
				(switch temp0
					(20 (self changeState: 2))
					(26
						(if local1
							(localproc_12db 0 215 10)
						else
							(self changeState: 6)
						)
					)
					(21 (self changeState: 13))
					(else 
						(pEvent claimed: 1)
						(HighPrint 215 11)
						(localproc_12a0)
					)
				)
			)
		)
	)
)

(instance zapEgoOutS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= [skills 17] 0)
				(sparkle
					view: 183
					loop: 0
					cel: 0
					posn: (ego x?) (- (ego y?) 36)
					setCycle: End self
					init:
				)
			)
			(1
				(sparkle dispose:)
				(ego hide:)
				(= cycles 4)
			)
			(2
				(= gTopExit 3)
				(curRoom newRoom: 229)
			)
		)
	)
)

(instance zapBellS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(sparkle
					init:
					posn: (register x?) (register y?)
					cel: 0
					setCycle: End self
				)
			)
			(1
				(register view: 214 cel: 0 setLoop: 4 setCycle: End self)
			)
			(2
				(sparkle
					posn: (client x?) (client y?)
					cel: 0
					setCycle: End self
				)
			)
			(3
				(client view: 214 cel: 0 setLoop: 4 setCycle: End self)
			)
			(4
				(register hide:)
				(client hide:)
				(sparkle dispose:)
				(self dispose:)
			)
		)
	)
)

(instance leftBell of Actor
	(properties
		x 89
		y 103
		noun '/bell'
		description {any of the bells}
		lookStr {If it looks like a bell, and it sounds like a bell, it's a bell.}
		view 212
		loop 1
		priority 10
		signal $4010
	)
)

(instance midBell of Actor
	(properties
		x 159
		y 129
		noun '/bell'
		description {any of the bells}
		lookStr {Ask not for whom the bell tolls...it tolls for YOU.}
		view 212
		loop 1
		priority 10
		signal $4010
	)
)

(instance rightBell of Actor
	(properties
		x 229
		y 103
		noun '/bell'
		description {any of the bells}
		lookStr {She was the belle of the ball 'til someone tolled on her.}
		view 212
		loop 1
		priority 10
		signal $4010
	)
)

(instance bellStand of PicView
	(properties
		x 158
		y 127
		noun '/stand[<bell]'
		description {the bell stand}
		lookStr {It's not real obvious at first what this does, but it's intricately carved.}
		view 214
		loop 3
		priority 8
		signal $4010
	)
)

(instance lassoFor of Actor
	(properties
		view 214
		loop 6
		priority 13
		signal $4010
	)
)

(instance lassoBack of Actor
	(properties
		view 214
		loop 5
		priority 9
		signal $4010
	)
	
	(method (doit)
		(lassoFor x: (- (local1 x?) 27))
		(lassoFor y: (+ (local1 y?) 17))
		(= x (- (local1 x?) 27))
		(= y (+ (local1 y?) 2))
		(super doit:)
	)
)

(instance erasmus of Talker
	(properties
		x 152
		y 80
		noun '/erasmus,wizard,mage,man'
		description {Erasmus}
		lookStr {It ain't Fenrus.}
		yStep 9
		view 212
		loop 6
		priority 2
		signal $5810
		xStep 9
		talkSpeed 0
		title {Erasmus:}
		color 11
		back 5
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow MidWindow)
	)
)

(instance fenrus of Actor
	(properties
		x 166
		y 80
		noun '/fenrus,fenrus,fenrus,familiar,firework'
		description {Fenrus}
		lookStr {It ain't Erasmus.}
		yStep 9
		view 212
		loop 7
		priority 2
		signal $5810
		xStep 9
	)
)

(instance black1 of Actor
	(properties
		x 106
		y 66
		yStep 4
		view 213
		loop 4
		priority 14
		signal $5810
	)
)

(instance black2 of Actor
	(properties
		x 226
		y 66
		yStep 4
		view 213
		loop 4
		priority 14
		signal $5810
	)
)

(instance sparkle of Prop
	(properties
		view 183
		priority 15
		signal $4010
	)
)
