;;; Sierra Script 1.0 - (do not remove this comment)
(script# 229)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Stage)
(use TargActor)
(use Intrface)
(use ForCount)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	rm229 0
)

(local
	local0
)
(procedure (localproc_000c &tmp temp0 botWindowBrRight botWindowBrLeft)
	(= botWindowBrRight (BotWindow brRight?))
	(= botWindowBrLeft (BotWindow brLeft?))
	(BotWindow color: 15 back: 8)
	(Print
		&rest
		#font
		userFont
		#title
		{Voices:}
		#window
		BotWindow
		#width
		(- botWindowBrRight (+ botWindowBrLeft 16))
		#mode
		1
	)
)

(instance rm229 of Stage
	(properties
		picture 700
		style $0009
		south 704
		bottomFromX 158
		bottomFromY 192
		bottomToX 158
		bottomToY 147
	)
	
	(method (init &tmp [temp0 20])
		(LoadMany 128 0 22 700 183 703)
		(Load rsSOUND 16)
		(proc1_19)
		(ego init: illegalBits: -384)
		(super init: &rest)
		(DrawFeature wallLeft wallRight)
		(= saveIllegal -384)
		(door init:)
		(if (OneOf prevRoomNum 210 215 220)
			(ego posn: 158 100 hide:)
			(Bset 2)
			(self setScript: zapInScript)
		)
		(= gGDftSC gAllSC)
	)
	
	(method (doit)
		(if (and (== inOut 3) (>= (ego y?) 192))
			(= edgeHit 3)
		)
		(super doit:)
	)
	
	(method (dispose)
		(= gTopExit 2)
		(door dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
				(Said
					'look,examine,feel[/alley,passage,street,road,wall,ground]'
				)
				(cond 
					(local0 (HighPrint 229 0))
					((ego knows: 20) (HighPrint 229 1))
					(else (HighPrint 229 2))
				)
			)
			((Said 'look,examine/door,gate') (if local0 (HighPrint 229 0) else (HighPrint 229 3)))
		)
	)
)

(instance showDoorS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door loop: 0 cel: 0 setCycle: ForwardCounter 3 self)
			)
			(1
				(door loop: 1 setCycle: End self)
				(= cycles 12)
			)
			(2
				(if (not local0) (Print 229 4) (= local0 1))
				(self dispose:)
			)
		)
	)
)

(instance goInsideS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not local0)
					(door setLoop: 1 cel: 0 cycleSpeed: 0 setCycle: End self)
				else
					(self cue:)
				)
			)
			(1
				(door loop: 2 cel: 0 cycleSpeed: 3 setCycle: End self)
			)
			(2
				(ego
					ignoreActors:
					ignoreHorizon:
					illegalBits: 0
					setMotion: MoveTo 158 77 self
				)
			)
			(3
				(sparkle cel: 0 posn: 158 60 init: setCycle: CT 2 1 self)
			)
			(4
				(ego hide:)
				(sparkle setCycle: End self)
			)
			(5
				(= gTopExit 1)
				(Bset 28)
				(Bclr 2)
				(curRoom newRoom: 210)
			)
		)
	)
)

(instance flashDoorS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= register (door loop?))
				(door loop: 3 cel: 0 cycleSpeed: 1 setCycle: End self)
			)
			(1 (door setCycle: Beg self))
			(2
				(if register (door cel: 2))
				(door loop: register)
				(if register
					(SetUpEgo)
					(Print 229 5)
				else
					(door cel: 0)
					(SetUpEgo)
					(Print 229 6)
				)
				(self dispose:)
			)
		)
	)
)

(instance zapInScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo 1)
				(UnlockEgo)
				(gCMusic stop:)
				(sparkle init: cel: 0 posn: 158 80 setCycle: CT 2 1 self)
			)
			(1
				(ego show:)
				(if (= register (!= prevRoomNum 220))
					(ego loop: 3)
				else
					(ego view: 22 loop: 0 cel: 2 setCycle: CT 6 1)
					(ReduceSP 10)
				)
				(sparkle setCycle: End self)
			)
			(2
				(sparkle dispose:)
				(if register
					(ego view: 22 loop: 0 setCycle: CT 6 1 self)
				else
					(self cue:)
				)
			)
			(3
				(gSpareMusic number: 16 loop: 1 play:)
				(= cycles 10)
			)
			(4
				(ego loop: 1 cel: 0 cycleSpeed: 1 setCycle: End self)
			)
			(5
				(proc1_19)
				(ego loop: 3 illegalBits: -384)
				(= cycles 2)
			)
			(6
				(if (and (== prevRoomNum 220) (not (Btst 65)))
					(HighPrint 229 7)
					(if (Btst 162)
						(localproc_000c 229 8)
					else
						(localproc_000c 229 9)
					)
				)
				(LockEgo)
				(self dispose:)
			)
		)
	)
)

(instance wallLeft of PicView
	(properties
		x 160
		y 79
		view 700
		loop 2
		cel 3
		signal $4000
	)
)

(instance wallRight of PicView
	(properties
		x 160
		y 79
		view 700
		loop 3
		cel 3
		signal $4000
	)
)

(instance door of TargActor
	(properties
		x 160
		y 77
		view 703
		signal $4000
		illegalBits $0000
	)
	
	(method (isNotHidden)
		(return 1)
	)
	
	(method (detectMe)
		(self setScript: showDoorS)
		(return 1)
	)
	
	(method (hurtMe param1 param2 &tmp temp0)
		(return
			(if (OneOf (param2 type?) 25 27)
				(self setScript: flashDoorS)
				(return 1)
			else
				(return 0)
			)
		)
	)
	
	(method (openMe)
		(return
			(if (Btst 65)
				(Print 229 10)
				(return 0)
			else
				(self setScript: goInsideS)
				(return 1)
			)
		)
	)
)

(instance sparkle of Prop
	(properties
		view 183
		priority 15
		signal $4010
	)
)
