;;; Sierra Script 1.0 - (do not remove this comment)
(script# 303)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Stage)
(use TryToMoveTo)
(use Elemental)
(use LoadMany)
(use Reverse)
(use Timer)
(use Motion)
(use Actor)
(use System)

(public
	rm303 0
)

(local
	[local0 25]
	local25 =  -130
	local26
	local27
	local28
	gEgoCycler
	[local30 25] = [0 {Ow!__Hey!} {Man, that's hot!} {Wowf!} {Yowp!} {Watch out!} {Ouch!} {Yikes!} {Geez!} 2 3 0 2 0 1 2 3 -15 -15 15 -15 -15 15 15 15]
)
(instance rm303 of Stage
	(properties
		picture 303
		style $000f
		north 704
		south 704
		vanishingY 50
		bottomFromX 158
		bottomFromY 250
		bottomToX 158
	)
	
	(method (init &tmp [temp0 22])
		(LoadMany 128 0 1 18 19 21 47 61 340 700 701)
		(LoadMany 130 969)
		(= gEgoLocXCoord 40)
		(= gEgoLocYCoord 1)
		(proc1_19)
		(ego view: 18 loop: 3 illegalBits: local25 init:)
		(= entranceScript enterScript)
		(AFeat_1 init:)
		(AFeat_2 init:)
		(AFeat_3 init:)
		(AFeat_4 init:)
		(AFeat_5 init:)
		(AFeat_6 init:)
		(AFeat_7 init:)
		(super init:)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			((& (ego onControl: 1) $0080) (ego hide:) (curRoom newRoom: 704))
			(
				(and
					(== (fireElemental loop?) 0)
					(== (fireElemental attackDist?) 15)
				)
				(fireElemental attackDist: 1)
			)
			(
				(and
					(fleeTimer client?)
					(== (ego y?) (fireElemental y?))
					(== (fireElemental attackDist?) 1)
				)
				(fleeTimer cue:)
			)
			(
				(and
					(< (ego y?) 115)
					(not local26)
					(not (ego script?))
				)
				(HighPrint 303 0)
				(proc1_19)
				(ego use: 13 1 loop: 2 illegalBits: local25)
				(= local26 1)
			)
		)
	)
	
	(method (dispose)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(ChangeEgoWalk 0 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'run') (ChangeEgoWalk 1 0) (ego setMotion: MoveTo 160 0))
			(
				(Said
					'deposit,use,done,spread,sprinkle,strew,dust/trail,frankincense'
				)
				(cond 
					((OneOf (ego view?) 18 21) (HighPrint 303 1))
					((ego has: 13) (HighPrint 303 2))
					(else (HighPrint 303 3))
				)
			)
			((not local26) (pEvent claimed: 1) (HighPrint 303 4))
			((Said '/lamp>')
				(cond 
					((not (ego has: 33)) (pEvent claimed: 1) (PrintDontHaveIt))
					((Said 'put<down') (HighPrint 303 5) (ego setScript: doLamp 0 1))
					((Said 'deposit') (HighPrint 303 6) (ego setScript: doLamp 0 1))
					((Said 'use,set')
						(if (== elementalsStatus 1)
							(ego setScript: doLamp 0 1)
						else
							(pEvent claimed: 0)
						)
					)
				)
			)
			(
				(or
					(Said
						'spray,squirt,splash/fire,(elemental[<fire]),water,waterbag'
					)
					(Said 'douse,(put<out)/fire,(elemental[<fire])')
					(Said 'throw,use/water,waterbag')
				)
				(cond 
					((<= currentWater 0) (HighPrint 303 7))
					((> (fireElemental y?) 180) (HighPrint 303 8))
					((> (ego distanceTo: fireElemental) 50) (HighPrint 303 9))
					(else
						(= currentWater 0)
						(fireElemental setScript: douseElemental)
					)
				)
			)
		)
	)
	
	(method (cue)
		(super cue:)
		(= gEgoCycler (ego cycler?))
	)
)

(instance getBurned of HandsOffScript
	(properties)
	
	(method (init)
		(super init: &rest)
		(UnlockEgo)
	)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(ego
					view: 19
					setLoop: (if (< (ego x?) 160) 1 else 0)
					setCycle: End self
				)
			)
			(1
				(= temp1 (if (cast contains: lamp) (lamp y?) else 115))
				(= temp0
					(+ (ego x?) (if (< (ego x?) 160) 8 else -8))
				)
				(if (< (ego y?) temp1)
					(HighPrint 303 10)
					(ego hide:)
					(curRoom newRoom: 704)
				else
					(ego
						view: 0
						setLoop: 2
						setCycle: Rev
						setMotion: MoveTo temp0 (- (ego y?) 15) self
					)
				)
			)
			(2
				(HighPrint
					(Format @local0 303 11 [local30 (Random 1 8)])
				)
				(if (not (ReduceHP 40))
					(Die
						0
						303
						12
						80
						{All your joints feel inflamed...}
						82
						19
						2
						4
					)
				else
					(self cue:)
				)
			)
			(3
				(proc1_19)
				(ego
					view: (gEgoCycler vWalking?)
					loop: 2
					illegalBits: local25
					setCycle: gEgoSW (gEgoCycler vStopped?)
				)
				(LockEgo 1)
				(= cycles 12)
			)
			(4
				(fireElemental cue:)
				(ego hurtScript: 0)
				(self dispose:)
			)
		)
	)
)

(instance douseElemental of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1 fireElementalX fireElementalY)
		(switch (= state newState)
			(0
				(= fireElementalX (fireElemental x?))
				(= fireElementalY (fireElemental y?))
				(if (> fireElementalX 160)
					(= temp0 (- fireElementalX 30))
					(= local28 0)
				else
					(= temp0 (+ fireElementalX 30))
					(= local28 1)
				)
				(= temp1 (- fireElementalY 8))
				(client setMotion: 0)
				(ego setMotion: MoveTo temp0 temp1 self)
			)
			(1
				(ego view: 61 loop: local28 setCycle: Fwd)
				(fireElemental
					loop: 4
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(2
				(ego view: 0 loop: (+ (ego loop?) 4) setCycle: gEgoSW 4)
				(fireElemental loop: 0 cycleSpeed: 0 setCycle: Fwd)
				(proc1_32 fleeTimer 15)
				(= cycles 1)
			)
			(3
				(proc1_19)
				(ego illegalBits: local25)
				(if local27
					(fireElemental setScript: jumpIntoLamp)
				else
					(fireElemental setPri: -1)
				)
				(self dispose:)
			)
		)
	)
)

(instance jumpIntoLamp of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(if (>= (ego heading?) 180)
					(ego setMotion: MoveTo (- (ego x?) 10) (ego y?) self)
				else
					(ego setMotion: MoveTo (+ (ego x?) 10) (ego y?) self)
				)
			)
			(1
				(FaceObject ego fireElemental)
				(= temp0 (+ (lamp x?) 20))
				(= temp1 (+ (lamp y?) 3))
				(fireElemental
					setPri: -1
					setMotion: MoveTo temp0 temp1 self
				)
			)
			(2
				(FaceObject ego lamp)
				(fireElemental loop: 5 setCycle: End self)
			)
			(3
				(AddToScore 622 20)
				(SkillUsed 14 100)
				(gCMusic fade:)
				(Bclr 181)
				(++ elementalsStatus)
				(lamp setCycle: Fwd)
				(ego setScript: doLamp 0 0)
				(fleeTimer dispose:)
				(fireElemental dispose: delete:)
			)
		)
	)
)

(instance enterScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fireElemental posn: 158 250 setCycle: Fwd init:)
				(ego setCycle: gEgoSW 21)
				(self dispose:)
			)
		)
	)
)

(instance doLamp of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== register 0)
					(ego setMotion: MoveTo 160 (+ (lamp y?) 3) self)
				else
					(ego setMotion: MoveTo 160 (ego y?) self)
				)
			)
			(1 (ego setHeading: 270 self))
			(2
				(ego view: 47 loop: 1 setCycle: End self)
			)
			(3
				(if (== register 1)
					(lamp posn: 145 (- (ego y?) 3) init:)
					(ego use: 33)
					(= local27 1)
				else
					(lamp dispose:)
					(ego get: 33)
					(= local27 0)
				)
				(ego setCycle: Beg self)
			)
			(4
				(if (== register 1)
					(ChangeEgoWalk 0 0)
					(ego setMotion: MoveTo 180 (- (ego y?) 15) self)
				else
					(if (== elementalsStatus 2)
						(HighPrint 303 13)
					else
						(HighPrint 303 14)
					)
					(self cue:)
				)
			)
			(5
				(if (cast contains: lamp)
					(FaceObject ego lamp 0 self)
				else
					(= cycles 1)
				)
			)
			(6
				(proc1_19)
				(ego illegalBits: local25)
				(if (fleeTimer client?) (fleeTimer cue:))
				(self dispose:)
			)
		)
	)
)

(instance fireElemental of Elemental
	(properties
		x 160
		y 160
		noun '/elemental'
		description {the fire elemental}
		lookStr {You see a magical mass of fire.}
		view 340
		loop 2
		priority 14
		signal $6810
		following 1
	)
	
	(method (attack)
		(ego hurtScript: getBurned)
		(super attack:)
	)
	
	(method (follow &tmp temp0 temp1 temp2)
		(= temp0 (* 5 (= temp2 (- x (ego x?)))))
		(if (< (= temp1 (Random 1 100)) temp0)
			(= newX (- x (Random 1 (+ 10 temp2))))
		else
			(= temp2 (Abs temp2))
			(= newX (+ x (Random 1 (+ 10 temp2))))
		)
		(cond 
			((ego script?))
			((< y 105) (= newX 160) (= newY 70))
			((> y (ego y?)) (= newY (- y 7)))
			(else (= newY (ego y?)))
		)
		(self setMotion: TryToMoveTo newX newY 500 self)
	)
)

(instance lamp of Prop
	(properties
		x 150
		y 150
		noun '/lamp'
		description {the lamp}
		view 340
		loop 7
		cel 2
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '(lockpick<up)/lamp')
				(if local27
					(ego setScript: doLamp 0 0)
				else
					(HighPrint 303 15)
				)
			)
		)
	)
	
	(method (doVerb theVerb)
		(cond 
			((== theVerb 1)
				(if (!= elementalsStatus 1)
					(HighPrint 303 16)
				else
					(HighPrint 303 17)
				)
			)
			((== theVerb 7)
				(if local27
					(ego setScript: doLamp 0 0)
				else
					(HighPrint 303 18)
				)
			)
		)
	)
)

(instance fleeTimer of Timer
	(properties)
	
	(method (cue)
		(if local27
			(fireElemental setScript: jumpIntoLamp)
		else
			(HighPrint 303 19)
			(fireElemental
				cycleSpeed: 0
				yStep: 5
				setMotion: MoveTo (fireElemental x?) 250
			)
			(self dispose:)
		)
	)
)

(instance AFeat_1 of View
	(properties
		x 118
		y 118
		noun '/door'
		description {the door}
		lookStr {It's a door to nowhere.}
		view 701
		cel 4
		priority 8
		signal $6014
	)
)

(instance AFeat_2 of View
	(properties
		x 188
		y 90
		noun '/door'
		description {the door}
		lookStr {It's another door to nowhere.}
		view 701
		loop 1
		cel 8
		priority 5
		signal $6014
	)
)

(instance AFeat_3 of View
	(properties
		x 136
		y 45
		noun '/sconce,light,torch'
		description {the sconce}
		lookStr {At least there's SOME light in here.}
		view 701
		loop 4
		cel 12
		priority 15
		signal $6014
	)
)

(instance AFeat_4 of View
	(properties
		x 176
		y 69
		noun '/door'
		description {the door}
		lookStr {It's the door to success.}
		view 701
		loop 1
		cel 12
		priority 3
		signal $6014
	)
)

(instance AFeat_5 of View
	(properties
		x 160
		y 80
		noun '/door'
		description {the door}
		lookStr {Through this door lies the other side.}
		view 700
		priority 1
		signal $6014
	)
)

(instance AFeat_6 of View
	(properties
		x 160
		y 102
		noun '/door'
		description {the door}
		lookStr {I'll take what's behind door number 3.}
		view 700
		priority 1
		signal $6014
	)
)

(instance AFeat_7 of View
	(properties
		x 160
		y 140
		noun '/door'
		description {the door}
		lookStr {Huh?__It's only PAINTED on.}
		view 700
		priority 1
		signal $6014
	)
)
