;;; Sierra Script 1.0 - (do not remove this comment)
(script# 360)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use Talker)
(use Flame)
(use Full)
(use Intrface)
(use PolyPath)
(use Polygon)
(use Feature)
(use MoveFwd)
(use LoadMany)
(use Timer)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm360 0
	ferrari 1
	bartender 2
	barMoveTimer 3
	wipeTimer 4
	waitTimer 5
	seatEgo 6
	proc360_7 7
)

(local
	[local0 50]
	local50
	local51
	[local52 4] = [0 50 75 100]
	local56
	[local57 38] = [20 21 22 19 19 19 19 19 19 19 23 19 24 19 25 19 19 19 26 27 19 28 19 29 30 19 19 19 19 19 19 19 31 19 19 19 19 19]
	[local95 34] = [0 '//bird,falcon' 1 '//barman,barman' 2 '//room,cost' 3 '//bill,bill' 4 '//night' 5 '//ugarte' 6 '//game' 7 '//ability' 8 '//news' 9 '//ad[<ad]' 10 '//performance' 11 '//order' 12 '//service' 13 '//info' 14 '//khaveen' 15 '//someone']
	[local129 16] = [0 '//drink' 1 '//water' 2 '//waterman,(man<water)' 3 '//coffee' 4 '//sling<djinn' 5 '//senor,(ferrari<senor)' 6 '//ferrari']
	[local145 10] = [152 32 135 117 167 118 158 72 205 26]
	[local155 6] = [197 20 228 58 266 13]
	[local161 6] = [257 21 321 69 321 8]
	[local167 6] = [321 93 312 132 321 148]
	[local173 12] = [1 157 119 129 140 134 138 159 85 181 1 191]
	[local185 14] = [184 114 183 118 178 121 182 125 186 125 190 122 186 119]
	[local199 8] = [186 93 182 99 186 101 190 99]
	[local207 10] = [238 95 234 101 236 104 240 104 242 101]
	[local217 14] = [295 100 294 104 291 106 292 109 299 109 300 107 297 103]
	[local231 18] = [113 78 119 79 119 119 112 122 116 123 125 123 128 122 121 118 121 77]
	[local249 10] = [124 78 123 93 126 93 130 87 127 78]
	[local259 24] = [182 126 169 127 165 133 171 137 167 144 171 147 194 147 197 140 196 133 203 128 203 123 189 122]
	[local283 18] = [158 124 183 120 220 123 225 129 210 142 189 146 160 143 152 138 148 131]
)
(procedure (proc360_7 param1 param2)
	(Die 0 369 param1 82 999 1 4 80 param2)
)

(procedure (localproc_0033 param1)
	(switch (proc3_1 [local52 param1])
		(0 (Say bartender 360 0))
		(1 (Say bartender 360 1))
		(2
			(= local51 param1)
			(proc3_2 [local52 local51])
			(switch local51
				(1 (HighPrint 360 2))
				(2 (HighPrint 360 3))
				(3
					(HighPrint 360 4)
					(HighPrint 360 5)
				)
			)
		)
	)
)

(procedure (localproc_00c6 param1)
	(cond 
		((== local51 0) (HighPrint 360 6))
		((!= param1 local51)
			(switch local51
				(1 (HighPrint 360 7))
				(2 (HighPrint 360 8))
				(3 (HighPrint 360 9))
			)
		)
		(else
			(switch local51
				(1 (HighPrint 360 10))
				(2 (HighPrint 360 11))
				(3
					(if (== (++ local56) 3)
						(proc360_7 8 {Been slung once too often})
					else
						(HighPrint 360 12)
					)
				)
			)
			(= local51 0)
		)
	)
)

(instance rm360 of Rm
	(properties
		picture 360
		style $0006
	)
	
	(method (init &tmp temp0)
		(LoadMany 128 0 100 360 361 363 365)
		(LoadMany 131 365 363)
		(LoadMany 130 951)
		(LoadMany 132 361)
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(if (< global257 2600) (= global257 0))
		(if (and (>= currentTimeZone 4) (== global295 4))
			(++ global295)
		)
		(if
			(and
				(>= currentTimeZone 4)
				(== global295 6)
				(!= prevRoomNum 370)
			)
			(++ global295)
		)
		(if
			(and
				(>= currentTimeZone 4)
				(== global295 1)
				(!= prevRoomNum 370)
			)
			(++ global295)
		)
		(= useObstacles 1)
		(super init:)
		(if (or (>= currentTimeZone 4) (!= currentDay 28))
			(ferrari init:)
		)
		(bartender init:)
		(proc1_19)
		(if
			(not
				(= temp0
					(+
						(mod (+ currentDay currentTimeZone) 28)
						(if (== currentTimeZone 4) else (== currentTimeZone 5))
					)
				)
			)
			(= temp0 1)
		)
		(if (> (mod temp0 2) 0) (addToPics add: customer1))
		(if (> (mod temp0 3) 0) (addToPics add: customer2))
		(if (> (mod temp0 4) 0) (addToPics add: customer3))
		(proc1_31 curtains bar lamps perch hole)
		(DrawFeature
			table1
			table2
			table3
			table4
			table5
			shelf1
			shelf2
			parrot
		)
		(if (not (Btst 55)) (oilLamp init:))
		(if
		(or (== currentTimeZone 4) (== currentTimeZone 5))
			(flame1 init:)
			(DrawFeature thieves drunk)
		)
		(if (OneOf prevRoomNum 380 361 401)
			(gCMusic number: 361 loop: -1 priority: 0 playBed:)
		)
		(switch prevRoomNum
			(380
				(self setScript: (ScriptID 367 0))
			)
			(400
				(self setScript: (ScriptID 367 0))
			)
			(361
				(self setScript: (ScriptID 368 0))
			)
			(else 
				(self setScript: (ScriptID 366 0))
			)
		)
		(poly1 points: @local145 size: 5)
		(poly2 points: @local155 size: 3)
		(poly3 points: @local161 size: 3)
		(poly4 points: @local167 size: 3)
		(poly5 points: @local173 size: 6)
		(poly7 points: @local185 size: 7)
		(poly8 points: @local199 size: 4)
		(poly9 points: @local207 size: 5)
		(poly10 points: @local217 size: 7)
		(poly11 points: @local231 size: 9)
		(poly12 points: @local249 size: 5)
		(poly13 points: @local259 size: 12)
		(poly14 points: @local283 size: 9)
		(self addObstacle: poly14)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			((!= curRoomNum newRoomNum))
			(
				(and
					(cast contains: ferrari)
					(& (ego onControl: 1) $0010)
				)
				(if
					(and
						(Btst 113)
						(not (Btst 171))
						(!= (ego script?) seatEgo)
					)
					(Bset 171)
					(Say ferrari self 360 13)
				)
			)
			((ego script?))
			((& (ego onControl: 1) $4000)
				(cond 
					(isNightTime (curRoom setScript: goToSleep))
					((not local50) (HighPrint 360 14) (= local50 1))
				)
			)
			((== (ego edgeHit?) 3) (self setScript: byeScript))
			(
				(and
					(== global295 1)
					(or (== currentTimeZone 4) (== currentTimeZone 5))
				)
				(++ global295)
			)
			(
				(and
					(or (== currentTimeZone 4) (== currentTimeZone 5))
					(== currentDay 29)
				)
				(self setScript: toJailS)
			)
			(
				(and
					(!= (bartender x?) 99)
					(& (ego onControl: 1) $0002)
				)
				(bartender setMotion: MoveTo 99 139)
			)
		)
	)
	
	(method (dispose)
		(= global257 global277)
		(if (== newRoomNum 380) (gCMusic fade:))
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(LoadMany 0 367 366 368 364)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 360 15))
			(
				(or
					(Said 'lockpick[/lock]')
					(Said 'use/(lockpick[<lock]),lockpick')
					(Said 'unlock')
				)
				(if (& (ego onControl: 1) $4000)
					(HighPrint 360 16)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'open,open/door') (HighPrint 360 17))
			((Said 'talk,chat,ask')
				(if (Btst 113)
					(HighPrint 360 18)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'sat')
				(if (cast contains: ferrari)
					(if (== (ego view?) 361)
						(HighPrint 360 19)
					else
						(ego setScript: seatEgo)
					)
				else
					(HighPrint 360 20)
				)
			)
			((Said 'stand,(get,acquire<up)')
				(if (not (== (ego view?) 361))
					(HighPrint 360 21)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'attack,kill,attack,cast,throw') (proc360_7 6 {Don't DO that!}))
			((Said 'tell')
				(if (cast contains: ferrari)
					(Say ferrari 360 22)
				else
					(HighPrint 360 23)
				)
			)
			((Said 'drink>')
				(cond 
					((and (== local51 0) (Said '/water')) (pEvent claimed: 0))
					((== local51 0) (pEvent claimed: 1) (HighPrint 360 24))
					((Said '/water') (localproc_00c6 1))
					((Said '/coffee') (localproc_00c6 2))
					((Said '/sling') (localproc_00c6 3))
					((Said '/*') (localproc_00c6 0))
					(else (pEvent claimed: 1) (localproc_00c6 local51))
				)
			)
			((Said 'chew,acquire,use,eat,chew/pill>') (pEvent claimed: 0))
			((Said 'get,acquire/lamp,grease') (HighPrint 360 25))
			((Said 'order,buy>')
				(cond 
					((== (ego view?) 361) (pEvent claimed: 1) (Say ferrari 360 26))
					((not (& (ego onControl: 1) $0002)) (pEvent claimed: 1) (Say bartender 360 27))
					((!= local51 0) (pEvent claimed: 1) (Say bartender 360 28))
					((or (Said '/drink') (Said '[/!*]')) (Say bartender 360 29))
					((or (Said 'water') (Said '/water')) (localproc_0033 1))
					((or (Said 'coffee') (Said '/coffee')) (localproc_0033 2))
					(
					(or (Said 'sling,djinn') (Said '/sling,djinn')) (localproc_0033 3))
					(else (pEvent claimed: 1) (Say bartender 360 30))
				)
			)
		)
	)
)

(instance byeScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((and isNightTime (== global295 8)) (HighPrint 360 31) (= cycles 1))
					(
						(and
							isNightTime
							(not (Btst 98))
							(!= global295 6)
							(cast contains: ferrari)
						)
						(Say ferrari self 360 32)
					)
					(else (self changeState: 3))
				)
			)
			(1
				(ego setHeading: 0 setMotion: MoveFwd 20 self)
			)
			(2 (self changeState: 6))
			(3
				(ego setMotion: MoveTo 160 250 self)
			)
			(4
				(cond 
					((== global295 6) (self cue:))
					(isNightTime (proc360_7 2 {Persona non Grata}))
					((Btst 113) (proc360_7 1 {You took too long}))
					(else (self cue:))
				)
			)
			(5
				(= gTopExit 4)
				(curRoom newRoom: 380)
			)
			(6 (self dispose:))
		)
	)
)

(instance goToSleep of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (and (Btst 99) (== currentDay 27))
					(Say ferrari self 360 33)
				else
					(self cue:)
				)
			)
			(1
				(if (Btst 166) (= global295 9) else (= global295 4))
				(gCMusic fade:)
				(curRoom newRoom: 361)
			)
		)
	)
)

(instance seatEgo of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(waitTimer dispose:)
				(ego setMotion: PolyPath 230 163 self)
			)
			(1
				(ego setPri: 12 setMotion: MoveTo 256 171 self)
			)
			(2
				(cond 
					((OneOf global295 1 3 6 8) (Say ferrari self 360 34))
					((not (Btst 113)) (HighPrint 360 35) (= cycles 1))
					(else (= cycles 1))
				)
			)
			(3
				(if
				(or (OneOf global295 1 3 6 8) (not (Btst 113)))
					(self changeState: 8)
				else
					(ego setHeading: 135 self)
				)
			)
			(4
				(ego view: 361 setLoop: 0 setCel: 0 setCycle: End self)
				(Bclr 113)
			)
			(5
				(ego
					posn: (+ (ego x?) 8) (- (ego y?) 10)
					setLoop: 1
					setCel: 0
				)
				(= cycles 2)
			)
			(6
				(if (== global295 7)
					(self setScript: giveBird self)
				else
					(= cycles 1)
				)
			)
			(7 (curRoom newRoom: 370))
			(8
				(ego
					setMotion: MoveTo (- (ego x?) 20) (- (ego y?) 10) self
				)
			)
			(9
				(if (not (== (ego view?) 361)) (ego setPri: -1))
				(self dispose:)
			)
		)
	)
)

(instance giveBird of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego has: 47)
					(ego setLoop: 5 cycleSpeed: 1 setCycle: CT 5 1 self)
				else
					(proc360_7 7 {You should have given him the bird})
				)
			)
			(1
				(ferrariArm
					setLoop: 5
					setCel: 0
					cycleSpeed: 1
					setCycle: CT 4 1 self
				)
				(swishTimer dispose: delete:)
				(headTimer dispose: delete:)
			)
			(2
				(ego
					posn: (- (ego x?) 8) (+ (ego y?) 14)
					setLoop: 0
					setCel: 4
					cycleSpeed: 0
				)
				(ferrariArm setCycle: End self)
				(AddToScore 708 3 2)
				(ego use: 47 1)
			)
			(3 (self dispose:))
		)
	)
)

(instance headScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (< register 6) (= register 0))
				(if register
					(ferrariHead cycleSpeed: 1 setCycle: Beg self)
				else
					(ferrariHead cycleSpeed: 1 setCycle: End self)
				)
			)
			(1 (= cycles 4))
			(2
				(if register
					(ferrariHead setCycle: CT 2 1 self)
				else
					(ferrariHead setCycle: CT 2 -1 self)
				)
			)
			(3
				(ferrariHead cycleSpeed: 0)
				(proc1_32 headTimer 4 10)
				(self dispose:)
			)
		)
	)
)

(instance toJailS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HighPrint 360 36)
				(HighPrint 360 37 80 {Guard:})
				(= cycles 1)
			)
			(1
				(curRoom drawPic: 2)
				(cast eachElementDo: #hide)
				(Print 360 38)
				(= cycles 1)
			)
			(2
				(curRoom newRoom: 440)
				(self dispose:)
			)
		)
	)
)

(instance ferrari of Talker
	(properties
		x 280
		y 165
		description {Ferrari}
		lookStr {The huge man has a very jovial expression as he proceeds to swat a fly with the tail of some sort of animal.}
		view 365
		loop 4
		priority 13
		signal $4010
		illegalBits $0000
		tLoop -1
		myName '//ferrari,man,senor'
		title {Signor Ferrari:}
		color 2
		msgFile 365
	)
	
	(method (init)
		(super init: &rest)
		(ferrariArm init:)
		(ferrariHead init:)
		(ferrariMouth init: hide:)
		(proc1_32 headTimer 2)
		(proc1_32 swishTimer 2)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'made,gave,display/sign[<thief]')
				(if (MakeThiefSign)
					(AddToScore 709 5 2)
					(Say ferrari 360 39 360 40)
					(Bset 99)
				else
					(Say ferrari 360 41)
				)
			)
			((Said 'look,examine/whip,flyswatter,swat[<fly]') (HighPrint 360 42))
		)
	)
	
	(method (onMe param1)
		(if
		(or (super onMe: param1) (ferrariArm onMe: param1))
		else
			(ferrariHead onMe: param1)
		)
	)
	
	(method (respond param1)
		(cond 
			((Btst 113) (param1 claimed: 1) (Say self 360 43))
			((== global295 1) (param1 claimed: 1) (HighPrint 360 44))
			((and (== global295 3) (not (Btst 111))) (param1 claimed: 1) (Say self 360 45))
			((== global295 6) (param1 claimed: 1) (Say self 360 46))
			((== global295 8) (param1 claimed: 1) (HighPrint 360 47))
			((== global295 9) (param1 claimed: 1) (HighPrint 360 48))
			(else (super respond: param1 &rest))
		)
	)
	
	(method (atSpec param1)
		(return [local95 param1])
	)
	
	(method (atGen param1)
		(return [local57 param1])
	)
	
	(method (messages)
		(ferrariHead setLoop: 2 setCycle: Fwd)
		(headTimer dispose:)
		(ferrariMouth setCycle: Fwd show:)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(ferrariMouth hide:)
		(ferrariHead setLoop: 3 setCel: 2 setCycle: 0)
		(proc1_32 headTimer 2)
		(super endTalk: &rest)
	)
	
	(method (talkTo param1)
		(self respond: param1 0 &rest)
	)
)

(instance ferrariArm of Prop
	(properties
		x 280
		y 165
		view 365
		priority 15
		signal $0010
	)
)

(instance ferrariHead of Prop
	(properties
		x 289
		y 154
		view 365
		loop 3
		priority 14
		signal $4010
	)
)

(instance ferrariMouth of Prop
	(properties
		x 289
		y 154
		view 365
		loop 2
		priority 15
		signal $0010
		cycleSpeed 1
	)
)

(instance bartender of Talker
	(properties
		x 98
		y 139
		description {the bartender}
		lookStr {The man glares back at you.__This is not the face you associate with bartenders.__It reminds you more of Bruno from Spielburg.__Definitely not a man to mess with.}
		view 363
		loop 8
		priority 12
		signal $0810
		illegalBits $0000
		tLoop -1
		talkSpeed 1
		myName '//barman,barman,man'
		title {Wilmer the Bartender:}
		color 1
		msgFile 363
	)
	
	(method (init)
		(super init: &rest)
		(proc1_32 wipeTimer 2)
		(proc1_32 barMoveTimer 3 8)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(== (pEvent type?) evSAID)
					(Btst 113)
					(== global295 6)
				)
				(pEvent claimed: 1)
				(Say self 360 49)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local129 param1])
	)
	
	(method (atGen param1)
		(return (if param1 (return 7) else (return 8)))
	)
	
	(method (messages)
		(barMoveTimer dispose:)
		(self setMotion: 0)
		(wipeTimer dispose:)
		(barMouth
			posn: (- x 4) (- y 17)
			setPri: (+ priority 1)
			setCycle: Fwd
			ignoreActors: 1
			init:
		)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(barMouth dispose:)
		(proc1_32 barMoveTimer 3 8)
		(proc1_32 wipeTimer 2)
		(super endTalk: &rest)
	)
	
	(method (talkTo param1)
		(param1 claimed: 1)
		(self respond: param1 &rest)
	)
)

(instance barMouth of Prop
	(properties
		view 363
		loop 10
		cycleSpeed 1
	)
)

(instance headTimer of Timer
	(properties)
	
	(method (cue)
		(ferrariHead setScript: headScript 0 (Random 1 10))
	)
)

(instance swishTimer of Timer
	(properties)
	
	(method (cue)
		(ferrariArm setCycle: Full 1)
		(proc1_32 self 2 10)
	)
)

(instance wipeTimer of Timer
	(properties)
	
	(method (cue)
		(bartender setCycle: CT 0 1)
		(proc1_32 self 1 4)
	)
)

(instance barMoveTimer of Timer
	(properties)
	
	(method (cue &tmp temp0 temp1 temp2 temp3)
		(= temp3
			(/
				(+ (* (= temp2 (* (- (Random 1 9) 5) 4)) 44) 5)
				10
			)
		)
		(= temp1 (- (bartender y?) temp2))
		(= temp0 (+ (bartender x?) temp3))
		(if (and (< 137 temp1) (< temp1 141))
			(= temp1 139)
			(= temp0 99)
		)
		(if
			(and
				(< 0 temp0)
				(< temp0 110)
				(not (& (ego onControl: 1) $0002))
			)
			(bartender setMotion: MoveTo temp0 temp1)
		)
		(proc1_32 self 3 8)
	)
)

(instance waitTimer of Timer
	(properties)
	
	(method (cue)
		(if (ego script?)
			(self dispose:)
		else
			(proc360_7 1 {You took too long})
		)
	)
)

(instance table1 of PicView
	(properties
		x 272
		y 189
		noun '/table'
		description {the table}
		lookStr {The table is cracked and worn.}
		view 100
		priority 13
		signal $0010
	)
)

(instance table2 of PicView
	(properties
		x 185
		y 141
		noun '/table'
		description {the table}
		lookStr {The table is stained and marred.}
		view 100
		cel 1
		priority 10
		signal $0010
	)
)

(instance table3 of PicView
	(properties
		x 296
		y 123
		noun '/table'
		description {the table}
		lookStr {The table is broken and wobbly.}
		view 100
		cel 2
		priority 9
		signal $0010
	)
)

(instance table4 of PicView
	(properties
		x 238
		y 116
		noun '/table'
		description {the table}
		lookStr {The table is cracked and worn.}
		view 100
		cel 3
	)
)

(instance table5 of PicView
	(properties
		x 185
		y 111
		noun '/table'
		description {the table}
		lookStr {The table is stained and marred.}
		view 100
		cel 4
		priority 7
		signal $0010
	)
)

(instance drunk of PicView
	(properties
		x 185
		y 146
		noun '/bum,man[<bum]'
		description {the drunk}
		lookStr {This patron looks to have enjoyed the house specialty, the Djinn Sling, to excess.}
		view 360
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) poly13)
	)
)

(instance customer1 of PicView
	(properties
		x 79
		y 178
		noun '/customer,man'
		description {the customer}
		lookStr {You see a customer, probably a regular.}
		view 360
		loop 3
	)
)

(instance customer2 of PicView
	(properties
		x 60
		y 189
		noun '/customer,man'
		description {the customer}
		lookStr {You see a customer enjoying his drink.}
		view 360
		loop 3
		cel 1
	)
)

(instance customer3 of PicView
	(properties
		x 39
		y 185
		noun '/customer,man'
		description {the customer}
		lookStr {You see a customer near the bar.}
		view 360
		loop 4
	)
)

(instance thieves of PicView
	(properties
		x 298
		y 105
		noun '/thief,man'
		description {the thieves}
		lookStr {These two look like they belong (and enjoy being) in dark alleys.}
		view 360
		cel 1
		priority 9
		signal $0010
	)
)

(instance shelf1 of PicView
	(properties
		x 30
		y 119
		noun '/shelf'
		description {the shelf}
		lookStr {The shelf contains several types of glassware, each of which appears to be supporting several types of bacteria.}
		view 360
		loop 1
		priority 11
		signal $0010
	)
)

(instance shelf2 of PicView
	(properties
		x 30
		y 92
		noun '/shelf'
		description {the shelf}
		lookStr {The shelf is dirtier than the bar only because the customers keep the bar clean with their dirty shirt sleeves.}
		view 360
		loop 1
		cel 1
		priority 11
		signal $0010
	)
)

(instance parrot of PicView
	(properties
		x 121
		y 123
		noun '/bird,parrot'
		description {the parrot}
		lookStr {It is an ex-parrot.__It had one too many (that is to say one) Djinn Sling.__Actually, it's just pining for the fjords.}
		view 360
		loop 2
		signal $4000
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) poly12)
	)
)

(instance oilLamp of View
	(properties
		x 186
		y 100
		noun '/lamp,grease'
		description {the oil lamp}
		lookStr {It is an unlit oil lamp.}
		view 100
		loop 2
		cel 10
		priority 7
		signal $4011
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(if (& (ego onControl: 1) $0004)
				(HighPrint 360 50)
				(oilLamp dispose:)
				(ego get: 42)
				(Bset 55)
			else
				(HighPrint 360 51)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance flame1 of Flame
	(properties
		x 184
		y 130
		z 15
		noun '/flame'
		description {the flame}
		lookStr {The oil lamp is burning dimly.}
		view 100
		loop 3
	)
)

(instance curtains of Feature
	(properties
		noun '/curtain,curtain'
		description {the drapes}
		lookStr {These drapes must have been very beautiful once.}
	)
	
	(method (onMe param1)
		(if
			(or
				(AvoidPath (param1 x?) (param1 y?) poly1)
				(AvoidPath (param1 x?) (param1 y?) poly2)
				(AvoidPath (param1 x?) (param1 y?) poly3)
			)
		else
			(AvoidPath (param1 x?) (param1 y?) poly4)
		)
	)
)

(instance bar of Feature
	(properties
		noun '/bar,counter'
		description {the bar}
		lookStr {The old bar shows the stains of a thousand and one drinks.}
	)
	
	(method (onMe param1)
		(return
			(if
				(and
					(AvoidPath (param1 x?) (param1 y?) poly5)
					(not (customer1 onMe: param1))
					(not (customer2 onMe: param1))
				)
				(not (customer3 onMe: param1))
			else
				0
			)
		)
	)
)

(instance lamps of Feature
	(properties
		noun '/lamp'
		description {the lamp}
		lookStr {It is an oil-burning lamp.}
	)
	
	(method (onMe param1)
		(if
			(or
				(AvoidPath (param1 x?) (param1 y?) poly7)
				(AvoidPath (param1 x?) (param1 y?) poly8)
				(AvoidPath (param1 x?) (param1 y?) poly9)
			)
		else
			(AvoidPath (param1 x?) (param1 y?) poly10)
		)
	)
)

(instance perch of Feature
	(properties
		x 120
		y 99
		noun '/perch'
		nsTop 79
		nsLeft 118
		nsBottom 120
		nsRight 122
		description {the perch}
		lookStr {It's primary use is to keep the parrot off the dirty floor.}
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) poly11)
	)
)

(instance hole of Feature
	(properties
		x 119
		y 151
		noun 'chasm'
		nsTop 150
		nsLeft 117
		nsBottom 153
		nsRight 122
		description {the hole}
		lookStr {So, how do you feel about this as a hole?}
	)
)

(instance poly1 of Polygon
	(properties
		type $0000
	)
)

(instance poly2 of Polygon
	(properties
		type $0000
	)
)

(instance poly3 of Polygon
	(properties
		type $0000
	)
)

(instance poly4 of Polygon
	(properties
		type $0000
	)
)

(instance poly5 of Polygon
	(properties
		type $0000
	)
)

(instance poly7 of Polygon
	(properties
		type $0000
	)
)

(instance poly8 of Polygon
	(properties
		type $0000
	)
)

(instance poly9 of Polygon
	(properties
		type $0000
	)
)

(instance poly10 of Polygon
	(properties
		type $0000
	)
)

(instance poly11 of Polygon
	(properties
		type $0000
	)
)

(instance poly12 of Polygon
	(properties
		type $0000
	)
)

(instance poly13 of Polygon
	(properties
		type $0000
	)
)

(instance poly14 of Polygon
	(properties
		type $0002
	)
)
