;;; Sierra Script 1.0 - (do not remove this comment)
(script# 380)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Talker)
(use Full)
(use Intrface)
(use Feature)
(use Save)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm380 0
)

(local
	local0
	local1
	[local2 5] = [{By order of Khaveen, you are not allowed to leave the city without showing your visa, yellow-haired dog._} {By order of Khaveen, foreign dog, you are not allowed to leave.__Let me see your visa._} {By order of Khaveen, Infidel of Shapeir, you may not pass through these gates unless I see your visa._} {By order of Khaveen, you who come to this city unbidden may not leave as easily as you arrived.__Show me your visa._} {By order of Khaveen, you dog, you may not pass without showing your visa._}]
	local7
	local8
	local9
	theGSeconds
	local11
	[local12 100]
)
(instance rm380 of Rm
	(properties
		picture 300
		style $0006
	)
	
	(method (init)
		(Bset 100)
		(Load rsVIEW 0 4 465 385 382 383 380 410 450)
		(Load rsSCRIPT 78)
		(if isNightTime
			(= defaultPalette 3)
		else
			(= defaultPalette 2)
		)
		(= theGSeconds gSeconds)
		(bpiDoor init: stopUpd:)
		(super init:)
		(self overlay: curRoomNum)
		(= gGDftSC gNoSC)
		(cond 
			((and (== prevRoomNum 360) (>= currentDay 29))
				(guard4 init:)
				(guard5 init:)
				(guard6 init: setScript: toTheDungeon)
				(ego setScript: fromBlueParrot)
			)
			((== prevRoomNum 360) (ego setScript: fromBlueParrot))
			((== prevRoomNum 880) (ChangeEgoWalk 0 0) (ego setScript: backAgain))
			((and (== prevRoomNum 872) (not (Btst 134)))
				(ChangeEgoWalk 0 0)
				(khaveen init: stopUpd:)
				(kMouth
					init:
					posn: (+ (khaveen x?) 2) (- (khaveen y?) 43)
					hide:
				)
				(if (> theGSeconds 0) (guard3 init:))
				(self setScript: comeIn)
			)
			((or (== prevRoomNum 703) (Btst 28)) (ego loop: 2 posn: 160 80 init: setMotion: MoveTo 160 100))
		)
		(if
			(and
				(> currentTimeZone 4)
				(!= prevRoomNum 872)
				(!= currentDay 28)
				(not (ego has: 47))
			)
			(guard7 init:)
		)
		(if (== prevRoomNum 872)
			(guard1 posn: 80 170 loop: 0 init:)
			(guard2 posn: 230 170 loop: 1 init:)
		else
			(guard1 posn: 113 186 loop: 3 illegalBits: 0 init:)
			(guard2 posn: 203 186 loop: 3 illegalBits: 0 init:)
		)
		(DrawFeature
			bpiSign
			lWindow
			lShadow
			rShadow
			rBlock
			lBlock
		)
		(proc1_31 topAlleyDoor)
	)
	
	(method (doit)
		(if
			(and
				(> (ego y?) 189)
				(not script)
				(not (ego script?))
			)
			(ego setScript: getTheHellOuttaDodge)
		)
		(if (< (ego y?) 80)
			(= gTopExit 3)
			(curRoom newRoom: 703)
		)
		(if
		(and (ego inRect: 216 103 273 123) (not (ego script?)))
			(ego setScript: toParrot)
		)
		(if
			(and
				(ego inRect: 119 170 220 190)
				(not local1)
				(not (ego script?))
				(not script)
				(Btst 134)
			)
			(= local1 1)
			(guard1 setScript: gateBlock)
		)
		(if
		(and (not (ego inRect: 110 170 230 190)) local1)
			(= local1 0)
			(if (> (guard1 x?) 120) (guard2 setScript: atEase))
		)
		(if (and local8 (not (-- local8))) (Die 1 380 0))
		(super doit:)
	)
	
	(method (dispose)
		(= defaultPalette 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'ask') (HighPrint 380 1 80 {Guard:}))
			((Said 'attack') (HighPrint 380 2))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(if (Btst 134)
					(HighPrint 380 3)
				else
					(HighPrint 380 4)
				)
			)
			((Said 'look,examine<up')
				(if (> currentTimeZone 4)
					(PrintWarning 380 5)
				else
					(PrintWarning 380 6)
				)
			)
			((Said 'look,examine<down') (HighPrint 380 7))
		)
	)
)

(instance khaveen of Actor
	(properties
		x 141
		y 149
		noun '/khaveen'
		description {Khaveen}
		lookStr {It is Khaveen, Captain of the Raseirian Guard.}
		view 385
	)
)

(instance kMouth of Talker
	(properties
		view 385
		loop 5
		signal $6810
		illegalBits $0000
		tLoop 5
		talkSpeed 0
		myName '//khaveen,man'
		title {Khaveen:}
		back 11
	)
	
	(method (showText)
		(HighPrint 380 8 80 {Khaveen:} 103 35 aWin)
	)
	
	(method (messages)
		(self show:)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(self setCycle: End)
		(super endTalk:)
	)
)

(instance guard1 of Actor
	(properties
		noun '/guard'
		description {the Raseirian guard}
		lookStr {The guards of this city look like well-disciplined, tough fighters.}
		view 382
	)
)

(instance guard2 of Actor
	(properties
		noun '/guard'
		description {the Raseirian guard}
		lookStr {The guards of this city look like well-disciplined, tough fighters.}
		view 382
		loop 1
	)
)

(instance guard3 of Actor
	(properties
		x 187
		y 149
		noun '/guard'
		description {the Raseirian guard}
		lookStr {The guards of this city look like well-disciplined, tough fighters.}
		view 382
		loop 2
	)
)

(instance guard4 of Actor
	(properties
		x 222
		y 99
		noun '/guard'
		description {the Raseirian guard}
		lookStr {The guards of this city look like well-disciplined, tough fighters.}
		view 383
		loop 6
		signal $4000
		illegalBits $0000
	)
)

(instance guard5 of Actor
	(properties
		x 261
		y 130
		noun '/guard'
		description {the Raseirian guard}
		lookStr {The guards of this city look like well-disciplined, tough fighters.}
		view 383
		loop 8
		signal $4000
		illegalBits $0000
	)
)

(instance guard6 of Actor
	(properties
		x 162
		y 98
		noun '/guard'
		description {the Raseirian guard}
		lookStr {The guards of this city look like well-disciplined, tough fighters.}
		view 383
		loop 5
		signal $4000
		illegalBits $0000
	)
)

(instance guard7 of Actor
	(properties
		x 120
		y 120
		description {the Raseirian guard}
		lookStr {The guards of this city look like well-disciplined, tough fighters.}
		view 382
		loop 6
		cel 2
	)
	
	(method (init)
		(self setCycle: Walk setMotion: MoveTo 125 115 self)
		(super init:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'made,gave,display/sign[<thief]')
				(MakeThiefSign)
				(= local8 0)
				(HighPrint 380 11 103 25 4)
				(self setLoop: 1)
			)
			((Said 'run')
				(= egoWalkMode 1)
				(self mover: 0)
				(ego setScript: runningMan)
			)
		)
	)
	
	(method (cue)
		(self view: 383 loop: 7)
		(cond 
			((and (== currentDay 27) (not local11)) (= local11 1) (self setScript: backToInn))
			((== prevRoomNum 360) (PrintWarning 380 9) (= local8 15))
			(else (PrintWarning 380 10) (= local8 15))
		)
	)
)

(instance bpiDoor of Prop
	(properties
		x 252
		y 117
		noun '/door[<hotel]'
		description {the door to the Blue Parrot Inn}
		lookStr {If the sign is correct, this is the stained and dirty door to the Blue Parrot Inn.}
		view 380
		priority 2
		signal $0010
	)
)

(instance bpiSign of PicView
	(properties
		x 252
		y 54
		noun '/sign[<hotel]'
		description {the sign of the Blue Parrot Inn}
		lookStr {The paint on the sign is starting to chip, but it seems to indicate that this is the Blue Parrot Inn.}
		view 380
		loop 1
		priority 10
		signal $0010
	)
)

(instance lWindow of PicView
	(properties
		x 74
		y 53
		noun '/window'
		description {the window.}
		lookStr {The windows are securely barred.}
		view 450
		loop 2
		cel 1
		priority 14
		signal $0010
	)
	
	(method (init)
		(if isNightTime (= palette 2) else (= palette 1))
		(super init:)
	)
)

(instance lShadow of PicView
	(properties
		x 267
		y 189
		shiftClick 0
		view 380
		loop 1
		cel 2
		priority 0
		signal $4010
	)
)

(instance rShadow of PicView
	(properties
		x 50
		y 189
		shiftClick 0
		view 380
		loop 1
		cel 2
		priority 0
		signal $4010
	)
)

(instance rBlock of PicView
	(properties
		x 308
		y 164
		view 460
		loop 3
		priority 8
		signal $4010
	)
	
	(method (init)
		(if isNightTime (= palette 2) else (= palette 1))
	)
)

(instance lBlock of PicView
	(properties
		x 4
		y 173
		view 460
		loop 4
		priority 8
		signal $4010
	)
	
	(method (init)
		(if isNightTime (= palette 2) else (= palette 1))
	)
)

(instance comeIn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gCMusic number: 380 loop: -1 priority: 0 playBed:)
				(SetControl 1)
				(= cycles 1)
			)
			(1
				(ego posn: 159 230 init: setMotion: MoveTo 159 172)
				(guard1 setCycle: Walk setMotion: MoveTo 135 170)
				(guard2 setCycle: Walk setMotion: MoveTo 180 170 self)
			)
			(2
				(guard1 view: 383 loop: 2 cel: 0 setCycle: End)
				(guard2 view: 383 loop: 3 cel: 0 setCycle: End self)
			)
			(3
				(guard1 stopUpd:)
				(guard2 stopUpd:)
				(khaveen setCycle: End)
				(kMouth setPri: (+ (khaveen priority?) 1))
				(= seconds 3)
			)
			(4 (Say kMouth self 380 14))
			(5
				(ego loop: 7)
				(khaveen
					view: 465
					setLoop: 4
					cel: 0
					setCycle: Walk
					ignoreActors:
					illegalBits: 0
					setMotion: MoveTo (- (ego x?) 2) (- (ego y?) 10) self
				)
			)
			(6
				(khaveen view: 385 loop: 2 cel: 0)
				(ego loop: 3)
				(kMouth
					posn: (+ (khaveen x?) 1) (- (khaveen y?) 43)
					setPri: 15
				)
				(= cycles 2)
			)
			(7 (Say kMouth self 380 15))
			(8 (SetInput 0) (= seconds 3))
			(9
				(SetInput 1)
				(if (>= local0 1)
					(self changeState: 15)
				else
					(khaveen setCycle: Full 1 self)
					(ego view: 385 loop: 4 cel: 0 cycleSpeed: 1 setCycle: End)
					(= local0 1)
				)
			)
			(10
				(ego view: 4 setLoop: 3)
				(kMouth setPri: (+ (khaveen priority?) 1))
				(Say kMouth self 380 16)
			)
			(11 (SetInput 0) (= seconds 3))
			(12
				(SetInput 1)
				(if (>= local0 2)
					(self changeState: 15)
				else
					(khaveen setCycle: Full 1 self)
					(ego view: 385 loop: 4 cel: 0 cycleSpeed: 1 setCycle: End)
				)
			)
			(13
				(ego view: 4 setLoop: 3)
				(kMouth setPri: (+ (khaveen priority?) 1))
				(Say kMouth self 380 17)
			)
			(14 (SetInput 0) (= seconds 2))
			(15
				(kMouth setPri: (+ (khaveen priority?) 1))
				(Say kMouth self 380 18)
			)
			(16
				(khaveen setCycle: Full 1 self)
				(ego view: 385 loop: 4 cel: 0 cycleSpeed: 1 setCycle: End)
			)
			(17
				(ego view: 4 setLoop: 3)
				(kMouth setPri: (+ (khaveen priority?) 1))
				(Say kMouth self 380 19)
			)
			(18
				(khaveen loop: 3 cel: 0 setCycle: End self)
			)
			(19
				(kMouth posn: 159 122 setPri: 15)
				(Say kMouth self 380 20)
			)
			(20
				(ego get: 41)
				(guard1 setCycle: Beg)
				(guard2 setCycle: Beg self)
			)
			(21
				(guard1 stopUpd:)
				(guard2 stopUpd:)
				(khaveen
					view: 465
					illegalBits: 0
					ignoreActors: 1
					setCycle: Walk
					setMotion: MoveTo 167 39 self
				)
				(kMouth dispose:)
				(if (> theGSeconds 0)
					(guard3
						illegalBits: 0
						setCycle: Walk
						setMotion: MoveTo 147 41
					)
				)
			)
			(22
				(khaveen dispose:)
				(proc1_19)
				(guard1
					view: 382
					illegalBits: 0
					setCycle: Walk
					setMotion: MoveTo 113 189
				)
				(guard2
					view: 382
					illegalBits: 0
					setCycle: Walk
					setMotion: MoveTo 203 189 self
				)
			)
			(23
				(guard1 setLoop: 3)
				(guard2 setLoop: 3)
				(ego setMotion: MoveTo 159 169 self)
				(if (> theGSeconds 0) (guard3 dispose:))
			)
			(24
				(Bset 134)
				(gCMusic fade:)
				(SetControl 0)
				(SetInput 0)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((< state 7) (pEvent claimed: 1) (HighPrint 380 12))
			((Said 'n')
				(if (!= (khaveen loop?) 3)
					(HighPrint 380 13 80 {Khaveen:} 35 aWin)
				)
			)
			((Said 'affirmative') (++ local0) (if seconds (= seconds 0) (self cue:)))
		)
	)
)

(instance gateBlock of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetControl 1 1)
				(ego setMotion: 0)
				(guard1
					view: 382
					illegalBits: 0
					ignoreActors: 1
					setLoop: 0
					setCycle: Walk
					setMotion: MoveTo 134 188
				)
				(guard2
					view: 382
					illegalBits: 0
					ignoreActors: 1
					setLoop: 1
					setCycle: Walk
					setMotion: MoveTo 184 188 self
				)
			)
			(1
				(SetInput 1)
				(guard1
					illegalBits: -32768
					view: 383
					loop: 2
					cel: 0
					setCycle: End
				)
				(guard2
					illegalBits: -32768
					view: 383
					loop: 3
					cel: 0
					setCycle: End self
				)
			)
			(2
				(if (and local9 (not (ego has: 41)))
					(HighPrint 380 21 80 {Gate Guard:})
					(guard1 ignoreActors: 0)
					(guard2 ignoreActors: 0)
					(LockEgo)
					(self dispose:)
				else
					(HighPrint
						(Format @local12 380 22 [local2 local7])
						80
						{Gate Guard:}
					)
					(if (< local7 4) (++ local7) else (= local7 0))
					(= cycles 2)
				)
			)
			(3
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo 147 186 self
				)
			)
			(4 (ego setHeading: 225 self))
			(5
				(cond 
					((== currentDay 28) (HighPrint 380 23 80 {Gate Guard:}))
					((ego has: 41)
						(HighPrint 380 24 80 {Gate Guard:})
						(guard2 setScript: atEase)
					)
					(else (HighPrint 380 25 80 {Gate Guard:}) (= local9 1))
				)
				(ego ignoreActors: 0 illegalBits: -32768)
				(= cycles 2)
			)
			(6
				(guard1 ignoreActors: 0)
				(guard2 ignoreActors: 0)
				(LockEgo)
				(self dispose:)
			)
		)
	)
)

(instance atEase of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetControl 1)
				(guard1 view: 383 loop: 2 setCycle: Beg)
				(guard2 view: 383 loop: 3 setCycle: Beg self)
				(guard1 ignoreActors: 0)
				(guard2 ignoreActors: 0)
			)
			(1
				(SetControl 0)
				(guard1 setLoop: 1 cel: 0)
				(guard2 setLoop: 0 cel: 0)
				(= cycles 2)
			)
			(2
				(guard1
					illegalBits: 0
					view: 382
					setLoop: 1
					setCycle: Walk
					setMotion: MoveTo 113 189 self
				)
				(guard2
					illegalBits: 0
					view: 382
					setLoop: 0
					setCycle: Walk
					setMotion: MoveTo 203 189
				)
			)
			(3
				(guard1 setLoop: 3 cel: 0)
				(guard2 setLoop: 3 cel: 0)
				(self dispose:)
			)
		)
	)
)

(instance toParrot of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bpiDoor setCel: 1)
				(ego setPri: 6 setMotion: MoveTo 270 112 self)
			)
			(1
				(curRoom newRoom: 360)
				(self dispose:)
			)
		)
	)
)

(instance fromBlueParrot of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(bpiDoor setCel: 1)
				(ego
					setPri: 6
					loop: 1
					illegalBits: 0
					signal: 16384
					posn: 253 112
					init:
					setCycle: Walk
					setMotion: MoveTo 210 112 self
				)
			)
			(1
				(bpiDoor setCel: 0)
				(proc1_19)
				(= cycles 1)
			)
			(2 (LockEgo) (self dispose:))
		)
	)
)

(instance toTheDungeon of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(guard4
					view: 382
					loop: 5
					setCycle: Walk
					setMotion: MoveTo 222 111
				)
				(guard5
					view: 382
					loop: 7
					setCycle: Walk
					setMotion: MoveTo 238 117 self
				)
			)
			(2
				(guard4 setLoop: 1)
				(guard5 setLoop: 1)
				(= cycles 4)
			)
			(3
				(HighPrint 380 27 80 {Guard:})
				(= cycles 4)
			)
			(4
				(HighPrint 380 28)
				(guard6 view: 382 loop: 3)
				(= cycles 4)
			)
			(5
				(guard6 setCycle: Walk setMotion: MoveTo 159 40)
				(guard4 setCycle: Walk setMotion: MoveTo 159 111)
				(guard5 setCycle: Walk setMotion: MoveTo 159 117)
				(ego setMotion: MoveTo 159 114)
				(= seconds 2)
			)
			(6
				(curRoom drawPic: 2)
				(bpiDoor dispose:)
				(guard1 dispose:)
				(guard2 dispose:)
				(guard4 dispose:)
				(guard5 dispose:)
				(guard6 hide:)
				(ego hide:)
				(= seconds 2)
			)
			(7
				(Print 380 29)
				(curRoom newRoom: 440)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast') (HighPrint 380 26) (pEvent claimed: 1))
		)
	)
)

(instance runningMan of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 159 100 self)
				(HighPrint 380 30 80 {Guard:} 103 70 280)
			)
			(1
				(ego setMotion: MoveTo 159 75 self)
			)
			(2 (self dispose:))
		)
	)
)

(instance backAgain of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego posn: 160 220 init:)
				(guard1 view: 382)
				(guard2 view: 382)
				(= cycles 2)
			)
			(1
				(ego setMotion: MoveTo 160 187)
				(guard1
					setLoop: 0
					setCycle: Walk
					setMotion: MoveTo 134 184
				)
				(guard2
					setLoop: 1
					setCycle: Walk
					setMotion: MoveTo 184 184 self
				)
			)
			(2
				(guard1
					illegalBits: -32768
					view: 383
					loop: 2
					cel: 0
					setCycle: End
				)
				(guard2
					illegalBits: -32768
					view: 383
					loop: 3
					cel: 0
					setCycle: End self
				)
			)
			(3
				(HighPrint 380 31 80 {Guard:})
				(= cycles 5)
			)
			(4
				(if (not (ego has: 41)) (HighPrint 380 32))
				(ego setMotion: MoveTo 147 188)
				(= cycles 20)
			)
			(5
				(if (ego has: 41)
					(HighPrint 380 33 80 {Guard:})
					(= cycles 2)
				else
					(HighPrint 380 34 80 {Guard:})
					(HighPrint 380 35)
					(curRoom newRoom: 880)
					(self dispose:)
				)
			)
			(6
				(guard2 setScript: atEase)
				(= seconds 3)
			)
			(7
				(ego setMotion: MoveTo 160 169 self)
			)
			(8
				(if
					(and
						(not
							(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
						)
						(== currentDay 27)
					)
					(curRoom setScript: backToInn)
				)
				(self dispose:)
			)
		)
	)
)

(instance getTheHellOuttaDodge of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo (ego x?) 230 self)
			)
			(1 (curRoom newRoom: 880))
		)
	)
)

(instance backToInn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo (ego x?) 106 self)
			)
			(1
				(HighPrint 380 36 80 {Guard:})
				(= cycles 2)
			)
			(2
				(if (ego has: 41)
					(HighPrint 380 37)
					(= cycles 2)
				else
					(Die 1 380 38 80 {Get a life - Get a visa})
					(self dispose:)
				)
			)
			(3
				(HighPrint 380 39 80 {Guard:})
				(= cycles 2)
			)
			(4
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 10)
			)
			(5 (Print 380 40) (= cycles 2))
			(6
				(= prevRoomNum 380)
				(curRoom newRoom: 360)
				(self dispose:)
			)
		)
	)
)

(instance aWin of SysWindow
	(properties
		back 11
	)
)

(instance topAlleyDoor of Feature
	(properties
		x 158
		y 67
		noun '/door,sign[<alley,bearing,street]'
		nsTop 38
		nsLeft 132
		nsBottom 91
		nsRight 185
		description {an alley leading south}
		lookStr {You see a dark, foreboding passage leading South.__The street sign reads "You must carry your Visa at all times!"}
	)
)
