;;; Sierra Script 1.0 - (do not remove this comment)
(script# 390)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TargActor)
(use RasPlaza)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	rm390 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
)
(procedure (localproc_000c)
	(Die 1 390 0 80 {Yours is a high-risk occupation})
)

(instance rm390 of RasPlaza
	(properties
		style $0006
		north 703
		south 450
		west 703
	)
	
	(method (init)
		(LoadMany 128 6 47 591 382 383 450)
		(Load rsSCRIPT 972)
		(if (or (== currentDay 28) (== currentDay 29))
			(= gGetBellows ropeMe)
			(= global168 30)
			(= gLevMe levMe)
			(= global166 30)
		)
		(if isNightTime (= gGDftSC gAllSC))
		(if (== prevRoomNum 410) (= inOut 3))
		(super init:)
		(proc1_31 topAlleyDoor leftAlleyDoor)
		(DrawFeature rightFullBlock lWindow rWindow)
		(cond 
			((== prevRoomNum 410) (curRoom setScript: fromRm410))
			(
				(and
					(< (- (GetTime 1) global294) 45)
					(!= (- (GetTime 1) global294) 0)
					(!= global294 0)
					(== prevRoomNum 450)
				)
				(ego setScript: stillDraggin)
			)
			(
				(and
					(< (- (GetTime 1) global294) 15)
					(!= (- (GetTime 1) global294) 0)
					(!= global294 0)
					(== prevRoomNum 703)
				)
				(ego setScript: multiGuards)
			)
			((and (== currentDay 28) (not (Btst 97)))
				(rGuard1 init:)
				(rGuard2 init:)
				(rGuard3 init:)
				(rGuard4 view: 383 loop: 7 posn: 20 189 init:)
				(HighPrint 390 1 103)
			)
			(
				(and
					(== currentDay 28)
					(> currentTimeZone 4)
					(!= prevRoomNum 450)
				)
				(rGuard6 init:)
			)
		)
	)
	
	(method (doit)
		(cond 
			((not local5))
			((-- local5))
			(else (rGuard6 dispose:) (rGuard7 init:))
		)
		(super doit:)
	)
	
	(method (dispose)
		(= gLevMe (= gGetBellows 0))
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(if local6
					(pEvent claimed: 1)
					(HighPrint 390 2)
				else
					(pEvent claimed: 0)
				)
			)
			(
				(or
					(Said 'look,examine<up')
					(Said 'look,examine<at/sky')
				)
				(if isNightTime
					(PrintWarning 390 3)
				else
					(PrintWarning 390 4)
				)
			)
			(
				(or
					(Said 'look,examine<down')
					(Said 'look,examine<at/floor,ground')
				)
				(PrintWarning 390 5)
			)
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(if (and (== currentDay 28) (not (Btst 97)))
					(PrintWarning 390 6)
				else
					(PrintWarning 390 7)
				)
			)
			((Said 'ask,tell,talk,chat')
				(if (and (== currentDay 28) (not (Btst 97)))
					(PrintWarning 390 8)
				else
					(PrintWarning 390 9)
				)
			)
			(
				(or
					(Said 'search,strip[/guard,body,man]')
					(Said 'get,acquire/blade,shield,weapon')
				)
				(if local8 (HighPrint 390 10) else (pEvent claimed: 0))
			)
			(
			(Said 'free,use/(elemental[<water]),(water<magic)')
				(if (ego has: 43)
					(HighPrint 390 11)
				else
					(PrintDontHaveIt)
				)
			)
		)
	)
)

(instance lWindow of PicView
	(properties
		x 74
		y 53
		noun '/window'
		description {the window}
		lookStr {The window was manufactured by MS Window Co.}
		view 450
		loop 2
		cel 1
		priority 2
		signal $6010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rWindow of PicView
	(properties
		x 249
		y 54
		description {the window}
		lookStr {It's the window of Khaveens' house.}
		view 450
		loop 2
		cel 4
		priority 2
		signal $6010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rGuard10 of PicView
	(properties
		x 123
		y 95
		noun '/guard'
		description {the guard}
		lookStr {For all you do, this guard's for you.}
		view 383
		loop 5
	)
)

(instance rGuard11 of PicView
	(properties
		x 196
		y 96
		description {the guard}
		lookStr {He has been waiting for you.}
		view 383
		loop 6
	)
)

(instance rGuard12 of PicView
	(properties
		x 28
		y 142
		description {the guard}
		lookStr {He's in search of curfew breakers.}
		view 383
		loop 5
	)
)

(instance rGuard13 of PicView
	(properties
		x 7
		y 199
		description {the guard}
		lookStr {A Raseirian guard.}
		view 383
		loop 7
	)
)

(instance rGuard14 of PicView
	(properties
		x 251
		y 176
		description {the guard}
		lookStr {A Raseirian guard.}
		view 383
		loop 8
	)
)

(instance rGuard1 of Actor
	(properties
		x 239
		y 180
		description {the guard}
		lookStr {A Raseirian guard.}
		view 382
		loop 3
		cel 4
	)
	
	(method (doit)
		(cond 
			(
			(and (< (self distanceTo: ego) 30) (not local1))
				(= local1 1)
				(ego setMotion: 0)
				(self view: 383 loop: 2 cel: 0 setCycle: End self)
			)
			((and (> (self distanceTo: ego) 30) local1) (= local1 0) (self setCycle: Beg self))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine/guard,guard,man') (Print 390 13))
			((Said 'attack,kill,beat') (Print 390 14))
		)
	)
	
	(method (cue)
		(cond 
			((< (self distanceTo: ego) 30) (Print 390 12 #title {Guard:} #dispose #time 3))
			((> (self distanceTo: ego) 30) (proc1_19) (self view: 382 loop: 3 cel: 4))
		)
		(super cue:)
	)
)

(instance rGuard2 of Actor
	(properties
		x 288
		y 181
		description {the guard}
		lookStr {A Raseirian guard.}
		view 383
		loop 8
	)
	
	(method (doit)
		(cond 
			(
			(and (< (self distanceTo: ego) 30) (not local2))
				(= local2 1)
				(ego setMotion: 0)
				(self view: 383 loop: 3 cel: 0 setCycle: End self)
			)
			((and (> (self distanceTo: ego) 30) local2) (= local2 0) (self setCycle: Beg self))
		)
		(super doit:)
	)
	
	(method (cue)
		(cond 
			((< (self distanceTo: ego) 30) (Print 390 12 #title {Guard:} #dispose #time 3))
			((> (self distanceTo: ego) 30) (proc1_19) (self view: 382 loop: 3 cel: 4))
		)
		(super cue:)
	)
)

(instance rGuard3 of Actor
	(properties
		x 18
		y 162
		description {the guard}
		lookStr {A Raseirian guard.}
		view 383
		loop 5
	)
	
	(method (doit)
		(cond 
			((< (ego x?) 10) (Die 1 {________You WERE warned!!!}))
			((and (not local4) (< (ego x?) 20))
				(ego setCycle: 0 setMotion: 0)
				(proc1_19)
				(= local4 1)
				(Print 390 15 #title {Guard:})
			)
			(
			(and (< (self distanceTo: ego) 25) (not local3))
				(= local3 1)
				(ego setCycle: 0 setMotion: 0)
				(proc1_19)
				(Print 390 16 #title {Guard:})
			)
			((and (> (self distanceTo: ego) 25) local3) (= local4 0) (= local3 0))
		)
		(super doit:)
	)
)

(instance rGuard4 of Actor
	(properties
		description {the guard}
		lookStr {A Raseirian guard.}
	)
)

(instance rGuard5 of Actor
	(properties
		x 15
		y 177
		description {the guard}
		lookStr {A Raseirian guard.}
		view 382
		loop 1
		illegalBits $0000
	)
)

(instance rGuard6 of TargActor
	(properties
		description {the guard}
		lookStr {A Raseirian guard.}
		view 382
	)
	
	(method (init)
		(if (== (ego loop?) 0)
			(self
				posn: 159 117
				loop: 3
				setCycle: Walk
				setMotion: MoveTo 159 36
			)
		else
			(self
				posn: 66 170
				loop: 1
				setCycle: Walk
				setMotion: MoveTo -10 170
			)
		)
		(= local6 20)
		(super init:)
	)
	
	(method (doit)
		(if (and (< (ego y?) 90) local0)
			(= local0 0)
			(self setCycle: 0 setMotion: 0 setScript: 0)
			(rGuard8 setCycle: 0 setMotion: 0)
			(rGuard9 setCycle: 0 setMotion: 0)
			(self setScript: runningMan)
		)
		(cond 
			((not local6))
			((-- local6))
			((not (== egoWalkMode 2))
				(self setCycle: 0 setMotion: 0)
				(FaceObject self ego)
				(self setScript: theChase)
			)
			(else (= local5 350))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'run,escape')
				(ChangeEgoWalk 1)
				(self setCycle: 0 setMotion: 0 setScript: 0)
				(rGuard8 setCycle: 0 setMotion: 0)
				(rGuard9 setCycle: 0 setMotion: 0)
				(self setScript: runningMan)
			)
		)
	)
	
	(method (hurtMe)
		(= local6 0)
		(= local5 0)
		(self setScript: guardZapped)
		(return 1)
	)
)

(instance rGuard7 of TargActor
	(properties
		x -10
		y 170
		description {the guard}
		lookStr {A Raseirian guard.}
		view 382
		illegalBits $0000
	)
	
	(method (init)
		(self setCycle: Walk setMotion: MoveTo 15 170 self)
		(super init:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'run,escape')
				(= egoWalkMode 1)
				(self setCycle: 0 setMotion: 0 setScript: 0)
				(rGuard8 setCycle: 0 setMotion: 0)
				(rGuard9 setCycle: 0 setMotion: 0)
				(self setScript: runningMan)
			)
		)
	)
	
	(method (cue)
		(self setScript: theChase)
		(super cue:)
	)
	
	(method (hurtMe)
		(= local6 0)
		(= local5 0)
		(self setScript: guardZapped)
		(return 1)
	)
)

(instance rGuard8 of Actor
	(properties
		x 159
		y 75
		description {the guard}
		lookStr {A Raseirian guard.}
		view 382
		loop 2
		illegalBits $0000
	)
	
	(method (init)
		(self setCycle: Walk setMotion: MoveTo 159 100)
		(super init:)
	)
)

(instance rGuard9 of Actor
	(properties
		x -15
		y 170
		description {the guard}
		lookStr {A Raseirian guard.}
		view 382
	)
	
	(method (init)
		(self setCycle: Walk setMotion: MoveTo 90 170)
		(super init:)
	)
)

(instance fromRm410 of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 47
					loop: 1
					cel: 3
					setPri: 12
					posn: 249 45
					z: 0
					init:
				)
				(= cycles 1)
			)
			(1
				(ego cel: 2 posn: 245 45)
				(= cycles 1)
			)
			(2
				(ego cel: 1 posn: 240 46)
				(= cycles 1)
			)
			(3
				(ego view: 591 loop: 3 cel: 0 posn: 236 40)
				(= cycles 1)
			)
			(4
				(ego posn: 231 46)
				(= cycles 1)
			)
			(5
				(ego posn: 226 54)
				(= cycles 1)
			)
			(6
				(ego posn: 214 66)
				(= cycles 1)
			)
			(7
				(ego posn: 201 85)
				(= cycles 1)
			)
			(8
				(ego posn: 186 101)
				(= cycles 1)
			)
			(9
				(ego loop: 1 cel: 1 setPri: -1 posn: 174 108)
				(= cycles 1)
			)
			(10
				(if (ReduceHP 15)
					(ego cel: 2 posn: 167 114)
					(= cycles 1)
				else
					(= local7 1)
					(ego loop: 1 cel: 9 x: 175 y: 107)
					(= cycles 1)
				)
			)
			(11
				(if local7
					(ego
						view: 22
						setLoop: 0
						cel: 0
						x: 180
						y: 111
						yStep: 16
						setMotion: MoveTo 187 117
						setCycle: End self
					)
				else
					(ego cel: 3 posn: 164 113)
					(= cycles 1)
				)
			)
			(12
				(if local7
					(Die
						1
						{After all the trouble you took to get your hands on that Raven, it's really a shame you couldn't take any more damage.__You should've tended to your healing, but now it's too late._}
						80
						{You Fell for It}
					)
				else
					(ego cel: 4 posn: 160 111)
					(= cycles 1)
				)
			)
			(13
				(ego cel: 5 posn: 158 112)
				(= cycles 1)
			)
			(14
				(ego cel: 6 posn: 145 113)
				(= cycles 1)
			)
			(15
				(ego cel: 7 posn: 145 112)
				(= cycles 1)
			)
			(16
				(ego cel: 8 posn: 143 112)
				(= cycles 1)
			)
			(17
				(ego cel: 9 posn: 138 112)
				(= cycles 1)
			)
			(18
				(ego view: 4 setLoop: 1 cel: 0 posn: 140 110)
				(= cycles 1)
			)
			(19 (proc1_19) (self dispose:))
		)
	)
)

(instance stillDraggin of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(rGuard5
					init:
					setLoop: 1
					setCycle: Walk
					setMotion: MoveTo -35 177
				)
				(rGuard4
					view: 382
					loop: 1
					posn: 40 189
					init:
					setCycle: Walk
					setMotion: MoveTo -30 189
				)
				(= seconds 4)
			)
			(1
				(rGuard4 dispose:)
				(rGuard5 dispose:)
				(= global294 0)
				(self dispose:)
			)
		)
	)
)

(instance theChase of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= local0 1) (= seconds 3))
			(1
				(Print 390 17 #title {Guard:} #time 4)
				(if (== (ego view?) 6) (ego setScript: 0) (UnlockEgo))
				(= seconds 1)
			)
			(2
				(client
					setCycle: Walk
					setMotion: MoveTo (ego x?) (+ (ego y?) 15) self
				)
			)
			(3
				(FaceObject client ego)
				(Print 390 18 #title {Guard:})
				(= cycles 1)
			)
			(4
				(UnlockEgo)
				(rGuard9 init:)
				(rGuard8 init:)
				(= cycles 10)
			)
			(5
				(if (== client rGuard6)
					(Die
						1
						{All things come to those who wait.__Looks like you waited too long, and look what came to you!_}
						80
						{Don't just stand there....}
					)
				else
					(Die
						1
						{You took too long to do your deed.}
						80
						{Don't just stand there....}
					)
				)
			)
		)
	)
)

(instance runningMan of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local6 0)
				(= global294 (GetTime 1))
				(if (== client rGuard7)
					(if (> (ego x?) 154)
						(ego setMotion: MoveTo 159 100 self)
					else
						(ego setMotion: MoveTo 20 170 self)
					)
				else
					(self cue:)
				)
			)
			(1
				(Print 390 19 #title {Guard:})
				(= cycles 2)
			)
			(2
				(if (< (ego y?) 150)
					(ego setMotion: MoveTo 160 82 self)
				else
					(ego setMotion: MoveTo -10 162 self)
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance multiGuards of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(DrawFeature rGuard10 rGuard11 rGuard12 rGuard13 rGuard14)
				(= seconds 3)
			)
			(1
				(Die
					1
					{Looks like they were waiting for you.__Maybe you should have made them wait a bit longer before you returned._}
					80
					{Many unhappy returns}
				)
				(self dispose:)
			)
		)
	)
)

(instance ropeMe of Script
	(properties)
	
	(method (doit)
		(if (== (ego z?) 33) (ego setScript: intoWindow))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 218 128 self)
			)
			(1 (caller cue:))
		)
	)
)

(instance levMe of Script
	(properties)
	
	(method (doit)
		(if (== (ego z?) 45) (ego setScript: jumpToWindow))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego inRect: 109 178 130 189)
					(ego setMotion: MoveTo 90 180 self)
				else
					(self cue:)
				)
			)
			(1
				(if (ego inRect: 0 150 160 189)
					(ego setMotion: MoveTo 100 140 self)
				else
					(self cue:)
				)
			)
			(2
				(ego setMotion: MoveTo 235 127 self)
			)
			(3 (ego loop: 3) (= cycles 2))
			(4 (caller cue:))
		)
	)
)

(instance intoWindow of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 6
					loop: 6
					cel: 0
					z: 0
					posn: 228 83
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1
				(if (ego has: 47)
					(cast eachElementDo: #hide)
					(curRoom drawPic: 2 6)
					(= cycles 2)
				else
					(curRoom newRoom: 410)
					(self dispose:)
				)
			)
			(2 (localproc_000c))
		)
	)
)

(instance jumpToWindow of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 6 loop: 6 cel: 3 z: 0 posn: 238 82)
				(= cycles 2)
			)
			(1
				(if (ego has: 47)
					(cast eachElementDo: #hide)
					(curRoom drawPic: 2 6)
					(= cycles 2)
				else
					(curRoom newRoom: 410)
					(self dispose:)
				)
			)
			(2 (localproc_000c))
		)
	)
)

(instance rightFullBlock of PicView
	(properties
		x 308
		y 164
		shiftClick 0
		view 460
		loop 3
		priority 7
		signal $4010
		palette 1
	)
	
	(method (init)
		(super init: &rest)
		(if isNightTime (= palette 2))
	)
)

(instance leftAlleyDoor of Feature
	(properties
		x 5
		y 124
		noun '/door,sign[<alley,bearing,street]'
		nsTop 92
		nsBottom 156
		nsRight 13
		description {the alley leading west}
		lookStr {You see a dark foreboding passage leading West.__The street sign reads "Everything not mandatory is forbidden!"}
	)
)

(instance topAlleyDoor of Feature
	(properties
		x 158
		y 67
		noun '/door,sign[<alley,bearing,street]'
		nsTop 38
		nsLeft 132
		nsBottom 91
		nsRight 185
		description {the alley leading North}
		lookStr {You see a dark foreboding passage leading North.__The street sign reads "You must carry your Visa at all times!"}
	)
)

(instance guardZapped of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					illegalBits: 0
					setPri: 8
					signal: 16384
					view: 381
					loop: 2
					cel: 1
					posn: (- (client x?) 10) (+ (client y?) 10)
				)
				(= cycles 1)
			)
			(1
				(client
					cel: 2
					posn: (- (client x?) 8) (- (client y?) 13)
				)
				(= cycles 1)
			)
			(2
				(client
					cel: 3
					posn: (- (client x?) 16) (+ (client y?) 14)
				)
				(= cycles 1)
			)
			(3
				(client signal: -32735)
				(= local8 1)
				(self dispose:)
			)
		)
	)
)
