;;; Sierra Script 1.0 - (do not remove this comment)
(script# 420)
(include sci.sh)
(use Main)
(use n001)
(use TopWindow)
(use Talker)
(use Intrface)
(use RandCyc)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm420 0
)

(local
	[local0 200]
	local200
	local201
)
(procedure (localproc_000c param1)
	(Print param1 &rest 67 184 140 70 135)
)

(procedure (localproc_0024 param1)
	(Print param1 &rest 67 -1 180 70 310)
)

(instance rm420 of Rm
	(properties
		picture 420
		style $0010
	)
	
	(method (init)
		(Load rsVIEW 420 421 425)
		(Load rsSOUND 420)
		(super init: &rest)
		(egoHead init:)
		(adAvis init:)
		(rightArm init:)
		(leftArm init:)
		(leftflame cel: 1 init:)
		(rightflame init:)
		(UnlockEgo)
		(gCMusic number: 420 loop: -1 priority: 5 playBed:)
		(self setScript: talkToEgo)
	)
	
	(method (dispose)
		(DisposeScript 941)
		(super dispose:)
	)
)

(instance talkToEgo of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_000c 420 0)
				(= cycles 3)
			)
			(1
				(Say
					adAvis
					self
					(Format @local0 420 1 @userName)
					420
					2
					420
					3
					420
					4
				)
				(adAvis
					cycleSpeed: 2
					setScript: gesture
					setCycle: RandCycle -1
				)
			)
			(2
				(localproc_000c 420 5)
				(localproc_000c 420 6)
				(= cycles 3)
			)
			(3
				(Say
					adAvis
					self
					(Format @local0 420 1 @userName)
					420
					7
					420
					8
					420
					9
				)
			)
			(4
				(localproc_000c 420 10)
				(= cycles 3)
			)
			(5
				(Say
					adAvis
					self
					(Format @local0 420 1 @userName)
					420
					11
					420
					12
					420
					13
				)
			)
			(6
				(localproc_000c 420 14)
				(= cycles 3)
			)
			(7
				(Say
					adAvis
					self
					(Format @local0 420 15 @userName)
					420
					16
				)
			)
			(8
				(localproc_000c 420 17)
				(= cycles 3)
			)
			(9
				(Say adAvis self 420 18 420 19 420 20)
			)
			(10
				(localproc_000c 420 21)
				(= cycles 3)
			)
			(11
				(Say adAvis self 420 22 420 23)
			)
			(12
				(localproc_0024 420 24)
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 1)
			)
			(13
				(Print 420 25)
				(curRoom newRoom: 550)
				(self dispose:)
			)
		)
	)
)

(instance gesture of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= state (Random 0 1))
				(= seconds (Random 2 4))
			)
			(1
				(= state -1)
				(if local200
					(= local200 0)
					(leftArm setCycle: Beg self)
				else
					(= local200 1)
					(leftArm setCycle: End self)
				)
			)
			(2
				(= state -1)
				(if local201
					(= local201 0)
					(rightArm setCycle: Beg self)
				else
					(= local201 1)
					(rightArm setCycle: End self)
				)
			)
		)
	)
)

(instance leftflame of Prop
	(properties
		x 41
		y 28
		view 420
		cel 1
	)
)

(instance rightflame of Prop
	(properties
		x 281
		y 31
		view 420
		loop 1
		cel 2
	)
)

(instance egoHead of Actor
	(properties
		x 220
		y 96
		view 421
	)
)

(instance adAvis of Talker
	(properties
		x 118
		y 92
		description {Ad Avis}
		view 425
		cel 4
		tLoop -1
		color 15
		back 5
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow BotWindow)
	)
)

(instance leftArm of Prop
	(properties
		x 156
		y 115
		view 425
		loop 4
		cel 2
		cycleSpeed 2
	)
)

(instance rightArm of Prop
	(properties
		x 84
		y 124
		view 425
		loop 3
		cycleSpeed 2
	)
)

(instance rightArm2 of Prop
	(properties
		x 58
		y 173
		view 425
		loop 2
		cel 4
		signal $4000
	)
)
