;;; Sierra Script 1.0 - (do not remove this comment)
(script# 440)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use TargActor)
(use Intrface)
(use Feature)
(use LoadMany)
(use StopWalk)
(use DPath)
(use Grooper)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm440 0
)

(local
	theCurrentTimeZone
	[local1 100]
	[theInvNum_2 58]
	local159
	local160
	local161
	local162
	local163
	local164 =  5000
	local165
	[local166 38] = [1 2 3 0 0 0 0 0 0 0 4 5 6 0 7 0 0 0 0 0 0 8 0 9 10 0 0 0 0 0 11 0 12]
	[local204 22] = [13 '//pin' 14 '//underground,resistance' 15 '//escape,passage' 16 '//equipment,belonging' 17 '//shameen' 18 '//shema' 19 '//khaveen' 20 '//guard' 21 '//capture' 22 '//honor']
)
(procedure (localproc_2106 &tmp temp0 theInvNum)
	(= theInvNum [invNum 27])
	(= temp0 0)
	(while (<= temp0 58)
		(= [theInvNum_2 temp0] [invNum temp0])
		(if (!= temp0 27) (= [invNum temp0] 0))
		(++ temp0)
	)
)

(procedure (localproc_2136 &tmp temp0)
	(= temp0 0)
	(while (<= temp0 58)
		(if (or (== temp0 2) (== temp0 1))
			(= [invNum temp0] 0)
		else
			(= [invNum temp0] [theInvNum_2 temp0])
		)
		(= [theInvNum_2 temp0] 0)
		(++ temp0)
	)
	(= local160 1)
)

(procedure (localproc_2173)
	(door hide:)
	(sharaf hide:)
	(straw hide:)
	(= defaultPalette 1)
	(ego illegalBits: -32768 ignoreActors: 0)
	(curRoom style: 15 drawPic: 2)
	(curRoom drawPic: 440 overlay: 442 7)
	(if (and (Btst 94) (cast contains: shar))
		(curRoom setScript: dualEscapeS)
	)
)

(procedure (localproc_21e8)
	(door show:)
	(sharaf show:)
	(straw show:)
	(= defaultPalette 0)
	(ego illegalBits: -32768 ignoreActors: 0)
	(curRoom style: 15 drawPic: 2)
	(curRoom drawPic: 440 overlay: 441 7)
)

(instance rm440 of Rm
	(properties
		picture 440
		style $000f
	)
	
	(method (init)
		(Load rsPIC 2 441 442)
		(LoadMany 128 440 445 49 576 6 47 382)
		(Load rsTEXT 445)
		(Load rsSOUND 20)
		(= gGDftSC theSpellChecker)
		(= egoWalkMode 0)
		(= theCurrentTimeZone currentTimeZone)
		(localproc_2106)
		(= defaultPalette 0)
		(super init:)
		(curRoom overlay: 441)
		(ego init:)
		(sharaf init: hide:)
		(shar init:)
		(door init:)
		(outerDoor init:)
		(secretDoor init: stopUpd:)
		(equipment init: stopUpd:)
		(guard init: setCycle: Walk setLoop: Grooper)
		(straw setPri: 0 init: stopUpd:)
		(win init:)
		(table init:)
		(wall init:)
		(inlets init:)
		(self setScript: thrownInS)
	)
	
	(method (doit)
		(super doit:)
		(-- local164)
		(cond 
			((curRoom script?))
			((not local164) (self setScript: gotCaughtS))
			((== local164 1000) (HighPrint 440 0))
		)
		(cond 
			((curRoom script?))
			((and local165 (not (Btst 87))) (= local165 0) (Die 1 440 1 80 {What were you thinking?}))
			((<= (ego y?) 136) (if (not (& (door signal?) $0080)) (localproc_2173)))
			((& (door signal?) $0080) (localproc_21e8))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/cell,dungeon')
				)
				(HighPrint 440 2)
			)
			((Said 'gave/food')
				(cond 
					((Btst 94)
						(SkillUsed 14 25)
						(if (> (ego use: 3) 0)
							(Say shar 440 3)
						else
							(Say shar 440 4)
						)
					)
					(local163 (Say shar 440 5))
					(else (HighPrint 440 6) (pEvent claimed: 1))
				)
			)
			((Said 'listen') (HighPrint 440 7))
			((Said 'look,examine/bar') (HighPrint 440 8))
			((Said 'kill/catperson,cousin,friend') (Die 1 440 9 80 {Next Time, Try Dale Carnegie}))
			((Said 'thank/catperson,cousin,friend')
				(cond 
					((not (Btst 94)) (HighPrint 440 10))
					((TestSkill 14 50) (SayThanks shar 440 11))
					(else (HighPrint 440 12))
				)
			)
			((Said 'made,gave,display/sign[<thief]')
				(MakeThiefSign)
				(HighPrint 440 13)
				(if (Btst 94) (HighPrint 440 14))
			)
			((Said 'force[/boulder,wall]')
				(if (secretDoor cel?)
					(PrintAlreadyDoneThat)
				else
					(HighPrint 440 15)
				)
			)
			((Said 'stare')
				(FaceObject ego shar)
				(SetUpEgo)
				(HighPrint 440 16)
				(ego setHeading: 235)
			)
			((<= (ego y?) 136)
				(cond 
					(
						(or
							(Said 'use/force,strength')
							(Said 'force,break,force,open,open,unlock/door,gate')
						)
						(self setScript: gotCaughtS)
					)
					((Said 'search')
						(cond 
							((not (secretDoor cel?)) (self setScript: soloEscapeS))
							((not local160) (HighPrint 440 17))
							(else (HighPrint 440 18))
						)
					)
					(
						(or
							(Said 'go,crawl,done,done,escape,(bend,get,acquire<down)')
							(Said 'enter/passage')
						)
						(if (cast contains: secretDoor)
							(HighPrint 440 19)
						else
							(self setScript: leaveS)
						)
					)
					((Said 'force,move[/boulder,wall]')
						(cond 
							((secretDoor cel?) (PrintAlreadyDoneThat))
							((and (> (ego x?) 103) (< (ego y?) 123))
								(HighPrint 440 20)
								(soloEscapeS start: 3)
								(self setScript: soloEscapeS)
							)
							(else (HighPrint 440 15))
						)
					)
				)
			)
			(
				(or
					(Said 'tell//shapeir,shema,shameen,self,cousin')
					(Said 'ask//catperson,cousin,friend')
				)
				(cond 
					((Btst 94) (HighPrint 440 21))
					((TestSkill 13 120) (self setScript: makeFriendS))
					(else (= local163 1) (Say shar 440 5))
				)
			)
			(
			(or (Said 'display/pin') (Said 'display//pin'))
				(cond 
					(local162 (HighPrint 440 22))
					([invNum 27] (= local162 1) (self setScript: makeFriendS))
					(else (PrintDontHaveIt))
				)
			)
			(
				(or
					(Said 'use/strength')
					(Said 'force,break,force/door,gate')
				)
				(if (door cel?)
					(HighPrint 440 23)
				else
					(self setScript: pushDoorS)
				)
			)
			((Said 'search')
				(cond 
					([invNum 27]
						(if (cast contains: shar)
							(HighPrint 440 24)
						else
							(HighPrint 440 25)
						)
					)
					([invNum 58] (HighPrint 440 25))
					(else (HighPrint 440 26) (= [invNum 58] 1))
				)
			)
			(
				(or
					(Said 'use/pin,nail')
					(Said 'lockpick/lock,door,gate/pin,nail')
				)
				(cond 
					((not (if [invNum 27] else [invNum 58])) (PrintDontHaveIt))
					((door cel?) (HighPrint 440 23))
					((TestSkill 9 5)
						(HighPrint
							(Format
								@local1
								440
								27
								(if [invNum 27]
									{pointed end of your sapphire pin}
								else
									{nail you found}
								)
							)
						)
						(self setScript: pickS)
					)
					(else (HighPrint 440 28))
				)
			)
			((Said 'lockpick/lock,door,gate')
				(if local160
					(if (not (door cel?))
						(if (CanPickLocks 1) (self setScript: pickS))
					else
						(HighPrint 440 23)
					)
				else
					(HighPrint 440 29)
				)
			)
			((Said 'climb,scale') (if [skills 11] (HighPrint 440 30)))
			((Said 'bend,break/bar')
				(if (TestSkill 0 150)
					(HighPrint 440 31)
				else
					(HighPrint 440 32)
				)
			)
			(
				(or
					(Said 'come,follow,heel')
					(Said 'lockpick//catperson,cousin,friend')
				)
				(if (Btst 94)
					(if (door cel?)
						(= local163 1)
						(Say shar 440 33)
					else
						(Say shar 440 34)
					)
				else
					(HighPrint 440 35)
				)
			)
			((Said 'go,done,done,escape')
				(if (door cel?)
					(HighPrint 440 36)
				else
					(HighPrint 440 37)
				)
			)
		)
	)
)

(instance thrownInS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					posn: 81 135
					setHeading: 135
					setMotion: MoveTo 90 142 self
				)
				(guard posn: 85 127 setMotion: MoveTo 83 138)
			)
			(1
				(ego
					view: 49
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: End
					setStep: 1 1
					setMotion: MoveTo 95 147 self
				)
			)
			(2
				(guard setMotion: MoveTo 80 125 self)
			)
			(3
				(guard setMotion: MoveTo 95 106 self)
				(door setCycle: Beg)
			)
			(4
				(outerDoor setCycle: End self)
			)
			(5
				(guard setMotion: MoveTo 102 95 self)
			)
			(6
				(guard setMotion: MoveTo 125 94 self)
			)
			(7
				(ego
					setLoop: 1
					posn: 93 148
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
				(guard dispose:)
				(outerDoor setCycle: Beg)
			)
			(8
				(proc1_19)
				(ego posn: 127 167 loop: 4 setHeading: 135)
				(guard dispose:)
				(door ignoreActors: 0 stopUpd:)
				(= cycles 6)
			)
			(9
				(HighPrint 440 38)
				(= cycles 4)
			)
			(10
				(Print 440 39)
				(outerDoor stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance pushDoorS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 101 145 self)
				(++ local159)
			)
			(1
				(ego
					view: 576
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: CT 4 1 self
				)
			)
			(2
				(if
					(= register
						(cond 
							(
								(or
									(TestSkill 0 150)
									(and (>= [skills 0] 130) (== local159 2))
								)
							)
							((== gHeroType 0)
								(if (== local159 3)
									(if (not [skills 9]) (not [skills 12]))
								)
							)
						)
					)
					(= cycles 1)
				else
					(ego cel: 4 setCycle: End self)
				)
			)
			(3
				(if register
					(ego
						setLoop: 4
						cel: 0
						setStep: 2 2
						setMotion: MoveTo 120 123
					)
					(door setCycle: End)
				else
					(ego
						setLoop: 2
						cel: 1
						setStep: 3 3
						setMotion: MoveTo 93 152
					)
				)
				(ego view: 6 cycleSpeed: 1 setCycle: End self)
			)
			(4
				(if register (ego setLoop: 5) else (ego setLoop: 3))
				(ego cel: 0 cycleSpeed: 2 setCycle: End self)
			)
			(5 (proc1_19) (= cycles 5))
			(6
				(cond 
					(register
						(cond 
							(local161 (self cue:))
							((not (Btst 94)) (HighPrint 440 40) (self cue:))
							(else (Say shar self 440 41))
						)
						(= local161 1)
					)
					(
						(and
							(== gHeroType 0)
							(not [skills 9])
							(not [skills 12])
						)
						(switch local159
							(1
								(HighPrint 440 42)
								(self cue:)
							)
							(2
								(HighPrint 440 43)
								(self cue:)
							)
						)
					)
					((or [skills 9] [skills 12]) (HighPrint 440 44) (self cue:))
					(else (self cue:))
				)
			)
			(7
				(if register
					(ego loop: 4 setHeading: 135)
				else
					(ego loop: 3 setHeading: 0)
				)
				(self dispose:)
			)
		)
	)
)

(instance pickS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 78 140 self)
			)
			(1
				(ego view: 47 setLoop: 4 cycleSpeed: 1 setCycle: End self)
			)
			(2
				(gMiscMusic number: 20 priority: 10 loop: 0 play:)
				(door cycleSpeed: 4 setScript: openDoorS self)
			)
			(3
				(ego cel: 3 setCycle: Beg self)
			)
			(4 (proc1_19) (self dispose:))
		)
	)
)

(instance makeFriendS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local163 1)
				(sharaf hide:)
				(if (< (ego x?) 230)
					(ego setMotion: MoveTo 222 152 self)
				else
					(= cycles 3)
				)
			)
			(1
				(FaceObject ego sharaf)
				(= cycles 4)
			)
			(2 (shar setCycle: End self))
			(3
				(shar stopUpd:)
				(SetUpEgo)
				(AddToScore 631 7)
				(sharaf posn: 248 124)
				(if local162
					(Say shar self 440 45 440 46)
				else
					(Say shar self 440 47)
				)
			)
			(4 (Bset 94) (self dispose:))
		)
	)
)

(instance openDoorS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door startUpd: setCycle: End self)
			)
			(1
				(door stopUpd: ignoreActors:)
				(if (not local161) (= cycles 16) else (self dispose:))
			)
			(2
				(if (not (Btst 94))
					(HighPrint 440 40)
					(self dispose:)
				else
					(Say shar self 440 41)
				)
				(= local161 1)
			)
			(3 (self dispose:))
		)
	)
)

(instance closeDoorS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door startUpd: ignoreActors: 0 setCycle: Beg self)
			)
			(1
				(door stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance gotCaughtS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1 temp2)
		(switch (= state newState)
			(0
				(if
					(and
						(<= (Abs (= temp0 (- (ego x?) 80))) 26)
						(< (ego y?) 136)
					)
					(= temp1 (if (< temp0 0) 54 else 106))
					(ego view: 0 setCycle: StopWalk 4)
					(if (< (ego y?) 112)
						(ego setMotion: DPath 80 112 56 120 self)
					else
						(ego setMotion: MoveTo temp1 (ego y?) self)
					)
				else
					(self cue:)
				)
			)
			(1
				(= temp2 (GetAngle (ego x?) (ego y?) 42 136))
				(ego setHeading: temp2)
				(outerDoor setCycle: End self)
			)
			(2
				(guard
					init:
					setCycle: Walk
					posn: 125 94
					setMotion: MoveTo 102 95 self
				)
			)
			(3
				(guard setMotion: MoveTo 95 106 self)
				(outerDoor setCycle: Beg)
			)
			(4
				(guard setMotion: MoveTo 80 125 self)
			)
			(5
				(FaceObject ego guard 1 self)
			)
			(6
				(Die 1 440 48 80 {In Guarded Condition})
			)
		)
	)
)

(instance soloEscapeS of HandsOffScript
	(properties)
	
	(method (dispose)
		(proc1_19)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 66 121 self)
			)
			(1
				(ego setMotion: MoveTo 30 129 self)
			)
			(2
				(ego setMotion: MoveTo 172 121 self)
			)
			(3
				(ego setMotion: MoveTo 120 117 self)
			)
			(4
				(ego
					posn: 112 117
					view: 47
					cel: 0
					setLoop: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(5
				(HighPrint 440 49)
				(ego
					view: 445
					setLoop: 9
					cel: 0
					cycleSpeed: 3
					setCycle: End self
				)
			)
			(6
				(secretDoor cycleSpeed: 3 setCycle: End self)
			)
			(7
				(secretDoor dispose:)
				(ego view: 47 setLoop: 0 cel: 3)
				(HighPrint 440 50)
				(if (not local160) (HighPrint 440 51))
				(= cycles 8)
			)
			(8
				(if local160
					(cast eachElementDo: #hide)
					(curRoom drawPic: 2)
					(Print 440 52)
					(AddToScore 630 7)
					(= currentDay 29)
					(SetGameTime 17 0)
					(= gTopExit 1)
					(curRoom newRoom: 703)
				else
					(ego cel: 3 cycleSpeed: 1 setCycle: Beg self)
				)
			)
			(9 (self dispose:))
		)
	)
)

(instance dualEscapeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 93 121)
				(shar
					setPri: -1
					posn: 136 152
					setLoop: 1
					setCycle: Fwd
					setStep: 4 3
					setMotion: MoveTo 44 142 self
				)
				(sharaf posn: -10 -10)
			)
			(1
				(ego setMotion: 0)
				(FaceObject ego shar)
				(shar setLoop: 4 setMotion: MoveTo 142 120 self)
			)
			(2
				(shar setCycle: 0 cel: 1)
				(if (secretDoor cel?)
					(Say shar self 440 53)
				else
					(Say shar self 440 54)
				)
			)
			(3 (= cycles 8))
			(4
				(sharaf setPri: 14)
				(ego setMotion: MoveTo 112 117)
				(if (secretDoor cel?)
					(Say shar self 440 55)
				else
					(Say shar self 440 56)
				)
			)
			(5
				(if (secretDoor cel?)
					(self state: 7)
				else
					(ego
						posn: 112 117
						view: 47
						cel: 0
						setLoop: 0
						cycleSpeed: 1
						setCycle: End
					)
				)
				(shar view: 445 setLoop: 5 cel: 0 setCycle: End self)
			)
			(6
				(ego
					view: 445
					setLoop: 9
					cel: 0
					cycleSpeed: 3
					setCycle: End self
				)
				(shar setLoop: 8 cel: 0 cycleSpeed: 3 setCycle: End)
			)
			(7
				(secretDoor cycleSpeed: 3 setCycle: End self)
			)
			(8
				(secretDoor dispose:)
				(ego view: 47 setLoop: 0 cel: 3)
				(sharaf posn: 158 104)
				(= cycles 1)
			)
			(9
				(if (not local160)
					(Say shar self 440 57 440 58 440 59)
				else
					(Say shar self 440 57)
				)
			)
			(10
				(shar
					setPri: 4
					setLoop: 6
					posn: 162 111
					cycleSpeed: 0
					setStep: 2 1
					setCycle: Fwd
					setMotion: MoveTo 193 108 self
				)
			)
			(11
				(shar dispose:)
				(sharaf dispose:)
				(= local164 450)
				(if local160
					(cast eachElementDo: #hide)
					(curRoom drawPic: 2)
					(Print 440 60)
					(Print 440 61)
					(AddToScore 630 7)
					(= currentDay 29)
					(SetGameTime 17 0)
					(= gTopExit 1)
					(curRoom newRoom: 703)
				else
					(ego cel: 3 cycleSpeed: 1 setCycle: Beg self)
				)
			)
			(12 (proc1_19) (self dispose:))
		)
	)
)

(instance leaveS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 112 120 self)
			)
			(1
				(ego view: 47 setLoop: 0 cel: 0 setCycle: End self)
			)
			(2
				(= temp0 (Btst 94))
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(if (not local160)
					(if temp0
						(Die 1 440 62 80 {Forget something?})
					else
						(Die 1 440 63 80 {Forget something?})
					)
				else
					(if temp0
						(Print 440 60)
						(Print 440 61)
					else
						(Print 440 64)
					)
					(AddToScore 630 7)
					(= currentDay 29)
					(SetGameTime 17 0)
					(= gTopExit 1)
					(curRoom newRoom: 703)
				)
			)
		)
	)
)

(instance getStuffS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 172 126 self)
			)
			(1
				(ego setMotion: MoveTo 186 130 self)
			)
			(2
				(localproc_2136)
				(equipment hide:)
				(HighPrint 440 65)
				(ego setMotion: MoveTo 168 126 self)
			)
			(3
				(ego setPri: -1)
				(self dispose:)
			)
		)
	)
)

(instance straw of View
	(properties
		x 249
		y 153
		noun '/hay'
		description {straw}
		view 440
	)
)

(instance guard of Actor
	(properties
		noun '/guard,man'
		description {the guard}
		lookStr {The guards of Raseir sure are less friendly to tourists.}
		view 382
		signal $4000
		illegalBits $0000
	)
)

(instance secretDoor of TargActor
	(properties
		x 145
		y 114
		noun '/wall,passage,boulder'
		description {the wall}
		lookStr {The wall looks solid enough.}
		view 440
		loop 1
		priority 8
		signal $0810
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (OneOf theVerb 2 1 5)
			(cond 
				((secretDoor cel?) (PrintAlreadyDoneThat))
				((not (<= (ego y?) 136)) (HighPrint 440 67))
				((and (> (ego x?) 103) (< (ego y?) 123))
					(HighPrint 440 20)
					(soloEscapeS start: 3)
					(self setScript: soloEscapeS)
				)
				(else (HighPrint 440 68))
			)
		else
			(super doVerb: theVerb)
		)
	)
	
	(method (fetchMe)
		(HighPrint 440 66)
		(return 0)
	)
	
	(method (hurtMe)
		(return 1)
	)
	
	(method (openMe)
		(HighPrint 440 66)
		(return 0)
	)
)

(instance equipment of TargActor
	(properties
		x 209
		y 100
		noun '/equipment,belonging,stuff,clothes,item'
		description {your equipment}
		lookStr {Your equipment has been carefully searched and neatly laid out on the table, awaiting Khaveen's inspection.}
		view 440
		cel 1
		priority 8
		signal $4010
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(cond 
				(local160 (HighPrint 440 70))
				((not (<= (ego y?) 136)) (HighPrint 440 71))
				((< (ego y?) 113) (HighPrint 440 72))
				(else (self setScript: getStuffS))
			)
		else
			(super doVerb: theVerb)
		)
	)
	
	(method (fetchMe)
		(localproc_2136)
		(self setLoop: 0 setCel: 1)
		(return 1)
	)
	
	(method (hurtMe param1 param2)
		(return
			(if (== (param2 type?) 25)
				(HighPrint 440 69)
				(self dispose:)
				(return 1)
			else
				(return 0)
			)
		)
	)
)

(instance door of TargActor
	(properties
		x 42
		y 136
		noun '/door,gate[<cell,iron]'
		description {the gate to the cell}
		lookStr {The gate is made of the same iron bars as the rest of the cell.__The lock is a simple key mounting.}
		view 445
		cel 2
		signal $4000
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(3
				(if cel (HighPrint 440 75) else (HighPrint 440 74))
			)
			(2
				(if cel (outerDoor openMe:) else (HighPrint 440 76))
			)
			(1 (HighPrint lookStr))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (fetchMe)
		(if cel
			(self setScript: closeDoorS)
		else
			(HighPrint 440 74)
		)
		(return 0)
	)
	
	(method (openMe)
		(return
			(if cel
				(HighPrint 440 73)
				(return 0)
			else
				(self setScript: openDoorS)
				(return 1)
			)
		)
	)
)

(instance sharaf of Prop
	(properties
		x 248
		y 133
		view 445
		loop 3
		cel 1
		priority 11
		signal $0010
	)
)

(instance shar of Talker
	(properties
		x 250
		y 151
		description {Sharaf}
		lookStr {The katta is thin, and looks as if he has been recently beaten.}
		yStep 3
		view 445
		loop 2
		priority 10
		signal $4010
		illegalBits $0000
		xStep 4
		tLoop -1
		talkSpeed 1
		myName '//cousin,catperson,friend'
		title {Sharaf:}
		color 1
		back 7
		msgFile 445
	)
	
	(method (onMe)
		(if (super onMe: &rest) else (sharaf onMe: &rest))
	)
	
	(method (hurtMe)
		(sharaf show: setCel: 2)
		(= local165 1)
	)
	
	(method (atSpec param1)
		(return [local204 param1])
	)
	
	(method (atGen param1)
		(return [local166 param1])
	)
	
	(method (messages)
		(cond 
			(
				(and
					(Btst 94)
					(door cel?)
					local161
					(not (<= (ego y?) 136))
					(not local163)
				)
				(sharaf show: setCycle: Fwd)
				(switch (Random 1 3)
					(1
						(super
							messages:
								{I would tell you all you wish to know.___But now it is time to depart... in great haste!}
						)
					)
					(2
						(super
							messages:
								{Truly, you have many questions I might answer, but the guards will soon return.__We must leave this most dangerous place.}
						)
					)
					(else 
						(super
							messages:
								{I will answer all later.__But now that you have so skillfully opened the door, we should leave.}
						)
					)
				)
			)
			((or (Btst 94) local163)
				(= local163 0)
				(sharaf show: setCycle: Fwd)
				(super messages: &rest)
			)
			(else (HighPrint 440 6))
		)
	)
	
	(method (endTalk)
		(super endTalk: &rest)
		(sharaf setCycle: 0 hide:)
	)
)

(instance outerDoor of TargActor
	(properties
		x 94
		y 102
		noun '/door<wooden'
		description {the heavy wooden door}
		lookStr {The heavy wooden door leads to the hallway.__You can hear the sound of many boots marching and several guards talking.}
		view 445
		loop 10
		priority 2
		signal $0010
	)
	
	(method (hurtMe)
		(HighPrint 440 77)
		(curRoom setScript: gotCaughtS)
		(return 1)
	)
	
	(method (openMe)
		(curRoom setScript: gotCaughtS)
		(return 1)
	)
)

(instance win of Feature
	(properties
		x 274
		y 151
		z 68
		noun '/window'
		nsTop 65
		nsLeft 258
		nsBottom 102
		nsRight 291
		description {the barred window}
		lookStr {The bars on the window are heavy iron, and are set in stone.}
	)
)

(instance table of Feature
	(properties
		x 206
		y 111
		noun '/table'
		nsTop 96
		nsLeft 186
		nsBottom 126
		nsRight 227
		description {the stone table}
		lookStr {It is a stone table.}
	)
)

(instance wall of Feature
	(properties
		x 213
		y 125
		z 55
		noun '/wall'
		nsTop 44
		nsLeft 199
		nsBottom 97
		nsRight 227
		description {the stone wall}
		lookStr {The stone wall is just that.}
	)
)

(instance inlets of Feature
	(properties
		x 275
		y 150
		z 102
		noun '/duct,duct'
		nsTop 40
		nsLeft 260
		nsBottom 56
		nsRight 291
		description {the ventilation ducts}
		lookStr {The ventilation ducts are heavily reinforced.}
	)
)

(instance theSpellChecker of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (OneOf param1 28 6)
				(HighPrint 440 78)
				(return 0)
			else
				(return 1)
			)
		)
	)
)
