;;; Sierra Script 1.0 - (do not remove this comment)
(script# 490)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use ProjClient)
(use TargActor)
(use Flame)
(use Full)
(use n095)
(use Intrface)
(use LoadMany)
(use Save)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm490 0
)

(local
	local0
	[local1 100]
	[newACandle 6]
	[local107 6] = [118 114 83 53 50 84]
	[local113 6] = [107 98 93 98 107 114]
	[newAFlame 6]
	[local125 6] = [117 113 82 52 49 83]
	[local131 6] = [96 87 82 87 96 103]
	local137
	[local138 4] = [-4 0 2]
	[local142 4] = [10 13 17 18]
	local146
	local147
	local148
	local149
	local150
	local151
	local152
	local153
	local154
	local155
	local156
	local157
	local158
	local159
	local160
	local161
)
(procedure (localproc_000c)
	((= [newAFlame local0] (aFlame new:))
		x: [local125 local0]
		y: [local131 local0]
		init:
	)
	(return (++ local0))
)

(procedure (localproc_0232)
	(switch arcadeDifficultyLevel
		(1 (= local159 150))
		(2 (= local159 120))
		(3 (= local159 60))
	)
)

(instance toPillar of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 491 loop: 0 cel: 0 setCycle: CT 3 1 self)
			)
			(1
				(if (== local161 2)
					(ego cel: 4 posn: (+ (ego x?) 5) (- (ego y?) 1))
				else
					(ego cel: 4 posn: (+ (ego x?) 5) (ego y?))
				)
				(if (== local161 2) (= local161 0) else (++ local161))
				(= cycles 1)
			)
			(2 (self dispose:))
		)
	)
)

(instance fromPillar of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 491 loop: 0 cel: 4)
				(= cycles 1)
			)
			(1 (ego cel: 3) (= cycles 1))
			(2 (ego cel: 2) (= cycles 1))
			(3 (ego cel: 1) (= cycles 1))
			(4
				(if (== local161 2)
					(ego cel: 0 posn: (- (ego x?) 5) (+ (ego y?) 1))
				else
					(ego cel: 0 posn: (- (ego x?) 5) (ego y?))
				)
				(if (== local161 2) (= local161 0) else (++ local161))
				(= cycles 1)
			)
			(5 (self dispose:))
		)
	)
)

(instance rm490 of Rm
	(properties
		picture 490
	)
	
	(method (init)
		(LoadMany
			128
			6
			8
			32
			4
			9
			612
			47
			501
			555
			491
			495
			613
			3
			490
			285
			781
		)
		(Load rsSCRIPT 491)
		(AddToScore 715 5 2)
		(super init:)
		(= gGDftSC spellCode)
		(iblis init:)
		(= local0 0)
		(while (< local0 6)
			((= [newACandle local0] (aCandle new:))
				x: [local107 local0]
				y: [local113 local0]
				init:
				stopUpd:
			)
			(++ local0)
		)
		(= local0 0)
		(localproc_000c)
		(avis init: setCycle: Fwd)
		(proc1_19)
		(ego loop: 1 cel: 0 setPri: 12 posn: 330 160 init:)
		(self setScript: comeIn)
		(gCMusic number: 470 loop: -1 playBed:)
	)
	
	(method (doit)
		(if
		(and (> (ego x?) 316) local148 (not (ego script?)))
			(ego setScript: oNoYouDont)
		)
		(if
		(and (ego inRect: 31 126 46 136) (not local147))
			(= local147 1)
			(ego setScript: (ScriptID 491 1))
			(curRoom setScript: nowWhat)
		)
		(if
		(and (ego inRect: 120 118 140 125) (not local158))
			(= local158 1)
			(= local159 5)
			(ego view: 491 loop: 3 cel: 0)
		)
		(cond 
			((not local159))
			((-- local159))
			((not (avis script?)) (avis setScript: shootEm))
		)
		(cond 
			((not local149))
			((-- local149))
			((== local150 0) (DjinniSpeaks 490 0) (= local149 50) (++ local150))
			((== local150 1) (DjinniSpeaks 490 1) (= local149 50) (++ local150))
			((== local150 2) (DjinniSpeaks 490 2) (++ local150))
			((== local150 3) (DjinniSpeaks 490 3) (= local149 50) (++ local150))
			((== local150 4) (DjinniSpeaks 490 4))
		)
		(cond 
			((not local137))
			((-- local137))
			(else (avis setScript: fireUp))
		)
		(super doit:)
	)
	
	(method (dispose)
		(DisposeScript 491)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine>')
				(cond 
					((or (Said '<up') (Said '/sky')) (HighPrint 490 5))
					(
					(or (Said '<down') (Said '/ground,courtyard,roof')) (HighPrint 490 6))
					(
						(or
							(Said 'search,look,examine[<at,around][/room,area][/!*]')
							(Said '/building,city,castle,hill,hill,minaret')
						)
						(HighPrint 490 7)
					)
					((Said '/chamber,ritual')
						(cond 
							(local147 (DjinniSpeaks 490 8))
							((== script avisDead) (HighPrint 490 9))
							(else (HighPrint 490 10))
						)
					)
					(
					(Said '/design,floor,pattern,hexagram,rune,star') (HighPrint 490 11))
					(
					(and (Said '/djinn') (not (cast contains: stayPufft))) (HighPrint 490 12))
				)
			)
			((Said 'hop') (DjinniSpeaks 490 13))
			((Said 'duck')
				(if (and (< (ego x?) 200) (< (avis y?) 150))
					(ego setScript: duckDown)
				else
					(HighPrint 490 14)
				)
			)
			((Said '(acquire[<off])/ring') (HighPrint 490 15) (DjinniSpeaks 490 16))
			((Said 'ask,tell/djinn') (DjinniSpeaks 490 17))
			((Said 'get,acquire') (HighPrint 490 18))
			((Said 'tell') (DjinniSpeaks 490 19))
			(
				(or
					(Said 'spray,squirt,splash/fire,candle,water,waterbag')
					(Said 'douse,(put<out)/fire,candle')
					(Said 'throw,use/water,waterbag')
				)
				(cond 
					((<= currentWater 0) (HighPrint 490 20))
					((> (ego x?) 200) (HighPrint 490 21))
					(else (-- currentWater) (HighPrint 490 22))
				)
			)
			((Said 'use/bellows')
				(cond 
					((not (ego has: 25)) (HighPrint 490 23))
					((> (ego x?) 200) (HighPrint 490 21))
					(else (HighPrint 490 24))
				)
			)
			((Said 'throw/dagger')
				(= local149 0)
				(= local152 5)
				(cond 
					((bProjectile client?) (DjinniSpeaks 490 25))
					((not (ego has: 5)) (HighPrint 490 26))
					((> (ego x?) 200) (ego setScript: wimpThrow))
					(else (ego setScript: thrower))
				)
			)
			((Said 'throw/boulder')
				(= local149 0)
				(= local152 4)
				(cond 
					((bProjectile client?) (DjinniSpeaks 490 25))
					((not (ego has: 9)) (HighPrint 490 27))
					((> (ego x?) 200) (ego setScript: wimpThrow))
					(else (ego setScript: thrower))
				)
			)
			((Said 'throw/dirt')
				(= local149 0)
				(= local152 6)
				(cond 
					((bProjectile client?) (DjinniSpeaks 490 25))
					((and (not (ego has: 52)) (not global293)) (HighPrint 490 28))
					((> (ego x?) 200) (ego setScript: wimpThrow))
					(else (ego setScript: thrower))
				)
			)
			((Said 'throw/powder')
				(= local149 0)
				(= local152 7)
				(cond 
					((bProjectile client?) (DjinniSpeaks 490 25))
					((not (ego has: 39)) (HighPrint 490 29))
					((> (ego x?) 200) (ego setScript: wimpThrow))
					(else (ego setScript: thrower))
				)
			)
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(cond 
					((not (ego has: 16)) (pEvent claimed: 0))
					((< (ego x?) 200) (HighPrint 490 30))
					(else (= local149 0) ((ScriptID 491 0) init:))
				)
			)
		)
	)
)

(instance aHead of TargActor
	(properties
		z 38
		noun '/ad,man,wizard,minister'
		description {Ad Avis}
		lookStr {Ad Avis is intent on raising Iblis.}
		view 555
		loop 5
		signal $4000
	)
	
	(method (cue)
		(super cue: &rest)
		(HighPrint 490 31)
		(dagger dispose:)
	)
	
	(method (hurtMe &tmp temp0)
		(return
			(if (ego inRect: 120 118 140 125)
				(if (== local157 1)
					(= local159 0)
					(if (not (avis script?)) (self setScript: avisDead))
				else
					(switch local152
						(4
							(if (== [invNum 9] 0)
								(= local159 0)
								(HighPrint 490 32 80 {Ad Avis:} 35 myHigh)
								(if (not (avis script?)) (self setScript: avisDead))
							else
								(HighPrint 490 33 80 {Ad Avis:} 35 myHigh)
								(++ local157)
							)
						)
						(5
							(if (== [invNum 5] 0)
								(= local159 0)
								(if (not (avis script?)) (self setScript: avisDead))
							else
								(self setScript: avisPoked)
								(++ local157)
							)
						)
						(6
							(HighPrint 490 34 80 {Ad Avis:} 35 myHigh)
							(HighPrint 490 35 80 {Your Alter-Ego:})
							(HighPrint 490 36)
						)
						(7 (HighPrint 490 37))
					)
				)
			else
				(dagger
					init:
					illegalBits: 0
					ignoreActors:
					posn: 189 86
					yStep: 10
					xStep: 3
					setPri: 6
					setLoop:
					(switch local152
						(4 4)
						(5 5)
						(6 4)
						(7 4)
					)
					setCycle: Fwd
					setMotion: MoveTo 283 191 self
				)
				(return 0)
			)
		)
	)
)

(instance flash of Prop
	(properties
		view 32
		loop 7
		signal $4000
	)
)

(instance smoke of Prop
	(properties
		x 88
		y 89
		view 781
		signal $4000
		cycleSpeed 3
	)
)

(instance nife of Actor
	(properties
		yStep 8
		view 9
		loop 5
		signal $0800
		illegalBits $0000
		xStep 8
	)
)

(instance avis of TargActor
	(properties
		x 147
		y 114
		noun '/ad,man,wizard,minister'
		description {Ad Avis}
		lookStr {Ad Avis is intent on raising Iblis.}
		view 495
		loop 2
		cycleSpeed 1
	)
	
	(method (hurtMe)
		(aHead hurtMe:)
	)
)

(instance stayPufft of Actor
	(properties
		x 178
		y 115
		noun '/djinn'
		description {the ghost}
		lookStr {Do you mind if I'm smoke?}
		view 612
		loop 6
		cel 5
		priority 8
		signal $4010
		illegalBits $0000
	)
)

(instance aCandle of TargActor
	(properties
		noun '/candle'
		description {the ritual candle}
		lookStr {The candles are a crucial part of the Iblis ritual.}
		view 490
	)
	
	(method (hurtMe &tmp temp0)
		(= temp0 0)
		(while (< temp0 local0)
			(if (== [newACandle temp0] self)
				(HighPrint 490 38)
				(return 0)
			)
			(++ temp0)
		)
		(if (not local160)
			(self setScript: knockCandle)
		else
			(HighPrint 490 39)
		)
		(return 1)
	)
)

(instance dagger of Actor
	(properties
		yStep 8
		view 9
		loop 5
		signal $4000
		xStep 8
	)
)

(instance aFlame of Flame
	(properties
		view 490
		loop 1
		signal $4000
	)
)

(instance iblis of View
	(properties
		x 84
		y 102
		noun '/statue,iblis'
		description {the statue of Iblis}
		lookStr {It's the statue that has held Iblis for a Thousand Years and a Year.}
		view 613
		signal $4000
	)
)

(instance fireUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(avis loop: 0 cel: 0 cycleSpeed: 0 setCycle: Full 1 self)
			)
			(2
				(localproc_000c)
				(avis loop: 4 cel: 0 cycleSpeed: 1 setCycle: Fwd)
				(= cycles 4)
			)
			(3
				(avis loop: 2 cycleSpeed: 1 setCycle: Fwd)
				(switch arcadeDifficultyLevel
					(1 (= local137 290))
					(2 (= local137 240))
					(3 (= local137 220))
				)
				(if (< local0 6)
					(cond 
						((and (!= (ego view?) 285) (== local0 2)) (DjinniSpeaks 490 40))
						((== local0 5) (DjinniSpeaks 490 41))
						((!= (ego view?) 285) (DjinniSpeaks 490 42))
					)
				)
				(= cycles 2)
			)
			(4
				(if (== local0 6)
					(avis setScript: overAndOut)
					(curRoom setScript: 0)
					(self dispose:)
				else
					(self dispose:)
				)
			)
		)
	)
)

(instance dashing of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(= local146 0)
				(curRoom setScript: 0)
				(ego view: 6 setLoop: 2 illegalBits: 0 setPri: 14 cel: 0)
				(= cycles 3)
			)
			(1
				(ego
					cel: (+ (ego cel?) 1)
					x: (+ (ego x?) [local138 local146])
					y: (+ (ego y?) [local142 local146])
				)
				(++ local146)
				(= cycles 1)
			)
			(2
				(if (< local146 5)
					(self changeState: 1)
				else
					(= local146 0)
					(self cue:)
				)
			)
			(3 (ego hide:) (= cycles 1))
			(4
				(HighPrint 490 43 80 {You fell for it!})
				(curRoom newRoom: 790)
			)
		)
	)
)

(instance comeIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setPri: 13 setMotion: MoveTo 305 160 self)
			)
			(1
				(DjinniSpeaks 490 44)
				(= cycles 4)
			)
			(2
				(= local148 1)
				(= local149 50)
				(avis setScript: fireUp)
				(self dispose:)
			)
		)
	)
)

(instance oNoYouDont of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 305 160 self)
			)
			(1
				(DjinniSpeaks 490 45)
				(self dispose:)
			)
		)
	)
)

(instance knockCandle of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local160 1)
				(= local137 0)
				(avis setScript: 0)
				(client posn: (+ (client x?) 4) (client y?))
				(= cycles 2)
			)
			(1
				(if (< local151 6)
					(++ local151)
					(self changeState: 0)
				else
					(curRoom setScript: allOver)
					(avis setScript: avisBattle)
					(self dispose:)
				)
			)
		)
	)
)

(instance wimpThrow of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 9
					loop: 3
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(1
				(proc1_19)
				(ego setPri: 12 loop: 7)
				(dagger
					posn: 279 127
					init:
					setLoop:
					(switch local152
						(4 4)
						(5 5)
						(6 4)
						(7 4)
					)
					setCycle: Fwd
					setMotion: MoveTo 254 119 self
				)
			)
			(2
				(dagger setMotion: MoveTo 225 120 self)
			)
			(3
				(dagger setMotion: MoveTo 192 142 self)
			)
			(4
				(dagger setMotion: MoveTo 169 172 self)
			)
			(5
				(dagger setMotion: MoveTo 164 194 self)
			)
			(6
				(cond 
					((== local152 4) (ego use: 9))
					((== local152 5) (ego use: 5))
					((== local152 6)
						(cond 
							((ego has: 52) (ego use: 52))
							((not (mod (-- global293) 6)) (ego use: 32) (ego get: 35))
						)
					)
					((== local152 7) (ego use: 39))
				)
				(dagger dispose:)
				(HighPrint 490 46)
				(self dispose:)
			)
		)
	)
)

(instance allOver of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(SetControl 1)
		(gDirH addToFront: self)
		(gMouseH addToFront: self)
	)
	
	(method (dispose)
		(gDirH delete: self)
		(gMouseH delete: self)
		(SetInput 0)
		(SetControl 0)
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (super handleEvent: pEvent) (return 1))
		(return
			(switch (pEvent type?)
				(evSAID
					(cond 
						((super handleEvent: pEvent))
						((Said 'throw')
							(if (not local158)
								(DjinniSpeaks 490 47)
								(pEvent claimed: 1)
							else
								(pEvent claimed: 0)
							)
						)
					)
				)
				(evMOUSEBUTTON
					(if (!= (ego script?) dashing)
						(cond 
							(
								(or
									(<
										(= temp0
											(GetAngle (ego x?) (ego y?) (pEvent x?) (pEvent y?))
										)
										45
									)
									(> temp0 315)
								)
								(if (and (not local158) (not local156))
									(DjinniSpeaks 490 48)
									(flash
										posn: (ego x?) (- (ego y?) 24)
										init:
										setPri: (+ (ego priority?) 1)
										setCycle: End
									)
									(ego setScript: dashing)
									(avis setScript: 0)
									(self dispose:)
								)
							)
							((and (< 135 temp0) (< temp0 225)) (if (not (ego script?)) (ego setScript: duckDown)))
							((and (< 225 temp0) (< temp0 315))
								(if (and (not (ego script?)) (not local158))
									(ego setScript: fromPillar)
								)
							)
							(
								(and
									(< 45 temp0)
									(< temp0 135)
									(not (ego script?))
									(not local158)
								)
								(ego setScript: toPillar)
							)
						)
					)
				)
				(evJOYSTICK
					(pEvent claimed: 1)
					(switch (pEvent message?)
						(JOY_UP
							(if (and (not local158) (not local156))
								(DjinniSpeaks 490 48)
								(flash
									posn: (ego x?) (- (ego y?) 24)
									init:
									setPri: (+ (ego priority?) 1)
									setCycle: End
								)
								(ego setScript: dashing)
								(avis setScript: 0)
								(self dispose:)
							)
						)
						(JOY_DOWN
							(if (not (ego script?)) (ego setScript: duckDown))
						)
						(JOY_LEFT
							(if (and (not (ego script?)) (not local158))
								(ego setScript: fromPillar)
							)
						)
						(JOY_DOWNLEFT
							(if (and (not (ego script?)) (not local158))
								(ego setScript: fromPillar)
							)
						)
						(JOY_RIGHT
							(if (and (not (ego script?)) (not local158))
								(ego setScript: toPillar)
							)
						)
						(JOY_UPRIGHT
							(if (and (not (ego script?)) (not local158))
								(ego setScript: toPillar)
							)
						)
					)
				)
			)
		)
	)
)

(instance myHigh of TopWindow
	(properties)
)

(instance avisBattle of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(myHigh color: 13 back: 0)
				(Print 490 49 #title {Ad Avis:} #window myHigh)
				(= local0 0)
				(while (< local0 6)
					([newACandle local0] signal: -32735)
					(DrawFeature [newACandle local0])
					(++ local0)
				)
				(= local0 0)
				(while (< local0 6)
					([newACandle local0] dispose:)
					(++ local0)
				)
				(= cycles 2)
			)
			(1
				(avis
					view: 555
					loop: 1
					cel: 0
					posn: (+ (avis x?) 13) (- (avis y?) 2)
					setCycle: End self
				)
			)
			(2
				(avis loop: 3)
				(aHead posn: (avis x?) (avis y?) init: setCycle: End)
				(HighPrint 490 50 80 {Ad Avis:} 35 myHigh)
				(= cycles 2)
			)
			(3
				(DjinniSpeaks 490 51)
				(switch arcadeDifficultyLevel
					(1 (= seconds 5))
					(2 (= seconds 3))
					(3 (= seconds 2))
				)
			)
			(4 (avis setCycle: End self))
			(5
				(bProjectile
					type: 25
					xStart: (- (avis x?) 20)
					yStart: (- (avis y?) 36)
					x: (if local156 (- (ego x?) 20) else (ego x?))
					y: (- (ego y?) 35)
				)
				(self setScript: bProjectile self)
			)
			(6
				(avis setCycle: Beg)
				(if (not local156)
					(ego setScript: dashing)
					(avis setScript: 0)
				else
					(self cue:)
				)
			)
			(7
				(DjinniSpeaks 490 52)
				(= cycles 2)
			)
			(8
				(avis setScript: scurry)
				(self dispose:)
			)
		)
	)
)

(instance scurry of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(avis cel: 2 setCycle: Beg self)
			)
			(2
				(DjinniSpeaks 490 53)
				(switch arcadeDifficultyLevel
					(1 (= seconds 5))
					(2 (= seconds 3))
					(3 (= seconds 2))
				)
			)
			(3 (avis setCycle: End self))
			(4
				(bProjectile
					type: 25
					xStart: (- (avis x?) 20)
					yStart: (- (avis y?) 36)
					x: (if local156 (- (ego x?) 20) else (ego x?))
					y: (- (ego y?) 35)
				)
				(self setScript: bProjectile self)
			)
			(5
				(avis setCycle: Beg)
				(if (not local156) (ego setScript: dashing))
				(localproc_0232)
				(self dispose:)
			)
		)
	)
)

(instance nowWhat of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(AddToScore 716 3 2)
				(= cycles 2)
			)
			(1
				(DjinniSpeaks 490 54)
				(= local149 50)
				(= local150 3)
				(= cycles 2)
			)
			(2
				(ego
					view: 491
					loop: 2
					cel: 0
					posn: 39 128
					signal: 16384
					cycleSpeed: 2
					setMotion: 0
					setPri: 11
					setCycle: End self
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance thrower of ProjClient
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not local160) (avis setScript: 0))
				(ego loop: 3 cel: 0)
				(cond 
					((== local152 4) (= type 4))
					((== local152 5) (= type 5))
					((or (== local152 7) (== local152 6)) (= type 1))
				)
				(self setScript: (AimSpell new:) self type)
			)
			(1 (ego setCycle: End self))
			(2
				(= local154 (+ (ego x?) 12))
				(= local155 (- (ego y?) 37))
				(aProjectile
					type: type
					xStart: local154
					yStart: local155
					x: x
					y: y
				)
				(self setScript: aProjectile self)
				(cond 
					((== local152 4) (ego use: 9))
					((== local152 5) (ego use: 5))
					((== local152 6)
						(cond 
							((ego has: 52) (ego use: 52))
							((not (mod (-- global293) 6)) (ego use: 32) (ego get: 35))
						)
					)
					((== local152 7) (ego use: 39))
				)
			)
			(3 (ego setCycle: Beg self))
			(4 (self dispose:))
		)
	)
)

(instance aProjectile of Projectile
	(properties)
)

(instance bProjectile of Projectile
	(properties)
)

(instance overAndOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(DjinniSpeaks 490 55)
				(cond 
					((== (ego view?) 285) (curRoom setScript: 0) (ego setScript: dashing))
					((< (ego x?) 200)
						(ego
							loop: 4
							cel: 1
							posn: (- (ego x?) 6) (+ (ego y?) 8)
						)
					)
					(else (ego view: 47 loop: 1 cel: 0 setCycle: End))
				)
				(= cycles 2)
			)
			(1
				(smoke init: setCycle: End self)
				(ShakeScreen 10 2)
				(if (< (ego x?) 200)
					(ego
						loop: 4
						cel: 2
						posn: (+ (ego x?) 19) (+ (ego y?) 13)
					)
				)
			)
			(2
				(smoke loop: 1 cel: 0 cycleSpeed: 3 setCycle: End self)
				(ShakeScreen 3 3)
				(if (< (ego x?) 200)
					(ego
						loop: 4
						cel: 1
						posn: (+ (ego x?) 8) (+ (ego y?) 8)
					)
				)
			)
			(3
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 6)
			)
			(4
				(Print 490 56 #title {Shake, Rattle and Roll!})
				(curRoom newRoom: 790)
			)
		)
	)
)

(instance duckDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(ego view: 47 loop: 0 cel: 0 setCycle: End self)
			)
			(1
				(= local156 1)
				(switch arcadeDifficultyLevel
					(1 (= seconds 7))
					(2 (= seconds 5))
					(3 (= seconds 4))
				)
			)
			(2 (ego setCycle: Beg self))
			(3
				(= local156 0)
				(ego
					view: 491
					loop: (if (not local158) 0 else 3)
					cel: 1
				)
				(LockEgo)
				(self dispose:)
			)
		)
	)
)

(instance shootEm of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HighPrint 490 57 80 {Ad Avis:} 35 myHigh)
				(switch arcadeDifficultyLevel
					(1 (= seconds 5))
					(2 (= seconds 3))
					(3 (= seconds 2))
				)
			)
			(1 (avis setCycle: End self))
			(2
				(bProjectile
					type: 25
					xStart: (- (avis x?) 20)
					yStart: (- (avis y?) 36)
					x: (if local156 (- (ego x?) 20) else (ego x?))
					y: (- (ego y?) 35)
				)
				(self setScript: bProjectile self)
			)
			(3
				(avis setCycle: Beg)
				(if (not local156) (ego setScript: dashing))
				(localproc_0232)
				(self dispose:)
			)
		)
	)
)

(instance avisDead of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(AddToScore 714 20 2)
				(aHead hide:)
				(self setScript: avisBack self)
			)
			(1 (= cycles 1))
			(2 (= cycles 1))
			(3
				(DjinniSpeaks 490 58)
				(= cycles 2)
			)
			(4
				(DjinniSpeaks 490 59)
				(= cycles 2)
			)
			(5
				(ego
					view: 491
					loop: 0
					cel: 1
					posn: (- (ego x?) 7) (+ (ego y?) 2)
				)
				(= cycles 1)
			)
			(6 (ego cel: 0) (= cycles 1))
			(7
				(ego
					view: 0
					loop: 7
					cel: 0
					posn: (- (ego x?) 4) (+ (ego y?) 3)
				)
				(= cycles 1)
			)
			(8
				(ego
					view: 3
					loop: 3
					cel: 3
					setPri: 8
					posn: (- (ego x?) 7) (ego y?)
				)
				(= cycles 1)
			)
			(9
				(ego cel: 4 posn: (ego x?) (+ (ego y?) 4))
				(= cycles 2)
			)
			(10
				(ego posn: (- (ego x?) 2) (+ (ego y?) 2) cel: 5)
				(= cycles 2)
			)
			(11
				(ego view: 0 loop: 3)
				(= cycles 1)
			)
			(12
				(DjinniSpeaks 490 60)
				(= cycles 2)
			)
			(13
				(stayPufft
					loop: 1
					cel: 0
					posn: 117 102
					init:
					setCycle: End self
				)
			)
			(14
				(stayPufft
					setLoop: 3
					cycleSpeed: 1
					xStep: 1
					yStep: 1
					setCycle: Walk
					setMotion: MoveTo 107 99 self
				)
			)
			(15
				(stayPufft cycleSpeed: 1 setCycle: Fwd)
				(= seconds 2)
			)
			(16
				(stayPufft setLoop: 6 cel: 0 setCycle: End self)
				(iblis dispose:)
			)
			(17
				(stayPufft hide:)
				(= seconds 3)
			)
			(18
				(stayPufft show: setCycle: Beg self)
			)
			(19
				(stayPufft
					view: 612
					setLoop: 3
					cycleSpeed: 1
					setCycle: Fwd
				)
				(= seconds 3)
			)
			(20
				(PrintTimedMessage 490 61 35 aWin)
				(= cycles 2)
			)
			(21
				(PrintTimedMessage 490 62 80 {Djinni:} 70 315)
				(= cycles 2)
			)
			(22
				(PrintTimedMessage 490 63 80 {Djinni:} 70 315 35 aWin)
				(= cycles 2)
			)
			(23
				(PrintTimedMessage 490 64 80 {Djinni:} 70 315 35 aWin)
				(= seconds 3)
			)
			(24
				(stayPufft setLoop: 6 cel: 0 setCycle: End self)
			)
			(25
				(stayPufft hide:)
				(= seconds 4)
			)
			(26
				(DjinniSpeaks 490 65)
				(= cycles 2)
			)
			(27 (curRoom newRoom: 820))
		)
	)
)

(instance avisPoked of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(aHead hide:)
				(avis view: 509 loop: 0 cel: 0 setCycle: End self)
			)
			(1
				(avis
					view: 555
					loop: 3
					cel: 0
					posn: (+ (avis x?) 6) (- (avis y?) 2)
				)
				(aHead posn: (avis x?) (avis y?) show:)
				(nife
					posn: (+ (avis x?) 22) (- (avis y?) 42)
					init:
					setLoop: 5
					setCycle: Fwd
					setMotion: MoveTo 216 66 self
				)
			)
			(2
				(nife
					setLoop: 5
					setCycle: Fwd
					setMotion: MoveTo 245 73 self
				)
			)
			(3
				(nife
					setLoop: 5
					setCycle: Fwd
					setMotion: MoveTo 263 99 self
				)
			)
			(4
				(HighPrint 490 66 80 {Ad Avis:} 35 myHigh 25 4 103)
				(nife
					setLoop: 5
					setCycle: Fwd
					setMotion: MoveTo 271 134 self
				)
			)
			(5
				(nife
					setLoop: 5
					setCycle: Fwd
					setMotion: MoveTo 272 190 self
				)
			)
			(6
				(nife dispose:)
				(self dispose:)
			)
		)
	)
)

(instance avisBack of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gCMusic number: 821 playBed:)
				(avis
					view: 509
					loop: 0
					cel: 0
					posn: (+ (avis x?) 3) (- (avis y?) 1)
					setCycle: End self
				)
			)
			(1
				(avis
					loop: 1
					cel: 1
					posn: (+ (avis x?) 4) (- (avis y?) 2)
				)
				(= cycles 3)
			)
			(2
				(avis cel: 2 posn: (+ (avis x?) 5) (avis y?))
				(= cycles 3)
			)
			(3
				(avis cel: 3 posn: (+ (avis x?) 12) (+ (avis y?) 1))
				(= cycles 2)
			)
			(4
				(avis
					cel: 4
					setPri: 6
					posn: (+ (avis x?) 15) (+ (avis y?) 12)
				)
				(= cycles 2)
			)
			(5
				(avis cel: 5 posn: (+ (avis x?) 12) (+ (avis y?) 16))
				(= cycles 1)
			)
			(6
				(avis cel: 6 posn: (+ (avis x?) 3) (+ (avis y?) 20))
				(= cycles 1)
			)
			(7
				(avis
					setCycle: Fwd
					setLoop: 1
					yStep: 10
					setMotion: MoveTo (avis x?) 230 self
				)
			)
			(8
				(avis hide:)
				(self dispose:)
			)
		)
	)
)

(instance aWin of SysWindow
	(properties
		back 13
	)
)

(instance spellCode of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (OneOf param1 1 5 6)
				(return 1)
			else
				(HighPrint 490 67)
				(return 0)
			)
		)
	)
)
