;;; Sierra Script 1.0 - (do not remove this comment)
(script# 530)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use StairScript)
(use TopWindow)
(use Flame)
(use n095)
(use Intrface)
(use Feature)
(use LoadMany)
(use Timer)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm530 0
)

(local
	local0
	local1
)
(procedure (localproc_0040)
	(nawarWindow color: 12 back: 1)
	(HighPrint &rest 35 nawarWindow 80 {Nawar:})
)

(procedure (localproc_0063 param1 param2 param3 param4)
	(param1 claimed: 1)
	(if (== (param1 type?) 64)
		(OneOf (param1 message?) param2 param3 param4)
	)
)

(procedure (localproc_0090 param1)
	(switch (++ local0)
		(1
			(if param1
				(DjinniSpeaks 530 0)
			else
				(DjinniSpeaks 530 1)
			)
		)
		(2
			(if param1
				(DjinniSpeaks 530 2)
			else
				(DjinniSpeaks 530 3)
			)
		)
		(3 (ego setScript: egoCaughtS))
	)
)

(instance nawarWindow of TopWindow
	(properties)
)

(instance rm530 of Rm
	(properties
		picture 530
		style $0006
	)
	
	(method (init)
		(LoadMany 128 0 4 26 2 47 530 532 531 3)
		(Load rsPIC 2)
		(flame1 init:)
		(flame2 init:)
		(flame3 init:)
		(poolWater init: setCycle: Fwd)
		(fountainWater init: setCycle: Fwd)
		(eunuchGuard init: setCycle: Walk)
		(eunuch init:)
		(bigEhi init:)
		(super init:)
		(sky init:)
		(DrawFeature
			plant
			carpet
			table
			fish
			pots
			wine
			pillows
			sconce1
			sconce2
			sconce3
			vase
			bigElow
		)
		(gCMusic number: 530 loop: -1 playBed:)
		(ego illegalBits: 0 posn: 272 133 loop: 2 init:)
		(proc1_19)
		(ego setScript: sneakThruS)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			((== (ego script?) egoCaughtS))
			(
				(and
					(< 5 (eunuchGuard x?))
					(< (eunuchGuard x?) 100)
					(not (eunuchGuard loop?))
					(== (ego x?) 225)
				)
				(ego setScript: egoCaughtS)
			)
		)
	)
	
	(method (dispose)
		(gCMusic fade:)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(super dispose: &rest)
	)
)

(instance sneakThruS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: comeInS self)
			)
			(1
				(= local0 0)
				(self setScript: hajibToDoorS self)
			)
			(2
				(= local0 0)
				(self setScript: crawlToTableS self)
			)
			(3
				(= local0 0)
				(self setScript: sneakToDoorS self)
			)
			(4
				(ego setScript: upStepsS)
				(self dispose:)
			)
		)
	)
)

(instance comeInS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(startingTimer set: startingTimer 8)
				(= cycles 5)
			)
			(1
				(localproc_0040 530 4)
				(SetControl 0)
			)
			(2
				(SetControl 1)
				(ChangeEgoWalk 2 0)
				(ego setMotion: MoveTo 259 172 self)
			)
			(3 (self dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((localproc_0063 pEvent 6 5 4) (self cue:))
			((!= (pEvent type?) evJOYSTICK))
			(else (localproc_0090 0))
		)
	)
)

(instance hajibToDoorS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_0040 530 5)
				(ego setMotion: MoveTo 225 181)
				(eunuch
					setLoop: 4
					setCel: 0
					cycleSpeed: 3
					setCycle: End self
				)
				(eunuchGuard setMotion: MoveTo -10 95)
			)
			(1
				(eunuch
					setLoop: 5
					setCel: 0
					cycleSpeed: 0
					posn: (- (eunuch x?) 3) (eunuch y?)
					setCycle: End self
				)
			)
			(2
				(ego view: 47 setLoop: 1 setCel: 0 setCycle: End)
				(eunuch
					view: 532
					setLoop: 0
					setCel: 0
					setPri: 7
					posn: 166 140
					setCycle: Walk
					setMotion: MoveTo 276 138 self
				)
			)
			(3
				(HighPrint 530 6 80 {Hajib:})
				(self dispose:)
			)
		)
	)
)

(instance crawlToTableS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(delayTimer set: delayTimer 10)
				(SetControl 0)
			)
			(1
				(SetControl 1)
				(ego
					view: 26
					posn: (- (ego x?) 12) (+ (ego y?) 6)
					setLoop: 0
					setCel: 0
					setCycle: Walk
					setMotion: MoveTo 110 155 self
				)
				(delayTimer dispose:)
				(returnTimer setCycle: returnTimer 55)
			)
			(2 (self dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((localproc_0063 pEvent 7 8 1)
				(if
					(and
						(<= 65 (eunuchGuard x?))
						(<= (eunuchGuard x?) 255)
					)
					(localproc_0090 1)
				else
					(self cue:)
				)
			)
			((!= (pEvent type?) evJOYSTICK))
			(else (localproc_0090 0))
		)
	)
)

(instance sneakToDoorS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(delayTimer set: delayTimer 14)
				(SetControl 0)
			)
			(1
				(SetControl 1)
				(ego view: 47 setLoop: 1 setCel: 3 setCycle: Beg self)
				(delayTimer dispose:)
			)
			(2
				(= egoWalkMode 2)
				(proc1_19)
				(ego illegalBits: 0 setMotion: MoveTo 58 142 self)
			)
			(3
				(ego setMotion: MoveTo 72 88 self)
			)
			(4 (self dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((localproc_0063 pEvent 7 8 1)
				(if
					(and
						(<= 160 (eunuchGuard x?))
						(<= (eunuchGuard x?) 255)
					)
					(self cue:)
				else
					(localproc_0090 1)
				)
			)
			((!= (pEvent type?) evJOYSTICK))
			(else (localproc_0090 0))
		)
	)
)

(instance egoCaughtS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(yawnTimer dispose:)
				(bigEhi setLoop: 2 cel: 0 setCycle: End self)
			)
			(1
				(HighPrint 530 7 80 {Eunuch:})
				(= cycles 1)
			)
			(2
				(eunuch setHeading: 270 self)
			)
			(3
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 5)
			)
			(4
				(Print 530 8 #mode 1 #title {You call that sneaking?})
				(= cycles 3)
			)
			(5
				(Print
					530
					9
					#title
					{It's all over but the crying!}
					#mode
					1
				)
				(= cycles 3)
			)
			(6 (curRoom newRoom: 790))
		)
	)
)

(instance upStepsS of StairScript
	(properties
		stairSize 9
		numStairs 2
	)
	
	(method (init)
		(= goingUp 1)
		(super init: &rest)
	)
	
	(method (dispose)
		(curRoom newRoom: 490)
		(super dispose:)
	)
)

(instance sky of Feature
	(properties
		x 78
		y 24
		noun '/sky,star'
		nsTop 14
		nsLeft 56
		nsBottom 34
		nsRight 101
		description {the dark black sky}
		lookStr {The inky black skies of Raseir are ablaze with stars.}
	)
)

(instance yawnTimer of Timer
	(properties)
	
	(method (cue)
		(if (bigEhi cel?)
			(bigEhi setCel: 0)
		else
			(bigEhi setCel: 1)
		)
		(proc1_32 self 10 20)
	)
)

(instance returnTimer of Timer
	(properties)
	
	(method (cue)
		(if (< (eunuchGuard x?) 0)
			(eunuchGuard setMotion: MoveTo 255 95)
		else
			(ego setScript: egoCaughtS)
		)
	)
)

(instance startingTimer of Timer
	(properties)
	
	(method (cue)
		(if (== (ego y?) 133) (ego setScript: egoCaughtS))
	)
)

(instance delayTimer of Timer
	(properties)
	
	(method (cue)
		(if (!= (ego script?) egoCaughtS)
			(if (> (eunuchGuard x?) 180)
				(DjinniSpeaks 530 10)
			else
				(DjinniSpeaks 530 11)
			)
			(returnTimer set: returnTimer 20)
		)
	)
)

(instance eunuch of Actor
	(properties
		x 166
		y 137
		noun '/hajib,man,eunuch'
		description {Hajib}
		lookStr {The eunuch looks like a formidable foe.}
		view 531
		loop 3
		illegalBits $0000
	)
)

(instance eunuchGuard of Actor
	(properties
		x 304
		y 95
		noun '/abu,man,eunuch'
		description {the eunuch guard}
		lookStr {The eunuch guard, Abu, paces back and forth.}
		view 532
		signal $4000
		illegalBits $0000
	)
)

(instance bigEhi of Prop
	(properties
		y 148
		noun '/eunuch,man'
		description {the sleeping eunuch}
		lookStr {The eunuch seems to be sleeping soundly.}
		view 531
		priority 15
		signal $4010
	)
	
	(method (init)
		(proc1_32 yawnTimer 10 20)
		(super init: &rest)
	)
)

(instance fountainWater of Prop
	(properties
		x 213
		y 123
		noun '/fount,spray,water,spout'
		description {the fountain water}
		lookStr {The sound of the water is almost hypnotic.}
		view 530
		loop 7
		signal $4000
	)
)

(instance poolWater of Prop
	(properties
		x 228
		y 134
		noun '/fount,oasis,water,base'
		description {the fountain water}
		lookStr {The water at the base of the fountain looks cool and refreshing.}
		view 530
		loop 8
		priority 12
		signal $4010
		cycleSpeed 2
	)
)

(instance flame1 of Flame
	(properties
		x 29
		y 42
		noun '/lamp,fire,flame,torch'
		description {the torch}
		lookStr {The torch flickers calmly.}
		view 530
		loop 10
		signal $6000
	)
)

(instance flame2 of Flame
	(properties
		x 166
		y 42
		noun '/lamp,fire,flame,torch'
		description {the torch}
		lookStr {The torch flickers calmly.}
		view 530
		loop 10
		signal $6000
	)
)

(instance flame3 of Flame
	(properties
		x 218
		y 42
		noun '/lamp,fire,flame,torch'
		description {the torch}
		lookStr {The torch flickers calmly.}
		view 530
		loop 10
		signal $6000
	)
)

(instance plant of PicView
	(properties
		x 123
		y 88
		noun '/tree,bush,plant'
		description {the Raseirian Rubber Plant}
		lookStr {The Raserian Rubber Plant gets good light and air at the door.}
		view 530
		priority 1
		signal $6010
	)
)

(instance carpet of PicView
	(properties
		x 60
		y 105
		noun '/carpet,carpet'
		description {the woven carpet}
		lookStr {The carpet is finely woven of the best Shapeirian wool.}
		view 530
		loop 1
		priority 1
		signal $4010
	)
)

(instance table of PicView
	(properties
		x 110
		y 135
		noun '/table'
		description {the table}
		lookStr {The table is made of hand rubbed Iblia wood from the hills of the Forbidden City of Iblis.}
		view 530
		loop 2
		priority 9
		signal $0010
	)
)

(instance fish of PicView
	(properties
		x 220
		y 173
		noun '/carp,statue,fount'
		description {the fountain}
		lookStr {The world famous Spitting Fish is the pride of Raseir.}
		view 530
		loop 3
		priority 12
		signal $4010
	)
)

(instance pots of PicView
	(properties
		x 281
		y 189
		noun '/pan,urn,bottle'
		description {the clay pots}
		lookStr {The large earthen pots probably contain water.}
		view 530
		loop 4
		priority 15
		signal $0010
	)
)

(instance wine of PicView
	(properties
		x 131
		y 119
		noun '/wine,pitcher,drink'
		description {the eunuchs' wine}
		lookStr {It's a fine port, a favorite of the eunuchs, no doubt.}
		view 530
		loop 5
		priority 10
		signal $0010
	)
)

(instance pillows of PicView
	(properties
		x 130
		y 148
		noun '/cushion'
		description {the pillows}
		lookStr {The big, fat pillows are for big, fat eunuchs.}
		view 530
		loop 6
		priority 9
		signal $0010
	)
)

(instance sconce1 of PicView
	(properties
		x 29
		y 43
		noun '/sconce'
		description {the torch sconce}
		lookStr {The sconce holds the torch.}
		view 530
		loop 9
		priority 1
		signal $0010
	)
)

(instance sconce2 of PicView
	(properties
		x 166
		y 43
		noun '/sconce'
		description {the sconce}
		lookStr {The sconce holds the torch.}
		view 530
		loop 9
		priority 1
		signal $0010
	)
)

(instance sconce3 of PicView
	(properties
		x 218
		y 43
		noun '/sconce'
		description {the sconce}
		lookStr {The sconce holds the torch.}
		view 530
		loop 9
		priority 1
		signal $0010
	)
)

(instance vase of PicView
	(properties
		x 306
		y 65
		noun '/bouquet,vase'
		description {the flowers}
		lookStr {A "Friendship Bouquet" brightens any day.}
		view 530
		loop 11
		priority 15
		signal $0010
	)
)

(instance bigElow of PicView
	(properties
		x 31
		y 189
		noun '/eunuch,man'
		description {the sleeping eunuch}
		lookStr {The eunuch seems to be sleeping soundly.}
		view 531
		loop 1
		priority 15
		signal $4010
	)
)
