;;; Sierra Script 1.0 - (do not remove this comment)
(script# 550)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use Talker)
(use TargActor)
(use Full)
(use Feature)
(use LoadMany)
(use StopWalk)
(use Music)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm550 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
)
(procedure (localproc_000c)
	(localproc_004b 4)
	(adAvis view: 555 setLoop: 2 setCel: 2)
)

(procedure (localproc_0029)
	(localproc_004b 0)
	(adAvis view: 555 setLoop: 0 setCel: -1 cel: 8)
)

(procedure (localproc_004b param1 &tmp temp0)
	(if (= temp0 param1)
		(adAvisHead
			view: 555
			setLoop: temp0
			setPri: (+ (adAvis priority?) 4)
			setCycle: 0
			cel: 0
			show:
		)
	else
		(adAvisHead hide:)
	)
)

(instance rm550 of Rm
	(properties
		picture 550
		style $0010
	)
	
	(method (init)
		(LoadMany 128 550 555 495 552 556 4 0)
		(LoadMany 132 550 551 12 15)
		(= currentDay 29)
		(SetGameTime 21 0)
		(= defaultPalette 1)
		(proc1_19)
		(super init:)
		(UnlockEgo)
		(adAvis init:)
		(adAvisHead init: setPri: (+ (adAvis priority?) 2))
		(localproc_000c)
		(door init: stopUpd:)
		(ego view: 4 posn: 72 185 init:)
		(proc1_31 turret entrance stoneWall)
		(DrawFeature moon)
		(gCMusic number: 550 loop: -1 playBed:)
		(self setScript: cartoon1)
	)
	
	(method (doit &tmp temp0 [temp1 21])
		(if (!= local5 (= temp0 (GetTime 1)))
			(= local5 temp0)
			(= local6 1)
			(if (> local2 1) (-- local2))
		)
		(cond 
			(script (script doit:))
			((== local2 1)
				(= local2 0)
				(cond 
					((not local3) (self setScript: noNoticeDoor) (= local3 1))
					((not local0) (= local0 1) (self setScript: adAvisAngry))
					(else (self setScript: adAvisAngry))
				)
			)
		)
		(= local6 0)
	)
	
	(method (handleEvent pEvent &tmp [temp0 21])
		(super handleEvent: pEvent)
		(if (or script (pEvent claimed?)) (return))
		(switch (pEvent type?)
			(evSAID
				(cond 
					((Said 'use/mirror')
						(if (ego has: 46)
							(self setScript: useTheMirror)
						else
							(HighPrint 550 0)
						)
					)
					((Said 'cast/open,open,detect') (pEvent claimed: 0))
					(
						(Said
							'attack,cast,throw/flame,dart,dagger,boulder,dazzle'
						)
						(HighPrint 550 1)
					)
					(
						(or
							(Said 'search,look,examine[<at,around][/room,area][/!*]')
							(Said 'look,examine/city,ruin,remain,grave')
						)
						(HighPrint 550 2)
					)
					(
						(or
							(Said 'look,examine/sand,ground,boulder')
							(Said 'look,examine<down')
						)
						(HighPrint 550 3)
					)
					(
						(or
							(Said 'look,examine/sky,star,constellation')
							(Said 'look,examine<up')
						)
						(HighPrint 550 4)
					)
				)
			)
		)
	)
)

(instance adAvisHead of Prop
	(properties
		x 21
		y 155
		z 39
		description {Ad Avis}
		view 555
		loop 4
		signal $4000
	)
)

(instance adAvis of Talker
	(properties
		x 21
		y 155
		noun '/ad,man,wizard'
		description {Ad Avis}
		lookStr {He seems like such a nice man.__You would really like to be able to help him.}
		view 555
		signal $4000
		illegalBits $0000
		tLoop -1
		title {Ad Avis:}
		color 13
		back 0
	)
	
	(method (handleEvent pEvent)
		(return
			(cond 
				((Said 'ask,tell//mirror')
					(Say adAvis askAboutMirror 550 5)
					(curRoom setScript: askAboutMirror)
				)
				((Said 'ask,tell//door,star,constellation')
					(if local3
						(Say adAvis 550 6)
					else
						(= local2 0)
						(Say adAvis 550 7)
						(++ local3)
						(= local2 40)
					)
				)
				((Said 'ask,tell//*')
					(switch (++ local4)
						(1 (Say adAvis 550 8))
						(2 (Say adAvis 550 9))
						(3 (Say adAvis 550 10))
						(4 (Say adAvis 550 11))
						(5
							(curRoom setScript: egoToSaurus)
						)
					)
				)
				((super handleEvent: pEvent) 1)
			)
		)
	)
	
	(method (messages)
		(super messages: &rest)
		(adAvisHead setCycle: Fwd cycleSpeed: 2)
	)
	
	(method (endTalk)
		(adAvisHead setCycle: 0 cel: 0)
		(super endTalk: &rest)
	)
)

(instance ballOfFlame of Actor
	(properties
		z 30
		view 555
		loop 7
	)
)

(instance reflection of Actor
	(properties
		x 104
		y 47
		view 550
		loop 6
		priority 15
		signal $6810
		illegalBits $0000
	)
)

(instance door of TargActor
	(properties
		x 159
		y 119
		description {the doorway to the ancient city}
		yStep 7
		view 550
		cel 2
		priority 1
		signal $5810
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (< y 119)
				(HighPrint 550 12)
			else
				(HighPrint 550 13)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (detectMe)
		(HighPrint 550 15)
		(return 1)
	)
	
	(method (openMe)
		(HighPrint 550 14)
		(return 0)
	)
)

(instance cartoon1 of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 0 setMotion: MoveTo 72 185 init:)
				(if reversalTimer (= reversalTimer 3))
				(adAvis setScript: castOpen self 1)
			)
			(1
				(Say adAvis 550 16)
				(ego setScript: baseToDoor self)
			)
			(2 (= seconds 2))
			(3 (Say adAvis self 550 17))
			(4
				(HighPrint 550 18)
				(ego setScript: doorToBase)
			)
			(5
				(localproc_004b 6)
				(Say adAvis self 550 19)
			)
			(6
				(adAvis setScript: castOpen self 2)
			)
			(7
				(localproc_004b 4)
				(= cycles 1)
			)
			(8
				(localproc_004b 6)
				(Say adAvis self 550 20)
			)
			(9
				(Say adAvis self 550 21 550 22 550 23 550 24)
			)
			(10
				(localproc_004b 4)
				(Say adAvis self 550 25)
			)
			(11
				(localproc_004b 6)
				(= cycles 1)
			)
			(12
				(localproc_004b 5)
				(Say adAvis self 550 26)
			)
			(13
				(localproc_004b 4)
				(Say adAvis 550 27)
				(= cycles 1)
			)
			(14
				(adAvis setScript: castOpen self 2)
			)
			(15
				(Say adAvis self 550 28 550 29)
			)
			(16
				(SetInput 0)
				(= local2 25)
				(self dispose:)
			)
		)
	)
)

(instance slideDoor of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(self doit:)
		(doorSound number: 551 loop: 1 init: play:)
	)
	
	(method (doit)
		(super doit: &rest)
		(if
		(not (if (>= (door x?) 180) (>= (door y?) 168)))
			(door posn: (+ (door x?) 3) (+ (door y?) 7))
		else
			(self dispose:)
		)
	)
)

(instance castOpen of Script
	(properties)
	
	(method (dispose)
		(= register 0)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: turnToDoor self)
			)
			(1
				(adAvis setLoop: 3 setCel: 0 setCycle: Full 1 self)
			)
			(2
				(xSound number: 12 loop: 1 init: play:)
				(door setLoop: register setCycle: Full)
				(adAvis setLoop: 5 setCel: 0 setCycle: Full 2 self)
			)
			(3
				(door setCel: 255)
				(self setScript: turnToEgo self)
			)
			(4
				(door stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance baseToDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					ignoreControl: -1
					view: 0
					setLoop: -1
					setCycle: SyncWalk
					setMotion: MoveTo 72 173 self
				)
			)
			(1
				(ego setMotion: MoveTo 79 130 self)
			)
			(2
				(ego setMotion: MoveTo 165 133 self)
			)
			(3
				(ego setMotion: MoveTo 165 129 self)
			)
			(4
				(if local1
					(self dispose:)
				else
					(ego setLoop: setMotion: MoveTo 163 126 self)
				)
			)
			(5
				(ego setMotion: MoveTo 165 129 self)
			)
			(6
				(ego setLoop: setMotion: MoveTo 163 126 self)
			)
			(7
				(ego setMotion: MoveTo 165 129 self)
			)
			(8
				(ego setLoop: -1)
				(self dispose:)
			)
		)
	)
)

(instance doorToBase of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					ignoreControl: -1
					view: 0
					setLoop: -1
					setCycle: SyncWalk
					setMotion: MoveTo 79 131 self
				)
			)
			(1
				(ego setMotion: MoveTo 75 167 self)
			)
			(2
				(curRoom cue:)
				(ego setMotion: MoveTo 227 184 self)
			)
			(3
				(ego setLoop: -1 setMotion: MoveTo 225 181 self)
			)
			(4
				(ego setCycle: StopWalk 4)
				(= cycles 1)
			)
			(5 (self dispose:))
		)
	)
)

(instance egoToSaurus of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_000c)
				(localproc_004b 6)
				(adAvis view: 555 setLoop: 2 cel: 1)
				(Say adAvis self 550 30)
			)
			(1
				(localproc_004b 4)
				(adAvis setCel: -1 cel: 0 setCycle: End self)
			)
			(2
				(ego view: 556 cel: 0 cycleSpeed: 2 setCycle: CT 2 1)
				(tSound number: 15 loop: 1 init: play:)
				(ballOfFlame
					ignoreActors:
					ignoreControl: -1
					setLoop: 7
					setPri: (- (ego priority?) 1)
					setStep: 20 20
					setCycle: Fwd
					posn: (adAvis x?) (adAvis y?)
					setMotion: MoveTo (ego x?) (ego y?) self
					init:
				)
			)
			(3
				(ballOfFlame dispose:)
				(ego setCycle: End self)
			)
			(4
				(Die 0 550 31 82 (ego view?) (ego loop?) (ego cel?))
				(self dispose:)
			)
		)
	)
)

(instance useTheMirror of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HighPrint 550 32)
				(ego
					view: 552
					setLoop: 0
					setCel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1
				(turnToDoor start: 2)
				(adAvis setScript: turnToDoor self 1)
			)
			(2
				(reflection init: setMotion: MoveTo 144 96 self)
			)
			(3
				(door setLoop: 3 setCel: 0)
				(reflection setMotion: MoveTo 152 104 self)
			)
			(4
				(door setCel: 1)
				(reflection setMotion: MoveTo 161 112 self)
			)
			(5
				(door setCel: 2)
				(= cycles 5)
			)
			(6
				(reflection hide:)
				(door setLoop: 5 setCycle: Full 5 self)
				(ego setCycle: Beg)
			)
			(7
				(reflection
					posn: 159 99
					setLoop: 4
					setCel: 0
					show:
					setCycle: End self
				)
			)
			(8
				(reflection dispose:)
				(door
					setCel: 2
					moveSpeed: 3
					setPri:
					setScript: slideDoor self
				)
			)
			(9
				(door dispose:)
				(adAvis setScript: turnToEgo self)
				(AddToScore 632 5)
			)
			(10
				(adAvis setLoop: 2 setCel: 1)
				(localproc_004b 6)
				(Say adAvis self 550 33)
			)
			(11
				(adAvis setLoop: 2 setCel: 2)
				(localproc_004b 4)
				(Say adAvis self 550 34)
			)
			(12
				(= local1 1)
				(proc1_19)
				(UnlockEgo)
				(ego setScript: baseToDoor self)
				(turnToDoor start: 2)
				(adAvis setScript: turnToDoor self 1)
				(= local2 0)
			)
			(13 0)
			(14
				(curRoom newRoom: 580)
				(= defaultPalette 0)
				(self dispose:)
			)
		)
	)
)

(instance turnToEgo of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(adAvis
					view: 555
					posn: 21 155
					setLoop: 0
					setCel: 0
					setCycle: End self
				)
			)
			(1
				(localproc_000c)
				(= cycles 1)
			)
			(2 (self dispose:))
		)
	)
)

(instance turnToDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_0029)
				(adAvis setLoop: 0 setCel: 8 setCycle: Beg self)
			)
			(1
				(adAvis view: 495 posn: 32 158 setLoop: 1 setCel: 0)
				(self dispose:)
			)
			(2
				(localproc_0029)
				(adAvis setLoop: 0 setCel: 255 setCycle: CT 1 -1 self)
			)
			(3
				(self start: 0)
				(self dispose:)
			)
		)
	)
)

(instance noNoticeDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 1)
				(Say adAvis self 550 35)
			)
			(1 (= seconds 3))
			(2
				(HighPrint 550 36)
				(= cycles 1)
			)
			(3
				(adAvis setScript: turnToDoor self)
			)
			(4
				(adAvis view: 495 setLoop: 3 setCycle: Fwd)
				(Say adAvis self 550 37)
			)
			(5 (Say adAvis self 550 38))
			(6
				(adAvis
					view: 555
					setLoop: 0
					cel: 1
					setCycle: 0
					setScript: turnToEgo self
				)
			)
			(7 (Say adAvis self 550 39))
			(8
				(HighPrint 550 40)
				(SetInput 0)
				(= local2 40)
				(self dispose:)
			)
		)
	)
)

(instance adAvisAngry of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 1)
				(if local0
					(Say adAvis self 550 41)
				else
					(Say adAvis self 550 42)
				)
			)
			(1
				(SetInput 0)
				(if local0 (curRoom setScript: egoToSaurus))
				(self dispose:)
			)
		)
	)
)

(instance askAboutMirror of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 0)
			(1
				(if (ego has: 46)
					(self setScript: useTheMirror self)
				else
					(self dispose:)
				)
			)
			(2 (self dispose:))
		)
	)
)

(instance turret of Feature
	(properties
		x 264
		y 131
		noun '/minaret'
		nsTop 111
		nsLeft 242
		nsBottom 152
		nsRight 287
		description {the fallen tower}
		lookStr {This fallen tower once stood guard over the ancient city.}
	)
)

(instance moon of PicView
	(properties
		x 30
		y 30
		noun '/moon'
		description {the pale moon}
		lookStr {The pale moon provides the only illumination for this eerie tableau.}
		view 552
		loop 1
	)
)

(instance xSound of Sound
	(properties
		vol 50
		priority 5
	)
)

(instance tSound of Sound
	(properties
		vol 80
		priority 5
	)
)

(instance doorSound of Sound
	(properties
		priority 5
	)
)

(instance stoneWall of Feature
	(properties
		x 205
		y 52
		noun '/wall,cliff'
		nsLeft 93
		nsBottom 104
		nsRight 318
		description {the remains of the ancient city}
		lookStr {The ancient city, long before it was sealed, bustled with intelligence and magic under these granite cliffs.}
	)
)

(instance entrance of Feature
	(properties
		x 146
		y 77
		noun '/entrance,door'
		nsTop 34
		nsLeft 100
		nsBottom 120
		nsRight 193
		description {the entrance to the Forbidden City}
		lookStr {Jutting from the ground like the prow of an ancient shipwreck is the entrance to the Forbidden City.}
	)
)
