;;; Sierra Script 1.0 - (do not remove this comment)
(script# 580)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use ProjClient)
(use n065)
(use TargActor)
(use Intrface)
(use LoadMany)
(use Timer)
(use Music)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm580 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
)
(procedure (localproc_000c)
	(highBlackWindow color: 9 back: 0)
	(Print &rest #window highBlackWindow)
)

(procedure (localproc_0028)
	(localproc_000c 580 0)
	(return
		(if
			(Print
				{Might as well die now.__Just to save yourself a little frustration.}
				#title
				{Your Choice of Poison}
				#button
				{OK.__Kill me now}
				1
				#button
				{Later (but not much)}
				0
			)
			(Die
				1
				{Perhaps there's a reason why people are scared of the dark.}
				80
				{Whaddaya think?}
			)
		else
			(return 0)
		)
	)
)

(instance rm580 of Rm
	(properties
		picture 580
		east 570
	)
	
	(method (init)
		(Bset 101)
		(LoadMany 129 580 570 2)
		(LoadMany 132 600 580)
		(LoadMany 128 585 586 580 591 591)
		(if (!= prevRoomNum 550) (LoadMany 128 6 62))
		(= gGDftSC gAllSC)
		(proc1_19)
		(gCMusic number: 600 priority: 0 loop: -1 playBed:)
		(if (= local0 (not (Btst 107)))
			(roomSound init: play:)
		)
		(kludge init: hide:)
		(redDr
			init:
			setScript: (if (== prevRoomNum 560) 0 else glowDrS)
		)
		(blueDr init:)
		(stag1 init: stopUpd:)
		(stag2 init: stopUpd:)
		(stag3 init: stopUpd:)
		(stag4 init: stopUpd:)
		(self
			style:
			(switch prevRoomNum
				(570 41)
				(560 6)
				(550 15)
				(else  15)
			)
		)
		(= defaultPalette 0)
		(super init:)
		(floorShine init: hide:)
		(wallShine init: hide:)
		(self
			setScript:
				(switch prevRoomNum
					(570 fromWaterRm)
					(560 fromFireRm)
					(else  fromEntrance)
				)
		)
		(gCMusic number: 600 loop: -1 playBed:)
		(gMiscMusic number: 580 loop: 1 play:)
	)
	
	(method (doit &tmp temp0)
		(cond 
			((== (= temp0 (ego onControl: 1)) local1))
			((and (< (ego x?) 1) (not script)) (= mouseY (ego y?)) (curRoom newRoom: 570))
			(
			(and (& temp0 $0004) (== (ego illegalBits?) -32768)) (self setScript: toFireRm))
			((and (& temp0 $0008) (not local4))
				(= local4 1)
				(wallShine hide:)
				(self setScript: fallOffLedge)
			)
			((and (& temp0 $0010) (!= (ego priority?) 6))
				(ego setPri: 6)
				(if (Btst 116) (wallShine hide:) (floorShine hide:))
			)
			(
			(and (not (& temp0 $0010)) (== (ego priority?) 6))
				(ego setPri: 8)
				(if (Btst 116) (wallShine show:) (floorShine show:))
			)
			((& temp0 $0020) (ego y: 181 setMotion: 0) (localproc_000c 580 1))
			(else (ego setPri: 8))
		)
		(= local1 temp0)
		(super doit:)
	)
	
	(method (dispose)
		(if local0 (roomSound stop: dispose:))
		(= defaultPalette 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'use,light,rub,rub,(turn<on)/lamp,light')
				(cond 
					((not [invNum 33]) (localproc_0028))
					((Btst 116) (localproc_000c 580 2))
					(else
						(Bset 116)
						(ego show:)
						(ChangeEgoWalk 4 0)
						(LockEgo)
						(floorShine show:)
						(wallShine show:)
						(if (< (ego y?) 100)
							(= defaultPalette 2)
						else
							(= defaultPalette 1)
						)
						(curRoom drawPic: 580 7)
						(self setScript: 0)
					)
				)
			)
			(
				(Said
					'put,deposit,extinguish,douse,(turn<off)/lamp,light'
				)
				(if (Btst 116)
					(localproc_000c 580 3)
				else
					(localproc_000c 580 4)
				)
			)
			((and (not (Btst 116)) (Said 'look,examine')) (localproc_000c 580 5))
			((Said 'run,sneak,walk') (localproc_000c 580 6))
			((Said 'listen') (if local0 (HighPrint 580 7) else (HighPrint 580 8)))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/cave,wall,chamber')
					(Said 'look,examine<up,down')
				)
				(localproc_000c 580 9)
			)
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(cond 
					(local0 (localproc_000c 580 10))
					((< (ego y?) 100) (localproc_000c 580 11))
					(else (= global168 150) (pEvent claimed: 0))
				)
			)
			((Said 'cast>')
				(switch (proc65_0 pEvent)
					(28
						(cond 
							(local0 (localproc_000c 580 12) (pEvent claimed: 1))
							((< (ego y?) 100) (localproc_000c 580 13) (pEvent claimed: 1))
							(else (= global166 123) (pEvent claimed: 0))
						)
					)
					(else  (pEvent claimed: 0))
				)
			)
		)
	)
)

(instance toFireRm of HandsOffScript
	(properties)
	
	(method (doit &tmp egoY)
		(= egoY (ego y?))
		(redDr
			setCel:
				(cond 
					((<= egoY 60) 0)
					((<= egoY 62) 1)
					((<= egoY 64) 2)
					((<= egoY 65) 3)
					(else 4)
				)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(redDr setScript: 0)
				(ego illegalBits: 0 setMotion: MoveTo 283 58 self)
			)
			(1
				(= gTopExit 4)
				(curRoom newRoom: 560)
				(self dispose:)
			)
		)
	)
)

(instance toEarthRm of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(blueDr cycleSpeed: 2 setCycle: Beg)
				(ego
					illegalBits: 0
					setMotion: MoveTo (+ (ego x?) 4) (- (ego y?) 4) self
				)
			)
			(1
				(curRoom newRoom: 590)
				(self dispose:)
			)
		)
	)
)

(instance fromWaterRm of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(AddToScore 634 7)
				(wallShine doit: show:)
				(floorShine doit: show:)
				(ego
					loop: 0
					posn: 1 mouseY
					illegalBits: 0
					setPri: 8
					init:
				)
				(if (< (ego y?) 100)
					(self cue:)
				else
					(ego setMotion: MoveTo 14 mouseY self)
				)
			)
			(1
				(proc1_19)
				(if (and local0 (< (ego y?) 90))
					(ego posn: 1 mouseY)
					(ego setScript: windyCityS)
				)
				(ego setPri: 8)
				(self dispose:)
			)
		)
	)
)

(instance windyCityS of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (and (> (ego x?) 106) (not global161))
			(UnlockEgo)
			(ego setMotion: MoveTo 152 77)
		else
			(ego x: (- (ego x?) 2))
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 62 setLoop: 0 setMotion: MoveTo 152 77)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast,throw') (localproc_000c 580 14))
		)
	)
)

(instance fromEntrance of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (and local2 (not (Btst 87)))
			(ego hide:)
			(SetUpEgo)
			(localproc_000c 580 15)
			(= local2 0)
		)
	)
	
	(method (dispose)
		(gDirH delete: self)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(gDirH add: self)
				(ego
					setPri: 32
					loop: 5
					posn: 199 137
					illegalBits: 0
					init:
					setMotion: MoveTo 174 149 self
				)
				(blueDr cel: 0)
			)
			(1
				(blueDr cycleSpeed: 2 setCycle: End self)
			)
			(2
				(curRoom drawPic: 2)
				(ego setPri: 8 hide:)
				(blueDr stopUpd:)
				(= cycles 8)
			)
			(3
				(localproc_000c 580 16)
				(= seconds 3)
			)
			(4
				(localproc_000c 580 17)
				(= cycles 10)
			)
			(5
				(localproc_000c 580 18)
				(ego ignoreActors: illegalBits: -32768)
				(LockEgo)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast>')
				(if (OneOf (proc65_0 pEvent) 22 25) (= local2 1))
				(pEvent claimed: 0)
			)
			((== (pEvent type?) evJOYSTICK) (msgTimer setReal: msgTimer 3) (pEvent claimed: 1))
		)
	)
)

(instance fromFireRm of HandsOffScript
	(properties)
	
	(method (doit &tmp egoY)
		(= egoY (ego y?))
		(redDr
			setCel:
				(cond 
					((<= egoY 60) 0)
					((<= egoY 62) 1)
					((<= egoY 64) 2)
					((<= egoY 65) 3)
					(else 4)
				)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setPri: 5
					loop: 5
					posn: 286 58
					illegalBits: 0
					init:
					setMotion: MoveTo 273 66 self
				)
				(redDr setCel: 0)
			)
			(1
				(proc1_19)
				(ego setPri: 8)
				(redDr setScript: glowDrS)
				(self dispose:)
			)
		)
	)
)

(instance glowDrS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles (Random 5 30)))
			(1
				(client setCel: 3)
				(= cycles (Random 2 8))
			)
			(2
				(client setCel: 4)
				(self changeState: 0)
			)
		)
	)
)

(instance fallOffLedge of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 0)
				(ego
					setScript: 0
					view: 591
					setLoop: 3
					cel: 0
					setPri: 13
					setMotion: MoveTo (ego x?) (+ (ego y?) 3) self
				)
				(if (Btst 116)
					(floorShine hide:)
					(wallShine hide:)
					(lamp posn: (+ (ego x?) 20) (- (ego y?) 15) init:)
				)
			)
			(1
				(ego setLoop: 1 cel: 0 posn: (- (ego x?) 8) (ego y?))
				(if (Btst 116)
					(lamp posn: (+ (ego x?) 20) (- (ego y?) 15))
				)
				(= cycles 1)
			)
			(2
				(ego cel: 1 posn: (- (ego x?) 2) (+ (ego y?) 3))
				(if (Btst 116)
					(lamp posn: (+ (ego x?) 20) (- (ego y?) 10))
				)
				(= cycles 1)
			)
			(3
				(ego cel: 2 posn: (+ (ego x?) 1) (+ (ego y?) 7))
				(if (Btst 116)
					(lamp posn: (+ (ego x?) 20) (- (ego y?) 5))
				)
				(= cycles 1)
			)
			(4
				(ego cel: 3 posn: (+ (ego x?) 3) (+ (ego y?) 3))
				(if (Btst 116) (lamp posn: (+ (ego x?) 20) (ego y?)))
				(= cycles 1)
			)
			(5
				(ego
					view: 6
					setLoop: 2
					cel: 3
					posn: (+ (ego x?) 5) (+ (ego y?) 14)
				)
				(if (Btst 116) (lamp posn: (+ (ego x?) 20) (ego y?)))
				(= cycles 1)
			)
			(6
				(SetInput 1)
				(ego cel: 4 posn: (- (ego x?) 1) (+ (ego y?) 9))
				(if (Btst 116) (lamp posn: (+ (ego x?) 20) (ego y?)))
				(= cycles 1)
			)
			(7
				(ego cel: 5 posn: (+ (ego x?) 3) (+ (ego y?) 13))
				(if (Btst 116) (lamp posn: (+ (ego x?) 20) (ego y?)))
				(= cycles 1)
			)
			(8
				(ego cel: 6 posn: (ego x?) (+ (ego y?) 14))
				(if (Btst 116) (lamp posn: (+ (ego x?) 20) (ego y?)))
				(= cycles 1)
			)
			(9
				(ego cel: 7 posn: (- (ego x?) 1) 153)
				(if (Btst 116) (lamp posn: (+ (ego x?) 20) (ego y?)))
				(= cycles 1)
			)
			(10
				(ego cel: 8)
				(if (Btst 116)
					(lamp posn: (+ (ego x?) 20) (ego y?))
					(floorShine
						posn: (lamp x?) (lamp y?)
						setPri: (- (lamp priority?) 1)
						show:
					)
				)
				(= cycles 1)
			)
			(11 (ego cel: 9) (= cycles 10))
			(12
				(if (ReduceHP 10)
					(if local0
						(switch (++ global296)
							(1 (localproc_000c 580 21))
							(2 (localproc_000c 580 22))
							(3 (localproc_000c 580 23))
							(4 (localproc_000c 580 24))
							(else  (localproc_000c 580 25))
						)
					else
						(localproc_000c 580 26)
					)
					(ego
						setLoop: 3
						cel: 0
						cycleSpeed: 1
						setCycle: CT 6 1 self
					)
					(= local4 0)
				else
					(Die
						1
						{Dancing in the dark is romantic, but dangerous.}
						80
						{You Blew That One}
					)
				)
			)
			(13
				(ego setCycle: End self)
				(lamp dispose:)
			)
			(14
				(wallShine posn: (ego x?) 140 show:)
				(LockEgo)
				(proc1_19)
				(ego setPri: 8)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast>')
				(if (== (proc65_0 pEvent) 28)
					(if (CastSpell 28)
						(= temp0 (- 170 (ego y?)))
						(ego y: (+ (ego y?) temp0) z: temp0)
						(client setScript: (ScriptID 62 0))
					)
				else
					(Print 580 19)
				)
				(pEvent claimed: 1)
			)
			(else (pEvent claimed: 1) (Print 580 20))
		)
	)
)

(instance lamp of Actor
	(properties
		view 586
		loop 2
		signal $4000
		illegalBits $0000
	)
)

(instance floorShine of Actor
	(properties
		x 159
		y 150
		view 586
		priority 1
		signal $4810
		illegalBits $0000
	)
	
	(method (doit)
		(if (and (Btst 116) (== (ego view?) 585))
			(cond 
				((> (ego y?) 100) (self setPri: 4))
				((== (ego loop?) 2) (self setPri: 1))
				(else (self setPri: 7))
			)
			(switch (ego loop?)
				(0
					(self posn: (+ (ego x?) 10) (+ (ego y?) 5))
				)
				(1
					(self posn: (- (ego x?) 10) (+ (ego y?) 5))
				)
				(2
					(self posn: (ego x?) (+ (ego y?) 5))
				)
				(3
					(self posn: (ego x?) (- (ego y?) 5))
				)
				(4
					(self posn: (+ (ego x?) 12) (ego y?))
				)
				(5
					(self posn: (- (ego x?) 20) (+ (ego y?) 5))
				)
				(6
					(self posn: (+ (ego x?) 12) (ego y?))
				)
				(else 
					(self posn: (- (ego x?) 20) (+ (ego y?) 5))
				)
			)
		)
		(super doit:)
	)
)

(instance wallShine of Actor
	(properties
		x 159
		y 140
		view 586
		loop 1
		priority 2
		signal $4810
		illegalBits $0000
	)
	
	(method (doit)
		(if (and (Btst 116) (== (ego view?) 585))
			(if (== (ego loop?) 2) (self hide:) else (self show:))
			(switch (ego loop?)
				(0
					(self posn: (+ (ego x?) 10) (- (ego y?) 15))
				)
				(1
					(self posn: (- (ego x?) 10) (- (ego y?) 15))
				)
				(2
					(self posn: (ego x?) (ego y?))
				)
				(3
					(self posn: (- (ego x?) 10) (- (ego y?) 15))
				)
				(4
					(self posn: (+ (ego x?) 20) (- (ego y?) 15))
				)
				(5
					(self posn: (- (ego x?) 20) (- (ego y?) 15))
				)
				(6
					(self posn: (+ (ego x?) 20) (- (ego y?) 15))
				)
				(7
					(self posn: (- (ego x?) 20) (- (ego y?) 15))
				)
				(else 
					(self posn: (lamp x?) (- (lamp y?) 15))
				)
			)
		else
			(self hide:)
		)
		(super doit:)
	)
)

(instance blueDr of TargActor
	(properties
		x 199
		y 130
		noun '/door,entrance[<out,city]'
		description {the door to the outside}
		lookStr {The door through which you entered the Forbidden City has closed behind you.}
		view 580
		cel 4
		priority 4
		signal $4010
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 2)
			(self openMe:)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (hurtMe param1 param2 &tmp newProjectile)
		(return
			(if (OneOf (param2 type?) 25 27)
				((= newProjectile (Projectile new:))
					type: (param2 type?)
					damage: param1
					xStart: hitX
					yStart: hitY
					x: (+ (ego x?) (Random -15 15))
					y: (+ (ego y?) (Random -10 10))
				)
				(self setScript: newProjectile self 0)
				(if (== (param2 type?) 25)
					(= local3 4)
				else
					(= local3 5)
				)
				(msgTimer setReal: msgTimer 2)
				(return 0)
			else
				0
			)
		)
	)
	
	(method (openMe)
		(HighPrint 580 27)
		(return 0)
	)
)

(instance redDr of TargActor
	(properties
		x 283
		y 56
		noun '/done,glow'
		description {the red glow}
		lookStr {There is a red glow in another chamber beyond this one.}
		view 580
		loop 1
		cel 4
		priority 4
		signal $4010
	)
	
	(method (hurtMe param1 param2 &tmp newProjectile)
		(return
			(if (OneOf (param2 type?) 25 27)
				((= newProjectile (Projectile new:))
					type: (param2 type?)
					damage: param1
					xStart: hitX
					yStart: hitY
					x: (+ (ego x?) (Random -15 15))
					y: (+ (ego y?) (Random -10 10))
				)
				(self setScript: newProjectile self 0)
				(if (== (param2 type?) 25)
					(= local3 4)
				else
					(= local3 5)
				)
				(msgTimer setReal: msgTimer 2)
				(return 0)
			else
				0
			)
		)
	)
)

(instance stag1 of Prop
	(properties
		x 17
		y 75
		view 580
		loop 2
		cel 4
		priority 12
		signal $0010
	)
	
	(method (doit)
		(cond 
			((and (Btst 116) (< (ego y?) 100))
				(cond 
					((> (- (ego x?) (stag1 x?)) 70) (self setCel: 4))
					((> (- (ego x?) (stag1 x?)) 25) (self setCel: 3))
					((> (- (ego x?) (stag1 x?)) 10) (self setCel: 2))
					((> (- (stag1 x?) (ego x?)) 25) (self setCel: 0))
					(else (self setCel: 1))
				)
			)
			((!= (self cel?) 4) (self setCel: 4))
		)
		(super doit:)
	)
)

(instance stag2 of Prop
	(properties
		x 53
		y 75
		view 580
		loop 3
		cel 4
		priority 12
		signal $0010
	)
	
	(method (doit)
		(cond 
			((and (Btst 116) (< (ego y?) 100))
				(cond 
					((> (- (ego x?) (self x?)) 70) (self setCel: 4))
					((> (- (ego x?) (self x?)) 25) (self setCel: 3))
					((> (- (ego x?) (self x?)) 10) (self setCel: 2))
					((> (- (self x?) (ego x?)) 25) (self setCel: 0))
					(else (self setCel: 1))
				)
			)
			((!= (self cel?) 4) (self setCel: 4))
		)
		(super doit:)
	)
)

(instance stag3 of Prop
	(properties
		x 91
		y 78
		view 580
		loop 2
		cel 4
		priority 12
		signal $0010
	)
	
	(method (doit)
		(cond 
			((and (Btst 116) (< (ego y?) 100))
				(cond 
					((> (- (ego x?) (self x?)) 70) (self setCel: 4))
					((> (- (ego x?) (self x?)) 25) (self setCel: 3))
					((> (- (ego x?) (self x?)) 10) (self setCel: 2))
					((> (- (self x?) (ego x?)) 25) (self setCel: 0))
					(else (self setCel: 1))
				)
			)
			((!= (self cel?) 4) (self setCel: 4))
		)
		(super doit:)
	)
)

(instance stag4 of Prop
	(properties
		x 142
		y 82
		view 580
		loop 4
		cel 4
		priority 12
		signal $0010
	)
	
	(method (doit)
		(cond 
			((and (Btst 116) (< (ego y?) 100))
				(cond 
					((> (- (ego x?) (self x?)) 70) (self setCel: 4))
					((> (- (ego x?) (self x?)) 25) (self setCel: 3))
					((> (- (ego x?) (self x?)) 10) (self setCel: 2))
					((> (- (self x?) (ego x?)) 25) (self setCel: 0))
					(else (self setCel: 1))
				)
			)
			((!= (self cel?) 4) (self setCel: 4))
		)
		(super doit:)
	)
)

(instance kludge of TargActor
	(properties
		x 100
		y 100
		signal $0080
	)
	
	(method (calmMe)
		(localproc_000c 580 29)
		(if local5 (ego setScript: local5) (= local5 0))
		(return 1)
	)
	
	(method (dazzleMe)
		(ego show:)
		(return 1)
	)
	
	(method (detectMe)
		(localproc_000c 580 28)
		(if local5 (ego setScript: local5) (= local5 0))
		(return 1)
	)
)

(instance msgTimer of Timer
	(properties)
	
	(method (cue)
		(super cue:)
		(switch local3
			(0
				(localproc_000c 580 30)
				(ego loop: 1 setHeading: 270 posn: 168 143)
			)
			(1
				(localproc_000c 580 31)
				(ego loop: 0 setHeading: 90 posn: 127 153)
				(if (not [invNum 33]) (localproc_0028))
			)
			(2
				(localproc_000c 580 32)
				(ego posn: 94 186 loop: 2 setHeading: 180)
			)
			(3
				(localproc_000c 580 33)
				(Die
					1
					{Afraid of the dark?__You should have been.__Perhaps you would have lasted longer if you hadn't taken the darkness so lightly.}
					80
					{Can't you see?}
				)
			)
			(4 (localproc_000c 580 34))
			(5 (localproc_000c 580 35))
		)
		(return (++ local3))
	)
)

(instance highBlackWindow of TopWindow
	(properties)
)

(instance roomSound of Sound
	(properties
		number 580
		priority 5
		loop -1
	)
)
