;;; Sierra Script 1.0 - (do not remove this comment)
(script# 590)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use n065)
(use TargActor)
(use Intrface)
(use LoadMany)
(use Music)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm590 0
)

(local
	local0
	local1
	local2
	[newSound 15]
	[local18 12] = [8 10 11 9 12 10 9 8 7 10 11 9]
)
(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 12)
		([newSound (= [newSound temp0] (Sound new:))]
			priority: [local18 temp0]
			loop: 1
			init:
		)
		(++ temp0)
	)
)

(procedure (localproc_003e &tmp temp0 temp1)
	(= temp1 12)
	(= temp0 0)
	(while (< temp0 local2)
		(= temp1
			(switch (Random 0 1)
				(0 12)
				(1 751)
			))
		([newSound temp0] number: temp1 loop: 1 vol: 90 play:)
		(++ temp0)
	)
)

(procedure (localproc_008c &tmp temp0)
	(= temp0 0)
	(while (< temp0 12)
		([newSound temp0] dispose:)
		(++ temp0)
	)
)

(procedure (localproc_00a9)
	(hiWindow color: 9 back: 0)
	(Print &rest #mode 1 #window hiWindow)
)

(instance rm590 of Rm
	(properties
		picture 590
		style $0006
	)
	
	(method (init)
		(LoadMany 129 2 590)
		(LoadMany 128 591 6 31 586)
		(if [invNum 16] (LoadMany 128 8 47))
		(LoadMany 132 600 551 590 591)
		(Bset 116)
		(= egoWalkMode 4)
		(= gGDftSC gAllSC)
		(AddToScore 636 7)
		(= defaultPalette 1)
		(gKeyH add: self)
		(super init:)
		(proc1_19)
		(dr1 init:)
		(dr2 init:)
		(floorShine init:)
		(self setScript: enterS)
		(gCMusic number: 600 loop: -1 playBed:)
	)
	
	(method (doit)
		(cond 
			((ego script?))
			(
				(and
					(& (ego onControl: 1) $0002)
					(== (ego illegalBits?) -32768)
				)
				(ego setScript: fallDnCliff)
			)
			(
				(and
					(& (ego onControl: 1) $0004)
					(== (ego illegalBits?) -32768)
				)
				(ego setScript: toTreasRoom)
			)
			((> (ego x?) 320) (= gTopExit 2) (curRoom newRoom: 560))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gKeyH delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'hop')
				(cond 
					((> (ego x?) 208) (Print 590 0))
					((> (ego y?) 100) (HighPrint 590 1))
					((!= gHeroType 0) (= local1 2) (UnlockEgo) (ego setMotion: MoveTo 120 120))
					(else (AddToScore 635 7 0) (ego setScript: jumpDownS))
				)
			)
			((Said 'climb,scale')
				(cond 
					((> (ego y?) 100) (HighPrint 590 2))
					([skills 11] (Print 590 3))
					((> (ego x?) 208) (Print 590 4))
					(else (UnlockEgo) (= local1 1) (ego setMotion: MoveTo 120 120))
				)
			)
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/cave')
				)
				(if (> (ego y?) 100)
					(HighPrint 590 5)
				else
					(HighPrint 590 6)
				)
			)
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(cond 
					((> (ego y?) 100) (pEvent claimed: 0))
					((not [invNum 16]) (PrintDontHaveIt))
					((> (ego x?) 208) (Print 590 7))
					(else (ego setScript: climbDownRopeS))
				)
			)
			((Said 'put,deposit,extinguish/lamp,light') (PrintWarning 590 8))
			((Said 'cast>')
				(if (== (proc65_0 pEvent) 28)
					(cond 
						((> (ego y?) 100) (pEvent claimed: 0))
						((> (ego x?) 208) (Print 590 9))
						((CastSpell 28) (ego setScript: levitateDownS))
					)
				else
					(pEvent claimed: 0)
				)
			)
		)
	)
)

(instance enterS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					illegalBits: -32768
					posn: 319 101
					init:
					setMotion: MoveTo 299 96 self
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance jumpDownS of HandsOffScript
	(properties)
	
	(method (doit)
		(super doit:)
		(if
		(and (& (ego onControl: 1) $0002) (== state 0))
			(ego setMotion: 0)
			(self cue:)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 120 120 self)
			)
			(1
				(SetInput 0)
				(gMiscMusic number: 590 loop: 1 priority: 10 play:)
				(ego
					view: 591
					loop: 3
					cel: 0
					illegalBits: 0
					posn: (- (ego x?) 3) (- (ego y?) 3)
				)
				(= cycles 1)
			)
			(2
				(ego
					loop: 5
					cel: 0
					posn: (- (ego x?) 4) (+ (ego y?) 10)
				)
				(= cycles 1)
			)
			(3
				(ego cel: 1 posn: (- (ego x?) 4) (+ (ego y?) 15))
				(= cycles 1)
			)
			(4
				(ego cel: 2 posn: (- (ego x?) 3) (+ (ego y?) 16))
				(= cycles 1)
			)
			(5
				(ego cel: 2 posn: (- (ego x?) 1) (+ (ego y?) 16))
				(= cycles 1)
			)
			(6
				(ego cel: 1 posn: (- (ego x?) 1) (+ (ego y?) 12))
				(= cycles 1)
			)
			(7
				(SetInput 1)
				(ego cel: 1 posn: (- (ego x?) 1) (+ (ego y?) 11))
				(= cycles 1)
			)
			(8
				(ego
					loop: 1
					cel: 1
					posn: (- (ego x?) 1) (+ (ego y?) 7)
				)
				(= cycles 1)
			)
			(9
				(ego cel: 2 posn: (- (ego x?) 1) (+ (ego y?) 5))
				(= cycles 1)
			)
			(10
				(ego cel: 3 posn: (- (ego x?) 2) (ego y?))
				(= cycles 1)
			)
			(11
				(ego cel: 4 posn: (- (ego x?) 10) (- (ego y?) 2))
				(= cycles 1)
			)
			(12
				(ego cel: 5 posn: (- (ego x?) 9) (- (ego y?) 3))
				(= cycles 1)
			)
			(13
				(ego cel: 6 posn: (- (ego x?) 7) (+ (ego y?) 7))
				(= cycles 1)
			)
			(14
				(ego cel: 7 posn: (+ (ego x?) 1) (ego y?))
				(= cycles 1)
			)
			(15
				(ego cel: 8 posn: (- (ego x?) 1) (ego y?))
				(= cycles 1)
			)
			(16
				(ego cel: 9 posn: (- (ego x?) 2) (ego y?))
				(= cycles 1)
			)
			(17
				(proc1_19)
				(ego loop: 3 heading: 0)
				(= cycles 1)
			)
			(18
				(if (ReduceHP 10)
					(Print 590 12)
				else
					(Die
						1
						{With all the damage you took to get here, it's really a shame you couldn't take any more.__You should've tended to your healing, but now it's too late.}
						80
						{You Fell for It}
					)
				)
				(= defaultPalette 0)
				(curRoom drawPic: 590)
				(SetUpEgo)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast>')
				(if (== (proc65_0 pEvent) 28)
					(if (CastSpell 28)
						(= temp0 (- 160 (ego y?)))
						(ego y: (+ (ego y?) temp0) z: temp0)
						(AddToScore 635 7 1)
						(client setScript: (ScriptID 62 0))
					)
				else
					(Print 590 10)
				)
				(pEvent claimed: 1)
			)
			((== (pEvent type?) evSAID) (pEvent claimed: 1) (Print 590 11))
			(else (pEvent claimed: 1))
		)
	)
)

(instance levitateDownS of HandsOffScript
	(properties)
	
	(method (doit)
		(super doit:)
		(if
		(and (& (ego onControl: 1) $0002) (== state 0))
			(ego setMotion: 0)
			(self cue:)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 120 120 self)
			)
			(1
				(SetInput 0)
				(ego
					view: 591
					loop: 3
					cel: 0
					illegalBits: 0
					posn: (- (ego x?) 3) (- (ego y?) 3)
				)
				(= cycles 1)
			)
			(2
				(ego
					loop: 5
					cel: 0
					posn: (- (ego x?) 4) (+ (ego y?) 10)
				)
				(= cycles 1)
			)
			(3
				(ego cel: 1 posn: (- (ego x?) 4) (+ (ego y?) 15))
				(= defaultPalette 0)
				(curRoom drawPic: 590)
				(SetUpEgo)
				(ego y: 160 z: (- 160 (ego y?)))
				(AddToScore 635 7 1)
				(client setScript: (ScriptID 62 0))
			)
		)
	)
)

(instance fallDnCliff of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 0)
				(ego
					view: 591
					loop: 3
					cel: 0
					posn: (ego x?) (+ (ego y?) 3)
				)
				(gMiscMusic number: 590 loop: 1 priority: 10 play:)
				(= cycles 1)
			)
			(1
				(ego loop: 1 posn: (- (ego x?) 8) (+ (ego y?) 4))
				(= cycles 1)
			)
			(2
				(ego cel: 2 posn: (- (ego x?) 2) (+ (ego y?) 6))
				(= cycles 1)
			)
			(3
				(ego posn: (+ (ego x?) 1) (+ (ego y?) 8))
				(= cycles 1)
			)
			(4
				(ego cel: 3 posn: (+ (ego x?) 3) (+ (ego y?) 10))
				(= cycles 1)
			)
			(5
				(SetInput 1)
				(ego
					view: 6
					loop: 2
					cel: 3
					posn: (+ (ego x?) 5) (+ (ego y?) 14)
				)
				(= cycles 1)
			)
			(6
				(ego
					loop: 2
					cel: 4
					posn: (- (ego x?) 1) (+ (ego y?) 13)
				)
				(= cycles 1)
			)
			(7
				(ego
					loop: 2
					cel: 5
					posn: (+ (ego x?) 3) (+ (ego y?) 14)
				)
				(= cycles 1)
			)
			(8
				(ego cel: 6 posn: (ego x?) (+ (ego y?) 15))
				(= cycles 1)
			)
			(9
				(ego cel: 7 posn: (- (ego x?) 1) (+ (ego y?) 13))
				(= cycles 1)
				(gMiscMusic number: 591 loop: 1 play:)
			)
			(10
				(ego cel: 8 posn: (ego x?) (ego y?))
				(= cycles 1)
			)
			(11
				(ego cel: 9 posn: (ego x?) (ego y?))
				(= cycles 1)
			)
			(12
				(cond 
					((not (ReduceHP 20))
						(Die
							0
							{The conclusion to this little cliff-hanger was in abbreviated form.}
							80
							{Cliff Notes}
							82
							6
							2
							7
						)
					)
					((== local1 1) (LockEgo) (Print 590 13) (= local1 0))
					((== local1 2) (LockEgo) (Print 590 14))
					(else (Print 590 15))
				)
				(= defaultPalette 0)
				(curRoom drawPic: 590)
				(SetUpEgo)
				(ego setLoop: 3 cel: 0 setCycle: End self)
			)
			(13 (proc1_19) (self dispose:))
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast>')
				(if (== (proc65_0 pEvent) 28)
					(if (CastSpell 28)
						(= temp0 (- 160 (ego y?)))
						(ego y: (+ (ego y?) temp0) z: temp0)
						(AddToScore 635 7 1)
						(client setScript: (ScriptID 62 0))
					)
				else
					(Print 590 10)
				)
				(pEvent claimed: 1)
			)
			((== (pEvent type?) evSAID) (pEvent claimed: 1) (Print 590 11))
			(else (pEvent claimed: 1))
		)
	)
)

(instance climbDownRopeS of HandsOffScript
	(properties)
	
	(method (doit)
		(super doit:)
		(if
		(and (& (ego onControl: 1) $0002) (== state 0))
			(ego setMotion: 0 y: (- (ego y?) 2))
			(self cue:)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 120 120 self)
			)
			(1 (ego setHeading: 315 self))
			(2
				(ego view: 8 loop: 1 cel: 0 setCycle: End self)
			)
			(3
				(ego loop: 6 cel: 0)
				(coil
					init:
					posn: (- (ego x?) 13) (+ (ego y?) 4)
					setMotion:
						MoveTo
						(- (ego x?) 18)
						(if (< (ego x?) 234) 144 else 164)
						self
				)
			)
			(4
				(ego loop: 6 cel: 0 cycleSpeed: 2 setCycle: End)
				(coil setCycle: End)
				(rope
					posn: (coil x?) (- (coil y?) 2)
					init:
					setCycle: End self
				)
			)
			(5 (ego setCycle: Beg self))
			(6
				(ego
					view: 591
					loop: 0
					cel: 0
					setPri: 9
					posn: (+ (rope x?) 1) (ego y?)
					cycleSpeed: 2
					setCycle: CT 4 1 self
				)
			)
			(7
				(ego
					view: 6
					setLoop: 9
					setCycle: Fwd
					cycleSpeed: 1
					moveSpeed: 1
					yStep: 4
					setMotion: MoveTo (coil x?) (+ (coil y?) 4) self
				)
			)
			(8
				(ego
					setLoop: 8
					cel: 2
					yStep: 2
					setCycle: Beg self
					moveSpeed: 0
					setMotion: MoveTo (coil x?) (+ (coil y?) 12)
				)
				(= defaultPalette 0)
				(curRoom drawPic: 590)
				(SetUpEgo)
			)
			(9
				(rope setCycle: Beg self)
				(coil setCycle: Beg)
			)
			(10
				(proc1_19)
				(ego
					heading: 0
					loop: 3
					setMotion: MoveTo (coil x?) (+ (coil y?) 8) self
				)
			)
			(11
				(ego
					view: 47
					loop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(12
				(rope dispose:)
				(coil dispose:)
				(ego setCycle: Beg self)
			)
			(13
				(AddToScore 635 7 2)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance toTreasRoom of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: wrongS 0 1)
				(ego setMotion: 0)
				(HighPrint 590 22)
				(localproc_00a9 590 23)
				(localproc_00a9 590 24)
				(SetInput 0)
			)
			(1
				(SetInput 1)
				(ego setPri: -1)
				(Print 590 25)
				(gMiscMusic number: 551 loop: 1 priority: 15 init: play:)
				(dr1 setCycle: End)
				(dr2 setCycle: End self)
			)
			(2
				(ego setMotion: MoveTo 8 124 self)
			)
			(3 (curRoom newRoom: 600))
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said '/bendaoud') (self cue:))
			((Said 'cast') (HighPrint 590 16))
			(
				(or
					(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
					(Said 'use,get,acquire')
				)
				(HighPrint 590 17)
			)
			((Said 'look,examine,get,acquire,use') (HighPrint 590 18))
			((Said 'answer') (HighPrint 590 19))
			((Said 'ask') (HighPrint 590 20))
			((Said 'talk,chat,tell') (HighPrint 590 21))
			((== (pEvent type?) evSAID)
				(pEvent claimed: 1)
				(wrongS changeState: (wrongS register?))
			)
			(else (pEvent claimed: 1))
		)
	)
)

(instance wrongS of Script
	(properties)
	
	(method (init)
		(localproc_000c)
		(super init: &rest)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(1
				(= local2 6)
				(localproc_003e)
				(ShakeScreen 15 2)
				(= cycles 3)
			)
			(2
				(HighPrint 590 26 103)
				(= register 3)
			)
			(3
				(= local2 (+ local2 3))
				(localproc_003e)
				(ShakeScreen 25 1)
				(= cycles 3)
			)
			(4
				(HighPrint 590 27 103)
				(= register 5)
			)
			(5
				(= local2 (+ local2 3))
				(localproc_003e)
				(ShakeScreen 35 3)
				(= cycles 3)
			)
			(6
				(HighPrint 590 28 103)
				(= register 7)
			)
			(7
				(localproc_008c)
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(Die
					1
					{Your last thoughts as the cavern collapses around you are, "Who thought up this crummy puzzle, anyway?"}
					80
					{Wrong!}
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(== (pEvent type?) evKEYBOARD)
					(== (pEvent message?) KEY_RETURN)
				)
				(if modelessDialog (modelessDialog dispose:))
				(pEvent claimed: 1)
			)
		)
	)
)

(instance dr1 of TargActor
	(properties
		x 47
		y 127
		noun '/door'
		description {the ancient doors}
		lookStr {The great, ancient doors stand guard, as they have for one thousand and one years.}
		view 591
		loop 7
		signal $0010
		cycleSpeed 2
	)
	
	(method (onMe)
		(if (super onMe: &rest) else (dr2 onMe: &rest))
	)
	
	(method (detectMe)
		(HighPrint 590 31)
	)
	
	(method (fetchMe)
		(HighPrint 590 30)
		(return 0)
	)
	
	(method (hurtMe)
		(HighPrint 590 32)
	)
	
	(method (openMe)
		(HighPrint 590 29)
		(return 1)
	)
)

(instance dr2 of Prop
	(properties
		x 15
		y 131
		view 591
		loop 8
		signal $0010
		cycleSpeed 2
	)
)

(instance rope of Prop
	(properties
		view 8
		loop 4
		priority 8
		signal $0010
		cycleSpeed 1
	)
)

(instance coil of Actor
	(properties
		yStep 8
		view 8
		loop 2
		priority 8
		signal $5810
		illegalBits $0000
		xStep 4
	)
)

(instance hiWindow of TopWindow
	(properties)
)

(instance floorShine of View
	(properties
		noun '/reflection,glow,light'
		description {the reflection of your lamp.}
		lookStr {It is the reflection of your lamp light.}
		view 586
		signal $4810
	)
	
	(method (doit)
		(cond 
			((and (Btst 116) (== (ego view?) 585))
				(if (& signal $0008) (self show:))
				(switch (ego loop?)
					(0
						(self posn: (+ (ego x?) 10) (+ (ego y?) 5))
					)
					(1
						(self posn: (- (ego x?) 10) (+ (ego y?) 5))
					)
					(2
						(self posn: (ego x?) (+ (ego y?) 5))
					)
					(3
						(self posn: (ego x?) (- (ego y?) 5))
					)
					(4
						(self posn: (+ (ego x?) 12) (ego y?))
					)
					(5
						(self posn: (- (ego x?) 20) (+ (ego y?) 5))
					)
					(6
						(self posn: (+ (ego x?) 12) (ego y?))
					)
					(7
						(self posn: (- (ego x?) 20) (+ (ego y?) 5))
					)
				)
			)
			((not (& signal $0008)) (self hide:))
		)
		(super doit:)
	)
)
