;;; Sierra Script 1.0 - (do not remove this comment)
(script# 650)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Stage)
(use TargActor)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	rm650 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	local9
	local10
	local11
	[local12 10] = [0 {I have a red pencil box} {Can you direct me to the public bath} {I will not buy your rotten pears} {May a sleepy hippopotamus lie down on your house keys} {I can give you 5 dinars for the gourd} {My sister has a saurus for sale} {Excuse me, your camel has fallen on my mother} {Your horse is foundered and I do not need that} {May I apply spices to your beard?}]
	[local22 6] = [0 {Well, you think that might have been} {Hmm.__That rather sounded like} {You believe that was} {If your translation is correct, that was} {You think that roughly translates to}]
	[local28 5] = [0 {Perhaps you should have paid more attention in "Griffin 101"} {You should have kept your Griffin-English phrase book from Adventurer's School} {Of course, you can never be sure when talking with a Griffin} {Unfortunately, your fluency in Griffin-speak is too low}]
	[local33 8] = [0 {Screech chirpy caw peep, squawka squawka!"} {Chirp caw peepa-peepa, screechy screechy!} {Freep squeaky pip-pip, awoooooo!} {Screechy squawk, titwillow, titwillow!} {Cheep, cheep, tite, penurious!} {Scratch squawk screech do-be-do-be-doooo!} {(Mumble, mumble...tourists...mumble mumble!)}]
)
(procedure (localproc_000c &tmp temp0 botWindowBrRight botWindowBrLeft)
	(= botWindowBrRight (BotWindow brRight?))
	(= botWindowBrLeft (BotWindow brLeft?))
	(BotWindow color: 10 back: 6)
	(Print
		&rest
		#font
		userFont
		#title
		{Merv the Griffin}
		#window
		BotWindow
		#width
		(- botWindowBrRight (+ botWindowBrLeft 16))
	)
)

(procedure (localproc_0051 &tmp [temp0 150])
	(if (not local7) (HighPrint 650 0) (HighPrint 650 1))
	(if (== local8 9) (= local8 1) else (++ local8))
	(if (== local9 5) (= local9 1) else (++ local9))
	(if (== local10 4) (= local10 1) else (++ local10))
	(HighPrint
		(Format
			@temp0
			650
			2
			[local22 (proc1_5 local9 1 5)]
			[local12 (proc1_5 local8 1 9)]
			[local28 (proc1_5 local10 1 4)]
		)
	)
	(= local7 1)
)

(procedure (localproc_00dd)
	(cond 
		(local6
			(if (TestSkill 0 60)
				(HighPrint 650 3)
				(Bset 73)
				(= local2 2)
			)
		)
		((TestSkill 0 85) (HighPrint 650 4) (Bset 73) (= local2 2))
	)
	(Btst 73)
)

(instance rm650 of Stage
	(properties
		picture 650
		style $0008
		east 665
		south 665
		west 665
		rightFromY 170
		rightToY 170
		leftFromY 170
		leftToY 170
	)
	
	(method (init)
		(LoadMany 128 0 6 7 8 11 12 14 31 47 650 657 655)
		(AddToScore 653 3)
		(self setRegions: 660)
		(ego init:)
		(super init:)
		(= gGetBellows magicRope)
		(= gLevMe goToLevitate)
		(= global168 (= global166 60))
		(= gGDftSC gAllSC)
		(if (not (Btst 74)) (griffin init:))
		(nest init:)
		(rock palette: (+ isNightTime 1) init:)
	)
	
	(method (dispose)
		(= gLevMe (= gGetBellows 0))
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 650 5) (HighPrint 650 6))
			((Said 'look,examine>')
				(cond 
					((Said '/griffin') (HighPrint 650 7))
					((Said '/cliff') (HighPrint 650 8))
					((or (Said '/debris,ground') (Said '<down')) (HighPrint 650 9))
					(
					(or (Said '<up') (Said '/sky,star,constellation'))
						(if isNightTime
							(HighPrint 650 10)
						else
							(HighPrint 650 11)
						)
					)
					((Said '/bird')
						(if (Btst 74)
							(HighPrint 650 12)
						else
							(HighPrint 650 13)
						)
					)
					((Said '/feather')
						(cond 
							((ego has: 28) (pEvent claimed: 0))
							((or (== local2 1) (== local3 1)) (HighPrint 650 14))
							(else (HighPrint 650 15))
						)
					)
				)
			)
			(
			(Said 'pluck,lockpick,grab/feather,bird,griffin')
				(cond 
					((ego has: 28) (HighPrint 650 16))
					((not (cast contains: griffin)) (= local1 0) (self setScript: getFeather))
					(else (HighPrint 650 17))
				)
			)
			(
				(or
					(Said 'search/nest')
					(Said 'search,look,examine<for/feather')
					(Said 'look,examine<in/nest')
				)
				(if (ego has: 28)
					(HighPrint 650 16)
				else
					(HighPrint 650 18)
				)
			)
			((Said 'search,find,get,acquire,acquire/feather')
				(cond 
					((ego has: 28) (HighPrint 650 16))
					((not (if local2 else local3)) (HighPrint 650 19))
					((< local2 2) (HighPrint 650 20))
					(else (= local1 0) (self setScript: getFeather))
				)
			)
			((Said 'talk,chat,ask>')
				(if (cast contains: griffin)
					(cond 
						((Said '[/griffin,griffin]/feather') (= local5 1) (griffin setScript: griffinTalk))
						((Said '[/griffin,griffin]') (= local5 0) (griffin setScript: griffinTalk))
					)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'climb,scale')
				(cond 
					((== egoWalkMode 3) (pEvent claimed: 0))
					((> [skills 11] 75) (HighPrint 650 21))
					(else (TestSkill 11 75) (self setScript: scrabble))
				)
			)
		)
	)
)

(instance goToLevitate of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 144 160 self)
			)
			(1 (ego setHeading: 315 self))
			(2 (caller cue:))
			(3
				(if (and (Btst 74) (cast contains: griffin))
					(ego setScript: (ScriptID 62 1) self 175)
				else
					(self cue:)
				)
			)
			(4
				(= local3 1)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((!= (pEvent type?) evSAID))
			((super handleEvent: pEvent))
			(
			(Said 'pluck,lockpick,grab/feather,bird,griffin')
				(if (and (< 40 (ego z?)) (< (ego z?) 60))
					(= local1 2)
					(self setScript: getFeather)
				else
					(PrintNotCloseEnough)
				)
			)
			(
				(or
					(Said 'search/nest')
					(Said 'search,look,examine<for/feather')
					(Said 'look,examine<in/nest')
				)
				(cond 
					((> (ego z?) 60) (HighPrint 650 22))
					((> (ego z?) 30) (= local1 0) (self setScript: getFeather))
					(else (PrintNotCloseEnough))
				)
			)
			((Said 'search,find,get,acquire,acquire/feather')
				(if (and (< 30 (ego z?)) (< (ego z?) 60))
					(= local1 0)
					(self setScript: getFeather)
				else
					(PrintNotCloseEnough)
				)
			)
			(
			(Said 'talk,chat,ask,holler,tell[/griffin,griffin]')
				(if
				(and (> (ego z?) 35) (cast contains: griffin))
					(= local1 1)
					(griffin setScript: flyAway)
					(self cue:)
				else
					(pEvent claimed: 0)
					(curRoom handleEvent: pEvent)
				)
			)
			((Said 'climb,scale') (HighPrint 650 23))
		)
	)
)

(instance scrabble of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 112 162 self)
			)
			(1
				(ego view: 7 loop: 3 setCycle: Fwd)
				(= cycles 16)
			)
			(2 (ego setCycle: End self))
			(3 (proc1_19) (= cycles 2))
			(4
				(HighPrint 650 24)
				(self dispose:)
			)
		)
	)
)

(instance magicRope of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> (ego x?) 83)
					(ego setMotion: MoveTo 85 164 self)
				else
					(ego setMotion: MoveTo 60 164 self)
				)
			)
			(1
				(if (< (ego x?) 70)
					(ego setHeading: 45 self)
				else
					(ego setHeading: 315 self)
				)
			)
			(2 (caller cue:) (= caller 0))
			(3
				(if local1
					(ego setScript: (ScriptID 61 3))
				else
					(self cue:)
				)
			)
			(4
				(= local3 1)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((!= (pEvent type?) evSAID))
			((super handleEvent: pEvent))
			(
			(Said 'pluck,lockpick,grab/feather,bird,griffin')
				(if (and (< 40 (ego z?)) (< (ego z?) 60))
					(= local1 2)
					(self setScript: getFeather)
				else
					(PrintNotCloseEnough)
				)
			)
			(
				(or
					(Said 'search/nest')
					(Said 'search,look,examine<for/feather')
					(Said 'look,examine<in/nest')
				)
				(cond 
					((> (ego z?) 60) (HighPrint 650 22))
					((> (ego z?) 30)
						(if (ego has: 28)
							(HighPrint 650 16)
						else
							(= local1 0)
							(self setScript: getFeather)
						)
					)
					(else (PrintNotCloseEnough))
				)
			)
			((Said 'search,find,get,acquire,acquire/feather')
				(if (and (< 30 (ego z?)) (< (ego z?) 60))
					(= local1 0)
					(self setScript: getFeather)
				else
					(PrintNotCloseEnough)
				)
			)
			((Said 'talk,chat,ask[/griffin,griffin]')
				(if
				(and (> (ego z?) 35) (cast contains: griffin))
					(= local1 1)
					(griffin setScript: flyAway)
					(magicRope cue:)
				else
					(pEvent claimed: 0)
					(curRoom handleEvent: pEvent)
				)
			)
			((Said 'climb,scale') (HighPrint 650 23))
		)
	)
)

(instance getFeather of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (or (Btst 90) (Btst 88))
					(self changeState: 4)
				else
					(self setScript: moveToRock self)
				)
			)
			(1
				(ego view: 47 loop: 1 setCycle: End self)
			)
			(2
				(AddToScore 654 7)
				(HighPrint 650 25)
				(ego get: 28)
				(= local2 3)
				(ego setCycle: Beg self)
			)
			(3
				(proc1_19)
				(self changeState: 7)
			)
			(4
				(if (Btst 88)
					(ego setLoop: 6 cel: 0 setCycle: End self)
				else
					(ego setCycle: CT 3 -1 self)
				)
			)
			(5
				(AddToScore 654 7)
				(= local3 3)
				(ego get: 28)
				(if local1
					(griffin setScript: flyAway)
					(self changeState: 7)
				else
					(HighPrint 650 26)
					(self cue:)
				)
			)
			(6
				(if (Btst 88)
					(ego setCycle: Beg self)
				else
					(ego setCycle: End self)
				)
			)
			(7
				(cond 
					((Btst 88)
						(ego setLoop: 9)
						(if local1
							(magicRope cue:)
						else
							((ScriptID 61 2) cue:)
						)
					)
					((Btst 90)
						(if local1
							(goToLevitate cue:)
						else
							((ScriptID 62 0) cue:)
						)
					)
				)
				(self dispose:)
			)
		)
	)
)

(instance griffinTalk of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(FaceObject ego griffin)
				(griffinBody posn: (griffin x?) (griffin y?) init:)
				(griffin
					loop: 5
					posn: (+ (griffin x?) 23) (- (griffin y?) 8)
					setPri: 10
					cel: 1
				)
				(= cycles 2)
			)
			(1
				(griffin cel: (Random 1 3))
				(= cycles 2)
			)
			(2
				(if (> (++ local0) (Random 4 6))
					(= local0 0)
					(self cue:)
				else
					(self changeState: 1)
				)
			)
			(3
				(if local5
					(localproc_000c [local33 1])
					(if (TestSkill 13 100)
						(HighPrint 650 27)
					else
						(localproc_0051)
					)
				else
					(if (== local11 7) (= local11 1) else (++ local11))
					(localproc_000c [local33 local11])
					(localproc_0051)
				)
				(= cycles 5)
			)
			(4 (griffin setCycle: Beg self))
			(5
				(griffin
					posn: (griffinBody x?) (griffinBody y?)
					loop: 0
					cel: 0
					setPri: -1
				)
				(griffinBody dispose:)
				(self dispose:)
			)
		)
	)
)

(instance flyAway of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch local1
					(1 (HighPrint 650 28))
					(2 (HighPrint 650 29))
				)
				(AddToScore 681 -10 3)
				(Bset 74)
				(= gGHealth 100)
				(self cue:)
			)
			(1
				(TopWindow color: 10 back: 6)
				(Print
					650
					30
					#font
					userFont
					#at
					250
					80
					#width
					100
					#title
					{Merv the Griffin}
					#window
					TopWindow
					#time
					3
					#dispose
				)
				(griffin setCycle: End self)
			)
			(2
				(wings init: setCycle: Fwd)
				(griffin
					view: 655
					setLoop: 0
					setCel: 1
					y: (- (griffin y?) 10)
				)
				(= cycles 5)
			)
			(3
				(griffin xStep: 9 yStep: 6 setMotion: MoveTo 175 50 self)
			)
			(4
				(griffin
					xStep: 12
					yStep: 9
					ignoreHorizon:
					setMotion: MoveTo 300 -10 self
				)
			)
			(5
				(HighPrint 650 31)
				(griffin dispose:)
				(wings dispose:)
				(self dispose:)
			)
		)
	)
)

(instance moveRock of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: moveToRock self)
			)
			(1
				(ego view: 47 loop: 1 setCycle: End self)
			)
			(2
				(if (localproc_00dd)
					(rock setCycle: End)
					(self changeState: 7)
				else
					(= cycles 4)
				)
			)
			(3 (ego setCycle: Beg self))
			(4
				(ego
					view: 0
					setCycle: Walk
					setMotion: MoveTo 183 139 self
				)
			)
			(5
				(ego view: 47 loop: 0 setCycle: End self)
			)
			(6
				(if local6 (HighPrint 650 32) else (HighPrint 650 33))
				(self cue:)
			)
			(7 (ego setCycle: Beg self))
			(8 (proc1_19) (self dispose:))
		)
	)
)

(instance digSand of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (or local6 (< local2 1))
					(ego view: 47 loop: 1 setCycle: End)
					(= cycles 8)
				else
					(= local6 1)
					(self changeState: 3)
				)
			)
			(1
				(HighPrint 650 34)
				(ego setCycle: Beg self)
			)
			(2 (self changeState: 8))
			(3
				(self setScript: moveToRock self)
			)
			(4
				(ego view: 47 loop: 1 setCycle: End)
				(= cycles 8)
			)
			(5
				(ego
					setCel: (- (ego cel?) 1)
					setMotion: MoveTo (- (ego x?) 5) (ego y?) self
				)
			)
			(6
				(ego setCycle: End)
				(= cycles 8)
			)
			(7 (ego setCycle: Beg self))
			(8 (proc1_19) (= cycles 2))
			(9
				(if (== local2 1) (HighPrint 650 35))
				(self dispose:)
			)
		)
	)
)

(instance moveToRock of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (and (< (ego y?) 161) (< (ego x?) 90))
					(ego setMotion: MoveTo (ego x?) 175 self)
				else
					(self cue:)
				)
			)
			(1
				(ego setMotion: MoveTo 210 139 self)
			)
			(2 (self dispose:))
		)
	)
)

(instance griffin of TargActor
	(properties
		x 98
		y 77
		noun '/griffin,creature,griffin'
		description {Merv, the Griffin}
		lookStr {The Griffin looks like a cross between a lion and an eagle.__It seems to be sleeping.}
		view 657
		illegalBits $0000
	)
	
	(method (hurtMe)
		(= local1 3)
		(griffin setScript: flyAway)
		(return 1)
	)
)

(instance wings of Prop
	(properties
		noun '/griffin,creature,griffin'
		description {Merv, the Griffin}
		lookStr {The Griffin looks like a cross between a lion and an eagle.__It seems to be sleeping.}
		view 657
		loop 6
		signal $4000
	)
	
	(method (doit)
		(= x (+ (griffin x?) 3))
		(= y (- (griffin y?) 34))
		(super doit:)
	)
)

(instance rock of Prop
	(properties
		x 187
		y 134
		noun '/boulder'
		description {the rock}
		view 650
	)
	
	(method (init)
		(if (Btst 73) (= local6 1) (= local2 3) (rock cel: 3))
		(super init: &rest)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(cond 
			((== egoWalkMode 3) (pEvent claimed: 0))
			((Said 'move,dig,acquire/sand[/boulder]')
				(if (> (ego view?) 5)
					(HighPrint 650 40)
				else
					(curRoom setScript: digSand)
				)
			)
			((Said 'lift,acquire,(lockpick<up)/boulder')
				(cond 
					((rock cel?) (HighPrint 650 39))
					((> (ego view?) 5) (HighPrint 650 40))
					(else (curRoom setScript: moveRock))
				)
			)
			((Said 'replace/boulder')
				(if (rock cel?)
					(HighPrint 650 41)
				else
					(HighPrint 650 42)
				)
			)
			((Said 'climb,scale') (pEvent claimed: 0))
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(switch local2
					(3 (HighPrint 650 36))
					(2 (HighPrint 650 37))
					(else 
						(= local2 1)
						(HighPrint 650 38)
					)
				)
			)
			(5
				(cond 
					((rock cel?) (HighPrint 650 39))
					((> (ego view?) 5) (HighPrint 650 40))
					(else (curRoom setScript: moveRock))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance nest of Feature
	(properties
		x 100
		y 148
		z 85
		noun '/nest'
		nsTop 38
		nsLeft 52
		nsBottom 89
		nsRight 148
		description {the Griffin's nest}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (or (< (ego y?) 140) (> (ego z?) 20))
				(HighPrint 650 22)
			else
				(HighPrint 650 43)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance griffinBody of View
	(properties
		view 657
		loop 4
		signal $4000
	)
)
