;;; Sierra Script 1.0 - (do not remove this comment)
(script# 790)
(include sci.sh)
(use Main)
(use n001)
(use Extra)
(use Music)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm790 0
)

(local
	local0
	local1
	[newALightning 8]
	[local10 4] = [66 111 256 200]
	[local14 4] = [35 9 18 -3]
	[newABolt 8]
	[local26 8] = [104 115 130 91 241 218 253 248]
	[local34 8] = [128 120 120 129 117 120 125 120]
	[newSound 6]
	[local48 4] = [11 12 13 14]
)
(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 4)
		([newSound (= [newSound temp0] (Sound new:))]
			number: 12
			loop: 1
			priority: [local48 temp0]
			init:
		)
		(++ temp0)
	)
)

(procedure (localproc_0043 &tmp temp0)
	(= temp0 0)
	(while (< temp0 4)
		([newSound temp0] dispose:)
		(++ temp0)
	)
)

(procedure (localproc_0060 &tmp temp0)
	(= temp0 0)
	(while (< temp0 4)
		([newALightning temp0]
			setLoop: temp0
			cel: 0
			ignoreActors:
			posn:
				[local10 temp0]
				[local14 (= [newALightning temp0] (aLightning new:))]
			init:
		)
		(++ temp0)
	)
)

(procedure (localproc_00a0 &tmp temp0)
	(= temp0 0)
	(while (< temp0 4)
		([newALightning temp0] dispose:)
		(++ temp0)
	)
)

(procedure (localproc_00bd &tmp temp0)
	(= temp0 0)
	(while (< temp0 8)
		([newABolt temp0]
			setLoop: (mod temp0 4)
			cel: 0
			ignoreActors:
			posn: [local26 temp0] [local34 (= [newABolt temp0] (aBolt new:))]
			init:
			hide:
		)
		(++ temp0)
	)
)

(instance aLightning of Extra
	(properties
		view 792
		cycleType 1
		minCycles 1
		maxCycles 2
	)
)

(instance aBolt of Prop
	(properties
		view 792
	)
)

(instance rm790 of Rm
	(properties
		picture 790
		style $0006
	)
	
	(method (init)
		(Load rsVIEW 781 791)
		(Load rsSOUND 12)
		(Load rsPIC 2)
		(= defaultPalette 2)
		(super init:)
		(city1 init:)
		(city2 init:)
		(city3 init:)
		(city4 init:)
		(DrawFeature cityWall)
		(gCMusic number: 340 loop: 1 priority: 5 playBed:)
		(localproc_000c)
		(self setScript: rising)
	)
	
	(method (doit)
		(if local0
			(if (mod ([newALightning 0] cel?) 2)
				([newSound 0] init: play:)
				(leftArmFlash show:)
				(ShakeScreen 1 2)
			else
				(leftArmFlash hide:)
			)
			(if (mod ([newALightning 1] cel?) 2)
				([newSound 1] init: play:)
				(bodyFlash show:)
				(ShakeScreen 1 2)
			else
				(bodyFlash hide:)
			)
			(if (mod ([newALightning 2] cel?) 2)
				([newSound 2] init: play:)
				(rightArmFlash show:)
				(ShakeScreen 1 2)
			else
				(rightArmFlash hide:)
			)
			(if (mod ([newALightning 3] cel?) 2)
				([newSound 3] init: play:)
				(headFlash show:)
				(ShakeScreen 1 2)
			else
				(headFlash hide:)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
	)
)

(instance rising of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ShakeScreen 2 2)
				(tower init:)
				(firstSmoke
					setPri: 1
					init:
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1
				(ShakeScreen 2 2)
				(secondSmoke
					posn: (- (firstSmoke x?) 3) (- (firstSmoke y?) 1)
					setPri: 1
					init:
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(2
				(ShakeScreen 2 2)
				(lastSmoke
					posn: (- (firstSmoke x?) 44) (- (firstSmoke y?) 47)
					setPri: 2
					init:
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(3
				(ShakeScreen 2 2)
				(firstSmoke dispose:)
				(secondSmoke dispose:)
				(lastSmoke dispose:)
				(torso setPri: 13 init:)
				(head
					posn: (- (torso x?) 4) (- (torso y?) 48)
					setPri: 13
					init:
				)
				(body
					posn: (torso x?) (- (torso y?) 14)
					setPri: 13
					init:
				)
				(smoke
					posn: (+ (torso x?) 43) (+ (torso y?) 25)
					setPri: 1
					init:
				)
				(rightArm
					posn: (- (torso x?) 16) (- (torso y?) 62)
					setPri: 13
					init:
				)
				(leftArm
					posn: (+ (torso x?) 11) (- (torso y?) 64)
					setPri: 13
					init:
				)
				(= cycles 4)
			)
			(4
				(ShakeScreen 2 2)
				(head cel: 1 posn: (- (torso x?) 3) (- (torso y?) 58))
				(body cel: 1 posn: (+ (torso x?) 1) (- (torso y?) 14))
				(smoke
					cel: 1
					posn: (+ (torso x?) 40) (+ (torso y?) 25)
				)
				(rightArm
					cel: 1
					posn: (- (torso x?) 32) (- (torso y?) 54)
				)
				(leftArm
					cel: 1
					posn: (+ (torso x?) 37) (- (torso y?) 49)
				)
				(torso dispose:)
				(localproc_0060)
				(localproc_00bd)
				(headFlash
					posn: (- (torso x?) 2) (- (torso y?) 64)
					setPri: 15
					init:
					hide:
				)
				(bodyFlash
					posn: (- (torso x?) 2) (- (torso y?) 49)
					setPri: 15
					init:
					hide:
				)
				(leftArmFlash
					posn: (- (torso x?) 51) (- (torso y?) 15)
					setPri: 15
					init:
					hide:
				)
				(leftHandFlash
					posn: (- (torso x?) 50) (+ (torso y?) 11)
					setPri: 15
					init:
					hide:
				)
				(rightArmFlash
					posn: (+ (torso x?) 58) (- (torso y?) 16)
					setPri: 15
					init:
					hide:
				)
				(rightHandFlash
					posn: (+ (torso x?) 78) (+ (torso y?) 10)
					setPri: 15
					init:
					hide:
				)
				([newABolt 0] setScript: leftBolt)
				([newABolt 4] setScript: rightBolt)
				(= local0 1)
				(= cycles 4)
			)
			(5
				(ShakeScreen 2 2)
				(= seconds 3)
			)
			(6
				(city1 palette: 2 cycleSpeed: 2 setCycle: End)
				(city2 palette: 2 cycleSpeed: 2 setCycle: End)
				(city3 palette: 2 cycleSpeed: 2 setCycle: End)
				(city4 palette: 2 cycleSpeed: 2 setCycle: End)
				(ShakeScreen 2 2)
				(= cycles 2)
			)
			(7
				(ShakeScreen 2 2)
				(fire2 init: setCycle: Fwd)
				(= cycles 2)
			)
			(8
				(ShakeScreen 2 2)
				(= seconds 8)
			)
			(9 (= local0 0) (= cycles 12))
			(10 (tower setCycle: End self))
			(11
				(localproc_00a0)
				(localproc_0043)
				(cast eachElementDo: #dispose)
				(curRoom drawPic: 2)
				(= seconds 3)
			)
			(12
				(Die 1 790 0 80 {The end of the world!})
			)
		)
	)
)

(instance leftBolt of Script
	(properties)
	
	(method (doit)
		(if (mod (client cel?) 2)
			(leftHandFlash show:)
		else
			(leftHandFlash hide:)
		)
		(super doit:)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(= temp0 0)
				(while (< temp0 4)
					([newSound temp0] init: play:)
					([newABolt temp0] show: setCycle: End)
					(++ temp0)
				)
				(= cycles 10)
			)
			(1
				(= temp0 0)
				(while (< temp0 4)
					([newABolt temp0] cel: 0 hide:)
					(++ temp0)
				)
				(= cycles 1)
			)
			(2 (= cycles (Random 5 25)))
			(3 (self changeState: 0))
		)
	)
)

(instance rightBolt of Script
	(properties)
	
	(method (doit)
		(if (mod (client cel?) 2)
			(rightHandFlash show:)
		else
			(rightHandFlash hide:)
		)
		(super doit:)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(= temp0 4)
				(while (< temp0 8)
					([newSound (- temp0 4)] init: play:)
					([newABolt temp0] show: setCycle: End)
					(++ temp0)
				)
				(= cycles 10)
			)
			(1
				(= temp0 4)
				(while (< temp0 8)
					([newABolt temp0] cel: 0 hide:)
					(++ temp0)
				)
				(= cycles 1)
			)
			(2 (= cycles (Random 5 25)))
			(3 (self changeState: 0))
		)
	)
)

(instance crashSound of Sound
	(properties
		number 12
		priority 13
	)
)

(instance tower of Prop
	(properties
		x 230
		y 140
		view 792
		loop 7
	)
)

(instance firstSmoke of Prop
	(properties
		x 201
		y 137
		view 781
		signal $4000
	)
)

(instance secondSmoke of Prop
	(properties
		view 781
		loop 1
		signal $4000
	)
)

(instance lastSmoke of Prop
	(properties
		view 781
		loop 2
		signal $4000
	)
)

(instance head of View
	(properties
		view 791
	)
)

(instance body of View
	(properties
		view 791
		loop 1
	)
)

(instance smoke of View
	(properties
		view 791
		loop 2
		cel 1
	)
)

(instance rightArm of View
	(properties
		view 791
		loop 3
		cel 1
	)
)

(instance leftArm of View
	(properties
		view 791
		loop 4
		cel 1
	)
)

(instance torso of View
	(properties
		x 160
		y 110
		view 791
		loop 1
	)
)

(instance headFlash of View
	(properties
		view 791
		cel 2
		priority 12
		signal $0010
	)
)

(instance bodyFlash of View
	(properties
		view 791
		loop 1
		cel 2
		priority 15
		signal $0010
	)
)

(instance leftArmFlash of View
	(properties
		view 791
		loop 3
		cel 2
		priority 12
	)
)

(instance leftHandFlash of View
	(properties
		view 791
		loop 3
		cel 3
		priority 12
	)
)

(instance rightArmFlash of View
	(properties
		view 791
		loop 4
		cel 2
		priority 12
	)
)

(instance rightHandFlash of View
	(properties
		view 791
		loop 4
		cel 3
		priority 12
	)
)

(instance cityWall of PicView
	(properties
		x 155
		y 155
		view 790
		priority 2
		signal $4010
	)
)

(instance city1 of Prop
	(properties
		x 219
		y 140
		view 790
		loop 2
		priority 1
		signal $4010
		palette 1
	)
)

(instance city2 of Prop
	(properties
		x 181
		y 143
		view 790
		loop 3
		priority 1
		signal $4010
		palette 1
	)
)

(instance city3 of Prop
	(properties
		x 147
		y 137
		view 790
		loop 4
		priority 1
		signal $4010
		palette 1
	)
)

(instance city4 of Prop
	(properties
		x 104
		y 139
		view 790
		loop 5
		priority 1
		signal $4010
		palette 1
	)
)

(instance fire1 of Prop
	(properties
		x 186
		y 134
		view 790
		loop 6
		priority 2
		signal $4010
	)
)

(instance fire2 of Prop
	(properties
		x 203
		y 134
		view 790
		loop 7
		priority 2
		signal $4010
	)
)

(instance fire3 of Prop
	(properties
		x 118
		y 133
		view 790
		loop 6
		priority 2
		signal $4010
	)
)

(instance fire4 of Prop
	(properties
		x 146
		y 133
		view 790
		loop 7
		priority 2
		signal $4010
	)
)

(instance aRock of Actor
	(properties
		yStep 18
		view 792
		signal $4000
		illegalBits $0000
		xStep 18
	)
)
