;;; Sierra Script 1.0 - (do not remove this comment)
(script# 861)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Feature)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm861 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	local9
	local10
	local11
	[newABee1 12]
	[newABee2 12]
	[newABee3 12]
	[newASaury 10]
	[newABrigs1 25]
	[newABrigs6 25]
	[newANearDude 3]
	[newAFarDude 3]
	[local114 11] = [36 71 86 147 188 200 239 265 284 313 5]
	[local125 11] = [89 89 88 91 91 95 84 72 67 70 89]
	[local136 11] = [3 15 5 59 97 152 184 226 236 313 27]
	[local147 11] = [109 85 71 77 86 88 86 88 84 69 76]
	[local158 11] = [32 45 36 81 72 150 137 190 208 194 168]
	[local169 11] = [109 111 117 109 113 108 111 108 104 115 113]
	[local180 3] = [320 355 340]
	[local183 3] = [108 118 128]
	[local186 4] = [36 77 141 204]
	[local190 4] = [85 87 89 91]
	local194
)
(procedure (localproc_000c)
	(= local7 0)
	(while (< local7 local11)
		([newABee1 local7]
			x: [local114 local7]
			y: [local125 (= [newABee1 local7] (aBee1 new:))]
			init:
			setCycle: Fwd
		)
		(++ local7)
	)
)

(procedure (localproc_0047)
	(= local8 0)
	(while (< local8 local11)
		([newABee2 local8]
			x: [local136 local8]
			y: [local147 (= [newABee2 local8] (aBee2 new:))]
		)
		(DrawFeature [newABee2 local8])
		(++ local8)
	)
)

(procedure (localproc_007e)
	(= local9 0)
	(while (< local9 local11)
		([newABee3 local9]
			x: [local158 local9]
			y: [local169 (= [newABee3 local9] (aBee3 new:))]
		)
		(DrawFeature [newABee3 local9])
		(++ local9)
	)
)

(procedure (localproc_00b5)
	(= local2 0)
	(while (< local2 local11)
		((= [newABrigs1 local1] (aBrigs1 new:))
			x: [local180 local2]
			y: [local183 local2]
			init:
			setCycle: Fwd
			setMotion: MoveTo 40 108
		)
		(++ local1)
		(++ local2)
	)
)

(procedure (localproc_00fa)
	(= local3 0)
	(while (< local3 local11)
		((= [newABrigs6 local4] (aBrigs6 new:))
			x: [local186 local3]
			y: [local190 local3]
			init:
			setCycle: Fwd
			setMotion: MoveTo (+ 57 (* 10 local4)) 125
		)
		(++ local4)
		(++ local3)
	)
)

(procedure (localproc_0146)
	((= [newANearDude local5] (aNearDude new:))
		init:
		setCycle: Fwd
		setMotion: MoveTo 330 127
	)
	(return (++ local5))
)

(procedure (localproc_016f)
	((= [newAFarDude local6] (aFarDude new:))
		init:
		setCycle: Fwd
		setMotion: MoveTo 330 123
	)
	(return (++ local6))
)

(procedure (localproc_0198)
	((= [newASaury local0] (aSaury new:))
		loop:
			(cond 
				((or (== local0 0) (== local0 5)) 10)
				((or (== local0 1) (== local0 6)) 8)
				(else 11)
			)
		init:
		setCycle: Fwd
		setMotion: MoveTo 330 125
	)
	(return (++ local0))
)

(procedure (localproc_01f1)
	(= local0 0)
	(while (< local0 (+ local10 1))
		(if (cast contains: [newASaury local0])
			([newASaury local0] setCycle: 0 setMotion: 0 stopUpd:)
			(DrawFeature [newASaury local0])
		)
		(++ local0)
	)
)

(procedure (localproc_0230)
	(= local5 0)
	(while (< local5 2)
		(if (cast contains: [newANearDude local5])
			([newANearDude local5] setCycle: 0 setMotion: 0 stopUpd:)
			(DrawFeature [newANearDude local5])
		)
		(++ local5)
	)
)

(procedure (localproc_026c)
	(= local6 0)
	(while (< local6 2)
		(if (cast contains: [newAFarDude local6])
			([newAFarDude local6] setCycle: 0 setMotion: 0 stopUpd:)
			(DrawFeature [newAFarDude local6])
		)
		(++ local6)
	)
)

(procedure (localproc_02a8)
	(= local7 0)
	(while (< local7 (+ local10 1))
		(if (cast contains: [newASaury local7])
			([newASaury local7] dispose:)
		)
		(++ local7)
	)
	(= local7 0)
	(while (< local7 2)
		(if (cast contains: [newANearDude local7])
			([newANearDude local7] dispose:)
		)
		(if (cast contains: [newAFarDude local7])
			([newAFarDude local7] dispose:)
		)
		(++ local7)
	)
)

(procedure (localproc_0313)
	(= local1 0)
	(while (< local1 13)
		(if (cast contains: [newABrigs1 local1])
			([newABrigs1 local1] dispose:)
		)
		(if (cast contains: [newABrigs6 local1])
			([newABrigs6 local1] dispose:)
		)
		(++ local1)
	)
)

(instance aBrigs1 of Actor
	(properties
		noun '/bandit'
		description {the brigands}
		lookStr {They look as thick as ants at a picnic, and far nastier.}
		view 861
		loop 13
		signal $4800
		illegalBits $0000
		xStep 10
	)
)

(instance aBrigs6 of Actor
	(properties
		noun '/bandit'
		description {the brigands}
		lookStr {They look as thick as ants at a picnic, and far nastier.}
		yStep 5
		view 861
		loop 13
		signal $4800
		illegalBits $0000
	)
)

(instance aSaury of Actor
	(properties
		x -20
		y 125
		description {the caravan}
		view 861
		signal $4800
		xStep 1
	)
	
	(method (doit)
		(if (== x -5)
			(if (< local0 local10) (localproc_0198))
			(if (== loop 10) (localproc_016f))
			(if (== loop 8) (localproc_0146))
		)
		(if (> x 325) (self setMotion: 0 setCycle: 0 dispose:))
		(super doit:)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(cond 
					((== loop 10) (HighPrint 861 0))
					((== loop 11) (HighPrint 861 1))
					(else (HighPrint 861 2))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance aNearDude of Actor
	(properties
		x 1
		y 127
		noun '/man,ride,member'
		description {the rider}
		lookStr {One of the riders of the caravan.}
		view 861
		loop 8
		signal $4800
		xStep 1
	)
)

(instance aFarDude of Actor
	(properties
		x 1
		y 123
		noun '/man,ride,member'
		description {the rider}
		lookStr {One of the riders of the caravan.}
		view 861
		loop 8
		signal $4800
		xStep 1
	)
)

(instance lookOut of Prop
	(properties
		x 297
		y 58
		description {the caravan}
		lookStr {The plain, Boss, the plain!__The caravan's on the plain.}
		view 861
		loop 7
	)
)

(instance rm861 of Rm
	(properties
		picture 861
		style $0007
	)
	
	(method (init)
		(LoadMany 128 12 861 13)
		(Load rsPIC 2)
		(UnlockEgo)
		(= local10 (+ 2 (* gSeconds 2)))
		(= local11 (Max 1 gSeconds))
		(nearHills init:)
		(farHills init:)
		(sky init:)
		(floor init:)
		(ego
			view: 12
			setLoop: 3
			yStep: 3
			setPri: 11
			posn: 110 240
			init:
		)
		(super init:)
		(self setScript: joinGroup)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(cast contains: [newABrigs1 0])
					(== ([newABrigs1 0] x?) 250)
				)
				(localproc_00b5)
			)
			(
				(and
					(cast contains: [newABrigs1 3])
					(== ([newABrigs1 3] x?) 250)
				)
				(localproc_00b5)
			)
			(
				(and
					(cast contains: [newABrigs1 6])
					(== ([newABrigs1 6] x?) 250)
				)
				(localproc_00b5)
			)
			(
				(and
					(cast contains: [newABrigs1 9])
					(== ([newABrigs1 9] x?) 250)
				)
				(localproc_00b5)
			)
			(
				(and
					(cast contains: [newABrigs6 0])
					(== ([newABrigs6 0] y?) 110)
				)
				(localproc_00fa)
			)
			(
				(and
					(cast contains: [newABrigs6 3])
					(== ([newABrigs6 3] y?) 110)
				)
				(localproc_00fa)
			)
			(
				(and
					(cast contains: [newABrigs6 6])
					(== ([newABrigs6 6] y?) 110)
				)
				(localproc_00fa)
			)
		)
		(cond 
			((not local194))
			((-- local194))
			(else (curRoom setScript: byeScript))
		)
		(super doit:)
	)
)

(instance aBee1 of Prop
	(properties
		description {the brigand}
		lookStr {The brigands, the brigands!__Run for your lives!}
		view 861
		loop 6
	)
)

(instance aBee2 of PicView
	(properties
		description {the brigand}
		lookStr {The brigands, the brigands!__Run for your lives!}
		view 861
		loop 5
		cel 1
	)
)

(instance aBee3 of PicView
	(properties
		description {the brigand}
		lookStr {The brigands, the brigands!__Run for your lives!}
		view 861
		loop 5
		cel 2
	)
)

(instance nearHills of Feature
	(properties
		x 159
		y 85
		noun '/hill,hill'
		nsTop 72
		nsBottom 99
		nsRight 318
		description {the hills in the near distance}
		lookStr {The needle sharp hills stand in stark contrast to the desert floor.}
	)
)

(instance farHills of Feature
	(properties
		x 159
		y 59
		noun '/hill'
		nsTop 47
		nsBottom 72
		nsRight 318
		description {the distant mountains}
		lookStr {The distant mountains seem to go on forever.}
	)
)

(instance sky of Feature
	(properties
		x 159
		y 23
		noun '/sky'
		nsBottom 47
		nsRight 318
		description {the sky}
		lookStr {The crisp, clear morning sky makes you feel good to be alive.}
	)
)

(instance floor of Feature
	(properties
		x 158
		y 117
		noun '/ground,(floor<desert)'
		nsTop 103
		nsBottom 131
		nsRight 317
		description {the dry desert floor}
		lookStr {The dry, dusty desert floor looks well traveled through this narrow pass.}
	)
)

(instance joinGroup of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 110 156 self)
			)
			(1
				(ego setPri: 10 setMotion: MoveTo 110 213 self)
			)
			(2 (= seconds 2))
			(3
				(ego
					view: 13
					xStep: 1
					yStep: 1
					setLoop: 3
					setMotion: MoveTo 76 135 self
				)
				(localproc_0198)
			)
			(4
				(ego setPri: 8 setLoop: 6 setMotion: MoveTo 88 150 self)
			)
			(5 (= seconds 3))
			(6
				(ego setMotion: MoveTo 109 126 self)
			)
			(7
				(ego
					setPri: (+ (ego priority?) 1)
					setLoop: 0
					setMotion: MoveTo 330 126
				)
				(lookOut init: setCycle: Fwd)
				(self cue:)
			)
			(8
				(gCMusic stop: number: 792 loop: 0 priority: 0 playBed:)
				(= seconds 7)
			)
			(9
				(localproc_01f1)
				(localproc_0230)
				(localproc_026c)
				(ego setCycle: 0 setMotion: 0)
				(if (>= gSeconds 1) (localproc_00b5) (localproc_00fa))
				(= local194 16)
				(= cycles 2)
			)
			(10
				(localproc_000c)
				(= seconds 2)
			)
			(11
				(localproc_0047)
				(= seconds 2)
			)
			(12
				(localproc_007e)
				(= seconds 2)
			)
			(13 (self dispose:))
		)
	)
)

(instance byeScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HighPrint 861 3)
				(= seconds 1)
			)
			(1
				(cast eachElementDo: #dispose)
				(curRoom drawPic: 2)
				(= seconds 2)
			)
			(2
				(localproc_0313)
				(localproc_02a8)
				(= seconds 2)
			)
			(3
				(curRoom newRoom: 865)
				(self dispose:)
			)
		)
	)
)
