;;; Sierra Script 1.0 - (do not remove this comment)
(script# 240)
(include sci.sh)
(use Main)
(use n001)
(use Talker)
(use Stage)
(use Class_86_0)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	rmPalaceGatesE 0
)

(local
	local0
	[newPalaceGuard 2]
	[newPalaceGuard_2 2]
	[local5 4] = [{I am Kuzay bin Bishr.} {I have been named al-Hajjaj.} {My name is Abd al-Malik.} {I am called Sadik Isfahani.}]
)
(instance palaceGuard of Guard
	(properties)
	
	(method (init param1)
		(if param1
			(= illegalBits 0)
			(super init: 1)
			(self setScript: (guardPace new:))
		else
			(super init: 0)
		)
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(not local0)
				(< (self distanceTo: ego) 30)
				(not modelessDialog)
			)
			(Say self 240 0)
			(= local0 1)
		)
	)
	
	(method (showSelf)
		(Say self [local5 nameNum])
	)
	
	(method (showText param1)
		(switch param1
			(13 (Say self 240 1))
			(11 (Say self 240 2))
			(else  (super showText: param1))
		)
	)
	
	(method (endTalk &tmp temp0)
		(super endTalk:)
		(if (self script?)
			((self script?) changeState: (script state?))
		)
	)
)

(instance rmPalaceGatesE of Stage
	(properties
		picture 240
		south 335
		bottomFromX 160
		bottomFromY 250
		bottomExit 4
		bottomToX 160
		bottomToY 188
	)
	
	(method (init)
		(LoadMany 128 460 294 295)
		(ego init:)
		(proc1_19)
		(super init:)
		(DrawFeature leftDoor rightDoor)
		(if (== elementalsStatus 3) (= global168 50))
		(if (not global292) (= global292 808))
		(cond 
			(
				(and
					(<= 0 currentTimeZone)
					(<= currentTimeZone 4)
					(!= elementalsStatus 3)
				)
				((= [newPalaceGuard 0] (palaceGuard new:))
					nameNum: 0
					posn: 204 112
					init: 0
				)
				((= [newPalaceGuard 1] (palaceGuard new:))
					nameNum: 1
					posn: 120 112
					init: 0
				)
				((= [newPalaceGuard_2 0] (palaceGuard new:))
					nameNum: 2
					posn: 30 144
					init: 1
				)
				((= [newPalaceGuard_2 1] (palaceGuard new:))
					nameNum: 3
					posn: 295 156
					loop: 1
					init: 1
				)
			)
			((== elementalsStatus 3) ((ScriptID 241 0) init:) (= gGDftSC gAllSC))
			(else (= gGDftSC gAllSC))
		)
		(Bset 132)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/castle,courtyard,courtyard')
				)
				(HighPrint 240 3)
			)
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(if
					(and
						(< (ego y?) 145)
						(== gGDftSC gAllSC)
						(ego has: 16)
					)
					(HighPrint 240 4)
				else
					(pEvent claimed: 0)
				)
			)
		)
	)
)

(instance guardPace of Script
	(properties)
	
	(method (init param1)
		(if (> (param1 x?) 160) (= start 1))
		(super init: param1 &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client setMotion: MoveTo 295 (client y?) self)
			)
			(1
				(client setMotion: MoveTo 30 (client y?) self)
			)
			(2 (self changeState: 0))
		)
	)
)

(instance leftDoor of PicView
	(properties
		x 133
		y 109
		noun '/door'
		description {the gate}
		lookStr {The doors appear copper clad, judging from the color of them.}
		view 460
		loop 1
		priority 7
		signal $0010
	)
	
	(method (init)
		(if isNightTime (= palette 2) else (= palette 1))
		(super init:)
	)
)

(instance rightDoor of PicView
	(properties
		x 189
		y 109
		noun '/gate'
		description {the right side of the gate}
		lookStr {The doors appear copper clad, judging from the color of them.}
		view 460
		loop 2
		priority 7
		signal $0010
	)
	
	(method (init)
		(if isNightTime (= palette 2) else (= palette 1))
		(super init:)
	)
)
