;;; Sierra Script 1.0 - (do not remove this comment)
(script# 170)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use TopWindow)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rmPractice 0
	printResponses 1
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6 =  3
	local7
	local8
	[local9 399]
	local408
	local409
	local410
	local411
	local412
	local413
	[local414 249]
)
(instance rmPractice of Rm
	(properties
		picture 170
		style $0011
	)
	
	(method (init)
		(super init: &rest)
		(if (== currentDay 16)
			(AddToScore 662 5 0)
			(= local412 1)
			(= local411 (ScriptID 175 0))
			(= local410 {Rakeesh:})
			(DrawFeature uhura1)
			(TopWindow color: 14 back: 0)
		else
			(AddToScore 663 5 0)
			(= local412 0)
			(= local411 (ScriptID 171 0))
			(= local410 {Uhura:})
			(if (not (== currentDay 3)) (simba init:))
			(TopWindow color: 0 back: 11)
		)
		(self setScript: printResponses)
		(Bset 159)
		(local411
			barMessage: 0
			opponent: (ScriptID 32 0)
			initCombat:
		)
		((ScriptID 32 0)
			barMessage: 0
			posn: 142 142
			setPri: 10
			opponent: local411
			initCombat:
		)
		(= gGDftSC rm170Check)
	)
	
	(method (notify param1 &tmp temp0 newEvent temp2)
		(= temp0 1)
		(= local408 param1)
		(UnlockEgo)
		(while ((= newEvent (Event new:)) type?)
			(newEvent dispose:)
		)
		(newEvent dispose:)
		(if (curRoom script?) ((curRoom script?) dispose:))
		(if (== currentDay 16)
			(= local8
				{You are good, very good.__Soon you will be a master with your sword.__However, the real battle is not always won by a swing or a thrust.__To fight with Honor is not always easy.__Sometimes the Way of Honor will seem foolish to those that have none.__Nevertheless, without Honor, there is no victory.__With Honor, there is no real defeat.}
			)
		else
			(switch param1
				(59 (HighPrint 170 0))
				(60
					(if (< local2 local3)
						(= local8
							(switch global314
								(0
									{You need to defend better.__You hit pretty often, but you get hit too often.}
								)
								(1
									{Don't get into combat with Scorpion until you dodge better.}
								)
								(2
									{You getting much better, but you still be not defending enough.}
								)
								(else 
									{Do not let me touch you with my spear the next time.__I will be plenty mad if some monster tears you to shreds because you do not dodge enough.}
									(= global314 0)
								)
							)
						)
					else
						(= local8
							(switch global314
								(0
									{Enough for now.__You look pretty winded.__We go back to Hall.}
								)
								(1
									{You got a good swing.__My shield arm is sore.}
								)
								(2
									{That time, we both got workout.__Pretty soon, I be needing rest.}
								)
								(else 
									{You be getting past my shield many times now.__You be getting good.}
									(= global314 0)
								)
							)
						)
					)
					(= [skills 17] 10)
				)
				(57
					(= local8
						(switch global314
							(0
								{Brigands in the desert better watch out for you.__They be in big trouble.}
							)
							(1
								{The TerrorSaurus who tries to eat you will be dead meat first.}
							)
							(2
								{You can take on a pack of Jackalmen now.}
							)
							(3
								{The Ghoulyman who tries to get you now will be sorry.}
							)
							(4
								{That be enough for now.__Soon you be giving me lessons.}
							)
							(5
								{Either I be out of shape from Simba or you be getting too good for me plenty soon.}
							)
							(else 
								{You very fast learner.__I think maybe you be plenty tough enough now.}
								(= global314 0)
							)
						)
					)
				)
				(58
					(= local8
						{That be enough for today.__Soon you be giving me lessons.}
					)
				)
				(else  (= temp0 0))
			)
		)
		(++ global314)
		(local411 health: 0 endCombat: setScript: monsterToNormal)
		((ScriptID 32 0) endCombat: setScript: returnToNormal)
		(return temp0)
	)
)

(instance simba of Prop
	(properties
		x 104
		y 91
		view 168
		loop 11
		signal $0001
	)
)

(instance uhura1 of View
	(properties
		x 104
		y 91
		view 162
		loop 4
		signal $0001
	)
)

(instance printResponses of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(= local4 1)
		(= local2 (= local3 0))
		(= local0 (= local1 ((ScriptID 32 0) loop?)))
		(= local409 (= local7 (local411 loop?)))
	)
	
	(method (doit)
		(super doit:)
		(= local0 ((ScriptID 32 0) loop?))
		(= local409 (local411 loop?))
		(if (>= local5 local6)
			(= local5 0)
			(= local6 (Random 3 5))
			(= local4
				(cond 
					((and local4 (>= local2 2)) 0)
					((and (not local4) (< local2 local3)) 1)
				)
			)
			(self cue:)
		)
		(if (!= local0 local1)
			(cond 
				((== ((ScriptID 32 0) loop?) 1) (++ local3) (++ local5))
				((OneOf ((ScriptID 32 0) loop?) 9 10 11) (++ local2))
			)
			(= local1 local0)
		)
		(if (!= local409 local7)
			(if (== (local411 loop?) 1)
				(++ local5)
				(if (< (-- local3) 0) (= local3 0))
			)
			(= local7 local409)
		)
	)
	
	(method (changeState newState)
		(asm
			lap      newState
			aTop     state
			push    
			dup     
			ldi      0
			eq?     
			bnt      code_04b7
			ldi      0
			jmp      code_0680
code_04b7:
			dup     
			ldi      1
			eq?     
			bnt      code_04f9
			lsg      currentDay
			ldi      16
			eq?     
			bnt      code_04e0
			+ag      global313
			push    
			ldi      2
			ge?     
			bnt      code_04d5
			ldi      0
			sag      global313
code_04d5:
			pushi    #changeState
			pushi    1
			pushi    3
			self     6
			jmp      code_0680
code_04e0:
			+ag      global313
			push    
			ldi      9
			ge?     
			bnt      code_04ef
			ldi      0
			sag      global313
code_04ef:
			pushi    #changeState
			pushi    1
			pushi    2
			self     6
			jmp      code_0680
code_04f9:
			dup     
			ldi      2
			eq?     
			bnt      code_0638
			ldi      0
			aTop     state
			lal      local4
			bnt      code_0588
			ldi      0
			sal      local4
			pushi    3
			lsg      global313
			pushi    0
			pushi    6
			calle    OneOf,  6
			bnt      code_0524
			lofsa    {Block my spear or get out of the way.__If it be scorpion's tail, you be dead.}
			jmp      code_061e
code_0524:
			pushi    3
			lsg      global313
			pushi    1
			pushi    7
			calle    OneOf,  6
			bnt      code_053b
			lofsa    {Dodge!__Don't take damage, get out of the way.}
			jmp      code_061e
code_053b:
			pushi    3
			lsg      global313
			pushi    2
			pushi    8
			calle    OneOf,  6
			bnt      code_0552
			lofsa    {Move out of the way more.__You got feet, use them.}
			jmp      code_061e
code_0552:
			pushi    3
			lsg      global313
			pushi    3
			pushi    9
			calle    OneOf,  6
			bnt      code_056a
			lofsa    {Don't rely on your weapon to save you. Use your body to avoid damage.}
			jmp      code_061e
code_056a:
			lsg      global313
			ldi      4
			eq?     
			bnt      code_0579
			lofsa    {You let me get you with spear way too often.__If I be ghoul, you be plenty cold right now.}
			jmp      code_061e
code_0579:
			lsg      global313
			ldi      5
			eq?     
			bnt      code_061e
			lofsa    {Never stand still.__Moving target harder to hit.}
			jmp      code_061e
code_0588:
			lsg      global313
			dup     
			ldi      0
			eq?     
			bnt      code_0598
			lofsa    {TerrorSaurus is stupid but strong.__Takes a while before it knows it is dead.}
			jmp      code_061d
code_0598:
			dup     
			ldi      1
			eq?     
			bnt      code_05a5
			lofsa    {Watch my actions.__Move before I do.}
			jmp      code_061d
code_05a5:
			dup     
			ldi      2
			eq?     
			bnt      code_05b2
			lofsa    {Swing high, swing low.__Keep enemy guessing where your weapon will be.}
			jmp      code_061d
code_05b2:
			dup     
			ldi      3
			eq?     
			bnt      code_05bf
			lofsa    {Don't watch my weapon, watch my eyes.__Let them show you where I will hit and when.}
			jmp      code_061d
code_05bf:
			dup     
			ldi      4
			eq?     
			bnt      code_05cc
			lofsa    {Put your body into your thrusts.}
			jmp      code_061d
code_05cc:
			dup     
			ldi      5
			eq?     
			bnt      code_05d9
			lofsa    {Brigands don't defend well.__Keep up your attacks.}
			jmp      code_061d
code_05d9:
			dup     
			ldi      6
			eq?     
			bnt      code_05e6
			lofsa    {If I be Griffin, swing high.__If I be Ghoul, swing low.__Use best attack for monster.}
			jmp      code_061d
code_05e6:
			dup     
			ldi      7
			eq?     
			bnt      code_05f3
			lofsa    {Scorpion always wiggles tail before it strikes.__Be ready to dodge.}
			jmp      code_061d
code_05f3:
			dup     
			ldi      8
			eq?     
			bnt      code_0600
			lofsa    {Jackalmen may be cowards, but they do fight well.__Keep sword on one at a time.__Take it out as fast as possible.}
			jmp      code_061d
code_0600:
			dup     
			ldi      9
			eq?     
			bnt      code_061d
			pushi    #has
			pushi    1
			pushi    7
			lag      ego
			send     6
			bnt      code_061a
			lofsa    {Keep your shield held higher.__Easier to block spears and swords with it there.}
			jmp      code_061d
code_061a:
			lofsa    {TerrorSaurus is stupid but strong.__Takes a while before it knows it is dead.}
code_061d:
			toss    
code_061e:
			sal      local413
			bnt      code_0680
			pushi    5
			push    
			pushi    80
			lsl      local410
			pushi    35
			class    TopWindow
			push    
			calle    HighPrint,  10
			jmp      code_0680
code_0638:
			dup     
			ldi      3
			eq?     
			bnt      code_0680
			ldi      0
			aTop     state
			lsg      global313
			dup     
			eq?     
			bnt      code_0651
			lofsa    {When fighting against a sword, do not let a swing catch you off guard.__You can be disarmed that way.}
			jmp      code_0668
code_0651:
			dup     
			ldi      1
			eq?     
			bnt      code_065e
			lofsa    {Do not let yourself be distracted by thoughts.__Let yourself be one with your weapon.}
			jmp      code_0668
code_065e:
			dup     
			ldi      2
			eq?     
			bnt      code_0668
			lofsa    {Let your motion flow smoothly as you dodge.__Always remain in balance.}
code_0668:
			toss    
			sal      local413
			bnt      code_0680
			pushi    5
			push    
			pushi    80
			lsl      local410
			pushi    35
			class    TopWindow
			push    
			calle    HighPrint,  10
code_0680:
			toss    
			ret     
		)
	)
)

(instance monsterToNormal of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(local411 setCycle: Beg self)
				(if (and (cast contains: simba) (>= gSeconds 2))
					(simba cycleSpeed: 1 setCycle: Fwd)
				)
			)
			(1
				(local411 action: 0 setLoop: 0)
			)
		)
	)
)

(instance returnToNormal of Script
	(properties)
	
	(method (doit)
		(super doit: &rest)
		(if
			(and
				(== (local411 script?) monsterToNormal)
				(>= (monsterToNormal state?) 1)
				(== (self state?) 2)
			)
			(monsterToNormal dispose:)
			(= cycles 1)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					action: 0
					setCycle: (if (== ((ScriptID 32 0) loop?) 1) End else Beg) self
				)
			)
			(1
				(client
					view: (if (== (client view?) 80) 83 else 84)
					setLoop: -1
					loop: 0
					cel: (if (== (client view?) 80) 4 else 3)
					cycleSpeed: 1
					setCycle: Beg self
				)
			)
			(2 0)
			(3
				(if (and local8 (!= local408 59))
					(HighPrint local8 80 local410 35 TopWindow 103 self)
				else
					(= cycles 1)
				)
			)
			(4 (= seconds 2))
			(5 (curRoom newRoom: 160))
		)
	)
)

(instance rm170Check of Code
	(properties)
	
	(method (doit)
		(if (not local412)
			(HighPrint 170 1 80 local410 35 TopWindow)
			(SkillUsed 14 -50)
		else
			(HighPrint 170 2 80 local410 35 TopWindow)
			(SkillUsed 14 -100)
		)
		(curRoom newRoom: 160)
		(return 0)
	)
)
