;;; Sierra Script 1.0 - (do not remove this comment)
(script# 61)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Motion)
(use Actor)

(public
	rope 0
	coil 1
	ropeClimb 2
	ropeFall 3
)

(local
	gEgoX
	gEgoY
	local2
	local3
	gEgoY_2
	local5
	gEgoSignal
	gEgoIllegalBits
	local8 =  1
	local9
	local10
	local11
	local12 =  4
)
(procedure (localproc_0012)
	(if (== local10 1)
		(= local10 0)
	else
		(= local10 1)
		(= local11 190)
	)
)

(procedure (localproc_002b)
	(if (== local10 2)
		(= local10 0)
	else
		(= local10 2)
		(= local11 (Abs (- gEgoY_2 (- (ego y?) (ego z?)))))
	)
)

(instance ropeClimb of HandsOffScript
	(properties)
	
	(method (init)
		(gDirH addToFront: self)
		(gMouseH addToFront: self)
		(= gEgoSignal (ego signal?))
		(= gEgoIllegalBits (ego illegalBits?))
		(if (not global168) (= global168 100))
		(Bset 91)
		(-- magicRopeDuration)
		(super init: &rest)
	)
	
	(method (doit &tmp theCaller)
		(switch state
			(7
				(if (<= (ego z?) 4)
					(ego z: 0)
					(self cue:)
				else
					(switch local10
						(1
							(if (>= (- (ego y?) (ego z?)) local3)
								(if (> (= local11 (- local11 local12)) 0)
									(ego
										z: (+ (ego z?) local12)
										cel: (if (== (ego cel?) 3) 0 else (+ (ego cel?) 1))
									)
								else
									(= local10 0)
								)
							else
								(= gEgoSignal (ego signal?))
								(= theCaller caller)
								(= caller 0)
								(client setScript: ropeFall theCaller)
								(return)
							)
						)
						(2
							(if (> (= local11 (- local11 local12)) 0)
								(ego
									z: (- (ego z?) local12)
									cel: (if (== (ego cel?) 0) 3 else (- (ego cel?) 1))
								)
							else
								(= local10 0)
							)
						)
					)
				)
			)
			(8
				(cond 
					((<= (ego z?) 4) (ego z: 0) (self cue:))
					((> (= local11 (- local11 local12)) 0)
						(ego
							z: (- (ego z?) local12)
							cel: (if (== (ego cel?) 0) 3 else (- (ego cel?) 1))
						)
					)
				)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gDirH delete: self)
		(gMouseH delete: self)
		(Bclr 88)
		(Bclr 91)
		(if local9 (ego signal: gEgoSignal))
		(= local10 0)
		(= local11 0)
		(super dispose:)
	)
	
	(method (changeState newState &tmp temp0 temp1 temp2 temp3)
		(switch (= state newState)
			(0
				(if gGetBellows
					(self setScript: gGetBellows self)
				else
					(self cue:)
				)
			)
			(1
				(TestSkill 11 80)
				(= gEgoX (ego x?))
				(= gEgoY (ego y?))
				(= local2 (if (mod (ego loop?) 2) 1 else 0))
				(ego view: 8 loop: local2 cel: 0 setCycle: End)
				(= cycles 12)
			)
			(2
				(= temp0
					(if local2 (- (ego x?) 13) else (+ (ego x?) 13))
				)
				(cond 
					(
						(<
							(= temp3 (- (= temp1 (- (ego y?) 7)) global168))
							40
						)
						(= temp2 7)
						(= local3 (- temp1 25))
					)
					((< temp3 60) (= temp2 10) (= local3 (- temp1 55)))
					(else (= temp2 13) (= local3 (- temp1 75)))
				)
				(coil
					loop: (+ local2 2)
					posn: temp0 temp1
					init:
					setCycle: End
				)
				(rope posn: temp0 temp1 init: setCycle: CT temp2 1 self)
				(ego loop: (+ local2 5) cel: 0 setCycle: End)
			)
			(3
				(proc1_19)
				(ego
					ignoreActors: 1
					setMotion: MoveTo (coil x?) (+ (coil y?) 5) self
				)
			)
			(4 (ego setHeading: 0 self))
			(5
				(ego
					view: 6
					setLoop: 8
					cel: 0
					illegalBits: 0
					ignoreActors: 1
					setPri: (+ (ego priority?) 1)
					setCycle: End self
				)
			)
			(6
				(ego z: (+ (ego z?) 5))
				(= cycles 2)
			)
			(7
				(Bset 88)
				(theGame setCursor: normalCursor)
				(ego setLoop: 9 cel: 0 y: (- (ego y?) 9))
				(= gEgoY_2 (ego y?))
				(LockEgo)
			)
			(8
				(UnlockEgo)
				(Bclr 88)
				(if (not (ego z?)) (self cue:) else (localproc_002b))
			)
			(9
				(ego setLoop: 8 cel: 2 y: (+ (ego y?) 9))
				(= cycles 1)
			)
			(10 (ego setCycle: Beg self))
			(11
				(proc1_19)
				(ego setMotion: MoveTo gEgoX gEgoY self)
			)
			(12
				(ego view: 8 loop: (+ local2 5) setCycle: End self)
			)
			(13
				(ego cycleSpeed: 1 setCycle: Beg)
				(rope setCycle: Beg self)
				(coil setCycle: Beg)
			)
			(14
				(rope dispose:)
				(coil dispose:)
				(if (not magicRopeDuration)
					(self cue:)
				else
					(ego
						view: 8
						loop: local2
						cel: 6
						cycleSpeed: 0
						setCycle: Beg self
					)
				)
			)
			(15
				(proc1_19)
				(ego setHeading: 180 self)
				(if (not magicRopeDuration)
					(HighPrint 61 4)
					(ego use: 16)
				)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== state 7)
				(== (ego loop?) 9)
				(switch (pEvent type?)
					(evSAID
						(cond 
							((Said 'go,climb,scale,move<up') (localproc_0012))
							((Said 'go,climb,scale,move<down') (localproc_002b))
							((Said 'cease,halt') (= local10 0))
							((Said 'climb,scale,move') (HighPrint 61 0))
							((Said 'get,acquire') (HighPrint 61 1))
							((Said 'ask,talk,chat') (HighPrint 61 2))
							((Said 'look,examine') (pEvent claimed: 0))
							(else (HighPrint 61 3) (pEvent claimed: 1))
						)
					)
					(evMOUSEBUTTON
						(cond 
							((== (pEvent modifiers?) emSHIFT) (pEvent claimed: 0))
							(
								(or
									(> (Abs (- (ego x?) (pEvent x?))) 15)
									(== (pEvent modifiers?) emCTRL)
								)
								(pEvent claimed: 1)
							)
							(else
								(cond 
									(
									(< (pEvent y?) (- (- (ego y?) (ego z?)) 50))
										(= local11
											(Abs (- (pEvent y?) (- (- (ego y?) (ego z?)) 50)))
										)
										(= local10 1)
									)
									((> (pEvent y?) (- (ego y?) (ego z?)))
										(= local11
											(Abs (- (pEvent y?) (- (ego y?) (ego z?))))
										)
										(= local10 2)
									)
									(else (= local10 0))
								)
								(pEvent claimed: 1)
							)
						)
					)
					(evJOYSTICK
						(switch (pEvent message?)
							(JOY_UP (localproc_0012))
							(JOY_DOWN (localproc_002b))
							(JOY_NULL (= local10 0))
						)
						(pEvent claimed: 1)
					)
				)
			)
			(else (pEvent claimed: 1))
		)
	)
)

(instance ropeFall of HandsOffScript
	(properties)
	
	(method (init)
		(Bset 95)
		(super init: &rest)
	)
	
	(method (doit)
		(if (== state 1)
			(cond 
				((not (ego z?)) (ego y: local5) (self cue:))
				((<= (ego z?) 12) (ego z: 0))
				(else (ego z: (- (ego z?) 12)))
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bclr 88)
		(Bclr 91)
		(Bclr 95)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 6
					loop: 2
					cel: 0
					cycleSpeed: 0
					moveSpeed: 0
					setCycle: CT 5 1 self
				)
			)
			(1
				(= local5 (if register else (+ gEgoY_2 15)))
				(rope setCycle: Beg)
				(coil setCycle: Beg)
			)
			(2
				(ego setCycle: End)
				(= cycles 24)
			)
			(3
				(if (ReduceHP (/ (ego z?) 5))
					(ego loop: 3 cel: 0 cycleSpeed: 1 setCycle: End self)
				else
					(Die 1 61 5 80 {You've really made an impact})
				)
			)
			(4
				(proc1_19)
				(ego setHeading: 45 self)
			)
			(5
				(rope hide:)
				(ego
					setMotion: MoveTo (+ (coil x?) 13) (+ (coil y?) 7) self
				)
			)
			(6
				(rope dispose:)
				(coil dispose:)
				(ego
					view: 8
					loop: 1
					cel: 6
					cycleSpeed: 0
					setCycle: Beg self
				)
			)
			(7
				(= local8 1)
				(= local9 0)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance coil of Prop
	(properties
		description {the coil of rope}
		lookStr {It is your Magic Rope.}
		view 8
		loop 3
		signal $4000
		cycleSpeed 1
	)
)

(instance rope of Prop
	(properties
		description {your Magic Rope}
		lookStr {Your Magic Rope performs well.}
		view 8
		loop 4
		signal $4000
	)
)
