;;; Sierra Script 1.0 - (do not remove this comment)
(script# 701)
(include sci.sh)
(use System)

(public
	ReadStreet 0
)

(local
	[streetName 50] = [0 {Khanjar Tarik} {Marrib Darb} {Kasir Tarik} {Tarik of Kattas} {Sharki Darb} {Junub Tarik} {Rani Tarik} {Tarik of Stars} {Kital Darb} {Dambi Darb} {Naufara Darb} {Dinar Tarik} {Centime Tarik} {Mwai Tarik} {Harik Darb} {Wahir Darb} {Dahab Tarik} {Sultan Darb} {Effendi Darb} {Sahib Tarik} {Saif Darb} {Askeri Darb} {Tarik of Rafir} {Shmali Tarik} {Jamal Darb} {Hawa Darb} {Nisr Darb} {Trab Darb} {Khalsa Darb} {Zrir Darb} {Akrab Darb} {Kudra Darb} {Sahir Tarik} {Rules must be obeyed.__Follow the system} {An order from a guard is a rule} {Ignorance of the law is no excuse} {Suicide is punishable by death} {Red Sauruses may be watered on Tuesdays and Thursdays; Green Sauruses may be watered every other Wednesday} {Some men are more equal than others} {Everything not mandatory is forbidden} {All men are equal} {Women shall remain indoors and veiled at all times} {It is forbidden to be on the streets at night} {You must carry your Visa at all times} {You are being watched} {Overtime is mandatory for everyone} {This street closed by order of Khaveen} {The smuggling of water is a capital crime} {All Fed-Ex packages must by out by 2:30}]
)
(procedure (ReadStreet param1)
	(return [streetName param1])
)

(class Alley of Obj
	(properties
		streetIndex 0
		topX 0
		botX 0
		topY 0
		botY 0
		topType 0
		botType 0
		topLoc 0
		botLoc 0
		atLoc 0
		atType 0
	)
	
	(method (at param1 param2 &tmp temp0 temp1)
		(cond 
			((and (== param1 topX) (== param2 topY)) (= atType topType))
			((and (== param1 botX) (== param2 botY)) (= atType botType))
			(else (= atType 0))
		)
		(if
			(not
				(if (>= param1 (- topX 1)) (>= param2 (- topY 1)))
			)
			(if
				(not
					(if (<= param1 (+ botX 1)) (<= param2 (+ botY 1)))
				)
				(= temp0 (mod (+ param1 param2) 10))
				(cond 
					((OneOf temp0 1 4 7) (= atType (| atType $0401)))
					((OneOf temp0 2 3 9) (= atType (| atType $0402)))
					((OneOf temp0 5 6) (= atType (| atType $0403)))
				)
			)
		)
		(cond 
			((OneOf temp0 4 7) (= atType (| atType $0008)))
			((OneOf temp0 3 9) (= atType (| atType $0004)))
		)
		(= atLoc 0)
		(cond 
			((and (== param1 topX) (== param2 topY)) (= atLoc topLoc))
			((and (== param1 botX) (== param2 botY)) (= atLoc botLoc))
		)
		(return atType)
	)
	
	(method (streetName)
		(ReadStreet streetIndex)
	)
)
