;;; Sierra Script 1.0 - (do not remove this comment)
(script# 810)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use Bar)
(use Intrface)
(use Timer)
(use Game)

(public
	chAlloc 0
)

(local
	local0
	local1
	[local2 80]
)
(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 30)
		(= [lastViewedSkills temp0] [skills temp0])
		(++ temp0)
	)
)

(procedure (localproc_0028 param1 param2 param3)
	(Display
		&rest
		dsCOORD
		param1
		param2
		dsALIGN
		0
		dsFONT
		300
		dsCOLOR
		param3
		dsBACKGROUND
		15
	)
)

(procedure (localproc_0046)
	(localproc_0028
		40
		127
		statColor
		(Format @local2 810 0 local0 local1)
		106
		52
	)
	(poolBar max: local1 value: local0 draw:)
	(SetUpEgo)
)

(instance nameEdit of DEdit
	(properties
		nsTop 6
		nsLeft 58
		nsBottom 19
		nsRight 310
		font 300
		max 40
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (& state $0008)
			(if (== evJOYSTICK (pEvent type?))
				(pEvent type: 4)
				(switch (pEvent message?)
					(JOY_DOWN
						(pEvent message: 20480)
					)
					(JOY_UP (pEvent message: 18432))
				)
			)
			(if
			(and (& state $0008) (== evKEYBOARD (pEvent type?)))
				(switch (pEvent message?)
					(KEY_NUMPAD2
						(pEvent message: 9)
					)
					(KEY_UP (pEvent message: 3840))
				)
			)
		)
		(return (super handleEvent: pEvent))
	)
)

(class BoxSelector of Class_255_1
	(properties
		type $000a
		state $0001
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		key 0
		said 0
		value 0
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (= temp0 (super handleEvent: pEvent))
			(return temp0)
		)
		(if (not (& state $0008)) (return 0))
		(if (== evJOYSTICK (pEvent type?))
			(pEvent type: 4)
			(switch (pEvent message?)
				(JOY_DOWN
					(pEvent message: 20480)
				)
				(JOY_UP (pEvent message: 18432))
				(JOY_RIGHT
					(pEvent message: 19712)
				)
				(JOY_LEFT
					(pEvent message: 19200)
				)
				(else  (pEvent type: 64))
			)
		)
		(switch (pEvent type?)
			(evKEYBOARD
				(pEvent claimed: 1)
				(switch (pEvent message?)
					(KEY_UP (pEvent message: 3840))
					(KEY_NUMPAD2
						(pEvent message: 9)
					)
					(KEY_RIGHT (self incr: 5))
					(KEY_NUMPAD4 (self dec: 5))
					(KEY_EXECUTE (self incr: 1))
					(KEY_SUBTRACT (self dec: 1))
					(else  (pEvent claimed: 0))
				)
			)
		)
		(return 0)
	)
	
	(method (draw)
		(DrawCel
			805
			1
			(if (& state $0008) 0 else 1)
			nsLeft
			nsTop
			-1
		)
	)
	
	(method (incr param1)
		(if (not local0) (return))
		(if (< local0 param1) (= param1 local0))
		(if (== [skills value] 0)
			(if (< local0 15) (return))
			(= [skills value] 5)
			(= local0 (- local0 15))
		else
			(= [skills value] (+ [skills value] param1))
			(= local0 (- local0 param1))
		)
		(self select: 0)
		(= [skills 16] (GetMaxHealth))
		(= [skills 17] (GetMaxStamina))
		(= [skills 18] (GetMaxMana))
		(localproc_0046)
		((ScriptID 70 0) update:)
		(self select: 1)
	)
	
	(method (dec param1 &tmp temp0)
		(if
			(not
				(= temp0 (- [skills value] [lastViewedSkills value]))
			)
			(return)
		)
		(if (< temp0 param1) (= param1 temp0))
		(= [skills value] (- [skills value] param1))
		(if (< [skills value] 5)
			(= param1 (+ param1 [skills value]))
			(= [skills value] 0)
			(= local0 (+ local0 10))
		)
		(= local0 (+ local0 param1))
		(self select: 0)
		(= [skills 16] (GetMaxHealth))
		(= [skills 17] (GetMaxStamina))
		(= [skills 18] (GetMaxMana))
		(localproc_0046)
		((ScriptID 70 0) update:)
		(self select: 1)
	)
)

(instance strengthSel of BoxSelector
	(properties
		nsTop 26
		nsLeft 81
		nsBottom 39
		nsRight 191
	)
)

(instance intSel of BoxSelector
	(properties
		nsTop 38
		nsLeft 81
		nsBottom 51
		nsRight 191
		value 1
	)
)

(instance agilSel of BoxSelector
	(properties
		nsTop 50
		nsLeft 81
		nsBottom 63
		nsRight 191
		value 2
	)
)

(instance vitSel of BoxSelector
	(properties
		nsTop 62
		nsLeft 81
		nsBottom 75
		nsRight 191
		value 3
	)
)

(instance luckSel of BoxSelector
	(properties
		nsTop 74
		nsLeft 81
		nsBottom 87
		nsRight 191
		value 4
	)
)

(instance wpnSel of BoxSelector
	(properties
		nsTop 26
		nsLeft 205
		nsBottom 39
		nsRight 315
		value 5
	)
)

(instance parrySel of BoxSelector
	(properties
		nsTop 38
		nsLeft 205
		nsBottom 51
		nsRight 315
		value 6
	)
)

(instance dodgeSel of BoxSelector
	(properties
		nsTop 50
		nsLeft 205
		nsBottom 63
		nsRight 315
		value 7
	)
)

(instance stealthSel of BoxSelector
	(properties
		nsTop 62
		nsLeft 205
		nsBottom 75
		nsRight 315
		value 8
	)
)

(instance pickSel of BoxSelector
	(properties
		nsTop 74
		nsLeft 205
		nsBottom 87
		nsRight 315
		value 9
	)
)

(instance throwSel of BoxSelector
	(properties
		nsTop 86
		nsLeft 205
		nsBottom 99
		nsRight 315
		value 10
	)
)

(instance climbSel of BoxSelector
	(properties
		nsTop 98
		nsLeft 205
		nsBottom 111
		nsRight 315
		value 11
	)
)

(instance magicSel of BoxSelector
	(properties
		nsTop 110
		nsLeft 205
		nsBottom 123
		nsRight 315
		value 12
	)
)

(class CSDButton of DButton
	(properties
		type $0001
		state $0003
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		key 0
		said 0
		value 0
		text 0
		font 0
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (& state $0008)
			(if (== evJOYSTICK (pEvent type?))
				(pEvent type: 4)
				(switch (pEvent message?)
					(JOY_DOWN
						(pEvent message: 20480)
					)
					(JOY_UP (pEvent message: 18432))
				)
			)
			(if
			(and (& state $0008) (== evKEYBOARD (pEvent type?)))
				(switch (pEvent message?)
					(KEY_NUMPAD2
						(pEvent message: 9)
					)
					(KEY_UP (pEvent message: 3840))
				)
			)
		)
		(return (super handleEvent: pEvent))
	)
)

(instance exitButton of CSDButton
	(properties
		nsTop 156
		nsLeft 210
		text { Start Game_}
	)
)

(instance canButton of CSDButton
	(properties
		nsTop 171
		nsLeft 226
		text { Cancel_}
	)
)

(instance statDial of Dialog
	(properties
		nsBottom 189
		nsRight 319
	)
)

(instance poolBar of Bar
	(properties
		x 95
		y 132
		cel 4
	)
)

(instance chAlloc of Rm
	(properties
		picture 1
		style $0064
	)
	
	(method (init)
		(Bclr 2)
		(Load rsSCRIPT 70)
		(Load rsSCRIPT 24)
		(Load rsVIEW 805)
		(Load rsVIEW hpStatusView)
		(super init:)
		(gCMusic stop:)
		((Timer new:) setCycle: self 2)
	)
	
	(method (cue &tmp temp0 temp1 temp2 temp3 temp4 temp5)
		(asm
			lag      heroType
			sag      gHeroType
			pushi    5000
			ldi      15
			sagi     skills
			lsg      prevRoomNum
			ldi      805
			ne?     
			bnt      code_0a8b
			ldi      0
			sat      temp3
code_08b2:
			lst      temp3
			ldi      58
			lt?     
			bnt      code_08cb
			pushi    0
			lat      temp3
			sagi     global401
			push    
			lat      temp3
			sagi     invNum
			+at      temp3
			jmp      code_08b2
code_08cb:
			ldi      19
			sat      temp3
code_08cf:
			lst      temp3
			ldi      29
			le?     
			bnt      code_08e2
			pushi    0
			lat      temp3
			sagi     skills
			+at      temp3
			jmp      code_08cf
code_08e2:
			ldi      50
			sal      local0
			pushi    4000
			ldi      15
			sagi     skills
			pushi    150
			ldi      17
			sagi     invNum
			ldi      0
			sag      userName
			lsg      heroType
			dup     
			ldi      0
			eq?     
			bnt      code_0970
			pushi    70
			ldi      0
			sagi     skills
			pushi    40
			ldi      1
			sagi     skills
			pushi    60
			ldi      2
			sagi     skills
			pushi    70
			ldi      3
			sagi     skills
			pushi    50
			ldi      4
			sagi     skills
			pushi    70
			ldi      5
			sagi     skills
			pushi    60
			ldi      6
			sagi     skills
			pushi    40
			ldi      7
			sagi     skills
			pushi    0
			ldi      8
			sagi     skills
			pushi    0
			ldi      9
			sagi     skills
			pushi    50
			ldi      10
			sagi     skills
			pushi    0
			ldi      11
			sagi     skills
			pushi    0
			ldi      12
			sagi     skills
			pushi    1
			ldi      4
			sagi     invNum
			pushi    1
			ldi      15
			sagi     invNum
			pushi    1
			ldi      7
			sagi     invNum
			jmp      code_0a8a
code_0970:
			dup     
			ldi      1
			eq?     
			bnt      code_0a0d
			pushi    40
			ldi      0
			sagi     skills
			pushi    70
			ldi      1
			sagi     skills
			pushi    60
			ldi      2
			sagi     skills
			pushi    50
			ldi      3
			sagi     skills
			pushi    50
			ldi      4
			sagi     skills
			pushi    40
			ldi      5
			sagi     skills
			pushi    0
			ldi      6
			sagi     skills
			pushi    50
			ldi      7
			sagi     skills
			pushi    0
			ldi      8
			sagi     skills
			pushi    0
			ldi      9
			sagi     skills
			pushi    0
			ldi      10
			sagi     skills
			pushi    0
			ldi      11
			sagi     skills
			pushi    70
			ldi      12
			sagi     skills
			pushi    40
			ldi      19
			sagi     skills
			pushi    40
			ldi      20
			sagi     skills
			pushi    30
			ldi      21
			sagi     skills
			pushi    50
			ldi      23
			sagi     skills
			pushi    40
			ldi      24
			sagi     skills
			pushi    50
			ldi      25
			sagi     skills
			pushi    40
			ldi      26
			sagi     skills
			pushi    1
			ldi      5
			sagi     invNum
			pushi    1
			ldi      6
			sagi     invNum
			jmp      code_0a8a
code_0a0d:
			dup     
			ldi      2
			eq?     
			bnt      code_0a8a
			pushi    50
			ldi      0
			sagi     skills
			pushi    50
			ldi      1
			sagi     skills
			pushi    70
			ldi      2
			sagi     skills
			pushi    50
			ldi      3
			sagi     skills
			pushi    60
			ldi      4
			sagi     skills
			pushi    50
			ldi      5
			sagi     skills
			pushi    0
			ldi      6
			sagi     skills
			pushi    50
			ldi      7
			sagi     skills
			pushi    60
			ldi      8
			sagi     skills
			pushi    60
			ldi      9
			sagi     skills
			pushi    50
			ldi      10
			sagi     skills
			pushi    60
			ldi      11
			sagi     skills
			pushi    0
			ldi      12
			sagi     skills
			pushi    5
			ldi      5
			sagi     invNum
			pushi    1
			ldi      6
			sagi     invNum
			pushi    1
			ldi      11
			sagi     invNum
			pushi    1
			ldi      12
			sagi     invNum
			ldi      35
			sag      global133
code_0a8a:
			toss    
code_0a8b:
			pushi    5
			ldi      3
			sagi     invNum
			pushi    1
			ldi      37
			sagi     invNum
			ldi      10
			sag      currentWater
			lal      local0
			sal      local1
			pushi    0
			callb    GetMaxHealth,  0
			push    
			ldi      16
			sagi     skills
			pushi    0
			callb    GetMaxStamina,  0
			push    
			ldi      17
			sagi     skills
			pushi    0
			callb    GetMaxMana,  0
			push    
			ldi      18
			sagi     skills
			ldi      1
			lsgi     skills
			ldi      3
			mul     
			push    
			ldi      4
			lagi     skills
			add     
			push    
			ldi      4
			div     
			push    
			ldi      13
			sagi     skills
			pushi    50
			ldi      14
			sagi     skills
			pushi    0
			call     localproc_000c,  0
			pushi    #text
			pushi    1
			lea      @userName
			push    
			pushi    36
			pushi    1
			pushi    1
			lea      @userName
			push    
			callk    StrLen,  2
			push    
			lofsa    nameEdit
			send     12
			pushi    #setSize
			pushi    0
			lofsa    exitButton
			send     4
			pushi    #setSize
			pushi    0
			lofsa    canButton
			send     4
			pushi    #window
			pushi    1
			lsg      systemWindow
			pushi    110
			pushi    16
			lofsa    nameEdit
			push    
			lofsa    strengthSel
			push    
			lofsa    intSel
			push    
			lofsa    agilSel
			push    
			lofsa    vitSel
			push    
			lofsa    luckSel
			push    
			lofsa    wpnSel
			push    
			lofsa    parrySel
			push    
			lofsa    dodgeSel
			push    
			lofsa    stealthSel
			push    
			lofsa    pickSel
			push    
			lofsa    throwSel
			push    
			lofsa    climbSel
			push    
			lofsa    magicSel
			push    
			lofsa    exitButton
			push    
			lofsa    canButton
			push    
			pushi    167
			pushi    2
			pushi    1
			pushi    65535
			lofsa    statDial
			send     50
			pushi    #useWindow
			pushi    1
			pushi    0
			pushi    692
			pushi    1
			pushi    0
			pushi    102
			pushi    0
			pushi    2
			pushi    70
			pushi    0
			callk    ScriptID,  4
			send     16
			pushi    11
			pushi    810
			pushi    1
			pushi    100
			pushi    62
			pushi    109
			pushi    101
			pushi    0
			pushi    105
			pushi    300
			pushi    102
			lsg      statColorNew
			callk    Display,  22
			pushi    #max
			pushi    1
			lsl      local1
			pushi    77
			pushi    1
			lsl      local0
			pushi    102
			pushi    0
			pushi    240
			pushi    0
			lofsa    poolBar
			send     20
			pushi    13
			pushi    810
			pushi    2
			pushi    100
			pushi    165
			pushi    127
			pushi    106
			pushi    150
			pushi    101
			pushi    0
			pushi    105
			pushi    300
			pushi    102
			lsg      statColorNew
			callk    Display,  26
			pushi    0
			call     localproc_0046,  0
			pushi    0
			callb    SetUpEgo,  0
			pushi    #setCursor
			pushi    2
			lsg      normalCursor
			pushi    1
			lag      theGame
			send     8
			ldi      1
			sat      temp1
			ldi      100
			sat      temp2
code_0bea:
			lat      temp1
			bnt      code_0c96
			pushi    #doit
			pushi    0
			lofsa    statDial
			send     4
			sat      temp0
			not     
			bt       code_0c06
			lst      temp0
			lofsa    canButton
			eq?     
			bnt      code_0c40
code_0c06:
			pushi    8
			pushi    810
			pushi    3
			pushi    81
			lofsa    {Yes}
			push    
			pushi    1
			pushi    81
			lofsa    { No_}
			push    
			pushi    2
			calle    Print,  16
			sat      temp0
			push    
			ldi      1
			eq?     
			bnt      code_0c34
			ldi      0
			sat      temp1
			ldi      800
			sat      temp2
			jmp      code_0bea
code_0c34:
			ldi      0
			sat      temp1
			ldi      765
			sat      temp2
			jmp      code_0bea
code_0c40:
			pushi    1
			lea      @userName
			push    
			callk    StrLen,  2
			push    
			ldi      3
			lt?     
			bnt      code_0c5e
			pushi    2
			pushi    810
			pushi    4
			calle    Print,  4
			jmp      code_0bea
code_0c5e:
			lsl      local0
			ldi      0
			gt?     
			bnt      code_0c8f
			pushi    8
			pushi    810
			pushi    5
			pushi    81
			lofsa    {Start the Game}
			push    
			pushi    1
			pushi    81
			lofsa    {Use More Points}
			push    
			pushi    2
			calle    Print,  16
			sat      temp0
			push    
			ldi      1
			eq?     
			bnt      code_0bea
			ldi      0
			sat      temp1
			jmp      code_0bea
code_0c8f:
			ldi      0
			sat      temp1
			jmp      code_0bea
code_0c96:
			pushi    0
			calle    UnlockEgo,  0
			pushi    0
			callb    GetMaxHealth,  0
			push    
			ldi      16
			sagi     skills
			pushi    0
			callb    GetMaxStamina,  0
			push    
			ldi      17
			sagi     skills
			pushi    0
			callb    GetMaxMana,  0
			push    
			ldi      18
			sagi     skills
			pushi    0
			call     localproc_000c,  0
			pushi    #lineObj
			pushi    0
			lofsa    poolBar
			send     4
			sat      temp4
			pushi    #dispose
			pushi    0
			pushi    84
			pushi    0
			lofsa    poolBar
			send     8
			pushi    1
			lst      temp4
			callk    IsObject,  2
			bnt      code_0ce4
			pushi    #delete
			pushi    0
			lat      temp4
			send     4
code_0ce4:
			pushi    0
			callb    SetUpEgo,  0
			pushi    #dispose
			pushi    0
			pushi    2
			pushi    70
			pushi    0
			callk    ScriptID,  4
			send     4
			pushi    #dispose
			pushi    0
			lofsa    statDial
			send     4
			pushi    #dispose
			pushi    0
			lag      addToPics
			send     4
			ldi      12
			lagi     skills
			sat      temp5
			lsg      prevRoomNum
			ldi      805
			ne?     
			bnt      code_0d47
			lsg      heroType
			ldi      2
			ne?     
			bnt      code_0d2d
			ldi      9
			lagi     skills
			bnt      code_0d2d
			pushi    1
			ldi      10
			sagi     invNum
			ldi      20
			sag      global133
code_0d2d:
			lat      temp5
			bnt      code_0d47
			lsg      heroType
			ldi      1
			ne?     
			bnt      code_0d47
			lst      temp5
			ldi      26
			sagi     skills
			push    
			ldi      25
			sagi     skills
code_0d47:
			ldi      12
			lagi     skills
			bnt      code_0d7f
			ldi      23
			lagi     skills
			not     
			bnt      code_0d5f
			lst      temp5
			ldi      23
			sagi     skills
code_0d5f:
			ldi      24
			lagi     skills
			not     
			bnt      code_0d6f
			lst      temp5
			ldi      24
			sagi     skills
code_0d6f:
			ldi      19
			lagi     skills
			not     
			bnt      code_0d7f
			lst      temp5
			ldi      19
			sagi     skills
code_0d7f:
			lst      temp2
			ldi      100
			eq?     
			bnt      code_0db0
			pushi    1
			pushi    2
			calle    Bset,  2
			ldi      1
			sag      currentDay
			pushi    2
			pushi    8
			pushi    0
			calle    SetGameTime,  4
			ldi      0
			sag      elementalsStatus
			lsg      heroType
			ldi      0
			eq?     
			bnt      code_0dac
			ldi      0
			sag      paladinPoints
			jmp      code_0db0
code_0dac:
			ldi      12
			sag      paladinPoints
code_0db0:
			pushi    #drawPic
			pushi    1
			pushi    1
			pushi    298
			pushi    1
			lst      temp2
			lag      curRoom
			send     12
			ret     
		)
	)
)
