;;; Sierra Script 1.0 - (do not remove this comment)
(script# 86)
(include sci.sh)
(use Main)
(use n001)
(use Talker)
(use StopWalk)
(use Motion)
(use Actor)


(local
	[local0 33] = [1 2 3 0 4 5 6 7 8 9 10 11 12 0 13 14 15 0 16 17 18 19 20 21 22 23 24 25 26 27 28 0 29]
	[local33 4] = [42 '//bazaar']
)
(class Class_86_0
	(properties
		client 0
		mouth 0
		doesMove 0
	)
	
	(method (new)
		(Clone self)
	)
	
	(method (init theClient param2 &tmp temp0)
		(= doesMove (if (>= argc 2) param2 else 0))
		(= client theClient)
		(client
			view: (if doesMove 294 else 295)
			loop: (if doesMove 2 else 7)
			tLoop: -1
			color: 0
			back: 15
			msgFile: 294
			myName: '//guard,man'
			title: {Guard:}
			description: {a local guard}
			lookStr: {He is one of the local guards.}
		)
		((= mouth (Prop new:))
			name: {guardMouth}
			view: 295
			stopUpd:
			init:
			hide:
		)
		(if doesMove
			(client setCycle: StopWalk 295)
		else
			(client stopUpd:)
		)
	)
	
	(method (startTalking &tmp temp0 temp1 temp2)
		(if doesMove
			(client setMotion: 0 view: 295)
			(FaceObject client ego)
		)
		(switch (client loop?)
			(3 (return))
			(0
				(= temp0 5)
				(= temp1 5)
				(= temp2 38)
			)
			(1
				(= temp0 6)
				(= temp1 -2)
				(= temp2 38)
			)
			(else 
				(= temp0 4)
				(= temp1 -1)
				(= temp2 39)
			)
		)
		(mouth
			loop: temp0
			x: (+ (client x?) temp1)
			y: (client y?)
			z: temp2
			signal: 16384
			setCycle: Fwd
			show:
		)
	)
	
	(method (stopTalking)
		(mouth setCycle: 0 stopUpd: hide:)
	)
	
	(method (dispose)
		(mouth dispose:)
		(DisposeClone self)
	)
	
	(method (atGen param1)
		(return [local0 param1])
	)
	
	(method (atSpec param1)
		(return [local33 param1])
	)
	
	(method (respond param1 param2)
		(return
			(if (== param2 32)
				(client showSelf:)
				(return 1)
			else
				(return 0)
			)
		)
	)
)

(class Guard of Talker
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 0
		back 15
		msgFile 0
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
		nameNum 0
		guardCode 0
	)
	
	(method (init param1)
		((= guardCode (Class_86_0 new:)) init: self param1)
		(super init:)
	)
	
	(method (dispose)
		(guardCode dispose:)
		(super dispose:)
	)
	
	(method (respond param1 param2)
		(if (not (guardCode respond: param1 param2))
			(super respond: param1 param2 &rest)
		)
	)
	
	(method (atSpec param1)
		(guardCode atSpec: param1)
	)
	
	(method (atGen param1)
		(guardCode atGen: param1)
	)
	
	(method (messages)
		(super messages: &rest)
		(guardCode startTalking:)
	)
	
	(method (endTalk)
		(super endTalk:)
		(guardCode stopTalking:)
	)
)
