;;; Sierra Script 1.0 - (do not remove this comment)
(script# 947)
(include sci.sh)
(use ProjClient)
(use User)
(use System)


(class DelayedEvent of Event
	(properties
		client 0
		state $0000
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
	)
	
	(method (perform param1 param2 &tmp superPerform)
		(= superPerform (super perform:))
		(if argc
			(superPerform client: param1)
			(if (>= argc 2)
				(superPerform
					type: (param2 type?)
					message: (param2 message?)
					modifiers: (param2 modifiers?)
					y: (param2 y?)
					x: (param2 x?)
					claimed: (param2 claimed?)
				)
			else
				(GetEvent 32767 superPerform)
			)
		)
		(return superPerform)
	)
	
	(method (changeState)
		(if lastSeconds (lastSeconds indexOf: self))
		(self new:)
	)
)

(class GoToDlyEvt of ProjScript
	(properties
		client 0
		state $0000
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
	)
	
	(method (perform)
		(= register (User input?))
		(= script (User alterEgo?))
		(User verbMessager: 0 getInput: 0)
		(super perform: &rest)
	)
	
	(method (changeState)
		(User verbMessager: register getInput: script)
		(Parse (User prompt?) self)
		(super changeState: &rest)
	)
)
