;;; Sierra Script 1.0 - (do not remove this comment)
(script# 120)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Flame)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rmChanger 0
)

(local
	local0
	[local1 3] = [1000 2000 1500]
	[local4 3] = [1000 2000 1500]
	[local7 3] = [53 57 56]
	[local10 3] = [{teapot} {bowl} {silver dagger}]
	local13 =  -1
	local14
	theInvNum
	[local16 38] = [0 20 21 22 1 1 1 1 1 1 1 23 24 1 25 26 1 1 27 28 29 30 31 32 33 34 1 1 1 35 1 1 36 1 1 1 1 1]
	[local54 42] = [2 '//relation,relationship,couple' 3 '//favor' 4 '//night,evening' 5 '//jackal,dog' 6 '//goat,sheep' 7 '//need' 8 '//change,barter,rate' 9 '//benefit,loot' 10 '//dinar' 11 '//cent,brass' 12 '//evaluate' 13 '//ferrari,guildmaster,(man<fat)' 14 '//date,sex' 15 '//kiss,love' 18 '//job,labor,errand' 19 '//guard,man,guard,servant,friend,franc' 37 '//grease' 38 '//implement,(implement<thief)' 39 '//safe,armorer,(shop<weapon),someone' 40 '//anvil,trap']
	[local96 201]
	local297
)
(procedure (localproc_014e param1)
	(Say dinarzad param1 125 (Random 41 43))
)

(procedure (localproc_13c6 param1)
	(if (== [local4 param1] [local1 param1])
		(Format
			@local96
			120
			57
			[local10 param1]
			(/ [local1 param1] 50)
			(/ (+ [local4 param1] 50) 100)
		)
	else
		(Format
			@local96
			120
			58
			[local10 param1]
			(/ [local1 param1] 50)
			(/ [local1 param1] 100)
			(/ (+ [local4 param1] 50) 100)
		)
	)
	@local96
)

(class DelayedEvent of Event
	(properties
		type $0000
		message 0
		modifiers $0000
		y 0
		x 0
		claimed 0
		client 0
	)
	
	(method (new param1 param2 &tmp newSuper)
		(= newSuper (super new:))
		(if argc
			(newSuper client: param1)
			(if (>= argc 2)
				(newSuper
					type: (param2 type?)
					message: (param2 message?)
					modifiers: (param2 modifiers?)
					y: (param2 y?)
					x: (param2 x?)
					claimed: (param2 claimed?)
				)
			else
				(GetEvent 32767 newSuper)
			)
		)
		(return newSuper)
	)
	
	(method (cue)
		(if client (client handleEvent: self))
		(self dispose:)
	)
)

(class GoToDlyEvt of DelayedEvent
	(properties
		type $0000
		message 0
		modifiers $0000
		y 0
		x 0
		claimed 0
		client 0
	)
	
	(method (new)
		(UnlockEgo)
		(super new: &rest)
	)
	
	(method (cue)
		(LockEgo)
		(Parse (User inputLineAddr?) self)
		(super cue: &rest)
	)
)

(instance rmChanger of Rm
	(properties
		picture 120
		style $0006
	)
	
	(method (init)
		(LoadMany 128 120 125 355)
		(Load rsTEXT 125)
		(Load rsSCRIPT 947)
		(if
		(or (== currentTimeZone 7) (== currentTimeZone 0))
			(= gGDftSC gAllSC)
			(= defaultPalette 2)
		else
			(= gGDftSC moneySpells)
		)
		(super init:)
		(proc1_19)
		(sconce1
			cel: (if
			(or (== currentTimeZone 7) (== currentTimeZone 0))
				1
			else
				0
			)
			init:
		)
		(sconce2
			cel: (if
			(or (== currentTimeZone 7) (== currentTimeZone 0))
				1
			else
				0
			)
			init:
		)
		(if
		(or (== currentTimeZone 7) (== currentTimeZone 0))
			(shutter init:)
		else
			(dinarzad init:)
			(theGuard init:)
			(flame1 init: setCycle: Fwd)
			(flame2 init: setCycle: Fwd)
		)
		(grill init:)
		(addToPics doit:)
		(gMouseH add: self)
		(self setScript: comeIn)
	)
	
	(method (doit)
		(cond 
			(script (script doit:))
			((ego edgeHit?) (self newRoom: 704))
		)
	)
	
	(method (dispose)
		(gMouseH delete: self)
		(if (== defaultPalette 2) (= defaultPalette 1))
		(DisposeScript 947)
		(= gTopExit 2)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine/alley,passage')
				(if
				(or (== currentTimeZone 7) (== currentTimeZone 0))
					(HighPrint 120 0)
				else
					(HighPrint 120 1)
				)
			)
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard,area,culdesac,alcove')
				)
				(if
				(or (== currentTimeZone 7) (== currentTimeZone 0))
					(HighPrint 120 2)
				else
					(HighPrint 120 3)
					(if (not (Btst 9)) (HighPrint 120 4))
				)
			)
		)
	)
)

(instance dinarzad of Talker
	(properties
		x 179
		y 85
		description {the Money Changer}
		lookStr {The woman is very attractive with her dark, curly hair and lovely figure.__She smiles invitingly at you.}
		view 125
		signal $6800
		illegalBits $0000
		tLoop 1
		talkSpeed 1
		myName '//dinarzad,woman,changer'
		title {Dinarzad:}
		color 1
		back 13
		msgFile 125
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(cond 
			(
				(and
					(>= local13 0)
					(or (Said 'ask/cost') (Said 'ask//cost'))
				)
				(Say self (localproc_13c6 local13))
			)
			(
				(and
					(not
						(if (and (== (ego x?) 165) (== (ego y?) 113))
							(== (ego heading?) 45)
						)
					)
					(or
						(Said 'ask[/dinarzad]')
						(Said
							'barter,change,gave,display,bargain,sell,fence,(hand[<above]),tell'
						)
					)
				)
				(= local0 (GoToDlyEvt new: self pEvent))
				(self setScript: goToHer local0)
			)
			((Said 'tell')
				(if (TestSkill 13 50)
					(Say dinarzad 120 7)
				else
					(Say dinarzad 120 8)
				)
			)
			((Said 'ask//insertion') (Say self 120 9))
			((super handleEvent: pEvent))
			(
				(Said
					'look,examine/hair,boob,ass,body,face,eye,lip,cheek'
				)
				(HighPrint 120 10)
			)
			((Said 'kiss/girl,woman,dinarzad,changer') (HighPrint 120 11))
			((Said 'thank') (SayThanks self 120 12))
			(
			(or (Said 'gave/bouquet') (Said 'gave//bouquet'))
				(GiveFlowers self 120 13)
				(= temp0 0)
				(while (< temp0 3)
					(if
						(>
							(= temp1 (/ (* 11 [local1 temp0]) 10))
							[local4 temp0]
						)
						(= [local4 temp0] temp1)
					)
					(++ temp0)
				)
			)
			(
			(Said 'kill,beat,attack,chop,grope,grab,grab,feel') (HighPrint 120 14))
			((Said 'made,gave,display/sign[<thief]')
				(cond 
					((Btst 11) (MakeThiefSign) (Say self 120 15))
					((MakeThiefSign)
						(AddToScore 694 3 2)
						(Bset 11)
						(= dayDinarzadOffersJob (+ currentDay 1))
						(Say self 120 16 120 17 120 18)
					)
					((Random 0 1) (Say self 120 19))
					(else (Say self 120 20))
				)
			)
			((Said 'barter,gave,change,sell,(hand[<above])>')
				(cond 
					((Said '/alm,alm,gold') (self setScript: changeLoot))
					(
						(and
							(ego has: 53)
							(Said '/item,samovar,(pan,set,service<tea)')
						)
						(self setScript: sheBends self 0)
					)
					((and (ego has: 56) (Said '/dagger')) (self setScript: sheBends self 2))
					((and (ego has: 57) (Said '/bowl')) (self setScript: sheBends self 1))
					(else (pEvent claimed: 1) (Say self 120 21))
				)
			)
			((Said 'bargain>')
				(cond 
					(
						(or
							(Said '/item,samovar,(pan,set,service<tea)')
							(Said '//item,samovar,(pan,set,service<tea)')
						)
						(= local13 0)
					)
					((or (Said '/dagger') (Said '//dagger')) (= local13 2))
					((or (Said '/bowl') (Said '//bowl')) (= local13 1))
				)
				(pEvent claimed: 1)
				(cond 
					(
					(or (== local13 -1) (not (ego has: [local7 local13]))) (= local13 -1) (Say self 120 22))
					((!= [local1 local13] [local4 local13]) (Say self 120 23 (localproc_13c6 local13)))
					((TestSkill 13 100)
						(= [local4 local13] (/ (* 12 [local1 local13]) 10))
						(Say self 120 24 (localproc_13c6 local13))
					)
					(else
						(= [local4 local13]
							(+ [local1 local13] (/ (* 5 [local1 local13]) 100))
						)
						(Say self 120 25 (localproc_13c6 local13))
					)
				)
			)
			((Said 'display>')
				(cond 
					(
						(and
							(ego has: 53)
							(Said '/item,samovar,(pan,set,service<tea)')
						)
						(= local13 0)
						(Say self (localproc_13c6 local13))
					)
					((and (ego has: 56) (Said '/dagger')) (= local13 2) (Say self (localproc_13c6 local13)))
					((and (ego has: 57) (Said '/bowl')) (= local13 1) (Say self (localproc_13c6 local13)))
					((Said '/alm,gold,dinar,cent,loot') (Say self 120 26))
					(else (pEvent claimed: 1) (Say self 120 27))
				)
			)
			((Said 'affirmative,affirmative')
				(switch local14
					(0 (HighPrint 120 28))
					(3 (localproc_014e))
					(4 (Say dinarzad 125 18))
					(5
						(if
						(or (ego has: 53) (ego has: 57) (ego has: 56))
							(HighPrint 120 29)
						else
							(HighPrint 120 30)
						)
					)
					(else  (Say self 120 31))
				)
			)
			((Said 'n')
				(switch local14
					(1 (Say self 120 32))
					(4 (Say self 120 32))
					(2 (Say self 120 33))
					(5 (Say self 120 34))
					(else  (HighPrint 120 28))
				)
			)
		)
		(if (== (pEvent type?) evSAID) (= local14 0))
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(6 (HighPrint 120 5))
			(9
				(self setScript: goToHer)
				(Say self 120 6)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local54 param1])
	)
	
	(method (atGen param1)
		(return [local16 param1])
	)
	
	(method (showText param1)
		(cond 
			((== param1 18)
				(cond 
					((not (Btst 12)) (= param1 16))
					((Btst 26) (= param1 17))
					((Btst 13) (= param1 39))
				)
			)
			(
				(and
					(or (== param1 39) (== param1 40))
					(not (Btst 39))
				)
				(= param1 0)
			)
		)
		(super showText: param1)
	)
)

(instance grill of Feature
	(properties
		x 184
		y 41
		noun '/grate,iron,grillwork,(labor<grate)'
		nsTop 31
		nsLeft 168
		nsBottom 51
		nsRight 200
		description {intricate iron grillwork}
		lookStr {The iron grillwork looks intricately wrought.}
	)
)

(instance theGuard of PicView
	(properties
		x 83
		y 110
		noun '/guard'
		description {the dangerous looking guard}
		view 355
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint 120 35)
			(HighPrint 120 36)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance sconce1 of PicView
	(properties
		x 140
		y 47
		noun '/grease,sconce,holder,lamp'
		description {a sconce}
		view 120
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if
			(or (== currentTimeZone 7) (== currentTimeZone 0))
				(HighPrint 120 37)
			else
				(HighPrint 120 38)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance sconce2 of PicView
	(properties
		x 234
		y 59
		noun '/grease,sconce,holder,lamp'
		description {a sconce}
		view 120
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if
			(or (== currentTimeZone 7) (== currentTimeZone 0))
				(HighPrint 120 37)
			else
				(HighPrint 120 38)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance flame1 of Flame
	(properties
		x 140
		y 41
		noun '/flame,torch'
		view 120
		loop 1
		priority 13
		signal $0010
	)
)

(instance flame2 of Flame
	(properties
		x 234
		y 53
		noun '/flame,torch'
		view 120
		loop 1
		priority 13
		signal $0010
	)
)

(instance shutter of PicView
	(properties
		x 185
		y 88
		noun '/window,shutter'
		description {a shutter}
		lookStr {The shutter covers the window.__It looks like the business is not in business at the moment.}
		view 120
		loop 3
	)
)

(instance comeIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego posn: 6 189 init: setMotion: MoveTo 77 164 self)
			)
			(1
				(if
				(or (== currentTimeZone 7) (== currentTimeZone 0))
					(self dispose:)
				else
					(dinarzad setCycle: End self)
				)
			)
			(2
				(cond 
					((and (Btst 12) (Btst 13) (not (Btst 39))) (Bset 39) (Say dinarzad self 120 39 120 40))
					((or (Btst 13) (Btst 12)) (localproc_014e self))
					(
						(and
							(Btst 11)
							(== currentDay dayDinarzadOffersJob)
							(>= currentTimeZone 4)
							(not (Btst 13))
						)
						(Bset 12)
						(Say dinarzad self 120 41 120 42 120 43 120 44)
						(= local14 4)
					)
					((Btst 10) (localproc_014e self))
					((Btst 9) (Bset 10) (= local14 2) (Say dinarzad self 120 45))
					(else (Bset 9) (= local14 1) (Say dinarzad self 120 46 120 47))
				)
			)
			(3
				(dinarzad loop: 1 cel: 0)
				(self dispose:)
			)
		)
	)
)

(instance changeLoot of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1 [temp2 50])
		(switch (= state newState)
			(0
				(if (not (= theInvNum [invNum 17]))
					(HighPrint 120 48)
				else
					(Format @temp2 120 49 theInvNum)
					(if
						(>
							(= theInvNum (GetNumber @temp2 theInvNum))
							[invNum 17]
						)
						(= theInvNum [invNum 17])
						(Format @temp2 120 50 theInvNum)
						(HighPrint @temp2)
						(self changeState: 0)
					)
				)
				(if (>= theInvNum 1)
					(dinarzad loop: 2 cel: 0 cycleSpeed: 1 setCycle: End self)
				else
					(self changeState: 5)
				)
			)
			(1 (= cycles 8))
			(2
				(dinarzad setLoop: 3 cel: 2 setCycle: Beg self)
			)
			(3
				(gMiscMusic number: 120 loop: 0 priority: 5 play:)
				(dinarzad cycleSpeed: 0)
				(AddToScore 604 7)
				(Say dinarzad self 120 51)
			)
			(4
				(ego use: 17 theInvNum)
				(if (< (= temp0 (/ theInvNum 5)) 10) (= temp0 10))
				(if (> temp0 50) (= temp0 50))
				(= theInvNum
					(/ (= temp1 (* theInvNum (- 100 temp0))) 100)
				)
				(ego get: 2 theInvNum)
				(self dispose:)
			)
			(5 (Say dinarzad self 120 52))
			(6 (self dispose:))
		)
	)
)

(instance goToHer of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 165 113 self)
			)
			(1 (ego setHeading: 45 self))
			(2 (self dispose:))
		)
	)
)

(instance sheBends of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (ego has: [local7 register]))
					(self changeState: 20)
				else
					(dinarzad loop: 2 cel: 0 cycleSpeed: 1 setCycle: End self)
				)
			)
			(1 (= cycles 6))
			(2
				(dinarzad loop: 3 cel: 2 setCycle: Beg self)
			)
			(3
				(AddToScore 695 3 2)
				(gMiscMusic number: 120 loop: 0 priority: 5 play:)
				(dinarzad cycleSpeed: 0)
				(HighPrint (Format @local96 120 53 [local10 register]))
				(ego use: [local7 register])
				(ego get: 2 (/ (+ [local4 register] 50) 100))
				(= local13 -1)
				(if (and (not (Btst 26)) (not local297))
					(= local297 1)
					(Say dinarzad self 120 54)
				else
					(= cycles 1)
				)
			)
			(4 (self dispose:))
			(20 (Say dinarzad self 120 55))
			(21 (self dispose:))
		)
	)
)

(instance moneySpells of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (OneOf param1 20 23 29)
				(return 1)
			else
				(HighPrint 120 56)
				(return 0)
			)
		)
	)
)
