;;; Sierra Script 1.0 - (do not remove this comment)
(script# 77)
(include sci.sh)
(use Main)
(use Extra)
(use Motion)
(use Actor)


(class Flame of Extra
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 1
		script 0
		cycler 0
		timer 0
		cycleType 0
		hesitation 0
		pauseCel -1
		minPause 1
		maxPause 5
		minCycles 1
		maxCycles 5
		counter 0
		state $ffff
		cycles 0
	)
	
	(method (init)
		(= signal (| signal isExtra))
		(self description: {a flickering flame} noun: '/flame')
		(super init: &rest)
	)
)

(class Fire of Prop
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 340
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $4000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		burnTime 0
	)
	
	(method (init)
		(super init: &rest)
		(= burnTime (+ (Random 40 75) (* 25 gSeconds)))
		(self loop: 8 cel: 4 cycleSpeed: 1 setCycle: Beg self)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			((< (ego distanceTo: self) 5) (= burnTime 0) (self dispose:))
			((not (-- burnTime)) (self loop: 8 cel: 0 setCycle: End self))
		)
	)
	
	(method (cue)
		(super cue:)
		(if (< burnTime 1)
			(self dispose:)
		else
			(self loop: 0 cycleSpeed: 1 setCycle: Fwd)
		)
	)
)

(class FlameSpout of Prop
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 560
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		flameTimer 0
	)
	
	(method (init)
		(self description: {a gaseous jet of flame})
		(super init:)
	)
	
	(method (doit)
		(if (and flameTimer (not (-- flameTimer)))
			(self setCycle: End self)
		)
		(if
			(and
				cel
				(not (ego script?))
				(< (ego distanceTo: self) 15)
			)
			(self ignite:)
		)
		(super doit:)
	)
	
	(method (cue)
		(if cel (self setCycle: Beg self))
	)
	
	(method (ignite)
		(return 1)
	)
)
