;;; Sierra Script 1.0 - (do not remove this comment)
(script# 977)
(include sci.sh)
(use Main)
(use Sight)
(use Motion)
(use System)


(local
	[trans1 8] = [2 6 4 0 3 5 1 7]
	[trans2 8] = [3 6 0 4 2 5 1 7]
)
(class Grooper of Code
	(properties
		client 0
		oldCycler 0
		oldMover 0
		caller 0
	)
	
	(method (doit param1 param2 param3 param4 &tmp temp0 temp1)
		(asm
			pToa     client
			not     
			bnt      code_0010
			lap      param1
			aTop     client
code_0010:
			pushi    #signal
			pushi    0
			pToa     client
			send     4
			push    
			ldi      2048
			and     
			bnt      code_002f
			pToa     caller
			bnt      code_002a
			pushi    #cue
			pushi    0
			send     4
code_002a:
			ldi      0
			aTop     caller
			ret     
code_002f:
			lsp      argc
			ldi      3
			ge?     
			bnt      code_003b
			lap      param3
			aTop     caller
code_003b:
			pushi    1
			pTos     client
			callk    NumLoops,  2
			push    
			ldi      8
			lt?     
			bnt      code_004d
			ldi      4
			jmp      code_004f
code_004d:
			ldi      8
code_004f:
			sat      temp1
			pushi    #contains
			pushi    1
			pTos     client
			lag      cast
			send     6
			not     
			bt       code_006b
			lsp      argc
			ldi      4
			ge?     
			bnt      code_00b7
			lap      param4
			bnt      code_00b7
code_006b:
			pushi    6
			pushi    1
			lst      temp1
			ldi      4
			eq?     
			bnt      code_007b
			ldi      2
			jmp      code_007d
code_007b:
			ldi      1
code_007d:
			push    
			pushi    2
			pushi    #heading
			pushi    0
			pToa     client
			send     4
			push    
			pushi    180
			lat      temp1
			div     
			add     
			push    
			pushi    360
			calle    umod,  4
			push    
			pushi    360
			lat      temp1
			div     
			div     
			mul     
			lsli     trans2
			pToa     client
			send     6
			pToa     caller
			bnt      code_00b2
			pushi    #cue
			pushi    0
			send     4
code_00b2:
			ldi      0
			aTop     caller
			ret     
code_00b7:
			pushi    #loop
			pushi    0
			pToa     client
			send     4
			lali     trans1
			sat      temp0
			pToa     oldMover
			bnt      code_00d0
			pushi    #dispose
			pushi    0
			send     4
			ldi      0
			aTop     oldMover
code_00d0:
			pushi    1
			pTos     oldCycler
			callk    IsObject,  2
			bnt      code_0115
			pushi    #isMemberOf
			pushi    1
			class    Grycler
			push    
			pToa     oldCycler
			send     6
			bt       code_010a
			pushi    1
			pushi    #cycler
			pushi    0
			pToa     client
			send     4
			push    
			callk    IsObject,  2
			bnt      code_0106
			pushi    #isMemberOf
			pushi    1
			class    Grycler
			push    
			pushi    #cycler
			pushi    0
			pToa     client
			send     4
			send     6
code_0106:
			not     
			bnt      code_0115
code_010a:
			pushi    #dispose
			pushi    0
			pToa     oldCycler
			send     4
			ldi      0
			aTop     oldCycler
code_0115:
			pToa     oldCycler
			not     
			bnt      code_0125
			pushi    #cycler
			pushi    0
			pToa     client
			send     4
			aTop     oldCycler
code_0125:
			pushi    1
			pushi    #cycler
			pushi    0
			pToa     client
			send     4
			push    
			callk    IsObject,  2
			bnt      code_0168
			pushi    #isMemberOf
			pushi    1
			class    Grycler
			push    
			pushi    #cycler
			pushi    0
			pToa     client
			send     4
			send     6
			bnt      code_0168
			pushi    #cycler
			pushi    0
			pToa     client
			send     4
			push    
			pToa     oldCycler
			eq?     
			bnt      code_015b
			ldi      0
			aTop     oldCycler
code_015b:
			pushi    #dispose
			pushi    0
			pushi    #cycler
			pushi    0
			pToa     client
			send     4
			send     4
code_0168:
			pushi    #mover
			pushi    0
			pToa     client
			send     4
			aTop     oldMover
			pushi    #cycler
			pushi    1
			pushi    0
			pushi    59
			pushi    1
			pushi    0
			pushi    252
			pushi    1
			pushi    0
			pushi    139
			pushi    3
			class    Grycler
			push    
			pushSelf
			lst      temp0
			pToa     client
			send     28
			ret     
		)
	)
	
	(method (dispose)
		(if (IsObject oldCycler)
			(oldCycler dispose:)
			(= oldCycler 0)
		)
		(if (IsObject oldMover)
			(oldMover dispose:)
			(= oldMover 0)
		)
		(if client (client looper: 0))
		(super dispose:)
	)
	
	(method (cue &tmp theCaller)
		(if (not (IsObject (client mover?)))
			(client mover: oldMover)
		)
		(if (IsObject oldCycler) (client cycler: oldCycler))
		(= theCaller caller)
		(= caller (= oldMover (= oldCycler 0)))
		(if theCaller (theCaller cue: &rest))
	)
)

(class Grycler of Cycle
	(properties
		client 0
		caller 0
		cycleDir 1
		cycleCnt 0
		completed 0
		loopIndex 0
		numOfLoops 0
	)
	
	(method (init param1 theCaller theLoopIndex)
		(super init: param1)
		(= caller theCaller)
		(= numOfLoops (if (< (NumLoops client) 8) 4 else 8))
		(= cycleDir
			(-
				(sign
					(AngleDiff (* theLoopIndex 45) (param1 heading?))
				)
			)
		)
		(= loopIndex theLoopIndex)
		(if (self loopIsCorrect:) (self cycleDone:))
	)
	
	(method (doit)
		(client loop: (self nextCel:))
		(if (self loopIsCorrect:) (self cycleDone:))
	)
	
	(method (nextCel)
		(++ cycleCnt)
		(return
			(if
				(or
					(<= cycleCnt (client cycleSpeed?))
					(self loopIsCorrect:)
				)
				(client loop?)
			else
				(= cycleCnt 0)
				(= loopIndex
					(+ loopIndex (* cycleDir (/ 8 numOfLoops)))
				)
				(= loopIndex (umod loopIndex 8))
				[trans2 loopIndex]
			)
		)
	)
	
	(method (cycleDone)
		(= doMotionCue (= completed 1))
	)
	
	(method (loopIsCorrect)
		(return
			(<
				(Abs (AngleDiff (* loopIndex 45) (client heading?)))
				(+ (/ 180 numOfLoops) 1)
			)
		)
	)
)
