;;; Sierra Script 1.0 - (do not remove this comment)
(script# 80)
(include sci.sh)
(use Main)
(use n001)
(use Stage)
(use Feature)
(use LoadMany)
(use Actor)
(use System)

(public
	proc80_0 0
)

(procedure (proc80_0 param1 &tmp temp0)
	(asm
		lap      argc
		bnt      code_0018
		lap      param1
		jmp      code_001a
code_0018:
		lag      curRoomNum
code_001a:
		sat      temp0
		push    
		ldi      300
		ne?     
		bt       code_0034
		lsg      elementalsStatus
		ldi      1
		ne?     
		bnt      code_005c
		lsg      currentDay
		ldi      4
		ne?     
		bnt      code_005c
code_0034:
		lst      temp0
		ldi      310
		ne?     
		bnt      code_0046
		lst      temp0
		ldi      315
		ne?     
		bt       code_004e
code_0046:
		lsg      elementalsStatus
		ldi      7
		ne?     
		bnt      code_005c
code_004e:
		lst      temp0
		ldi      335
		ne?     
		bt       code_005c
		lsg      elementalsStatus
		ldi      3
		ne?     
code_005c:
		not     
		ret     
	)
)

(class Plaza of Stage
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		picture 300
		style $ffff
		horizon 82
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY -30000
		obstacles 0
		inOut 0
		edgeHit 0
		entranceScript 0
		topFromX 160
		topFromY 80
		topExit 1
		topToX 160
		topToY 100
		bottomFromX 160
		bottomFromY 250
		bottomExit 3
		bottomToX 160
		bottomToY 188
		rightFromX 330
		rightFromY 162
		rightExit 2
		rightToX 310
		rightToY 162
		leftFromX -10
		leftFromY 162
		leftExit 4
		leftToX 10
		leftToY 162
		saveIllegal 0
		saveSig 0
		whereTo 0
		merchants 0
		xIn 0
		yIn 0
		xOut 0
		yOut 0
	)
	
	(method (init)
		(if
			(and
				(<= 0 currentTimeZone)
				(<= currentTimeZone 4)
				(not (proc80_0))
			)
			(LoadMany 128 357 351 358 352 359 353)
		else
			(= gGDftSC gAllSC)
		)
		(ego init:)
		((= merchants (List new:)) add:)
		(if (not (proc80_0))
			(if
			(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
				(if (and (>= gSeconds 2) (>= global190 1))
					((ScriptID 89 1) init:)
					((ScriptID 83 0) init:)
				)
			else
				((ScriptID 89 0) init:)
			)
		)
		(super init:)
		(if (== curRoomNum 300)
			(self overlay: 305)
		else
			(self overlay: curRoomNum)
		)
		(proc1_31 topAlleyDoor)
		(if (not west)
			(DrawFeature leftDoorBlock)
		else
			(proc1_31 leftAlleyDoor)
		)
		(if (not east)
			(DrawFeature rightDoorBlock)
		else
			(proc1_31 rightAlleyDoor)
		)
	)
	
	(method (dispose)
		(merchants release: dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(HighPrint 80 0)
			)
			(else (pEvent claimed: 0))
		)
		(pEvent claimed?)
	)
	
	(method (findUnblockedDoor &tmp temp0 temp1)
		(asm
			pushi    2
			pushi    1
			pushi    4
			callk    Random,  4
			sat      temp1
			sat      temp0
			ldi      32767
			aTop     xIn
code_01ae:
			pushi    #setDoorPos
			pushi    1
			lst      temp0
			self     6
			pTos     xIn
			ldi      32767
			ne?     
			bnt      code_0205
			pushi    4
			pTos     xIn
			pTos     yIn
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			callk    GetDistance,  8
			push    
			ldi      30
			gt?     
			bnt      code_0205
			pushi    4
			pTos     xOut
			pTos     yOut
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			callk    GetDistance,  8
			push    
			ldi      30
			gt?     
			bnt      code_0205
			jmp      code_0225
			jmp      code_01ae
code_0205:
			ldi      32767
			aTop     xIn
			+at      temp0
			push    
			ldi      4
			gt?     
			bnt      code_0217
			ldi      1
			sat      temp0
code_0217:
			lst      temp0
			lat      temp1
			eq?     
			bnt      code_01ae
			ldi      0
			ret     
			jmp      code_01ae
code_0225:
			lat      temp0
			ret     
		)
	)
	
	(method (setDoorPos param1)
		(switch param1
			(1
				(if north
					(= xOut topFromX)
					(= yOut (- topFromY 12))
					(= xIn topToX)
					(= yIn (+ topToY 10))
				)
			)
			(2
				(if east
					(= xOut rightFromX)
					(= yOut rightFromY)
					(= xIn (- rightToX 10))
					(= yIn rightToY)
				)
			)
			(3
				(if south
					(= xOut bottomFromX)
					(= yOut bottomFromY)
					(= xIn bottomToX)
					(= yIn (- bottomToY 10))
				)
			)
			(4
				(if west
					(= xOut leftFromX)
					(= yOut leftFromY)
					(= xIn (+ leftToX 10))
					(= yIn leftToY)
				)
			)
		)
	)
)

(instance leftDoorBlock of PicView
	(properties
		x 4
		y 173
		shiftClick 0
		view 300
		loop 4
		priority 7
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rightDoorBlock of PicView
	(properties
		x 308
		y 164
		shiftClick 0
		view 300
		loop 3
		priority 7
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance leftAlleyDoor of Feature
	(properties
		x 5
		y 124
		noun '/door,sign,alley[<alley,bearing,street]'
		nsTop 92
		nsBottom 156
		nsRight 13
		description {an alley door}
	)
	
	(method (init)
		(switch curRoomNum
			(310
				(self
					lookStr:
						{You see a dark passage leading West.__The street sign reads "Naufara Darb," which means "Fountain Avenue."}
				)
			)
			(315
				(self
					lookStr:
						{You see a dark passage leading East.__The street sign reads "Sultan Darb," which means "Sultan's Avenue."}
				)
			)
			(335
				(self
					lookStr:
						{You see a dark passage leading South.__The street sign reads "Tarik of Stars," which means "Street of Stars."__Gosh, that one was a lot easier to translate!}
				)
			)
		)
		(super init: &rest)
	)
)

(instance rightAlleyDoor of Feature
	(properties
		x 312
		y 124
		noun '/door,sign[<alley,bearing,street]'
		nsTop 89
		nsLeft 305
		nsBottom 159
		nsRight 320
		description {an alley door}
	)
	
	(method (init)
		(switch curRoomNum
			(335
				(self
					lookStr:
						{You see a dark passage leading North.__The street sign reads "Hawa Darb," which means "Air Avenue."}
				)
			)
		)
		(super init: &rest)
	)
)

(instance topAlleyDoor of Feature
	(properties
		x 158
		y 67
		noun '/door,sign[<alley,bearing,street]'
		nsTop 38
		nsLeft 132
		nsBottom 91
		nsRight 185
		description {an alley door}
	)
	
	(method (init)
		(switch curRoomNum
			(300
				(self
					lookStr:
						{You see a dark passage leading North.__The street sign reads "Junub Tarik," which means "South Street."}
				)
			)
			(310
				(self
					lookStr:
						{You see a dark passage leading North.__The street sign reads "Shmali Tarik," which means "North Street."}
				)
			)
			(315
				(self
					lookStr:
						{You see a dark passage leading South.__The street sign reads "Junub Tarik," which means "South Street."}
				)
			)
			(330
				(self
					lookStr:
						{You see a dark passage leading East.__The street sign reads "Kital Darb," which means "Battle Avenue."}
				)
			)
			(335
				(self
					lookStr:
						{You see a dark passage leading West.__The street sign reads "Sultan Darb," which means "Sultan's Avenue."}
				)
			)
		)
		(super init: &rest)
	)
)
