;;; Sierra Script 1.0 - (do not remove this comment)
(script# 89)
(include sci.sh)
(use Main)
(use n001)
(use Talker)
(use PlazaTalker)
(use Class_86_0)
(use System)

(public
	nightPlazaGuard 0
	dayPlazaGuard 1
)

(local
	[local0 14] = [89 0 89 1 89 2 89 3 89 4 89 5 89 6]
	local14
	local15
)
(class PlazaGuard of PlazaWalker
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $2000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $0000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 0
		back 15
		msgFile 0
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
		merchantsVisited 0
		curMerchant 0
		doorEntered 0
		doorExiting 0
		pwSeconds 0
		pwLastSeconds 0
		pwState 0
		oldMover 0
		walkingView 294
		stoppedView 295
		nameNum 0
		guardCode 0
	)
	
	(method (init)
		((= guardCode (Class_86_0 new:)) init: self 1)
		(super init:)
	)
	
	(method (dispose)
		(guardCode dispose:)
		(super dispose:)
	)
	
	(method (showSelf)
		(Say self 83 [local0 (+ (* nameNum 2) 1)])
	)
	
	(method (respond param1 param2)
		(if (not (guardCode respond: param1 param2))
			(super respond: param1 param2 &rest)
		)
	)
	
	(method (atSpec param1)
		(guardCode atSpec: param1)
	)
	
	(method (atGen param1)
		(guardCode atGen: param1)
	)
	
	(method (messages)
		(super messages: &rest)
		(guardCode startTalking:)
	)
	
	(method (endTalk)
		(super endTalk:)
		(guardCode stopTalking:)
	)
	
	(method (beOutOfRoom)
		(= nameNum (Random 0 6))
		(super beOutOfRoom:)
	)
)

(instance dayPlazaGuard of PlazaGuard
	(properties)
)

(instance nightPlazaGuard of PlazaGuard
	(properties)
	
	(method (init)
		(= local15 0)
		(super init: &rest)
	)
	
	(method (doit &tmp [temp0 100])
		(super doit:)
		(if
			(and
				(not script)
				(< 1 pwState)
				(< pwState 6)
				(or
					(Btst 87)
					(Btst 88)
					(Btst 117)
					(and global191 (not (== curRoomNum 300)))
				)
			)
			(cond 
				(
					(and
						(Btst 87)
						(not (Btst 90))
						(not (Btst 88))
						(== ((ego script?) type?) 5)
					)
					(Die 1 89 7 80 {Guards Hate Knife Throwers})
				)
				((Btst 117) (Die 1 89 8 80 {Blatant Thievery}))
				(global191 (Die 1 89 9 80 {Blatant Thievery}))
				((> (++ local15) 1) (Die 1 89 10 80 {Nothing Magical about This}))
				(else (self setScript: guardWarning))
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'tell//elemental<air,about')
			(Say self 89 11)
			(self leave:)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (beOutOfRoom)
		(super beOutOfRoom:)
		(= pwSeconds 30)
	)
)

(instance guardWarning of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(Say client self 89 12)
				(cond 
					((Btst 90)
						(= local14
							{Do you not know that practicing Magic is best done outside of the city?__Do not let me see you using magic around here again unless it is needed!}
						)
						(= temp0 (ScriptID 62 1))
					)
					((Btst 88)
						(= local14
							{The punishment for thievery in this city is to lose a hand.__Do not let me catch you trying to steal again!}
						)
						(= temp0 (ScriptID 61 3))
					)
					(else
						(= local14
							{Do you not know that practicing Magic is best done outside of the city?__Do not let me see you using magic around here again unless it is needed!}
						)
						(= temp0 0)
					)
				)
				(ego setScript: temp0)
			)
			(1 (= cycles 1))
			(2 (Say client self local14))
			(3 (= seconds 5))
			(4
				(client leave:)
				(self dispose:)
			)
		)
	)
)
