;;; Sierra Script 1.0 - (do not remove this comment)
(script# 83)
(include sci.sh)
(use Main)
(use n001)
(use Talker)
(use PolyPath)
(use StopWalk)
(use System)

(public
	fred 0
)

(local
	[theView_2 20] = [357 351 358 352 359 353 83 0 83 1 83 2 83 3 83 4 83 5 83 6]
)
(procedure (localproc_050a param1)
	(if
		(or
			(localproc_0534 ego param1)
			(localproc_0534 fred param1)
		)
	else
		(localproc_0534 (ScriptID 89 1) param1)
	)
)

(procedure (localproc_0534 param1 param2)
	(return
		(if (!= param1 self)
			(cond 
				((<= (param1 distanceTo: param2) 50))
				((param1 respondsTo: #curMerchant) (== param2 (param1 curMerchant?)))
			)
		else
			0
		)
	)
)

(class PlazaTalker of Talker
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 0
		back 15
		msgFile 0
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
	)
	
	(method (init)
		(super init: &rest)
		(self stopUpd:)
	)
	
	(method (handleEvent)
		(return
			(if (& signal $0088)
				(return 0)
			else
				(return (super handleEvent: &rest))
			)
		)
	)
	
	(method (respond param1 param2 &tmp [temp0 2])
		(if (== param2 32)
			(self showSelf:)
		else
			(super respond: param1 param2 &rest)
		)
	)
	
	(method (initTalk)
		(ego setMotion: 0)
		(super initTalk:)
	)
	
	(method (endTalk)
		(self stopUpd:)
		(super endTalk:)
	)
)

(class PlazaWalker of PlazaTalker
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $2000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $0000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 0
		back 15
		msgFile 0
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
		merchantsVisited 0
		curMerchant 0
		doorEntered 0
		doorExiting 0
		pwSeconds 0
		pwLastSeconds 0
		pwState 0
		oldMover 0
		walkingView 0
		stoppedView 0
	)
	
	(method (init)
		(super init:)
		((= merchantsVisited (List new:)) add:)
		(= baseSetter (theBaseSetter new:))
		(self beOutOfRoom:)
	)
	
	(method (doit &tmp thePwLastSeconds)
		(if
			(and
				(not tCount)
				pwSeconds
				(!= pwLastSeconds (= thePwLastSeconds (GetTime 1)))
			)
			(= pwLastSeconds thePwLastSeconds)
			(if (not (-- pwSeconds)) (self cue:))
		)
		(super doit:)
	)
	
	(method (dispose)
		(if oldMover (oldMover dispose:) (= oldMover 0))
		(merchantsVisited release: dispose:)
		(super dispose:)
	)
	
	(method (cue)
		(if (< state 0) (super cue:) (return))
		(switch pwState
			(0
				(if
				(not (= doorEntered (curRoom findUnblockedDoor:)))
					(= pwSeconds 5)
					(self stopUpd:)
				else
					(self
						posn: (curRoom xOut?) (curRoom yOut?)
						setMotion: PolyPath (curRoom xIn?) (curRoom yIn?) self
						show:
					)
					(= pwState 1)
				)
			)
			(1 (= pwState 2) (self cue:))
			(2 (self goto:))
			(3
				(FaceObject self curMerchant)
				(= pwSeconds (Random 5 30))
				(= pwState 4)
			)
			(4 (self goto:))
			(5
				(self
					setMotion: PolyPath (curRoom xOut?) (curRoom yOut?) self
				)
				(= pwState 6)
			)
			(6 (self beOutOfRoom:))
		)
	)
	
	(method (initTalk)
		(if oldMover (oldMover dispose:))
		(= oldMover mover)
		(self view: stoppedView cel: 0 mover: 0 setCycle: 0)
		(FaceObject self ego)
		(super initTalk:)
	)
	
	(method (endTalk &tmp theView)
		(super endTalk:)
		(if oldMover ((= mover oldMover) init:) (= oldMover 0))
		(= theView view)
		(self
			view: walkingView
			setCycle: StopWalk stoppedView
			view: theView
		)
	)
	
	(method (goto &tmp temp0 temp1 temp2 temp3)
		(asm
			pushi    #merchants
			pushi    0
			lag      curRoom
			send     4
			sat      temp0
			pushi    #size
			pushi    0
			send     4
			sat      temp1
			pushi    #size
			pushi    0
			pToa     merchantsVisited
			send     4
			sat      temp2
			lat      temp1
			bnt      code_046e
			lat      temp2
			not     
			bt       code_03fc
			pushi    2
			pushi    1
			pushi    4
			callk    Random,  4
			push    
			ldi      1
			ne?     
			bnt      code_046e
			lst      temp1
			lat      temp2
			ne?     
			bnt      code_046e
code_03fc:
			ldi      0
			sat      temp3
code_0400:
			pushi    67
			pushi    #superClass
			pushi    2
			pushi    0
			lst      temp1
			ldi      1
			sub     
			push    
			callk    Random,  4
			push    
			lat      temp0
			send     6
			aTop     curMerchant
			pushi    #contains
			pushi    1
			pTos     curMerchant
			pToa     merchantsVisited
			send     6
			not     
			bnt      code_0430
			pushi    1
			pTos     curMerchant
			call     localproc_050a,  2
			not     
			bnt      code_0430
			jmp      code_0443
code_0430:
			+at      temp3
			push    
			ldi      30
			gt?     
			bnt      code_0400
			pushi    #leave
			pushi    0
			self     4
			ret     
			jmp      code_0400
code_0443:
			pushi    #add
			pushi    1
			pTos     curMerchant
			pToa     merchantsVisited
			send     6
			pushi    #setMotion
			pushi    4
			class    PolyPath
			push    
			pushi    #x
			pushi    0
			pToa     curMerchant
			send     4
			push    
			pushi    #y
			pushi    0
			pToa     curMerchant
			send     4
			push    
			pushSelf
			self     12
			ldi      3
			aTop     pwState
			jmp      code_0474
code_046e:
			pushi    #leave
			pushi    0
			self     4
code_0474:
			ret     
		)
	)
	
	(method (beOutOfRoom)
		(merchantsVisited release:)
		(self hide: setCycle: StopWalk stoppedView)
		(= pwSeconds (Random 1 30))
		(= pwState 0)
	)
	
	(method (leave &tmp curRoomFindUnblockedDoor)
		(if
			(or
				(not
					(= curRoomFindUnblockedDoor (curRoom findUnblockedDoor:))
				)
				(and
					(== curRoomFindUnblockedDoor doorEntered)
					(not (merchantsVisited size?))
				)
			)
			(= pwSeconds 1)
		else
			(self
				doorExiting: curRoomFindUnblockedDoor
				setMotion: PolyPath (curRoom xIn?) (curRoom yIn?) self
			)
			(= pwState 5)
		)
	)
)

(instance fred of PlazaWalker
	(properties
		tLoop -1
		color 15
		back 1
	)
	
	(method (init)
		(= title {Townsperson:})
		(= lookStr {A local townsperson.})
		(= myName '//man,woman,townsperson,people')
		(= description {the townsperson})
		(super init:)
	)
	
	(method (respond param1)
		(Say self 83 7)
		(param1 claimed: 1)
	)
	
	(method (endTalk)
		(super endTalk:)
		(proc1_15 3 83 8)
	)
	
	(method (beOutOfRoom &tmp temp0)
		(= temp0 (* (Random 0 2) 2))
		(= palette (Random 1 3))
		(= walkingView (= view [theView_2 temp0]))
		(= stoppedView [theView_2 (+ temp0 1)])
		(super beOutOfRoom:)
	)
)

(instance theBaseSetter of Code
	(properties)
	
	(method (doit param1 &tmp temp0 temp1)
		(= temp0 (param1 x?))
		(= temp1 (param1 y?))
		(param1
			brTop: (- temp1 1)
			brBottom: (+ temp1 1)
			brLeft: (- temp0 6)
			brRight: (+ temp0 10)
		)
	)
)
