;;; Sierra Script 1.0 - (do not remove this comment)
(script# 93)
(include sci.sh)
(use Main)
(use n001)
(use Stage)
(use Actor)
(use System)

(public
	RasPlaza 0
)

(procedure (localproc_000c param1)
	(if (> param1 159)
		(= param1 (Max 220 param1))
	else
		(= param1 (Min 90 param1))
	)
	(return param1)
)

(class RasPlaza of Stage
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		picture 300
		style $ffff
		horizon 82
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY -30000
		obstacles 0
		inOut 0
		edgeHit 0
		entranceScript 0
		topFromX 160
		topFromY 80
		topExit 1
		topToX 160
		topToY 100
		bottomFromX 160
		bottomFromY 250
		bottomExit 3
		bottomToX 160
		bottomToY 188
		rightFromX 325
		rightFromY 162
		rightExit 2
		rightToX 310
		rightToY 162
		leftFromX -10
		leftFromY 162
		leftExit 4
		leftToX 35
		leftToY 162
		saveIllegal 0
		saveSig 0
		whereTo 0
	)
	
	(method (init)
		(ego init:)
		(if (== prevRoomNum south)
			(= bottomToX
				(= bottomFromX (localproc_000c (- 319 (ego x?))))
			)
		else
			(self style: 7)
		)
		(if isNightTime
			(= defaultPalette 3)
		else
			(= defaultPalette 2)
		)
		(super init:)
		(self overlay: curRoomNum)
		(if (or (== curRoomNum 390) (== curRoomNum 450))
			(DrawFeature fountainBasin fountainSpout)
		)
	)
	
	(method (dispose)
		(= defaultPalette 0)
		(super dispose:)
	)
)

(instance fountainBasin of PicView
	(properties
		x 161
		y 197
		noun '/basin,fount'
		description {the city fountain}
		view 450
		priority 14
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if isNightTime (= palette 2))
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint 93 0)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance fountainSpout of PicView
	(properties
		x 161
		y 194
		noun '/fount'
		description {the city fountain}
		view 450
		cel 1
		priority 15
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if isNightTime (= palette 2))
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint 93 0)
		else
			(super doVerb: theVerb &rest)
		)
	)
)
