;;; Sierra Script 1.0 - (do not remove this comment)
(script# 290)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Talker)
(use Stage)
(use Intrface)
(use fakirsPitch)
(use Polygon)
(use Feature)
(use LoadMany)
(use Grooper)
(use Motion)
(use Actor)
(use System)

(public
	rm290 0
	saurus1 1
	saurus2 2
	gate 3
)

(local
	local0
	local1
	local2
	local3
	[local4 16] = [296 114 296 123 269 123 269 111]
	[local20 33] = [1 2 3 0 4 5 6 7 8 9 10 11 12 0 13 14 15 0 16 17 18 19 20 21 22 23 24 25 26 27 28 0 29]
	[local53 22] = [-1 '//saurii,ride' 30 '//preparation,waterbag,compass,food,supply,water,prepare' 33 '//stable' 36 '//skareen' 37 '//bedouin' 38 '//oasis' 39 '//dune' 40 '//griffin' 41 '//nest' 42 '//bazaar']
	[local75 30]
)
(instance rm290 of Stage
	(properties
		picture 290
		style $0001
		horizon 114
		north 300
		south 780
		topFromX 254
		topFromY 113
		topToX 240
		topToY 133
	)
	
	(method (init)
		(Bset 152)
		(LoadMany 128 290 11 295 299)
		(Load rsSCRIPT 985)
		(Load rsSOUND 290)
		(Bclr 82)
		(Bset 16)
		(if (== egoWalkMode 3)
			(= egoWalkMode 3)
		else
			(= egoWalkMode 0)
		)
		(proc1_19)
		(ego illegalBits: -32766 init:)
		(if (Btst 149) (= inOut 3))
		(= local1 (Btst 45))
		(= useObstacles 1)
		(super init:)
		(self addObstacle: guardPoly)
		(guardPoly points: @local4 size: 4)
		(gate palette: (if isNightTime 2 else 1) init:)
		(= [local20 31] 35)
		(if
		(and (= local0 (not isNightTime)) (< currentDay 17))
			(theGuard
				title: {Uns al-Wujud:}
				myName: '//alwujud,guard,man'
				init:
				stopUpd:
			)
		else
			(theGuard
				title: {Abdallah bin Tahir:}
				myName: '//abdallah,guard,man'
				init:
				stopUpd:
			)
		)
		(gCMusic number: 290 loop: -1 playBed:)
		(if
			(= local2
				(if
					(and
						(not local1)
						(>= currentDay 2)
						(< currentDay 17)
						(not (Btst 149))
					)
					local0
				)
			)
			(Load rsVIEW 292)
			(Load rsVIEW 297)
			(Load rsSCRIPT 291)
			(Load rsTEXT 292)
			(Load rsSOUND 293)
			(DrawFeature aliSign)
			(FakirAppears)
		)
		(DrawFeature guardBod)
		(proc1_31 cityGate corral corral2 canopy shadow)
		(saurus1 init: illegalBits: 0 setScript: saurus1S)
		(if
			(or
				(>= gSeconds 2)
				(and (== gSeconds 1) (not local2))
			)
			(saurus2 init: illegalBits: 0 setScript: saurus2S)
		)
		(if
			(and
				(Btst 45)
				(!= egoWalkMode 3)
				(not (Btst 149))
				(not (Btst 155))
			)
			((ScriptID 660 1)
				init:
				view: 11
				posn: -20 149
				setLoop: Grooper
				setCycle: Walk
				setScript: wimpInCorral
			)
		)
		(if
			(and
				(not (Btst 155))
				(not (cast contains: (ScriptID 660 1)))
			)
			((ScriptID 660 1) init:)
		)
		(if (< currentDay 17)
			(if (== egoWalkMode 3) (Bset 173) (Bclr 155))
			(self setRegions: 660)
		)
		(if (Btst 149)
			(ego view: 4 loop: 1 cel: 0 posn: 143 140)
			(proc1_19)
			(ego illegalBits: -32766)
			((ScriptID 660 1)
				loop: 1
				cel: 0
				posn: 84 147
				setPri: -1
				init:
				setCycle: Walk
				illegalBits: 0
				ignoreActors:
				setMotion: MoveTo 55 147
			)
			(HighPrint 290 0 25 4 103)
			(LockEgo 1)
		)
		(= entranceScript
			(cond 
				((>= currentDay 17) lateForCaravan)
				(local2 (ScriptID 291 0))
				(else helloS)
			)
		)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(> (ego y?) 180)
					(not (Btst 48))
					(not (ego has: 50))
					(< currentDay 17)
				)
				(Say theGuard 290 1)
				(Bset 48)
			)
			(
				(and
					(== egoWalkMode 3)
					(< (ego y?) 120)
					(not (ego script?))
				)
				(ego setScript: guardStopsEgo)
			)
			((ego edgeHit?)
				(if (Btst 172)
					(Die 1 290 2 80 {Terminal Stubbornness})
				else
					(curRoom setScript: 0)
				)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(if (== egoWalkMode 3) (Bset 155) else (Bclr 155))
		(Bclr 149)
		(Bclr 173)
		(gCMusic fade:)
		(gMiscMusic stop:)
		(DisposeScript 291)
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 290 4) (if local2 (HighPrint 290 5)))
			(
				(or
					(Said 'get,acquire[<!*]/saurii,roget')
					(Said
						'mount,ride,(climb,scale,get,acquire<on,up)[/saurii,roget]'
					)
					(and
						(!= egoWalkMode 3)
						(Said 'get,acquire[<!*][/saurii,roget]')
					)
				)
				(cond 
					((== egoWalkMode 3) (HighPrint 290 6))
					((Btst 155) (HighPrint 290 7))
					((not (Btst 45)) (HighPrint 290 8))
					(
						(or
							(& ((ScriptID 660 1) onControl: 1) $0002)
							(< ((ScriptID 660 1) x?) 1)
						)
						((ScriptID 660 1) setScript: 0)
						(self setScript: egoGetSaurus)
					)
					((Said 'open,open') (HighPrint 290 8))
					(else (Bset 173) (pEvent claimed: 0))
				)
			)
			((Said 'replace,put/saurii,roget')
				(cond 
					((Btst 173) (self notify:))
					((== local3 1) (HighPrint 290 9))
					((== egoWalkMode 3) (HighPrint 290 10))
					((Btst 155) (HighPrint 290 7))
					((not (Btst 45)) (HighPrint 290 8))
					(
						(or
							(& ((ScriptID 660 1) onControl: 1) $0002)
							(< ((ScriptID 660 1) x?) 1)
						)
						(HighPrint 290 11)
					)
					(else (HighPrint 290 12))
				)
			)
		)
	)
	
	(method (notify)
		(if (Btst 173) (Say theGuard 290 3))
		(Bclr 173)
		(= local3 1)
		(super notify: &rest)
	)
)

(instance helloS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					(
						(and
							(== currentDay 12)
							(not (Btst 93))
							(not (Btst 168))
						)
						(Say theGuard self 290 13)
						(Bset 93)
					)
					((and (== currentDay 1) (not (Btst 46))) (Say theGuard self 290 14) (Bset 46))
					(
						(and
							(Btst 45)
							(not (Btst 93))
							(not (Btst 174))
							(== prevRoomNum (curRoom north?))
						)
						(Say theGuard self 290 15)
					)
					(
						(and
							(not (Btst 47))
							(== prevRoomNum (curRoom south?))
							(not local2)
						)
						(if local0
							(Say theGuard self 290 16)
						else
							(Say theGuard self 290 17)
						)
						(Bset 47)
					)
					((and (< currentDay 7) (not local2))
						(if local0
							(Say theGuard self 290 18)
						else
							(Say theGuard self 290 19)
						)
					)
					((and (< 6 currentDay) (< currentDay 14))
						(cond 
							((and (== currentDay 11) (not (Btst 145))) (Say theGuard self 290 20) (Bset 145))
							(local0 (Say theGuard self 290 21))
							(else (Say theGuard self 290 22))
						)
					)
					(
						(and
							(== currentDay 15)
							(== prevRoomNum (curRoom north?))
						)
						(cond 
							((and (== currentDay 15) (not (Btst 146))) (Say theGuard self 290 23) (Bset 146))
							(local0 (Say theGuard self 290 24))
							(else (Say theGuard self 290 25))
						)
					)
					(
						(and
							(== currentDay 16)
							(== prevRoomNum (curRoom north?))
						)
						(if local0
							(Say theGuard self 290 26)
						else
							(Say theGuard self 290 27)
						)
					)
					(local0 (Say theGuard self 290 21))
					(else (Say theGuard self 290 22))
				)
			)
			(1
				(if (and (Btst 155) (== egoWalkMode 0))
					(Say theGuard self 290 28)
				)
				(gate stopUpd:)
				(self dispose:)
			)
		)
	)
)

(class SaurusScript of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0 (= seconds (Random 2 8)))
			(1
				(client
					setCycle: Fwd
					cycleSpeed: 0
					y: (Random 120 137)
					setMotion: MoveTo (Random 30 80) (client y?) self
				)
			)
			(2
				(client setCycle: 0 setMotion: 0)
				(self
					changeState:
					(switch (Random 0 5)
						(1 3)
						(2 4)
						(3 6)
						(4 9)
						(5 12)
					)
				)
			)
			(3
				(client
					setLoop: 5
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(4
				(client setLoop: 4 cel: 0 setCycle: End self)
			)
			(5 (client setCycle: Beg self))
			(6
				(client setLoop: 2 setCycle: End self)
			)
			(7 (client setCycle: Beg self))
			(8 (self changeState: 12))
			(9
				(client setLoop: 6 cel: 0 setCycle: End self)
			)
			(10 (= seconds 5))
			(11 (client setCycle: Beg self))
			(12
				(= cycles 8)
				(client setCycle: 0)
			)
			(13
				(client setLoop: 6 cel: 0 setCycle: End self)
			)
			(14
				(client setLoop: 7 setCycle: Beg self)
			)
			(15
				(client
					setLoop: 1
					setCycle: Fwd
					cycleSpeed: 0
					setMotion: MoveTo -29 (client y?) self
				)
			)
			(16
				(client setLoop: 0)
				(self changeState: 0)
			)
		)
	)
)

(instance saurus1S of SaurusScript
	(properties)
)

(instance saurus2S of SaurusScript
	(properties)
)

(instance wimpInCorral of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				0
				((ScriptID 660 1) setMotion: MoveTo 18 147 self)
			)
			(1 2 (= seconds (Random 4 7)))
			(2
				3
				((ScriptID 660 1) setMotion: MoveTo 55 147 self)
			)
			(3 4 (self dispose:))
		)
	)
)

(instance egoGetSaurus of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(ego setScript: (ScriptID 660 6))
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 140 140 self)
			)
			(1 (ego setHeading: 315 self))
			(2 (gate setCycle: End self))
			(3
				((ScriptID 660 1)
					setCycle: Walk
					setMotion: MoveTo 200 147 self
				)
			)
			(4 (gate setCycle: Beg self))
			(5
				(gate stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance guardStopsEgo of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0 setHeading: 45 self)
			)
			(1 (Say theGuard self 290 29))
			(2
				(ego setMotion: MoveTo 220 130 self)
			)
			(3
				(ego setMotion: MoveTo 230 140 self)
			)
			(4 (self dispose:))
		)
	)
)

(instance cityGate of Feature
	(properties
		x 252
		y 71
		noun '/arch,gateway,entrance,(gate<shapeir)'
		nsTop 25
		nsLeft 212
		nsBottom 117
		nsRight 292
		description {the Gateway to the City of Shapeir}
		lookStr {This is the Main (and only) gateway to the City of Shapeir.}
	)
)

(instance corral of Feature
	(properties
		x 55
		y 128
		noun '/corral,pen,fence,stable'
		nsTop 99
		nsLeft 1
		nsBottom 158
		nsRight 110
		description {the corral}
		lookStr {The corral is used to keep the sauruses penned in.}
	)
)

(instance corral2 of Feature
	(properties
		x 152
		y 103
		noun '/corral,pen,fence,stable'
		nsTop 79
		nsLeft 111
		nsBottom 127
		nsRight 194
		description {the corral}
		lookStr {The corral is used to keep the sauruses penned in.}
	)
)

(instance canopy of Feature
	(properties
		x 73
		y 30
		noun '/awning,awning'
		nsTop 19
		nsLeft 1
		nsBottom 41
		nsRight 146
		description {the canopy over the saurus lot}
		lookStr {There is a small canopy for shade and color.}
	)
)

(instance shadow of Feature
	(properties
		x 73
		y 57
		noun '/shadow'
		nsTop 49
		nsBottom 66
		nsRight 147
		description {the shade of the awning}
		lookStr {Only really tall people appreciate the awning's shade.__One can only speculate that it is purely decorative.}
	)
)

(instance guardPoly of Polygon
	(properties
		type $0002
	)
)

(instance guardBod of PicView
	(properties
		x 283
		y 121
		view 295
		loop 7
	)
)

(instance theGuard of Talker
	(properties
		x 282
		y 82
		description {the guard}
		lookStr {The guard looks much like any other well-trained soldier.}
		view 295
		loop 4
		signal $6010
		illegalBits $0000
		tLoop 4
		talkSpeed 0
		myName '//guard,man'
		title {Guard Name:}
		color 14
		back 0
		msgFile 294
	)
	
	(method (onMe)
		(if (super onMe: &rest) else (guardBod onMe: &rest))
	)
	
	(method (atSpec param1)
		(return [local53 param1])
	)
	
	(method (atGen param1)
		(return [local20 param1])
	)
	
	(method (showText param1)
		(FaceObject ego self)
		(switch param1
			(29
				(if local0 (Say self 290 30) else (Say self 290 31))
			)
			(15
				(Say theGuard 290 32 290 33 290 34)
			)
			(9
				(if local0
					(Say self 290 35 290 36 290 37)
				else
					(Say self 290 35 290 38 290 39)
				)
			)
			(27
				(if local1 (Say self 290 40) else (Say self 290 41))
			)
			(14
				(Format
					@local75
					{There will be a caravan to Raseir in %u Days.}
					(- 17 currentDay)
				)
				(Say self 290 42 @local75)
			)
			(-1
				(if (== currentDay 1)
					(Say self 290 43 290 44 290 45 290 46)
				else
					(Say self 290 43 290 44 290 45)
				)
			)
			(30 (self showMany: 30 32))
			(33 (self showMany: 33 34))
			(else 
				(self messages: 294 param1)
			)
		)
	)
	
	(method (messages)
		(self setPri: 9)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(super endTalk: &rest)
		(self setPri: 0)
	)
)

(instance saurus1 of Actor
	(properties
		x -29
		y 124
		noun '[<!*]/(saurii[<red]),animal,monster,creature,dragon,dinosaur'
		description {the red saurus}
		lookStr {It is a variety of red saurus that you never saw in Spielburg.}
		view 299
		loop 1
		cel 1
		priority 7
		signal $4010
		xStep 7
	)
)

(instance saurus2 of Actor
	(properties
		x -32
		y 132
		noun '[<!*]/(saurii[<red]),animal,monster,creature,dragon,dinosaur'
		description {the red saurus}
		lookStr {It is a variety of red saurus that you never saw in Spielburg.}
		view 299
		loop 1
		cel 1
		priority 7
		signal $4010
		xStep 7
	)
)

(instance aliSign of PicView
	(properties
		x 41
		y 172
		noun '/sign,carpet'
		description {the sign}
		lookStr {The only thing that's honest about Ali is the fact that he honestly can't spell "Saurus."}
		view 290
		loop 1
		signal $4010
	)
)

(instance gate of Prop
	(properties
		x 134
		y 132
		noun '/gate,door,stable,grass'
		description {the gate to the saurus lot}
		lookStr {Through this gate saunter some of the sorriest sauruses ever.}
		view 290
		priority 7
		signal $4010
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(cond 
					((== egoWalkMode 3) (HighPrint 290 47))
					((Btst 155) (HighPrint 290 48))
					((not (Btst 45)) (HighPrint 290 8))
					(
						(or
							(& ((ScriptID 660 1) onControl: 1) $0002)
							(< ((ScriptID 660 1) x?) 1)
						)
						((ScriptID 660 1) setScript: 0)
						(self setScript: egoGetSaurus)
					)
					(else (HighPrint 290 8))
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
)

(instance lateForCaravan of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cast eachElementDo: #dispose)
				(curRoom drawPic: 2)
				(= cycles 4)
			)
			(1 (Print 290 49) (= cycles 1))
			(2
				(Print 290 50)
				(Bclr 3)
				(Bclr 137)
				(Bclr 4)
				(Bclr 5)
				(ego get: 49 get: 3 12)
				(if (not (ego has: 37)) (ego get: 37))
				(++ mealsPreEaten)
				(= currentWater (* [invNum 37] 10))
				(= cycles 2)
			)
			(3
				(if (== egoWalkMode 3)
					(Print 290 51)
				else
					(Print 290 52)
				)
				(= cycles 1)
			)
			(4 (curRoom newRoom: 861))
		)
	)
)
