;;; Sierra Script 1.0 - (do not remove this comment)
(script# 25)
(include sci.sh)
(use Main)
(use n001)
(use Motion)
(use Game)


(class Stage of Rm
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		picture 0
		style $ffff
		horizon 0
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY -30000
		obstacles 0
		inOut 0
		edgeHit 0
		entranceScript 0
		topFromX 32767
		topFromY 32767
		topExit 1
		topToX 32767
		topToY 32767
		bottomFromX 32767
		bottomFromY 240
		bottomExit 3
		bottomToX 32767
		bottomToY 180
		rightFromX 335
		rightFromY 32767
		rightExit 2
		rightToX 305
		rightToY 32767
		leftFromX -15
		leftFromY 32767
		leftExit 4
		leftToX 15
		leftToY 32767
		saveIllegal 0
		saveSig 0
		whereTo 0
	)
	
	(method (init &tmp theTopFromX theTopFromY theTopToX theTopToY temp4 temp5 theTopExit)
		(super init: &rest)
		(if (== inOut 0)
			(UnlockEgo)
			(= saveSig (ego signal?))
			(= saveIllegal (ego illegalBits?))
			(= temp5 1)
			(= theTopExit (+ (mod (+ gTopExit 1) 4) 1))
			(if (Btst 28)
				(cond 
					(north (= theTopExit topExit) (= prevRoomNum north))
					(south (= theTopExit bottomExit) (= prevRoomNum south))
					(west (= theTopExit leftExit) (= prevRoomNum west))
					(east (= theTopExit rightExit) (= prevRoomNum east))
					(else (= temp5 0))
				)
			)
			(cond 
				((and north (== theTopExit topExit))
					(= theTopFromX topFromX)
					(= theTopFromY topFromY)
					(= theTopToX topToX)
					(= theTopToY topToY)
					(= temp4 2)
					(cond 
						(
						(and (== theTopFromY 32767) (== theTopToY 32767))
							(= theTopFromY (- horizon 2))
							(= theTopToY (+ horizon 20))
						)
						((== theTopFromY 32767) (= theTopFromY (- theTopToY 22)))
						((== theTopToY 32767) (= theTopToY (+ theTopFromY 22)))
					)
				)
				((and south (== theTopExit bottomExit))
					(= theTopFromX bottomFromX)
					(= theTopFromY bottomFromY)
					(= theTopToX bottomToX)
					(= theTopToY bottomToY)
					(= temp4 3)
				)
				((and west (== theTopExit leftExit))
					(= theTopFromX leftFromX)
					(= theTopFromY leftFromY)
					(= theTopToX leftToX)
					(= theTopToY leftToY)
					(= temp4 0)
				)
				((and east (== theTopExit rightExit))
					(= theTopFromX rightFromX)
					(= theTopFromY rightFromY)
					(= theTopToX rightToX)
					(= theTopToY rightToY)
					(= temp4 1)
				)
				(else (= temp5 0))
			)
			(if temp5
				(if (== theTopFromX 32767) (= theTopFromX (ego x?)))
				(if (== theTopFromY 32767) (= theTopFromY (ego y?)))
				(if (== theTopToX 32767) (= theTopToX (ego x?)))
				(if (== theTopToY 32767) (= theTopToY (ego y?)))
				(= inOut 1)
				(ego
					ignoreActors:
					ignoreHorizon:
					illegalBits: 0
					posn: theTopFromX theTopFromY
					loop: temp4
					setMotion: MoveTo theTopToX theTopToY self
				)
			else
				(= inOut 3)
			)
		)
	)
	
	(method (doit &tmp egoX egoY temp2)
		(cond 
			((ego script?))
			(script (script doit:))
			(
				(and
					(== inOut 3)
					(or edgeHit (= edgeHit (ego edgeHit?)))
				)
				(= temp2 (- (ego nsBottom?) (- (ego nsTop?) 1)))
				(switch edgeHit
					(1
						(= whereTo north)
						(= gTopExit topExit)
						(= egoX (ego x?))
						(= egoY
							(if (== topFromY 32767) (- (ego y?) 10) else topFromY)
						)
					)
					(3
						(= whereTo south)
						(= gTopExit bottomExit)
						(= egoX (ego x?))
						(= egoY
							(if (== bottomFromY 32767)
								(+ (ego y?) temp2)
							else
								bottomFromY
							)
						)
					)
					(2
						(= whereTo east)
						(= gTopExit rightExit)
						(= egoX
							(if (== rightFromX 32767)
								(+ (ego x?) 30)
							else
								rightFromX
							)
						)
						(= egoY (ego y?))
					)
					(4
						(= whereTo west)
						(= gTopExit leftExit)
						(= egoX
							(if (== leftFromX 32767)
								(- (ego x?) 30)
							else
								leftFromX
							)
						)
						(= egoY (ego y?))
					)
				)
				(if whereTo
					(UnlockEgo)
					(= inOut 2)
					(= saveSig (ego signal?))
					(= saveIllegal (ego illegalBits?))
					(ego
						illegalBits: 0
						ignoreActors:
						ignoreHorizon:
						setMotion: MoveTo egoX egoY self
					)
				)
				(= edgeHit 0)
				(ego edgeHit: 0)
			)
		)
	)
	
	(method (cue)
		(LockEgo 1)
		(switch inOut
			(1
				(ego illegalBits: saveIllegal signal: saveSig)
				(= inOut 3)
				(super cue:)
				(if entranceScript (self setScript: entranceScript))
			)
			(2
				(curRoom setScript: 0 newRoom: whereTo)
				(super cue:)
			)
		)
	)
)
