;;; Sierra Script 1.0 - (do not remove this comment)
(script# 23)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use TopWindow)
(use TargActor)
(use Intrface)
(use Save)
(use Motion)
(use User)

(public
	Say 0
)

(procedure (Say  whom)     ; Kludge to keep args as far strings
   (whom  messages: &rest)
)

(class Talker of TargActor
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 0
		back 15
		msgFile 0
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow TopWindow)
		(gKeyH add: self)
		(if (and myName (not noun)) (= noun (+ myName 1)))
	)
	
	(method (doit &tmp theLastSeconds)
		(++ cycles)
		(if
			(and
				seconds
				(!= lastSeconds (= theLastSeconds (GetTime 1)))
			)
			(= lastSeconds theLastSeconds)
			(if (not (-- seconds)) (self talkCue:))
		)
		(super doit:)
	)
	
	(method (dispose)
		(if (IsObject oldCycler)
			(oldCycler dispose:)
			(= oldCycler 0)
		)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'ask/identity') (self respond: pEvent 32))
			((and (Said 'ask>') (self saidMe: pEvent))
				(if (< (++ global192) 5)
					(SkillUsed 13 5)
					(SkillUsed 1 3)
				)
				(if
				(and (not (= temp0 (proc1_18 pEvent))) (Said myName))
					(= temp0 32)
				)
				(self respond: pEvent temp0)
			)
			((not (if s1 else s2)))
			(
				(or
					(== (pEvent type?) evMOUSEBUTTON)
					(== (pEvent type?) evKEYBOARD)
				)
				(pEvent claimed: 1)
				(if (> cycles endCycles) (self talkCue:))
			)
		)
		(pEvent claimed?)
	)
	
	(method (doVerb theVerb &tmp userCurEvent)
		(if (== theVerb 9)
			((= userCurEvent (User curEvent?)) claimed: 0)
			(self talkTo: userCurEvent)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (cue)
		(if (== state -1) (self talkCue:) else (super cue:))
	)
	
	(method (saidMe param1 &tmp temp0)
		(if
		(= temp0 (if (Said noun) else (Said '[/!*]')))
			(param1 claimed: 0)
		)
		(return temp0)
	)
	
	(method (respond param1 param2 &tmp theTalkerAtSpecAnswer talkerAtSpecAnswer)
		(if (or (== (ego view?) 0) (== (ego view?) 4))
			(ego setMotion: 0)
			(FaceObject ego self)
		)
		(= theTalkerAtSpecAnswer (self atGen: param2))
		(if (not param2)
			(if
			(!= (= talkerAtSpecAnswer (self atSpecAnswer:)) 32767)
				(= theTalkerAtSpecAnswer talkerAtSpecAnswer)
			)
			(param1 claimed: 1)
		)
		(self showText: theTalkerAtSpecAnswer)
	)
	
	(method (atSpecAnswer)
		(self scanSaidSpecs: 428)
	)
	
	(method (scanSaidSpecs param1 &tmp temp0 temp1 temp2)
		(= temp1 32767)
		(= temp0 1)
		(while (= temp2 (self param1: temp0))
			(if (Said temp2)
				(= temp1 (self param1: (- temp0 1)))
				(break)
			)
			(= temp0 (+ temp0 2))
		)
		(return temp1)
	)
	
	(method (atSpec)
		(return 0)
	)
	
	(method (atGen)
		(return 0)
	)
	
	(method (showText param1)
		(self messages: msgFile param1)
	)
	
	(method (showMany param1 param2)
		(switch (+ (- param2 param1) 1)
			(1
				(self messages: msgFile (+ param1 0))
			)
			(2
				(self
					messages: msgFile (+ param1 0) msgFile (+ param1 1)
				)
			)
			(3
				(self
					messages:
						msgFile
						(+ param1 0)
						msgFile
						(+ param1 1)
						msgFile
						(+ param1 2)
				)
			)
			(4
				(self
					messages:
						msgFile
						(+ param1 0)
						msgFile
						(+ param1 1)
						msgFile
						(+ param1 2)
						msgFile
						(+ param1 3)
				)
			)
		)
	)
	
	(method (messages param1 &tmp temp0 temp1 temp2 temp3)
		(asm
			ldi      0
			aTop     s8
			aTop     s7
			aTop     s6
			aTop     s5
			aTop     s4
			aTop     s3
			aTop     s2
			aTop     s1
			sat      temp0
			ldi      0
			sat      temp3
			pushi    1
			ldi      0
			lspi     param1
			callk    IsObject,  2
			bnt      code_02f4
			ldi      0
			lapi     param1
			aTop     caller
			+at      temp0
code_02f4:
			ldi      0
			aTop     tCount
code_02f8:
			lst      temp0
			lap      argc
			lt?     
			bnt      code_0390
			lat      temp0
			lspi     param1
			ldi      1000
			ult?    
			bnt      code_0321
			lat      temp0
			lapi     param1
			sat      temp1
			lst      temp0
			ldi      1
			add     
			lapi     param1
			sat      temp2
			ldi      2
			sat      temp3
			jmp      code_033c
code_0321:
			lat      temp0
			lapi     param1
			bnt      code_0390
			lat      temp0
			lapi     param1
			sat      temp1
			ldi      0
			sat      temp2
			ldi      1
			sat      temp3
			jmp      code_033c
			jmp      code_0390
code_033c:
			pTos     tCount
			dup     
			ldi      0
			eq?     
			bnt      code_0350
			lat      temp1
			aTop     s1
			lat      temp2
			aTop     s2
			jmp      code_0383
code_0350:
			dup     
			ldi      1
			eq?     
			bnt      code_0362
			lat      temp1
			aTop     s3
			lat      temp2
			aTop     s4
			jmp      code_0383
code_0362:
			dup     
			ldi      2
			eq?     
			bnt      code_0374
			lat      temp1
			aTop     s5
			lat      temp2
			aTop     s6
			jmp      code_0383
code_0374:
			dup     
			ldi      3
			eq?     
			bnt      code_0383
			lat      temp1
			aTop     s7
			lat      temp2
			aTop     s8
code_0383:
			toss    
			ipToa    tCount
			lst      temp0
			lat      temp3
			add     
			sat      temp0
			jmp      code_02f8
code_0390:
			pTos     state
			ldi      0
			ge?     
			bnt      code_039e
			pushi    #initTalk
			pushi    0
			self     4
code_039e:
			ret     
		)
	)
	
	(method (initTalk)
		(= seconds 0)
		(= state 1)
		(= tCount
			(cond 
				((or s7 s8) 4)
				((or s5 s6) 3)
				((or s3 s4) 2)
				((or s1 s2) 1)
				(else 0)
			)
		)
		(if (>= tLoop 0)
			(= oldLoop loop)
			(= oldCel cel)
			(= oldSpeed cycleSpeed)
			(= loop tLoop)
			(= cycleSpeed talkSpeed)
			(= oldCycler cycler)
			(= cycler 0)
			(self setCycle: Fwd)
		)
		(DisposeDialog)
		(self talk:)
	)
	
	(method (talk &tmp theSeconds theS1 theS2 [temp3 500])
		(switch state
			(1 (= theS1 s1) (= theS2 s2))
			(2 (= theS1 s3) (= theS2 s4))
			(3 (= theS1 s5) (= theS2 s6))
			(4 (= theS1 s7) (= theS2 s8))
		)
		(cond 
			((u< theS1 1000) (GetFarText theS1 theS2 @temp3))
			(theS1 (StrCpy @temp3 theS1))
		)
		(if (< colorCount 8)
			(tWindow color: 0 back: 15)
		else
			(tWindow color: color back: back)
		)
		(Print
			@temp3
			#font
			userFont
			#title
			title
			#window
			(if tWindow else SysWindow)
			#width
			(if tWindow
				(- (tWindow brRight?) (+ (tWindow brLeft?) 16))
			else
				-1
			)
			#mode
			1
			#dispose
		)
		(if (< (= theSeconds (/ (StrLen @temp3) 9)) 4)
			(= theSeconds 4)
		)
		(if suckBlueFrog
			(= endCycles 0)
		else
			(= endCycles (+ 1 (* gSeconds 1)))
		)
		(= cycles 0)
		(= seconds theSeconds)
	)
	
	(method (endTalk &tmp theCaller)
		(if (or s1 s2)
			(if (>= tLoop 0)
				(self
					setCycle: oldCycler
					loop: oldLoop
					cel: oldCel
					cycleSpeed: oldSpeed
				)
				(= oldCycler 0)
			)
			(DisposeDialog)
			(= state 0)
			(self
				tCount: 0
				s1: 0
				s2: 0
				s3: 0
				s4: 0
				s5: 0
				s6: 0
				s7: 0
				s8: 0
				seconds: 0
			)
			(if caller
				(= theCaller caller)
				(= caller 0)
				(theCaller cue:)
			)
		)
	)
	
	(method (talkCue)
		(++ state)
		(cond 
			((== state 0) (self initTalk:))
			((<= state tCount) (DisposeDialog) (self talk:))
			(else (self endTalk:))
		)
	)
	
	(method (talkTo param1 &tmp temp0)
		(if (Said '/[/!*]')
			(= temp0 32)
		else
			(if (< (++ global192) 5)
				(SkillUsed 13 6)
				(SkillUsed 1 3)
			)
			(if
			(and (not (= temp0 (proc1_18 param1))) (Said myName))
				(= temp0 32)
			)
		)
		(self respond: param1 temp0)
	)
)
