;;; Sierra Script 1.0 - (do not remove this comment)
(script# 366)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use Talker)
(use rm360)
(use Grooper)
(use Motion)
(use Actor)
(use System)

(public
	beginScript 0
)

(local
	[local0 200]
	local200
)
(procedure (localproc_000c)
	(if (!= (egoHead cel?) 2) (egoHead setCycle: CT 2 1))
)

(procedure (localproc_002b)
	(if (== (egoHead cel?) 2) (egoHead setCycle: End))
)

(procedure (localproc_0047 param1)
	(if
	(or (== currentTimeZone 4) (== currentTimeZone 5))
		(Say
			(ScriptID 360 1)
			param1
			((ScriptID 360 1) msgFile?)
			16
			((ScriptID 360 1) msgFile?)
			18
		)
	else
		(Say
			(ScriptID 360 1)
			param1
			((ScriptID 360 1) msgFile?)
			16
			((ScriptID 360 1) msgFile?)
			17
		)
	)
)

(instance egoHead of Prop
	(properties
		view 361
		loop 4
		priority 14
		signal $0010
	)
)

(instance theDrink of View
	(properties
		x 251
		y 188
		z 20
		view 363
		loop 12
		signal $4000
	)
)

(instance beginScript of Script
	(properties)
	
	(method (init)
		(if (== global295 3)
			((ScriptID 364 0) setLoop: 1 posn: 115 175 init:)
		)
		(super init: &rest)
		(SetControl 1)
		(= approachCode self)
		(if (not (cast contains: (ScriptID 360 1)))
			((ScriptID 360 1) init:)
		)
	)
	
	(method (dispose)
		(= approachCode 0)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 361
					setLoop: 1
					setCel: 0
					setPri: 12
					posn: 264 161
					init:
				)
				(egoHead posn: (+ (ego x?) 2) (- (ego y?) 10) init:)
				(= cycles 1)
			)
			(1
				(switch global295
					(1
						((ScriptID 360 2) setScript: serveDrinks)
					)
					(3
						((ScriptID 364 0) setScript: ugarteTalk)
					)
					(8 (= cycles 1))
				)
			)
			(2
				(SetControl 0)
				(if (and (>= currentTimeZone 4) (== global295 1))
					(++ global295)
					(curRoom newRoom: 370)
				else
					(ego setScript: standEgo)
				)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'stand,(get,acquire<up),done')
				(switch global295
					(1
						(if
						(and (not (Btst 110)) ((ScriptID 360 2) script?))
							((ScriptID 360 2) setLoop: -1 setLoop: Grooper)
							(((ScriptID 360 2) script?) changeState: 5)
						)
						(localproc_0047 self)
					)
					(else  (self cue:))
				)
			)
			((Said 'drink>')
				(cond 
					((not (Btst 110)) (pEvent claimed: 1) (HighPrint 366 0) (return))
					((and (Btst 102) (Said '/coffee')) (HighPrint 366 1))
					((and (not (Btst 102)) (Said '/sling')) (HighPrint 366 2))
					(
						(not
							(if (or (Said '/coffee') (Said '/sling'))
							else
								(Said '[/!*]')
							)
						)
						(HighPrint 366 3)
					)
				)
				(pEvent claimed: 1)
				(self setScript: drinkStuff self)
			)
			((Said 'look,examine>')
				(cond 
					((not (Btst 110)) (HighPrint 366 4))
					((Btst 102)
						(cond 
							((Said '/coffee') (HighPrint 366 5))
							((Said '/sling,drink') (HighPrint 366 6))
						)
					)
					((Said '/sling') (HighPrint 366 7))
					((Said '/coffee,drink') (HighPrint 366 8))
				)
			)
			((and (== global295 1) (Said 'talk,chat,ask')) (localproc_0047 self))
		)
	)
)

(instance drinkStuff of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (Btst 102)
					(HighPrint 366 9)
				else
					(HighPrint 366 10)
				)
				(HighPrint 366 11)
				(Bclr 110)
				(= cycles 1)
			)
			(1
				(cond 
					((or (TestSkill 3 125) (Btst 121))
						(Bclr 121)
						(HighPrint 366 12)
						(Say (ScriptID 360 1) self 366 13)
						(GameTimeEvents 1 0)
					)
					((TestSkill 3 75)
						(HighPrint 366 14)
						(Say (ScriptID 360 1) self 366 15)
						(GameTimeEvents 2 0)
					)
					(else
						(HighPrint 366 16)
						(Say (ScriptID 360 1) self 366 17)
						(GameTimeEvents 3 0)
					)
				)
			)
			(2
				(if
				(or (== currentTimeZone 4) (== currentTimeZone 5))
					(Say
						(ScriptID 360 1)
						self
						((ScriptID 360 1) msgFile?)
						18
					)
				else
					(Say
						(ScriptID 360 1)
						self
						((ScriptID 360 1) msgFile?)
						17
					)
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance standEgo of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
					(and
						(== global295 3)
						(cast contains: (ScriptID 364 0))
					)
					((ScriptID 364 1) cue:)
				)
				(ego
					posn: (- (ego x?) 8) (+ (ego y?) 10)
					setLoop: 0
					setCycle: Beg self
				)
				(egoHead dispose:)
			)
			(1
				(ego view: 0 setLoop: 2)
				(= cycles 1)
			)
			(2
				(ego
					view: 0
					setLoop: -1
					setLoop: gEgoGL
					setCel: -1
					setHeading: 270 self
				)
			)
			(3
				(ego setCycle: gEgoSW 4 setMotion: MoveTo 200 175 self)
			)
			(4
				(ego setPri: -1)
				(self dispose:)
			)
		)
	)
)

(instance serveDrinks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 0)
				(Bset 112)
				((ScriptID 360 3) dispose:)
				((ScriptID 360 4) dispose:)
				((ScriptID 360 2) setLoop: 9 setCycle: End self)
			)
			(1
				((ScriptID 360 2)
					posn: (+ ((ScriptID 360 2) x?) 1) (+ ((ScriptID 360 2) y?) 18)
					setLoop: 11
					setPri: 11
					setCycle: Walk
					setMotion: MoveTo 118 149 self
				)
			)
			(2
				((ScriptID 360 2) setMotion: MoveTo 225 179 self)
			)
			(3
				(localproc_000c)
				((ScriptID 360 2)
					setPri: 14
					setMotion: MoveTo 235 189 self
				)
			)
			(4
				(localproc_002b)
				(Bclr 112)
				(Bset 110)
				(theDrink init:)
				((ScriptID 360 2)
					setLoop: -1
					setLoop: Grooper
					setMotion: MoveTo 225 179 self
				)
				(Say (ScriptID 360 1) 366 19)
			)
			(5
				((ScriptID 360 2)
					setPri: -1
					setMotion: MoveTo 118 149 self
				)
			)
			(6
				((ScriptID 360 2) setMotion: MoveTo 99 157 self)
			)
			(7
				((ScriptID 360 2)
					posn: (- ((ScriptID 360 2) x?) 1) (- ((ScriptID 360 2) y?) 18)
					setLoop: 8
					setPri: 12
				)
				(proc1_32 (ScriptID 360 3) 2 10)
				(proc1_32 (ScriptID 360 4) 2)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'talk,chat,ask')
				(if (Btst 112)
					(Say (ScriptID 360 1) 366 18)
				else
					(pEvent claimed: 0)
				)
			)
		)
	)
)

(instance ugarteTalk of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if register
					(self changeState: 6)
				else
					(localproc_000c)
					((ScriptID 364 0)
						illegalBits: 0
						setLoop: -1
						setLoop: Grooper
						setCycle: Walk
						setMotion: MoveTo 235 189 self
					)
				)
			)
			(1
				(= approachCode (ScriptID 364 0))
				(Say (ScriptID 364 0) self 366 20)
			)
			(2
				(localproc_002b)
				(Say (ScriptID 360 1) self 366 21)
			)
			(3
				(localproc_000c)
				(Say (ScriptID 364 0) self 366 22)
			)
			(4
				(localproc_002b)
				(Say (ScriptID 360 1) self 366 23)
			)
			(5
				(localproc_000c)
				(Say (ScriptID 364 0) self 366 24)
			)
			(6 (LockEgo 1) (SetControl 1))
			(7
				(SetInput 1)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((or (Said 'buy/info') (Said 'pay,gave')) (= local200 500) (client setScript: payUgarte 0 0))
			((Said 'bargain')
				(= local200 (if (TestSkill 13 125) 300 else 500))
				(client setScript: payUgarte 0 1)
			)
			((Said 'n') (client setScript: ugarteInsultS))
		)
	)
)

(instance payUgarte of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if register
					(if (== local200 300)
						(Say (ScriptID 364 0) self 366 25)
					else
						(Say (ScriptID 364 0) self 366 26)
						(client setScript: ugarteTalk 0 1)
					)
				else
					(self cue:)
				)
			)
			(1
				(switch (proc3_1 local200)
					(1
						(Say
							(ScriptID 364 0)
							self
							(Format @local0 366 27 @userName)
						)
					)
					(2
						(proc3_2 local200)
						(Bset 111)
						(self changeState: 3)
					)
					(0
						(HighPrint 366 28)
						(Say (ScriptID 364 0) self 366 29)
					)
				)
			)
			(2
				(client setScript: ugarteInsultS)
			)
			(3
				(localproc_000c)
				(SkillUsed 1 100)
				(Say (ScriptID 364 0) self 366 30)
			)
			(4
				(localproc_002b)
				(Say (ScriptID 360 1) self 366 31)
			)
			(5
				(localproc_000c)
				(Say (ScriptID 364 0) self 366 32)
			)
			(6
				(localproc_002b)
				(Say
					(ScriptID 360 1)
					self
					(Format @local0 366 33 @userName)
					366
					34
				)
			)
			(7
				(proc1_32 (ScriptID 364 1) 15)
				(self dispose:)
			)
		)
	)
)

(instance ugarteInsultS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 364 0) setMotion: MoveTo 180 190 self)
			)
			(1
				(localproc_002b)
				((ScriptID 364 0) setMotion: MoveTo 160 250 self)
				(Say (ScriptID 360 1) self 366 35)
			)
			(2
				(proc360_7 0 {Now you're broke AND busted!})
			)
		)
	)
)
