;;; Sierra Script 1.0 - (do not remove this comment)
(script# 850)
(include sci.sh)
(use Main)
(use n001)
(use Intrface)
(use LoadMany)
(use Save)
(use Motion)
(use Game)
(use Menu)
(use Actor)
(use System)

(public
	closingCredits 0
)

(local
	local0
	local1
	local2
	[newAStar 5]
	[local8 5] = [53 170 224 30 284]
	[local13 5] = [16 78 46 84 67]
	[local18 5] = [53 285 196 85 178]
	[local23 5] = [16 16 80 65 14]
	[local28 5] = [1 2 3 3 2]
	[local33 7] = [13 12 11 10 9 7 3]
	[local40 20] = [{Jerry Moore} {Cheryl Loyd} {Doug Herring} {Nate Larsen} {Eric Kasner} {Desie Hartman} {Dean La Rocca} {Tamra Dayton} {Harry McLaughlin} {Corey Cole} {Mark Wilden} {Brian K. Hughes} {Jerry Shaw} {Robert Lee Mallory} {Randy MacNeill} {Gary Kamigawachi} {Robert E. Heitman} {Mark Seibert} {Chris Braymen} {The Whole Gang}]
	[local60 20] = [{Mr. Science} {No-stress graphics} {Only his wit is sharper than his blade.} {I taught Mr. Science everything he knows.} {Give me some slack.} {I'll be at the candy machine.} {Has anyone got change for a dollar?} {Velcro Mama} {The Joisey Boy} {Owner, Graduate, and\nSole Employee of the\nFamous Programmer's\nCorrespondence School._} {Alleys and plazas are my life.} {Monty Python's summer replacement.} {Spellcaster Master} {Edit, compile, test...\nEdit, compile, beep...\nEdit, compile, test..._} {It came from Q.A.} {You want me to work HOW MUCH OVERTIME??} {Quick and Courteous\nCameo Coding_} {Whambos and Thuds} {Binks and Thweeps} {Jeff Stephenson, Robert E. Heitman\nDan Foy, Pablo Ghenis, Larry Scott\nEric Hart, J. Mark Hood, John Rettig\nand a cast of several._}]
)
(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 5)
		((= [newAStar temp0] (aStar new:))
			cel: temp0
			x: [local8 temp0]
			y: [local13 temp0]
			palette: [local28 temp0]
			init:
			setCycle: Fwd
		)
		(++ temp0)
	)
)

(procedure (localproc_004f &tmp temp0)
	(= temp0 0)
	(while (< temp0 5)
		([newAStar temp0]
			x: [local18 temp0]
			y: [local23 temp0]
			show:
		)
		(++ temp0)
	)
)

(procedure (localproc_0077 &tmp temp0 temp1)
	(creditWindow back: [local33 (Random 0 6)])
	(= temp0 (if (== local2 19) -1 else 85))
	(= temp1 40)
	(Print
		[local60 local2]
		#at
		temp0
		temp1
		#title
		[local40 temp1]
		#width
		(if (== temp1 19) 230 else 135)
		#mode
		1
		#window
		creditWindow
		#dispose
	)
	(return (++ local2))
)

(instance closingCredits of Rm
	(properties
		picture 663
		style $002a
	)
	
	(method (init)
		(LoadMany 128 860 845 850 846 847)
		(Load rsPIC 662)
		(Load rsSOUND 832)
		(= defaultPalette 1)
		(moon init:)
		(Title init: hide:)
		(torso init: setCycle: Fwd)
		(egoHead init: setCycle: Fwd)
		(leftArm init: setCycle: Fwd)
		(rightArm init: setCycle: Fwd)
		(reins init: setCycle: Fwd)
		(= suckBlueFrog 0)
		(localproc_000c)
		(gKeyH add: self)
		(gMouseH add: self)
		(super init: &rest)
		(curRoom overlay: 659 42)
		(DrawFeature saurTop saurBottom waist)
		(self setScript: rollTheCredits)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(pEvent claimed: 1)
		(if
			(and
				(== (pEvent type?) evKEYBOARD)
				(== (pEvent message?) KEY_F2)
			)
			(ToggleSound)
		)
		(if (not (curRoom script?))
			(if
				(or
					(and
						(== (pEvent type?) evMOUSEBUTTON)
						(!= (pEvent modifiers?) emSHIFT)
					)
					(and
						(== (pEvent type?) evKEYBOARD)
						(or
							(== (pEvent message?) KEY_CONTROL)
							(== (pEvent message?) KEY_RETURN)
						)
					)
				)
				(= quit 1)
			)
			(if
				(and
					(== (pEvent type?) evKEYBOARD)
					(== (pEvent message?) KEY_F9)
				)
				(theGame restart:)
			)
		)
	)
)

(instance saurTop of PicView
	(properties
		x 40
		y 118
		shiftClick 0
		view 860
		loop 5
		priority 15
		signal $0010
		palette 2
	)
)

(instance saurBottom of PicView
	(properties
		x 34
		y 189
		shiftClick 0
		view 860
		loop 6
		priority 15
		signal $0010
		palette 2
	)
)

(instance waist of PicView
	(properties
		x 120
		y 189
		shiftClick 0
		view 860
		loop 7
		priority 15
		signal $4010
		palette 2
	)
)

(instance torso of Prop
	(properties
		x 118
		y 178
		shiftClick 0
		view 860
		loop 4
		priority 15
		signal $0010
		palette 2
		cycleSpeed 2
	)
)

(instance egoHead of Prop
	(properties
		x 122
		y 130
		shiftClick 0
		view 860
		priority 14
		signal $0010
		palette 2
		cycleSpeed 2
	)
)

(instance leftArm of Prop
	(properties
		x 141
		y 186
		shiftClick 0
		view 860
		loop 2
		priority 14
		signal $0010
		palette 2
		cycleSpeed 2
	)
)

(instance rightArm of Prop
	(properties
		x 91
		y 180
		shiftClick 0
		view 860
		loop 3
		priority 14
		signal $0010
		palette 2
		cycleSpeed 2
	)
)

(instance reins of Prop
	(properties
		x 74
		y 148
		shiftClick 0
		view 860
		loop 1
		priority 14
		signal $0010
		palette 2
		cycleSpeed 3
	)
)

(instance moon of Prop
	(properties
		x 280
		y 71
		description {the moon}
		view 845
		signal $7010
	)
	
	(method (doVerb theVerb)
		(if (and (== theVerb 1) (not (curRoom script?)))
			(Print
				850
				0
				#at
				-1
				20
				#mode
				0
				#width
				250
				28
				12
				35
				theOtherWindow
			)
		)
	)
)

(instance Title of View
	(properties
		x 155
		y 15
		shiftClick 0
		view 850
		priority 15
		signal $0010
		palette 2
	)
)

(instance creditWindow of SysWindow
	(properties
		back 12
	)
)

(instance theOtherWindow of SysWindow
	(properties
		back 11
	)
)

(instance rollTheCredits of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0 (= cycles 1))
			(1
				(SetCursor theCursor 0)
				(= cycles 20)
			)
			(2 (self changeState: 4))
			(3 (= cycles 20))
			(4 (Title show:) (= seconds 3))
			(5
				(localproc_0077)
				(moon x: (+ (moon x?) 4) y: (- (moon y?) 1))
				(if (== local2 20) (= seconds 6) else (= seconds 3))
			)
			(6
				(DisposeDialog)
				(= cycles 5)
			)
			(7
				(= temp0 0)
				(switch local1
					(0
						(if (== local2 9) (= temp0 1))
					)
					(1
						(if (== local2 17) (= temp0 1))
					)
					(2
						(if (== local2 19) (= temp0 1))
					)
					(3
						(if (== local2 20) (= temp0 1))
					)
					(else  (= temp0 1))
				)
				(if temp0
					(if (== (++ local1) 4)
						(self cue:)
					else
						(Title setLoop: (+ (Title loop?) 1) hide:)
						(self changeState: 3)
					)
				else
					(self changeState: 5)
				)
			)
			(8
				(Title dispose:)
				(= cycles 5)
			)
			(9
				(gMiscMusic fade:)
				(Print
					850
					1
					#at
					-1
					20
					#width
					250
					#mode
					1
					#window
					theOtherWindow
					#time
					15
				)
				(theOtherWindow back: 12)
				(Print
					850
					2
					#at
					-1
					20
					#width
					250
					29
					12
					30
					1
					35
					theOtherWindow
					25
					8
				)
				(self cue:)
			)
			(10
				(features eachElementDo: #dispose release:)
				(gMiscMusic number: 832 playBed:)
				(torso dispose:)
				(egoHead dispose:)
				(leftArm dispose:)
				(rightArm dispose:)
				(reins dispose:)
				(curRoom drawPic: 662 41 overlay: 659 41)
				(moon x: (- (moon x?) 320))
				(localproc_004f)
				(DrawFeature quest For glory III)
				(shadows init:)
				(Of init:)
				(darkness init:)
				(= seconds 5)
			)
			(11
				(++ local0)
				(moon setCel: local0)
				(if (and (< 1 local0) (< local0 5))
					(shadows palette: local0 forceUpd:)
					(Of palette: local0 forceUpd:)
					(darkness palette: local0 forceUpd:)
				)
				(= cycles 8)
			)
			(12
				(if (< local0 5)
					(self changeState: 11)
				else
					(= seconds 6)
				)
			)
			(13
				(SetCursor normalCursor (HaveMouse))
				(gMiscMusic stop:)
				(gSpareMusic fade:)
				(self dispose:)
			)
		)
	)
)

(instance quest of PicView
	(properties
		x 122
		y 47
		description {whatever}
		view 846
		priority 15
		signal $4010
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 3)
		)
	)
)

(instance For of PicView
	(properties
		x 134
		y 73
		description {whatever}
		view 846
		cel 1
		priority 15
		signal $4010
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 3)
		)
	)
)

(instance glory of PicView
	(properties
		x 212
		y 77
		description {whatever}
		view 846
		cel 2
		priority 15
		signal $4010
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 3)
		)
	)
)

(instance III of PicView
	(properties
		x 290
		y 75
		description {whatever}
		view 846
		loop 1
		priority 15
		signal $4010
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 3)
		)
	)
)

(instance shadows of View
	(properties
		x 87
		y 149
		description {whatever}
		view 846
		loop 2
		priority 2
		signal $4011
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 3)
		)
	)
)

(instance Of of View
	(properties
		x 174
		y 169
		description {whatever}
		view 846
		loop 2
		cel 1
		priority 15
		signal $4011
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 3)
		)
	)
)

(instance darkness of View
	(properties
		x 254
		y 181
		description {whatever}
		view 846
		loop 2
		cel 2
		priority 15
		signal $4011
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 3)
		)
	)
)

(instance aStar of Prop
	(properties
		description {whatever}
		view 847
		signal $6010
		cycleSpeed 2
	)
	
	(method (doVerb theVerb)
		(if (and (not (curRoom script?)) (== theVerb 1))
			(HighPrint 850 4)
		)
	)
)
