;;; Sierra Script 1.0 - (do not remove this comment)
(script# 367)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Talker)
(use rm360)
(use Timer)
(use Motion)

(public
	enterScript 0
)

(local
	local0
)
(instance enterScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					posn: 160 250
					setCycle: gEgoSW 4
					setMotion: MoveTo 160 180 self
					init:
				)
			)
			(1
				(switch global295
					(0
						(Bset 113)
						(HighPrint 367 1)
						(HighPrint 367 2)
						(= cycles 1)
					)
					(2
						(Bset 113)
						(Say (ScriptID 360 1) self 367 3)
					)
					(5
						(if (Btst 99) (Bset 113) else (Bclr 113))
						(if (not (Bset 119))
							(Say (ScriptID 360 1) self 367 4 367 5 367 6)
						else
							(= cycles 1)
						)
					)
					(7
						(SetInput 0)
						(Say (ScriptID 360 1) 367 7)
						(proc1_32 birdTimer 10)
					)
					(else  (= cycles 1))
				)
			)
			(2
				(switch global295
					(0
						(Say (ScriptID 360 2) self 367 8)
					)
					(5
						(if (Btst 99)
							(Say (ScriptID 360 1) self 367 9)
						else
							(= cycles 1)
						)
					)
					(else  (= cycles 1))
				)
			)
			(3
				(switch global295
					(0
						(Say (ScriptID 360 1) self 367 10 367 11)
						(proc1_32 (ScriptID 360 5) 60)
					)
					(else  (= cycles 1))
				)
			)
			(4 (self dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== global295 7)
				(cond 
					((Said 'n') (client setScript: birdScript 0 0))
					((Said 'affirmative') (client setScript: birdScript 0 1))
					(else (Say (ScriptID 360 1) 367 0))
				)
			)
		)
	)
)

(instance birdScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 0)
				(if register
					(Say (ScriptID 360 1) 367 13)
					(= local0 2)
					(Bset 113)
					(proc1_32 birdTimer 10)
				else
					(Say (ScriptID 360 1) self 367 14)
				)
			)
			(1
				(HighPrint 367 15)
				(Bclr 113)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'sat') (birdTimer dispose:) (pEvent claimed: 0))
			(
			(or (Said 'gave/bird') (Said 'gave[/ferrari,man]/bird'))
				(HighPrint 367 12)
				(birdTimer dispose:)
				(client setScript: (ScriptID 360 6))
			)
			((Said 'n') (= local0 3) (birdTimer cue:))
		)
	)
)

(instance birdTimer of Timer
	(properties)
	
	(method (cue)
		(switch (++ local0)
			(1
				(Say (ScriptID 360 1) 367 16)
				(proc1_32 self 10)
			)
			(3
				(Say (ScriptID 360 1) 367 17)
				(proc1_32 self 5)
			)
			(else 
				(if (ego has: 47)
					(proc360_7 4 {You give him the bird})
				else
					(proc360_7 5 {He still don't got it})
				)
			)
		)
	)
)
