;;; Sierra Script 1.0 - (do not remove this comment)
(script# 291)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use Talker)
(use desertReg)
(use ForCount)
(use Motion)
(use System)

(public
	fakirsPitch 0
	haggleSP 1
	bargainSP 2
	buySP 3
	FakirAppears 4
)

(local
	local0
	local1 =  50
	fakirScript
	local3
	[local4 38] = [1 2 0 3 0 0 0 0 0 4 5 6 0 0 7 0 8 0 9 12 12 0 14 15 16 17 0 0 0 21 0 0 22]
	[local42 10] = [23 '//dinar' 27 '//cent' 24 '//saurii,merchandise' 28 '//cost,cost,line']
	[local52 30]
)
(procedure (FakirAppears)
	(gMiscMusic number: 293 loop: -1 priority: 5 play:)
	(fakir init:)
	((ScriptID 660 1) init:)
)

(instance fakirsPitch of Script
	(properties)
	
	(method (doit)
		(if (not (fakir tCount?)) (super doit: &rest))
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch (++ global271)
					(1
						(Say fakir self 291 13 291 14)
					)
					(2
						(Say fakir self 291 15 291 16)
					)
					(3
						(Say fakir self 291 17 291 18 291 19)
					)
					(4 (Say fakir self 291 20))
					(else 
						(Say fakir self 291 21 291 22 291 23 291 24)
						(Bset 172)
					)
				)
			)
			(1
				(fakir loop: 4 cel: 0 setCycle: ForwardCounter 3 self)
			)
			(2
				(= local3
					(if (< (ego y?) 137)
						(+ (ego y?) 12)
					else
						(- (ego y?) 12)
					)
				)
				(self
					changeState: (if (> global271 3) 301 else (* global271 100))
				)
			)
			(100
				(UnlockEgo)
				(fakir
					illegalBits: 0
					ignoreActors:
					tLoop: -1
					setCycle: Walk
					setMotion: MoveTo 272 137 self
				)
				(Say fakir self 291 25)
			)
			(101
				(fakir setLoop: 6)
				(SetUpEgo)
				(fakir
					caller: 0
					tLoop: -1
					setLoop: -1
					setMotion: MoveTo 146 137 self
				)
				(Say fakir 291 26)
			)
			(102
				(LockEgo)
				(fakir loop: 7 ignoreActors: 0)
				(SetUpEgo)
				(fakir loop: 4 cel: 0 setCycle: ForwardCounter 2)
				(= seconds 4)
			)
			(103
				(fakir tLoop: 2)
				(Say fakir self 291 27)
			)
			(104
				(fakir tLoop: 3)
				(Say fakir self 291 28)
			)
			(105
				(fakir loop: 4 cel: 0 setCycle: ForwardCounter 3)
				(= seconds 5)
			)
			(106
				(fakir tLoop: 2)
				(Say fakir self 291 29)
			)
			(107
				(fakir tLoop: 3)
				(Say fakir self 291 30)
			)
			(108
				(fakir loop: 4 setCycle: ForwardCounter 3 self)
			)
			(109
				(fakir tLoop: 2)
				(Say fakir self 291 31)
			)
			(110
				(fakir tLoop: 3)
				(Say fakir self 291 32)
			)
			(111
				(fakir loop: 4 setCycle: ForwardCounter 4 self)
			)
			(112 (fakir setScript: puffEtc))
			(200
				(UnlockEgo)
				(fakir
					illegalBits: 0
					ignoreActors:
					tLoop: -1
					setCycle: Walk
					setMotion: MoveTo 250 137 self
				)
				(Say fakir 291 33 291 34)
			)
			(201
				(fakir setLoop: 6)
				(SetUpEgo)
				(fakir setLoop: -1 setMotion: MoveTo 150 137 self)
			)
			(202
				(LockEgo)
				(fakir loop: 7 ignoreActors: 0)
				(SetUpEgo)
				(fakir loop: 4 setCycle: ForwardCounter 5)
				(= seconds 4)
			)
			(203
				(fakir tLoop: 2)
				(Say fakir self 291 35)
			)
			(204
				(fakir tLoop: 3)
				(Say fakir self 291 36)
			)
			(205
				(fakir loop: 4 setCycle: ForwardCounter 5 self)
			)
			(206 (fakir setScript: puffEtc))
			(300
				(fakir tLoop: 2)
				(Say fakir self 291 37 291 38)
			)
			(301
				(fakir loop: 4 setCycle: ForwardCounter 5 self)
			)
			(302
				(fakir tLoop: 2)
				(Say fakir self 291 39)
			)
			(303 (fakir setScript: puffEtc))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine') (pEvent claimed: 0))
			((Said 'n')
				(fakir tLoop: 2)
				(switch (++ global315)
					(1 (Say fakir 291 0 291 1))
					(2 (Say fakir 291 2 291 3))
					(3 (Say fakir 291 4 291 5))
					(else 
						(Say fakir 291 6)
						(= global315 0)
					)
				)
			)
			(
				(or
					(Said 'affirmative')
					(Said 'made/deal')
					(Said 'deal')
					(Said 'buy/saurii')
				)
				(curRoom setScript: haggleSP)
			)
			((Said 'bargain') (curRoom setScript: bargainSP))
			(
			(Said 'look,examine,mount,ride,climb,scale,get,acquire') (pEvent claimed: 0))
			(else
				(pEvent claimed: 1)
				(switch (++ global316)
					(1
						(fakir tLoop: 3)
						(Say fakir 291 7)
					)
					(2
						(fakir tLoop: 2)
						(Say fakir 291 8 291 9 291 10 291 11)
					)
					(3
						(fakir tLoop: 3)
						(Say fakir 291 12)
					)
					(else 
						(fakir tLoop: 2)
						(Say fakir 291 6)
						(= global316 0)
					)
				)
			)
		)
	)
)

(instance puffEtc of Script
	(properties)
	
	(method (changeState)
		(switch (Random 0 2)
			(0
				(fakir setLoop: 2 cel: 0 setCycle: CT 4 1 self)
			)
			(1
				(fakir setLoop: 3 cel: 0)
				(= cycles (Random 8 16))
			)
			(2
				(fakir
					setLoop: 4
					setCycle: ForwardCounter (Random 2 5) self
				)
			)
		)
	)
)

(instance haggleSP of Script
	(properties)
	
	(method (doit)
		(if (not (fakir tCount?)) (super doit: &rest))
	)
	
	(method (dispose)
		(super dispose: &rest)
		(SetControl 0)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global315 0)
				(= global316 0)
				(fakir tLoop: 3)
				(Say fakir self 291 55 291 56 291 57)
			)
			(1
				(Say
					fakir
					(Format
						@local52
						291
						58
						(switch local1
							(50 {fifty})
							(40 {forty})
							(30 {thirty})
							(20 {twenty})
							(10 {ten})
							(5 {five})
						)
					)
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'n')
				(switch local1
					(50
						(fakir tLoop: 3)
						(Say fakir 291 40 291 41)
						(= local1 40)
					)
					(40
						(fakir tLoop: 2)
						(Say fakir 291 42)
						(= local1 30)
					)
					(30
						(fakir tLoop: 2)
						(Say fakir 291 43)
						(= local1 20)
					)
					(20
						(fakir tLoop: 3)
						(Say fakir 291 44 291 45 291 46 291 47)
						(= local1 10)
					)
					(10
						(fakir tLoop: 2)
						(Say fakir 291 48 291 49)
						(= local1 5)
					)
					(else 
						(fakir tLoop: 3)
						(Say fakir 291 50)
						(fakirsPitch start: 303)
						(= next fakirsPitch)
						(self dispose:)
					)
				)
			)
			(
				(or
					(Said 'affirmative')
					(Said 'made/deal')
					(Said 'deal')
					(Said 'buy/saurii')
				)
				(curRoom setScript: buySP)
			)
			((Said 'bargain') (curRoom setScript: bargainSP))
			(else
				(pEvent claimed: 1)
				(switch (++ global316)
					(1
						(fakir tLoop: 2)
						(Say fakir 291 51 291 52)
						(= local1 40)
					)
					(2
						(fakir tLoop: 3)
						(Say fakir 291 53)
						(= local1 30)
					)
					(3
						(fakir tLoop: 3)
						(Say fakir 291 54)
						(fakirsPitch start: 303)
						(= next fakirsPitch)
						(self dispose:)
					)
				)
			)
		)
	)
)

(instance bargainSP of Script
	(properties)
	
	(method (doit)
		(if (not (fakir tCount?)) (super doit: &rest))
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fakir tLoop: 3)
				(if (TestSkill 13 30)
					(Say fakir self 291 59 291 60)
					(= local1 20)
				else
					(Say fakir self 291 61 291 62)
					(= local1 50)
				)
			)
			(1 (client setScript: buySP))
		)
	)
)

(instance buySP of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 155 148 self)
			)
			(1 (ego setHeading: 315 self))
			(2
				(= next fakirsPitch)
				(fakir tLoop: 3)
				(switch (proc3_0 0 (* local1 100) 1 0 0 1)
					(1
						(if
						(>= (= temp0 (+ [invNum 2] (/ [invNum 1] 100))) 5)
							(Say fakir self 291 63 291 64 291 65)
							(= local1
								(cond 
									((< temp0 10) 5)
									((< temp0 20) 10)
									((< temp0 30) 20)
									((< temp0 40) 30)
									(else 40)
								)
							)
							(= next (ScriptID 291 1))
						else
							(Say fakir self 291 66 291 67 291 68 291 69)
						)
					)
					(0
						(if (>= (+ [invNum 2] (/ [invNum 1] 100)) 10)
							(Say fakir self 291 63 291 64 291 70)
							(= next (ScriptID 291 1))
						else
							(Say fakir self 291 63 291 71)
						)
					)
					(else 
						(fakir tLoop: 2)
						(Bset 45)
						(= next hiSaurusSP)
						(= cycles 1)
					)
				)
			)
			(3
				(if (== next fakirsPitch) (fakirsPitch start: 303))
				(self dispose:)
			)
		)
	)
)

(instance hiSaurusSP of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HighPrint 291 72)
				(fakir tLoop: 2 setScript: 0)
				(Say fakir self 291 73)
			)
			(1
				(Bclr 172)
				(ego setLoop: -1 setMotion: MoveTo 213 146)
				(fakir
					setScript: 0
					setLoop: 5
					cycleSpeed: 1
					moveSpeed: 1
					setCycle: Fwd
					setMotion: MoveTo 135 138 self
				)
			)
			(2
				((ScriptID 290 3) setCycle: End self)
				(ego setMotion: MoveTo 211 146 self)
			)
			(3
				((ScriptID 290 3) stopUpd:)
				(fakir loop: 4 cel: 0)
				((ScriptID 660 1)
					illegalBits: 0
					ignoreActors:
					posn: -30 146
					setCycle: Walk
					setMotion: MoveTo 174 146 self
				)
			)
			(4 (ego setHeading: 270))
			(5
				(ego hide:)
				((ScriptID 660 1)
					view: 297
					loop: 0
					cel: 0
					posn: 174 146
					cycleSpeed: 0
					setCycle: CT 5 1 self
				)
				((ScriptID 290 1)
					setScript: 0
					setLoop: 1
					setCycle: Fwd
					setMotion: MoveTo -30 ((ScriptID 290 1) y?)
				)
			)
			(6
				(gSpareMusic number: 292 loop: 1 play: self)
				((ScriptID 660 1) setCycle: End)
			)
			(7
				(if (cast contains: (ScriptID 290 2))
					((ScriptID 290 2)
						setScript: 0
						setLoop: 1
						setCycle: Fwd
						setMotion: MoveTo -30 ((ScriptID 290 2) y?)
					)
				)
				(AddToScore 618 7)
				(ego get: 50)
				(= cycles 2)
			)
			(8
				(fakir tLoop: 2)
				(Say fakir self 291 74 291 75 291 76)
			)
			(9
				(fakir
					setLoop: 1
					ignoreActors:
					moveSpeed: 0
					cycleSpeed: 0
					setCycle: Fwd
					setMotion: MoveTo (- (fakir x?) 25) (fakir y?) self
				)
				(ego posn: 210 146 show:)
				((ScriptID 660 1)
					ignoreActors: 0
					posn: 168 146
					view: 11
					cel: 2
				)
				((ScriptID 290 1) dispose:)
				((ScriptID 290 2) dispose:)
			)
			(10
				(fakir setMotion: MoveTo -32 126 self)
				((ScriptID 290 3) setCycle: Beg)
			)
			(11
				(Bset 173)
				(curRoom notify:)
				(gMiscMusic fade:)
				(proc660_10)
				((ScriptID 290 3) stopUpd:)
				(fakir dispose:)
				(self dispose:)
			)
		)
	)
)

(instance fakir of Talker
	(properties
		x 148
		y 141
		description {the familiar-looking little fellow}
		lookStr {You'd Bet Your Life that you've seen this guy before.}
		view 292
		loop 4
		xStep 4
		tLoop 2
		talkSpeed 0
		myName '//fakir,ali,man,merchant,merchant'
		title {Ali Fakir:}
		color 1
		back 11
		msgFile 292
	)
	
	(method (atSpec param1)
		(return [local42 param1])
	)
	
	(method (atGen param1)
		(return [local4 param1])
	)
	
	(method (showText param1)
		(FaceObject ego self)
		(= fakirScript (fakir script?))
		(fakir setScript: 0)
		(= tLoop (Random 2 3))
		(switch param1
			(12 (self showMany: param1 13))
			(17 (self showMany: param1 20))
			(24 (self showMany: param1 26))
			(9 (self showMany: param1 11))
			(else 
				(self messages: 292 param1)
			)
		)
	)
	
	(method (endTalk)
		(super endTalk: &rest)
		(if fakirScript
			(fakir setScript: fakirScript)
		else
			(fakir cel: 0)
		)
	)
)
