;;; Sierra Script 1.0 - (do not remove this comment)
(script# 665)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Intrface)
(use desertReg)
(use PolyPath)
(use Polygon)
(use MoveFwd)
(use LoadMany)
(use Timer)
(use Grooper)
(use Music)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	desert 0
	proc665_1 1
)

(local
	local0 =  660
	local1
	[local2 3]
	local5
	local6
	gEgoX_2
	gEgoY
	local9
	local10
	local11 =  100
	local12
	local13
	newActor
	local15 =  832
	local16
	local17
	local18
	gEgoX_3
	gEgoY_2
	local21
	local22
	[thirstDeathTime 40]
	[local63 100]
	[local163 10] = [-650 1296 -780 1300 -640 1307 -620 6303 -880 8700]
	[local173 4] = [-630 4295]
	[local177 8]
	[local185 8]
	[local193 8] = [0 0 1 0 1 1 0 1]
	[local201 8]
	[local209 4] = [5 41 4 40]
	[local213 6] = [680 680 680 670 670 675]
	[local219 6] = [685 685 695 695 670 675]
	[local225 10] = [680 '/bandit,man' 671 '/scorpion' 675 '/dinosaur,(saurii<terror)' 685 '/ghoul,skeleton' 695 '/jackal,(man<jackal),jackal']
	[local235 10] = [{Damn} {Rats} {Shoot} {Blast} {Argh} {Ack} {Camel Dung} {#@!%$} {Snarl} {Glastnost}]
	[local245 6] = [{Albuquerque___152,700 cubits} {Hours: Mon - Fri__8:00 - 5:00} {Keep off the grass} {Desertside litter removal crews next 3 dunes} {Maximum Speed 1.5} {Downtown Shapeir next exit}]
	[local251 4] = [{Aye, 'tis a rock.} {The rock reflects the desert heat.} {The rock is made of red sandstone.} {This rock looks, predictably, much like any other desert rock.}]
	[local255 4] = [{One of few living things in the desert.} {The plant seems to have adapted to the desert heat.} {The dry heat of the desert has stunted the plant's growth.} {If it were larger, you could sit in the shade.}]
	[local259 6] = [{The blazing desert sun beats down fiercely on your head.} {It is amazing that anything can survive in the furnace-like desert.} {The hot desert air scorches your throat as you breathe.} {The searing desert heat seems to draw the water right out of you.} {The sound of your footsteps seem to echo "water" in your ears.} {Without water, you would not survive even an hour in the desert.}]
)
(procedure (proc665_1 &tmp temp0 temp1 temp2 temp3 temp4 egoX)
	(= temp2 (localproc_15d1 (featPolyL points?) 2))
	(= temp3 (localproc_15d1 (featPolyR points?) 0))
	(if (== (featPolyL points?) @local193) (= temp2 0))
	(if (== (featPolyR points?) @local193) (= temp3 320))
	(if (== egoWalkMode 3)
		(= egoX (ego x?))
	else
		(= egoX (local9 x?))
	)
	(= temp0 (- egoX temp2))
	(= temp1 (- temp3 egoX))
	(= temp4 0)
	(cond 
		((< temp0 48) (= temp4 (- temp0)))
		((< temp1 48) (= temp4 temp1))
	)
	(return temp4)
)

(procedure (localproc_0b74 param1 param2 &tmp temp0 temp1)
	(if (< (= temp1 param1) 0)
		(= temp0 0)
		(while [local163 temp0]
			(if (== param1 [local163 temp0])
				(= temp1 [local163 (+ temp0 1)])
				(break)
			)
			(= temp0 (+ temp0 2))
		)
		(if (< temp1 0)
			(Printf 665 15 temp1 param2)
			(= temp1 1300)
			(= param2 3)
			(ego posn: 160 70)
		)
	)
	(if (and (>= temp1 5000) (>= param1 0))
		(= param2 (localproc_16c3 param2))
	)
	(switch param2
		(1 (= temp1 (- temp1 1000)))
		(3 (= temp1 (+ temp1 1000)))
		(2 (++ temp1))
		(4 (-- temp1))
	)
	(= temp0 1)
	(while [local163 temp0]
		(if (== temp1 [local163 temp0])
			(return [local163 (- temp0 1)])
		)
		(= temp0 (+ temp0 2))
	)
	(return temp1)
)

(procedure (localproc_0c59 theGTheGNorth_2 param2 &tmp temp0 theDefaultPalette temp2 theGTheGNorth temp4 temp5 temp6 temp7)
	(= theGTheGNorth gTheGNorth)
	(= gTheGNorth theGTheGNorth_2)
	(= local13 0)
	(= defaultPalette 0)
	(= temp0 (& theGTheGNorth_2 $0003))
	(= theDefaultPalette (& theGTheGNorth_2 $0002))
	(cond 
		((< theGTheGNorth_2 2000) (= local0 (+ 666 temp0)) (= local13 1))
		((< theGTheGNorth_2 3000) (= local0 (+ 662 temp0)))
		((< theGTheGNorth_2 4000)
			(= local0 (+ 660 (& theGTheGNorth_2 $0001)))
			(= defaultPalette theDefaultPalette)
		)
		((< theGTheGNorth_2 5000)
			(= local0 (+ 660 (- 1 (& theGTheGNorth_2 $0001))))
			(= defaultPalette theDefaultPalette)
		)
		((< theGTheGNorth_2 6000)
			(= local0 (+ 660 (- 1 (& theGTheGNorth_2 $0001))))
			(= defaultPalette (- 2 theDefaultPalette))
		)
		((< theGTheGNorth_2 7000)
			(= local0 (+ 660 (& theGTheGNorth_2 $0001)))
			(= defaultPalette (- 2 theDefaultPalette))
		)
		((< theGTheGNorth_2 8000) (= local0 (+ 660 (- 5 temp0))))
		(else (= local0 (+ 660 (- 9 temp0))) (= local13 1))
	)
	(= local6 0)
	(if isNightTime
		(++ defaultPalette)
		(if (not local13) (= local6 1))
	)
	(if (>= theGTheGNorth_2 5000)
		(= param2 (localproc_16c3 param2))
	)
	(= temp2 [local209 (- param2 1)])
	(cond 
		((> theGTheGNorth 0))
		((== temp2 41) (= temp2 3))
		((== temp2 40) (= temp2 2))
	)
	(curRoom style: temp2 drawPic: local0 picture: local0)
	(= temp5 (mod theGTheGNorth_2 37))
	(= temp6 (mod theGTheGNorth_2 31))
	(cond 
		((< temp5 12)
			(localproc_137b 1 theGTheGNorth_2 0)
			(featPolyL points: @local177)
		)
		((< temp5 24)
			(localproc_137b 0 theGTheGNorth_2 0)
			(featPolyL points: @local177)
		)
		(else (featPolyL points: @local193))
	)
	(cond 
		((< temp6 12)
			(localproc_137b 1 theGTheGNorth_2 1)
			(featPolyR points: @local185)
		)
		((< temp6 24)
			(localproc_137b 0 theGTheGNorth_2 1)
			(featPolyR points: @local185)
		)
		(else (featPolyR points: @local193))
	)
	(if local6
		(curRoom overlay: 659 100)
		(if (>= theGTheGNorth_2 5000)
			(stellar1
				cel: 0
				x: 208
				y: 72
				noun: '/star,constellation<dragon'
				description: {the Dragon constellation}
				lookStr: {The star pattern known as the Dragon.}
			)
			(stellar2
				cel: 1
				x: 86
				y: 36
				noun: '/star,constellation<scorpion'
				description: {the Scorpion constellation}
				lookStr: {The sign of the Scorpion.}
			)
		else
			(stellar1
				cel: 2
				x: 273
				y: 65
				noun: '/star,constellation<hand'
				description: {the Dark Hand constellation}
				lookStr: {The stars here appear to form a Dark Hand.}
			)
			(stellar2
				cel: 3
				x: 67
				y: 43
				noun: '/star,constellation<saurii'
				description: {the Saurus constellation}
				lookStr: {This constellation is said to resemble a Saurus.}
			)
		)
		(DrawFeature stellar1 stellar2)
	)
	(cond 
		((and gGHealth (not local13))
			(= monsterInRoom 655)
			(= gHealth gGHealth)
			((ScriptID 655 0) initAmbush:)
		)
		((and monsterInRoom gHealth)
			(= local10 (ScriptID monsterInRoom 0))
			(if (== prevRoomNum 666)
				(= local12 (local10 attackRange?))
				(local10
					x: 130
					y: 160
					heading: 90
					attackRange: 0
					initChase: 0
				)
				(ChangeEgoWalk 1 0)
				(UnlockEgo)
				(ego setMotion: Flee local10)
			else
				(SetControl 0)
				(if
					(or
						(< local11 350)
						(and (== monsterInRoom 695) (< currentTimeZone 5))
					)
					(if (== gTopExit 3) (local10 y: 170))
					(if local12 (local10 attackRange: local12))
					(local10 initChase: local11)
				else
					(if (cast contains: local10) (local10 dispose:))
					(= monsterInRoom 0)
					(= jackalmenInRoom 0)
					(= centimesOnMonster 0)
					(= local5 0)
				)
			)
		)
		((localproc_1163))
		(
			(and
				(!= egoWalkMode 3)
				(ego has: 50)
				(== gTheGNorth gGTheGNorth)
				(not (cast contains: deadBody))
			)
			(local9
				view: 298
				setLoop: (< (ego x?) 160)
				posn: 160 180
				init:
				setScript: sheepScript
			)
		)
	)
	(= gEgoX_2 (ego x?))
	(= gEgoY (ego y?))
	(if
		(or
			(and
				(== (= temp7 (/ theGTheGNorth 1000)) 4)
				(== gTopExit 3)
			)
			(and (== temp7 5) (== gTopExit 1))
		)
		(= gEgoX_2 (- 320 gEgoX_2))
	)
	(switch param2
		(-1)
		(3
			(ego posn: gEgoX_2 60)
			(if
				(or
					monsterInRoom
					(> (Random 0 5) 1)
					(not (proc660_4 (ego x?) (ego y?) 2 0))
				)
				(ego setScript: (ScriptID 660 2))
			else
				(ego setScript: (ScriptID 660 8))
			)
		)
		(else 
			(ego setScript: egoEnters 0 param2)
		)
	)
)

(procedure (localproc_1163 &tmp temp0 temp1)
	(= temp0 0)
	(if
		(and
			(> currentDay 2)
			(not (Random 0 8))
			(not (cast contains: deadBody))
			(not isNightTime)
		)
		(switch (++ desertEasterEgg)
			(1
				(arthur x: (if (< (ego x?) 160) 220 else 120) init:)
				(= temp0 1)
			)
			(2
				(switch (curRoom picture?)
					(662
						(gulfFlag x: 74)
						(DrawFeature gulfFlag)
						(gulfer posn: 43 129 setCycle: gulfCycle init:)
						(= temp0 1)
					)
					(663
						(gulfFlag x: 246)
						(DrawFeature gulfFlag)
						(gulfer posn: 277 129 setCycle: gulfCycle init:)
						(= temp0 1)
					)
					(else  (-- desertEasterEgg))
				)
			)
			(3
				((= newActor (Actor new:))
					view: 660
					setLoop: 7
					setCel: 1
					x: -50
					y: 40
					xStep: 10
					init:
					setMotion: MoveTo 350 40
					noun: '/airplane,airplane,airplane,mirage'
					lookStr: {It's just a Mirage.}
					description: {the Mirage}
				)
				(= temp0 1)
			)
			(4
				(theSign lookStr: [local245 (Random 0 5)])
				(DrawFeature theSign)
				(-- desertEasterEgg)
				(= temp0 1)
			)
		)
	)
	(return temp0)
)

(procedure (localproc_12e0 &tmp [temp0 20] [temp20 4] temp24 temp25)
	(if (== (++ local15) 900)
		(StrCpy @temp0 {Um... That's a gimme.})
	else
		(Format @temp0 665 16 [local235 (Random 0 9)] local15)
	)
	(TextSize @[temp20 0] @temp0 userFont 0)
	(= temp24 [temp20 3])
	(= temp25
		(if (> (gulfer x?) 160) (- 300 temp24) else 20)
	)
	(Print
		@temp0
		#title
		{Persian Golfer}
		#at
		temp25
		20
		#width
		temp24
		#dispose
	)
	(gulfer z: (- (gulfer z?) 1))
)

(procedure (localproc_137b param1 param2 param3 &tmp newRock temp1 temp2 temp3 temp4 temp5 temp6 temp7 temp8 temp9 temp10 temp11)
	(if param3
		(= temp1 (+ (* (mod param2 10) 10) (/ param2 10)))
	else
		(= temp1 (+ (* (mod param2 10) 100) (/ param2 100)))
	)
	(= temp5
		(*
			(= temp2 (+ (mod (= param2 (+ param2 temp1)) 11) 1))
			10
		)
	)
	(if param3 (= temp5 (- 320 temp5)))
	(= temp6 (+ 150 (* temp2 2)))
	(= temp3
		(+ 3 (> (= temp4 (mod (+ temp2 param3) 8)) 3))
	)
	(if param1 (= temp3 (+ temp3 2)))
	(= temp4 (- temp4 (* 4 (> temp4 3))))
	(if param1
		((= newRock (rock new:))
			cel: (if (and (== gTheGNorth 6300) (not param3))
				4
			else
				temp4
			)
			lookStr: [local251 (Random 0 3)]
		)
	else
		((= newRock (bush new:))
			cel: temp4
			lookStr: [local255 (Random 0 3)]
		)
	)
	(newRock
		loop: temp3
		x: temp5
		y: temp6
		palette: (+ isNightTime 1)
	)
	(DrawFeature newRock)
	(= temp8 (- (newRock nsLeft?) 10))
	(= temp9 (- (newRock nsBottom?) 15))
	(= temp10 (+ (newRock nsRight?) 10))
	(= temp11 (+ (newRock nsBottom?) 5))
	(= temp7 (if param3 @local185 else @local177))
	(localproc_15f7 temp7 0 (Max temp8 0))
	(localproc_15f7 temp7 1 (Max temp9 0))
	(localproc_15f7 temp7 2 (Min temp10 320))
	(localproc_15f7 temp7 3 (Max temp9 0))
	(localproc_15f7 temp7 4 (Min temp10 320))
	(localproc_15f7 temp7 5 (Min temp11 190))
	(localproc_15f7 temp7 6 (Max temp8 0))
	(localproc_15f7 temp7 7 (Min temp11 190))
)

(procedure (localproc_1572 &tmp temp0 temp1 temp2)
	(= temp0 (- 70 (* 20 arcadeDifficultyLevel)))
	(= temp1 (- 90 (* 20 arcadeDifficultyLevel)))
	(= temp2 (Random temp0 temp1))
	(if isNightTime (= temp2 (/ temp2 2)))
	(proc1_32 monsterTimer temp2)
)

(procedure (localproc_15ab &tmp temp0)
	(= temp0
		(+
			(if (== egoWalkMode 3) 60 else 30)
			(* 60 isNightTime)
		)
	)
	(proc1_32 drinkTimer temp0)
)

(procedure (localproc_15d1 param1 param2)
	(if (== argc 1) (= param2 0))
	(return
		(|
			(StrAt param1 (* param2 2))
			(<< (StrAt param1 1) $0008)
		)
	)
)

(procedure (localproc_15f7 param1 param2 param3)
	(StrAt param1 (+ 0 (* param2 2)) (& param3 $00ff))
	(StrAt
		param1
		(+ 1 (* param2 2))
		(& (>> param3 $0008) $00ff)
	)
)

(procedure (localproc_16c3 param1)
	(return
		(if (> param1 0)
			(return (+ (& (+ param1 1) $0003) 1))
		else
			(return param1)
		)
	)
)

(instance desert of Rm
	(properties)
	
	(method (init &tmp thePrevRoomNum)
		(LoadMany 129 659 660 661 662 663 664 665 666 667 668 669)
		(LoadMany 128 0 5 11 12 13 14 15 47 298 660 83 84)
		(Load rsSOUND 291 660 661)
		(if (< currentDay 12)
			(= [local173 0] (= [local173 1] 0))
		)
		(if (== (= thePrevRoomNum prevRoomNum) 666)
			(= gTopExit -1)
			(= thePrevRoomNum gTheGNorth)
		else
			(= gTheGNorth (- thePrevRoomNum))
			(= thePrevRoomNum (localproc_0b74 gTheGNorth gTopExit))
			(= global304 0)
		)
		(proc1_19)
		(ego x: 170 y: 175 init:)
		(= picture 0)
		(= gGDftSC desertChecker)
		(= useObstacles 1)
		(super init: &rest)
		(self setRegions: 660)
		(gCMusic number: 660 priority: 0 loop: -1 playBed:)
		(if isNightTime (nightSound play:))
		(= local9 (ScriptID 660 1))
		(featPolyL points: @local177 size: 4)
		(featPolyR points: @local185 size: 4)
		(bodyPoly points: @local201 size: 4)
		(self addObstacle: featPolyL featPolyR)
		(switch global304
			(0
				(if
				(or (== monsterInRoom 655) (not monsterInRoom))
					(localproc_1572)
				)
			)
			(58
				(switch monsterInRoom
					(670
						(deadBody
							view: 671
							loop: 7
							cel: 2
							init:
							noun: '/scorpion,body,monster,creature'
							lookStr: {It is a thoroughly dead Scorpion.}
							description: {the dead Scorpion}
						)
						(= local16 -6)
						(= local18 35)
						(AddToScore 674 3 0)
					)
					(675
						(deadBody
							view: 675
							loop: 2
							cel: 6
							init:
							noun: '/dinosaur,(saurii<terror),body,monster,creature'
							lookStr: {The Terrorsaurus is quite dead.}
							description: {the dead Terrorsaurus}
						)
						(= local16 18)
						(= local18 15)
						(AddToScore 673 3 0)
					)
					(680
						(deadBody
							view: 680
							loop: 2
							cel: 4
							init:
							noun: '/bandit,man,body,monster,creature'
							lookStr: {It is a recently-croaked brigand.}
							description: {the dead brigand}
						)
						(= local16 25)
						(= local18 20)
						(AddToScore 670 3 0)
					)
					(685
						(deadBody
							view: 685
							loop: 2
							cel: 2
							init:
							noun: '/ghoul,skeleton,body,monster,creature'
							lookStr: {You have killed the Ghoul.__Again.}
							description: {the re-dead Ghoul}
						)
						(= local16 25)
						(= local18 20)
						(AddToScore 671 3 0)
					)
					(695
						(deadBody
							view: 695
							loop:
							(switch centimesOnMonster
								(1 2)
								(2 12)
								(else  13)
							)
							cel: 3
							posn: 140 150
							init:
							noun: '/jackal,(man<jackal),jackal,body,monster,creature'
						)
						(if (== centimesOnMonster 1)
							(deadBody
								lookStr: {It is a dead Jackalman.}
								description: {the dead Jackalman}
							)
						else
							(deadBody
								lookStr: {They are dead Jackalmen.}
								description: {the dead Jackalmen}
							)
						)
						(= local16 25)
						(= local17 20)
						(= local18 15)
						(AddToScore 672 3 0)
					)
				)
				(if (!= monsterInRoom 655)
					(= [local201 0]
						(= [local201 6] (- (deadBody brLeft?) 10))
					)
					(= [local201 1]
						(= [local201 3] (- (deadBody brBottom?) local18))
					)
					(= [local201 2]
						(= [local201 4] (+ (deadBody brRight?) 10))
					)
					(= [local201 5]
						(= [local201 7] (+ (deadBody brBottom?) 5))
					)
					(self addObstacle: bodyPoly)
				)
				(if
				(or (!= monsterInRoom 695) (not jackalmenInRoom))
					(= monsterInRoom (= gHealth 0))
				)
				(localproc_1572)
			)
		)
		(= global304 0)
		(localproc_15ab)
		(if (not isNightTime) (proc1_32 msgTimer 45 60))
		(localproc_0c59 thePrevRoomNum gTopExit)
		(= local1 1)
	)
	
	(method (doit)
		(cond 
			(script (script doit:))
			((ego script?))
			(
				(and
					(cast contains: arthur)
					(not (arthur cycler?))
					(< (ego distanceTo: arthur) 60)
				)
				(arthur setCycle: End arthur)
			)
			((!= curRoomNum newRoomNum))
			(local5 (= local5 0) (self setScript: prepCombat))
			((= gTopExit (ego edgeHit?)) (self setScript: walkOff 0 gTopExit))
			((& (ego onControl:) $0004)
				(if
					(or
						(> (Random 0 5) 1)
						(not (proc660_4 (ego x?) (ego y?) 2 1))
					)
					(ego setScript: (ScriptID 660 3))
				else
					(ego setScript: (ScriptID 660 9))
				)
			)
			(
				(and
					monsterInRoom
					(or (cast contains: local10) (== monsterInRoom 655))
				)
				(cond 
					((== egoWalkMode 3) (ego setScript: throwEgo))
					(
						(and
							(cast contains: local9)
							(local9 inRect: 0 0 320 190)
							(not (local9 mover?))
						)
						(local9 setMotion: Flee local10)
					)
				)
			)
		)
	)
	
	(method (dispose)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(= defaultPalette 0)
		(if (sounds contains: nightSound) (nightSound dispose:))
		(gCMusic stop:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(cond 
			((Said 'go/home') (monsterTimer dispose:) (pEvent claimed: 0))
			(
				(and
					monsterInRoom
					(Said
						'mount,ride,(climb,scale,get,acquire<on,up)[/saurii,roget]'
					)
				)
				(HighPrint 665 0)
			)
			((super handleEvent: pEvent))
			((Said 'get,acquire/blade,weapon')
				(if
					(and
						(cast contains: deadBody)
						(OneOf (deadBody view?) 680 695)
					)
					(HighPrint 665 1)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'look,examine/tail,stinger')
				(cond 
					((not (cast contains: deadBody)) (HighPrint 665 2))
					((OneOf (deadBody view?) 685 680) (HighPrint 665 3))
					((== (deadBody view?) 671) (HighPrint 665 4))
				)
			)
			((Said 'look,examine/claw,nail,bone,hand,finger')
				(cond 
					((not (cast contains: deadBody)) (HighPrint 665 2))
					((== (deadBody view?) 680) (HighPrint 665 5))
					((== (deadBody view?) 685) (HighPrint 665 6))
				)
			)
			(
			(Said 'get,acquire,chop,search,acquire/tail,stinger')
				(cond 
					((not (cast contains: deadBody)) (HighPrint 665 2))
					((OneOf (deadBody view?) 685 680) (HighPrint 665 3))
					(local21 (HighPrint 665 7))
					((== (deadBody view?) 671)
						(HighPrint 665 8)
						(ego get: 29)
						(= local21 1)
						(AddToScore 669 5 0)
					)
					(else (HighPrint 665 9))
				)
			)
			(
				(Said
					'get,acquire,chop,search,acquire/claw,nail,bone,hand,finger'
				)
				(cond 
					((not (cast contains: deadBody)) (HighPrint 665 10))
					((OneOf (deadBody view?) 680 671) (HighPrint 665 11))
					(local22 (HighPrint 665 12))
					((== (deadBody view?) 685)
						(HighPrint 665 13)
						(ego get: 30 2)
						(= local22 1)
						(AddToScore 668 5 0)
					)
					(else (HighPrint 665 14))
				)
			)
			((Said 'search,strip>')
				(if (cast contains: deadBody)
					(= temp1 0)
					(while (< temp1 10)
						(if (== [local225 temp1] (deadBody view?))
							(= temp0 [local225 (+ temp1 1)])
							(break)
						)
						(= temp1 (+ temp1 2))
					)
					(if
						(or
							(Said '/body,monster,alm,loot')
							(Said '[/!*]')
							(Said temp0)
						)
						(ego setScript: searchBody)
					else
						(pEvent claimed: 1)
						(HighPrint 665 2)
					)
				)
			)
			((cast contains: local10)
				(cond 
					((Said 'attack,attack,kill') (self setScript: prepCombat))
					((Said 'run,escape')
						(if (!= egoWalkMode 3) (ChangeEgoWalk 1 0))
						(ego setMotion: Flee local10)
					)
				)
			)
		)
	)
	
	(method (newRoom newRoomNumber &tmp egoLooper)
		(= local5 0)
		(if (and monsterInRoom (not gGHealth))
			(= local11 (ego distanceTo: local10))
		)
		(if (and (!= newRoomNumber 666) (<= gHealth 0))
			(= monsterInRoom 0)
			(if (cast contains: local10) (local10 endCombat:))
		)
		(features eachElementDo: #dispose release:)
		(if modelessDialog (DisposeDialog))
		(switch desertEasterEgg
			(1
				(if (cast contains: arthur) (arthur dispose:))
			)
			(2
				(if (cast contains: gulfer)
					(DisposeDialog)
					(gulfer dispose:)
				)
			)
			(3
				(if (cast contains: newActor) (newActor dispose:))
			)
		)
		(if (cast contains: deadBody)
			(deadBody dispose: delete:)
			(obstacles delete: bodyPoly)
			(= local21 (= local22 0))
		)
		(if
			(and
				(cast contains: local9)
				(local9 inRect: 0 0 320 190)
			)
			(local9 dispose: delete:)
			(obstacles delete: (ScriptID 660 11))
		)
		(LockEgo 1)
		(self setScript: 0)
		(ego setScript: 0)
		(if (= egoLooper (ego looper?)) (egoLooper dispose:))
		(cond 
			((== newRoomNumber 666)
				(= mouseX (ego x?))
				(= mouseY (ego y?))
				(super newRoom: newRoomNumber)
			)
			(
				(<
					(= newRoomNumber (localproc_0b74 gTheGNorth gTopExit))
					0
				)
				(if (>= gTheGNorth 5000)
					(= gTopExit (localproc_16c3 gTopExit))
				)
				(= monsterInRoom (= gHealth 0))
				(super newRoom: (- newRoomNumber))
			)
			(else
				(if (and monsterInRoom (cast contains: local10))
					(local10 dispose:)
				)
				(= prevRoomNum desert)
				(if (>= gTheGNorth 5000)
					(= gTopExit (localproc_16c3 gTopExit))
				)
				(localproc_0c59 newRoomNumber gTopExit)
			)
		)
	)
	
	(method (notify param1)
		(if (== param1 54) (= local5 1))
	)
)

(instance nightSound of Sound
	(properties
		number 661
		priority 1
		loop -1
	)
)

(instance featPolyR of Polygon
	(properties
		type $0002
	)
)

(instance featPolyL of Polygon
	(properties
		type $0002
	)
)

(instance bodyPoly of Polygon
	(properties
		type $0002
	)
)

(instance saurusHead of Prop
	(properties
		view 298
	)
)

(instance deadBody of View
	(properties
		x 140
		y 160
		signal $0001
	)
	
	(method (init)
		(= local17 2)
		(super init: &rest)
	)
)

(instance rock of PicView
	(properties
		noun '/boulder'
		description {the rock}
		view 660
		signal $4000
	)
	
	(method (handleEvent pEvent)
		(if
			(and
				(not (== egoWalkMode 3))
				(Said 'get,acquire,(lockpick<up)/boulder')
			)
			(ego setScript: (ScriptID 60))
		else
			(super handleEvent: pEvent)
		)
	)
)

(instance bush of PicView
	(properties
		noun '/bush,bush,tree,plant,cactus'
		description {the plant}
		view 660
		signal $4000
	)
)

(instance arthur of Prop
	(properties
		y 170
		noun '/man,arthur,king'
		description {the man}
		lookStr {He looks vaguely familiar... maybe you've seen him in a camel lot?}
		view 660
		loop 9
		cycleSpeed 1
	)
	
	(method (cue)
		(self dispose:)
	)
)

(instance gulfFlag of PicView
	(properties
		y 150
		noun '/flag'
		description {the golf flag}
		lookStr {It is a golf flag.}
		view 660
		loop 7
	)
)

(instance gulfer of Prop
	(properties
		noun '/man,golfer'
		description {the golfer}
		lookStr {He's participating in the Persian Golf tournament.}
		view 660
		loop 8
		priority 1
		signal $0010
		cycleSpeed 1
	)
)

(instance theSign of PicView
	(properties
		x 160
		y 170
		noun '/sign'
		description {the sign}
		view 660
		loop 7
		cel 2
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'read/sign') (self doVerb: 1))
		)
	)
)

(instance stellar1 of PicView
	(properties
		view 660
		loop 2
		priority 0
		signal $6010
	)
)

(instance stellar2 of PicView
	(properties
		view 660
		loop 2
		priority 0
		signal $6010
	)
)

(class gulfCycle of Fwd
	(properties
		client 0
		caller 0
		cycleDir 1
		cycleCnt 0
		completed 0
		cycles 0
	)
	
	(method (doit)
		(if cycles
			(if (not (-- cycles)) (self cue:))
		else
			(super doit:)
		)
	)
	
	(method (cycleDone)
		(if (< local15 900) (localproc_12e0))
		(= cycles 10)
	)
	
	(method (cue)
		(client cel: 0)
	)
)

(class Flee of PolyPath
	(properties
		client 0
		caller 0
		x 0
		y 0
		dx 0
		dy 0
		b-moveCnt 0
		b-i1 0
		b-i2 0
		b-di 0
		b-xAxis 0
		b-incr 0
		completed 0
		xLast 0
		yLast 0
		value 2
		points 0
	)
	
	(method (init param1 param2 param3)
		(if argc
			(param1
				setLoop: -1
				setPri: -1
				heading: (param2 heading?)
			)
			(if (or local13 (== monsterInRoom 655))
				(if (> (param2 x?) (param1 x?))
					(param1 heading: 200)
				else
					(param1 heading: 160)
				)
			)
			(cond 
				((!= param1 local9))
				((< (param1 heading?) 100) (param1 heading: 100))
				((> (param1 heading?) 260) (param1 heading: 260))
			)
			(super
				init:
					param1
					(+ (param1 x?) (SinMult (param1 heading?) 600))
					(- (param1 y?) (CosMult (param1 heading?) 600))
					(if (>= argc 3) param3 else 0)
			)
		else
			(super init:)
		)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(if (& (client signal?) $0400)
			(client setMotion: MoveTo (client x?) 500)
		)
	)
)

(instance monsterTimer of Timer
	(properties)
	
	(method (cue &tmp [temp0 4])
		(cond 
			(gGHealth)
			((cast contains: deadBody))
			(
				(and
					(cast contains: local9)
					(local9 inRect: 0 0 320 190)
					(!= (local9 view?) 11)
				)
			)
			((or (ego script?) (curRoom script?)))
			((not monsterInRoom)
				(= monsterInRoom (Random 0 5))
				(= monsterInRoom
					(if isNightTime
						[local219 monsterInRoom]
					else
						[local213 monsterInRoom]
					)
				)
				(= gHealth 0)
				(switch monsterInRoom
					(695
						(= jackalmenInRoom (Random 1 5))
						(= dinarsOnMonster
							(+ (* (Random 3 8) 100) (Random 2 50))
						)
					)
					(680
						(= dinarsOnMonster
							(+ (* (Random 2 6) 100) (Random 2 50))
						)
					)
					(else  (= dinarsOnMonster 0))
				)
				((= local10 (ScriptID monsterInRoom 0)) initAmbush:)
			)
		)
		(localproc_1572)
	)
)

(instance msgTimer of Timer
	(properties)
	
	(method (cue &tmp [temp0 40])
		(if (not (cast contains: local10))
			(Print
				(Format @temp0 665 17 [local259 (Random 0 5)])
				#at
				-1
				20
				#dispose
			)
		)
		(proc1_32 self (Random 45 60))
	)
)

(instance drinkTimer of Timer
	(properties)
	
	(method (cue)
		(if
			(and
				(not (DrinkWater 0))
				(not (ReduceHP (* currentWater -10)))
			)
			(if isNightTime
				(= thirstDeathTime {pale desert moon})
			else
				(= thirstDeathTime {hot desert sun})
			)
			(Die
				1
				(Format @local63 665 18 thirstDeathTime)
				80
				{And not a drop to drink}
			)
		)
		(localproc_15ab)
	)
)

(instance desertChecker of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (or (== param1 6) (== param1 28))
				(HighPrint 665 19)
				(return 0)
			else
				(return 1)
			)
		)
	)
)

(instance egoEnters of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(User prevDir: register)
	)
	
	(method (changeState newState &tmp egoLooper temp1 temp2)
		(switch (= state newState)
			(0
				(proc1_19)
				(if (= egoLooper (ego looper?)) (egoLooper dispose:))
				(switch register
					(1
						(= register 1)
						(ego
							loop: 3
							posn: gEgoX_2 210
							setMotion: PolyPath gEgoX_2 187 self
						)
						(= gEgoY 0)
					)
					(2
						(= register 3)
						(if local1
							(ego posn: (- gEgoX_2 320) gEgoY)
						else
							(ego posn: -20 gEgoY)
						)
						(= temp1 (Max (+ (ego x?) 10) 10))
						(= gEgoX_2 350)
						(ego setMotion: PolyPath temp1 gEgoY self)
					)
					(4
						(= register 7)
						(if local1
							(ego posn: (+ gEgoX_2 320) gEgoY)
						else
							(ego posn: 340 gEgoY)
						)
						(= temp1 (Min (- (ego x?) 10) 310))
						(= gEgoX_2 -30)
						(ego setMotion: PolyPath temp1 gEgoY self)
					)
				)
			)
			(1
				(proc1_19)
				(ego setMotion: PolyPath gEgoX_2 gEgoY)
				(self dispose:)
			)
		)
	)
)

(instance walkOff of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(if
					(or
						(== register 3)
						(> (localproc_0b74 gTheGNorth gTopExit) 0)
					)
					(switch register
						(3
							(= temp0 (- (ego nsBottom?) (- (ego nsTop?) 1)))
							(ego
								setMotion: PolyPath (ego x?) (+ (ego y?) temp0) self
							)
						)
						(2
							(ego setMotion: PolyPath (+ (ego x?) 30) (ego y?) self)
						)
						(4
							(ego setMotion: PolyPath (- (ego x?) 30) (ego y?) self)
						)
						(else  (= cycles 1))
					)
				else
					(= cycles 1)
				)
			)
			(1
				(self dispose:)
				(curRoom newRoom: 0)
			)
		)
	)
)

(instance throwEgo of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(if (and local13 (proc1_30 20))
					(ego setMotion: MoveTo (ego x?) (+ (ego y?) 15) self)
				else
					(= cycles 1)
				)
			)
			(1
				(gMiscMusic number: 291 priority: 10 loop: 0 play:)
				(= egoWalkMode 0)
				(ego
					view: 15
					setCycle: 0
					setMotion: 0
					setLoop: (if (< (ego heading?) 180) 0 else 1)
					setCel: 0
				)
				(= cycles 1)
			)
			(2 (ego setCycle: End self))
			(3
				(local9
					view: 11
					posn: (ego x?) (ego y?)
					init:
					loop: (ego loop?)
					setLoop: Grooper
					setPri: -1
					setCycle: Walk
				)
				(= temp0
					(if (ego loop?) (+ (ego x?) 43) else (- (ego x?) 43))
				)
				(ego
					posn: temp0 (+ (ego y?) 4)
					setLoop: (+ (ego loop?) 2)
					setCel: 0
				)
				(= cycles 2)
			)
			(4
				(ego setCycle: End self)
				(= gGTheGNorth gTheGNorth)
				(if local10
					(local9 setMotion: Flee local10)
				else
					(local9 setMotion: MoveTo 160 500)
				)
			)
			(5
				(proc1_19)
				(if (!= monsterInRoom 655)
					(ego setMotion: MoveFwd 15 self)
				else
					(= cycles 2)
				)
			)
			(6 (self dispose:))
		)
	)
)

(instance sheepScript of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(if (not (local9 loop?))
					(= temp0 (+ (local9 x?) 23))
				else
					(= temp0 (- (local9 x?) 23))
				)
				(saurusHead
					x: temp0
					y: (local9 y?)
					z: 32
					setLoop: (+ (local9 loop?) 4)
					setCel: 0
					init:
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(1
				(local9 setLoop: (+ (local9 loop?) 2))
				(saurusHead dispose:)
				(= cycles 1)
			)
			(2
				(proc660_10)
				(if (ego script?)
					((ego script?) next: (ScriptID 660 6))
				else
					(ego setScript: (ScriptID 660 6))
				)
				(self dispose:)
			)
		)
	)
)

(instance prepCombat of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(if (== egoWalkMode 3)
					(= cycles 1)
				else
					(if (ego has: 7) (= temp0 83) else (= temp0 84))
					(ego
						view: temp0
						setLoop: (< (local10 x?) (ego x?))
						cel: 0
						setCycle: End self
					)
				)
			)
			(1
				(self dispose:)
				(curRoom newRoom: 666)
			)
		)
	)
)

(instance searchBody of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1 temp2 temp3)
		(switch (= state newState)
			(0
				(bodyPoly type: 1)
				(= gEgoX_3 (ego x?))
				(= gEgoY_2 (ego y?))
				(= temp2 (+ (deadBody x?) local16))
				(= temp3 (+ (deadBody y?) local17))
				(ego setMotion: PolyPath temp2 temp3 self)
			)
			(1
				(ego view: 47 setLoop: 0 setCel: 0 setCycle: End)
				(= cycles 12)
			)
			(2 (ego setCycle: Beg self))
			(3
				(proc1_19)
				(if dinarsOnMonster
					(if (== (deadBody view?) 695)
						(= dinarsOnMonster (* dinarsOnMonster centimesOnMonster))
					)
					(= temp0 (/ dinarsOnMonster 100))
					(if (= temp1 (mod dinarsOnMonster 100))
						(Format @thirstDeathTime 665 20 temp1)
					else
						(Format @thirstDeathTime 665 21)
					)
					(HighPrint
						(Format @local63 665 22 temp0 @thirstDeathTime)
					)
					(ego get: 2 temp0)
					(ego get: 1 temp1)
					(= dinarsOnMonster 0)
				else
					(HighPrint 665 23)
				)
				(= cycles 1)
			)
			(4
				(if daggersInMonster
					(HighPrint
						(Format @local63 665 24 daggersInMonster)
						(ego get: 5 daggersInMonster)
						(= daggersInMonster 0)
						(= cycles 1)
					)
				else
					(= cycles 1)
				)
			)
			(5
				(ego
					illegalBits: 0
					setMotion: PolyPath gEgoX_3 gEgoY_2 self
				)
			)
			(6
				(bodyPoly type: 2)
				(self dispose:)
			)
		)
	)
)
