;;; Sierra Script 1.0 - (do not remove this comment)
(script# 491)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Intrface)
(use Motion)
(use Actor)
(use System)

(public
	it 0
	disposeRope 1
)

(local
	local0
	[newARope 10]
	local11 =  258
	local12 =  147
	[local13 4] = [-4 0 2]
	[local17 4] = [10 13 17 18]
	[local21 4] = [4 8 5 9]
	[local25 4] = [2 11 16 25]
	local29
	local30
	local31
	local32
	local33
	local34
	local35
	local36
	local37
	local38
	local39
)
(procedure (localproc_000e)
	(return
		(cond 
			((> (Random 50 local35) [skills 2]) (if (< local31 0) (-- local31) else (++ local31)))
			((> local31 0) (-- local31))
			(else (++ local31))
		)
	)
)

(procedure (localproc_0042)
	(= local33 0)
	(cond 
		((> (+ [skills 2] 10) (Random 30 local36))
			(= local31 0)
			(= local32 0)
			(SkillUsed 2 20)
			(localproc_00bb)
		)
		((== (ego loop?) 2) (= local34 1) (ego setScript: dashing))
		((== (ego loop?) 1) (= local34 0) (ego setScript: dashing))
		(else (localproc_0133))
	)
)

(procedure (localproc_00bb)
	(ego
		view: 285
		setLoop: 3
		cel: 0
		setPri: 13
		cycleSpeed: 1
		setCycle: Fwd
	)
)

(procedure (localproc_00e1)
	(ego
		view: 285
		setLoop: 2
		cel: 0
		setPri: 11
		cycleSpeed: 1
		setCycle: Fwd
	)
	(= local33 12)
)

(procedure (localproc_010a)
	(ego
		view: 285
		setLoop: 1
		cel: 0
		setPri: 11
		cycleSpeed: 1
		setCycle: Fwd
	)
	(= local33 12)
)

(procedure (localproc_0133)
	(ego
		view: 285
		loop: 4
		cel: 0
		setPri: 13
		cycleSpeed: 1
		setCycle: Fwd
	)
)

(procedure (localproc_0158)
	(if (> (- [skills 2] (Random 30 local36)) 18)
		(localproc_00e1)
	else
		(localproc_0042)
	)
)

(procedure (localproc_017b)
	(if (> (- [skills 2] (Random 30 local36)) 18)
		(localproc_010a)
	else
		(localproc_0042)
	)
)

(procedure (localproc_019e)
	(cond 
		(
		(> (/ (+ [skills 2] [skills 2]) 2) (Random 50 local35)) (ego setScript: stepForward))
		((== (mod (Random 50 local35) 2) 1) (= local32 1) (localproc_010a))
		(else (= local32 1) (localproc_00e1))
	)
)

(instance it of Actor
	(properties
		x -10
		view 490
		loop 1
	)
	
	(method (init)
		(ego setScript: ropeMe)
		(= local35 79)
		(= local36 79)
		(super init:)
	)
	
	(method (doit)
		(cond 
			((not local30))
			((-- local30))
			(else
				(localproc_000e)
				(= local30 10)
				(if (== (++ local37) 8)
					(= local37 0)
					(SkillUsed 11 10)
				)
			)
		)
		(cond 
			((not local33))
			((-- local33))
			((== (ego loop?) 1) (= local34 0) (ego setScript: dashing))
			((== (ego loop?) 2) (= local34 1) (ego setScript: dashing))
		)
		(cond 
			((< local31 -2) (= local30 0) (= local31 0) (localproc_010a))
			((> local31 2) (= local30 0) (= local31 0) (localproc_00e1))
		)
		(super doit:)
	)
)

(instance aRope of View
	(properties
		description {the magic rope}
		lookStr {It's your magic rope... you know, the one you've carried with you for days and days.}
		view 490
		loop 2
		priority 13
		signal $4010
	)
)

(instance ropeMe of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 294 166 self)
			)
			(1
				(ego view: 8 loop: 1 cel: 0 setCycle: End self)
			)
			(2 (proc1_19) (= cycles 4))
			(3
				(= [newARope local0] (aRope new:))
				([newARope local0] x: local11 y: local12 init: stopUpd:)
				(= cycles 1)
			)
			(4
				(if (< local39 8)
					(++ local39)
					(++ local0)
					(= local11 (- local11 26))
					(= local12 (- local12 2))
					(self changeState: 3)
				else
					(self cue:)
				)
			)
			(5
				(ego setPri: 13 setMotion: MoveTo 292 160 self)
			)
			(6
				(ego view: 3 setPri: 13 loop: 3 cel: 2)
				(= cycles 2)
			)
			(7
				(ego cel: 3 setPri: 13 posn: 285 153)
				(= cycles 2)
			)
			(8
				(ego cel: 4 setPri: 13 posn: 278 150)
				(= cycles 2)
			)
			(9
				(ego cel: 5 setPri: 13 posn: 276 148)
				(= cycles 2)
			)
			(10
				(ego view: 4 setPri: 13 loop: 1 cel: 0 posn: 272 146)
				(= cycles 2)
			)
			(11
				(HighPrint 491 0)
				(ego view: 285 loop: 0 cel: 3 setPri: 13 posn: 263 146)
				(= cycles 2)
			)
			(12
				(curRoom setScript: tightropeWalk)
				(self dispose:)
			)
		)
	)
)

(instance dashing of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local29 0)
				(UnlockEgo)
				(curRoom setScript: 0)
				(= local31 0)
				(ego
					view: 6
					setLoop: (if local34 4 else 2)
					illegalBits: 0
					setPri: (if local34 11 else 14)
					cel: 0
				)
				(= cycles 3)
			)
			(1
				(ego
					cel: (+ (ego cel?) 1)
					x: (+
						(ego x?)
						(if local34 [local21 local29] else [local13 local29])
					)
					y: (+
						(ego y?)
						(if local34 [local25 local29] else [local17 local29])
					)
				)
				(++ local29)
				(= cycles 1)
			)
			(2
				(if (< local29 5)
					(self changeState: 1)
				else
					(= local29 0)
					(self cue:)
				)
			)
			(3 (ego hide:) (= cycles 1))
			(4
				(HighPrint 491 1 80 {Nice of you to drop in!})
				(curRoom newRoom: 790)
				(LockEgo)
			)
		)
	)
)

(instance tightropeWalk of HandsOffScript
	(properties)
	
	(method (init)
		(super init: &rest)
		(gDirH add: self)
		(gMouseH addToFront: self)
		(= local30 10)
		(= local32 0)
	)
	
	(method (dispose)
		(= local33 0)
		(= local30 0)
		(gDirH delete: self)
		(gMouseH delete: self)
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (super handleEvent: pEvent) (return 1))
		(return
			(switch (pEvent type?)
				(evMOUSEBUTTON
					(if (not (ego script?))
						(cond 
							(
								(or
									(<
										(= temp0
											(GetAngle (ego x?) (ego y?) (pEvent x?) (pEvent y?))
										)
										45
									)
									(> temp0 315)
								)
								(if (== (ego loop?) 2)
									(= local34 1)
									(ego setScript: dashing)
								else
									(localproc_0158)
								)
							)
							((and (< 135 temp0) (< temp0 225))
								(if (== (ego loop?) 1)
									(= local34 0)
									(ego setScript: dashing)
								else
									(localproc_017b)
								)
							)
							((and (< 225 temp0) (< temp0 315)) (if (not local32) (localproc_019e)))
							((and (< 45 temp0) (< temp0 135)) (localproc_0133))
						)
					)
				)
				(evJOYSTICK
					(pEvent claimed: 1)
					(if (!= (ego script?) stepForward)
						(switch (pEvent message?)
							(JOY_LEFT
								(if (not local32) (localproc_019e))
							)
							(JOY_RIGHT (localproc_0133))
							(JOY_DOWN
								(if (== (ego loop?) 1)
									(= local34 0)
									(ego setScript: dashing)
								else
									(localproc_017b)
								)
							)
							(JOY_UP
								(if (== (ego loop?) 2)
									(= local34 1)
									(ego setScript: dashing)
								else
									(localproc_0158)
								)
							)
						)
					)
				)
			)
		)
	)
)

(instance stepForward of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> [skills 2] (Random 30 local36))
					(self cue:)
				else
					(localproc_0133)
					(self dispose:)
				)
			)
			(1
				(if (> local38 2)
					(= local38 0)
					(ego posn: (ego x?) (- (ego y?) 1))
				)
				(ego
					view: 285
					loop: 0
					cel: 0
					setPri: 13
					cycleSpeed: 1
					setCycle: End
					setMotion: MoveTo (- (ego x?) 5) (ego y?) self
				)
				(++ local38)
			)
			(2
				(localproc_00bb)
				(switch arcadeDifficultyLevel
					(1 (= cycles 3))
					(2 (= cycles 11))
					(3 (= cycles 18))
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance disposeRope of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(if [newARope local0] ([newARope local0] dispose:))
				(self cue:)
			)
			(2 (-- local0) (= cycles 1))
			(3
				(if (> local0 -1)
					(self changeState: 1)
				else
					(Print 491 2 #title {Bye, rope})
					(ego use: 16)
					(SetInput 0)
					(self dispose:)
				)
			)
		)
	)
)
