;;; Sierra Script 1.0 - (do not remove this comment)
(script# 62)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Timer)
(use Music)
(use Motion)
(use Actor)

(public
	levitate 0
	fallDown 1
)

(local
	gEgoY
	local1
	gEgoSignal
	local3
	local4
	local5
	local6
	local7 =  3
)
(procedure (localproc_000e)
	(if (== local5 1)
		(= local5 0)
	else
		(= local5 1)
		(= local6 (Abs (- global166 (- (ego y?) (ego z?)))))
	)
)

(procedure (localproc_003c)
	(if (== local5 2)
		(= local5 0)
	else
		(= local5 2)
		(= local6 (Abs (- gEgoY (- (ego y?) (ego z?)))))
	)
)

(instance levitate of HandsOffScript
	(properties)
	
	(method (init)
		(Bset 90)
		(Bset 87)
		(gDirH addToFront: self)
		(gMouseH addToFront: self)
		(= gEgoSignal (ego signal?))
		(super init: &rest)
	)
	
	(method (doit)
		(switch state
			(3
				(if (<= (ego z?) 3)
					(ego z: 0)
					(self cue:)
				else
					(switch local5
						(0
							(++ local4)
							(if (and local3 (> local4 3))
								(= local3 (= local4 0))
								(ego y: (+ (ego y?) 1))
							)
							(if (and (not local3) (> local4 3))
								(= local3 1)
								(= local4 0)
								(ego y: (- (ego y?) 1))
							)
						)
						(1
							(if
								(and
									(> (= local6 (- local6 local7)) 0)
									(>= (- (ego y?) (ego z?)) global166)
								)
								(ego z: (+ (ego z?) local7))
							else
								(= local5 0)
							)
						)
						(2
							(if (> (= local6 (- local6 local7)) 0)
								(ego z: (- (ego z?) local7))
							else
								(= local5 0)
							)
						)
					)
				)
			)
			(4
				(cond 
					((<= (ego z?) 3) (ego z: 0) (self cue:))
					((> (= local6 (- local6 local7)) 0) (ego z: (- (ego z?) local7)))
				)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gDirH delete: self)
		(gMouseH delete: self)
		(if (cast contains: sparkles) (sparkles dispose:))
		(= local3 0)
		(= local4 0)
		(= local5 0)
		(= local6 0)
		(theGame setCursor: waitCursor)
		(ego signal: gEgoSignal)
		(Bclr 90)
		(Bclr 87)
		(leviTimer dispose:)
		(super dispose:)
	)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(if gLevMe
					(self setScript: gLevMe self)
				else
					(self cue:)
				)
			)
			(1
				(= temp0
					(switch (ego loop?)
						(0 0)
						(1 3)
						(2 1)
						(3 2)
						(4 0)
						(5 1)
						(6 2)
						(7 3)
					)
				)
				(if (== curRoomNum 470) (= temp0 2))
				(if (not global166) (= global166 80))
				(= gEgoY (ego y?))
				(levSound init: play:)
				(ego
					view: 31
					setLoop: temp0
					cel: 0
					illegalBits: 0
					ignoreActors: 1
					setPri: (ego priority?)
					setCycle: End self
				)
				(sparkles
					loop: 4
					cel: 0
					posn: (ego x?) (ego y?)
					init:
					setPri: (+ (ego priority?) 1)
					setCycle: End
				)
			)
			(2
				(sparkles setLoop: 5 setCycle: Fwd)
				(ego setCycle: 0 setCel: 8 z: (+ (ego z?) 6))
				(= cycles 1)
			)
			(3
				(LockEgo)
				(leviTimer set: leviTimer 5)
			)
			(4
				(UnlockEgo)
				(if (not (ego z?))
					(self cue:)
				else
					(= local5 2)
					(= local6 (Abs (- gEgoY (- (ego y?) (ego z?)))))
				)
			)
			(5
				(ego setCycle: Beg self)
				(sparkles loop: 4 cel: 8 setCycle: Beg)
			)
			(6
				(proc1_19)
				(sparkles dispose:)
				(ego setPri: -1 setHeading: 180 self)
			)
			(7 (self dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== state 3)
				(== (ego cel?) 8)
				(switch (pEvent type?)
					(evSAID
						(cond 
							(
							(or (Said 'levitate,move,go<up') (Said 'rise,up')) (localproc_000e))
							(
								(or
									(Said 'levitate,move,go<down')
									(Said 'down,deposit[/!*]')
								)
								(localproc_003c)
							)
							((Said 'cease,halt') (= local5 0))
							((Said 'levitate,move') (HighPrint 62 0))
							((Said 'fall[<down]') (HighPrint 62 1) (ego setScript: fallDown))
							((Said 'get,acquire') (HighPrint 62 2))
							((Said 'ask,talk,chat') (HighPrint 62 3))
							((Said 'look,examine') (pEvent claimed: 0))
							(else (HighPrint 62 4) (pEvent claimed: 1))
						)
					)
					(evMOUSEBUTTON
						(if (> (Abs (- (ego x?) (pEvent x?))) 15)
							(pEvent claimed: 1)
						else
							(cond 
								(
								(< (pEvent y?) (- (- (ego y?) (ego z?)) 50))
									(= local6
										(Abs (- (pEvent y?) (- (- (ego y?) (ego z?)) 50)))
									)
									(= local5 1)
								)
								((> (pEvent y?) (- (ego y?) (ego z?)))
									(= local6
										(Abs (- (pEvent y?) (- (ego y?) (ego z?))))
									)
									(= local5 2)
								)
								(else (= local5 0))
							)
							(pEvent claimed: 1)
						)
					)
					(evJOYSTICK
						(switch (pEvent message?)
							(JOY_UP (localproc_000e))
							(JOY_DOWN (localproc_003c))
							(JOY_NULL (= local5 0))
						)
						(pEvent claimed: 1)
					)
				)
			)
			(else (pEvent claimed: 1))
		)
	)
)

(instance fallDown of HandsOffScript
	(properties)
	
	(method (init)
		(Bset 95)
		(super init: &rest)
	)
	
	(method (doit &tmp temp0)
		(if (== state 1)
			(cond 
				((not (ego z?)) (ego y: local1) (self cue:))
				((<= (ego z?) 12) (ego z: 0))
				(else (ego z: (- (ego z?) 12)))
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bclr 95)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 6
					loop: 2
					cel: 0
					cycleSpeed: 0
					setCycle: CT 5 1 self
				)
			)
			(1
				(= local1 (if register else gEgoY))
			)
			(2
				(ego setCycle: End)
				(= cycles 24)
			)
			(3
				(if (ReduceHP (/ (ego z?) 5))
					(ego loop: 3 cel: 0 cycleSpeed: 2 setCycle: End self)
				else
					(Die 1 62 5 80 {You've really made an impact})
				)
			)
			(4
				(proc1_19)
				(ego setHeading: 180 self)
			)
			(5 (self dispose:))
		)
	)
)

(instance sparkles of Prop
	(properties
		view 31
		loop 4
		signal $4000
	)
	
	(method (doit)
		(self x: (ego x?) y: (ego y?) z: (ego z?))
		(super doit:)
	)
)

(instance leviTimer of Timer
	(properties)
	
	(method (cue)
		(if (and (not (ReduceMP 1)) (== (ego view?) 31))
			(ego setScript: fallDown)
			(self dispose:)
		else
			(self set: self 5)
		)
	)
)

(instance levSound of Sound
	(properties
		number 29
		priority 10
	)
)
