;;; Sierra Script 1.0 - (do not remove this comment)
(script# 806)
(include sci.sh)
(use Main)
(use Intrface)
(use FileSel)
(use Save)
(use System)

(public
	proc806_0 0
)

(local
	[local0 20]
)
(procedure (proc806_0 param1)
	(getFileName doit: param1)
	(DisposeScript 944)
	(DisposeScript 806)
)

(procedure (localproc_0025)
	(if (localproc_0471)
		(theGame setCursor: waitCursor)
		(if (not (savedHeros init:)) (return 0))
		(self dispose:)
		(self init:)
		(savedHeros draw:)
	)
	(theGame setCursor: normalCursor)
	(return 1)
)

(procedure (localproc_03b4 param1 param2 param3 &tmp temp0 temp1)
	(if (= temp1 (StrLen param2))
		(= temp0 (StrAt param2 (- temp1 1)))
		(Format
			param1
			{%s%c%s}
			param2
			(if (OneOf temp0 92 58) 0 else 92)
			param3
		)
	else
		(StrCpy param1 param3)
	)
	(return param1)
)

(procedure (localproc_0471 &tmp temp0 [temp1 20] [temp21 40])
	(repeat
		(if
			(not
				(= temp0
					(Print
						806
						3
						#edit
						(StrCpy @temp1 @local0)
						40
						#button
						{OK}
						1
						#button
						{Cancel}
						0
					)
				)
			)
			(break)
		)
		(if (not (StrLen @temp1)) (GetCWD @temp1))
		(if (ValidPath @temp1) (StrCpy @local0 @temp1) (break))
		(Print (Format @temp21 806 4 @temp1))
	)
	(return temp0)
)

(instance getFileName of Dialog
	(properties
		text {Import Character}
	)
	
	(method (init &tmp temp0)
		(= window SysWindow)
		(= nsBottom 0)
		(if (not (savedHeros init:)) (return 0))
		(savedHeros setSize: moveTo: 4 (+ nsBottom 4) state: 2)
		(= temp0 (+ (savedHeros nsRight?) 4))
		(importItem
			setSize:
			moveTo: temp0 (+ 10 (savedHeros nsTop?))
			state: (if (savedHeros nFiles?) 3 else 0)
		)
		(changeDirItem
			setSize:
			moveTo: temp0 (+ (importItem nsBottom?) 4)
			state: (& (changeDirItem state?) $fff7)
		)
		(cancelItem
			setSize:
			moveTo: temp0 (+ (changeDirItem nsBottom?) 4)
			state: (& (changeDirItem state?) $fff7)
		)
		(self
			add: savedHeros importItem changeDirItem cancelItem
			setSize:
			center:
			open: 4 15
		)
		(return 1)
	)
	
	(method (doit param1 &tmp [temp0 100] temp100 temp101)
		(asm
			ldi      0
			sal      local0
			pushi    #init
			pushi    0
			self     4
			not     
			bnt      code_016e
			pushi    #dispose
			pushi    0
			self     4
			ldi      0
			ret     
code_016e:
			pushi    60
			pushi    1
			pushi    #nFiles
			pushi    0
			lofsa    savedHeros
			send     4
			bnt      code_0183
			lofsa    importItem
			jmp      code_0186
code_0183:
			lofsa    changeDirItem
code_0186:
			push    
			super    Dialog,  6
			sat      temp100
			push    
			lofsa    importItem
			eq?     
			bnt      code_01b3
			pushi    3
			lsp      param1
			lea      @local0
			push    
			pushi    #cursor
			pushi    0
			lofsa    savedHeros
			send     4
			push    
			call     localproc_03b4,  6
			ldi      1
			sat      temp101
			jmp      code_01e8
			jmp      code_016e
code_01b3:
			lst      temp100
			lofsa    changeDirItem
			eq?     
			bnt      code_01cd
			pushi    0
			call     localproc_0025,  0
			sat      temp101
			not     
			bnt      code_01ca
			jmp      code_01e8
code_01ca:
			jmp      code_016e
code_01cd:
			lst      temp100
			ldi      0
			eq?     
			bt       code_01de
			lst      temp100
			lofsa    cancelItem
			eq?     
			bnt      code_016e
code_01de:
			ldi      0
			sat      temp101
			jmp      code_01e8
			jmp      code_016e
code_01e8:
			pushi    #dispose
			pushi    0
			self     4
			lat      temp101
			ret     
		)
	)
	
	(method (dispose)
		(savedHeros dispose:)
		(super dispose:)
	)
)

(instance savedHeros of FileSelector
	(properties
		y 16
	)
	
	(method (init &tmp temp0 superInit temp2 temp3 theText temp5 [temp6 80])
		(theGame setCursor: waitCursor)
		(= font smallFont)
		(= mask (localproc_03b4 @temp6 @local0 {*.*}))
		(if (not (= superInit (super init:)))
			(Print 806 0)
		else
			(= theText text)
			(= temp2 0)
			(while (< temp2 nFiles)
				(= temp3 0)
				(while (= temp5 (StrAt theText temp3))
					(StrAt
						theText
						temp3
						(if (or (< temp5 65) (> temp5 90))
							temp5
						else
							(+ (- temp5 65) 97)
						)
					)
					(++ temp3)
				)
				(++ temp2)
				(= theText (+ theText x))
			)
		)
		(theGame setCursor: normalCursor)
		(return superInit)
	)
)

(instance cancelItem of DButton
	(properties
		text { Cancel_}
	)
)

(instance changeDirItem of DButton
	(properties
		text {Change\0D\nDirectory}
	)
)

(instance importItem of DButton
	(properties
		text { Import_}
	)
)
