;;; Sierra Script 1.0 - (do not remove this comment)
(script# 100)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Flame)
(use Full)
(use PolyPath)
(use Polygon)
(use LoadMany)
(use Timer)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm100 0
	shameen 1
	shema 2
	standTimer 3
)

(local
	local0
	local1
	local2
	local3
	local4
	[local5 50]
	[local55 12] = [100 142 149 142 169 129 161 116 95 123 92 137]
	[local67 16] = [21 157 89 158 93 165 91 174 80 177 61 179 41 179 18 171]
	[local83 17] = [0 1 2 3 6 4 0 0 2 0 0 3 7 0 4 5 3]
	[local100 38] = [0 2 3 1 1 1 1 1 1 4 5 6 7 1 8 9 10 1 11 1 12 13 14 15 16 17 18 19 20 21 22 1 23 1 1 1 1 1]
	[local138 32] = [24 '//shema,wife' 25 '//abdulla' 26 '//destiny' 27 '//foreshadow' 28 '//cousin' 29 '//spielburg,hero' 30 '//dance' 31 '//loot' 32 '//lion,lion,rakeesh' 33 '//nephew,nephew' 34 '//bazaar' 35 '//room,bed,nap' 36 '//breakfast,food,drink,tea,eat,chew' 37 '//guest,bandit' 39 '//fire,air,earth,water']
	[local170 38] = [0 2 3 1 38 38 38 38 38 1 4 5 6 1 7 8 9 1 10 1 11 12 13 14 15 16 1 1 17 18 19 1 20 1 1 1 1 1]
	[local208 40] = [21 '//cousin' 22 '//food,eat,chew,breakfast' 23 '//drink,tea' 24 '//hero' 25 '//spielburg' 26 '//family' 27 '//underground' 28 '//abdulla' 29 '//dance' 30 '//shameen' 31 '//relation,cousin,dad' 32 '//lamb,chicken,rabbit,curry' 33 '//saurii' 34 '//knockwurst,sauerkraut' 35 '//fire' 36 '//shop,bazaar' 37 '//worry' 15 '//freedom,home,(land<home)' 67 '//fire,air,earth,water']
)
(procedure (localproc_0012 theMealsPreEaten param2)
	(Bclr 3)
	(Bclr 137)
	(if param2
		(= mealsPreEaten theMealsPreEaten)
		(Bclr 4)
		(Bclr 5)
		(= global258 global277)
	)
)

(procedure (localproc_003f param1 &tmp temp0)
	(cond 
		((OneOf currentDay 2 4 5 8 11) (Say shema param1 (shema msgFile?) (+ 51 currentDay)))
		(
		(and (== currentDay 6) (== elementalsStatus 1)) (Say shema param1 (shema msgFile?) (+ 51 currentDay)))
		(
		(and (== currentDay 10) (== elementalsStatus 3)) (Say shema param1 (shema msgFile?) (+ 51 currentDay)))
		(
		(and (== currentDay 13) (== elementalsStatus 5)) (Say shema param1 (shema msgFile?) (+ 51 currentDay)))
		((== elementalsStatus 7) (Say shema param1 (shema msgFile?) 65))
		(
		(and (== elementalsStatus 8) (not (ego has: 27))) (Say shema param1 (shema msgFile?) 66))
		(else
			(= temp0 (proc1_5 currentDay 1 5))
			(Say shema param1 (shema msgFile?) (+ 46 (- temp0 1)))
		)
	)
)

(instance rm100 of Rm
	(properties
		picture 100
		style $0006
	)
	
	(method (init &tmp temp0)
		(Bset 2)
		(Bset 16)
		(LoadMany 128 0 100 102 103 104 302)
		(LoadMany 131 104 102)
		(LoadMany 132 100 109)
		(= local1 [local83 currentDay])
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(if (not (OneOf prevRoomNum 112 118))
			(gCMusic
				number:
					(if
					(or (== currentTimeZone 4) (== currentTimeZone 5))
						109
					else
						100
					)
				loop: 0
				priority: 0
				playBed:
			)
		)
		(if
			(and
				(or (== currentTimeZone 4) (== currentTimeZone 5))
				(== local1 3)
			)
			(Load rsSCRIPT 116)
			(Load rsTEXT 116)
			(Load rsTEXT 106)
			(Load rsVIEW 106)
			(Load rsVIEW 108)
			((ScriptID 116 0) init:)
		)
		(if
			(and
				(or (== local1 1) (== local1 4))
				(< currentTimeZone 6)
			)
			(Load rsSCRIPT 117)
			(Load rsTEXT 117)
			(Load rsTEXT 105)
			(Load rsVIEW 105)
			((ScriptID 117 0) init:)
		)
		(LoadMany 130 945 946)
		(= useObstacles 1)
		(super init:)
		(if
		(or (== currentTimeZone 4) (== currentTimeZone 5))
			(flame1 init:)
			(flame2 init:)
			(DrawFeature musician)
		)
		(shemaPoly points: @local55 size: 6)
		(tablePoly points: @local67 size: 8)
		(self addObstacle: tablePoly shemaPoly)
		(shameen init:)
		(shema init: hide:)
		(proc1_19)
		(ego init:)
		(if
			(>
				(mod
					(= temp0
						(+
							(mod (+ currentDay currentTimeZone) 8)
							(if (== currentTimeZone 4) else (== currentTimeZone 5))
						)
					)
					2
				)
				0
			)
			(addToPics add: shadow1)
		)
		(if (> (mod temp0 3) 0) (addToPics add: shadow2))
		(if (> (mod temp0 4) 0) (addToPics add: shadow3))
		(lamp init:)
		(DrawFeature
			trim1
			trim2
			oilLamp
			rope
			tassle
			egoPillow
			pillow2
			pillow3
			pillow4
			detail1
			detail2
			brassBottle
			egoTable
			table1
			table2
			table3
			table4
		)
		(switch prevRoomNum
			(112
				(self setScript: beginScript)
			)
			(118
				(self setScript: beginScript)
			)
			(810
				(self setScript: beginScript)
			)
			(101
				(self setScript: sleepScript)
			)
			(else 
				(self setScript: enterScript)
			)
		)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			((ego script?))
			((& (ego onControl: 1) $4000) (self newRoom: 101))
			((== (ego edgeHit?) 3) (self setScript: byeScript))
		)
	)
	
	(method (dispose)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(= global257 global277)
		(gCMusic fade:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'sat')
				(if (== (ego view?) 100)
					(HighPrint 100 0)
				else
					(self setScript: egoSits)
				)
			)
			((Said 'stand,(get,acquire<up)')
				(if (== (ego view?) 100)
					(self setScript: egoStands)
				else
					(HighPrint 100 1)
				)
			)
			((Said 'order,call>')
				(cond 
					((Said '/tea') (= local0 2))
					(
					(Said '/food,breakfast,lamb,curry,chicken,rabbit') (= local0 0))
					((Said '/hostess,shema,hostess') (= local0 1))
					((Said '[/!*]') (if (not local2) (= local0 0) else (= local0 3)))
					(else (pEvent claimed: 1) (= local0 3))
				)
				(cond 
					(
					(or (> currentTimeZone 5) (< currentTimeZone 0))
						(if (== local0 0)
							(Say shameen 100 2)
						else
							(Say shameen 100 3)
						)
					)
					((OneOf currentTimeZone 2 3) (Say shameen 100 4 100 5))
					((not (== (ego view?) 100)) (Say shameen 100 6))
					((and (== (shema x?) 37) (== (shema y?) 163))
						(switch local0
							(0
								(if local2
									(Say shema 100 7)
								else
									(shemaTimer dispose:)
									(shema setScript: shemaLeaves 0 1)
								)
							)
							(2
								(if local3
									(Say shema 100 8)
								else
									(Say shema 100 9)
									(= local3 1)
								)
							)
							(else  (Say shema 100 10))
						)
					)
					(else
						(if (and local2 (== local0 0)) (= local0 1))
						(if (& (shema signal?) $0080)
							(Say
								shameen
								(Format
									@local5
									100
									11
									(cond 
										((== local0 2) { with some of our wonderful tea.})
										((or local2 (OneOf local0 1 3)) {._})
										(else { with one of her splendid meals.})
									)
								)
							)
						)
						(if (and (shema script?) (OneOf local0 0 2))
							(shema setScript: shemaLeaves 0 1)
						else
							(shema setScript: shemaServes)
						)
					)
				)
			)
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 100 12))
			((Said 'thank')
				(if (and (== (shema x?) 37) (== (shema y?) 163))
					(SayThanks shema shemaTimer 100 13)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'drink')
				(cond 
					((not (== (ego view?) 100)) (if local3 (HighPrint 100 14) else (HighPrint 100 15)))
					(local3 (HighPrint 100 16) (localproc_0012 0 0) (= local3 0))
					((> currentWater 0) (HighPrint 100 17))
					(else (HighPrint 100 18))
				)
			)
			(
				(Said
					'look,examine/food,breakfast,lamb,curry,chicken,rabbit'
				)
				(cond 
					((not local2) (pEvent claimed: 0))
					((< currentTimeZone 2) (HighPrint 100 19))
					(else (HighPrint 100 20))
				)
			)
			(
				(Said
					'eat,chew[/food,breakfast,lamb,curry,chicken,rabbit]'
				)
				(cond 
					((== global258 global277) (HighPrint 100 21))
					((not (== (ego view?) 100)) (HighPrint 100 22))
					((and local2 (< currentTimeZone 2))
						(if (< (shema x?) 240) (shemaTimer cue:))
						(localproc_0012 1 1)
						(HighPrint 100 23)
					)
					(local2
						(if (< (shema x?) 240) (shemaTimer cue:))
						(localproc_0012 2 1)
						(HighPrint 100 24)
						(if (== local4 6)
							(HighPrint 100 25)
						else
							(switch (umod currentDay 3)
								(0 (HighPrint 100 26))
								(1 (HighPrint 100 27))
								(2 (HighPrint 100 28))
							)
						)
					)
					(else
						(pEvent claimed: 1)
						(if (ego has: 3)
							(HighPrint 100 29)
						else
							(HighPrint 100 30)
						)
					)
				)
			)
			((Said 'gave,replace/back,purse,alm') (Say shameen 100 31))
			(
				(or
					(Said 'rent,buy,get,acquire/room,bed')
					(Said 'nap,rest')
				)
				(shameen showText: 35)
			)
		)
	)
)

(instance beginScript of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(SetControl 1)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 100 loop: 4 cel: 4 posn: 25 183 setPri: -1)
				(= cycles 6)
			)
			(1
				(if (not global257)
					((ScriptID 117 0) setScript: (ScriptID 117 1) self)
				else
					(self cue:)
				)
			)
			(2 (self dispose:))
		)
	)
)

(instance sleepScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego posn: 265 135 setMotion: MoveTo 195 135 self)
			)
			(1
				(FaceObject ego shameen)
				(client setScript: greetingScript)
			)
		)
	)
)

(instance enterScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego posn: 158 250 setMotion: MoveTo 158 185 self)
			)
			(1
				(FaceObject ego shameen)
				(= cycles 2)
			)
			(2
				(shameen setCycle: End)
				(= cycles 4)
			)
			(3
				(shameen loop: 1 cel: 0 cycleSpeed: 4 setCycle: Full 1)
				(= cycles 4)
			)
			(4
				(client setScript: greetingScript self)
			)
		)
	)
)

(instance greetingScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((or (== global257 global277) (Btst 161)) (= cycles 1))
					(
						(and
							(or (== currentTimeZone 4) (== currentTimeZone 5))
							(== local1 1)
						)
						(Say shameen self 100 32)
					)
					(
						(and
							(or (== currentTimeZone 4) (== currentTimeZone 5))
							(== local1 2)
						)
						(Say shameen self 100 33)
					)
					(
						(and
							(== local1 6)
							(< global257 400)
							(or (== elementalsStatus 1) (== currentDay 4))
						)
						(Say shameen self 100 34)
					)
					(
						(and
							(== local1 7)
							(== elementalsStatus 5)
							(< global257 1200)
						)
						(Say shameen self 100 35)
					)
					((== local1 3)
						(cond 
							((== currentDay 11) (Say shameen self 100 36))
							(
							(or (== currentTimeZone 4) (== currentTimeZone 5)) (Say shameen self 100 37))
							(else (Say shameen self 100 38))
						)
					)
					((and (== local1 5) (not (Bset 170)))
						(if (== gHeroType 0)
							(Say shameen self (shameen msgFile?) 38 100 39)
						else
							(Say shameen self (shameen msgFile?) 38)
						)
					)
					(else (Say shameen self 100 38))
				)
			)
			(1
				(if
					(and
						(or (== currentTimeZone 4) (== currentTimeZone 5))
						(not (Btst 161))
						(< global257 global277)
						(or (== currentDay 11) (== currentDay 16))
					)
					(self setScript: (ScriptID 116 1) self)
				else
					(self dispose:)
				)
			)
			(2 (curRoom setScript: egoSits))
		)
	)
)

(instance egoSits of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(ego illegalBits: 0)
		(UnlockEgo)
	)
	
	(method (dispose)
		(super dispose:)
		(SetInput 0)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: PolyPath 25 183 self)
			)
			(1 (ego setHeading: 45 self))
			(2
				(ego
					view: 100
					loop: 4
					cel: 0
					setPri: -1
					cycleSpeed: 1
					setCycle: End
				)
				(if (> (+ (shameen loop?) (shameen cel?)) 0)
					(standTimer dispose:)
					(shameen loop: 0 cel: 3 cycleSpeed: 0 setCycle: Beg)
				)
				(= cycles 20)
			)
			(3
				(cond 
					((and (== local1 4) (< currentTimeZone 6))
						(cond 
							((== elementalsStatus 1) (Say (ScriptID 117 0) self 100 40))
							((and (== currentDay 14) (< global257 1400)) (Say (ScriptID 117 0) self 100 41))
							(
								(not
									(if (== currentTimeZone 4) else (== currentTimeZone 5))
								)
								(= cycles 1)
							)
							((== currentDay 1) (Say (ScriptID 117 0) self 100 42))
							((== currentDay 5) (Say (ScriptID 117 0) self 100 43))
							((== currentDay 14)
								(Say
									(ScriptID 117 0)
									self
									(Format @local5 100 44 @userName)
								)
							)
							(else (= cycles 1))
						)
					)
					(
						(and
							(or (== currentTimeZone 4) (== currentTimeZone 5))
							(== local1 2)
						)
						(if (Btst 161)
							(= cycles 1)
						else
							(= global257 global277)
							(curRoom newRoom: 112)
						)
					)
					(
						(and
							(or (== currentTimeZone 4) (== currentTimeZone 5))
							(== local1 3)
						)
						(if (Btst 161)
							(= cycles 1)
						else
							(= global257 global277)
							(curRoom newRoom: 118)
						)
					)
					(
						(and
							(or
								(< currentTimeZone 2)
								(== currentTimeZone 4)
								(== currentTimeZone 5)
							)
							(not local2)
						)
						(= local0 (if (< global258 global277) 0 else 1))
						(shema setScript: shemaServes self)
					)
					(else (= cycles 1))
				)
			)
			(4
				(shameen stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance egoStands of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(SetInput 1)
	)
	
	(method (dispose)
		(LockEgo 1)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego cycleSpeed: 1 setCycle: CT 2 -1 self)
				(if (< (shema x?) 240) (shemaTimer cue:))
			)
			(1
				(proc1_19)
				(ego setMotion: MoveTo 100 188 self)
			)
			(2 (self dispose:))
		)
	)
)

(instance shemaServes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetInput 1)
				(shema
					view: (if (== local0 0) 103 else 102)
					setCycle: Walk
					setMotion: PolyPath 40 150 self
					show:
				)
			)
			(1
				(shema loop: 2 setMotion: MoveTo 37 163 self)
			)
			(2 (= cycles 4))
			(3
				(if (and (not local2) (== local0 0))
					(self setScript: putItDown self)
				else
					(shema loop: 5 cel: 0 cycleSpeed: 1 setCycle: End self)
				)
			)
			(4
				(shema cycleSpeed: 1 setCycle: Beg self)
			)
			(5
				(switch local0
					(1 (Say shema self 100 45))
					(2
						(Say shema self 100 46)
						(= local3 1)
					)
					(3 (= cycles 1))
					(0
						(= local2 1)
						(= local3 1)
						(if (< currentTimeZone 2)
							(localproc_003f self)
						else
							(= local4 (proc1_5 currentDay 1 6))
							(Say shema self (shema msgFile?) (+ 39 (- local4 1)))
						)
					)
				)
			)
			(6
				(SetInput 0)
				(proc1_32 shemaTimer 20)
				(self dispose:)
			)
		)
	)
)

(instance putItDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(shema view: 102 loop: 5 cel: 0)
				(tray init:)
				(= cycles 2)
			)
			(1
				(shema cel: 1)
				(tray y: (+ (tray y?) 2))
				(= cycles 2)
			)
			(2
				(if (!= (shema cel?) 4)
					(= state 1)
					(shema cel: (+ (shema cel?) 1))
					(tray y: (+ (tray y?) 2))
				)
				(= cycles 2)
			)
			(3
				(tray y: (+ (tray y?) 1))
				(self dispose:)
			)
		)
	)
)

(instance shemaLeaves of Script
	(properties)
	
	(method (dispose)
		(if register (SetInput 0))
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if register
					(Say shema self 100 47)
					(shemaTimer dispose:)
					(= next shemaServes)
					(SetInput 1)
				else
					(self cue:)
				)
			)
			(1
				(shema
					cycleSpeed: 0
					setCycle: Walk
					setMotion: PolyPath 240 117 self
				)
			)
			(2
				(= seconds (if next 5 else 1))
			)
			(3
				(shema hide:)
				(self dispose:)
			)
		)
	)
)

(instance byeScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((and (== local1 2) (not (Btst 161)))
						(ego setMotion: 0)
						(FaceObject ego shameen)
						(Say shameen self 100 48)
					)
					((and (== local1 3) (not (Btst 161)))
						(ego setMotion: 0)
						(FaceObject ego shameen)
						(Say shameen self 100 49)
					)
					(else (self changeState: 2))
				)
			)
			(1 (= cycles 4))
			(2
				(ego setMotion: MoveTo (ego x?) (+ (ego y?) 50) self)
			)
			(3
				(= gTopExit 4)
				(curRoom newRoom: 300)
			)
		)
	)
)

(instance shameen of Talker
	(properties
		x 247
		y 158
		description {Shameen}
		lookStr {It is your good friend, Shameen.}
		view 104
		signal $4000
		illegalBits $0000
		tLoop 2
		talkSpeed 1
		myName '//shameen,catperson,owner,keeper,innkeeper'
		title {Shameen:}
		color 15
		back 6
		msgFile 104
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (Said 'hello,greet') (Said '/hello,greet')) (Say self 100 50))
			((Said 'thank')
				(if (self saidMe:)
					(SayThanks self 100 51)
				else
					(pEvent claimed: 0)
				)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local138 param1])
	)
	
	(method (atGen param1)
		(return [local100 param1])
	)
	
	(method (messages)
		(standTimer dispose:)
		(if
		(not (> (+ (shameen loop?) (shameen cel?)) 0))
			(= state -1)
			(self setCycle: End self)
		)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(super endTalk:)
		(if (> (+ (shameen loop?) (shameen cel?)) 0)
			(proc1_32 standTimer 20)
		)
	)
)

(instance standTimer of Timer
	(properties)
	
	(method (cue)
		(shameen setCycle: Beg)
	)
)

(instance shema of Talker
	(properties
		x 240
		y 117
		description {Shema}
		lookStr {It is your good friend, Shema.}
		view 102
		signal $4000
		illegalBits $0000
		tLoop 4
		talkSpeed 1
		myName '//shema,catperson'
		title {Shema:}
		color 14
		back 6
		msgFile 102
	)
	
	(method (handleEvent)
		(if (< (shema x?) 240)
			(cond 
				((super handleEvent: &rest))
				(
				(or (Said 'gave/bouquet') (Said 'gave//bouquet')) (GiveFlowers self 100 52))
				(
				(or (Said 'hello,greet') (Said '/hello,greet')) (Say self 100 53))
			)
		)
	)
	
	(method (atSpec param1)
		(return [local208 param1])
	)
	
	(method (atGen param1)
		(return [local170 param1])
	)
	
	(method (showText param1)
		(if (== param1 0)
			(HighPrint 100 54)
		else
			(super showText: param1 &rest)
		)
	)
	
	(method (messages)
		(if script (self setMotion: 0))
		(super messages: &rest)
	)
	
	(method (endTalk)
		(super endTalk:)
		(if script
			(self setMotion: PolyPath 240 117 script)
		else
			(proc1_32 shemaTimer 20)
		)
	)
)

(instance shemaTimer of Timer
	(properties)
	
	(method (cue)
		(shema setScript: shemaLeaves 0 0)
		(= seconds 0)
	)
)

(instance musician of PicView
	(properties
		x 185
		y 109
		noun '/musician'
		description {the katta musician}
		lookStr {Lively, isn't he?}
		view 302
		loop 1
		signal $4000
	)
)

(instance trim1 of PicView
	(properties
		x 200
		y 34
		shiftClick 0
		view 100
		loop 1
	)
)

(instance trim2 of PicView
	(properties
		x 272
		y 18
		shiftClick 0
		view 100
		loop 1
		cel 1
		priority 12
	)
)

(instance detail1 of PicView
	(properties
		x 61
		y 41
		contClick 0
		view 100
		loop 1
		cel 2
	)
)

(instance detail2 of PicView
	(properties
		x 116
		y 43
		contClick 0
		view 100
		loop 1
		cel 3
	)
)

(instance egoPillow of PicView
	(properties
		x 26
		y 180
		noun '/cushion'
		description {a comfortable pillow}
		view 100
		loop 2
		cel 4
		priority 0
		signal $4010
	)
)

(instance pillow2 of PicView
	(properties
		x 108
		y 142
		noun '/cushion'
		description {a pillow}
		view 100
		loop 2
		cel 6
		priority 0
		signal $4010
	)
)

(instance pillow3 of PicView
	(properties
		x 95
		y 117
		noun '/cushion'
		description {a pillow}
		view 100
		loop 2
		cel 7
		priority 7
		signal $0010
	)
)

(instance pillow4 of PicView
	(properties
		x 38
		y 128
		noun '/cushion'
		description {a pillow}
		view 100
		loop 2
		cel 8
		priority 9
		signal $0010
	)
)

(instance tassle of PicView
	(properties
		x 92
		y 118
		z 50
		noun '/tassel'
		description {a tassel}
		view 100
		loop 2
		cel 3
	)
)

(instance rope of PicView
	(properties
		x 167
		y 165
		z 100
		noun '/rope,braid'
		description {braided rope}
		view 100
		loop 2
		cel 2
	)
)

(instance tray of View
	(properties
		x 37
		y 152
		noun '/tray'
		description {a tray}
		view 103
		loop 4
		priority 13
		signal $4010
	)
)

(instance shadow1 of PicView
	(properties
		x 8
		y 127
		noun '/customer,customer,customer,man'
		description {a patron of the Inn}
		lookStr {It is a patron of the Inn, drinking and dining, no doubt.}
		view 100
		loop 5
		priority 9
		signal $0010
	)
)

(instance shadow2 of PicView
	(properties
		x 72
		y 119
		noun '/customer,dine,customer,man'
		description {a patron of the Inn}
		lookStr {It is a patron of the Inn, drinking and dining, no doubt.}
		view 100
		loop 5
		cel 1
		priority 8
		signal $0010
	)
)

(instance shadow3 of PicView
	(properties
		x 126
		y 112
		noun '/customer,dine,customer,man'
		description {a patron of the Inn}
		lookStr {It is a patron of the Inn, drinking and dining, no doubt.}
		view 100
		loop 5
		cel 2
		priority 6
		signal $0010
	)
)

(instance egoTable of PicView
	(properties
		x 54
		y 180
		noun '/table'
		description {a table}
		lookStr {It is a low, round table__There is a green pillow on the floor near it.}
		view 100
		priority 13
		signal $4010
	)
)

(instance table1 of PicView
	(properties
		x 132
		y 137
		noun '/table'
		description {a table}
		lookStr {It is one of several low, round tables.}
		view 100
		cel 1
		priority 9
		signal $0010
	)
)

(instance table2 of PicView
	(properties
		x 76
		y 115
		noun '/table'
		description {a table}
		lookStr {It is one of several low, round tables.}
		view 100
		cel 3
		priority 8
		signal $0010
	)
)

(instance table3 of PicView
	(properties
		x 128
		y 109
		noun '/table'
		description {a table}
		lookStr {It is one of several low, round tables.}
		view 100
		cel 4
		priority 6
		signal $0010
	)
)

(instance table4 of PicView
	(properties
		x 17
		y 125
		noun '/table'
		description {a table}
		lookStr {It is one of several low, round tables.}
		view 100
		cel 1
		priority 9
		signal $0010
	)
)

(instance oilLamp of PicView
	(properties
		x 280
		y 171
		z 50
		noun '/lamp,bottle[<clear,cup,grease]'
		description {an oil lamp}
		lookStr {It is an oil lamp (batteries not included...or even necessary).}
		view 100
		loop 2
	)
)

(instance brassBottle of PicView
	(properties
		x 297
		y 183
		noun '/bottle[<brass,gold]'
		description {a brass bottle}
		lookStr {It is a large brass bottle.__What a genie it could hold!}
		view 100
		loop 2
		cel 1
	)
)

(instance lamp of View
	(properties
		x 53
		y 182
		z 18
		noun '/lamp,candle'
		description {an oil lamp}
		lookStr {It is an oil lamp.}
		view 100
		loop 2
		cel 9
		priority 13
		signal $0011
	)
)

(instance flame1 of Flame
	(properties
		x 53
		y 178
		z 25
		view 100
		loop 3
		signal $4000
	)
)

(instance flame2 of Flame
	(properties
		x 131
		y 137
		z 23
		view 100
		loop 3
		signal $4000
	)
)

(instance tablePoly of Polygon
	(properties
		type $0002
	)
)

(instance shemaPoly of Polygon
	(properties
		type $0002
	)
)
