;;; Sierra Script 1.0 - (do not remove this comment)
(script# 118)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Full)
(use Intrface)
(use LoadMany)
(use Timer)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm118 0
)

(local
	[local0 200]
)
(procedure (localproc_000c param1)
	(if (not argc) (= param1 0))
	(omarHead setCycle: Fwd)
	(Print
		&rest
		#dispose
		param1
		35
		omarWin
		80
		{Omar:}
		70
		300
		25
		15
	)
)

(instance rm118 of Rm
	(properties
		picture 110
		style $0006
	)
	
	(method (init &tmp [temp0 20])
		(LoadMany 128 110 118 119)
		(AddToScore 603 3)
		(omarHead view: 118 x: 193 y: 64 init:)
		(jaAfar init:)
		(super init:)
		(flame1 init:)
		(flame2 init:)
		(musician init: cycleSpeed: 2 setCycle: Fwd)
		(DrawFeature egoSilhouette omarFeet lamp1 lamp2 pillow)
		(gCMusic number: 106 loop: -1 priority: 0 playBed:)
		(proc1_32 jaAfarTimer 3 10)
		(Bclr 2)
		(switch currentDay
			(3 (self setScript: poem1S))
			(11 (self setScript: poem2S))
			(16 (self setScript: poem3S))
		)
	)
	
	(method (dispose)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(Bset 2)
		(super dispose:)
	)
)

(instance poem1S of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (localproc_000c self 118 0))
			(1 (self setScript: readS self))
			(2 (localproc_000c self 118 1))
			(3 (self setScript: readS self))
			(4 (localproc_000c self 118 2))
			(5 (self setScript: readS self))
			(6 (localproc_000c self 118 3))
			(7 (self setScript: bowS self))
			(8
				(gCMusic fade:)
				(Bset 161)
				(curRoom newRoom: 100)
			)
		)
	)
)

(instance poem2S of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (localproc_000c self 118 4))
			(1 (self setScript: readS self))
			(2 (localproc_000c self 118 5))
			(3 (self setScript: readS self))
			(4 (localproc_000c self 118 6))
			(5 (self setScript: readS self))
			(6 (localproc_000c self 118 7))
			(7 (self setScript: bowS self))
			(8
				(gCMusic fade:)
				(Bset 161)
				(curRoom newRoom: 100)
			)
		)
	)
)

(instance poem3S of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (localproc_000c self 118 8))
			(1 (self setScript: readS self))
			(2 (localproc_000c self 118 9))
			(3 (self setScript: readS self))
			(4 (localproc_000c self 118 10))
			(5 (self setScript: readS self))
			(6 (localproc_000c self 118 11))
			(7 (self setScript: readS self))
			(8 (localproc_000c self 118 12))
			(9
				(localproc_000c self (Format @local0 118 13 @userName))
			)
			(10 (self setScript: bowS self))
			(11
				(gCMusic fade:)
				(Bset 161)
				(curRoom newRoom: 100)
			)
		)
	)
)

(instance readS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(omarHead setLoop: 1 setCycle: End)
				(= cycles 12)
			)
			(1
				(omarHead setCycle: Beg)
				(= cycles 12)
			)
			(2
				(omarHead setLoop: 0)
				(self dispose:)
			)
		)
	)
)

(instance bowS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gestureTimer dispose:)
				(omarHead setLoop: 1 setCel: 0 setCycle: End self)
				(omarBody setLoop: 5 setCel: 0 setCycle: End)
			)
			(1 (= cycles 8))
			(2
				(omarHead setCycle: Beg self)
			)
			(3 (self dispose:))
		)
	)
)

(instance jaAfarLooks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(jaAfar setCycle: End)
				(= cycles 10)
			)
			(1
				(jaAfar setCycle: Beg)
				(= cycles 10)
			)
			(2
				(proc1_32 jaAfarTimer 3 10)
				(self dispose:)
			)
		)
	)
)

(instance omarHead of Prop
	(properties
		view 118
		signal $4010
		cycleSpeed 2
	)
	
	(method (init)
		(super init: &rest)
		(omarBody init:)
		(proc1_32 gestureTimer 2 3)
	)
)

(instance omarBody of Prop
	(properties
		x 191
		y 83
		view 118
		loop 4
	)
	
	(method (cue)
		(proc1_32 gestureTimer 2 3)
	)
)

(instance omarFeet of PicView
	(properties
		x 191
		y 108
		view 118
		loop 6
	)
)

(instance omarWin of BotWindow
	(properties
		color 5
		back 0
	)
)

(instance jaAfar of Actor
	(properties
		x 71
		y 107
		view 119
		cycleSpeed 4
	)
)

(instance musician of Prop
	(properties
		x 113
		y 88
		view 111
		loop 1
		signal $0210
	)
)

(instance egoSilhouette of PicView
	(properties
		x 249
		y 167
		view 110
		loop 2
	)
)

(instance lamp1 of PicView
	(properties
		x 87
		y 115
		view 110
		loop 1
	)
)

(instance lamp2 of PicView
	(properties
		x 222
		y 156
		view 110
		loop 1
		cel 1
	)
)

(instance flame1 of Actor
	(properties
		x 222
		y 138
		view 110
		loop 3
		cel 1
	)
)

(instance flame2 of Actor
	(properties
		x 87
		y 102
		view 110
		loop 3
		cel 2
	)
)

(instance pillow of PicView
	(properties
		x 63
		y 89
		view 110
		loop 1
	)
)

(instance jaAfarTimer of Timer
	(properties)
	
	(method (cue)
		(jaAfar setScript: jaAfarLooks)
	)
)

(instance gestureTimer of Timer
	(properties)
	
	(method (cue)
		(cond 
			((omarBody cel?) (omarBody setCycle: Beg omarBody))
			((> (Random 1 10) 5)
				(omarBody
					setLoop: (Random 2 4)
					setCel: 0
					setCycle: Full 1 omarBody
				)
			)
			(else
				(omarBody
					setLoop: (Random 2 4)
					setCel: 0
					setCycle: End omarBody
				)
			)
		)
	)
)
