;;; Sierra Script 1.0 - (do not remove this comment)
(script# 140)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use TargActor)
(use PolyPath)
(use Polygon)
(use Feature)
(use LoadMany)
(use Save)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm140 0
	emblem 1
	swordGotten 2
	door 3
)

(local
	local0
	local1
	local2
	local3
	theIsNightTime
	local5
	local6
	theInvNum
	theInvNum_2
	local9
	[local10 100]
	[local110 8] = [83 151 112 131 150 139 119 158]
	[local118 8] = [70 141 96 123 139 132 99 154]
	[local126 10] = [70 143 99 121 138 144 114 159 77 153]
)
(procedure (localproc_0012 &tmp temp0)
	(if (< (++ local9) 5)
		(= temp0 (if (Btst 164) 60 else 120))
		(ego setScript: moveAnvil 0 (TestSkill 0 temp0))
	else
		(ego setScript: (ScriptID 141 0) 0 1)
	)
)

(procedure (localproc_0060)
	(if (== (trapDoor cel?) 1)
		(chest hide:)
		(trapDoor setCel: 0 setPri: 1)
		(SetUpEgo)
		(if ((curRoom obstacles?) contains: poly3)
			((curRoom obstacles?) delete: poly3)
		)
		(curRoom addObstacle: poly2)
		(HighPrint 140 0)
	else
		(trapDoor setCel: 1 setPri: 11)
		(chest show:)
		(SetUpEgo)
		(HighPrint 140 1)
		(curRoom addObstacle: poly3)
	)
)

(procedure (localproc_00f9 param1 param2 param3 param4 param5 &tmp temp0)
	(= temp0 0)
	(switch (proc3_0 param1 param2 param3 param4 param5)
		(0
			(Say (ScriptID 141 5) 140 2)
		)
		(1
			(Say (ScriptID 141 5) 140 3)
		)
		(2 (= temp0 1))
	)
	(return temp0)
)

(instance shopWindow of TopWindow
	(properties)
)

(instance rm140 of Rm
	(properties
		picture 140
		style $0007
	)
	
	(method (init &tmp newEvent temp1)
		(LoadMany 128 140 301 47 145 141 272)
		(Load rsPIC 2)
		(LoadMany 130 141 972 951 969)
		(super init:)
		(if (== prevRoomNum 150)
			(while ((= newEvent (Event new:)) type?)
				(newEvent dispose:)
			)
			(newEvent dispose:)
		)
		(proc1_19)
		(= theIsNightTime isNightTime)
		(chest init: hide:)
		(trapDoor init:)
		(door init:)
		(anvil init:)
		(if (not (ego has: 25)) (emblem setPri: 15 init:))
		(proc1_31 opening firepit swordOne swordTwo)
		(DrawFeature
			(ScriptID 141 8)
			(ScriptID 141 9)
			(ScriptID 141 10)
			(ScriptID 141 11)
			(ScriptID 141 12)
			(ScriptID 141 13)
			(ScriptID 141 14)
			(ScriptID 141 15)
			(ScriptID 141 16)
			(ScriptID 141 17)
			(ScriptID 141 18)
			(ScriptID 141 19)
			(ScriptID 141 20)
			(ScriptID 141 21)
			(ScriptID 141 22)
		)
		(= useObstacles 1)
		(poly1 points: @local110 size: 4)
		(self addObstacle: poly1)
		(Bclr 115)
		(cond 
			((== prevRoomNum 150)
				(= defaultPalette 0)
				(= gGDftSC dayChecker)
				(fire init: setCycle: Fwd)
				(ego loop: 7 init: posn: 126 155)
				((ScriptID 141 5) posn: 90 143 init:)
				(if (Btst 23) (AddToScore 658 7 0))
				(cond 
					((and (Btst 38) (Btst 23))
						(ego get: 2 (* issurBet 2))
						(Bclr 38)
						(ego setScript: bellowsScored)
					)
					((and (Btst 38) (not (Btst 23)))
						(Say (ScriptID 141 5) 140 4)
						(Bclr 38)
						(if (== 0 (mod global259 3))
							((ScriptID 141 5) setScript: (ScriptID 141 3))
						)
					)
					((and (Btst 21) (Btst 23))
						(ego get: 2 (* issurBet 3))
						(Bclr 38)
						(ego setScript: bellowsScored)
					)
					((and (Btst 21) (not (Btst 23)))
						(Say (ScriptID 141 5) 140 5)
						(Bclr 38)
						(if (== 0 (mod global259 3))
							((ScriptID 141 5) setScript: (ScriptID 141 3))
						)
					)
					((Btst 23)
						(Say (ScriptID 141 5) 140 6)
						(ego get: 2 (* 2 issurBet))
					)
					(else (Say (ScriptID 141 5) 140 7) (++ issurBet))
				)
			)
			((not theIsNightTime)
				(= gGDftSC dayChecker)
				(fire init: setCycle: Fwd)
				(ego loop: 1 init: posn: 278 146)
				((ScriptID 141 5) init:)
				(self setScript: (ScriptID 141 6))
			)
			(theIsNightTime
				(Bset 115)
				(poly2 points: @local118 size: 4)
				(poly3 points: @local126 size: 5)
				(= gGDftSC gAllSC)
				(ego loop: 1 init: posn: 278 146)
				(AddToScore 698 3 2)
				(ego setScript: (ScriptID 141 2))
			)
		)
		(gCMusic
			number:
				(if
				(and theIsNightTime (not (== prevRoomNum 150)))
					260
				else
					140
				)
			loop: -1
			playBed:
		)
		(Bset 128)
	)
	
	(method (doit)
		(if (and theIsNightTime (not isNightTime))
			(if (timers contains: (ScriptID 141 7))
				((ScriptID 141 7) dispose:)
			)
			(ego setScript: (ScriptID 141 0) 0 1)
		)
		(if (& (ego onControl: 1) $0002)
			(if (Btst 114) (Bset 26))
			(if
			(and theIsNightTime (timers contains: (ScriptID 141 7)))
				((ScriptID 141 7) dispose:)
			)
			(= gTopExit 3)
			(if (cast contains: (ScriptID 141 5))
				((ScriptID 141 5) dispose:)
			)
			(curRoom newRoom: 330)
		)
		(super doit:)
	)
	
	(method (dispose)
		(++ global259)
		(DisposeScript 141)
		(gCMusic fade:)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/shop')
				)
				(HighPrint 140 8)
			)
			(
			(and theIsNightTime (Said 'throw/dagger,boulder')) (HighPrint 140 9))
			((Said 'buy,barter/blade')
				(cond 
					((not (cast contains: (ScriptID 141 5))) (HighPrint 140 10))
					((not (if (ego has: 4) else (ego has: 24))) (HighPrint 140 11))
					((ego has: 24) (Say (ScriptID 141 5) 140 12))
					(else (self setScript: swordGotten 0 1))
				)
			)
			(
				(or
					(Said 'bargain//blade')
					(Said 'bargain[<for]/blade')
				)
				(cond 
					((not (cast contains: (ScriptID 141 5))) (HighPrint 140 10))
					((not (if (ego has: 4) else (ego has: 24))) (HighPrint 140 11))
					((ego has: 24) (Say (ScriptID 141 5) 140 12))
					((TestSkill 13 80) (self setScript: swordGotten 0 2))
					(else (self setScript: swordGotten 0 3))
				)
			)
			(
				(or
					(Said 'bargain//dagger')
					(Said 'bargain[<for]/dagger')
				)
				(if (cast contains: (ScriptID 141 5))
					(HighPrint 140 13)
				else
					(HighPrint 140 10)
				)
			)
			(
				(or
					(Said 'bargain//bellows')
					(Said 'bargain[<for]/bellows')
				)
				(cond 
					((not (cast contains: (ScriptID 141 5))) (HighPrint 140 10))
					((ego has: 25) (Say (ScriptID 141 5) 140 14))
					((not (Btst 21)) (Say (ScriptID 141 5) 140 15))
					((TestSkill 13 80)
						(if (Btst 165)
							(Say (ScriptID 141 5) 140 16)
							(Bclr 21)
							(Bclr 38)
							(ego setScript: bellowsScored)
						else
							(Say (ScriptID 141 5) 140 17)
							(= local6 1)
							(= issurBet 10)
							(Bset 38)
						)
					)
					(else (Say (ScriptID 141 5) 140 18))
				)
			)
			(
				(or
					(Said
						'tell[/issur,man,armorer,keeper,clerk]/elemental[<air]'
					)
					(Said 'tell[/issur,man,armorer,keeper,clerk]/bellows')
					(Said 'tell[<of]/bellows')
				)
				(cond 
					((not (cast contains: (ScriptID 141 5))) (HighPrint 140 10))
					((ego has: 25) (Say (ScriptID 141 5) 140 19))
					((Btst 21) (Say (ScriptID 141 5) 140 20))
					((not (Btst 23))
						(if (TestSkill 13 50)
							(Say (ScriptID 141 5) 140 21)
							(= local6 1)
							(= issurBet 20)
							(Bset 21)
						else
							(Say (ScriptID 141 5) 140 22)
						)
					)
				)
			)
			((Said 'tell') (Say (ScriptID 141 5) 140 23))
			(
				(or
					(Said 'play[/wrestle[<arm,wrist]]')
					(Said '/wrestle[<arm,wrist]')
					(Said 'wrestle[<arm,wrist]')
					(Said 'defeat[/issur,man,keeper,clerk,armorer]')
					(Said 'put<down/alm,dinar')
					(Said 'bet,gamble')
					(Said 'made,place/bet')
					(Said 'try<again')
				)
				(cond 
					((not (cast contains: (ScriptID 141 5))) (HighPrint 140 24))
					((Btst 23) (Say (ScriptID 141 5) 140 25))
					((not local6)
						(cond 
							((and (not (cast contains: emblem)) (Btst 21)) (Say (ScriptID 141 5) 140 26) (= issurBet 20))
							((Btst 24) (Say (ScriptID 141 5) (Format @local10 140 27 issurBet)))
							(else (Say (ScriptID 141 5) 140 28) (= issurBet 1))
						)
						(= local6 1)
					)
					(else (ego setScript: checkMoneyAndGo))
				)
			)
			(
			(and (Said 'hello') (cast contains: (ScriptID 141 5))) (Say (ScriptID 141 5) 140 29))
			((Said 'made,gave,display/sign[<thief]')
				(MakeThiefSign)
				(if (cast contains: (ScriptID 141 5))
					(ego setScript: (ScriptID 141 4))
				)
			)
			((Said 'grab,acquire/chest,box,strongbox,safe')
				(if (== (trapDoor cel?) 1)
					(HighPrint 140 30)
				else
					(HighPrint 140 31)
				)
			)
			((Said 'grab') (HighPrint 140 32))
		)
	)
)

(instance openChest of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(ego
					setMotion: PolyPath (+ (chest x?) 34) (chest y?) self
				)
			)
			(1 (ego setHeading: 315 self))
			(2
				(ego view: 47 loop: 1 cel: 0 setCycle: End)
				(= cycles 10)
			)
			(3
				(cond 
					(local1
						(= local1 0)
						(if (Btst 26)
							(HighPrint 140 33)
						else
							(AddToScore 699 3 2)
							(HighPrint 140 34)
							(Bset 26)
							(ego get: 2 100)
							(ego get: 1 500)
						)
						(self changeState: 6)
					)
					((== (chest cel?) 2)
						(chest setCel: 1)
						(SetUpEgo)
						(HighPrint 140 35)
						(self changeState: 6)
					)
					(register (gMiscMusic number: 20 loop: 1 priority: 12 play: self))
					(else (= seconds 3))
				)
			)
			(4
				(chest setCel: 2)
				(= cycles 2)
			)
			(5
				(HighPrint 140 36)
				(if (Btst 26)
					(HighPrint 140 33)
				else
					(AddToScore 699 3 2)
					(HighPrint 140 34)
					(Bset 26)
					(ego get: 2 100)
					(ego get: 1 500)
				)
				(self cue:)
			)
			(6 (ego setCycle: Beg self))
			(7
				(LockEgo)
				(proc1_19)
				(ego setHeading: 315)
				(self dispose:)
			)
		)
	)
)

(instance openTrap of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(cond 
					((not (Btst 114)) (HighPrint 140 37) (self dispose:))
					((trapDoor onMe: ego) (HighPrint 140 38) (HighPrint 140 39))
					(else
						(ego
							setMotion: PolyPath (+ (trapDoor x?) 42) (+ (trapDoor y?) 4) self
						)
					)
				)
			)
			(1 (ego setHeading: 315 self))
			(2
				(if ((curRoom obstacles?) contains: poly2)
					((curRoom obstacles?) delete: poly2)
				)
				(ego view: 47 loop: 1 cel: 0 setCycle: End self)
			)
			(3
				(localproc_0060)
				(= cycles 3)
			)
			(4 (ego setCycle: Beg self))
			(5
				(proc1_19)
				(ego setHeading: 315)
				(self dispose:)
			)
		)
	)
)

(instance moveAnvil of Script
	(properties)
	
	(method (dispose)
		(proc1_19)
		(super dispose:)
	)
	
	(method (changeState newState &tmp temp0 temp1)
		(= temp0 (+ local5 local5))
		(= temp1 local5)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(ego
					setMotion: PolyPath (+ (anvil x?) 28) (+ (anvil y?) 9) self
				)
				(= local5 (if (Btst 114) 1 else -1))
			)
			(1 (ego setHeading: 315 self))
			(2
				(if ((curRoom obstacles?) contains: poly1)
					((curRoom obstacles?) delete: poly1)
				)
				(if ((curRoom obstacles?) contains: poly2)
					((curRoom obstacles?) delete: poly2)
				)
				(ego view: 47 setLoop: 5 setCel: 2)
				(= cycles 3)
			)
			(3
				(if register
					(= register 3)
					(= cycles 5)
				else
					(HighPrint 140 40)
					(ego setMotion: PolyPath (+ (ego x?) 15) (ego y?))
					(LockEgo)
					(curRoom addObstacle: poly1)
					(self dispose:)
				)
			)
			(4
				(anvil
					posn: (+ (anvil x?) temp0) (+ (anvil y?) temp1)
				)
				(ego setCel: 3)
				(if (Btst 114)
					(ego posn: (+ (ego x?) temp0) (+ (ego y?) temp1))
					(= cycles 1)
				else
					(= cycles 5)
				)
			)
			(5
				(ego setCel: 2)
				(if (Btst 114)
					(= cycles 5)
				else
					(ego posn: (+ (ego x?) temp0) (+ (ego y?) temp1))
					(= cycles 1)
				)
			)
			(6
				(cond 
					((-- register) (= local5 (* local5 2)) (self changeState: 4))
					((Btst 114)
						(Bclr 114)
						(curRoom addObstacle: poly1)
						(HighPrint 140 41)
						(LockEgo)
						(self dispose:)
					)
					(else
						(Bset 114)
						(curRoom addObstacle: poly2)
						(HighPrint 140 42)
						(LockEgo)
						(self dispose:)
					)
				)
			)
		)
	)
)

(instance bellowsScored of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (Btst 165)
					(= seconds 3)
				else
					(Say (ScriptID 141 5) self 140 43)
				)
			)
			(1
				(AddToScore 609 7)
				(HighPrint 140 44)
				(= local6 0)
				(emblem dispose:)
				(Bset 85)
				(ego get: 25)
				(self dispose:)
			)
		)
	)
)

(instance swordGotten of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch register
					(1
						(if (localproc_00f9 24 10000 0 0)
							(ego use: 4)
							(= global160 (+ global160 10))
							(SkillUsed 15 25)
						)
					)
					(2
						(if (localproc_00f9 24 8000 0 0)
							(ego use: 4)
							(= global160 (+ global160 10))
							(SkillUsed 15 25)
						)
					)
					(3
						(if (localproc_00f9 24 10000 0 0)
							(ego use: 4)
							(= global160 (+ global160 10))
							(SkillUsed 15 25)
						)
					)
					(4
						(if (localproc_00f9 5 500 0 1 1)
							(= theInvNum [invNum 5])
						)
					)
				)
				(self cue:)
			)
			(1
				(switch register
					(1
						(if (ego has: 24) (HighPrint 140 45))
					)
					(2
						(if (ego has: 24) (HighPrint 140 46))
					)
					(3
						(if (ego has: 24) (HighPrint 140 47))
					)
					(4
						(if (> theInvNum theInvNum_2)
							(HighPrint 140 48)
							(= theInvNum_2 [invNum 5])
						)
					)
				)
				(self dispose:)
			)
		)
	)
)

(instance yourWorthy of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Say (ScriptID 141 5) self 140 49)
			)
			(1
				(AddToScore 609 7)
				(HighPrint 140 50)
				(emblem dispose:)
				(Bset 85)
				(ego get: 25)
				(self dispose:)
			)
		)
	)
)

(instance checkMoneyAndGo of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch (proc3_1 (* issurBet 100))
					(0
						(Say (ScriptID 141 5) 140 51)
						(self dispose:)
					)
					(1
						(Say (ScriptID 141 5) 140 52)
						(self dispose:)
					)
					(else 
						(proc3_2 (* issurBet 100))
						(= cycles 2)
					)
				)
			)
			(1
				(Bset 24)
				(curRoom newRoom: 150)
				(self dispose:)
			)
		)
	)
)

(instance theDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: PolyPath 242 136 self)
			)
			(1
				(if (== (door cel?) 2)
					(door setCycle: Beg self)
				else
					(door setCycle: End self)
				)
			)
			(2
				(ego setMotion: MoveTo 212 133 self)
			)
			(3 (ego setHeading: 180 self))
			(4 (self dispose:))
		)
	)
)

(instance aWin of SysWindow
	(properties
		back 11
	)
)

(instance fire of Prop
	(properties
		x 50
		y 79
		noun '/fire'
		description {the intensely hot fire}
		lookStr {The fiercely flickering fire needs another faggot of firewood.}
		view 145
		loop 5
	)
)

(instance door of TargActor
	(properties
		x 285
		y 138
		noun '/door'
		description 'the&door&in&the&courtyard'
		lookStr {It is the only door to the shop.}
		view 140
		loop 6
		illegalBits $0000
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doit)
		(if
		(and (== (door cel?) 2) (< (ego distanceTo: door) 40))
			(ego setMotion: 0 posn: (- (ego x?) 6) (- (ego y?) 6))
			(HighPrint 140 54)
		)
		(super doit:)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(cond 
					((cast contains: (ScriptID 141 5)) (Say (ScriptID 141 5) 140 55))
					((== (door cel?) 0) (HighPrint 140 56))
					(else (self setScript: theDoor))
				)
			)
			(3
				(cond 
					((cast contains: (ScriptID 141 5)) (Say (ScriptID 141 5) 140 55))
					((== (door cel?) 2) (HighPrint 140 57))
					(else (self setScript: theDoor))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (openMe)
		(if (== (door cel?) 0)
			(HighPrint 140 53)
		else
			(door setCycle: Beg)
		)
		(return 1)
	)
)

(instance chest of TargActor
	(properties
		x 92
		y 150
		noun '/chasm,chest,box,strongbox,safe'
		description {the wooden strongbox}
		view 140
		loop 3
		cel 1
		signal $4010
		illegalBits $0000
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doit)
		(if (and local2 (not (ego script?)))
			(= local2 0)
			(self setScript: openChest 0 1)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,examine/chasm,chest,box,strongbox,safe') (HighPrint 140 58))
			(
			(Said 'unlock,lockpick/lock,chest,box,strongbox,safe')
				(cond 
					((== (chest cel?) 2) (HighPrint 140 59))
					((not (self passedChecks: 2)))
					((not (CanPickLocks)) (HighPrint 140 60))
					((TestSkill 9 75 global133) (self setScript: openChest 0 1))
					(else (HighPrint 140 61))
				)
			)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 140 58))
			(7
				(if (not theIsNightTime)
					(HighPrint 140 62)
				else
					(HighPrint 140 30)
				)
			)
			(5 (HighPrint 140 30))
			(2
				(if (== (chest cel?) 2)
					(HighPrint 140 63)
				else
					(HighPrint 140 64)
				)
			)
			(3
				(if (== (chest cel?) 2)
					(self setScript: openChest 0 1)
				else
					(HighPrint 140 65)
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (openMe)
		(if (== (chest cel?) 2)
			(HighPrint 140 63)
		else
			(= local1 1)
			(= local2 1)
			(chest setCel: 2)
			(SetUpEgo)
			(HighPrint 140 36)
		)
		(return 1)
	)
)

(instance trapDoor of TargActor
	(properties
		x 92
		y 150
		noun '/trap,(door<trap)'
		description {the trap door}
		view 140
		loop 5
		priority 1
		signal $4010
		illegalBits $0000
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doit)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'lift/trap,(door<trap)')
			(self doVerb: 2)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if (Btst 114)
					(HighPrint 140 66)
				else
					(HighPrint 140 67)
				)
			)
			(7 (HighPrint 140 68))
			(2
				(if (== (trapDoor cel?) 1)
					(HighPrint 140 69)
				else
					(ego setScript: openTrap)
				)
			)
			(3
				(if (== (trapDoor cel?) 1)
					(ego setScript: openTrap)
				else
					(HighPrint 140 70)
				)
			)
			(5 (ego setScript: openTrap))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (openMe &tmp temp0)
		(= temp0 0)
		(cond 
			((not theIsNightTime) (HighPrint 140 71))
			((== (trapDoor cel?) 1) (HighPrint 140 72))
			((not (Btst 114)) (HighPrint 140 37))
			((self onMe: ego) (HighPrint 140 38) (HighPrint 140 39))
			(else (self setScript: setTrapPoly) (= temp0 1))
		)
		(return temp0)
	)
)

(instance anvil of TargActor
	(properties
		x 93
		y 150
		noun '/anvil'
		description {the anvil}
		view 140
		loop 4
		priority 10
		signal $4010
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			(
				(or
					(Said 'grease/anvil,floor')
					(Said 'use,put,pour/grease[/anvil,floor]')
				)
				(cond 
					((Btst 164) (HighPrint 140 73))
					((not (ego has: 42)) (HighPrint 140 74))
					((> (ego distanceTo: anvil) 80) (HighPrint 140 75))
					(theIsNightTime (HighPrint 140 76) (Bset 164))
					(else (HighPrint 140 77) (Bset 164))
				)
			)
			((Said 'replace,(put<back)/anvil')
				(= temp0 (if (Btst 164) 60 else 120))
				(cond 
					((== (trapDoor cel?) 1) (HighPrint 140 78))
					((Btst 114) (localproc_0012))
					(else (HighPrint 140 79))
				)
			)
			((Said 'force,slide/anvil')
				(cond 
					((not theIsNightTime) (HighPrint 140 71))
					((== (trapDoor cel?) 1) (HighPrint 140 78))
					(else (localproc_0012))
				)
			)
		)
		(super handleEvent: pEvent)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 140 80))
			(7 (HighPrint 140 81))
			(5
				(cond 
					((not theIsNightTime) (HighPrint 140 71))
					((== (trapDoor cel?) 1) (HighPrint 140 78))
					(else (localproc_0012))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (openMe)
		(HighPrint 140 82)
		(return 0)
	)
)

(instance emblem of View
	(properties
		x 277
		y 52
		noun '/bellows'
		description {Saul's bellows}
		lookStr {It looks very much like Saul's Bellows.__It is the emblem of the iron worker's trade.}
		view 140
		loop 2
		cel 3
		priority 15
	)
	
	(method (init)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= palette 1)
		else
			(= palette 2)
		)
		(super init:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(cond 
				((ego has: 25)
					(if (cast contains: (ScriptID 141 5))
						(Say (ScriptID 141 5) 140 83)
					else
						(HighPrint 140 84)
					)
				)
				((Btst 23) (ego setScript: yourWorthy))
				((not (cast contains: (ScriptID 141 5))) (HighPrint 140 85))
				((not (Btst 22)) (Say (ScriptID 141 5) 140 86))
				(else (Say (ScriptID 141 5) 140 87))
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance firepit of Feature
	(properties
		x 56
		y 76
		noun '/alcove,chimney,(place<fire)'
		nsTop 45
		nsLeft 27
		nsBottom 107
		nsRight 86
		description {the alcove with a fire in it}
		lookStr {The weaponer works up a sweat when he is heating his metals.}
	)
)

(instance opening of Feature
	(properties
		x 280
		y 110
		noun '/opening'
		nsTop 78
		nsLeft 259
		nsBottom 142
		nsRight 302
		description {the doorway into the plaza}
		lookStr {It's the only way out.}
	)
)

(instance swordOne of Feature
	(properties
		x 197
		y 74
		noun '/blade<little'
		nsTop 70
		nsLeft 173
		nsBottom 78
		nsRight 221
		description {the small sword on the rack}
		lookStr {The smaller sword on the rack looks to be of fine workmanship.}
	)
)

(instance swordTwo of Feature
	(properties
		x 192
		y 82
		noun '/blade<big'
		nsTop 79
		nsLeft 165
		nsBottom 86
		nsRight 220
		description {the large sword on the rack}
		lookStr {The larger sword on the rack looks to be made for one of the giants of the desert brigands.}
	)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)

(instance poly2 of Polygon
	(properties
		type $0002
	)
)

(instance poly3 of Polygon
	(properties
		type $0002
	)
)

(instance dayChecker of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (== param1 24)
				(return 1)
			else
				(HighPrint 140 88)
				(return 0)
			)
		)
	)
)

(instance setTrapPoly of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if ((curRoom obstacles?) contains: poly2)
					((curRoom obstacles?) delete: poly2)
				)
				(trapDoor setCel: 1 setPri: 11)
				(chest show:)
				(SetUpEgo)
				(HighPrint 140 1)
				(= cycles 1)
			)
			(1
				(curRoom addObstacle: poly3)
				(= cycles 1)
			)
			(2 (self dispose:))
		)
	)
)
