;;; Sierra Script 1.0 - (do not remove this comment)
(script# 150)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Bar)
(use Intrface)
(use LoadMany)
(use Save)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm150 0
)

(local
	local0
	local1
	local2
	local3
	local4
	theGStrength
	theTheGStrength
	local7 =  1
	local8
	local9
	local10
	local11
	local12 =  400
	local13 =  1
	local14
	local15
	local16
	local17 =  10
	theArmsCel
	local19
	local20
	[newATrim 6]
	[local27 6] = [0 1 1 0 2 3]
	[local33 6] = [0 0 1 1]
	[local39 6] = [83 235 235 84 50 269]
	[local45 6] = [52 52 160 160 125 124]
)
(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 6)
		((= [newATrim temp0] (aTrim new:))
			loop: [local27 temp0]
			cel: [local33 temp0]
			x: [local39 temp0]
			y: [local45 temp0]
		)
		(addToPics add: [newATrim temp0] init: doit:)
		(++ temp0)
	)
)

(instance aTrim of PicView
	(properties
		shiftClick 0
		view 150
		signal $0010
	)
)

(instance rm150 of Rm
	(properties
		picture 150
		style $0007
	)
	
	(method (init &tmp temp0 temp1)
		(LoadMany 128 150 151)
		(switch gSeconds
			(0 (= gSaveSpeed 0))
			(1 (= gSaveSpeed 2))
			(2 (= gSaveSpeed 5))
			(3 (= gSaveSpeed 6))
		)
		(if (== arcadeDifficultyLevel 1)
			(= gSaveSpeed (+ gSaveSpeed 5))
		)
		(if (== arcadeDifficultyLevel 3)
			(= gSaveSpeed (/ gSaveSpeed 2))
		)
		(= theTheGStrength (= theGStrength [skills 17]))
		(= temp1 150)
		(= temp0 1)
		(while (< temp0 5)
			(= local0 temp0)
			(if (>= [skills 0] temp1) (break))
			(++ temp0)
			(= temp1 (- temp1 25))
		)
		(= local10 (= local1 (/ 1500 local0)))
		(= local3 (/ (* (= local2 (/ local1 80)) 8) 10))
		(gDirH add: self)
		(gKeyH add: self)
		(gCMusic number: 50 loop: -1 playBed:)
		(super init:)
		(localproc_000c)
		(Display
			150
			0
			dsCOORD
			84
			3
			dsFONT
			300
			dsCOLOR
			12
			dsBACKGROUND
			0
		)
		(Display
			150
			1
			dsCOORD
			201
			3
			dsFONT
			300
			dsCOLOR
			12
			dsBACKGROUND
			0
		)
		(fatHead init:)
		(arms init:)
		(egoPressureBar max: 500 value: (/ local1 100) init:)
		(issurPressureBar max: 500 value: (/ local10 100) init:)
		(curRoom setScript: readySetGo)
	)
	
	(method (dispose)
		(Bset 17)
		(= gSaveSpeed 6)
		(gCMusic fade:)
		(gDirH delete: self)
		(gKeyH delete: self)
		(super dispose:)
	)
)

(instance rulesWindow of SysWindow
	(properties
		back 7
	)
)

(instance egoPressureBar of Bar
	(properties
		x 85
		y 18
		cel 7
	)
)

(instance issurPressureBar of Bar
	(properties
		x 210
		y 18
		cel 7
	)
)

(instance fatHead of Prop
	(properties
		x 161
		y 93
		shiftClick 0
		view 151
		loop 2
		cel 3
	)
	
	(method (doit)
		(if (arms loop?) (self setCel: (arms cel?)))
		(super doit:)
	)
)

(instance arms of Prop
	(properties
		x 125
		y 153
		shiftClick 0
		view 151
	)
)

(instance readySetGo of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Print
					150
					2
					#mode
					1
					#width
					270
					#at
					-1
					100
					#window
					rulesWindow
				)
				(self cue:)
			)
			(1
				(HighPrint 150 3 103)
				(= seconds 2)
			)
			(2
				(HighPrint 150 4 103)
				(arms setCycle: End)
				(= seconds 2)
			)
			(3
				(HighPrint 150 5 103)
				(arms loop: 1 cel: 3)
				(egoPressureBar
					max: (/ (* (/ 2500 local0) 2) 10)
					value: (/ local1 10)
					doit:
				)
				(issurPressureBar
					max: (/ (* (/ 2500 local0) 2) 10)
					value: (/ local10 10)
					doit:
				)
				(fatHead setScript: issurStrategy)
				(curRoom setScript: goForIt)
			)
		)
	)
)

(instance goForIt of HandsOffScript
	(properties)
	
	(method (doit &tmp armsCel temp1)
		(if local15
			(= local15 0)
			(egoPressureBar
				max: (/ (* (/ 2500 local0) 2) 10)
				value: (/ local1 10)
				draw:
			)
			(issurPressureBar
				max: (/ (* (/ 2500 local0) 2) 10)
				value: (/ local10 10)
				draw:
			)
			(= local13 (+ (/ (* 7 local10) 4000) 1))
			(= local7
				(+ (/ (* 5 local1) (* (/ 2500 local0) 2)) 1)
			)
			(if local8 (= local7 (* local7 local8)))
			(if local14 (= local13 (* local13 (+ local14 2))))
			(cond 
				((< [skills 0] 40) (= local7 (* local7 4)))
				((< [skills 0] 60) (= local7 (* local7 3)))
				((< [skills 0] 80) (= local7 (* local7 2)))
			)
			(= theGStrength (- theGStrength local7))
			(= local12 (- local12 local13))
			(if (< theGStrength (- theTheGStrength 10))
				(= theTheGStrength theGStrength)
				(ReduceSP 10)
			)
			(= armsCel (arms cel?))
			(cond 
				((< local17 0)
					(if (== local17 -1)
						(arms setCel: theArmsCel)
						(= local17 10)
					else
						(++ local17)
					)
				)
				((!= theArmsCel armsCel) (= theArmsCel armsCel) (= local17 10))
				(local17 (-- local17))
				((and (!= armsCel 1) (> local10 local1)) (arms setCel: (- armsCel 1)) (= local17 -4))
				((and (!= armsCel 5) (> local1 local10)) (arms setCel: (+ armsCel 1)) (= local17 -4))
			)
			(= temp1
				(cond 
					((== currentDay 10) 10)
					((or (>= local0 2) (< (arms cel?) 3)) 0)
					(else (/ 200 local12))
				)
			)
			(if local8
				(-- local8)
				(= local1 (+ local1 (* local2 (+ local8 temp1))))
			)
			(if local14
				(-- local14)
				(= local10 (+ local10 (* local3 local14)))
				(if (not (if (or local16 local8) else local9))
					(= local1 (- local1 local2))
				)
			)
			(cond 
				((not local16))
				((-- local16)
					(cond 
						((== currentDay 10) (= local1 local10))
						((> local1 local10) (= local1 (- local1 local2)))
						((> local10 (+ local1 30))
							(if (> (arms cel?) 3)
								(= local1 (+ local1 (* local2 (if local14 14 else 8))))
							else
								(= local1 (+ local1 (* local2 4)))
							)
						)
						((> local10 local1) (= local1 (+ local1 local2)))
						(else (= local1 (+ local1 (/ local2 4))))
					)
				)
			)
			(if (> local1 (+ local10 30))
				(if local8
					(= local10 (+ local10 (* local3 (+ local0 1))))
				else
					(= local10 (+ local10 (* local3 (- 5 local0))))
				)
			)
			(if (> local1 (* (/ 2500 local0) 2))
				(= local1 (* (/ 2500 local0) 2))
			)
			(if (> local10 4000) (= local10 4000))
			(cond 
				((and (< theGStrength 50) (not local20)) (= local20 1) (= local1 0) (PrintWarning 150 6 25 4 103))
				(
				(and (<= local12 0) (not local20) (!= (arms cel?) 6))
					(= local20 1)
					(= local10 0)
					(PrintWarning 150 7 25 4 103)
				)
			)
			(cond 
				((> local1 (+ local10 50))
					(= local11 0)
					(if (>= (++ local4) 5)
						(arms setCel: (+ (arms cel?) 1))
						(= local4 0)
						(= local17 10)
					)
				)
				((> local10 (+ local1 50))
					(= local4 0)
					(if (>= (++ local11) 5)
						(arms setCel: (- (arms cel?) 1))
						(= local11 0)
						(= local17 10)
					)
				)
			)
			(cond 
				((and (== (arms cel?) 6) (not local19)) (= local19 1) (Bset 23) (arms setScript: byeBye))
				(
					(and
						(== (arms cel?) 0)
						(== (arms loop?) 1)
						(not local19)
					)
					(= local19 1)
					(arms setScript: byeBye)
				)
			)
		else
			(= local15 1)
		)
		(= local9 0)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1 (DisposeDialog))
		)
	)
	
	(method (handleEvent pEvent &tmp newEvent)
		(return
			(if
			(and (== (pEvent message?) KEY_RETURN) local20)
				(return (pEvent claimed: 1))
			else
				(if (super handleEvent: pEvent) (return 1))
				(switch (pEvent type?)
					(evJOYSTICK
						(pEvent claimed: 1)
						(switch (pEvent message?)
							(JOY_LEFT
								(= local9 1)
								(= local1 (+ local1 local2))
							)
							(JOY_RIGHT
								(= local1 (- local1 local2))
							)
						)
						(while ((= newEvent (Event new:)) type?)
							(newEvent dispose:)
						)
						(newEvent dispose:)
					)
					(evKEYBOARD
						(pEvent claimed: 1)
						(switch (pEvent message?)
							(KEY_RETURN
								(if (and (not local16) (not local8))
									(SkillUsed 0 4)
									(= local16 (/ theGStrength 100))
								)
							)
							(KEY_SPACE
								(if (and (not local16) (not local8))
									(SkillUsed 0 8)
									(= local8 6)
								)
							)
						)
						(while ((= newEvent (Event new:)) type?)
							(newEvent dispose:)
						)
						(newEvent dispose:)
					)
				)
			)
		)
	)
)

(instance byeBye of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(DisposeDialog)
				(= cycles 2)
			)
			(2 (curRoom newRoom: 140))
		)
	)
)

(instance issurStrategy of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles (Random 5 20)))
			(1
				(if (not local14) (= local14 6))
				(= cycles (Random 20 50))
			)
			(2 (self changeState: 0))
		)
	)
)
