;;; Sierra Script 1.0 - (do not remove this comment)
(script# 160)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Stage)
(use Intrface)
(use Feature)
(use LoadMany)
(use Timer)
(use Avoider)
(use Extra)
(use Save)
(use Motion)
(use Actor)
(use System)

(public
	rm160 0
	uhura 1
	rakeesh 2
	uhuraBody 3
	rakeeshBody 4
	responseTimer 5
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
	[local9 33] = [0 1 0 0 1 2 5 0 0 0 2 0 3 3 4 0 2 0 3 0 2 0 0 4 1 5 2 5 2 5 2 6 4]
	[local42 38] = [1 31 32 33 34 35 36 37 38 39 40 41 42 0 43 44 45 0 46 0 47 48 49 50 51 52 0 0 0 53 54 55 56]
	[local80 60] = [2 '//labor' 3 '//note' 4 '//book,log,logbook' 5 '//plaque,emblem,logo,crest,(bulletin,sign,board<eof)' 6 '//spear,bow,arrow,quiver' 7 '//simba,baby,baby' 8 '//home' 9 '//scorpion' 10 '//bandit' 11 '//ghoul' 12 '//jackal,jackal,(man<jackal)' 13 '//dinosaur,(saurii<terror)' 14 '//griffin' 15 '//dad' 16 '//errand,bulletin,sign,board[<errand,about]' 17 '//rakeesh,lion' 18 '//paladin' 19 '//leg,bandage,injury' 20 '//eof,(order[<eternal,fighter,about])' 21 '//wizard,(user<magic),mage' 22 '//afreet' 23 '//attar,apothecary' 24 '//keapon,(clerk<magic),keapon' 25 '//issur,armorer,armorer' 26 '//prize,service' 27 '//blade,soulforge,(forge<soul)' 28 '//hero,adventurer' 29 '//moose' 30 '//train,practice,attack,battle']
	[local140 38] = [46 47 48 49 50 51 52 53 54 55 56 57 59 45 60 61 62 45 63 64 65 66 67 68 69 70 71 80 74 75 76 77 78 45 45 45 45 45]
	[local178 64] = [0 '//nature' 2 '//flame' 5 '//attack,battle' 6 '//leg,bandage,injury' 8 '//demon' 10 '//kingdom' 12 '//wizard' 14 '//choice' 15 '//people,lion' 16 '//tarna' 17 '//power,fighter' 19 '//will,soul' 20 '//philosopher' 21 '//forge,soulforge[<soul,about]' 23 '//paladin' 27 '//blade[<flaming,about]' 28 '//guildmaster' 30 '//simba,baby,baby' 32 '//magic<dark' 34 '//adventurer,adventure,adventuring' 35 '//ask' 36 '//hero' 37 '//ghoul' 38 '//dinosaur,(saurii<terror)' 39 '//griffin' 40 '//bandit' 41 '//(man<jackal),jackal' 42 '//scorpion' 43 '//poison,pill,cure,tail' 44 '//moose' 79 '//book,log,logbook']
)
(instance rm160 of Stage
	(properties
		picture 160
		south 320
		bottomFromX 160
		bottomExit 2
		bottomToX 160
	)
	
	(method (init &tmp [temp0 20] newEvent)
		(LoadMany 128 0 160 162 168)
		(Load rsTEXT 162 168)
		(= local2 [local9 (- (* currentDay 2) 1)])
		(= local3 [local9 (* currentDay 2)])
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(uhura init:)
		(switch local3
			(0
				(uhuraBody loop: 4 x: 67 y: 125 init:)
			)
			(1
				(uhuraBody loop: 2 x: 143 y: 119 init:)
				(rakeesh init:)
				(rakeeshHead init:)
				(rakeeshBody init:)
				(rakeeshTail init:)
				(simba init: setCycle: Fwd (= local4 50))
			)
			(2
				(uhuraBody loop: 3 x: 220 y: 157 init:)
			)
			(3
				(uhuraBody loop: 4 x: 218 y: 118 init:)
			)
			(4
				(uhuraBody loop: 2 x: 67 y: 125 init:)
				(rakeesh init:)
				(rakeeshHead init:)
				(rakeeshBody init:)
				(rakeeshTail init:)
				(simba init: setCycle: Fwd (= local4 50))
			)
			(5
				(uhuraBody loop: 2 x: 218 y: 118 init:)
			)
		)
		(switch prevRoomNum
			(161 (= inOut 3))
			(170
				(ego x: 220 y: 145 loop: 1)
				(= inOut 3)
			)
			(else  (= prevRoomNum 320))
		)
		(if (cast contains: rakeesh)
			(ego illegalBits: (| (ego illegalBits?) $2000))
			(if (cast contains: simba)
				(ego illegalBits: (| (ego illegalBits?) $1000))
			)
		)
		(if (== prevRoomNum 170)
			(self style: 17)
		else
			(self style: 6)
		)
		(cond 
			((== prevRoomNum 170))
			((== prevRoomNum 161))
			((== currentDay (/ global260 100))
				(if (== local2 2)
					(= entranceScript (ScriptID 163 1))
				else
					(= entranceScript (ScriptID 163 0))
				)
			)
			((and (== local2 3) (not (Btst 610))) (= entranceScript (ScriptID 163 2)))
			(
				(and
					(== local2 5)
					(== gHeroType 0)
					(< (/ global260 100) currentDay)
				)
				(= entranceScript (ScriptID 163 3))
			)
			((== local2 4)
				(if (and (== gHeroType 0) (> elementalsStatus 5))
					(= entranceScript (ScriptID 163 5))
				else
					(= entranceScript (ScriptID 163 4))
				)
			)
			((== local2 6) (= entranceScript (ScriptID 163 6)))
			((== local2 2) (= entranceScript (ScriptID 163 1)))
			(else (= entranceScript (ScriptID 163 0)))
		)
		(ego init:)
		(super init:)
		(proc1_31 leftDoor rightDoor quill fez spears tusks)
		(DrawFeature
			moose
			pillow1
			pillow2
			questBoard
			table
			EOFBoard
			book
			shield
			bow
		)
		(Bset 127)
		(while ((= newEvent (Event new:)) type?)
			(newEvent dispose:)
		)
		(newEvent dispose:)
	)
	
	(method (doit &tmp [temp0 20])
		(super doit:)
		(cond 
			(script)
			((& (ego onControl: 1) $0002) (curRoom newRoom: 170))
			((and (ego inRect: 33 110 65 135) (not local0))
				(= local0 1)
				(ego setMotion: 0)
				(FaceObject ego uhuraBody)
				(Say uhura 160 0)
			)
			(
			(and (ego inRect: 225 117 260 130) (not (Btst 176)))
				(Bset 176)
				(ego setMotion: 0)
				(FaceObject ego uhuraBody)
				(Say uhura 160 1 160 2)
			)
		)
	)
	
	(method (dispose)
		(if (timers contains: responseTimer)
			(= local1 1)
			(responseTimer cue:)
		)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(= gTopExit 2)
		(= global260 global277)
		(DisposeScript 163)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 42])
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/hall[<club,fighter]')
				)
				(HighPrint 160 3)
			)
			((Said 'practice') (FaceObject ego uhuraBody) (Say uhura 160 4))
			((Said 'get,acquire/note')
				(if
					(and
						(== local2 5)
						(== gHeroType 0)
						(< (/ global260 100) currentDay)
					)
					(HighPrint 160 5)
				else
					(pEvent claimed: 0)
				)
			)
			(
				(Said
					'get,acquire,acquire,borrow/blade,(forge<soul),soulforge'
				)
				(if
					(and
						(== currentDay 12)
						(== elementalsStatus 5)
						(== gHeroType 0)
					)
					(if (Btst 72)
						(Say rakeesh 160 6)
					else
						(Bset 72)
						(rakeeshBody setScript: egoTakesSword)
					)
				else
					(Say rakeesh 160 7)
				)
			)
			(
				(Said
					'gave,hand,offer,replace/blade,(forge<soul),soulforge[/guildmaster,woman]'
				)
				(if (ego has: 31)
					(AddToScore 676 5 3)
					(ego setScript: egoGivesSword)
				else
					(PrintDontHaveIt)
				)
			)
			((Said 'read/log,logbook,(book[<log])')
				(cond 
					((not (ego inRect: 260 130 310 140)) (HighPrint 160 8))
					((Btst 139) (HighPrint (Format @temp0 160 9 @userName)))
					(else (HighPrint 160 10))
				)
			)
			(
				(or
					(Said 'sign/log,logbook,(book[<log])')
					(Said 'write,sign/identity')
				)
				(cond 
					((not (ego inRect: 260 130 310 140)) (HighPrint 160 11))
					((Btst 139) (HighPrint 160 12))
					(else (Bset 139) (AddToScore 611 3) (HighPrint 160 13))
				)
			)
			((Said 'kiss/guildmaster,woman,(master<club)') (HighPrint 160 14))
			(
			(Said 'attack/guildmaster,woman,master,guildmaster') (curRoom newRoom: 170))
			((Said 'join/eof,order')
				(cond 
					((cast contains: rakeesh) (Say rakeesh 160 15))
					((cast contains: uhura) (Say uhura 160 15))
					(else (HighPrint 160 15))
				)
			)
		)
	)
)

(instance egoTakesSword of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (& (ego onControl: 1) $4000)
					(ego
						illegalBits: -20480
						setAvoider: Avoid
						setMotion: MoveTo 178 174 self
					)
				else
					(self cue:)
				)
			)
			(1
				(FaceObject ego rakeesh)
				(Say rakeesh self 160 16)
			)
			(2
				(rakeesh x: 198 z: 36)
				(rakeeshHead hide:)
				(rakeeshTail hide:)
				(rakeeshBody
					loop: 6
					cel: 0
					cycleSpeed: 1
					setCycle: End self
				)
				(if (not (simba loop?))
					(simba setCycle: CT 0 1)
				else
					(simba setScript: babyResumes)
					(= local4 -1)
				)
			)
			(3 (Say rakeesh self 160 17))
			(4
				(rakeeshBody loop: 7 cel: 0 setCycle: CT 7 1 self)
			)
			(5
				(rakeeshBody cel: 8)
				(flame init: setCycle: Fwd)
				(= cycles 15)
			)
			(6
				(flame dispose:)
				(rakeeshBody setCycle: End self)
			)
			(7
				(rakeesh x: 200)
				(Say rakeesh self 160 18 160 19 160 20)
			)
			(8
				(if (or (!= (ego x?) 178) (!= (ego y?) 174))
					(ego setMotion: MoveTo 178 174 self)
				else
					(self cue:)
				)
			)
			(9
				(ego view: 168 loop: 8 cel: 0 setCycle: CT 2 1 self)
			)
			(10
				(AddToScore 661 7 0)
				(ego setCycle: End self get: 31 setAvoider: 0)
				(rakeeshBody loop: 5)
				(rakeesh x: 199)
			)
			(11
				(proc1_19)
				(FaceObject ego rakeesh)
				(self dispose:)
			)
		)
	)
)

(instance egoGivesSword of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(= temp0 (+ (uhuraBody x?) 7))
				(= temp1 (+ (uhuraBody y?) 11))
				(ego setMotion: MoveTo temp0 temp1 self)
			)
			(1
				(if (== local1 0)
					(Say uhura self 160 21)
				else
					(Say uhura self 160 22)
				)
			)
			(2
				(ego use: 31)
				(responseTimer dispose:)
				(self dispose:)
			)
		)
	)
)

(instance babyTurns of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if local6 (HighPrint 160 23 80 {Hero}))
				(simba setCycle: Beg self)
			)
			(1
				(simba loop: 10 setCycle: CT 3 1 self)
			)
			(2
				(if local6
					(= local6 0)
					(Print
						160
						24
						#title
						{Baby Simba}
						#at
						-1
						25
						#window
						babyWindow
					)
					(= local4 5)
				else
					(if
					(and (not (rakeesh cycler?)) (== (++ local5) 4))
						(= local5 0)
						(Print
							160
							25
							#time
							5
							#title
							{Baby Simba}
							#at
							220
							50
							#window
							babyWindow
							#dispose
						)
					)
					(simba loop: 11 setCycle: Fwd)
					(= local4 50)
				)
				(self dispose:)
			)
		)
	)
)

(instance babyResumes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(simba loop: 10 cel: 3 setCycle: Beg self)
			)
			(1
				(simba loop: 0)
				(= local4 (Random 200 400))
				(client setScript: playWithTail)
			)
		)
	)
)

(instance rakeeshLooks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(rakeeshHead setCycle: End self)
			)
			(1 (= cycles 15))
			(2
				(rakeeshHead setCycle: Beg self)
			)
			(3 (self dispose:))
		)
	)
)

(instance playWithTail of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(== (rakeeshTail cel?) 6)
				(!= (simba loop?) 10)
				(not (rakeesh cycler?))
				(not (rakeeshHead cel?))
			)
			(simba setCycle: Beg)
			(if (Random 0 1) (rakeeshHead setScript: rakeeshLooks))
		)
		(super doit:)
	)
)

(instance babyToss of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local4 0)
				(simba loop: 10 cel: 0 setCycle: End)
				(ego
					view: 22
					loop: 0
					cel: 0
					illegalBits: 0
					posn: (+ (ego x?) 3) (+ (ego y?) 8)
					setCycle: End
				)
				(= cycles 20)
			)
			(1
				(simba loop: 11 setCycle: Fwd)
				(HighPrint 160 26 80 {Baby Simba} 35 babyWindow 103)
				(= seconds 6)
			)
			(2
				(simba loop: 10 cel: 3 setCycle: Beg)
				(ego loop: 1 cel: 0 cycleSpeed: 1 setCycle: End self)
			)
			(3
				(DisposeDialog)
				(= local4 50)
				(proc1_19)
				(ego loop: 3)
				(self dispose:)
			)
		)
	)
)

(instance uhura of Talker
	(properties
		z 31
		description {the warrior Uhura}
		view 162
		signal $4010
		illegalBits $0000
		talkSpeed 1
		myName '//guildmaster,woman,girl,fighter,instructor'
		title {Uhura:}
		color 14
		back 0
		msgFile 162
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'tell/guildmaster,woman/(spielburg,bandit)[<about]') (Say self 160 29) (TestSkill 13))
			(
			(or (Said 'gave/bouquet') (Said 'gave//bouquet')) (GiveFlowers self 160 30))
			((Said 'thank') (SayThanks self 160 31))
			(
			(or (Said 'hello,greet') (Said '/hello,greet')) (Say self 160 32))
			(
				(and
					(OneOf (uhuraBody loop?) 3 4)
					(Said 'look,examine/baby,simba,baby')
				)
				(Say self (self msgFile?) 7)
			)
		)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if
				(and
					(<= 3 (uhuraBody loop?))
					(<= (uhuraBody loop?) 4)
				)
				(HighPrint 160 27)
			else
				(HighPrint 160 28)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (atSpec param1)
		(return [local80 param1])
	)
	
	(method (atGen param1)
		(return [local42 param1])
	)
	
	(method (showText param1)
		(if (== param1 39) (AddToScore 659 3 0))
		(super showText: param1 &rest)
	)
	
	(method (messages &tmp theUhuraBodyX temp1 uhuraBodyX uhuraBodyY uhuraBodyPriority uhuraBodyLoop)
		(= uhuraBodyX (uhuraBody x?))
		(= uhuraBodyY (uhuraBody y?))
		(= uhuraBodyPriority (uhuraBody priority?))
		(cond 
			((== (= uhuraBodyLoop (uhuraBody loop?)) 2)
				(= theUhuraBodyX (- uhuraBodyX 3))
				(= temp1 (- uhuraBodyY 11))
			)
			((== uhuraBodyLoop 3)
				(= theUhuraBodyX (- uhuraBodyX 2))
				(= temp1 (+ uhuraBodyY 3))
			)
			(else (= theUhuraBodyX uhuraBodyX) (= temp1 (- uhuraBodyY 11)))
		)
		(self posn: theUhuraBodyX temp1 setPri: uhuraBodyPriority)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(super endTalk:)
		(self setPri: 0)
	)
)

(instance uhuraBody of View
	(properties
		noun '/guildmaster,woman,girl,fighter,instructor'
		description {the warrior Uhura}
		view 162
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if
				(and
					(<= 3 (uhuraBody loop?))
					(<= (uhuraBody loop?) 4)
				)
				(HighPrint 160 27)
			else
				(HighPrint 160 28)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance rakeesh of Talker
	(properties
		x 199
		y 161
		z 27
		description {the Liontaur Rakeesh}
		lookStr {The leonine creature before you looks ferocious and kindly at the same time.}
		view 168
		loop 4
		priority 13
		signal $4010
		illegalBits $0000
		tLoop 4
		talkSpeed 1
		myName '//rakeesh,lion,fighter,man'
		title {Rakeesh:}
		color 11
		back 0
		msgFile 168
	)
	
	(method (doit)
		(cond 
			((not local4))
			((-- local4))
			((not (simba loop?)) (simba setScript: babyTurns))
			(else (simba setScript: babyResumes))
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'thank[/rakeesh]')
				(if (and (Btst 72) (not (Btst 186)))
					(Bset 186)
					(SkillUsed 14 50)
				)
				(SayThanks rakeesh 160 33)
			)
			(
				(or
					(Said 'hello,greet[/rakeesh]')
					(Said '/hello,greet')
				)
				(Say self 160 34)
			)
			((Said 'gave,replace,refuse/purse,alm,prize')
				(cond 
					((Bset 158) (HighPrint 160 35))
					((or (not (Btst 610)) (Btst 600)) (Say self 160 36))
					(else (ego use: 2 50) (SkillUsed 14 50) (Say self 160 37))
				)
			)
		)
	)
	
	(method (atSpec param1)
		(return [local178 param1])
	)
	
	(method (atGen param1)
		(return [local140 param1])
	)
	
	(method (showText param1)
		(cond 
			(
				(and
					(== param1 27)
					(not (Btst 72))
					(== gHeroType 0)
					(== currentDay 12)
					(== elementalsStatus 5)
				)
				(Bset 72)
				(rakeeshBody setScript: egoTakesSword)
			)
			(
				(and
					(== param1 5)
					(<= 5 elementalsStatus)
					(<= elementalsStatus 6)
				)
				(= param1 3)
				(self showMany: param1 4)
			)
			(else
				(switch param1
					(78
						(Say self msgFile 78 msgFile 35)
					)
					(0 (self showMany: param1 1))
					(6 (self showMany: param1 7))
					(8 (self showMany: param1 9))
					(10 (self showMany: param1 11))
					(12 (self showMany: param1 13))
					(17 (self showMany: param1 18))
					(21 (self showMany: param1 22))
					(23
						(AddToScore 660 3 0)
						(self showMany: param1 26)
					)
					(28 (self showMany: param1 29))
					(32 (self showMany: param1 33))
					(57 (self showMany: param1 58))
					(72 (self showMany: param1 73))
					(else  (super showText: param1))
				)
			)
		)
	)
	
	(method (messages)
		(if (& (ego onControl: 1) $0800) (ego setPri: 14))
		(if (rakeeshHead script?)
			(rakeeshHead cel: 0 setScript: 0)
		)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(self setCel: 0)
		(ego setPri: -1)
		(super endTalk: &rest)
	)
)

(instance rakeeshHead of Prop
	(properties
		x 200
		y 164
		z 30
		noun '/rakeesh,lion,fighter'
		description {the Liontaur Rakeesh}
		lookStr {The leonine creature before you looks ferocious and kindly at the same time.}
		view 168
		loop 3
	)
)

(instance rakeeshBody of Prop
	(properties
		x 200
		y 161
		noun '/rakeesh,lion,fighter'
		description {the Liontaur Rakeesh}
		lookStr {The leonine creature before you looks ferocious and kindly at the same time.}
		view 168
		loop 1
	)
)

(instance rakeeshTail of Extra
	(properties
		x 226
		y 144
		noun '/tail'
		description {the Liontaur's tail}
		view 168
		loop 2
		priority 12
		signal $4010
		cycleType 1
		hesitation 20
		minPause 40
		maxPause 80
		minCycles 1
		maxCycles 3
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (cast contains: simba)
				(HighPrint 160 38)
			else
				(HighPrint 160 39)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance simba of Actor
	(properties
		x 235
		y 168
		noun '/baby,simba'
		description {the baby Simba}
		view 168
		loop 11
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'ask/simba,baby')
				(if (not (Btst 71))
					(Bset 71)
					(= local6 1)
					(simba setScript: babyTurns)
				else
					(HighPrint 160 42)
				)
			)
			((Said 'beat/baby,simba')
				(cond 
					(
					(and (ego inRect: 220 170 250 175) (not local7)) (= local7 1) (simba setScript: babyToss))
					(local7 (HighPrint 160 44))
					(else (HighPrint 160 45))
				)
			)
			((Said 'get,acquire,acquire/baby') (HighPrint 160 46))
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if
					(and
						(< (rakeeshBody loop?) 5)
						(cast contains: rakeesh)
					)
					(HighPrint 160 40)
				else
					(HighPrint 160 41)
				)
			)
			(9
				(if (not (Btst 71))
					(Bset 71)
					(= local6 1)
					(simba setScript: babyTurns)
				else
					(HighPrint 160 42)
				)
			)
			(7 (HighPrint 160 43))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance responseTimer of Timer
	(properties)
	
	(method (cue)
		(switch (++ local1)
			(1
				(FaceObject ego uhuraBody)
				(Say uhura 160 47)
				(proc1_32 self 15)
			)
			(2
				(ego use: 31)
				(ProclaimedHonorless)
				(Bset 157)
				(curRoom newRoom: 320)
			)
		)
	)
)

(instance moose of PicView
	(properties
		x 288
		y 90
		noun '/moose'
		description {the moose}
		lookStr {It's the head of the rare Southern Moose.__You can tell by the hat.}
		view 160
		priority 9
		signal $0010
	)
)

(instance pillow1 of PicView
	(properties
		x 46
		y 168
		noun '/cushion'
		description {a plump purple pillow}
		lookStr {The pillow looks like it would be a comfortable place to sit, if you had time.}
		view 160
		cel 2
		priority 0
		signal $4010
	)
)

(instance pillow2 of PicView
	(properties
		x 37
		y 156
		noun '/cushion'
		description {a plump cushion}
		lookStr {The pillow looks like a comfortable place to sit.}
		view 160
		cel 1
		priority 0
		signal $4010
	)
)

(instance questBoard of PicView
	(properties
		x 106
		y 84
		noun '/errand,bulletin,sign,board[<errand]'
		description {the quest board}
		view 160
		loop 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'read/bulletin,sign,board[<errand]') (self doVerb: 1))
		)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (ego inRect: 64 110 137 130)
				(curRoom newRoom: 161)
			else
				(HighPrint 160 48)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance table of PicView
	(properties
		x 184
		y 115
		noun '/table,barstool'
		description {a short solid table}
		lookStr {The table looks solid enough.}
		view 160
		loop 1
		cel 3
	)
)

(instance EOFBoard of PicView
	(properties
		x 192
		y 87
		noun '/errand,bulletin,sign,board,plaque,emblem,logo,crest[<eof]'
		description {the emblem of the EOF}
		lookStr {The emblem of the Eternal Order of Fighters is proudly displayed on the wall.}
		view 160
		loop 1
		cel 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((and (Said 'read>') (Said noun)) (self doVerb: 1))
		)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (ego inRect: 155 110 231 130)
				(HighPrint 160 49)
				(HighPrint 160 50)
			else
				(HighPrint 160 51)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance book of PicView
	(properties
		x 291
		y 113
		noun '/book,log,logbook'
		description {an open registration book}
		lookStr {The book is for visiting adventurers to sign.}
		view 160
		loop 1
		cel 2
		priority 9
		signal $0010
	)
)

(instance shield of PicView
	(properties
		x 241
		y 55
		noun '/shield'
		description {the shield of Uhura}
		lookStr {The shield has been in Uhura's family for many generations.}
		view 160
		loop 2
		priority 9
		signal $0010
	)
)

(instance bow of PicView
	(properties
		x 41
		y 55
		noun '/bow,quiver'
		description {the mighty bow of Uhura}
		lookStr {The bow and quiver on the wall are for times of war.}
		view 160
		loop 2
		cel 1
	)
)

(instance babyWindow of SysWindow
	(properties
		color 5
		back 14
	)
)

(instance flame of Prop
	(properties
		x 182
		y 161
		z 50
		view 168
		loop 12
		signal $4000
	)
)

(instance fez of Feature
	(properties
		x 287
		y 147
		z 92
		noun '/fez,hat[<moose,green]'
		nsTop 50
		nsLeft 283
		nsBottom 60
		nsRight 292
		description {the moose's fez}
		lookStr {I have trouble remembering names, but I never forget a fez.}
	)
)

(instance rightDoor of Feature
	(properties
		x 243
		y 91
		noun '/door'
		nsTop 62
		nsLeft 229
		nsBottom 120
		nsRight 257
		description {the door to the practice arena}
		lookStr {The door leads to fighters' practice arena.}
	)
)

(instance leftDoor of Feature
	(properties
		x 44
		y 94
		noun '/door'
		nsTop 64
		nsLeft 33
		nsBottom 125
		nsRight 55
		description {the door to Uhura's private quarters}
		lookStr {The door leads to Uhura's private quarters.}
	)
)

(instance quill of Feature
	(properties
		x 293
		y 95
		noun '/pen,feather'
		nsTop 88
		nsLeft 290
		nsBottom 102
		nsRight 297
		description {the quill pen that goes with the book}
		lookStr {The quill pen used with the registration book is fashioned from the largest chicken feather you've ever seen.}
	)
)

(instance tusks of Feature
	(properties
		x 111
		y 21
		noun '/tusk[<elephant]'
		nsTop 7
		nsLeft 85
		nsBottom 36
		nsRight 196
		description {a pair of hephalump tusks}
		lookStr {The tusks could only have come from a rather large specimen of "Hephalumpis Poohrobinus."}
	)
)

(instance spears of Feature
	(properties
		x 156
		y 83
		noun '/spear'
		nsTop 58
		nsLeft 147
		nsBottom 109
		nsRight 165
		description {Uhura's spears}
		lookStr {Uhura prefers very heavy spears for their greater impact.}
	)
)
