;;; Sierra Script 1.0 - (do not remove this comment)
(script# 210)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Stage)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use User)
(use Actor)
(use System)

(public
	rm210 0
)

(local
	local0
	[local1 51] = [{Erasmus:} 11 5 {Fenrus:} 5 11 {Zara:} 0 9 {Aziza:} 13 0 {Houdini:} 8 3 {Merlyn:} 0 7 {Ad Avis:} 7 0 {Low Voice:} 14 6 {Fluid Voice:} 15 1 {Breathy Voice:} 0 11 {Ardent Voice:} 4 14 {Voices:} 15 8 {Earth Wizard:} 14 6 {Water Wizard:} 15 1 {Air Wizard:} 0 11 {Fire Wizard:} 4 14 {Wizards:} 15 8]
)
(procedure (localproc_1c26 param1 &tmp temp0 temp1 temp2)
	(= temp0 (= temp1 (* param1 3)))
	(= temp2
		(if (OneOf param1 1 12 13 15 14)
			MidWindow
		else
			TopWindow
		)
	)
	(temp2
		color: [local1 (++ temp0)]
		back: [local1 (++ temp0)]
	)
	(Print
		&rest
		#title
		[local1 temp1]
		#width
		300
		#window
		temp2
		#mode
		1
	)
)

(procedure (localproc_1c7d)
	(switch local0
		(1
			(SkillUsed 13 -65)
			(SkillUsed 14 -100)
			(localproc_1c26 11 210 88)
			(curRoom setScript: zapEgoOutS)
		)
		(2
			(localproc_1c26 11 210 89)
			(curRoom setScript: zapEgoOutS)
		)
		(3 (localproc_1c26 11 210 41))
	)
)

(instance rm210 of Stage
	(properties
		picture 210
		style $000f
		south 229
		bottomFromX 160
		bottomToX 160
	)
	
	(method (init)
		(LoadMany 128 183 210 215 216 210)
		(erasmusPic init: stopUpd:)
		(door init: stopUpd:)
		(ego init:)
		(proc1_19)
		(gCMusic number: 211)
		(cond 
			((Btst 65) (= inOut 3) (self setScript: passedTestS))
			((== prevRoomNum 215) (= inOut 3) (self setScript: passedPretestS))
			((Btst 64) (= entranceScript playItAgainS))
			((Btst 63) (= entranceScript failedPretestS))
			(else (Bset 28) (gCMusic number: 210) (= entranceScript whoBU))
		)
		(super init:)
		(gCMusic loop: -1 init: playBed:)
		(if (== prevRoomNum 215)
			(ego illegalBits: 0 posn: 252 122)
		)
		(flame1 init: setCycle: Fwd)
		(flame2 init: setCycle: Fwd)
		(flame3 init: setCycle: Fwd)
		(flame4 init: setCycle: Fwd)
		(DrawFeature
			harryPic
			azizaPic
			avisPic
			darkPic
			zaraPic
			eranaPic
			merlinPic
			dragon1
			dragon2
			BASE1
			BASE2
			pillar1
			pillar2
			top1
			top2
			pole1
			pole2
			wit
		)
		(proc1_31
			thePath
			leftFarColumn
			rightFarColumn
			nearLeftCarving
			farLeftCarving
			farRightCarving
			nearRightCarving
		)
		(= gGDftSC gAllSC)
		(gKeyH addToFront: self)
	)
	
	(method (doit)
		(cond 
			(
			(and (& (ego onControl: 1) $0002) (== inOut 3))
				(= inOut 2)
				(= whereTo south)
				(= gTopExit 3)
				(UnlockEgo)
				(ego setMotion: MoveTo 160 260 self)
			)
			((and (!= local0 0) (< (ego y?) 126)) (ego y: 126 setMotion: 0) (localproc_1c26 11 210 0))
			(else (super doit: &rest))
		)
	)
	
	(method (handleEvent pEvent &tmp temp0 [temp1 100])
		(cond 
			((super handleEvent: pEvent))
			((== (self script?) zapEgoOutS) (pEvent claimed: 1))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (Print 210 1))
			((Said 'look,examine') (pEvent claimed: 0))
			((!= local0 0)
				(if
					(= temp0
						(proc2_21
							pEvent
							0
							{look}
							@userName
							{wizard}
							{mag}
							{init}
							{glory}
							{erana}
							{zara}
							{aziza}
							{merl}
							{avis}
							{houdini}
							{erasmus}
							{save}
							{steal}
							{cast}
							{ask}
						)
					)
					(cond 
						((== temp0 1)
							(Parse (User inputLineAddr?) pEvent)
							(pEvent type: 128)
							(pEvent claimed: 0)
							(User said: pEvent)
						)
						((and (== local0 1) (== temp0 2)) (TestSkill 13 100) (Bset 66) (= local0 0) (whoBU cue:))
						((and (== local0 2) (<= 3 temp0) (<= temp0 6)) (TestSkill 13 100) (Bset 183) (= local0 0) (whoBU cue:))
						(
						(and (== local0 3) (<= 7 temp0) (<= temp0 13))
							(switch temp0
								(7 (localproc_1c26 11 210 2))
								(8
									(localproc_1c26 11 (Format @temp1 210 3 @userName))
									(localproc_1c26 2 210 4)
									(localproc_1c26 11 210 5)
								)
								(9
									(localproc_1c26 11 (Format @temp1 210 6 @userName))
									(localproc_1c26 3 210 7)
									(localproc_1c26 11 210 5)
								)
								(10
									(localproc_1c26 11 (Format @temp1 210 8 @userName))
									(localproc_1c26 5 210 9)
									(localproc_1c26 11 210 5)
								)
								(11
									(localproc_1c26 11 (Format @temp1 210 10 @userName))
									(HighPrint 210 11)
									(localproc_1c26 6 210 12)
									(localproc_1c26 6 210 13)
									(localproc_1c26 6 210 14)
									(localproc_1c26 11 210 5)
								)
								(12
									(localproc_1c26 11 (Format @temp1 210 15 @userName))
									(HighPrint 210 16)
									(localproc_1c26 4 (Format @temp1 210 17 @userName))
									(localproc_1c26 11 210 5)
								)
								(13
									(= local0 0)
									(Bset 63)
									(HighPrint 210 18)
									(localproc_1c26 7 210 19)
									(localproc_1c26 8 210 20)
									(localproc_1c26 9 210 21)
									(localproc_1c26 10 210 22)
									(localproc_1c26 11 210 23)
									(localproc_1c26 11 (Format @temp1 210 24 @userName))
									(HighPrint 210 25)
									(localproc_1c26 0 (Format @temp1 210 26 @userName))
									(HighPrint 210 27)
									(localproc_1c26 1 210 28)
									(localproc_1c26 0 210 29)
									(localproc_1c26 1 210 30)
									(localproc_1c26 11 (Format @temp1 210 31 @userName))
									(localproc_1c26 0 (Format @temp1 210 32 @userName))
									(localproc_1c26 11 210 33)
									(localproc_1c26 0 210 34)
									(localproc_1c26 11 210 33)
									(localproc_1c26 0 210 35)
									(localproc_1c26 11 210 36)
									(localproc_1c26 0 210 37)
									(localproc_1c26 1 210 38)
									(localproc_1c26 0 210 39)
									(localproc_1c26 11 210 36)
									(localproc_1c26 0 210 40)
									(self setScript: gotoPreTestS)
								)
								(else 
									(localproc_1c26 11 210 41)
								)
							)
						)
						((== temp0 14)
							(if (Parse (User inputLineAddr?) pEvent)
								(pEvent type: 128 claimed: 0)
								(User said: pEvent)
							)
						)
						((>= temp0 15)
							(localproc_1c26 7 210 42)
							(localproc_1c26 8 210 43)
							(localproc_1c26 9 210 44)
							(localproc_1c26 10 210 45)
							(localproc_1c26 11 210 46)
							(self setScript: zapEgoOutS)
						)
						(else (localproc_1c7d) (pEvent claimed: 1))
					)
				else
					(localproc_1c7d)
					(pEvent claimed: 1)
				)
			)
		)
	)
)

(instance whoBU of Script
	(properties)
	
	(method (changeState newState &tmp [temp0 21])
		(switch (= state newState)
			(0
				(if (not (Btst 62))
					(AddToScore 684 11 1)
					(HighPrint 210 47)
					(HighPrint 210 48)
					(HighPrint 210 49)
					(HighPrint 210 50)
					(Bset 62)
				)
				(cond 
					((not (Btst 66))
						(HighPrint 210 51)
						(localproc_1c26 11 210 52)
						(= local0 1)
					)
					((not (Btst 183)) (self cue:))
					((not (Btst 63)) (self changeState: 2))
				)
			)
			(1
				(localproc_1c26 11 210 53)
				(= local0 2)
			)
			(2
				(localproc_1c26 11 210 54)
				(= local0 3)
			)
			(3 (LockEgo 1) (self dispose:))
		)
	)
)

(instance passedPretestS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(erasmusPic show: cel: 0 setPri: 5 setCycle: End self)
				(door show:)
			)
			(1
				(ego setMotion: MoveTo 157 126 self)
			)
			(2
				(erasmusPic setCycle: Beg self)
			)
			(3
				(Bset 64)
				(localproc_1c26 11 210 55)
				(cond 
					((not (if (ego knows: 27) (ego knows: 28))) (localproc_1c26 11 210 56))
					((localproc_1c26 11 210 57 81 {Yes} 1 81 {No} 0) (self cue:))
					(else (localproc_1c26 11 210 58) (client setScript: zapEgoOutS))
				)
			)
			(4 (door setCycle: End self))
			(5
				(ego setMotion: MoveTo 157 114 self)
			)
			(6 (curRoom newRoom: 220))
		)
	)
)

(instance passedTestS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 120])
		(switch (= state newState)
			(0
				(ego posn: 157 164 hide: setMotion: 0)
				(FaceObject ego wiz2)
				(wiz1 init: loop: 1 stopUpd:)
				(wiz2 init: loop: 1 stopUpd:)
				(wiz3 init: loop: 1 stopUpd:)
				(wiz4 init: loop: 1 stopUpd:)
				(sparkle
					posn: 157 148
					cel: 0
					init:
					setPri: 12
					setCycle: End self
				)
			)
			(1
				(ego show:)
				(sparkle setCycle: Beg self)
			)
			(2
				(sparkle dispose:)
				(SetUpEgo)
				(localproc_1c26 12 210 59)
				(localproc_1c26 14 210 60)
				(localproc_1c26 13 210 61)
				(localproc_1c26 15 210 62)
				(if (localproc_1c26 16 210 63 81 {Yes} 1 81 {No} 0)
					(self cue:)
				else
					(self changeState: 5)
				)
			)
			(3
				(localproc_1c26 16 210 64)
				(ego setMotion: MoveTo 160 155 self)
			)
			(4
				(Print 210 65)
				(Print 210 66)
				(Die
					1
					{You are now a very knowledgeable Wizard. However, on occasion, you find yourself wondering what ever happened to Abdulla Doo, the Kattas, and to all your other friends in Shapeir.__And you wonder: wouldn't it have been better to have endured your "Trial by Fire"?}
					80
					{That was the Wiz that was}
				)
			)
			(5
				(AddToScore 685 7 1)
				(localproc_1c26 16 210 67)
				(wiz1 setCycle: End)
				(wiz2 setCycle: End)
				(wiz3 setCycle: End)
				(wiz4 setCycle: End self)
			)
			(6
				(localproc_1c26 0 (Format @temp0 210 68 @userName))
				(localproc_1c26 0 210 69)
				(localproc_1c26 0 210 70)
				(ego learn: 29 10)
				(HighPrint 210 71)
				(localproc_1c26 0 210 72)
				(localproc_1c26 1 210 73)
				(localproc_1c26 0 210 74)
				(localproc_1c26 1 210 75)
				(localproc_1c26 0 210 76)
				(localproc_1c26 1 210 77)
				(localproc_1c26 0 210 78)
				(localproc_1c26 1 210 79)
				(localproc_1c26 0 210 80)
				(client setScript: zapEgoOutS)
			)
		)
	)
)

(instance playItAgainS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_1c26 16 210 81)
				(ego setMotion: MoveTo 160 155 self)
			)
			(1 (door setCycle: End self))
			(2
				(ego setMotion: MoveTo 160 144 self)
			)
			(3 (curRoom newRoom: 220))
		)
	)
)

(instance failedPretestS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_1c26 11 210 82)
				(= cycles 8)
			)
			(1
				(localproc_1c26 0 210 83)
				(localproc_1c26 1 210 84)
				(localproc_1c26 0 210 85)
				(localproc_1c26 1 210 86)
				(client setScript: gotoPreTestS)
			)
		)
	)
)

(instance gotoPreTestS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(erasmusPic setPri: 5 setCycle: End self)
			)
			(1
				(localproc_1c26 0 210 87)
				(ego setMotion: MoveTo 157 124 self)
			)
			(2
				(ego setMotion: MoveTo 252 122 self)
			)
			(3
				(gCMusic fade:)
				(curRoom newRoom: 215)
			)
		)
	)
)

(instance zapEgoOutS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= [skills 17] 0)
				(gSpareMusic number: 342 loop: 1 play:)
				(sparkle
					view: 183
					loop: 0
					cel: 0
					posn: (ego x?) (- (ego y?) 36)
					setCycle: End self
					init:
				)
			)
			(1
				(sparkle dispose:)
				(ego hide:)
				(= cycles 4)
			)
			(2
				(= gTopExit 3)
				(curRoom newRoom: 229)
			)
		)
	)
)

(instance pillar1 of PicView
	(properties
		x 35
		y 153
		noun '/column,column'
		description {the ornate column}
		view 216
		cel 1
		priority 15
		signal $0010
	)
)

(instance pillar2 of PicView
	(properties
		x 282
		y 154
		description {the ornate column}
		view 216
		loop 1
		cel 1
	)
)

(instance top1 of PicView
	(properties
		x 282
		y 39
		view 216
		loop 1
		priority 10
		signal $0010
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance top2 of PicView
	(properties
		x 35
		y 38
		view 216
		loop 1
		priority 10
		signal $0010
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance dragon1 of PicView
	(properties
		x 112
		y 52
		noun '/dragon,creature'
		description {the carved dragons}
		lookStr {There are two intricately carved creatures -- probably dragons -- placed above either side of the path.}
		view 215
		loop 2
	)
)

(instance dragon2 of PicView
	(properties
		x 206
		y 53
		noun '/dragon,creature'
		description {the carved dragons}
		lookStr {There are two intricately carved creatures -- probably dragons -- placed above either side of the path.}
		view 215
		loop 3
	)
)

(instance BASE1 of PicView
	(properties
		x 45
		y 189
		view 216
		cel 2
		priority 10
		signal $0010
	)
)

(instance BASE2 of PicView
	(properties
		x 274
		y 190
		view 216
		loop 1
		cel 2
		priority 10
		signal $0010
	)
)

(instance pole1 of PicView
	(properties
		x 123
		y 112
		view 216
		cel 3
		priority 4
		signal $0010
	)
)

(instance pole2 of PicView
	(properties
		x 196
		y 112
		view 216
		loop 1
		cel 3
		priority 4
		signal $0010
	)
)

(instance wit of PicView
	(properties
		x 160
		y 25
		noun '/logo,wit,sign'
		description {the WIT sign}
		lookStr {This is it...the WIT.}
		view 216
		loop 2
		priority 10
		signal $0010
	)
)

(instance harryPic of PicView
	(properties
		x -7
		y 154
		noun '/harry,(artist<escape),mage'
		description {the portrait of Harry Houdini, the Escape Artist.}
		lookStr {The portrait shows Harry Houdini in a typical state of intense concentration.}
		view 215
	)
)

(instance azizaPic of PicView
	(properties
		x 52
		y 156
		noun '/aziza,enchantress,portrait,painting[<aziza,enchantress][/aziza,enchantress]'
		description {the portrait of Aziza, the Enchantress.}
		lookStr {The portrait is politely formal, befitting Aziza the Enchantress}
		view 215
		cel 1
	)
)

(instance avisPic of PicView
	(properties
		x 78
		y 130
		noun '/ad,wizard,enchant,portrait,painting[<ad,wizard,enchant][/ad,wizard,enchant]'
		description {the portrait of Ad Avis, the Enchanter.}
		lookStr {The portrait shows a Wizard with a severe nature.__He appears totally humorless.}
		view 215
		cel 2
	)
)

(instance darkPic of PicView
	(properties
		x 97
		y 113
		noun '/portrait,painting[<black,dark,empty][/!*]'
		description {the portrait of Darkness}
		lookStr {The picture is entirely black.}
		view 215
		cel 3
	)
)

(instance zaraPic of PicView
	(properties
		x 220
		y 113
		noun '/zara,wizard,emissary,portrait,painting[<zara,emissary,wizard][/zara,emissary,wizard]'
		description {the portrait of Zara, the Wizard}
		lookStr {Like most of the Wizards, Zara's expression is serious and intent.__She shows little propensity towards humor.}
		view 215
		cel 4
		priority 1
		signal $0010
	)
)

(instance erasmusPic of Prop
	(properties
		x 239
		y 130
		noun '/erasmus,wizard,portrait,painting[<erasmus,wizard][/erasmus,wizard]'
		description {the portrait of Erasmus, the jocular Wizard}
		lookStr {The portrait of Erasmus appears to be a duplicate of the one you remember hanging in his house on Zauberberg.__You think that perhaps he has a few more crinkles around his eyes.}
		view 215
		loop 1
		cycleSpeed 1
	)
)

(instance eranaPic of PicView
	(properties
		x 266
		y 155
		noun '/erana,wizard,portrait,painting[<erana,wizard][/erana,wizard]'
		description {the portrait of Erana, the lost Wizard of Spielburg}
		lookStr {You always wondered what Erana looked like.__She reminds you of Genesta, a Faery you once knew.}
		view 215
		cel 6
	)
)

(instance merlinPic of PicView
	(properties
		x 323
		y 155
		noun '/ambrose,mage,portrait,painting[<ambrose,mage][/ambrose,mage]'
		description {the portrait of Merlyn, the legendary magician of King Arthur's Court}
		lookStr {That's funny!__He doesn't look anything like the way Peter Ledger drew him in Conquests of Camelot.}
		view 215
		cel 7
	)
)

(instance wiz1 of Prop
	(properties
		x 131
		y 73
		noun '/wizard[<fire]'
		description {the Wizard of Fire}
		lookStr {By his color, you judge that this Wizard specializes in Fire magic.}
		view 210
		priority 3
		signal $4010
		palette 3
		cycleSpeed 2
	)
)

(instance wiz2 of Prop
	(properties
		x 148
		y 79
		noun '/wizard[<water]'
		description {the Wizard of Water}
		lookStr {By his color, you judge that this Wizard specializes in Water magic.}
		view 210
		priority 3
		signal $4010
		palette 2
		cycleSpeed 1
	)
)

(instance wiz3 of Prop
	(properties
		x 167
		y 79
		noun '/wizard[<air]'
		description {the Wizard of Air}
		lookStr {By his color, you judge that this Wizard specializes in Air magic.}
		view 210
		priority 3
		signal $4010
		palette 1
		cycleSpeed 1
	)
)

(instance wiz4 of Prop
	(properties
		x 186
		y 74
		noun '/wizard[<earth]'
		description {the Wizard of Earth}
		lookStr {By his color, you judge that this Wizard specializes in Earth magic.}
		view 210
		priority 3
		signal $4010
		palette 4
		cycleSpeed 2
	)
)

(instance door of Prop
	(properties
		x 158
		y 93
		noun '/door'
		description {the door at the end of the path}
		lookStr {The door at the end of the path leads someplace strange, no doubt.}
		view 210
		loop 2
		priority 1
		signal $0010
		cycleSpeed 1
	)
)

(instance sparkle of Prop
	(properties
		shiftClick 0
		view 183
		priority 15
		signal $4010
	)
)

(instance flame1 of Prop
	(properties
		x 57
		y 166
		view 216
		loop 3
		cel 1
		priority 14
		signal $0010
		cycleSpeed 1
	)
)

(instance flame2 of Prop
	(properties
		x 263
		y 166
		view 216
		loop 3
		cel 2
		priority 14
		signal $0010
		cycleSpeed 1
	)
)

(instance flame3 of Prop
	(properties
		x 127
		y 98
		view 216
		loop 4
		cycleSpeed 1
	)
)

(instance flame4 of Prop
	(properties
		x 192
		y 98
		view 216
		loop 4
		cel 4
		cycleSpeed 1
	)
)

(instance thePath of Feature
	(properties
		x 160
		y 141
		noun '/path[<ivory]'
		nsTop 95
		nsLeft 118
		nsBottom 188
		nsRight 202
		description {the ivory path}
	)
)

(instance nearLeftCarving of Feature
	(properties
		x 33
		y 163
		noun '/carving,relief,frieze'
		nsTop 7
		nsBottom 39
		nsRight 66
		description {the decorative frieze}
	)
)

(instance farLeftCarving of Feature
	(properties
		x 90
		y 36
		noun '/carving,relief,frieze'
		nsTop 20
		nsLeft 66
		nsBottom 53
		nsRight 114
		description {the decorative frieze}
	)
)

(instance farRightCarving of Feature
	(properties
		x 230
		y 37
		noun '/carving,relief,frieze'
		nsTop 23
		nsLeft 206
		nsBottom 51
		nsRight 254
		description {the ornamental frieze}
	)
)

(instance nearRightCarving of Feature
	(properties
		x 286
		y 23
		noun '/carving,relief,frieze'
		nsTop 10
		nsLeft 252
		nsBottom 36
		nsRight 320
		description {the ornamental frieze}
	)
)

(instance leftFarColumn of Feature
	(properties
		x 116
		y 80
		noun '/column'
		nsTop 56
		nsLeft 112
		nsBottom 104
		nsRight 120
		description {the ornate columns}
	)
)

(instance rightFarColumn of Feature
	(properties
		x 203
		y 79
		noun '/column'
		nsTop 55
		nsLeft 199
		nsBottom 103
		nsRight 207
		description {the ornate columns}
	)
)
