;;; Sierra Script 1.0 - (do not remove this comment)
(script# 220)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use n065)
(use Intrface)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm220 0
	fallSP 1
	climbSP 2
	zapInSP 3
	proc220_4 4
	proc220_5 5
	proc220_6 6
	proc220_7 7
	wizP 8
	sparkleP 9
)

(local
	local0
	[local1 8]
	local9
	local10
	local11
	local12
)
(procedure (proc220_4)
	(pathTop setCycle: Fwd)
	(pathMid setCycle: Fwd)
	(pathEnd loop: 7 setCycle: Fwd)
)

(procedure (proc220_5)
	(pathTop setCycle: 0 stopUpd:)
	(pathMid setCycle: 0 stopUpd:)
	(pathEnd setCycle: 0 loop: 9)
)

(procedure (proc220_6)
	(proc1_19)
	(ego setMotion: 0)
)

(procedure (proc220_7)
	(ego view: 0 posn: 246 141 setLoop: 7 init: setCycle: Fwd)
)

(instance rm220 of Rm
	(properties
		picture 220
		style $000f
	)
	
	(method (init)
		(LoadMany 128 6 7 32 31 62 220 221 222 224 225 226 227)
		(LoadMany 130 221 222)
		(LoadMany 132 221 222 223)
		(= gLevMe (ScriptID 221 1))
		(= global166 88)
		(= local11 (Btst 163))
		(super init:)
		(gMouseH add: self)
		(= gGDftSC gAllSC)
		(self setScript: zapInSP)
		(gCMusic number: 220 loop: -1 playBed:)
	)
	
	(method (doit &tmp temp0)
		(cond 
			(
				(and
					((ScriptID 62 0) client?)
					(not (curRoom notify: 2))
				)
			)
			((== script fallSP))
			((== (= temp0 (ego onControl: 1)) local12))
			((& temp0 $2810) (self setScript: fallSP 0 (= local12 temp0)))
			(else (= local12 temp0))
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bclr 67)
		(Bclr 68)
		(Bclr 69)
		(Bset 163)
		(DisposeScript 221)
		(DisposeScript 222)
		(gCMusic fade:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (Print 220 0))
			(
				(and
					(== (pEvent type?) evMOUSEBUTTON)
					(& (pEvent modifiers?) emSHIFT)
				)
				(pEvent claimed: 1)
				(switch (Random 1 18)
					(2 (HighPrint 220 1))
					(3 (HighPrint 220 2))
					(4 (HighPrint 220 3))
					(5 (HighPrint 220 4))
					(6 (HighPrint 220 5))
					(7 (HighPrint 220 6))
					(8 (HighPrint 220 7))
					(9 (HighPrint 220 8))
					(else  (HighPrint 220 9))
				)
			)
			((Said 'cast>')
				(cond 
					((< [skills 18] [spellCost global659]) (pEvent claimed: 1) (self setScript: outaGasS))
					(
						(and
							(== (curRoom notify: 6) 6)
							(= temp0 (proc65_0 pEvent))
							(CastSpell temp0)
						)
						(switch temp0
							(21
								(ego view: 32)
								((ScriptID 221 3) changeState: 21)
								(gMiscMusic number: 31)
							)
							(22 (PrintWarning 220 10))
							(24
								(ego view: 31)
								(gMiscMusic number: 21)
								((ScriptID 221 3) changeState: 21)
							)
							(else  (PrintWarning 220 11))
						)
					)
				)
			)
			((Said 'crawl,duck')
				(if (== (curRoom notify: 6) 2)
					(HighPrint 220 12)
				else
					(HighPrint 220 13)
				)
			)
			((Said 'use,force,pull,move') (HighPrint 220 14))
		)
	)
	
	(method (notify param1 param2)
		(return
			(if (== argc 1)
				(return [local1 param1])
			else
				(return (= [local1 param1] param2))
			)
		)
	)
)

(instance zapInSP of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(if (not local9)
					(pathEnd init:)
					(pathMid init:)
					(pathTop init:)
					(sparkleP init: posn: 245 116 setCycle: CT 2 1 self)
				else
					(wizFrame cel: 0 loop: 1 posn: 177 112)
					(= cycles 4)
				)
				(proc220_4)
			)
			(1
				(ego posn: 246 141 init:)
				(proc220_7)
				(if (not local9) (sparkleP setCycle: End))
				(= cycles 18)
			)
			(2
				(if (or local9 local11)
					(= cycles 18)
				else
					(HighPrint 220 15)
					(= cycles 25)
				)
				(= local9 1)
			)
			(3
				(proc220_5)
				(proc220_6)
				(= local10
					(cond 
						((Btst 69)
							(= local0 3)
							(wizP title: {Fire Wizard:} color: 4 back: 14)
							(ScriptID 222 1)
						)
						((Btst 68)
							(= local0 2)
							(wizP title: {Water Wizard:} color: 15 back: 1)
							(ScriptID 222 0)
						)
						((Btst 67)
							(= local0 4)
							(wizP title: {Earth Wizard:} color: 14 back: 6)
							(ScriptID 221 2)
						)
						(else
							(= local0 1)
							(wizP title: {Air Wizard:} color: 0 back: 11)
							(ScriptID 221 0)
						)
					)
				)
				(wizP
					init:
					posn: 177 112
					loop: 0
					cel: 0
					palette: local0
					cycleSpeed: 1
					setCycle: CT 3 1 self
				)
			)
			(4 (= cycles 5))
			(5
				(wizP cycleSpeed: 0 setCycle: End self)
				(gMiscMusic number: 221 loop: 1 priority: 5 play:)
			)
			(6
				(wizFrame init: cycleSpeed: 1 setCycle: End self)
			)
			(7
				(wizFrame view: 219 palette: local0 setLoop: 2 cel: 0)
				(wizP loop: 1 tLoop: 1 posn: 179 74 talkSpeed: 1)
				(= cycles 10)
			)
			(8
				(switch local0
					(3 (Say wizP self 220 16))
					(2 (Say wizP self 220 17))
					(4 (Say wizP self 220 18))
					(1 (Say wizP self 220 19))
				)
			)
			(9
				(wizP dispose:)
				(if (== local10 (ScriptID 221 0)) (tempStaff init:))
				(wizFrame cycleSpeed: 0 setCycle: End self)
			)
			(10
				(wizFrame setPri: 9 setMotion: MoveTo 230 126 self)
				(proc220_4)
				(proc220_7)
			)
			(11
				(wizFrame
					view: 220
					setLoop: 4
					cel: 0
					setMotion: MoveTo 246 141
					setCycle: End self
				)
			)
			(12
				(wizFrame dispose:)
				(tempStaff dispose:)
				(client setScript: local10)
			)
		)
	)
)

(instance fallSP of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(ego view: 6 cel: 0 ignoreActors:)
				(switch register
					(16
						(ego
							setLoop: 2
							setStep: 4 6
							setMotion: MoveTo (- (ego x?) 9) (+ (ego y?) 26)
							setCycle: CT 6 1 self
						)
					)
					(8192
						(ego setLoop: 4 setCycle: CT 2 1 self)
					)
					(2048
						(ego
							setLoop: 4
							setStep: 4 6
							setMotion: MoveTo 292 186
							setCycle: CT 6 1 self
						)
					)
				)
			)
			(1
				(switch register
					(16
						(= temp0 -12)
						(= temp1 -15)
					)
					(8192
						(= temp0 13)
						(= temp1 -15)
					)
					(2048
						(= temp0 14)
						(= temp1 -2)
					)
				)
				(sparkleP
					view: 220
					loop: 5
					cel: 0
					show:
					posn: (+ (ego x?) temp0) (+ (ego y?) temp1)
					cycleSpeed: 0
					setCycle: End self
				)
			)
			(2
				(sparkleP setCycle: CT 2 1 self)
			)
			(3
				(ego setScript: 0 hide: z: 0)
				(sparkleP setCycle: End self)
			)
			(4
				(= gTopExit 3)
				(gCMusic fade:)
				(gMiscMusic fade:)
				(curRoom newRoom: 229)
			)
		)
	)
)

(instance climbSP of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 190 117 self)
			)
			(1
				(ego
					view: 7
					setLoop: 0
					setCycle: Fwd
					setPri: 9
					posn: 177 114
					setMotion: MoveTo 177 105 self
					illegalBits: 0
					ignoreActors:
				)
				(ego
					setStep:
						-1
						(if
							(= register
								(if (TestSkill 11 20)
									(== client (ScriptID 221 2))
								else
									0
								)
							)
							4
						else
							1
						)
				)
			)
			(2
				(if register
					(tallWall
						view: 222
						setLoop: 0
						setCel: -1
						cel: 0
						posn: 177 113
						setPri: 8
						setStep: -1 5
						cycleSpeed: 3
						setCycle: CT 2 1
						setMotion: MoveTo 177 72 self
						ignoreActors:
						illegalBits: 0
						init:
					)
					(ego setMotion: MoveTo 177 50)
				else
					(= cycles 14)
				)
			)
			(3
				(ego setCycle: 0 setCel: 2 setMotion: MoveTo 177 114 self)
			)
			(4
				(if register
					(tallWall
						setLoop: 0
						setCycle: Beg
						setMotion: MoveTo 177 113 self
					)
				else
					(self cue:)
				)
			)
			(5
				(if register (tallWall dispose:))
				(proc1_19)
				(ego
					illegalBits: 0
					posn: 179 117
					setMotion: MoveTo 224 133 self
				)
			)
			(6
				(if register
					(PrintWarning 220 20)
				else
					(PrintWarning 220 21)
				)
				(self dispose:)
			)
		)
	)
)

(instance outaGasS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				(wizP title: {Voices:} color: 15 back: 8 init: hide:)
				(= cycles 2)
			)
			(1 (Say wizP self 220 22))
			(2
				(Bset 162)
				(client setScript: fallSP 0 2048)
			)
		)
	)
)

(instance wizP of Talker
	(properties
		x 177
		y 112
		noun '/wizard,man'
		description {the wizard}
		lookStr {It's an ancient-looking man in a wizard suit.}
		view 219
		priority 13
		signal $4010
		illegalBits $0000
		title {Air Wizard:}
		color 13
		back 1
	)
)

(instance sparkleP of Prop
	(properties
		shiftClick 0
		view 220
		loop 5
		priority 15
		signal $4010
	)
)

(instance wizFrame of Actor
	(properties
		x 177
		y 112
		noun '/frame,painting'
		description {the wizFramed wizard}
		lookStr {Picture this - a wizFramed wizard.}
		view 220
		loop 1
		priority 12
		signal $4010
		illegalBits $0000
	)
)

(instance pathEnd of Prop
	(properties
		x 271
		y 172
		noun '/path,path'
		description {a pathway}
		lookStr {The pathway appears suspended in this timeless, dimensionless void.__It leads off into infinity.}
		view 220
		loop 7
		priority 6
		signal $4010
	)
)

(instance pathMid of Prop
	(properties
		x 240
		y 147
		noun '/path,path'
		description {a pathway}
		lookStr {The pathway appears suspended in this timeless, dimensionless void.__It leads off into infinity.}
		view 220
		loop 6
		priority 6
		signal $4010
	)
)

(instance pathTop of Prop
	(properties
		x 200
		y 122
		noun '/path,path'
		description {a pathway}
		lookStr {The pathway appears suspended in this timeless, dimensionless void.__It leads off into infinity.}
		view 220
		loop 8
		priority 6
		signal $4010
	)
)

(instance tempStaff of View
	(properties
		x 170
		y 86
		noun '/staff'
		description {the wizard's staff}
		lookStr {The wizard seems to have left behind his staff.}
		view 221
		priority 9
		signal $4010
	)
)

(instance tallWall of Actor
	(properties)
)
