;;; Sierra Script 1.0 - (do not remove this comment)
(script# 250)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Stage)
(use KeaponsStuff)
(use Polygon)
(use Feature)
(use LoadMany)
(use Timer)
(use Motion)
(use Actor)
(use System)

(public
	rm250 0
)

(local
	[local0 16] = [61 0 142 12 152 22 153 38 188 57 250 74 250 8 303]
	[local16 8] = [173 130 127 146 140 174 208 155]
	local24
	local25
	local26
	local27
	[local28 100]
	itemPurchased
	local129
	spellLearned
	[local131 8] = [0 10 15 20 25 30 125 15]
	[local139 38] = [83 84 85 86 87 88 89 90 91 92 93 95 96 97 98 82 99 82 100 82 101 102 103 104 105 106 107 108 109 110 111 112 113 82 82 82 82 82]
	[local177 74] = [56 '//detect,(spell,magic<detect),(spell<magic<detect)' 57 '//trigger,(spell<trigger)' 55 '//force,bolt,(spell<force,bolt)' 58 '//levitate,fly,(spell<levitate,fly)' 59 '//dazzle,(spell<dazzle)' 70 '//invisibility' 115 '//flame,fire,dart,fireball,(spell<flame,fire,dart,fireball)' 116 '//fetch,(spell<fetch)' 117 '//open,open,(spell<open,open)' 118 '//zap,(spell<zap)' 119 '//reversal,reflection,mirror,(spell<reversal,reflection,mirror)' 73 '//rope' 77 '//glasses,disguise,disguise' 49 '//caws' 50 '//shop' 51 '//wonder' 52 '//owner' 53 '//yorick' 76 '//cost,cost<rope' 54 '//spell,cost,cost,merchandise' 60 '//bedouin' 61 '//hero' 63 '//hoodoo' 72 '//dirt,earth<fooler' 64 '//dirt,earth' 65 '//whirl,beard' 66 '//gnome' 67 '//erasmus' 68 '//scroll' 69 '//beast,saurii' 71 '//wizard' 78 '//carp,carp,dolphin,aquarium,oasis,sea' 81 '//air,wind' 114 '//iblis' 115 '//flame,fire,dart,fireball,(spell<flame,fire,dart,fireball)' 120 '//contain,capture,bellows']
	[local251 11] = [{"Ghost Writers in the Sky."} {"To Air is Human."} {"Fear of Flying."} {"The Wind in the Bellows."} {"Gnome with the Wind."} {"The Pizza Elemental: Fact or Fiction?.'} {"Air Conditioning and Grooming.} {"H-I-J-K-Elemental-P."} {"We're Here to Pump You Up."} {"The Air Apparent."} {"Three's a Cloud."}]
	local262
)
(instance rm250 of Stage
	(properties
		picture 250
		south 310
		bottomFromX 89
		bottomFromY 250
		bottomToX 89
	)
	
	(method (init)
		(LoadMany 128 0 47 250 251 255)
		(LoadMany 131 254)
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(= entranceScript enterS)
		(proc1_19)
		(ego init:)
		(super init:)
		(gMouseH addToFront: self)
		(keapon ignoreActors: 1 init:)
		(pinWheels init:)
		(if (not (ego has: 54)) (xRayGlasses init:))
		(KeaponsStuff)
		(cloudPoly points: @local0 size: 8)
		(sunPoly points: @local16 size: 4)
		(self addObstacle: cloudPoly sunPoly)
		(proc1_31 booksRight booksLeft ceiling floor)
		(gCMusic number: 250 loop: -1 playBed:)
		(Bset 129)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			((ego script?))
			((!= inOut 3))
			((& (ego onControl: 1) $0002) (ego setScript: bumpNose))
			((& (ego onControl: 1) $2000) (ego setScript: sideDoor 0 0))
			((& (ego onControl: 1) $1000) (ego setScript: sideDoor 0 1))
			((& (ego onControl: 1) $4000) (curRoom setScript: byeScript))
		)
	)
	
	(method (dispose)
		(DisposeScript 251)
		(= global301 global277)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(gCMusic fade:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 250 0))
			(
				(and
					(== (pEvent type?) evMOUSEBUTTON)
					(not (pEvent modifiers?))
				)
				(cond 
					(
						(and
							(ego inRect: 272 139 308 146)
							(> (pEvent x?) (ego x?))
						)
						(pEvent claimed: 1)
						(ego setMotion: MoveTo 320 (ego y?))
					)
					(
						(and
							(ego inRect: 62 121 95 139)
							(< (pEvent x?) (ego x?))
						)
						(pEvent claimed: 1)
						(ego setMotion: MoveTo 0 (ego y?))
					)
				)
			)
			((Said 'throw,cast,attack,kill,attack') (HighPrint 250 1))
			((Said 'sell,gave/whirl,beard') (Say keapon 250 2) (ego get: 2 15) (ego use: 14))
			((Said 'grab') (HighPrint 250 3))
			((Said 'tell') (Say keapon 250 4))
			((Said 'buy>')
				(cond 
					(
						(Said
							'/detect,(spell,scroll,magic<detect),(spell,scroll<magic<detect)'
						)
						(= itemPurchased 1)
					)
					((Said '/trigger,(spell,scroll<trigger)') (= itemPurchased 2))
					((Said '/dazzle,(spell,scroll<dazzle)') (= itemPurchased 4))
					(
					(Said '/levitate,fly,(spell,scroll<levitate,fly)') (= itemPurchased 5))
					((Said '/force,bolt,(spell,scroll<force,bolt)') (= itemPurchased 3))
					((Said '/rope') (= itemPurchased 6))
					((Said '/spell,scroll,merchandise') (= itemPurchased 0) (keapon showText: 54))
					((Said '/glasses')
						(if (ego has: 54)
							(= itemPurchased 0)
							(Say keapon 250 5)
						else
							(= itemPurchased 7)
						)
					)
					((Said '/dirt,earth<fooler') (= itemPurchased 0) (keapon showText: 72))
					((Said '/dirt,earth') (= itemPurchased 0) (keapon showText: 64))
					(else
						(= itemPurchased 0)
						(pEvent claimed: 1)
						(Say keapon 250 6 250 7)
					)
				)
				(if itemPurchased (self setScript: buyItemS 0 0))
			)
			((Said 'bargain>')
				(cond 
					(
						(or
							(Said
								'/detect,(spell,scroll,magic<detect),(spell,scroll<magic<detect)'
							)
							(Said
								'//detect,(spell,scroll,magic<detect),(spell,scroll<magic<detect)'
							)
						)
						(= itemPurchased 1)
					)
					(
						(or
							(Said '/trigger,(spell,scroll<trigger)')
							(Said '//trigger,(spell,scroll<trigger)')
						)
						(= itemPurchased 2)
					)
					(
						(or
							(Said '/dazzle,(spell,scroll<dazzle)')
							(Said '//dazzle,(spell,scroll<dazzle)')
						)
						(= itemPurchased 4)
					)
					(
						(or
							(Said '/levitate,fly,(spell,scroll<levitate,fly)')
							(Said '//levitate,fly,(spell,scroll<levitate,fly)')
						)
						(= itemPurchased 5)
					)
					(
						(or
							(Said '/force,bolt,(spell,scroll<force,bolt)')
							(Said '//force,bolt,(spell,scroll<force,bolt)')
						)
						(= itemPurchased 3)
					)
					((or (Said '/rope') (Said '//rope')) (= itemPurchased 6))
					((or (Said '/glasses') (Said '//glasses'))
						(if (ego has: 54)
							(= itemPurchased 0)
							(Say keapon 250 8)
						else
							(= itemPurchased 7)
						)
					)
					(
						(or
							(Said '/dirt,earth<fooler')
							(Said '//dirt,earth<fooler')
						)
						(= itemPurchased 0)
						(keapon showText: 72)
					)
					(
					(or (Said '/dirt,earth') (Said '//dirt,earth')) (= itemPurchased 0) (keapon showText: 64))
					(
						(or
							(Said '/spell,scroll,merchandise')
							(Said '//spell,scroll,merchandise')
						)
						(= itemPurchased 0)
						(keapon showText: 54)
					)
					(else
						(= itemPurchased 0)
						(pEvent claimed: 1)
						(Say keapon 250 6 250 7)
					)
				)
				(if itemPurchased (self setScript: buyItemS 0 1))
			)
			((Said 'use,wear,(put<on)/glasses[<ray]') (pEvent claimed: 0) (keapon setScript: laughS 0 1))
			(
				(or
					(Said 'look,examine<up')
					(Said 'look,examine/cloud,ceiling,sky')
				)
				(if (shadow onMe: ego)
					(HighPrint 250 9)
				else
					(HighPrint 250 10)
				)
			)
			(
				(or
					(Said 'look,examine<down')
					(Said 'look,examine/floor,sun')
				)
				(HighPrint 250 11)
			)
			((Said 'thank') (SayThanks keapon 250 12))
		)
	)
)

(instance enterS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(= local25 1)
				(keapon caller: self)
				(cond 
					((not global301) (keapon showMany: 13 16))
					(
					(and (== elementalsStatus 1) (< global301 400)) (keapon showMany: 21 24))
					(
					(and (== elementalsStatus 3) (< global301 800)) (keapon showMany: 27 29))
					(
					(and (== elementalsStatus 5) (< global301 1200)) (keapon showMany: 32 34))
					(
					(and (== elementalsStatus 7) (< global301 1400)) (keapon showMany: 36 39))
					(else
						(= temp0 (proc1_5 global302 0 5))
						(Say keapon self (keapon msgFile?) (+ 0 temp0))
					)
				)
				(++ global302)
			)
			(1
				(cond 
					(
						(and
							(or (>= currentDay 7) (not global301))
							(not (ego has: 16))
							[skills 11]
						)
						(Say keapon self 250 13 250 14)
					)
					((and [skills 12] (not (Btst 180))) (Bset 180) (Say keapon self 250 15))
					(else (= cycles 1))
				)
			)
			(2
				(if (and [skills 12] (== global302 1))
					(Say keapon self 250 16 250 17 250 18 250 19)
				else
					(self cue:)
				)
			)
			(3
				(= local25 0)
				(keapon setScript: laughS 0 0)
				(self dispose:)
			)
		)
	)
)

(instance byeScript of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(cond 
					((keapon script?) ((keapon script?) caller: self))
					((keapon cycler?) (= local25 1) (keapon caller: self))
					(else (= cycles 1))
				)
			)
			(1
				(ego setMotion: MoveTo 94 200)
				(keapon caller: self)
				(cond 
					((not global301) (keapon showMany: 17 20))
					(
					(and (== elementalsStatus 1) (< global301 400)) (keapon showMany: 25 26))
					(
					(and (== elementalsStatus 3) (< global301 800)) (keapon showMany: 30 31))
					(
					(and (== elementalsStatus 5) (< global301 1200)) (keapon showMany: 35 35))
					(
					(and (== elementalsStatus 7) (< global301 1400)) (keapon showMany: 40 42) (keapon showMany: 43 45))
					(else
						(= temp0 (proc1_5 global302 0 5))
						(Say keapon self (keapon msgFile?) (+ 6 temp0))
					)
				)
				(++ global302)
			)
			(2 (self dispose:))
		)
	)
)

(instance laughS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(keapon
					setLoop: (+ register 1)
					cycleSpeed: register
					setCycle: Fwd
				)
				(= cycles (+ 16 (* 8 register)))
			)
			(1
				(keapon setLoop: 0 setCel: 0 setCycle: 0)
				(self dispose:)
			)
		)
	)
)

(instance bumpNose of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					posn: (ego x?) (- (ego y?) 3)
					view: 255
					setLoop: 8
					setCel: 0
					cycleSpeed: 1
					setCycle: CT 3 1
				)
				(= cycles 8)
			)
			(1
				(keapon setScript: laughS 0 1)
				(= cycles 12)
			)
			(2
				(ego setCycle: End)
				(= cycles 6)
			)
			(3 (ego setCycle: CT 4 -1 self))
			(4
				(ego setCycle: End)
				(= cycles 9)
			)
			(5 (ego setCycle: CT 3 -1 self))
			(6 (= cycles 8))
			(7
				(proc1_19)
				(ego
					posn: (ego x?) (+ (ego y?) 3)
					setHeading: 180 self
				)
			)
			(8
				(ego setMotion: MoveTo (ego x?) (+ (ego y?) 5) self)
			)
			(9
				(if (not local24) (HighPrint 250 20) (= local24 1))
				(self dispose:)
			)
		)
	)
)

(instance sideDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local25 1)
				(if register
					(ego posn: 61 134 setMotion: MoveTo 86 134 self)
				else
					(ego posn: 308 143 setMotion: MoveTo 274 143 self)
				)
			)
			(1
				(Say keapon self 250 21 250 22)
			)
			(2 (= cycles 1))
			(3
				(= local25 0)
				(keapon setScript: laughS 0 1)
				(self dispose:)
			)
		)
	)
)

(instance buyItemS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(cond 
					((and (< itemPurchased 6) (not [skills 12])) (Say keapon 250 23) (self dispose:))
					((and (== itemPurchased 6) (ego has: 16)) (Say keapon 250 24) (self dispose:))
					(else (self cue:))
				)
			)
			(1
				(= local129 [local131 itemPurchased])
				(if register
					(cond 
						((== itemPurchased 7) (Say keapon self 250 25 250 26))
						((TestSkill 13 60)
							(= temp1 (if (== itemPurchased 1) 5 else 10))
							(Say
								keapon
								self
								250
								27
								(Format @local28 250 28 temp1)
								250
								29
							)
							(= local129 (- local129 temp1))
						)
						(else (Say keapon 250 30 250 31 250 32) (self changeState: 9))
					)
				else
					(self cue:)
				)
			)
			(2
				(= local25 1)
				(if (or (not (Btst 120)) (== (Random 1 10) 1))
					(self setScript: zoomS self)
				else
					(switch (proc1_5 (+ global302 2) 0 2)
						(0
							(Say keapon self 250 33 250 34)
						)
						(1
							(Say keapon self 250 35 250 36)
						)
						(2 (Say keapon self 250 37))
					)
				)
			)
			(3
				(keapon
					setLoop: 3
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(4
				(keapon setLoop: 0 setCel: 0 cycleSpeed: 0)
				(smallCloud setLoop: 0 setCel: 0 posn: 170 145 60 init:)
				(= cycles 8)
			)
			(5
				(switch itemPurchased
					(6
						(= temp0 1)
						(magicThing
							noun: '/rope'
							lookStr: {It is a magic rope.}
							description: {the rope}
						)
					)
					(7
						(= temp0 2)
						(magicThing
							noun: '/glasses'
							lookStr: {Ali Fakir Genuine X-Ray Glasses.}
							description: {the x-ray glasses}
						)
						(xRayGlasses hide:)
					)
					(else 
						(= temp0 0)
						(magicThing
							noun: '/scroll,spell'
							lookStr: {It is a scroll containing a spell.}
							description: {the scroll}
						)
					)
				)
				(magicThing setLoop: 1 setCel: temp0 init:)
				(= cycles 4)
			)
			(6
				(ego setMotion: MoveTo 155 150 self)
			)
			(7 (ego setHeading: 45 self))
			(8
				(switch (proc3_1 (* local129 100))
					(0
						(Say keapon self 250 38 250 39)
					)
					(1
						(Say keapon self 250 40 250 41)
					)
					(2
						(Say keapon self 250 42)
						(proc3_2 (* local129 100))
						(if (== itemPurchased 6)
							(AddToScore 700 5 2)
							(self changeState: 10)
						else
							(= state 11)
						)
					)
				)
			)
			(9
				(magicThing dispose:)
				(if (== itemPurchased 7) (xRayGlasses show:))
				(smallCloud setCycle: Beg)
				(self changeState: 17)
			)
			(10)
			(11
				(Say keapon self (keapon msgFile?) 73)
			)
			(12 (smallCloud z: 59))
			(13
				(ego
					view: 47
					setLoop: 6
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(14
				(magicThing dispose:)
				(= spellLearned 0)
				(switch itemPurchased
					(1 (= spellLearned 20))
					(2 (= spellLearned 21))
					(4 (= spellLearned 22))
					(5 (= spellLearned 28))
					(3 (= spellLearned 27))
					(6 (ego get: 16))
					(7 (ego get: 54))
				)
				(ego setCycle: Beg self)
			)
			(15
				(if
				(and spellLearned (not (ego learn: spellLearned 10)))
					(HighPrint 250 43)
				)
				(= cycles 4)
			)
			(16
				(smallCloud setCycle: Beg self)
			)
			(17
				(proc1_19)
				(= local25 0)
				(smallCloud dispose:)
				(proc1_32 boredTimer 45)
				(self dispose:)
			)
		)
	)
)

(instance zoomS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 120)
				(boredTimer dispose:)
				(Say keapon self 250 44)
			)
			(1 (= cycles 2))
			(2
				(floatTimer1 dispose:)
				(keapon
					setLoop: 4
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
				(if (ego inRect: 67 117 150 150)
					(ego setMotion: MoveTo 140 160)
				)
			)
			(3
				(cloud init: setLoop: 6 setCycle: Fwd doit:)
				(keapon
					setLoop: 9
					setCel: 0
					setStep: 7 4
					setMotion: zMover 120 135 self
				)
				(pinWheels setCycle: Fwd)
				(proc1_32 whizTimer 3)
			)
			(4
				(keapon
					setPri: 10
					setMotion: MoveTo -50 (keapon y?) self
				)
			)
			(5 (= seconds 5))
			(6
				(keapon setLoop: 10 setMotion: MoveTo 120 135 self)
				(cloud setLoop: 7)
				(shadow setLoop: 12)
			)
			(7
				(keapon setPri: -1 setMotion: zMover 190 145 self)
			)
			(8
				(pinWheels setCycle: Fwd)
				(proc1_32 whizTimer 3)
				(cloud setCycle: Beg self)
			)
			(9
				(cloud dispose:)
				(keapon setLoop: 5 setCel: 255 setCycle: Beg self)
				(floatTimer1 setCycle: floatTimer1 (Random 7 13))
			)
			(10
				(keapon setLoop: 0 cycleSpeed: 0)
				(shadow setLoop: 11 setCel: 0 doit:)
				(= cycles 4)
			)
			(11
				(Say keapon self 250 45 250 46)
			)
			(12 (= cycles 2))
			(13 (self dispose:))
		)
	)
)

(instance keapon of Talker
	(properties
		x 191
		y 145
		z 60
		description {Keapon Laffin}
		lookStr {Be it ever so humble, there's no face like Gnome's.}
		view 255
		illegalBits $0000
		talkSpeed 1
		myName '//keapon,keapon,man,gnome,owner'
		title {Keapon Laffin:}
		color 15
		back 1
		msgFile 254
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow BotWindow)
		(proc1_32 boredTimer 45)
		(shadow ignoreActors: 1 setPri: 0 init:)
		(floatTimer1 setCycle: floatTimer1 (Random 7 13))
	)
	
	(method (handleEvent)
		(proc1_32 boredTimer 45)
		(super handleEvent: &rest)
	)
	
	(method (respond param1 param2)
		(if (== param2 10)
			(param1 claimed: 0)
			(if (Said '//spell')
				(self showText: 54)
				(return)
			else
				(param1 claimed: 1)
			)
		)
		(super respond: param1 param2 &rest)
	)
	
	(method (atSpec param1)
		(return [local177 param1])
	)
	
	(method (atGen param1)
		(return [local139 param1])
	)
	
	(method (showText param1)
		(cond 
			((== param1 72)
				(if global293
					(Say self msgFile 72 250 47)
				else
					(ego get: 32)
					(= global293 (+ global293 6))
					(= local27 1)
					(super showText: param1 &rest)
				)
			)
			((== param1 78) (self showMany: param1 80))
			((== param1 73) (self showMany: param1 76))
			(else
				(if (== param1 89) (AddToScore 617 5))
				(super showText: param1 &rest)
			)
		)
	)
	
	(method (messages)
		(floatTimer2 setCycle: floatTimer2 (Random 4 10))
		(super messages: &rest)
	)
	
	(method (endTalk)
		(super endTalk:)
		(if (not local25)
			(self setScript: laughS 0 0)
		else
			(self setLoop: 0 cel: 0)
		)
		(floatTimer2 dispose:)
		(if local27 (HighPrint 250 48) (= local27 0))
	)
)

(instance zMover of MoveTo
	(properties)
	
	(method (doit &tmp clientZ)
		(super doit:)
		(= clientZ (client z?))
		(switch x
			(120 (client z: (- clientZ 4)))
			(190 (client z: (+ clientZ 4)))
		)
	)
)

(instance shadow of View
	(properties
		x 191
		y 145
		noun '/shadow'
		description {Keapon's shadow}
		shiftClick 0
		lookStr {SOME people cast shadows.}
		view 255
		loop 11
		signal $0800
	)
	
	(method (doit)
		(super doit:)
		(= x (keapon x?))
		(= y (keapon y?))
		(if (cast contains: cloud) (= cel (cloud cel?)))
	)
)

(instance cloud of Prop
	(properties
		noun '/cloud'
		description {the cloud}
		lookStr {It's the new and improved Maxi-Cloud HyperTurbo V8 LE No-door Sports Coupe, the pinnacle of cloudal mediocrity.}
		view 255
		loop 6
		signal $4800
	)
	
	(method (doit)
		(super doit:)
		(= z (keapon z?))
		(= x (+ (keapon x?) 3))
		(= y (+ (keapon y?) 3))
		(self setPri: (- (keapon priority?) 1))
	)
)

(instance smallCloud of Prop
	(properties
		noun '/cloud'
		description {the cloud}
		lookStr {It's a cloud/table/tray/catch-all/whatchamacallit.}
		view 251
		signal $4800
		cycleSpeed 1
	)
	
	(method (init)
		(super init:)
		(self setCycle: End)
	)
	
	(method (doit)
		(super doit:)
		(if (and (< 34 z) (< z 60) (== (-- z) 34))
			(buyItemS cue:)
		)
	)
)

(instance magicThing of View
	(properties
		x 170
		y 145
		z 60
		view 251
		loop 1
		signal $4800
	)
	
	(method (doit)
		(super doit:)
		(= x (smallCloud x?))
		(= y (smallCloud y?))
		(= z (smallCloud z?))
	)
)

(instance floatTimer1 of Timer
	(properties)
	
	(method (cue)
		(if (== (keapon z?) 59)
			(keapon z: 60)
		else
			(keapon z: 59)
		)
		(self setCycle: self (Random 7 13))
	)
)

(instance floatTimer2 of Timer
	(properties)
	
	(method (cue)
		(keapon x: (- (keapon x?) local26))
		(= local26 (- (Random 0 2) 1))
		(keapon x: (+ (keapon x?) local26))
		(self setCycle: self (Random 4 10))
	)
)

(instance boredTimer of Timer
	(properties)
	
	(method (cue)
		(Say keapon (keapon msgFile?) (+ 46 (Random 0 2)))
		(proc1_32 self 45)
	)
)

(instance whizTimer of Timer
	(properties)
	
	(method (cue &tmp pinWheelsCycleSpeed)
		(if
		(< (= pinWheelsCycleSpeed (pinWheels cycleSpeed?)) 2)
			(pinWheels cycleSpeed: (+ pinWheelsCycleSpeed 1))
			(proc1_32 self 3)
		else
			(pinWheels cycleSpeed: 0 setCycle: 0)
		)
	)
)

(instance pinWheels of Prop
	(properties
		x 130
		y 40
		noun '/pinwheel,(wheel<pin)'
		description {pinwheels}
		lookStr {They're pinwheels.__Just something for Keapon to toy around with.}
		view 250
		loop 3
		cel 1
		signal $4000
	)
)

(instance xRayGlasses of View
	(properties
		x 267
		y 113
		noun '/face,glasses,disguise'
		description {the x-ray glasses}
		lookStr {The tag says "Ali Fakir Genuine X-Ray Glasses - 15 Dinars."__They look incredibly large, but the tag also says "One size fits all."__It must be magic.}
		view 250
		cel 7
		signal $4000
	)
)

(instance booksLeft of Feature
	(properties
		x 140
		y 62
		noun '/book'
		nsTop 56
		nsLeft 133
		nsBottom 69
		nsRight 147
		description {the books}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint (Format @local28 250 49 [local251 local262]))
			(if (> (++ local262) 10) (= local262 0))
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance booksRight of Feature
	(properties
		x 311
		y 35
		noun '/book'
		nsTop 26
		nsLeft 303
		nsBottom 44
		nsRight 319
		description {the books}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint (Format @local28 250 49 [local251 local262]))
			(if (> (++ local262) 10) (= local262 0))
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance cloudPoly of Polygon
	(properties
		type $0000
	)
)

(instance ceiling of Feature
	(properties
		noun '/ceiling'
		description {the ceiling}
		lookStr {The fact that the clouds on the ceiling don't move leads you to the conclusion that they were not painted on with an air brush.}
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) cloudPoly)
	)
)

(instance sunPoly of Polygon
	(properties
		type $0000
	)
)

(instance floor of Feature
	(properties
		noun '/floor'
		description {the floor}
		lookStr {Talk about topsy-turvy.__The sun shines up from the floor onto the clouds above.}
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) sunPoly)
	)
)
