;;; Sierra Script 1.0 - (do not remove this comment)
(script# 271)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Feature)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)

(public
	rm271 0
)

(local
	local0 =  1
	local1
	local2
)
(procedure (localproc_000c)
	(switch local0
		(3
			(HighPrint 271 0 80 {That Voice Again:})
			(= local0 4)
			(= local2 0)
			(theDoor cel: 0)
			(= global284 1)
		)
		(2
			(HighPrint 271 1 80 {Still The Same Voice:})
			(= local0 3)
			(= local1 50)
		)
		(1
			(PrintWarning 271 2)
			(HighPrint 271 3 80 {A Voice From Within:})
			(= local0 2)
			(= local1 50)
		)
	)
)

(instance rm271 of Rm
	(properties
		style $0007
		horizon 88
		vanishingY 50
	)
	
	(method (init)
		(asm
			pushi    5
			pushi    128
			pushi    0
			pushi    22
			pushi    700
			pushi    702
			calle    LoadMany,  10
			pushi    2
			pushi    129
			pushi    700
			callk    Load,  4
			lsg      prevRoomNum
			ldi      270
			eq?     
			bt       code_00bb
			lsg      prevRoomNum
			ldi      275
			eq?     
			bnt      code_00c3
code_00bb:
			pushi    2
			pushi    129
			pushi    2
			callk    Load,  4
code_00c3:
			lsg      currentDay
			ldi      15
			eq?     
			bnt      code_00df
			lag      global284
			not     
			bnt      code_00df
			lsg      currentTimeZone
			ldi      5
			eq?     
			bt       code_00df
			lsg      currentTimeZone
			ldi      4
			eq?     
code_00df:
			sal      local2
			pushi    0
			calle    proc1_19,  0
			lsg      prevRoomNum
			ldi      270
			eq?     
			bt       code_00f8
			lsg      prevRoomNum
			ldi      275
			eq?     
			bnt      code_0147
code_00f8:
			pushi    5
			pushi    1
			pushi    22
			pushi    4
			pushi    1
			pushi    164
			pushi    3
			pushi    1
			pushi    90
			pushi    241
			pushi    1
			lsg      global284
			ldi      2
			eq?     
			bt       code_011e
			lsg      global284
			ldi      3
			eq?     
			bnt      code_0123
code_011e:
			ldi      1
			jmp      code_0125
code_0123:
			ldi      0
code_0125:
			push    
			pushi    7
			pushi    1
			pushi    0
			pushi    102
			pushi    0
			pushi    152
			pushi    0
			pushi    135
			pushi    1
			lofsa    thrownOut
			push    
			lag      ego
			send     44
			pushi    #picture
			pushi    1
			pushi    2
			self     6
			jmp      code_01af
code_0147:
			pushi    #loop
			pushi    1
			pushi    3
			pushi    18
			pushi    1
			pushi    65152
			pushi    237
			pushi    2
			pushi    160
			pushi    181
			pushi    102
			pushi    0
			pushi    252
			pushi    3
			class    MoveTo
			push    
			pushi    160
			pushi    147
			lag      ego
			send     34
			pushi    7
			pushi    1
			lsg      prevRoomNum
			ldi      270
			eq?     
			bt       code_0186
			lsg      prevRoomNum
			ldi      275
			eq?     
			bnt      code_0191
code_0186:
			lag      global284
			bnt      code_0191
			ldi      3
			jmp      code_019d
code_0191:
			lal      local2
			bnt      code_019b
			ldi      1
			jmp      code_019d
code_019b:
			ldi      0
code_019d:
			push    
			pushi    102
			pushi    0
			lofsa    theDoor
			send     10
			pushi    #picture
			pushi    1
			pushi    700
			self     6
code_01af:
			pushi    #init
			pushi    0
			super    Rm,  4
			lsg      prevRoomNum
			ldi      270
			eq?     
			bt       code_01c4
			lsg      prevRoomNum
			ldi      275
			eq?     
code_01c4:
			not     
			bnt      code_01e1
			pushi    2
			lofsa    backWall
			push    
			lofsa    flame
			push    
			callb    DrawFeature,  4
			pushi    2
			lofsa    thisAlley
			push    
			lofsa    theDark
			push    
			calle    proc1_31,  4
code_01e1:
			ret     
		)
	)
	
	(method (doit)
		(if (> (ego y?) 181)
			(if global284 (= global284 5))
			(curRoom newRoom: 704)
		)
		(if
			(and
				local2
				(not local1)
				(< (ego distanceTo: theDoor) 40)
				(not (ego script?))
			)
			(= local1 50)
			(= local0 2)
			(ego setMotion: 0)
			(HighPrint 271 4 80 {Voice})
		)
		(if
			(and
				local2
				local1
				(< (ego distanceTo: theDoor) 15)
				(not (ego script?))
			)
			(= local1 0)
			(if (== egoWalkMode 4)
				(ego setMotion: 0)
				(= local0 3)
				(localproc_000c)
			else
				(ego setScript: openDoor)
			)
		)
		(cond 
			((not local1))
			((-- local1))
			(else (localproc_000c))
		)
	)
	
	(method (dispose)
		(if (== egoWalkMode 4)
			(HighPrint 271 5)
			(ChangeEgoWalk 0 0)
			(proc1_19)
			(SetUpEgo)
		)
		(= gTopExit 1)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 271 6))
			((Said 'knock[/door]') (ego setScript: knockDoor))
		)
	)
)

(instance backWall of PicView
	(properties
		x 160
		y 80
		noun '/door'
		description {the door}
		view 702
		cel 3
		priority 4
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(cond 
					((or (== prevRoomNum 270) (== prevRoomNum 275)) (HighPrint 271 7))
					(local2 (HighPrint 271 8))
					(else (HighPrint 271 9))
				)
			)
			(2 (ego setScript: openDoor))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance flame of PicView
	(properties
		x 215
		y 66
		noun '/flame,torch,lamp,light'
		description {the torch}
		lookStr {A torch lights up the alleyway.}
		view 701
		loop 5
		priority 9
	)
)

(instance theDoor of Prop
	(properties
		x 174
		y 78
		noun '/door'
		description {the door}
		view 702
		loop 4
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'listen[/door]')
				(if local2
					(PrintWarning 271 10)
				else
					(PrintWarning 271 11)
				)
			)
			((Said 'use,light/lamp,light')
				(if (and (ego has: 33) (!= egoWalkMode 4))
					(ChangeEgoWalk 4 0)
					(proc1_19)
					(SetUpEgo)
				)
				(if local2 (TestSkill 25 1) (localproc_000c))
			)
			((Said 'douse,(put<away,out)/lamp,light')
				(if (== egoWalkMode 4)
					(ChangeEgoWalk 0 0)
					(proc1_19)
					(HighPrint 271 5)
					(SetUpEgo)
				)
				(if local1
					(= local1 30)
					(= local0 2)
					(HighPrint 271 12 80 {The Same Voice:})
				)
			)
			(
				(and
					(ego has: 33)
					(Said 'deposit,(put<down)/light,lamp')
				)
				(if (== egoWalkMode 4)
					(ChangeEgoWalk 0 0)
					(proc1_19)
					(SetUpEgo)
				)
				(ego use: 33)
				(HighPrint 271 13)
			)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(cond 
					((or (== prevRoomNum 270) (== prevRoomNum 275)) (HighPrint 271 7))
					(local2 (HighPrint 271 8))
					(else (HighPrint 271 9))
				)
			)
			(2 (ego setScript: openDoor))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance thrownOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 5))
			(1
				(if (or (== global284 2) (== global284 3))
					(HighPrint 271 14)
				else
					(HighPrint 271 15)
				)
				(= cycles 3)
			)
			(2
				(theDoor
					cel:
						(cond 
							(
								(and
									(or (== prevRoomNum 270) (== prevRoomNum 275))
									global284
								)
								3
							)
							(local2 1)
							(else 0)
						)
					init:
				)
				(curRoom drawPic: 700)
				(DrawFeature backWall flame)
				(proc1_31 thisAlley theDark)
				(ego show:)
				(if (or (== global284 2) (== global284 3))
					(theDoor setCycle: Beg self)
				else
					(ego setCycle: End self)
					(theDoor setCycle: Beg)
				)
			)
			(3
				(cond 
					((== global284 6) (HighPrint 271 16 80 {The Same Voice As Before:}))
					((> global284 2)
						(= currentTimeZone 6)
						(if (or (== prevRoomNum 270) (== prevRoomNum 275))
							(PrintWarning 271 17)
							(PrintWarning 271 18)
						)
					)
					((== global284 2) (HighPrint 271 0 80 {The Same Voice As Before:}))
					(global284 (HighPrint 271 19 80 {The Same Voice As Before:}))
				)
				(ego
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: CT 4 1 self
				)
			)
			(4 (ego setCycle: End self))
			(5
				(ego
					view: 0
					setLoop: 3
					heading: 0
					cycleSpeed: 0
					posn: (- (ego x?) 3) (+ (ego y?) 8)
				)
				(proc1_19)
				(ego illegalBits: -384)
				(self dispose:)
			)
		)
	)
)

(instance knockDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> (ego distanceTo: theDoor) 15)
					(ego setMotion: MoveTo 160 90 self)
				else
					(self cue:)
				)
			)
			(1
				(cond 
					(local2 (PrintWarning 271 20) (theDoor setCycle: End self))
					(
						(and
							global284
							(or (== prevRoomNum 270) (== prevRoomNum 275))
						)
						(HighPrint 271 21 80 {The Same Old Voice:})
						(self dispose:)
					)
					(else (PrintWarning 271 22) (self dispose:))
				)
			)
			(2
				(PrintWarning 271 23)
				(ego
					illegalBits: 0
					setPri: 3
					setMotion: MoveTo 160 75 self
				)
			)
			(3 (curRoom newRoom: 270))
		)
	)
)

(instance openDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> (ego distanceTo: theDoor) 15)
					(ego setMotion: MoveTo 160 90 self)
				else
					(self cue:)
				)
			)
			(1
				(if local2
					(theDoor setCycle: End self)
				else
					(PrintWarning 271 24)
					(self dispose:)
				)
			)
			(2
				(ego
					illegalBits: 0
					setPri: 3
					setMotion: MoveTo 160 75 self
				)
			)
			(3 (curRoom newRoom: 270))
		)
	)
)

(instance thisAlley of Feature
	(properties
		x 159
		y 94
		noun '/alley'
		nsTop 15
		nsLeft 88
		nsBottom 173
		nsRight 230
		description {the alley}
		lookStr {The alleys of Shapeir are major arteries of transport.}
	)
)

(instance theDark of Feature
	(properties
		x 159
		y 93
		noun '/dark'
		nsTop -1
		nsBottom 187
		nsRight 318
		description {the dark}
		lookStr {All is darkness beyond the immediate alley.}
	)
)
