;;; Sierra Script 1.0 - (do not remove this comment)
(script# 340)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Motion)
(use Game)
(use Actor)

(public
	rm340 0
)

(local
	local0
	local1
)
(instance rm340 of Rm
	(properties
		picture 340
		style $0008
	)
	
	(method (init)
		(gCMusic number: 340 loop: 1 priority: 8 playBed:)
		(super init:)
		(cond 
			((<= currentDay 7) (= local0 0))
			((<= currentDay 11) (= local0 2))
			((<= currentDay 14) (= local0 1))
			((<= currentDay 16) (= local0 3))
		)
		(killer init:)
		(DrawFeature town)
		(self setScript: destructo)
	)
)

(instance destructo of HandsOffScript
	(properties)
	
	(method (init)
		(super init: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(killer
					setLoop: local0
					cel: 0
					setPri: 6
					xStep: 1
					cycleSpeed: 1
					setCycle: Fwd
					setMotion: MoveTo 176 71 self
				)
			)
			(1
				(killer
					setLoop: local0
					cel: 0
					setPri: 6
					xStep: 1
					cycleSpeed: 1
					setMotion: MoveTo 109 71 self
				)
			)
			(2
				(if (< (++ local1) 2)
					(self changeState: 0)
				else
					(= cSoundDeath 0)
					(Die 0 340 0 82 347 local0 0)
				)
			)
		)
	)
)

(instance killer of Actor
	(properties
		x 109
		y 71
		view 347
	)
)

(instance town of PicView
	(properties
		x 148
		y 90
		view 780
		priority 7
	)
)
