;;; Sierra Script 1.0 - (do not remove this comment)
(script# 370)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Full)
(use LoadMany)
(use Timer)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm370 0
)

(local
	[local0 100]
	local100 =  2
)
(procedure (localproc_000c param1)
	(ferrariHead
		tLoop: 2
		setLoop: 1
		setCel: 0
		setCycle: End param1
	)
)

(procedure (localproc_002a param1)
	(ferrariHead
		tLoop: 0
		setLoop: 1
		setCel: 4
		setCycle: Beg param1
	)
)

(procedure (localproc_0049 param1)
	(rightHand setCel: 0 setCycle: End param1)
)

(procedure (localproc_005d param1)
	(rightHand setCel: 2 setCycle: Beg param1)
)

(procedure (localproc_0071 param1 param2)
	(rightHand setCel: 0 setCycle: Full param1 param2)
)

(procedure (localproc_0088 param1)
	(leftHand setCycle: Full 1 param1)
)

(instance rm370 of Rm
	(properties
		picture 370
		style $0006
	)
	
	(method (init)
		(LoadMany 128 360 361 365)
		(super init:)
		(SetControl 1)
		(DrawFeature upperArm)
		(ego view: 371 loop: 0 posn: 115 78 init:)
		(egoEyes init:)
		(ferrariHead init:)
		(if (== global295 7)
			(leftHand setLoop: 7 posn: 240 109)
		)
		(leftHand init:)
		(rightHand init:)
		(proc1_32 nodTimer 5)
		(proc1_32 blinkTimer 3)
		(Bclr 2)
		(switch global295
			(0
				(curRoom setScript: meeting1)
			)
			(2
				(curRoom setScript: meeting2)
			)
			(5
				(curRoom setScript: meeting3)
			)
			(7
				(curRoom setScript: meeting4)
			)
		)
	)
	
	(method (dispose)
		(++ global295)
		(SetControl 0)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(Bset 2)
		(super dispose:)
	)
)

(instance ferrariLaughs of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= register (ferrariHead loop?))
				(ferrariHead
					setLoop: 5
					setCel: 0
					cycleSpeed: 0
					setCycle: End self
				)
			)
			(1
				(ferrariHead setLoop: 6 setCel: 0 setCycle: Fwd)
				(= cycles 8)
			)
			(2
				(ferrariHead setLoop: 5 setCel: 3 setCycle: Beg self)
			)
			(3
				(ferrariHead setLoop: register)
				(self dispose:)
			)
		)
	)
)

(instance meeting1 of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say ferrariHead self 370 0))
			(1 (localproc_000c self))
			(2
				(Say ferrariHead self 370 1 370 2)
			)
			(3 (localproc_002a self))
			(4
				(localproc_0049)
				(Say ferrariHead self 370 3)
			)
			(5
				(localproc_005d)
				(Say ferrariHead self 370 4)
			)
			(6
				(SetInput 0)
				(localproc_0071 1)
				(localproc_0088)
				(Say ferrariHead 370 5 370 6)
				(proc1_32 questionTimer 30)
			)
			(7
				(questionTimer dispose:)
				(SetInput 1)
				(localproc_0071 2)
				(self setScript: ferrariLaughs self)
			)
			(8
				(if (Btst 102)
					(Say ferrariHead self 370 7 370 8)
				else
					(Say ferrariHead self 370 9)
				)
			)
			(9 (localproc_000c self))
			(10
				(localproc_0088)
				(if (Btst 102)
					(Say ferrariHead self 370 10)
				else
					(Say ferrariHead self 370 11)
				)
			)
			(11 (curRoom newRoom: 360))
			(12
				(localproc_0071 1)
				(localproc_0088)
				(Say ferrariHead self 370 12)
			)
			(13
				(Die
					0
					369
					3
					82
					999
					1
					4
					80
					{You should have had one for the road}
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((or (Said '/coffee') (Said '//coffee')) (self cue:))
			(
			(or (Said '/sling,djinn') (Said '//sling,djinn')) (Bset 102) (self cue:))
			(else (pEvent claimed: 1) (self changeState: 12))
		)
	)
)

(instance meeting2 of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Say ferrariHead self 370 13)
			)
			(1
				(localproc_0049)
				(localproc_000c self)
			)
			(2
				(Say ferrariHead self 370 14)
			)
			(3
				(localproc_005d)
				(localproc_002a self)
			)
			(4
				(Say ferrariHead self 370 15 370 16)
			)
			(5
				(localproc_0049)
				(localproc_0088)
				(Say ferrariHead self 370 17)
			)
			(6
				(localproc_005d)
				(Say ferrariHead self 370 18 370 19)
			)
			(7 (localproc_000c self))
			(8
				(Say ferrariHead self 370 20 370 21)
			)
			(9
				(localproc_0071 3)
				(localproc_002a self)
			)
			(10
				(localproc_0088)
				(Say ferrariHead self 370 22)
			)
			(11 (localproc_000c self))
			(12
				(Say ferrariHead self (Format @local0 370 23 @userName))
			)
			(13 (curRoom newRoom: 360))
		)
	)
)

(instance meeting3 of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_0049)
				(Say ferrariHead self 370 25)
			)
			(1
				(localproc_005d)
				(Say ferrariHead self 370 26)
			)
			(2 (localproc_000c self))
			(3
				(Say ferrariHead self 370 27)
			)
			(4 (localproc_002a self))
			(5
				(SetInput 0)
				(Say ferrariHead 370 28)
			)
			(6
				(SetInput 1)
				(localproc_0049)
				(Say ferrariHead self 370 29)
			)
			(7
				(localproc_005d)
				(Say ferrariHead self 370 30)
			)
			(8
				(= global295 8)
				(curRoom newRoom: 360)
			)
			(9
				(SetInput 1)
				(Say ferrariHead self 370 31 370 32)
			)
			(10
				(localproc_0049)
				(localproc_000c self)
			)
			(11
				(Say ferrariHead self 370 33)
			)
			(12
				(localproc_005d)
				(localproc_002a self)
			)
			(13
				(self setScript: ferrariLaughs self)
			)
			(14
				(localproc_0088)
				(Say ferrariHead self 370 34 370 35)
			)
			(15
				(localproc_0071 2)
				(Say ferrariHead self 370 36)
			)
			(16 (localproc_000c self))
			(17
				(Say ferrariHead self 370 37)
			)
			(18 (localproc_002a self))
			(19
				(localproc_0088)
				(Say ferrariHead self 370 38 370 39)
			)
			(20 (localproc_000c self))
			(21
				(localproc_0049)
				(Say ferrariHead self 370 40 370 41)
			)
			(22
				(localproc_005d)
				(localproc_002a self)
			)
			(23
				(Say ferrariHead self 370 42 370 43)
			)
			(24 (curRoom newRoom: 360))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'affirmative') (self changeState: 9))
			((Said 'n') (self cue:))
			(else (Say ferrariHead 370 24 370 25) (pEvent claimed: 1))
		)
	)
)

(instance meeting4 of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Say ferrariHead self 370 44)
			)
			(1
				(localproc_0049)
				(Say ferrariHead self 370 45)
			)
			(2 (localproc_000c self))
			(3
				(localproc_005d)
				(Say ferrariHead self 370 46 370 47)
			)
			(4
				(Say ferrariHead self 370 48)
			)
			(5
				(ferrariHead
					setLoop: 8
					setCel: 0
					cycleSpeed: 1
					setCycle: CT 2 1
				)
				(= cycles 20)
			)
			(6
				(ferrariHead setCycle: End)
				(= cycles 20)
			)
			(7
				(ferrariHead setLoop: 9 setCel: 0 setCycle: CT 2 1)
				(= cycles 12)
			)
			(8
				(ferrariHead setCel: 0 setCycle: End)
				(= cycles 8)
			)
			(9
				(ferrariHead
					setLoop: 9
					setCel: 3
					cycleSpeed: 1
					setCycle: Beg
				)
				(= cycles 10)
			)
			(10
				(self setScript: ferrariLaughs self)
			)
			(11
				(localproc_0071 2)
				(Say ferrariHead self 370 49 370 50)
			)
			(12
				(nodTimer dispose:)
				(blinkTimer dispose:)
				(ego setLoop: 2 cycleSpeed: 1 setCycle: End)
				(= cycles 14)
			)
			(13
				(ego setCel: 0)
				(localproc_000c self)
			)
			(14
				(proc1_32 nodTimer 5)
				(proc1_32 blinkTimer 3)
				(ego setLoop: 0 setCel: 0)
				(Say ferrariHead self 370 51)
			)
			(15
				(localproc_0049)
				(Say ferrariHead self 370 52)
			)
			(16
				(localproc_005d)
				(Say ferrariHead self 370 53)
			)
			(17
				(localproc_0071 3)
				(Say ferrariHead self 370 54)
			)
			(18
				(Say ferrariHead self 370 55)
			)
			(19 (curRoom newRoom: 360))
		)
	)
)

(instance ferrariHead of Talker
	(properties
		x 184
		y 79
		description {Ferrari}
		lookStr {This is Signor Ferrari.__He is swatting flies with an animal-tail whip.}
		view 375
		talkSpeed 1
		myName '//ferrari,man,senor'
		title {Signor Ferrari:}
		color 2
	)
	
	(method (init)
		(super init: &rest)
		(= tWindow BotWindow)
	)
	
	(method (handleEvent pEvent)
		(if (== (pEvent type?) evSAID)
			(pEvent claimed: 0)
		else
			(super handleEvent: pEvent)
		)
	)
)

(instance upperArm of PicView
	(properties
		x 232
		y 118
		noun '/ferrari,(man<fat)'
		description {Ferrari}
		lookStr {This is Signor Ferrari.__He is swatting flies with an animal-tail whip.}
		view 375
		loop 11
	)
)

(instance leftHand of Prop
	(properties
		x 245
		y 111
		noun '/ferrari,(man<fat)'
		description {Ferrari}
		lookStr {This is Signor Ferrari.__He is swatting flies with an animal-tail whip.}
		view 375
		loop 4
		priority 9
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
	)
)

(instance rightHand of Prop
	(properties
		x 144
		y 98
		noun '/ferrari,(man<fat)'
		description {Ferrari}
		lookStr {This is Signor Ferrari.__He is swatting flies with an animal-tail whip.}
		view 375
		loop 3
	)
	
	(method (init)
		(super init: &rest)
	)
)

(instance egoEyes of Prop
	(properties
		x 124
		y 61
		view 371
		loop 1
		priority 15
		signal $0010
	)
)

(instance nodTimer of Timer
	(properties)
	
	(method (cue)
		(ego setCycle: Full (Random 1 3))
		(proc1_32 self 10 15)
	)
)

(instance blinkTimer of Timer
	(properties)
	
	(method (cue)
		(egoEyes setCycle: Full 1)
		(proc1_32 self 5 8)
	)
)

(instance questionTimer of Timer
	(properties)
	
	(method (cue)
		(if (not (-- local100))
			((curRoom script?) changeState: 12)
		else
			(Say ferrariHead 370 56)
			(proc1_32 self 30)
		)
	)
)
