;;; Sierra Script 1.0 - (do not remove this comment)
(script# 400)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use n065)
(use TargActor)
(use n095)
(use Intrface)
(use rasGuard)
(use PolyPath)
(use Polygon)
(use LoadMany)
(use Save)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm400 0
	fightScript 1
	eunuch 2
	holler 3
	rGuard1 4
	rGuard2 5
	leftDr 6
	rightDr 7
)

(local
	local0
	local1
	local2
	[local3 100]
	[newARopette 39]
	[newBGuard 6]
	[newAGuard 5]
	local153 =  27
	local154
	local155
	local156
	local157
	local158
	local159
	local160
	local161
	local162
	local163
	local164
	local165 =  147
	local166 =  122
	[local167 12] = [311 317 322 330 338 342 348 353 356 361 365 373]
	[local179 12] = [51 52 50 49 51 52 50 49 51 52 50 49]
	[local191 6] = [{Guards to the gate!!} {The gate is being attacked!} {Somebody HELP!!!!} {Defend the gate!!} {All guards, to the gate!!!} {Guards!__Guards!__Guards!__Guards!}]
	local197
	[local198 3] = [{Interference with a guard in his duties is a punishable offense.} {Loitering is forbidden.__Move on.} {Questioning a guard constitutes interference.__Leave before it becomes an offense._}]
	[local201 8] = [67 137 76 119 124 119 119 139]
	[local209 8] = [198 140 196 117 246 118 257 137]
	[local217 8] = [61 136 18 135 35 117 67 119]
	[local225 8] = [262 137 251 119 287 118 303 139]
	local233
	local234
	local235
	local236
	local237
	local238
	local239
	local240
	local241
	local242
)
(procedure (localproc_001a)
	(HighPrint &rest 80 {Eunuch:} 35 eWin)
)

(procedure (localproc_0068)
	(= local1 0)
	(while (< local1 38)
		(= [newARopette local1] (aRopette new:))
		([newARopette local1]
			y: local153
			x: ((ScriptID 61 0) x?)
			init:
		)
		(= local153 (+ local153 3))
		(++ local1)
	)
)

(procedure (localproc_01a2)
	(= local2 0)
	(while (< local2 local237)
		([newAGuard local2]
			x: [local167 local2]
			y: [local179 (= [newAGuard local2] (aGuard new:))]
			loop: 1
			priority: 6
			init:
			setCycle: Walk
			setMotion: MoveTo 70 [local179 local2]
		)
		(++ local2)
	)
)

(procedure (localproc_01f2)
	(= local1 0)
	(while (< local1 5)
		(= [newBGuard local1] (bGuard new:))
		([newBGuard local1]
			x: (- local165 10)
			y: 112
			loop: 2
			priority: 8
			signal: -32735
		)
		(= local165 (+ local165 13))
		(DrawFeature [newBGuard local1])
		(++ local1)
	)
)

(procedure (localproc_0243)
	(= local1 0)
	(while (< local1 12)
		(if (cast contains: [newBGuard local1])
			([newBGuard local1] dispose:)
		)
		(if (cast contains: [newAGuard local1])
			([newAGuard local1] dispose:)
		)
		(++ local1)
	)
)

(procedure (localproc_0283)
	(= local1 0)
	(while (< local1 5)
		(= [newBGuard local1] (aGuard new:))
		([newBGuard local1]
			x: local165
			y: 100
			loop: 2
			priority: 8
			init:
			setCycle: Walk
			setMotion: MoveTo local166 140
		)
		(= local165 (+ local165 7))
		(= local166 (+ local166 19))
		(++ local1)
	)
)

(procedure (localproc_02e0)
	(return
		(if (== local233 3)
			(Die
				1
				{The guards, tiring of your chatter, grab you and call other guards to their assistance.__You are dragged into prison and remain there for a long, long, long time._}
				80
				{Curiosity Killed the Hero}
			)
		else
			(HighPrint
				(Format @local3 400 0 [local198 local233])
				80
				{Guard:}
				103
				25
				6
			)
			(++ local233)
		)
	)
)

(instance eWin of SysWindow
	(properties
		back 13
	)
)

(instance aRopette of View
	(properties
		view 8
		loop 4
		priority 11
		signal $6010
	)
)

(instance disposeRope of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if [newARopette local1]
					([newARopette local1] dispose:)
					(= [newARopette local1] 0)
				)
				(self cue:)
			)
			(1 (-- local1) (= cycles 1))
			(2
				(if (> local1 -1)
					(self changeState: 0)
				else
					(self dispose:)
				)
			)
		)
	)
)

(instance aGuard of Actor
	(properties
		view 382
		signal $6010
		illegalBits $0000
	)
)

(instance bGuard of PicView
	(properties
		view 382
		signal $6010
	)
)

(instance rm400 of Rm
	(properties
		picture 240
	)
	
	(method (init)
		(LoadMany 130 401 381)
		(LoadMany 128 0 6 4 533 31 532 47 83 382 381 383 410 460)
		(if (Btst 96) (= currentDay 30) (SetGameTime 21 0))
		(if isNightTime
			(= defaultPalette 3)
		else
			(= defaultPalette 2)
		)
		((ScriptID 32 1) x: 170 y: 114)
		(= useObstacles 1)
		(super init:)
		(poly2 points: @local209 size: 4)
		(poly1 points: @local201 size: 4)
		(poly4 points: @local225 size: 4)
		(poly3 points: @local217 size: 4)
		(curRoom addObstacle: poly1 poly2 poly3 poly4)
		(if (<= global105 40)
			(= local237 2)
		else
			(= local237 8)
		)
		(if (and (== currentDay 30) isNightTime)
			(= gGDftSC gAllSC)
		)
		(= gLevMe levitateMe)
		(= gGetBellows ropeMe)
		(= global166 40)
		(= global168 40)
		(leftDr init: stopUpd:)
		(rightDr init: stopUpd:)
		(rGuard1 view: 383 loop: 5 cel: 0 posn: 124 111 init:)
		(rGuard2 init:)
		(cond 
			((and (== currentDay 30) isNightTime)
				(eunuch init: setScript: (ScriptID 401 6))
				(if (Btst 138) (scarf init: setCycle: Fwd))
			)
			(
			(and (<= 0 currentTimeZone) (<= currentTimeZone 4)) (rGuard3 init:) (rGuard4 init: setScript: guardPace))
		)
		(proc1_19)
		(ego posn: (- 320 (ego x?)) 224 loop: 3 init:)
		(self setScript: comeIn)
	)
	
	(method (doit)
		(if (== local239 12) (= local162 3))
		(if
			(and
				(cast contains: rGuard1)
				(not local161)
				(== (leftDr cel?) 3)
			)
			(= local161 1)
			(HighPrint 400 1 80 {Gate Guard:} 25 3)
			(= local162 4)
		)
		(cond 
			((not local238))
			((-- local238))
			(else
				(if (cast contains: rGuard1)
					(rGuard1 loop: 5 setScript: 0)
				)
				(if (cast contains: rGuard2) (rGuard2 loop: 6))
				(= local161 0)
				(if (or local157 local158)
					(HighPrint 400 2 80 {Blind guard:} 103 25 3)
				else
					(HighPrint 400 2 80 {Both guards in unison:} 103 25 3)
				)
			)
		)
		(cond 
			((not local162))
			((-- local162))
			(else
				(HighPrint 400 3 80 {Guard:})
				(ego setScript: guardsRushIn)
			)
		)
		(if local163 (-- local163))
		(cond 
			(
				(and
					(ego inRect: 131 109 188 118)
					(not (ego script?))
					(== (leftDr cel?) 3)
					(or
						local161
						(and
							(not (cast contains: rGuard1))
							(not (cast contains: rGuard2))
						)
					)
				)
				(ego setMotion: MoveTo (ego x?) (- (ego y?) 10))
				(curRoom newRoom: 470)
			)
			(
				(and
					(& (ego onControl: 1) $0004)
					(not local159)
					(not local161)
					isNightTime
				)
				(= local159 1)
				(cond 
					((and (== currentDay 27) (not local242)) (= local242 1) (self setScript: (ScriptID 401 9)))
					((or (and local157 local158) local236) (return))
					(local160 (HighPrint 400 4 80 {Guard:}) (DjinniSpeaks 400 5))
					(else
						(= local162 50)
						(= local163 50)
						(ego setMotion: 0)
						(HighPrint 400 6 80 {Guard:})
					)
				)
			)
			(
				(and
					(or
						(and (== (eunuch loop?) 0) (< (eunuch x?) (ego x?)))
						(and (== (eunuch loop?) 1) (> (eunuch x?) (ego x?)))
						(< (ego distanceTo: eunuch) 45)
					)
					(cast contains: eunuch)
					(< (ego y?) 60)
					(> (eunuch x?) 19)
					(< (eunuch x?) 314)
					(not local241)
				)
				(= local241 1)
				(localproc_001a 400 7)
				(eunuch setScript: (ScriptID 401 4))
			)
			((and (> (ego x?) 320) (< (ego y?) 90)) (ego setScript: guardHouse))
			((and (< (ego x?) 0) (< (ego y?) 90))
				(if (ego has: 16)
					(curRoom newRoom: 480)
				else
					(curRoom newRoom: 470)
				)
			)
			(
				(and
					local156
					(> (ego y?) 188)
					(Btst 96)
					(not script)
					local154
					(== local155 0)
				)
				(= local155 1)
				(= local162 0)
				(ego setScript: toPalace)
			)
			(
				(and
					local156
					(> (ego y?) 188)
					(Btst 96)
					(not script)
					(not local154)
				)
				(= local162 0)
				(ego setMotion: 0 posn: (ego x?) (- (ego y?) 5))
				(= local154 1)
				(DjinniSpeaks 400 8)
			)
			((and (== local156 1) (> (ego y?) 189)) (= gTopExit 2) (curRoom newRoom: 460))
		)
		(if (and local163 (ego script?))
			(= local163 0)
			(= local162 0)
		)
		(super doit:)
	)
	
	(method (dispose)
		(= gLevMe (= gGetBellows 0))
		(localproc_0243)
		(DisposeScript 401)
		(Bclr 96)
		(= defaultPalette 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(HighPrint 400 9)
			)
			(
				(or
					(Said 'lockpick[/lock]')
					(Said 'use/(lockpick[<lock]),lockpick')
					(Said 'unlock')
				)
				(cond 
					((not (CanPickLocks 1)))
					(
					(or (cast contains: rGuard1) (cast contains: rGuard2)) (HighPrint 400 10))
					(else (ego setScript: (ScriptID 401 7)))
				)
			)
			((Said 'force,break,beat/gate,door')
				(if
				(or (cast contains: rGuard1) (cast contains: rGuard2))
					(HighPrint 400 10)
				else
					(ego setScript: (ScriptID 401 8))
				)
			)
			((Said 'cast/levitate,fly,(spell<levitate,fly)')
				(cond 
					((and (< (ego y?) 130) (> (ego y?) 100)) (HighPrint 400 11))
					(
					(and (== currentDay 30) isNightTime (< (ego y?) 90)) (DjinniSpeaks 400 12))
					(
						(and
							local159
							local160
							(> (eunuch x?) 19)
							(< (eunuch x?) 314)
							(cast contains: rGuard1)
						)
						(eunuch setScript: badLevitate)
					)
					(
						(not
							(if
								(or
									(ego inRect: 22 133 47 150)
									(ego inRect: 81 133 109 150)
									(ego inRect: 211 133 241 150)
								)
							else
								(ego inRect: 270 133 302 150)
							)
						)
						(HighPrint 400 13)
					)
					((CastSpell 28) (ego setScript: (ScriptID 62 0)))
				)
			)
			((or (Said 'throw/dagger') (Said 'cast'))
				(if
				(and (== currentDay 30) isNightTime (< (ego y?) 90))
					(DjinniSpeaks 400 14)
					(pEvent claimed: 1)
				else
					(pEvent claimed: 0)
				)
			)
			(
			(and (== currentDay 30) isNightTime (Said 'hop[<down]'))
				(if (> (ego y?) 90)
					(DjinniSpeaks 400 15)
				else
					(DjinniSpeaks 400 16)
				)
			)
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(if (not (if (== currentDay 30) isNightTime))
					(HighPrint 400 17)
				else
					(ego setScript: (ScriptID 61 2))
				)
			)
			((Said 'attack[/guard]')
				(cond 
					((< (ego y?) 90) (DjinniSpeaks 400 18))
					(
						(and
							(not (cast contains: rGuard1))
							(not (cast contains: rGuard2))
						)
						(HighPrint 400 19)
					)
					(
					(and (<= 0 currentTimeZone) (<= currentTimeZone 4)) (HighPrint 400 20))
					((and (== currentDay 30) isNightTime)
						(= local162 0)
						(= local236 1)
						(cond 
							(local157 (rGuard2 setScript: letsFight))
							(local158 (rGuard1 setScript: letsFight))
							(else
								(rGuard1 setScript: 0)
								(rGuard2 setScript: 0)
								(self setScript: fightScript)
							)
						)
						(if (cast contains: eunuch)
							(eunuch setScript: (ScriptID 401 5))
						)
					)
					(else (HighPrint 400 21))
				)
			)
			((Said 'climb,scale') (HighPrint 400 22))
			((and (Said 'look,examine<at/djinn') (Btst 96)) (HighPrint 400 23))
			((Said 'open,open/gate,door')
				(cond 
					((> (ego distanceTo: leftDr) 40) (HighPrint 400 24))
					((not (if local157 local158)) (HighPrint 400 25))
					(else (HighPrint 400 26))
				)
			)
			((Said 'ask/djinn')
				(cond 
					((Btst 96) (DjinniSpeaks 400 27))
					((and (== currentDay 30) isNightTime) (DjinniSpeaks 400 28))
				)
			)
			((Said 'ask[/guard]')
				(if
				(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
					(localproc_02e0)
				else
					(= local162 4)
				)
			)
			((Said 'look,examine<up')
				(if isNightTime
					(HighPrint 400 29)
				else
					(HighPrint 400 30)
				)
			)
			((Said 'look,examine<down') (HighPrint 400 31))
		)
	)
	
	(method (notify param1)
		(return
			(switch param1
				(59
					(DjinniSpeaks 400 32)
					(return 0)
				)
				(60
					(HighPrint 400 33 80 {Too Tired to Win})
					(curRoom newRoom: 790)
					(return 1)
				)
				(61
					(HighPrint 400 34 80 {Alas, Poor Hero})
					(curRoom newRoom: 790)
					(return 1)
				)
				(else  (return 0))
			)
		)
	)
)

(instance eunuch of TargActor
	(properties
		x 15
		y 58
		noun '/(man[<fat]),eunuch'
		description {the eunuch walking the parapet}
		lookStr {A eunuch patrols the parapet.}
		view 532
		priority 2
		cycleSpeed 1
		illegalBits $0000
		xStep 2
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 9)
			(= local162 4)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (hurtMe)
		(self setScript: (ScriptID 401 2))
		(return 1)
	)
)

(instance rGuard1 of TargActor
	(properties
		noun '/guard[<left]'
		description {the guard at the gates}
		lookStr {The guards stand motionless at the gates.}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 9)
			(if
			(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
				(localproc_02e0)
			else
				(= local162 4)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (cue)
		(= local157 1)
		(super cue:)
	)
	
	(method (calmMe)
		(HighPrint 400 36)
		(= local160 1)
		(return 1)
	)
	
	(method (dazzleMe)
		(return
			(cond 
				(local238 (return 0))
				((not local157)
					(self setScript: (ScriptID 401 3))
					(= local238 400)
					(= local161 1)
					(return 1)
					(if
						(and
							(cast contains: eunuch)
							(> (eunuch x?) 19)
							(< (eunuch x?) 314)
						)
						(eunuch setScript: holler)
					)
				)
				(else (return 0))
			)
		)
	)
	
	(method (hurtMe param1 param2)
		(= local240 (param2 type?))
		(if (not local157)
			(if local238 (HighPrint 400 35))
			(if
				(and
					(cast contains: eunuch)
					(> (eunuch x?) 19)
					(< (eunuch x?) 314)
				)
				(eunuch setScript: holler)
			)
			(if (== script guardAttack) (SetControl 0))
			(self setScript: guardZapped self)
		)
		(return
			(if (not local158)
				(if (== local240 5)
					(= local159 1)
					(rGuard2 setScript: letsFight)
				else
					(rGuard2 setScript: guardAttack)
				)
				(return 1)
			else
				(return 0)
			)
		)
	)
)

(instance rGuard2 of TargActor
	(properties
		x 205
		y 111
		noun '/guard<right'
		description {the guard at the gates}
		lookStr {The guards stand motionless at the gates.}
		view 383
		loop 6
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 9)
			(if
			(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
				(localproc_02e0)
			else
				(= local162 4)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (cue)
		(= local158 1)
		(super cue:)
	)
	
	(method (hurtMe param1 param2)
		(= local240 (param2 type?))
		(if (not local158)
			(if local238 (HighPrint 400 35))
			(if
				(and
					(cast contains: eunuch)
					(> (eunuch x?) 19)
					(< (eunuch x?) 314)
				)
				(eunuch setScript: holler)
			)
			(if (== script guardAttack) (SetControl 0))
			(self setScript: guardZapped self)
		)
		(return
			(if (not local157)
				(if (== local240 5)
					(= local159 1)
					(rGuard1 setScript: letsFight)
				else
					(rGuard1 setScript: guardAttack)
				)
				(return 1)
			else
				(return 0)
			)
		)
	)
)

(instance leftDr of TargActor
	(properties
		x 133
		y 109
		noun '/door'
		description {the gate}
		lookStr {The doors are massive.}
		view 460
		loop 1
		priority 7
		signal $0010
	)
	
	(method (init)
		(if isNightTime (= palette 4) else (= palette 3))
		(super init:)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(cond 
					((> (ego distanceTo: self) 40) (HighPrint 400 24))
					(
					(or (cast contains: rGuard1) (cast contains: rGuard2)) (HighPrint 400 10))
					(else (HighPrint 400 39) (ego setScript: (ScriptID 401 8)))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (detectMe)
		(Print 400 38)
		(return 1)
	)
	
	(method (hurtMe)
		(return
			(if (cast contains: rGuard1)
				(if (or local161 local160)
					(return 0)
				else
					(= local162 5)
				)
			else
				(return 0)
			)
		)
	)
	
	(method (openMe)
		(return
			(if
				(or
					local161
					(and
						(not (cast contains: rGuard1))
						(not (cast contains: rGuard2))
					)
				)
				(leftDr setCycle: End)
				(rightDr setCycle: End)
				(return 1)
			else
				(HighPrint 400 37)
			)
		)
	)
)

(instance rightDr of TargActor
	(properties
		x 189
		y 109
		noun '/gate'
		description {the gate}
		lookStr {The doors are massive.}
		view 460
		loop 2
		priority 7
		signal $0010
	)
	
	(method (init)
		(if isNightTime (= palette 4) else (= palette 3))
		(super init:)
	)
	
	(method (doVerb)
		(leftDr doVerb: &rest)
	)
	
	(method (detectMe)
		(leftDr detectMe: &rest)
	)
	
	(method (hurtMe)
		(leftDr hurtMe: &rest)
	)
	
	(method (openMe)
		(leftDr openMe: &rest)
	)
)

(instance rGuard3 of Actor
	(properties
		x 45
		y 160
		description {the marching guard in front of the gates}
		lookStr {The guards march ceaselessly before the gates to the Palace.}
		view 382
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 9)
			(localproc_02e0)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance rGuard4 of Actor
	(properties
		x 290
		y 153
		description {the pacing guard in front of the gates}
		lookStr {The guards march ceaselessly before the gates to the Palace.}
		view 382
		loop 1
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 9)
			(localproc_02e0)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance scarf of Actor
	(properties
		x 57
		y 54
		noun '/scarf'
		description {the scarf}
		lookStr {It's a scarf left by the harem girl to show the way.}
		view 460
		priority 10
		signal $0010
		cycleSpeed 1
	)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)

(instance poly2 of Polygon
	(properties
		type $0002
	)
)

(instance poly3 of Polygon
	(properties
		type $0002
	)
)

(instance poly4 of Polygon
	(properties
		type $0002
	)
)

(instance toPalace of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setCycle: Walk
					setMotion: MoveTo (ego x?) (- (ego y?) 15) self
				)
				(DjinniSpeaks 400 40)
			)
			(1
				(= local155 0)
				(self dispose:)
			)
		)
	)
)

(instance comeIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo (ego x?) 181 self)
			)
			(1
				(= local156 1)
				(self dispose:)
			)
		)
	)
)

(instance guardPace of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(rGuard3 setCycle: Walk)
				(rGuard4 setCycle: Walk)
				(= cycles 1)
			)
			(1
				(rGuard3 setMotion: MoveTo 290 160)
				(rGuard4 setMotion: MoveTo 45 153 self)
			)
			(2
				(rGuard3 setMotion: MoveTo 45 160)
				(rGuard4 setMotion: MoveTo 290 153 self)
			)
			(3 (self changeState: 1))
		)
	)
)

(instance ropeMe of Script
	(properties)
	
	(method (doit)
		(if (== (ego z?) 57) (ego setScript: overWall))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (and local157 local158)
					(ego setMotion: PolyPath 27 147 self)
				else
					(HighPrint 400 41 103 25 3)
					(cond 
						((> (ego x?) 219) (ego setMotion: MoveTo 242 184 self))
						((> (ego x?) 77) (ego setMotion: MoveTo 67 184 self))
						(else (ego setMotion: MoveTo 9 170 self))
					)
				)
			)
			(1
				(cond 
					((and local157 local158) (ego setHeading: 45 self))
					((> (ego x?) 13) (ego setMotion: MoveTo 9 170 self))
					(else (self cue:))
				)
			)
			(2
				(if (and local157 local158)
					(self changeState: 4)
				else
					(ego setMotion: MoveTo 27 147 self)
				)
			)
			(3 (ego loop: 6) (= cycles 1))
			(4 (caller cue:))
		)
	)
)

(instance overWall of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: climbPost self)
			)
			(1
				(UnlockEgo)
				(if (> (ego x?) 160)
					(proc1_19)
					(ego setCycle: Walk setMotion: MoveTo 271 57 self)
				else
					(= cycles 1)
				)
			)
			(2
				(if (> (ego x?) 160)
					(ego setLoop: 4)
				else
					(ego setLoop: 5)
				)
				(localproc_0068)
				(= seconds 1)
			)
			(3
				(ego
					view: 31
					setLoop: (if (> (ego x?) 160) 0 else 1)
					cel: 0
					setPri: 2
					cycleSpeed: 1
					setCycle: CT 5 1
				)
				((ScriptID 61 1) hide:)
				(= cycles 1)
			)
			(4
				((ScriptID 61 1)
					posn: ((ScriptID 61 0) x?) 24
					cel: 5
					setPri: 13
					show:
				)
				((ScriptID 61 0) dispose:)
				(= cycles 1)
			)
			(5
				((ScriptID 61 1) setCycle: Beg)
				(curRoom setScript: disposeRope self)
			)
			(6
				(ego cycleSpeed: 1 setCycle: Beg)
				((ScriptID 61 1) dispose:)
				(= cycles 6)
			)
			(7
				(LockEgo)
				(proc1_19)
				(ego loop: 4 illegalBits: -32768)
				(self dispose:)
			)
		)
	)
)

(instance guardAttack of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetControl 1)
				(client view: 382 loop: 2 illegalBits: 0)
				(if (< (client x?) (ego x?))
					(client
						setCycle: Walk
						setMotion: PolyPath (- (ego x?) 20) (- (ego y?) 15) self
					)
				else
					(client
						setCycle: Walk
						setMotion: PolyPath (+ (ego x?) 20) (- (ego y?) 15) self
					)
				)
			)
			(1
				(FaceObject client ego)
				(= seconds (- 5 arcadeDifficultyLevel))
			)
			(2
				(if (cast contains: eunuch) (localproc_001a 400 42))
				(ego setMotion: 0)
				(curRoom setScript: guardsRushIn)
			)
		)
	)
)

(instance guardHouse of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setLoop: 0 setMotion: MoveTo 50 (ego y?))
				(if (cast contains: eunuch)
					(eunuch setMotion: 0 setCycle: 0 setLoop: 0)
				)
				(= cycles 9)
			)
			(1
				(localproc_01a2)
				(= seconds 4)
			)
			(2
				(ego setMotion: 0)
				(if (Btst 138)
					(Die
						1
						{By golly, you discovered the tower guard house.__Guess you should have tried the side with the scarf._}
						80
						{Yikes!!!}
					)
				else
					(Die
						1
						{By golly, you discovered the tower guard house.}
						80
						{Yikes!!!}
					)
				)
			)
		)
	)
)

(instance guardZapped of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setCycle: 0 setMotion: 0)
				(client
					illegalBits: 0
					setPri: 8
					signal: 16384
					view: 381
					setLoop: 2
					cel: 1
					posn: (- (client x?) 10) (+ (client y?) 10)
				)
				(= cycles 1)
			)
			(1
				(client
					cel: 2
					posn: (- (client x?) 8) (- (client y?) 13)
				)
				(= cycles 1)
			)
			(2
				(client
					cel: 3
					posn: (- (client x?) 16) (+ (client y?) 14)
				)
				(= cycles 1)
			)
			(3
				(proc401_10 client)
				(client ignoreActors: 0 addToPic:)
				(self dispose:)
			)
		)
	)
)

(instance guardsRushIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
					(and
						(> (ego x?) 119)
						(< (ego x?) 203)
						(> (ego y?) 110)
						(< (ego y?) 142)
					)
					(ego setMotion: MoveTo 159 144)
				else
					(ego setMotion: 0 setCycle: 0)
				)
				(= local161 1)
				(eunuch setMotion: 0 setCycle: 0)
				(= cycles 6)
			)
			(1
				(if (== (leftDr cel?) 0)
					(leftDr setCycle: End)
					(rightDr setCycle: End self)
				else
					(self cue:)
				)
			)
			(2
				(if (>= global105 40)
					(localproc_0283)
					(= seconds 6)
				else
					(localproc_01f2)
					(= seconds 2)
				)
			)
			(3
				(HighPrint 400 43)
				(= cycles 2)
			)
			(4 (Print 400 44) (= cycles 2))
			(5
				(SetControl 0)
				(curRoom newRoom: 790)
				(self dispose:)
			)
		)
	)
)

(instance badLevitate of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HighPrint 400 45 80 {Guard:})
				(= cycles 2)
			)
			(1
				(if (> (eunuch x?) 316)
					(eunuch
						view: 533
						loop: 0
						cel: 0
						mover: 0
						setCycle: End self
					)
				else
					(FaceObject eunuch ego)
					(= cycles 2)
				)
			)
			(2
				(if (== (eunuch view?) 533)
					(eunuch loop: 1 setCycle: Fwd)
				else
					(eunuch setMotion: 0 setCycle: 0)
				)
				(localproc_001a 400 46 25 5)
				(= seconds 1)
			)
			(3
				(ego setScript: guardsRushIn)
				(self dispose:)
			)
		)
	)
)

(instance holler of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(eunuch setMotion: 0)
				(FaceObject eunuch ego)
				(= seconds 2)
			)
			(1
				(localproc_001a 400 47)
				(= cycles 2)
			)
			(2 (self changeState: 4))
			(3
				(localproc_001a
					(Format @local3 400 0 [local191 local197])
					(++ local239)
				)
				(= seconds 4)
			)
			(4
				(if (< local197 5) (++ local197) else (= local197 0))
				(++ global305)
				(self changeState: 3)
			)
		)
	)
)

(instance climbPost of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local0
					(cond 
						((and (<= 23 (ego x?)) (<= (ego x?) 40)) 0)
						((and (<= 83 (ego x?)) (<= (ego x?) 106)) 1)
						((and (<= 214 (ego x?)) (<= (ego x?) 247)) 2)
						((and (<= 278 (ego x?)) (<= (ego x?) 309)) 3)
					)
				)
				(ego
					view: 6
					setLoop: (if (== local0 3) 7 else 6)
					cel: 0
					illegalBits: 0
					setPri: 10
					x:
					(switch local0
						(0 43)
						(1 102)
						(2 232)
						(3 281)
					)
					y:
					(switch local0
						(0 83)
						(1 83)
						(2 83)
						(3 83)
					)
					z: 0
					setCycle: End self
				)
			)
			(1
				(ego
					view: 410
					loop: 0
					cel: 6
					x:
					(switch local0
						(0 62)
						(1 128)
						(2 258)
						(3 260)
					)
					y:
					(switch local0
						(0 84)
						(1 84)
						(2 84)
						(3 84)
					)
				)
				(= cycles 3)
			)
			(2
				(ego
					cel: 5
					x:
					(switch local0
						(0 60)
						(1 125)
						(2 254)
						(3 254)
					)
					y:
					(switch local0
						(0 87)
						(1 87)
						(2 87)
						(3 87)
					)
				)
				(= cycles 3)
			)
			(3
				(ego
					cel: 4
					setPri: 8
					x:
					(switch local0
						(0 60)
						(1 125)
						(2 255)
						(3 255)
					)
					y:
					(switch local0
						(0 85)
						(1 85)
						(2 85)
						(3 85)
					)
				)
				(= cycles 3)
			)
			(4
				(ego
					cel: 3
					x:
					(switch local0
						(0 56)
						(1 121)
						(2 250)
						(3 250)
					)
					y:
					(switch local0
						(0 86)
						(1 86)
						(2 86)
						(3 86)
					)
				)
				(= cycles 3)
			)
			(5
				(ego
					view: 0
					loop: 5
					cel: 3
					x:
					(switch local0
						(0 48)
						(1 113)
						(2 241)
						(3 241)
					)
					y:
					(switch local0
						(0 56)
						(1 56)
						(2 56)
						(3 56)
					)
				)
				(= cycles 3)
			)
			(6
				(LockEgo)
				(proc1_19)
				(if
					(and
						(!= client overWall)
						(or
							(and (== (eunuch loop?) 1) (> (eunuch x?) (ego x?)))
							(cast contains: eunuch)
						)
						(< (ego distanceTo: eunuch) 40)
					)
					(eunuch setScript: (ScriptID 401 4))
				)
				(self dispose:)
			)
		)
	)
)

(instance levitateMe of Script
	(properties)
	
	(method (doit)
		(if (== (ego z?) 63)
			(= local162 0)
			(ego illegalBits: 0 setScript: climbPost)
		)
		(super doit:)
	)
	
	(method (changeState)
		(caller cue:)
	)
)

(instance fightScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (cast contains: rGuard2))
					(rGuard1
						view: 382
						loop: 0
						illegalBits: 0
						setCycle: Walk
						setMotion: MoveTo 177 141 self
					)
				else
					(rGuard2
						view: 382
						loop: 2
						setCycle: Walk
						setMotion: MoveTo 177 141 self
					)
					(HighPrint 400 48 80 {Other Guard:} 103 25 4)
					(= global312 1)
				)
				(if (cast contains: rGuard2)
					(ego setMotion: MoveTo 145 159 self)
				)
			)
			(1
				(if (not (cast contains: rGuard2)) (self cue:))
			)
			(2
				(if (not (cast contains: rGuard2))
					(FaceObject rGuard1 ego)
				else
					(FaceObject ego rGuard2 1)
				)
				(= cycles 6)
			)
			(3
				(if (cast contains: rGuard2)
					(ego
						view: (if (or (ego has: 4) (ego has: 24)) 83 else 84)
						loop: 0
						cel: 0
						cycleSpeed: 2
						setCycle: End self
					)
				else
					(self cue:)
				)
			)
			(4
				(if (not (cast contains: rGuard2))
					(rGuard1 dispose:)
					((ScriptID 401 0) show:)
					(self dispose:)
				else
					((= local234 (ScriptID 401 0))
						barMessage: 0
						posn: 175 142
						opponent: (= local235 (ScriptID 32 0))
					)
					(local235
						barMessage: 0
						posn: 145 152
						setPri: 11
						opponent: local234
						initCombat:
						loop: 8
						cel: 3
						setCycle: Beg self
					)
					(ego hide:)
				)
				(self cue:)
			)
			(5
				(if (not (cast contains: rGuard2))
					(rGuard1 dispose:)
				else
					(rGuard2 dispose:)
				)
				(local234 initCombat:)
				(self dispose:)
			)
		)
	)
)

(instance letsFight of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					view: 382
					loop: 0
					ignoreActors:
					illegalBits: 0
					setCycle: Walk
					setMotion: MoveTo 177 141 self
				)
			)
			(1
				(HighPrint 400 49 80 {Guard:})
				(= cycles 6)
			)
			(2
				(HighPrint 400 50)
				(ego setMotion: MoveTo 145 159 self)
			)
			(3
				(FaceObject ego client 1)
				(= cycles 2)
			)
			(4
				(ego
					view: (if (or (ego has: 4) (ego has: 24)) 83 else 84)
					loop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(5
				((= local234 (ScriptID 401 0))
					barMessage: 0
					posn: 175 142
					opponent: (= local235 (ScriptID 32 0))
				)
				(local235
					barMessage: 0
					posn: 145 152
					setPri: 11
					opponent: local234
					initCombat:
					loop: 8
					cel: 3
					setCycle: Beg self
				)
				(ego hide:)
			)
			(6
				(= global312 0)
				(client hide:)
				(local234 initCombat:)
				(self dispose:)
			)
		)
	)
)
