;;; Sierra Script 1.0 - (do not remove this comment)
(script# 410)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use n065)
(use TargActor)
(use VerbMessager)
(use Feature)
(use LoadMany)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm410 0
)

(local
	local0
	local1
	local2
	local3
	local4
	[local5 5] = [222 175 135 95 210]
	local10
	local11
	local12
	local13
	local14
	local15
	local16 =  1
	local17
	local18
	local19
	local20
)
(procedure (localproc_0b6a)
	(ego setMotion: 0)
	(cond 
		((not local19) (HighPrint 410 20) (HighPrint 410 21) (= local19 1))
		((curRoom script?))
		(else (HighPrint 410 20))
	)
	(if local12
		(= local12 0)
	else
		(curRoom
			setScript:
				(switch (++ local10)
					(1 rollBackS)
					(2 rollFrontS)
					(3 sitUpS)
					(4 sitAndSpeakS)
					(5 getUpS)
				)
		)
	)
)

(procedure (localproc_1c18)
	(door cel: 1 setCycle: End)
	(SetUpEgo)
	(HighPrint 410 37)
	(HighPrint 410 38)
	(curRoom setScript: sitAndSpeakS)
)

(procedure (localproc_1c4d)
	(return
		(cond 
			(
			(and (ego mover?) (not local18) (curRoom script?))
				(HighPrint 410 39)
				(= local11 2)
				(= local18 1)
				(return 1)
			)
			((and local11 (ego mover?) (not (-- local11))) (= local11 4) (localproc_0b6a) (return 1))
			(else (return 0))
		)
	)
)

(instance rm410 of Rm
	(properties
		picture 410
		style $0009
	)
	
	(method (init)
		(LoadMany 128 2 47 410 7)
		(LoadMany 132 410 20)
		(User verbMessager: myVerbs)
		(AddToScore 710 3 2)
		(super init:)
		(DrawFeature cabinet sofa)
		(= local20 (/ [skills 4] 5))
		(bird init: stopUpd:)
		(door init: stopUpd:)
		(guard init: stopUpd:)
		(khav init: stopUpd: setScript: snoreS)
		(= local11 6)
		(win init:)
		(bed init:)
		(tassle init:)
		(curtains init:)
		(weap1 init:)
		(gCMusic number: 410 loop: -1 priority: 0 playBed:)
		(= gGDftSC gAllSC)
		(self setScript: inWinS)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(cond 
			((and (not local0) (< (ego x?) [local5 0]))
				(= local0 1)
				(if (not (TestSkill 8 0 (+ 15 local20)))
					(localproc_0b6a)
				)
			)
			((and (not local1) (< (ego x?) [local5 1]))
				(= local1 1)
				(if (not (TestSkill 8 0 (+ 8 local20)))
					(localproc_0b6a)
				)
			)
			((and (not local2) (< (ego x?) [local5 2])) (= local2 1) (localproc_0b6a))
			((and (not local3) (< (ego x?) [local5 3]))
				(= local3 1)
				(if (not (TestSkill 8 0 (+ 5 local20)))
					(localproc_0b6a)
				)
			)
			(
			(and (not local4) (> (ego x?) [local5 4]) [invNum 47])
				(= local4 1)
				(if (not (TestSkill 8 0 (+ 12 local20)))
					(localproc_0b6a)
				)
			)
			((& (ego onControl: 1) $0002) (Die 1 410 0 80 {Fatal Distractions}))
			(
				(and
					local11
					(ego mover?)
					(!= egoWalkMode 2)
					(not (-- local11))
				)
				(localproc_0b6a)
				(= local11 4)
			)
			(
				(and
					[invNum 47]
					(ego inRect: 207 126 288 137)
					(not global161)
				)
				(self setScript: outWinS)
			)
			((== local13 -1) (= local13 (Btst 87)))
			((and local13 (not (Btst 87)))
				(if local14
					(Die 1 410 1 80 {Aggression was the death of you})
				else
					(Die 1 410 2 80 {Aggression was the death of you})
				)
			)
		)
	)
	
	(method (dispose)
		(gCMusic fade:)
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 410 3))
			((Said 'look,examine/floor') (HighPrint 410 4))
			((Said 'look,examine/woman') (HighPrint 410 5))
			((Said 'look,examine/hinge')
				(ego setMotion: 0)
				(cond 
					((not (if (< (ego x?) 76) (< (ego y?) 151))) (HighPrint 410 6))
					(local15 (ego loop: 3) (SetUpEgo) (HighPrint 410 7))
					(else (ego loop: 3) (SetUpEgo) (HighPrint 410 8))
				)
			)
			(
				(or
					(Said 'grease/hinge,door,armoire')
					(Said 'use/grease')
				)
				(cond 
					((not (if (< (ego x?) 76) (< (ego y?) 151))) (PrintNotCloseEnough))
					(local15 (PrintAlreadyDoneThat))
					((not [invNum 42]) (HighPrint 410 9))
					(else (AddToScore 712 3 2) (ego setScript: oilHingesS))
				)
			)
			((Said 'lockpick/lock')
				(cond 
					((not (CanPickLocks 1)))
					((not (if (< (ego x?) 76) (< (ego y?) 151))) (PrintNotCloseEnough))
					((not local16) (PrintAlreadyDoneThat))
					(else (ego setScript: pickLockS))
				)
			)
			((Said 'break/cup,door') (Die 1 410 10 80 {The Unsubtle Approach}))
			((Said 'kill,attack>')
				(if
					(or
						(Said '/guard')
						(and (< (ego x?) 60) (not (Said '/khaveen')))
					)
					(Die 1 410 11 80 {The Direct Approach})
				else
					(Die 1 410 12 80 {Killing can be Fatal})
				)
				(pEvent claimed: 1)
			)
			((Said 'conceal,duck,(get,acquire<down)')
				(if local17
					(HighPrint 410 13)
				else
					(ego setScript: hideS)
				)
			)
			((Said 'stand,(get,acquire<up)') (if local17 (hideS cue:) else (HighPrint 410 14)))
			((Said 'climb,scale')
				(if (> (ego x?) 200)
					(curRoom setScript: outWinS)
				else
					(PrintNotCloseEnough)
				)
			)
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(if (not magicRopeDuration)
					(HighPrint 410 15)
				else
					(proc65_3 6 ego self 0 0)
				)
			)
			((Said 'throw/dagger,boulder,powder,dust') (= local13 -1) (pEvent claimed: 0))
			((Said 'cast>')
				(if (OneOf (= temp0 (proc65_0 pEvent)) 25 27 22)
					(= local13 -1)
				)
				(pEvent claimed: 0)
			)
		)
	)
	
	(method (cue)
		(curRoom setScript: sitAndSpeakS)
	)
)

(instance inWinS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 410
					x: 247
					y: 134
					setLoop: 0
					cel: 0
					init:
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1
				(= egoWalkMode 0)
				(proc1_19)
				(ego view: 4 posn: 241 136 loop: 5 setHeading: 225)
				(= cycles 14)
			)
			(2
				(ego view: 0)
				(HighPrint 410 16)
				(self dispose:)
			)
		)
	)
)

(instance getBirdS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 64 141 self)
			)
			(1
				(ego setHeading: 0)
				(= cycles 5)
			)
			(2
				(AddToScore 711 5 2)
				(ego get: 47)
				(bird dispose:)
				(= cycles 2)
			)
			(3
				(HighPrint 410 17)
				(self dispose:)
			)
		)
	)
)

(instance oilHingesS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 40 141 self)
			)
			(1
				(ego
					view: 47
					loop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: CT 2 1 self
				)
			)
			(2 (= cycles 14))
			(3 (ego setCycle: Beg self))
			(4
				(proc1_19)
				(ego loop: 6 setHeading: 45)
				(= local15 1)
				(HighPrint 410 18)
				(self dispose:)
			)
		)
	)
)

(instance pickLockS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 64 141 self)
			)
			(1
				(ego setHeading: 0)
				(= cycles 10)
			)
			(2
				(if (PickLock 100 1 1)
					(HighPrint 410 19)
					(= local16 0)
				)
				(self dispose:)
			)
		)
	)
)

(instance openDoorS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 64 141 self)
			)
			(1
				(ego setHeading: 0)
				(door setCycle: End self)
				(if (not local15) (localproc_0b6a))
			)
			(2
				(door stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance closeDoorS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 64 141 self)
			)
			(1
				(ego setHeading: 0)
				(door setCycle: Beg self)
				(if (not local15) (localproc_0b6a))
			)
			(2
				(door stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance outWinS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 244 133 self)
			)
			(1 (ego setHeading: 0 self))
			(2
				(ego
					posn: 238 122
					view: 7
					setLoop: 1
					cel: 1
					cycleSpeed: 2
					setCycle: CT 5 1 self
				)
			)
			(3
				(ego
					view: 410
					setLoop: 0
					cel: 8
					posn: 247 134
					setCycle: Beg self
				)
			)
			(4 (curRoom newRoom: 390))
		)
	)
)

(instance rollBackS of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(localproc_1c4d)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khav
					setScript: 0
					setLoop: 1
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1 (= seconds 4))
			(2 (self dispose:))
		)
	)
)

(instance rollFrontS of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(localproc_1c4d)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (khav setCycle: Beg self))
			(1
				(khav setLoop: 2 cel: 0 cycleSpeed: 1 setCycle: End)
				(= seconds 4)
			)
			(2 (self dispose:))
		)
	)
)

(instance sitUpS of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(cond 
			((localproc_1c4d))
			((and local12 (== state 3)) (= local12 0) (self cue:))
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khav cycleSpeed: 2 setCycle: Beg self)
			)
			(1 (= cycles 6))
			(2
				(khav setLoop: 4 cel: 0 cycleSpeed: 0 setCycle: End self)
			)
			(3
				(if
					(and
						(not local17)
						(ego inRect: 123 147 210 180)
						(not local12)
					)
					(Die 1 410 22 80 {A man who enjoys his work})
				else
					(= seconds 5)
				)
			)
			(4
				(khav cycleSpeed: 1 setCycle: Beg self)
			)
			(5
				(khav setScript: snoreS)
				(self dispose:)
			)
		)
	)
)

(instance sitAndSpeakS of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(localproc_1c4d)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khav setScript: 0 cycleSpeed: 2 setCycle: Beg self)
			)
			(1 (= cycles 6))
			(2
				(khav setLoop: 4 cel: 0 cycleSpeed: 0 setCycle: End self)
			)
			(3
				(if
				(and (not local17) (ego inRect: 123 147 210 180))
					(Die 1 410 22 80 {A man who enjoys his work})
				else
					(Say khav self 410 23)
				)
			)
			(4
				(guard
					view: 410
					posn: 17 126
					setMotion: MoveTo 9 140
					setLoop: 4
					setCycle: End self
				)
			)
			(5 (= cycles 10))
			(6
				(cond 
					(local17 (Say guard self 410 24))
					(local12 (Die 1 410 25))
					(else (Die 1 410 26 80 {A man who enjoys his work}))
				)
			)
			(7 (Say khav self 410 27))
			(8 (= cycles 8))
			(9
				(khav cycleSpeed: 1 setCycle: Beg self)
				(guard setCycle: Beg setMotion: MoveTo 26 123)
			)
			(10
				(hideS cue:)
				(guard stopUpd:)
				(khav setScript: snoreS)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'conceal,duck,(get,acquire<down)')
			(if local17
				(HighPrint 410 13)
			else
				(ego setScript: hideS)
			)
		else
			(pEvent claimed: 1)
		)
	)
)

(instance getUpS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khav setScript: 0 setLoop: 3 setCycle: CT 2 1 self)
			)
			(1 (= cycles 8))
			(2
				(khav setPri: 4 cycleSpeed: 1 setCycle: End self)
			)
			(3
				(guard
					view: 410
					setLoop: 4
					setCycle: End self
					posn: 17 126
					setMotion: MoveTo 9 140
				)
			)
			(4
				(Die 1 410 26 80 {A man who enjoys his work})
			)
		)
	)
)

(instance snoreS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khav setLoop: 0 cel: 0 cycleSpeed: 1 setCycle: End self)
			)
			(1 (= cycles 4))
			(2 (khav setCycle: Beg self))
			(3 (= cycles (Random 30 40)))
			(4 (self changeState: 0))
		)
	)
)

(instance hideS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(= local17 1)
				(ego view: 47 setLoop: 0 cel: 0 setCycle: End self)
			)
			(1 (SetInput 0))
			(2
				(= local17 0)
				(ego setCycle: Beg self)
			)
			(3
				(proc1_19)
				(LockEgo 1)
				(self dispose:)
			)
		)
	)
)

(instance guard of Talker
	(properties
		x 26
		y 123
		description {the guard}
		lookStr {The guard, hidden by the shadows, appears alert despite the late hour.}
		yStep 3
		view 410
		loop 4
		illegalBits $0000
		xStep 4
		tLoop -1
		myName '//guard,man'
		title {Guard:}
		color 15
		back 8
	)
)

(instance khav of Talker
	(properties
		x 145
		y 138
		noun '/khaveen'
		description {the sleeping man}
		lookStr {The man asleep within the bed looks vaguely familiar.}
		view 415
		loop 1
		cycleSpeed 1
		illegalBits $0000
		tLoop -1
		myName '//man,khaveen,nap'
		title {Khaveen:}
		color 7
		back 0
	)
	
	(method (calmMe)
		(= local12 1)
	)
	
	(method (hurtMe)
		(= local14 1)
		(return 1)
	)
)

(instance cabinet of PicView
	(properties
		x 64
		y 139
		noun '/armoire'
		description {the antique cabinet}
		lookStr {The cabinet is old, but well built.}
		view 410
		loop 1
		priority 2
		signal $0010
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(cond 
					((not (if (< (ego x?) 76) (< (ego y?) 151))) (PrintNotCloseEnough))
					((door cel?) (PrintAlreadyDoneThat))
					(local16 (HighPrint 410 28))
					((not local15) (localproc_1c18))
					(else (ego setScript: openDoorS))
				)
			)
			(3
				(cond 
					((not (if (< (ego x?) 76) (< (ego y?) 151))) (PrintNotCloseEnough))
					((not (door cel?)) (HighPrint 410 29))
					(else (ego setScript: closeDoorS))
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
)

(instance bird of TargActor
	(properties
		x 67
		y 102
		noun '/bird,statue,falcon'
		description {the bird statue}
		lookStr {The statue of a bird is intricately carved from some sort of dark crystal.}
		view 410
		loop 2
		priority 3
		signal $1810
		cycleSpeed 1
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7)
			(cond 
				([invNum 47] (HighPrint 410 34))
				((not (if (< (ego x?) 76) (< (ego y?) 151))) (PrintNotCloseEnough))
				((not (door cel?)) (HighPrint 410 35))
				(else (door setScript: getBirdS))
			)
		else
			(super doVerb: theVerb)
		)
	)
	
	(method (fetchMe)
		(cond 
			((and (> (ego x?) 168) (< (ego y?) 178)) (HighPrint 410 30))
			((not (door cel?)) (HighPrint 410 31))
			(else (HighPrint 410 32))
		)
		(return 0)
	)
	
	(method (openMe)
		(cond 
			((door cel?) (HighPrint 410 33))
			((and (> (ego x?) 168) (< (ego y?) 178)) (HighPrint 410 30))
			(else
				(door setCycle: End)
				(if (not local15) (localproc_1c18))
			)
		)
	)
)

(instance door of TargActor
	(properties
		x 51
		y 120
		noun '/door'
		description {the door to the cabinet}
		lookStr {There is nothing special about the cabinet door.}
		view 410
		loop 3
		priority 4
		signal $4010
		cycleSpeed 1
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(cond 
					((not (if (< (ego x?) 76) (< (ego y?) 151))) (PrintNotCloseEnough))
					((door cel?) (PrintAlreadyDoneThat))
					(local16 (HighPrint 410 28))
					((not local15) (localproc_1c18))
					(else (ego setScript: openDoorS))
				)
			)
			(3
				(cond 
					((not (if (< (ego x?) 76) (< (ego y?) 151))) (PrintNotCloseEnough))
					((not (door cel?)) (HighPrint 410 29))
					(else (ego setScript: closeDoorS))
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
	
	(method (openMe)
		(cond 
			(cel (HighPrint 410 33))
			((and (> (ego x?) 168) (< (ego y?) 178)) (HighPrint 410 30))
			(else
				(door setCycle: End)
				(if (not local15) (localproc_1c18))
			)
		)
	)
)

(instance win of Feature
	(properties
		x 232
		y 123
		z 62
		noun '/window'
		nsTop 38
		nsLeft 211
		nsBottom 85
		nsRight 253
		description {the window}
		lookStr {The window you came through looks out onto the plaza.}
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2 (HighPrint 410 36))
			(3 (HighPrint 410 36))
			(8
				(if (> (ego x?) 200)
					(curRoom setScript: outWinS)
				else
					(PrintNotCloseEnough)
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
)

(instance sofa of PicView
	(properties
		x 230
		y 130
		noun '/couch'
		description {the divan}
		lookStr {The divan looks very stylish and uncomfortable.}
		view 410
		loop 5
		priority 3
		signal $0010
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(8
				(if (> (ego x?) 200)
					(curRoom setScript: outWinS)
				else
					(PrintNotCloseEnough)
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
)

(instance bed of Feature
	(properties
		x 149
		y 135
		noun '/bed'
		nsTop 122
		nsLeft 91
		nsBottom 148
		nsRight 208
		description {the bed}
		lookStr {The bed is covered with pillows of various colors.}
	)
)

(instance curtains of Feature
	(properties
		x 149
		y 102
		noun '/curtain'
		nsTop 57
		nsLeft 86
		nsBottom 148
		nsRight 202
		description {the bed curtains}
		lookStr {The bed curtains make it difficult to see the sleeping figure.}
	)
)

(instance weap1 of Feature
	(properties
		x 41
		y 157
		noun '/weapon,wall'
		nsTop 125
		nsBottom 189
		nsRight 83
		description {the weapons on the wall}
		lookStr {Well-worn weapons line the walls, suggesting that their owner enjoys their use.}
	)
	
	(method (onMe param1 param2 &tmp temp0 temp1)
		(if (IsObject param1)
			(= temp0 (param1 x?))
			(= temp1 (param1 y?))
		else
			(= temp0 param1)
			(= temp1 param2)
		)
		(return
			(cond 
				(
					(or
						(and
							(<= nsLeft temp0)
							(<= temp0 nsRight)
							(<= nsTop temp1)
							(<= temp1 nsBottom)
						)
						(and
							(<= 243 temp0)
							(<= temp0 320)
							(<= 141 temp1)
							(<= temp1 190)
						)
					)
				)
				((<= 283 temp0) (if (<= temp0 299) (if (<= 98 temp1) (<= temp1 143))))
			)
		)
	)
)

(instance tassle of Feature
	(properties
		x 142
		y 135
		z 53
		noun '/tassel'
		nsTop 74
		nsLeft 136
		nsBottom 91
		nsRight 148
		description {the decorative tassel}
		lookStr {It is just a decorative tassel.}
	)
)

(instance myVerbs of VerbMessager
	(properties
		ssLook 'look,examine>'
		ssOpen 'open,open>'
		ssClose 'close,shut>'
		ssSmell 'smell>'
		ssMove 'move>'
		ssEat 'eat,chew>'
		ssGet 'get,acquire,grab,(lockpick<up)>'
		ssClimb 'climb,scale>'
		ssTalk 'talk,chat,chat>'
	)
)
