;;; Sierra Script 1.0 - (do not remove this comment)
(script# 430)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Stage)
(use Full)
(use PolyPath)
(use Polygon)
(use Feature)
(use LoadMany)
(use StopWalk)
(use Timer)
(use Grooper)
(use Motion)
(use Actor)

(public
	rm430 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	[local6 50]
	[local56 24] = [42 109 90 109 92 115 56 135 59 139 74 138 134 110 200 114 226 134 251 133 204 98 50 97]
	[local80 34] = [55 62 65 70 82 48 97 66 111 35 131 19 150 51 165 20 189 42 195 67 205 47 213 49 222 58 226 73 236 59 234 13 51 8]
	[local114 18] = [199 71 203 86 209 90 215 88 224 75 225 102 215 114 206 114 198 98]
	[local132 8] = [65 75 65 131 69 131 69 75]
	[local140 8] = [95 70 95 110 99 110 99 70]
	[local148 8] = [194 71 194 109 198 109 198 71]
	[local156 8] = [225 77 225 132 229 132 228 76]
	[local164 8] = [111 118 183 118 216 151 78 151]
	[local172 38] = [12 13 14 11 11 11 11 11 11 15 16 17 18 11 19 20 21 11 22 11 11 23 24 25 26 11 11 11 11 11 27 11 28 11 11 11 11 11]
	[local210 24] = [0 '//khaveen' 1 '//marry' 2 '//puppet' 3 '//clothes' 4 '//woman,mayzun' 5 '//zayisha' 6 '//ad<ad' 7 '//power' 8 '//control' 9 '//eunuch' 10 '//harem']
	[local234 38] = [8 9 10 7 7 7 7 7 7 11 7 12 13 7 14 15 16 7 7 7 7 7 17 18 19 7 7 7 7 7 20 7 21 7 7 7 7 7]
	[local272 16] = [0 '//ad<ad' 1 '//zayisha,girl' 2 '//marry,khaveen' 3 '//eunuch' 4 '//harem' 5 '//resistance,revolt,revolution,underground' 6 '//forbidden']
)
(instance rm430 of Stage
	(properties
		picture 430
		east 429
		rightFromX 280
		rightFromY 140
		rightExit 3
		rightToX 200
		rightToY 140
	)
	
	(method (init)
		(LoadMany 128 0 4 47 382 383 432 435 436 437 438 440)
		(LoadMany 131 435 432)
		(LoadMany 132 430 431)
		(Bset 138)
		(Bclr 142)
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(= entranceScript enterS)
		(ego init:)
		(proc1_19)
		(super init:)
		(proc1_31 pillar ceiling rightVeil rug)
		(DrawFeature vase)
		(poly1 points: @local56 size: 12)
		(poly2 points: @local80 size: 17)
		(poly3 points: @local114 size: 9)
		(poly4 points: @local132 size: 4)
		(poly5 points: @local140 size: 4)
		(poly6 points: @local148 size: 4)
		(poly7 points: @local156 size: 4)
		(poly8 points: @local164 size: 4)
		(self addObstacle: poly1)
		(gCMusic number: 430 loop: -1 priority: 0 playBed:)
		(zayishah init:)
		(servant init:)
		(veil setCel: (Btst 125) init:)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			(
			(and (& (ego onControl: 1) $0200) (== inOut 3)) (curRoom setScript: byeS))
			((Btst 125)
				(if
				(and (< 45 (ego heading?)) (< (ego heading?) 135))
					(veil setCel: 0)
				else
					(veil setCel: 1)
				)
			)
		)
	)
	
	(method (dispose)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(gCMusic fade:)
		(SetGameTime 16)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 430 0))
			((Said 'kiss/girl')
				(if local2
					(Say zayishah 430 1)
				else
					(HighPrint 430 2)
					(Say zayishah 430 3)
					(= local2 1)
				)
			)
			((Said 'affirmative')
				(if local2
					(Say zayishah 430 4)
					(= local2 0)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'n')
				(cond 
					(local2 (Say zayishah 430 5) (= local2 0))
					(local3 (Say zayishah 430 6))
					(else (pEvent claimed: 0))
				)
			)
			((Said 'use,wear,(put<on)/glasses[<ray]')
				(= local2 0)
				(cond 
					((not (ego has: 54)) (PrintDontHaveIt))
					((Btst 125) (HighPrint 430 7))
					(else
						(if (cast contains: zayishah)
							(HighPrint 430 8)
						else
							(HighPrint 430 9)
						)
						(Bset 125)
						(if local0 (veil setCel: 1))
					)
				)
			)
			((Said '(acquire<off),acquire/glasses[<ray]')
				(= local2 0)
				(cond 
					((not (ego has: 54)) (PrintDontHaveIt))
					((Btst 125) (HighPrint 430 10) (Bclr 125) (veil setCel: 0))
					(else (HighPrint 430 11))
				)
			)
			((Said 'kill,attack,throw,cast')
				(= local2 0)
				(HighPrint 430 12)
				(Say servant 430 13)
				(Die
					1
					430
					14
					80
					{Discretion is the Better Part of Safety}
				)
			)
			(
				(or
					(Said 'gave,barter,(acquire<off),acquire/clothes')
					(Said 'strip,change,affirmative')
				)
				(cond 
					(script (Say zayishah 430 15))
					((ego has: 49)
						(AddToScore 628 5)
						(ego use: 49)
						(= local2 0)
						(waitTimer dispose:)
						(self setScript: stripTeaseS)
					)
					(else (Die 1 430 16 80 {Sheep in Sheik's clothing}))
				)
			)
			((Said 'gave/visa') (Say zayishah 430 17))
		)
	)
)

(instance enterS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local0 1)
				(servant
					setLoop: 2
					setCycle: Walk
					setMotion: MoveTo 110 116 self
				)
				(zayishah
					view: 437
					setLoop: 4
					setCycle: Walk
					setMotion: MoveTo (- (ego x?) 25) (ego y?) self
				)
			)
			(1
				(servant setLoop: 0 setCel: 1)
			)
			(2
				(zayishah view: 435 setLoop: 2 setCel: 0)
				(Say zayishah self 430 18 430 19)
			)
			(3
				(zayishah setCycle: CT 4 1 self)
			)
			(4
				(Say zayishah self 430 20)
				(proc1_32 waitTimer 120)
			)
			(5
				(zayishah setCycle: CT 0 -1 self)
			)
			(6
				(zayishah setCycle: Walk)
				(= local3 1)
				(self dispose:)
			)
		)
	)
)

(instance stripTeaseS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setMotion: MoveTo (+ (zayishah x?) 25) (zayishah y?) self
				)
			)
			(1 (ego setHeading: 270 self))
			(2
				(= local3 0)
				(HighPrint 430 23)
				(Say zayishah self 430 24)
			)
			(3
				(SetInput 0)
				(ego setHeading: 135 self)
				(zayishah
					view: 437
					setLoop: -1
					setMotion: PolyPath 75 120 self
				)
			)
			(4
				(ego view: 438 setLoop: 0 setCel: 0)
				(= local0 0)
				(veil setCel: 0)
			)
			(5
				(gMiscMusic
					number: 431
					loop: 0
					priority: 5
					vol: 100
					play:
				)
				(servant setCel: 0)
				(clothes init:)
				(zayishah
					view: 435
					setLoop: 0
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
				(ego setCycle: End self)
				(= local0 1)
			)
			(6 (veil setCel: (Btst 125)))
			(7
				(zayishah
					setLoop: 1
					setCel: 0
					setCycle: End self
					lookStr:
						{Whoo!__You haven't seen a figure like that since you visited your accountant!}
				)
			)
			(8
				(servant setCel: 1)
				(= cycles 16)
			)
			(9
				(servant setCel: 0)
				(= cycles 8)
			)
			(10
				(servant setLoop: 1 setCycle: Full 5 self)
			)
			(11
				(ego setCycle: Beg self)
				(= local0 0)
			)
			(12
				(veil setCel: 0)
				(= cycles 10)
			)
			(13
				(clothes dispose:)
				(zayishah
					x: (+ (zayishah x?) 7)
					view: 436
					setLoop: 0
					setCel: 0
					setCycle: End self
				)
			)
			(14
				(zayishah
					view: 436
					setLoop: 1
					setCel: 0
					setCycle: End self
				)
			)
			(15
				(zayishah
					view: 436
					setLoop: 2
					setCel: 0
					setCycle: End self
					lookStr: {Is it you or is it Memorex?}
				)
			)
			(16
				(zayishah
					view: 0
					setLoop: -1
					setLoop: Grooper
					cycleSpeed: 0
					setCycle: StopWalk 4
					setMotion: PolyPath (- (ego x?) 40) (ego y?) self
				)
				(proc1_19)
				(veil setCel: (Btst 125))
				(= local0 1)
				(= cycles 1)
			)
			(17 (ego setHeading: 180 self))
			(18 (ego setHeading: 270))
			(19 (Say zayishah self 430 25))
			(20
				(zayishah setHeading: 335 self)
			)
			(21
				(zayishah setHeading: 180 self)
			)
			(22
				(zayishah setHeading: 90 self)
			)
			(23
				(Say zayishah 430 26)
				(= local1 1)
				(proc1_32 visaTimer 60)
			)
			(24
				(zayishah
					setMotion: MoveTo (- (ego x?) 5) (+ (ego y?) 5) self
				)
			)
			(25
				(zayishah setHeading: 0 self)
			)
			(26
				(Say zayishah self 430 27 430 28 430 29)
				(ego get: 46)
				(ego use: 41)
			)
			(27
				(zayishah
					setPri: 10
					setMotion: MoveTo 300 (zayishah y?) self
				)
			)
			(28
				(zayishah dispose:)
				(Say servant self 430 30)
				(AddToScore 629 5)
				(SkillUsed 14 50)
				(proc1_32 servantTimer 120)
			)
			(29 (self dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(local1
				(if (or (Said 'affirmative') (Said 'gave/visa'))
					(if (ego has: 41)
						(visaTimer dispose:)
						(self cue:)
					else
						(Die 1 430 21 80 {Giving Credit where Credit's Due:})
					)
				else
					(pEvent claimed: 1)
					(Say zayishah 430 22)
				)
			)
			(
				(or
					(Said 'use,wear,(put<on)/glasses[<ray]')
					(Said '(acquire<off),acquire/glasses[<ray]')
				)
				(pEvent claimed: 0)
			)
		)
	)
)

(instance guardS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(guard
					init:
					setCycle: Walk
					setMotion: MoveTo 220 140 self
				)
			)
			(1
				(guard view: 383 setLoop: 3 setCel: 0 setCycle: End self)
			)
			(2 (Say guard self 430 31))
			(3 (Say guard self 430 32))
			(4
				(if register
					(HighPrint 430 33)
					(curRoom newRoom: 440)
				else
					(Die 1 430 33 80 {Not a Vacation})
				)
			)
		)
	)
)

(instance byeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego has: 46)
					(FaceObject ego servant)
					(Say servant self 430 34 430 35)
				else
					(Die 1 430 36)
				)
			)
			(1
				(ego setMotion: MoveTo 320 (ego y?))
				(= cycles 10)
			)
			(2 (self dispose:))
		)
	)
)

(instance zayishah of Talker
	(properties
		x 69
		y 158
		description {Zayishah}
		lookStr {Yup, she's a girl alright.}
		view 435
		illegalBits $0000
		tLoop -1
		talkSpeed 1
		myName '//girl,zayisha,woman'
		title {Zayishah:}
		back 11
		msgFile 435
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (Said 'tell/self,hero') (Said 'tell//self,hero')) (= local2 0) (Say self 430 37))
			(
				(or
					(Said 'tell/saurii,arus,emir')
					(Said 'tell//saurii,arus,emir')
				)
				(= local2 0)
				(Say self 430 38)
				(SkillUsed 14 25)
			)
			((Said 'tell') (= local2 0) (Say self 430 39))
		)
	)
	
	(method (respond param1)
		(cond 
			(local1 (param1 claimed: 1) (Say zayishah 430 40))
			((curRoom script?) (param1 claimed: 1) (HighPrint 430 41))
			(else (super respond: param1 &rest))
		)
	)
	
	(method (atSpec param1)
		(return [local210 param1])
	)
	
	(method (atGen param1)
		(return [local172 param1])
	)
)

(instance servant of Talker
	(properties
		x 200
		y 130
		description {Mayzun}
		lookStr {Mayzun is Zayishah's servant.}
		view 432
		illegalBits $0000
		tLoop 3
		talkSpeed 1
		myName '//servant,mayzun,woman'
		title {Mayzun:}
		back 13
		msgFile 432
	)
	
	(method (respond param1)
		(if (curRoom script?)
			(param1 claimed: 1)
			(HighPrint 430 42)
		else
			(super respond: param1 &rest)
		)
	)
	
	(method (atSpec param1)
		(return [local272 param1])
	)
	
	(method (atGen param1)
		(return [local234 param1])
	)
)

(instance guard of Talker
	(properties
		x 280
		y 140
		view 382
		tLoop -1
		talkSpeed 1
		myName '//guard,man'
		title {Guard:}
	)
)

(instance waitTimer of Timer
	(properties)
	
	(method (cue)
		(switch (++ local4)
			(1
				(Say zayishah 430 43)
				(proc1_32 self 60)
			)
			(2
				(Say zayishah 430 44)
				(proc1_32 self 60)
			)
			(3
				(Die 1 430 45 80 {Unwanted Visitors})
			)
		)
	)
)

(instance visaTimer of Timer
	(properties)
	
	(method (cue)
		(curRoom setScript: guardS 0 0)
	)
)

(instance servantTimer of Timer
	(properties)
	
	(method (cue)
		(switch (++ local5)
			(1
				(Say servant 430 46)
				(proc1_32 self 60)
			)
			(2
				(curRoom setScript: guardS 0 1)
			)
		)
	)
)

(instance veil of View
	(properties
		x 82
		y 122
		noun '/screen,veil,curtain'
		description {the veil}
		lookStr {The veil is made of light gauze, just opaque enough to prevent any would-be peepers from seeing anything fun.}
		view 430
		priority 9
		signal $4011
	)
)

(instance clothes of View
	(properties
		x 84
		y 122
		view 440
		cel 1
		signal $4000
	)
)

(instance vase of PicView
	(properties
		x 148
		y 114
		noun '/vase,bouquet,pan,plant'
		description {the vase}
		lookStr {A very ornate vase with beautiful flowers.__Certainly an un-Raseirish sight.}
		view 430
		loop 1
	)
)

(instance pillar of Feature
	(properties
		noun '/column'
		description {the pillars}
		lookStr {The pillars are made of white marble.}
	)
	
	(method (onMe param1)
		(if
			(or
				(AvoidPath (param1 x?) (param1 y?) poly4)
				(AvoidPath (param1 x?) (param1 y?) poly5)
				(AvoidPath (param1 x?) (param1 y?) poly6)
			)
		else
			(AvoidPath (param1 x?) (param1 y?) poly7)
		)
	)
)

(instance ceiling of Feature
	(properties
		noun '/ceiling,roof'
		description {the ceiling}
		lookStr {The ceiling is inlaid with many colorful woods.}
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine<up') (self doVerb: 1))
		)
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) poly2)
	)
)

(instance rightVeil of Feature
	(properties
		noun '/veil'
		description {the veil}
		lookStr {This veil is much like the other.}
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) poly3)
	)
)

(instance rug of Feature
	(properties
		noun '/carpet,carpet,floor'
		description {the rug}
		lookStr {A beautiful hand-woven rug decorates the center of the floor.}
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine<down') (self doVerb: 1))
		)
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) poly8)
	)
)

(instance poly1 of Polygon
	(properties
		type $0000
	)
)

(instance poly2 of Polygon
	(properties
		type $0000
	)
)

(instance poly3 of Polygon
	(properties
		type $0000
	)
)

(instance poly4 of Polygon
	(properties
		type $0000
	)
)

(instance poly5 of Polygon
	(properties
		type $0000
	)
)

(instance poly6 of Polygon
	(properties
		type $0000
	)
)

(instance poly7 of Polygon
	(properties
		type $0000
	)
)

(instance poly8 of Polygon
	(properties
		type $0000
	)
)
