;;; Sierra Script 1.0 - (do not remove this comment)
(script# 470)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use n065)
(use TargActor)
(use n095)
(use Intrface)
(use PolyPath)
(use Feature)
(use LoadMany)
(use Reverse)
(use Chase)
(use Grooper)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm470 0
	youBlewIt 1
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	local6
	local7
	local8
)
(procedure (localproc_000e)
	(DjinniSpeaks 470 0)
)

(procedure (localproc_0018)
	(DjinniSpeaks 470 1 470 2)
)

(procedure (localproc_0027)
	(= local8
		(switch arcadeDifficultyLevel
			(1 120)
			(2 100)
			(3 80)
		)
	)
	(= local7 0)
)

(procedure (localproc_008c)
	(PrintWarning &rest 35 khaveenWindow 80 {Khaveen:})
)

(procedure (localproc_00a1)
	(if (lDoor cel?)
		(localproc_000e)
	else
		(if (not (cast contains: doorTrap))
			(doorTrap init: setCycle: End)
		)
		(rDoor ignoreActors: 1 setCycle: End)
		(lDoor ignoreActors: 1 setCycle: End)
	)
)

(procedure (localproc_00f5)
	(if (not (cast contains: doorTrap))
		(doorTrap init: setCycle: End)
	)
)

(instance khaveenWindow of BotWindow
	(properties
		color 7
		back 0
	)
)

(instance rm470 of Rm
	(properties
		picture 2
		style $0003
	)
	
	(method (init)
		(Load rsPIC 470)
		(LoadMany
			128
			472
			473
			474
			382
			383
			465
			6
			31
			591
			576
			22
			475
			80
			83
		)
		(LoadMany 130 475 62 30 31 32 969 972)
		(AddToScore 666 5 0)
		(= gGDftSC gAllSC)
		(super init:)
		(= useObstacles 1)
		(gCMusic number: 470 loop: -1 priority: 0 playBed:)
		(DjinniSpeaks 470 3)
		(Print 470 4 #width 250)
		(DjinniSpeaks 470 5)
		(curRoom drawPic: 470)
		(ego posn: 0 40 init:)
		(lDoor init:)
		(rDoor init:)
		(aGuard init:)
		(khaveenTalker init:)
		(DrawFeature rope)
		(proc1_31 curtain balcony lowerDoor curtain2 stairs dais)
		(self setScript: enterBalcony)
	)
	
	(method (doit)
		(cond 
			(
			(and (lDoor cel?) (& (ego onControl: 1) $0010)) (curRoom newRoom: 500))
			(
				(and
					(not (if (< (ego x?) 50) (< (ego y?) 80)))
					(not (ego script?))
					(not script)
					(not local4)
				)
				(= local4 1)
				(if (cast contains: khaveenTalker)
					(= local8 0)
					(khaveenTalker setScript: 0 setMotion: 0)
					(FaceObject khaveenTalker ego)
					(if (and (not local1) (not local0))
						(ego setHeading: 45)
					)
					(if (not (ego has: 7)) (= local2 1))
					(self setScript: startFight)
				else
					(if (and local0 (> (ego x?) 50))
						(ego setLoop: -1 setHeading: 45)
					)
					(localproc_0018)
				)
			)
			((not local8))
			((-- local8))
			((and (not script) (not (ego script?)))
				(switch local7
					(0
						(DjinniSpeaks 470 7)
						(++ local7)
						(= local8
							(switch arcadeDifficultyLevel
								(1 120)
								(2 100)
								(3 80)
							)
						)
					)
					(1
						(DjinniSpeaks 470 8)
						(++ local7)
						(= local8 80)
					)
					(2 (ego setScript: youBlewIt))
				)
			)
			(else
				(= local8
					(switch arcadeDifficultyLevel
						(1 120)
						(2 100)
						(3 80)
					)
				)
			)
		)
		(if
			(and
				(or
					(& (ego onControl: 1) $0008)
					(& (ego onControl: 1) $0020)
					(& (ego onControl: 1) $0040)
					(& (ego onControl: 1) $0100)
					(& (ego onControl: 1) $0080)
				)
				(not script)
				(not (ego script?))
			)
			(ego setScript: wrongWay)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(script 0)
			((Said 'sneak')
				(if (and (< (ego x?) 50) (< (ego y?) 80))
					(HighPrint 470 9)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'run')
				(if (and (< (ego x?) 50) (< (ego y?) 80))
					(HighPrint 470 10)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'search,strip/body,khaveen,captain,man')
				(if (Btst 141)
					(if (not local6)
						(DjinniSpeaks 470 11)
						(= local6 1)
					else
						(self setScript: searchBody)
					)
				else
					(HighPrint 470 12)
				)
			)
			((Said 'break,force/door')
				(if
					(or
						(< (ego distanceTo: lDoor) 40)
						(< (ego distanceTo: rDoor) 40)
					)
					(cond 
						((lDoor cel?) (localproc_000e))
						((cast contains: doorTrap) (ego setScript: bustDoor))
						(else (ego setScript: blowDoor))
					)
				else
					(DjinniSpeaks 470 13)
				)
			)
			((Said 'get,acquire/blade,shield,weapon') (DjinniSpeaks 470 14))
			((and (< (ego x?) 50) (< (ego y?) 80))
				(cond 
					(
					(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 470 15))
					((Said 'ask,holler,talk,chat')
						(if (cast contains: khaveenTalker)
							(ego setScript: youBlewIt)
						else
							(HighPrint 470 16)
						)
					)
					((or (Said 'hop') (Said 'get,acquire<down')) (= local0 1) (ego setScript: jumpDown))
					(
					(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
						(HighPrint 470 17)
						(ego setScript: climbDown)
						(= local1 1)
					)
					(
						(or
							(Said
								'get,acquire,grab,(slide,climb,scale<down)/rope,curtain'
							)
							(Said 'get,acquire,climb,scale<down[/!*]')
							(Said 'climb,scale[<down][/!*]')
						)
						(ego setScript: climbDown)
						(= local1 1)
					)
					((Said 'cast>')
						(if (== (proc65_0 pEvent) 28)
							(if (CastSpell 28)
								(ego setScript: levDown)
							else
								(pEvent claimed: 1)
							)
						else
							(pEvent claimed: 0)
							(if (cast contains: khaveenTalker)
								(= temp0 (proc65_0 pEvent))
								(self setScript: whatEgoDid 0 temp0)
							)
						)
					)
					((Said 'throw/dagger,boulder')
						(if (cast contains: khaveenTalker)
							(self setScript: throwDelay)
						)
						(pEvent claimed: 0)
					)
				)
			)
		)
	)
	
	(method (notify param1)
		(switch param1
			(59 (DjinniSpeaks 470 6))
			(58
				(Bset 141)
				(AddToScore 665 15 0)
				(localproc_0027)
			)
			(999 (= local3 1) (= local2 1))
		)
		(return 0)
	)
)

(instance balcony of Feature
	(properties
		x 32
		y 60
		noun '/balcony'
		nsTop 40
		nsBottom 80
		nsRight 65
		description {the balcony}
		lookStr {The balcony overlooks the antechamber to Ad Avis' ritual chamber.}
	)
)

(instance lowerDoor of Feature
	(properties
		x 109
		y 73
		noun '/door'
		nsTop 48
		nsLeft 94
		nsBottom 98
		nsRight 125
		description {the door to the guards' quarters}
		lookStr {This door leads out to the passageways of the Palace.}
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 2)
			(if
				(or
					(< (ego distanceTo: lDoor) 40)
					(< (ego distanceTo: rDoor) 40)
				)
				(cond 
					((lDoor cel?) (localproc_000e))
					((cast contains: doorTrap) (HighPrint 470 18))
					(else (ego setScript: blowDoor))
				)
			else
				(DjinniSpeaks 470 13)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance curtain of Feature
	(properties
		x 14
		y 84
		noun '/curtain,curtain'
		nsTop -1
		nsBottom 169
		nsRight 29
		description {the curtain}
		lookStr {These red drapes match the ones on the other side of the room.}
	)
)

(instance curtain2 of Feature
	(properties
		x 290
		y 25
		noun '/curtain,curtain'
		nsLeft 261
		nsBottom 50
		nsRight 319
		description {the curtains}
		lookStr {These red drapes match the ones on the other side of the room.}
	)
)

(instance stairs of Feature
	(properties
		x 229
		y 73
		noun '/ladder'
		nsTop 55
		nsLeft 148
		nsBottom 91
		nsRight 310
		description {the stairs}
		lookStr {The stairs are not as important as the chamber beyond the top of the stairs.}
	)
)

(instance dais of Feature
	(properties
		x 213
		y 115
		noun '/platform,dais,circle,pizza,simulacrum,(elemental<pizza)'
		nsTop 94
		nsLeft 107
		nsBottom 137
		nsRight 319
		description {the pizza elemental}
		lookStr {Is it...?\nIt is!__It's a simulacrum of the Pizza Elemental!!}
	)
)

(instance doorTrap of Prop
	(properties
		x 195
		y 40
		view 472
		loop 5
		priority 2
		signal $4010
	)
)

(instance lDoor of TargActor
	(properties
		x 178
		y 55
		noun '/door'
		description {the door to Ad Avis' ritual chamber}
		lookStr {It is the door to Ad Avis' ritual chamber.}
		view 472
		priority 1
		signal $0010
		cycleSpeed 1
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 2)
			(if
				(or
					(< (ego distanceTo: lDoor) 40)
					(< (ego distanceTo: rDoor) 40)
				)
				(cond 
					(cel (localproc_000e))
					((cast contains: doorTrap) (HighPrint 470 18))
					(else (ego setScript: blowDoor))
				)
			else
				(DjinniSpeaks 470 13)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (detectMe)
		(HighPrint 470 19)
		(return 1)
	)
	
	(method (hurtMe)
		(localproc_00f5)
		(return 1)
	)
	
	(method (openMe)
		(localproc_00a1)
		(return 1)
	)
	
	(method (triggerMe)
		(localproc_00f5)
		(return 1)
	)
)

(instance rDoor of TargActor
	(properties
		x 214
		y 55
		noun '/door'
		description {the door to Ad Avis' ritual chamber}
		lookStr {It is the door to Ad Avis' ritual chamber.}
		view 472
		loop 1
		priority 1
		signal $0010
		cycleSpeed 1
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 2)
			(if
				(or
					(< (ego distanceTo: lDoor) 40)
					(< (ego distanceTo: rDoor) 40)
				)
				(cond 
					(cel (localproc_000e))
					((cast contains: doorTrap) (HighPrint 470 18))
					(else (ego setScript: blowDoor))
				)
			else
				(DjinniSpeaks 470 13)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (hurtMe)
		(localproc_00f5)
		(return 1)
	)
	
	(method (openMe)
		(localproc_00a1)
		(return 1)
	)
	
	(method (triggerMe)
		(localproc_00f5)
		(return 1)
	)
)

(instance rope of PicView
	(properties
		x 10
		y 142
		noun '/rope'
		description {the rope}
		lookStr {It is the rope that ties the curtains together.}
		view 472
		loop 2
		priority 12
		signal $0010
	)
	
	(method (doVerb theVerb)
		(if (or (== theVerb 7) (== theVerb 8))
			(if (and (< (ego x?) 50) (< (ego y?) 80))
				(ego setScript: climbDown)
				(= local1 1)
			else
				(HighPrint 470 20)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance aGuard of Actor
	(properties
		x 112
		y 98
		noun '/guard,guard,lieutenant'
		description {Khaveen's lieutenant}
		lookStr {It is the Captain of the Raseirian Guards.}
		view 383
		loop 5
		priority 3
		signal $0010
		illegalBits $0000
	)
)

(instance nextGuard of Actor
	(properties
		x 27
		y 246
		noun '/guard,guard'
		description {one of Khaveen's personal guards}
		lookStr {It is one of Khaveen's personal guards.}
		view 382
		illegalBits $0000
	)
)

(instance lastGuard of Actor
	(properties
		x 340
		y 165
		noun '/guard,guard'
		description {one of Khaveen's personal guards}
		lookStr {It is one of Khaveen's personal guards.}
		view 382
		illegalBits $0000
	)
)

(instance khaveenTalker of Talker
	(properties
		x 140
		y 110
		description {Khaveen}
		lookStr {It is Khaveen.}
		view 465
		loop 8
		tLoop -1
		myName '//khaveen,guard,man,captain'
		title {Khaveen:}
		color 7
		back 0
	)
	
	(method (init)
		(super init:)
		(self setLoop: Grooper)
		(= tWindow khaveenWindow)
	)
	
	(method (calmMe)
		(HighPrint 470 21)
		(self setScript: 0 setCycle: Walk illegalBits: 0)
	)
	
	(method (hurtMe)
		(return 1)
	)
	
	(method (openMe)
		(HighPrint 470 22)
		(return 1)
	)
)

(instance enterBalcony of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ChangeEgoWalk 0 0)
				(ego setMotion: MoveTo 40 72 self)
			)
			(1
				(ego setHeading: 45)
				(= cycles 8)
			)
			(2
				(DjinniSpeaks 470 23)
				(self cue:)
			)
			(3
				(Say khaveenTalker self 470 24 470 25)
			)
			(4
				(HighPrint 470 26)
				(aGuard view: 382 setLoop: Grooper setHeading: 315 self)
			)
			(5
				(aGuard setCycle: Walk setMotion: MoveTo 85 90 self)
			)
			(6
				(aGuard dispose:)
				(DjinniSpeaks 470 27)
				(localproc_0027)
				(khaveenTalker setScript: paceAround)
				(self dispose:)
			)
		)
	)
)

(instance callTheGuards of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(curRoom setScript: youBlewIt)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if local3
					(localproc_008c 470 28)
				else
					(localproc_008c 470 29)
				)
				(localproc_008c 470 30)
				(self cue:)
			)
			(1
				(aGuard
					init:
					setCycle: Walk
					setMotion: MoveTo 107 99 self
				)
				(nextGuard init: setCycle: Walk setMotion: MoveTo 75 175)
				(lastGuard init: setCycle: Walk setMotion: MoveTo 268 165)
			)
			(2
				(aGuard setMotion: MoveTo 107 120 self)
			)
			(3 (self dispose:))
		)
	)
)

(instance youBlewIt of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
					(and
						(cast contains: khaveenTalker)
						(or (ego has: 7) (not local4))
					)
					(self cue:)
				else
					(self changeState: 7)
				)
			)
			(1
				(ego setMotion: MoveTo 40 72)
				(if (khaveenTalker script?)
					(khaveenTalker setScript: 0 setMotion: 0)
				)
				(FaceObject khaveenTalker ego)
				(= cycles 5)
			)
			(2
				(khaveenTalker view: 475 setLoop: 0 setCel: 0)
				(= cycles 4)
			)
			(3
				(Say khaveenTalker self 470 31)
			)
			(4
				(DjinniSpeaks 470 32)
				(self cue:)
			)
			(5
				(ego setLoop: 4 setMotion: MoveTo 25 50 self)
			)
			(6
				(aGuard
					x: 0
					y: 40
					init:
					setCycle: Walk
					setMotion: Chase ego 15 self
				)
				(ego setLoop: 7 setMotion: MoveTo 40 70)
				(khaveenTalker
					view: 465
					setLoop: -1
					setCycle: Walk
					setMotion: MoveTo (- (khaveenTalker x?) 30) (khaveenTalker y?)
				)
			)
			(7
				(if (cast contains: khaveenTalker)
					(PrintWarning 470 33)
				else
					(PrintWarning 470 34)
				)
				(DjinniSpeaks 470 35)
				(ShakeScreen 15)
				(= cycles 5)
			)
			(8
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 2)
			)
			(9
				(PrintWarning
					470
					36
					80
					{Whatever you did, it didn't work!}
				)
				(curRoom newRoom: 790)
			)
		)
	)
)

(instance climbDown of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 41 72 self)
			)
			(1
				(ego view: 472 setPri: 15 setLoop: 3 cel: 0 posn: 24 50)
				(= cycles 4)
			)
			(2 (ego setCycle: End self))
			(3
				(ego
					view: 6
					x: 14
					y: 65
					setLoop: 0
					cel: 1
					xStep: 0
					yStep: 5
					setCycle: Rev
					setMotion: MoveTo 14 135 self
				)
			)
			(4
				(ego
					x: (+ (ego x?) 8)
					y: (+ (ego y?) 38)
					setLoop: 1
					setCycle: 0
					cel: 4
				)
				(= cycles 4)
			)
			(5 (ego setCycle: CT 6 1 self))
			(6
				(proc1_19)
				(ego setHeading: 45 self)
			)
			(7
				(localproc_0027)
				(self dispose:)
			)
		)
	)
)

(instance levDown of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(ego setPri: -1 setScript: (ScriptID 62 0))
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 53 73 self)
			)
			(1
				(ego
					view: 472
					loop: 3
					cel: 0
					x: (- (ego x?) 13)
					y: (- (ego y?) 25)
					setPri: 13
					setCycle: End self
				)
			)
			(2
				(ego
					view: 31
					loop: 3
					x: (- (ego x?) 9)
					y: (+ (ego y?) 44 80)
					z: 80
				)
				(self dispose:)
			)
		)
	)
)

(instance jumpDown of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 46 65 self)
			)
			(1
				(ego
					view: 472
					loop: 4
					cel: 0
					setPri: 10
					x: (+ (ego x?) 19)
					setCycle: End self
				)
			)
			(2
				(ego view: 591 loop: 4 cel: 0 x: 72 y: 53 illegalBits: 0)
				(= cycles 1)
			)
			(3
				(ego posn: 89 58)
				(= cycles 1)
			)
			(4
				(SetInput 0)
				(if (ReduceHP 20)
					(ego
						setLoop: 6
						cel: 0
						x: 102
						y: 68
						yStep: 20
						setCycle: Fwd
						setMotion: MoveTo 102 168 self
					)
				else
					(= local5 1)
					(ego
						view: 22
						loop: 0
						cel: 0
						x: 102
						y: 68
						yStep: 16
						setCycle: End
						setMotion: MoveTo 110 145 self
					)
				)
			)
			(5
				(if local5
					(ego setCycle: End)
					(= cycles 15)
				else
					(khaveenTalker setMotion: 0 setScript: 0)
					(FaceObject khaveenTalker ego 1)
					(ego
						setLoop: 2
						cel: 0
						x: 102
						y: 170
						yStep: 2
						xStep: 5
						setMotion: MoveTo 147 170 self
					)
				)
			)
			(6
				(if local5
					(Die
						1
						{With all the damage you took to get here, it's really a shame you couldn't take any more.__You should've tended to your healing, but now it's too late.}
						80
						{You Fell for It}
					)
				else
					(ego heading: 45 setLoop: 6)
					(proc1_19)
					(= cycles 2)
				)
			)
			(7
				(HighPrint 470 38)
				(localproc_0027)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			((Said 'cast>')
				(if (== (proc65_0 pEvent) 28)
					(if (CastSpell 28)
						(= temp0 (- 160 (ego y?)))
						(ego setPri: -1 y: (+ (ego y?) temp0) z: temp0)
						(client setScript: (ScriptID 62 0))
					)
				else
					(Print 470 37)
					(pEvent claimed: 1)
				)
			)
			(else (pEvent claimed: 1))
		)
	)
)

(instance paceAround of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khaveenTalker
					setCycle: Walk
					setMotion: MoveTo (Random 173 307) (Random 97 125) self
				)
			)
			(1
				(khaveenTalker
					setHeading:
						(mod (+ (khaveenTalker heading?) (Random 50 200)) 360)
						self
				)
			)
			(2 (= cycles (Random 15 30)))
			(3 (self changeState: 0))
		)
	)
)

(instance getRidOfKhaveen of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khaveenTalker setMotion: MoveTo 112 98 self)
			)
			(1
				(khaveenTalker setPri: 3 setMotion: MoveTo 85 90 self)
			)
			(2
				(SkillUsed 14 100)
				(AddToScore 680 7 3)
				(DjinniSpeaks 470 39)
				(self cue:)
			)
			(3
				(localproc_0027)
				(khaveenTalker dispose:)
				(self dispose:)
			)
		)
	)
)

(instance bustDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 219 61 self)
			)
			(1
				(ego view: 576 setLoop: 0 cel: 0 setCycle: CT 5 1 self)
			)
			(2
				(ego setCycle: End self)
				(lDoor ignoreActors: 1 setCycle: End)
				(rDoor ignoreActors: 1 setCycle: End)
			)
			(3
				(proc1_19)
				(ego loop: 7)
				(self dispose:)
			)
		)
	)
)

(instance blowDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 200 61 self)
			)
			(1
				(ego view: 472 loop: 6 cel: 0 setCycle: End self)
				(doorTrap init: setCycle: End)
			)
			(2
				(ego view: 22 loop: 0 cel: 0 setCycle: End self)
			)
			(3 (= cycles 6))
			(4
				(if (ReduceHP 15)
					(ego loop: 1 cel: 0 setCycle: End self)
				else
					(Die 1 470 40 80 {So Near And Yet So Far})
				)
			)
			(5 (proc1_19) (self dispose:))
		)
	)
)

(instance wrongWay of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(DjinniSpeaks 470 41)
				(cond 
					((& (ego onControl: 1) $0008) (ego setMotion: MoveTo 40 72 self))
					((& (ego onControl: 1) $0020) (ego setMotion: MoveTo 117 101 self))
					((& (ego onControl: 1) $0040) (ego setMotion: MoveTo (+ (ego x?) 20) (ego y?) self))
					((& (ego onControl: 1) $0100) (ego setMotion: MoveTo (- (ego x?) 20) (ego y?) self))
					((& (ego onControl: 1) $0080) (ego setMotion: MoveTo (ego x?) (- (ego y?) 15) self))
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance throwDelay of Script
	(properties)
	
	(method (doit)
		(if (not (ego script?)) (ego setScript: youBlewIt))
	)
)

(instance whatEgoDid of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (proc65_2 register ego self 0 0))
					(self dispose:)
				)
			)
			(1
				(switch register
					(19
						(if
						(and (cast contains: khaveenTalker) (lDoor cel?))
							(ego setScript: youBlewIt)
						)
					)
					(21
						(if
							(and
								(cast contains: khaveenTalker)
								(cast contains: doorTrap)
							)
							(ego setScript: youBlewIt)
						)
					)
					(24
						(ego setScript: getRidOfKhaveen)
					)
					(25
						(if (cast contains: khaveenTalker)
							(ego setScript: youBlewIt)
						)
					)
					(27
						(if (cast contains: khaveenTalker)
							(ego setScript: youBlewIt)
						)
					)
					(22
						(if (cast contains: khaveenTalker)
							(ego setScript: youBlewIt)
						)
					)
					(26 (DjinniSpeaks 470 42))
				)
				(self dispose:)
			)
		)
	)
)

(instance startFight of Script
	(properties)
	
	(method (doit)
		(if local2
			(= local2 0)
			(curRoom setScript: callTheGuards)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 0 (UnlockEgo) (= cycles 4))
			(1
				1
				(Say khaveenTalker self 470 43 470 44)
			)
			(2
				2
				(khaveenTalker setMotion: MoveTo 165 145 self)
				(if local0 (ego setMotion: MoveTo 143 152 self))
			)
			(3
				3
				(if
				(and local0 (== (ego x?) 143) (== (ego y?) 152))
					(FaceObject ego khaveenTalker)
				else
					(self cue:)
				)
			)
			(4
				4
				(gMiscMusic number: 54 priority: 5 loop: -1 play:)
				(ego
					view: 83
					loop: 0
					cel: 0
					x: (- (ego x?) 8)
					y: (- (ego y?) 2)
					cycleSpeed: 1
					setCycle: End self
				)
				(khaveenTalker view: 475 setLoop: 0 setCel: 0)
			)
			(5
				5
				(if local0
					(self cue:)
				else
					(ego
						view: 473
						setLoop: 1
						cel: 0
						y: (+ (ego y?) 8)
						cycleSpeed: 0
						setCycle: Walk
						setStep: 7 4
						setMotion: MoveTo 59 167 self
					)
				)
			)
			(6
				6
				(if local0
					(self changeState: 11)
				else
					(ego setLoop: 2 cel: 0 x: 91 y: 162)
					(= cycles 2)
				)
			)
			(7
				(ego cel: 1 x: 112 y: 152)
				(= cycles 2)
			)
			(8
				8
				(ego setLoop: 4 cel: 0 x: 135 y: 150)
				(= seconds 2)
			)
			(9
				9
				(ego setCycle: End)
				(khaveenTalker setLoop: 9 cel: 0 setCycle: CT 2 1 self)
			)
			(10
				10
				(ego setCycle: Beg)
				(khaveenTalker setCycle: Beg self)
			)
			(11
				11
				(LockEgo)
				(khaveenTalker dispose:)
				((ScriptID 475 0)
					barMessage: 0
					ignoreActors: 1
					posn: 165 145
					initCombat:
				)
				(Bset 159)
				(ego dispose:)
				((ScriptID 475 1)
					barMessage: 0
					ignoreActors: 1
					posn: 135 150
					setPri: 10
					initCombat:
				)
				(self dispose:)
			)
		)
	)
)

(instance searchBody of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 4])
		(switch (= state newState)
			(0
				(ego setMotion: PolyPath 186 125 self)
			)
			(1 (ego setHeading: 45 self))
			(2
				(ego view: 47 setLoop: 0 setCel: 0 setCycle: End)
				(= cycles 12)
			)
			(3 (ego setCycle: Beg self))
			(4
				(proc1_19)
				(HighPrint 470 45)
				(self setScript: youBlewIt)
			)
		)
	)
)
