;;; Sierra Script 1.0 - (do not remove this comment)
(script# 480)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Full)
(use Intrface)
(use MoveFwd)
(use LoadMany)
(use Timer)
(use Save)
(use Motion)
(use Game)
(use Actor)

(public
	rm480 0
)

(local
	[local0 50]
	[local50 40] = [{Kahla:} 1 15 0 0 {Layla:} 5 15 40 40 {Sulayma:} 2 15 80 20 {Nawar:} 12 1 220 30 {Budar:} 14 1 100 60 {Ruzhat:} 13 1 140 90 {Dunya:} 11 1 170 120 {Abu:} 15 0 0 160]
	[theGirl1 7]
	[local97 38] = [8 9 10 7 7 7 7 7 7 11 7 12 13 7 14 15 16 7 7 7 7 7 17 18 19 7 7 7 7 7 20 7 21 7 7 7 7 7]
	[local135 16] = [0 '//ad<ad' 1 '//zayisha' 2 '//marry' 3 '//eunuch' 4 '//harem' 5 '//resistance,revolt,revolution' 6 '//forbidden']
)
(procedure (localproc_0040 param1 param2 &tmp temp0 temp1 [temp2 2])
	(= temp0 (= temp1 (* param1 5)))
	(myWindow
		color: [local50 (++ temp0)]
		back: [local50 (++ temp0)]
	)
	(Print
		&rest
		#title
		[local50 temp1]
		#window
		myWindow
		#at
		[local50 (++ temp0)]
		[local50 (++ temp0)]
		#width
		130
		#mode
		1
		#dispose
		param2
		25
		4
	)
)

(instance myWindow of SysWindow
	(properties)
)

(instance rm480 of Rm
	(properties
		picture 480
	)
	
	(method (init)
		(LoadMany 128 0 4 47 432 532 481 47)
		(Load rsTEXT 432)
		(Load rsSOUND 480)
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(AddToScore 713 3 2)
		(= egoWalkMode 0)
		(proc1_19)
		(super init:)
		(servant init:)
		(barli init: hide:)
		(kahla init:)
		(layla init:)
		(sulayma init:)
		(girl1 init:)
		(girl2 init:)
		(girl3 init:)
		(girl4 init:)
		(girl5 init:)
		(girl6 init:)
		(= [theGirl1 1] girl1)
		(= [theGirl1 2] girl2)
		(= [theGirl1 3] girl3)
		(= [theGirl1 4] girl4)
		(= [theGirl1 5] girl5)
		(= [theGirl1 6] girl6)
		(proc1_32 aniTimer 2 4)
		(DrawFeature
			vaseTable
			smallTable
			blueStand
			flowerStand
			pillows1
			pillows2
		)
		(gCMusic number: 480 loop: -1 priority: 0 playBed:)
		(self setScript: enterS)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			((& (ego onControl: 1) $0200) (self setScript: byeS))
			((& (ego onControl: 1) $1000) (self setScript: hurryS))
		)
	)
	
	(method (dispose)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(gCMusic stop:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 480 0))
		)
	)
)

(instance enterS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego view: 481 loop: 0 cel: 0 x: 311 y: 80 init:)
				(= cycles 1)
			)
			(1
				(ego setPri: 9 cycleSpeed: 1 setCycle: End self)
			)
			(2
				(proc1_19)
				(ego posn: 294 128 setMotion: MoveTo 270 128 self)
			)
			(3
				(Say servant self 480 1 480 2)
			)
			(4
				(servant setLoop: 4 setCel: 0 tLoop: 4)
				(self setScript: rCurtainS self 1)
			)
			(5
				(Say servant self 480 3 480 4 480 5)
			)
			(6
				(self setScript: rCurtainS self 0)
			)
			(7 (Say servant self 480 6))
			(8
				(localproc_0040 0 self 480 7)
			)
			(9
				(localproc_0040 1 self 480 8)
			)
			(10
				(localproc_0040 2 self 480 9)
			)
			(11
				(localproc_0040 3 self 480 10)
			)
			(12
				(localproc_0040 4 self 480 11)
			)
			(13
				(localproc_0040 5 self 480 12)
			)
			(14
				(localproc_0040 6 self 480 13)
			)
			(15 (Say servant self 480 14))
			(16
				(ego setPri: 9 setMotion: MoveTo 165 118 self)
			)
			(17
				(ego setPri: -1 setMotion: MoveTo 80 120 self)
			)
			(18 (client setScript: graceS))
		)
	)
)

(instance graceS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say servant self 480 15))
			(1
				(kahla setLoop: 2 cycleSpeed: 1 setCycle: End)
				(layla setLoop: 9 cycleSpeed: 1 setCycle: End)
				(sulayma setLoop: 6 cycleSpeed: 1 setCycle: End)
				(= cycles 12)
			)
			(2
				(ego view: 481 setLoop: 3 setCel: 0)
				(= cycles 8)
			)
			(3
				(ego setCycle: CT 2 1)
				(= cycles 12)
			)
			(4
				(ego setCycle: End)
				(= cycles 8)
			)
			(5
				(ego view: 0 setLoop: -1 setHeading: 90 self)
			)
			(6
				(ego view: 47 setLoop: 0 setCel: 0 setCycle: End self)
				(servant setLoop: 3 setCel: 0 tLoop: 3)
			)
			(7
				(barli show: setCycle: End self)
			)
			(8
				(Say barli self 480 16 480 17)
			)
			(9
				(localproc_0040 0 self 480 18)
			)
			(10
				(localproc_0040 1 self 480 19)
			)
			(11
				(localproc_0040 2 self 480 20)
			)
			(12
				(localproc_0040 3 self 480 21)
			)
			(13
				(localproc_0040 4 self 480 22)
			)
			(14
				(localproc_0040 5 self 480 23)
			)
			(15
				(localproc_0040 6 self 480 24)
			)
			(16 (Say barli self 480 25))
			(17 (Say servant self 480 26))
			(18
				(localproc_0040 0 self 480 27)
			)
			(19
				(localproc_0040 1 self 480 28)
			)
			(20
				(localproc_0040 2 self 480 29)
			)
			(21
				(localproc_0040 3 self 480 30)
			)
			(22
				(localproc_0040 4 self 480 22)
			)
			(23
				(localproc_0040 5 self 480 31)
			)
			(24
				(localproc_0040 6 self 480 32)
			)
			(25 (Say barli self 480 33))
			(26 (Say servant self 480 34))
			(27 (Say barli self 480 35))
			(28 (Say servant self 480 36))
			(29 (Say barli self 480 37))
			(30
				(barli setCycle: Beg self)
				(servant setLoop: 4 setCel: 0 tLoop: 4)
			)
			(31
				(barli hide:)
				(kahla setCycle: Beg)
				(layla setCycle: Beg)
				(sulayma setCycle: Beg)
				(ego setCycle: Beg self)
			)
			(32
				(proc1_19)
				(ego setHeading: 90)
				(= cycles 8)
			)
			(33 (client setScript: hideS))
		)
	)
)

(instance hideS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say servant self 480 38))
			(1
				(self setScript: lCurtainS self 1)
			)
			(2 (= cycles 2))
			(3
				(self setScript: lCurtainS self 0)
			)
			(4 (Say servant self 480 39))
			(5
				(localproc_0040 5 self 480 40)
			)
			(6
				(localproc_0040 6 self 480 41)
			)
			(7
				(Say servant self 480 42)
				(proc1_32 guardTimer 60)
			)
			(8 (self dispose:))
		)
	)
)

(instance rCurtainS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> (ego x?) 213)
					(ego setMotion: MoveTo 237 109 self)
				else
					(ego setMotion: MoveTo 189 109 self)
				)
			)
			(1
				(ego setMotion: MoveTo 213 111 self)
			)
			(2
				(ego
					posn: 198 90
					view: 481
					setLoop: 4
					setCel: 0
					setPri: 8
				)
				(= cycles 1)
			)
			(3
				(if register
					(abu
						init:
						x: 0
						setCycle: Walk
						setMotion: MoveTo 128 (abu y?) self
					)
				else
					(abu
						init:
						x: 284
						setCycle: Walk
						setMotion: MoveTo 231 (abu y?) self
					)
				)
			)
			(4
				(if register
					(abu setMotion: MoveTo 192 (abu y?) self)
				else
					(abu setMotion: MoveTo 160 (abu y?) self)
				)
				(ego setCycle: End)
				(= cycles 8)
			)
			(5 (ego setCycle: Beg))
			(6
				(if register
					(abu setMotion: MoveTo 284 (abu y?) self)
				else
					(abu setMotion: MoveTo 0 (abu y?) self)
				)
				(ego setCycle: End)
				(= cycles 8)
			)
			(7 (ego setCycle: Beg))
			(8
				(ego
					posn: 213 111
					setLoop: 1
					setPri: -1
					setCycle: End self
				)
			)
			(9
				(proc1_19)
				(ego
					illegalBits: 0
					x: (- (ego x?) 11)
					setMotion: MoveTo (- (ego x?) 20) (+ (ego y?) 5) self
				)
			)
			(10
				(abu dispose:)
				(ego illegalBits: -32768 setHeading: 180)
				(self dispose:)
			)
		)
	)
)

(instance lCurtainS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> (ego x?) 213)
					(ego setMotion: MoveTo 167 109 self)
				else
					(ego setMotion: MoveTo 119 109 self)
				)
			)
			(1
				(ego setMotion: MoveTo 143 111 self)
			)
			(2
				(ego
					posn: 126 90
					view: 481
					setLoop: 4
					setCel: 0
					setPri: 8
				)
				(= cycles 1)
			)
			(3
				(if register
					(abu
						init:
						x: 0
						setCycle: Walk
						setMotion: MoveTo 128 (abu y?) self
					)
				else
					(abu
						init:
						x: 284
						setCycle: Walk
						setMotion: MoveTo 231 (abu y?) self
					)
				)
			)
			(4
				(if register
					(abu setMotion: MoveTo 192 (abu y?) self)
				else
					(abu setMotion: MoveTo 160 (abu y?) self)
				)
				(ego setCycle: End)
				(= cycles 8)
			)
			(5
				(if register
					(localproc_0040 0 0 480 43)
				else
					(localproc_0040 3 0 480 44)
				)
				(ego setCycle: Beg)
			)
			(6
				(if register
					(abu setMotion: MoveTo 284 (abu y?) self)
				else
					(abu setMotion: MoveTo 0 (abu y?) self)
				)
				(ego setCycle: End)
				(= cycles 8)
			)
			(7
				(if register
					(localproc_0040 1 0 480 45)
				else
					(localproc_0040 4 0 480 46)
				)
				(ego setCycle: Beg)
			)
			(8
				(ego
					posn: 143 111
					setLoop: 1
					setPri: -1
					setCycle: End self
				)
			)
			(9
				(proc1_19)
				(ego
					x: (- (ego x?) 11)
					setMotion: MoveTo (- (ego x?) 25) (+ (ego y?) 5) self
				)
			)
			(10
				(if register (localproc_0040 2 self 480 47))
				(abu dispose:)
				(ego illegalBits: -32768 setHeading: 180)
				(self dispose:)
			)
		)
	)
)

(instance hurryS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say servant self 480 48))
			(1 (ego setHeading: 270 self))
			(2
				(ego setMotion: MoveFwd 10 self)
			)
			(3 (self dispose:))
		)
	)
)

(instance byeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_0040 0 self 480 49)
			)
			(1 (ego setHeading: 135 self))
			(2 (= cycles 8))
			(3
				(ego
					setMotion: MoveTo (- (ego x?) 10) (+ (ego y?) 10) self
				)
			)
			(4
				(localproc_0040 1 self 480 50)
			)
			(5
				(localproc_0040 2 self 480 51)
			)
			(6
				(localproc_0040 3 self 480 52)
			)
			(7
				(localproc_0040 4 self 480 53)
			)
			(8 (ego setHeading: 135 self))
			(9 (= cycles 8))
			(10
				(ego
					setMotion: MoveTo (- (ego x?) 10) (+ (ego y?) 10) self
				)
			)
			(11
				(localproc_0040 5 self 480 54)
			)
			(12
				(localproc_0040 6 self 480 55)
			)
			(13
				(localproc_0040 3 self 480 56)
			)
			(14
				(localproc_0040 4 self 480 57)
			)
			(15
				(localproc_0040 3 self 480 58)
			)
			(16 (Say servant self 480 59))
			(17
				(ego
					view: 481
					setLoop: 2
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(18 (curRoom newRoom: 530))
		)
	)
)

(instance guardS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(abu
					posn: 0 133
					init:
					setCycle: Walk
					setMotion: MoveTo 29 133 self
				)
			)
			(1
				(localproc_0040 7 self 480 60)
			)
			(2
				(localproc_0040 7 self 480 61)
			)
			(3
				(Die 1 480 62 80 {Harem today, goon tomorrow})
			)
		)
	)
)

(instance servant of Talker
	(properties
		x 217
		y 117
		description {Mayzun}
		lookStr {Mayzun in Zayishah's servant.}
		view 432
		illegalBits $0000
		tLoop 3
		talkSpeed 1
		myName '//servant,mayzun,woman'
		title {Mayzun:}
		back 13
		msgFile 432
	)
	
	(method (atSpec param1)
		(return [local135 param1])
	)
	
	(method (atGen param1)
		(return [local97 param1])
	)
)

(instance barli of Talker
	(properties
		x 309
		y 78
		description {Barli}
		lookStr {Barli looks like one tough Eunuch.}
		view 533
		priority 8
		signal $4010
		illegalBits $0000
		tLoop 1
		talkSpeed 1
		myName '//barli,eunuch,man'
		title {Barli:}
		color 15
		back 8
	)
)

(instance abu of Actor
	(properties
		x 75
		y 93
		view 532
		signal $4000
		illegalBits $0000
	)
)

(instance kahla of Prop
	(properties
		x 90
		y 132
		view 482
		loop 3
		signal $0001
	)
)

(instance layla of Prop
	(properties
		x 105
		y 130
		view 482
		loop 9
		signal $0001
	)
)

(instance sulayma of Prop
	(properties
		x 118
		y 128
		view 482
		loop 6
		signal $0001
	)
)

(instance girl1 of Prop
	(properties
		x 226
		y 189
		view 483
		loop 4
		signal $0001
		cycleSpeed 1
	)
)

(instance girl2 of Prop
	(properties
		x 258
		y 146
		view 483
		loop 5
		signal $0001
		cycleSpeed 1
	)
)

(instance girl3 of Prop
	(properties
		x 194
		y 189
		view 483
		loop 3
		signal $0001
		cycleSpeed 1
	)
)

(instance girl4 of Prop
	(properties
		x 171
		y 189
		view 483
		loop 2
		signal $0001
		cycleSpeed 1
	)
)

(instance girl5 of Prop
	(properties
		x 138
		y 189
		view 483
		loop 1
		signal $0001
		cycleSpeed 1
	)
)

(instance girl6 of Prop
	(properties
		x 77
		y 188
		view 483
		signal $0001
		cycleSpeed 1
	)
)

(instance aniTimer of Timer
	(properties)
	
	(method (cue &tmp temp0)
		(= temp0 [theGirl1 (Random 1 6)])
		(temp0 setCycle: stopFullLoop 1)
		(proc1_32 aniTimer 2 4)
	)
)

(instance stopFullLoop of Full
	(properties)
	
	(method (cycleDone)
		(super cycleDone:)
		(if completed (client stopUpd:))
	)
)

(instance guardTimer of Timer
	(properties)
	
	(method (cue)
		(curRoom setScript: guardS)
	)
)

(instance vaseTable of PicView
	(properties
		x 161
		y 150
		view 480
		loop 2
	)
)

(instance smallTable of PicView
	(properties
		x 194
		y 153
		view 480
		loop 3
	)
)

(instance blueStand of PicView
	(properties
		x 312
		y 143
		view 480
		loop 5
	)
)

(instance flowerStand of PicView
	(properties
		x 182
		y 111
		view 480
		loop 1
	)
)

(instance pillows1 of PicView
	(properties
		x 252
		y 171
		view 480
		loop 4
	)
)

(instance pillows2 of PicView
	(properties
		x 76
		y 183
		view 480
		loop 6
	)
)
