;;; Sierra Script 1.0 - (do not remove this comment)
(script# 500)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Monster)
(use ProjClient)
(use TargActor)
(use Flame)
(use n095)
(use doBattleS)
(use Feature)
(use MoveFwd)
(use LoadMany)
(use Reverse)
(use Timer)
(use Music)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm500 0
)

(local
	[newCandle 6]
	[newFlame 6]
	local12 =  -1
	local13
	local14
	gEgoLoop
	local16
	local17
	local18
	local19
	local20
	local21
	local22
	local23
	[local24 13] = [160 117 206 125 223 146 160 158 94 146 108 125 -1]
)
(procedure (localproc_2976 param1)
	(= local12 0)
	(while (< local12 param1)
		([newFlame local12] show: loop: 1 setCycle: Fwd)
		([newCandle local12] stopUpd:)
		(switch local12
			(2
				(line02 init:)
				(addToPics add: line02)
			)
			(3
				(line13 init:)
				(addToPics add: line13)
			)
			(4
				(line24 init:)
				(line40 init:)
				(addToPics add: line24 line40)
			)
		)
		(++ local12)
	)
	(-- local12)
	(addToPics doit:)
)

(procedure (localproc_2a13)
	(ego hide:)
	(local13
		posn: mouseX mouseY
		opponent: dococ
		barMessage: 0
		hurtScript: (ScriptID 501 10)
		initCombat:
	)
	(dococ setHealth: gHealth opponent: local13 initCombat:)
)

(instance rm500 of Rm
	(properties
		picture 500
		style $0008
	)
	
	(method (init &tmp temp0 temp1 temp2)
		(LoadMany 130 501 78)
		(LoadMany 132 500 821)
		(LoadMany 128 1 4 41 500 501 502 503 505 510 612 613)
		(Bset 140)
		(AddToScore 691 7 1)
		(super init: &rest)
		(gCMusic number: 500 loop: -1 playBed:)
		(= local13 (ScriptID 32 0))
		(if (= local14 (ego knows: 29))
			(rev init: hide:)
			(proc501_2)
		else
			(proc501_3)
			(= [skills 29] 0)
		)
		(= egoWalkMode 0)
		(proc1_19)
		(ego
			posn: 197 173
			heading: 0
			loop: 3
			hurtScript: egoGetHurtS
			init:
		)
		(proc501_5)
		(thark init: stopUpd:)
		(dococ init: setCycle: Fwd)
		(adAvis init: setCycle: Fwd)
		(shieldSpell init: hide:)
		(iblis init:)
		(= temp0 0)
		(while (!= [local24 (* temp0 2)] -1)
			(= temp1 [local24 (+ (* temp0 2) 0)])
			(= temp2 [local24 (+ (* temp0 2) 1)])
			((= [newCandle temp0] (candle new:))
				view: 500
				loop: 2
				x: temp1
				y: temp2
				xStep: temp0
				init:
				stopUpd:
			)
			((= [newFlame temp0] (Flame new:))
				view: 500
				loop: 1
				x: temp1
				y: temp2
				z: 15
				cycleSpeed: 1
				init:
				hide:
			)
			(++ temp0)
		)
		(localproc_2976 3)
		(brazier init: stopUpd:)
		(brazFire init:)
		(if (> gSeconds 1)
			(brazFire setCycle: Fwd)
		else
			(brazFire stopUpd:)
		)
		(= monsterInRoom 1000)
		(= gHealth 1000)
		(= gGDftSC theSpellChecker)
		(self setScript: enterRoomS)
	)
	
	(method (doit &tmp temp0 temp1 temp2)
		(= mouseX (ego x?))
		(= mouseY (ego y?))
		(= temp0 (ego onControl: 1))
		(cond 
			(local14
				(if
					(and
						(not local16)
						(< mouseX 171)
						(< local12 5)
						(not local18)
						(not (adAvis script?))
					)
					(adAvis setScript: lightNextCandleS)
				)
			)
			(local18)
			((and (< mouseY 129) (not local23)) (curRoom setScript: fighterFlameS))
			(
				(and
					(< local12 4)
					(< mouseY 145)
					(not (adAvis script?))
				)
				(adAvis setScript: lightNextCandleS)
			)
			((and (not (ego script?)) (& temp0 $0008))
				(= temp1 0)
				(= temp2 0)
				(while (and (<= temp1 5) (not temp2))
					(if
						(and
							(not ([newCandle temp1] cel?))
							(< (ego distanceTo: [newCandle temp1]) 16)
						)
						(ego setScript: (ScriptID 501 9) 0 [newCandle temp1])
						(= temp2 1)
					)
					(++ temp1)
				)
			)
			((and (& temp0 $0020) (!= script pushAvisS)) (self setScript: pushAvisS))
			(script)
			(
				(and
					(& temp0 $1000)
					(not global161)
					(not (dococ script?))
				)
				(dococ setScript: hitEgoS)
			)
		)
		(cond 
			(global161)
			((== (ego edgeHit?) 3)
				(ego edgeHit: 0 posn: mouseX (- mouseY 2))
				((ScriptID 501 7) register: 1)
				(curRoom setScript: (ScriptID 501 7))
			)
			((== temp0 2)
				(ego posn: (+ mouseX 4) mouseY)
				((ScriptID 501 7) register: 0)
				(curRoom setScript: (ScriptID 501 7))
			)
			(
				(and
					(> mouseX 202)
					(not (dococ cycler?))
					(not (dococ script?))
				)
				(dococ setCycle: Fwd)
			)
			((not (& (dococ signal?) $0004)) (dococ stopUpd:))
		)
		(super doit:)
	)
	
	(method (dispose &tmp temp0)
		(DisposeScript 501)
		(flameT dispose: delete:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 500 2))
			((Said 'force/ad')
				(if local23
					(curRoom setScript: pushAvisS)
				else
					(HighPrint 500 3)
				)
			)
			((Said 'duck,(get,acquire<down)')
				(if (== (ego view?) 47)
					(HighPrint 500 4)
				else
					(ego setScript: duckS)
				)
			)
			((Said 'stand,(get,acquire<up)')
				(if (== (ego view?) 47)
					(duckS cue:)
				else
					(HighPrint 500 5)
				)
			)
		)
	)
	
	(method (notify param1)
		(return
			(if (not argc)
				(return local12)
			else
				(switch param1
					(-2 (= local16 1))
					(-3
						(if local16
							(DjinniSpeaks 500 0)
						else
							(DjinniSpeaks 500 1)
						)
					)
					(-1
						(if (not local17)
							(= local17 1)
							(self
								setScript: (if local14 angryAtMageS else angryAtFighterS)
							)
						)
					)
					(59
						(= global304 59)
						(ChangeEgoWalk 1 0)
						(ego show: x: 214 setMotion: MoveTo 183 166)
						(adAvis setScript: lightNextCandleS)
						(local13 dispose:)
						(dococ endCombat: stopUpd:)
						(return 1)
					)
					(else 
						(= global304 0)
						(return 0)
					)
				)
			)
		)
	)
)

(instance egoGetHurtS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 newProjectile)
		(switch (= state newState)
			(0
				(if (Btst 86)
					((= newProjectile (Projectile new:))
						type: (register type?)
						xStart: mouseX
						yStart: (- mouseY 30)
						x: (Random 90 244)
						y: (Random 50 80)
					)
					(rev setScript: (ScriptID 501 6))
					(client setScript: newProjectile)
				else
					(self cue:)
				)
			)
			(1
				(= gEgoLoop (ego loop?))
				(ego
					view: 41
					cel: 0
					setMotion: 0
					setCycle: End self
					setLoop:
						(cond 
							((= register (ReduceHP 10)) (if (< (ego heading?) 180) 2 else 3))
							((< (ego heading?) 180) 0)
							(else 1)
						)
				)
			)
			(2
				(if register
					(ego setCycle: Beg self)
				else
					(LoseFinalBattle
						(if (== (curRoom script?) angryAtFighterS) 2 else 6)
					)
				)
			)
			(3
				(proc1_19)
				(ego loop: gEgoLoop)
				(if (and local22 (not local21))
					(= local21 1)
					(DjinniSpeaks 500 6)
				)
				(= local22 0)
				(self dispose:)
			)
		)
	)
)

(instance enterRoomS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(ego
					posn: 233 198
					setMotion: MoveTo 234 (if local14 174 else 168) self
				)
			)
			(1
				(DjinniSpeaks 500 7)
				(ego setHeading: 45 self)
				(adAvis setScript: lightNextCandleS)
			)
			(2
				(if local14
					(client setScript: hitEgoS)
				else
					(localproc_2a13)
					(self dispose:)
				)
			)
		)
	)
)

(instance hitEgoS of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(cond 
			(
				(and
					local14
					(ego mover?)
					(not (Btst 87))
					(not local22)
				)
				(= cycles 0)
				(self changeState: 0)
			)
			(
			(and (== (ego view?) 47) (== state 5) (ego cel?)) (self cue:))
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(= register (== (ego view?) 47))
				(dococ
					setLoop: (if (< mouseY 175) 2 else 3)
					cel: 0
					cycleSpeed: 0
					setCycle: End self
				)
			)
			(1
				(ego view: 22 setLoop: 0 cel: 0 setCycle: End self)
				(if local14
					(ego setMotion: 0)
				else
					(ego
						x: (- mouseX 4)
						setMotion: MoveTo (- mouseX 10) mouseY
					)
				)
				(++ local20)
			)
			(2
				(cond 
					(register (Die 1 500 8 80 {Brainless and Painless}))
					((ReduceHP 60) (self cue:))
					(else (LoseFinalBattle 1))
				)
			)
			(3
				(ego setLoop: 1 cel: 0 cycleSpeed: 1 setCycle: End self)
				(dococ cycleSpeed: 2 setLoop: 0 setCycle: Fwd)
			)
			(4
				(proc1_19)
				(ego view: 4 heading: 0 loop: 3 setHeading: 45 self)
				(LockEgo)
				(if
				(and (OneOf local20 2 4) (not (adAvis script?)))
					(adAvis setScript: lightNextCandleS)
				)
			)
			(5
				(if local14 (= cycles 22) else (self dispose:))
			)
			(6
				(if (or (Btst 87) local22)
					(self changeState: 5)
				else
					(self changeState: 0)
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'attack,attack') (localproc_2a13) (self dispose:))
		)
	)
)

(instance lightNextCandleS of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(if (== local12 4)
					(if local16
						(self dispose:)
					else
						(DjinniSpeaks 500 9)
						(= temp0 1)
					)
				)
				(adAvis
					setLoop: 0
					cel: 0
					cycleSpeed: (if temp0 3 else 1)
					setCycle: End self
				)
			)
			(1
				(if local16
					(self dispose:)
				else
					([newFlame (++ local12)] show: setCycle: Fwd)
					(switch local12
						(2 (line02 init: stopUpd:))
						(3 (line13 init: stopUpd:))
						(4
							(line24 init: stopUpd:)
							(line40 init: stopUpd:)
						)
						(5
							(line35 init: stopUpd:)
							(line51 init: stopUpd:)
						)
					)
					(if (== local12 5)
						(flameT dispose: delete:)
						(adAvis setLoop: 0 cel: 0 setCycle: Fwd)
						(client setScript: (ScriptID 501 4))
					else
						(flameT setCycle: flameT 80)
						(DjinniSpeaks 500 10)
						(self dispose:)
					)
				)
			)
		)
	)
)

(instance stopTharkS of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose: &rest)
		(ego illegalBits: -16384)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(thark startUpd:)
				(= cycles 4)
			)
			(1
				(thark dispose:)
				(dococ
					view: 511
					posn: 254 162
					setLoop: 0
					cel: 0
					setMotion: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(2
				(dococ setPri: 11 stopUpd: addToPic:)
				(proc1_19)
				(if (not local16)
					(if (!= local12 5) (DjinniSpeaks 500 11))
					(if (and (< local12 4) (not (adAvis script?)))
						(adAvis setScript: lightNextCandleS)
					)
					((ScriptID 501 4) register: 3)
				)
				(self dispose:)
			)
		)
	)
)

(instance angryAtMageS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 8))
			(1
				(adAvis tLoop: 0)
				(Say adAvis self 500 12 500 13 500 14)
				(ego
					setMotion: 0
					setHeading:
						(cond 
							((Btst 86) 0)
							((< mouseX (adAvis x?)) 45)
							(else 315)
						)
				)
			)
			(2
				(adAvis cel: 0 setCycle: CT 5 1 self)
				(if (not (Btst 141))
					(khav init: setCycle: Walk setMotion: MoveTo 44 176)
				)
			)
			(3
				(trans
					init:
					setPri: (- (ego priority?) 1)
					posn: 158 84
					setCycle: Fwd
					setMotion: MoveTo mouseX (- mouseY 35) self
				)
			)
			(4
				(if (Btst 86)
					(rev setScript: (ScriptID 501 6))
					(client setScript: transKhavS)
				else
					(ego
						view: 556
						setLoop: (< (ego heading?) 180)
						cel: 0
						cycleSpeed: 0
						setCycle: End self
					)
					(trans dispose:)
				)
			)
			(5
				(Say adAvis self 500 15 500 16)
			)
			(6
				(LoseFinalBattle 4)
				(self dispose:)
			)
		)
	)
)

(instance transKhavS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(ego illegalBits: -16384)
				(trans
					setMotion: MoveTo (+ (khav x?) 7) (- (khav y?) 30) self
				)
				(khav setMotion: 0)
			)
			(1
				(trans dispose:)
				(if (Btst 141)
					(self changeState: 5)
				else
					(khav
						view: 506
						setLoop: 1
						cel: 0
						cycleSpeed: 0
						setCycle: End self
					)
				)
			)
			(2 (= cycles 4))
			(3
				(khav
					setLoop: 2
					cel: 0
					setCycle: Fwd
					setMotion: MoveTo -18 176 self
				)
			)
			(4
				(khav dispose:)
				(Say adAvis self 500 17)
			)
			(5
				(adAvis setLoop: 0 cel: 0 setCycle: CT 2 1 self)
			)
			(6
				(adAvis cel: 4)
				(flameBolt
					init:
					ignoreHorizon: 1
					setLoop: 2
					setPri: (- (ego priority?) 1)
					posn: 156 88
					setCycle: Fwd
					setMotion: MoveTo mouseX (- mouseY 30) self
				)
			)
			(7
				(rev setScript: (ScriptID 501 6))
				(adAvis cel: 2 setCycle: Beg)
				(flameBolt setLoop: 5 setMotion: MoveTo 60 84 self)
			)
			(8
				(flameBolt setLoop: 3 cel: 0 setCycle: End self)
				(LockEgo)
			)
			(9
				(flameBolt dispose:)
				(client setScript: bigBadSpellS)
			)
		)
	)
)

(instance bigBadSpellS of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (and (< mouseY 129) (< state 6))
			(= cycles (= seconds 0))
			(adAvis setCycle: 0)
			(self changeState: 6)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say adAvis self 500 18))
			(1
				(adAvis cycleSpeed: 1 setCycle: Rev)
				(= seconds 3)
			)
			(2
				(DjinniSpeaks 500 19)
				(adAvis setLoop: 0 cycleSpeed: 0)
				(= local19 6)
				(= seconds 10)
			)
			(3
				(adAvis setCycle: Rev)
				(DjinniSpeaks 500 20)
				(= seconds 2)
			)
			(4 (= cycles 6))
			(5
				(if (and (Btst 87) (-- local19))
					(self changeState: 4)
				else
					(adAvis setCycle: Beg self)
				)
			)
			(6
				(UnlockEgo)
				(ego
					view: 504
					setLoop: 0
					cycleSpeed: 3
					setScript: 0
					setCycle: End
				)
				(trans
					view: 504
					setLoop: 1
					cel: 10
					init:
					setPri: -1
					posn: mouseX (+ mouseY 3)
					setCycle: Beg self
				)
			)
			(7
				(ego hide:)
				(trans setCycle: End self)
			)
			(8 (LoseFinalBattle 5))
		)
	)
)

(instance angryAtFighterS of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(flameBolt dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 10))
			(1 (Say adAvis self 500 21))
			(2
				(if (Btst 87)
					(self changeState: 7)
				else
					(adAvis setLoop: 0 cel: 0 setCycle: CT 2 1 self)
				)
			)
			(3
				(adAvis cel: 4)
				(flameBolt
					init:
					ignoreHorizon: 0
					setLoop: 2
					posn: 148 84
					setCycle: Fwd
					setMotion: MoveTo mouseX (- mouseY 30)
				)
			)
			(4
				(if (== (ego view?) 47)
					(flameBolt
						ignoreHorizon: 1
						setPri: (+ (ego priority?) 1)
						setMotion: MoveFwd 50 self
					)
				else
					(flameBolt setLoop: 3 cel: 0 setCycle: End self)
					(avisSpellSound
						number: 14
						loop: 1
						priority: 6
						init:
						play:
					)
					(ego hurtMe: 25 25)
				)
			)
			(5
				(adAvis cel: 2 setCycle: Beg self)
				(flameBolt dispose:)
				(if (== (ego view?) 47) (duckS cue:))
			)
			(6
				(adAvis setLoop: 1 setCycle: Fwd)
				(= cycles 8)
			)
			(7 (= cycles 4))
			(8 (self changeState: 2))
		)
	)
)

(instance burnAvisUpS of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose: &rest)
		(ego illegalBits: -16384)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(brazier setCycle: CT 3 1 self)
				(brazFire dispose:)
			)
			(1
				(gCMusic number: 821 playBed:)
				(brazier setCycle: End)
				(adAvis
					view: 508
					setLoop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
				(ego setHeading: 45)
			)
			(2
				(= local18 1)
				(if (or (== heroType 0) (== heroType 3))
					(AddToScore 667 15)
				)
				(AddToScore 692 25 1)
				(adAvis dispose:)
				(FaceObject ego iblis 0 self)
			)
			(3
				(if (== local12 5)
					(self dispose:)
				else
					(brazier stopUpd:)
					(if (cast contains: brazFire)
						(brazFire setCycle: End self)
					else
						(= cycles 2)
					)
				)
			)
			(4
				(brazFire dispose:)
				(DjinniSpeaks 500 22)
				(client setScript: (ScriptID 501 11))
			)
		)
	)
)

(instance fighterFlameS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local23 1)
				(ego setMotion: 0)
				(adAvis
					setLoop: 0
					cel: 0
					cycleSpeed: 0
					setCycle: CT 4 1 self
				)
			)
			(1
				(brazFire
					setPri: -1
					view: 504
					posn: 117 118
					z: 0
					setLoop: 1
					cel: 10
					setCycle: Beg self
				)
			)
			(2
				(brazier dispose:)
				(brazFire setScript: fireCycleS)
				(adAvis setScript: lightNextCandleS)
				(self dispose:)
			)
		)
	)
)

(instance fireCycleS of Script
	(properties)
	
	(method (changeState newState)
		(if (== newState 2) (= newState 0))
		(switch (= state newState)
			(0
				(client setCycle: CT 3 1 self)
			)
			(1 (client setCycle: Beg self))
		)
	)
)

(instance pushAvisS of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose: &rest)
		(ego illegalBits: -16384)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ChangeEgoWalk 1 0)
				(ego
					ignoreActors:
					illegalBits: 0
					setMotion: MoveTo 127 116 self
				)
			)
			(1
				(adAvis
					view: 509
					setLoop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: End
				)
				(ego setMotion: MoveTo 145 111)
				(= cycles 10)
			)
			(2
				(gCMusic number: 821 playBed:)
				(adAvis setLoop: 1 cel: 1 setCycle: End)
				(ego setMotion: 0)
				(= cycles 10)
			)
			(3
				(adAvis
					setPri: 3
					setCel: 4
					setStep: 3 5
					setMotion: MoveTo 174 133 self
				)
			)
			(4
				(burnAvisUpS start: 2)
				(client setScript: burnAvisUpS)
			)
		)
	)
)

(instance duckS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(ego view: 47 setLoop: 0 cel: 0 setCycle: End self)
			)
			(1 (SetInput 0))
			(2 (ego setCycle: Beg self))
			(3
				(proc1_19)
				(LockEgo 1)
				(self dispose:)
			)
		)
	)
)

(instance adAvis of Talker
	(properties
		x 157
		y 108
		description {Ad Avis}
		lookStr {Ad Avis stands, glaring sternly, his black robes blowing in the wind.}
		view 501
		loop 1
		signal $4000
		illegalBits $0000
		myName '//ad,man'
		title {Ad Avis:}
		color 13
		back 0
	)
	
	(method (doit)
		(if (not (if (or cycler mover) else local23))
			(= loop 1)
			(self setCycle: Fwd)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'ask')
			(DjinniSpeaks 500 23)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (cue)
		(shieldSpell hide:)
	)
	
	(method (hurtMe param1 param2 &tmp newProjectile)
		(return
			(if (and (OneOf (param2 type?) 4 5) (not script))
				(adAvis setLoop: 8 cel: 0 setCycle: CT 3 1)
			else
				(shieldSpell
					posn: hitX (- hitY 6)
					setScript: adShieldUp
					show:
				)
				((= newProjectile (Projectile new:))
					type: (param2 type?)
					damage: param1
					xStart: hitX
					yStart: hitY
					x: mouseX
					y: (- mouseY 35)
				)
				(= local22 1)
				(ego setPri: 15)
				(brazier setScript: newProjectile)
				(return 0)
			)
		)
	)
)

(instance flameBolt of Actor
	(properties
		yStep 10
		view 505
		loop 2
		signal $4810
		illegalBits $0000
		xStep 12
	)
	
	(method (doit &tmp curRoomScript)
		(cond 
			((& signal ignoreHorizon))
			(
				(and
					(== loop 2)
					(< (- mouseX 7) x)
					(< x (+ mouseX 7))
					(> mouseY y)
					(> y (- mouseY 40))
				)
				(if (= curRoomScript (curRoom script?))
					(curRoomScript cue:)
				)
			)
			((self mover?)
				((self mover?) x: mouseX y: (- mouseY 30) init:)
				(= priority (- (ego priority?) 1))
			)
			(else (self setMotion: MoveTo mouseX (- mouseY 30)))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gSpareMusic number: 16 loop: 1 play:)
		(super dispose: &rest)
	)
	
	(method (setMotion)
		(gSpareMusic number: 15 loop: 1 play:)
		(super setMotion: &rest)
	)
)

(instance trans of Actor
	(properties
		yStep 18
		view 505
		loop 4
		signal $4810
		illegalBits $0000
		xStep 22
	)
	
	(method (dispose)
		(gSpareMusic number: 14 loop: 1 play:)
		(super dispose: &rest)
	)
	
	(method (setMotion)
		(gSpareMusic number: 13 loop: 1 play:)
		(super setMotion: &rest)
	)
)

(instance rev of Prop
	(properties
		view 506
		signal $4000
	)
)

(instance avisSpellSound of Sound
	(properties)
)

(instance shieldSpell of Prop
	(properties
		x 152
		y 86
		view 505
		signal $0010
	)
)

(instance adShieldUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					show:
					loop: 0
					cel: 0
					priority: (+ (adAvis priority?) 1)
					setCycle: End self
				)
			)
			(1
				(client loop: 1 init: setCycle: Fwd)
				(= cycles 4)
			)
			(2
				(client loop: 0 cel: 3 setCycle: Beg self)
			)
			(3
				(client hide:)
				(self dispose:)
			)
		)
	)
)

(instance thark of TargActor
	(properties
		x 264
		y 135
		view 510
		loop 1
		priority 12
		signal $4010
		cycleSpeed 2
		illegalBits $0000
		moveSpeed 2
	)
	
	(method (cue)
		(super cue:)
		(HighPrint 500 24)
	)
	
	(method (fetchMe)
		(self cue:)
		(return 0)
	)
	
	(method (hurtMe)
		(self cue:)
	)
	
	(method (triggerMe)
		(curRoom setScript: stopTharkS)
		(return 1)
	)
)

(instance dococ of Monster
	(properties
		x 264
		y 135
		yStep 5
		view 510
		priority 12
		signal $4010
		cycleSpeed 2
		illegalBits $0000
		xStep 5
		strength 300
		intell 125
		agil 125
		vit 125
		luck 125
		weap 125
		parry 125
		dodge 125
		armorValue 900
		armorEnc 20
		weapValue 10
		battleMusic 0
		endMusic 0
	)
	
	(method (fetchMe)
		(HighPrint 500 25)
		(return 0)
	)
	
	(method (hurtMe)
		(return 1)
	)
	
	(method (triggerMe)
		(curRoom setScript: stopTharkS)
		(return 1)
	)
	
	(method (initCombat)
		(= combatScript (ScriptID 501 1))
		(super initCombat: &rest)
	)
)

(instance candle of TargActor
	(properties
		x 123
		y 103
		noun '/candle'
		description {a candle}
		closeRangeDist 20
		lookStr {The candles are positioned at the six apexes of the hexagram.}
		view 500
		signal $1800
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'beat,move,knock/candle')
				(cond 
					(local16 (DjinniSpeaks 500 26))
					((curRoom script?) (HighPrint 500 30))
					(else (HighPrint 500 31))
				)
			)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(7
				(cond 
					(local16 (DjinniSpeaks 500 26))
					((== local12 5) (DjinniSpeaks 500 29))
					((curRoom script?) (HighPrint 500 30))
					(else (curRoom setScript: (ScriptID 501 8) 0 self))
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
	
	(method (fetchMe)
		(return
			(cond 
				(local18 (return 0))
				(local16 (DjinniSpeaks 500 26) (return (> xStep local12)))
				((> xStep local12)
					(= local16 1)
					(= local17 1)
					(curRoom
						setScript: (if local14 angryAtMageS else angryAtFighterS)
					)
					(return 1)
				)
				(else (DjinniSpeaks 500 27) (return 0))
			)
		)
	)
	
	(method (hurtMe)
		(return
			(cond 
				((== local12 5) (DjinniSpeaks 500 28) (return 0))
				((> xStep local12)
					(self setStep: 6 4 setMotion: MoveTo 84 114 setCycle: End)
					(cond 
						(local18)
						(local16 (DjinniSpeaks 500 26))
						(else
							(= local16 1)
							(= local17 1)
							(curRoom
								setScript: (if local14 angryAtMageS else angryAtFighterS)
							)
						)
					)
					(return 1)
				)
				(else
					(cond 
						(local18 (return 1))
						(local16 (DjinniSpeaks 500 26))
						(else (DjinniSpeaks 500 27))
					)
					(return 0)
				)
			)
		)
	)
)

(instance iblis of Feature
	(properties
		x 159
		y 133
	)
)

(instance brazier of TargActor
	(properties
		x 136
		y 117
		view 500
		loop 4
	)
	
	(method (cue)
		(self stopUpd:)
	)
	
	(method (fetchMe)
		(HighPrint 500 34)
		(return 0)
	)
	
	(method (hurtMe param1 param2)
		(cond 
			(cel (return 1))
			((== (param2 type?) 25) (HighPrint 500 32) (return 1))
			((> hitY 106) (DjinniSpeaks 500 33))
			((or (< mouseX 92) (Btst 147)) (curRoom setScript: burnAvisUpS))
			(else
				(self loop: 5 posn: 119 115 cel: 0 setCycle: End self)
				(brazFire dispose:)
			)
		)
		(return 1)
	)
)

(instance brazFire of Prop
	(properties
		x 123
		y 115
		z 12
		view 500
		priority 9
		signal $4010
	)
)

(instance line02 of View
	(properties
		x 158
		y 134
		view 503
		cel 2
		priority 5
		signal $4010
	)
)

(instance line13 of View
	(properties
		x 159
		y 134
		view 503
		cel 5
		priority 5
		signal $4010
	)
)

(instance line24 of View
	(properties
		x 158
		y 134
		view 503
		cel 1
		priority 5
		signal $4010
	)
)

(instance line35 of View
	(properties
		x 158
		y 134
		view 503
		cel 4
		priority 5
		signal $4010
	)
)

(instance line51 of View
	(properties
		x 159
		y 134
		view 503
		cel 3
		priority 5
		signal $4010
	)
)

(instance line40 of View
	(properties
		x 157
		y 134
		view 503
		priority 5
		signal $4010
	)
)

(instance khav of TargActor
	(properties
		x -10
		y 176
		description {Khaveen}
		lookStr {The Calm spell must have worn off of Khaveen.__He seems confused, but very angry.}
		view 465
		signal $4000
		illegalBits $0000
	)
)

(instance flameT of Timer
	(properties)
	
	(method (cue)
		(super cue: &rest)
		(if
			(not
				(if (or local16 (== local12 5)) else (adAvis script?))
			)
			(adAvis setScript: lightNextCandleS)
		)
	)
)

(instance theSpellChecker of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (OneOf param1 28 6)
				(DjinniSpeaks 500 35)
				(return 0)
			else
				(return 1)
			)
		)
	)
)
