;;; Sierra Script 1.0 - (do not remove this comment)
(script# 560)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Stage)
(use TargActor)
(use Full)
(use LoadMany)
(use Timer)
(use Motion)
(use Actor)

(public
	rm560 0
)

(local
	local0
	local1
	local2
	local3
	gEgoX
	gEgoY
	local6 =  12
	local7
	local8 =  4
	local9 =  8
	local10
	newFlame
	newFlame_2
	[local13 15] = [26 28 29 24 22 28 26 27 22 24 28 23 26 29 22]
	[local28 24] = [264 171 233 155 175 152 134 154 193 145 216 138 227 124 182 94 146 113 48 103 93 106 36 124]
	[local52 12] = [13 12 11 11 10 10 9 3 8 6 7 8]
	[local64 16] = [31 91 300 125 301 142 160 100 25 143 101 178 204 183 145 130]
)
(procedure (localproc_000c)
	(Die 1 560 0 80 {Hot Shot Got Caught for Naught})
)

(instance rm560 of Stage
	(properties
		picture 560
		style $0008
		east 580
		west 590
		rightFromX 321
		rightFromY 186
		rightToX 299
		rightToY 169
		leftFromX -10
		leftFromY 99
		leftToX 6
		leftToY 103
	)
	
	(method (init)
		(LoadMany 128 560 561 19)
		(LoadMany 130 78 956)
		(LoadMany 132 560 561)
		(= gGDftSC gAllSC)
		(ego init:)
		(super init:)
		(flame init:)
		(flameT setCycle: flameT 3)
		(if (>= arcadeDifficultyLevel 2)
			((= newFlame (flame new:)) init:)
			(flameT2 setCycle: flameT2 13)
			(if (>= arcadeDifficultyLevel 3)
				((= newFlame_2 (flame new:)) init:)
				(flameT3 setCycle: flameT3 21)
			)
		)
		(flow init: setCycle: Fwd)
		(flowT setCycle: flowT 3)
		(kludge init: hide:)
		(gCMusic number: 560 loop: -1 playBed:)
	)
	
	(method (doit &tmp temp0)
		(cond 
			(
				(and
					(& (= temp0 (ego onControl: 1)) $4000)
					(not (ego script?))
				)
				(ego setScript: hotFootS)
			)
			((& temp0 $4000))
			(else (= gEgoX (ego x?)) (= gEgoY (ego y?)))
		)
		(if
		(and (ego edgeHit?) (!= egoWalkMode 4) (not local0))
			(= local0 1)
			(ChangeEgoWalk 4 0)
			(HighPrint 560 2)
		)
		(if (not (-- local6))
			(= local6 12)
			(cond 
				((not (ReduceHP 1)) (localproc_000c))
				(local3 (HighPrint 560 3) (= local3 0))
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(flowT dispose: delete:)
		(flameT dispose: delete:)
		(flameT2 dispose: delete:)
		(flameT3 dispose: delete:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/cave')
				)
				(HighPrint 560 4)
			)
			(
				(or
					(Said 'get,acquire<wet')
					(Said 'use,apply,splash/water')
				)
				(cond 
					((and (> currentWater 0) (not local3))
						(HighPrint 560 5)
						(if (< (= currentWater (- currentWater 5)) 0)
							(= currentWater 0)
						)
						(= local6 120)
						(= local3 1)
					)
					(local3 (HighPrint 560 6))
					(else (HighPrint 560 7))
				)
			)
			(
				(Said
					'put,deposit,extinguish,douse,(turn<off)/lamp,light'
				)
				(HighPrint 560 8)
				(ChangeEgoWalk 0 0)
			)
			((Said 'use,rub,rub,light,(turn<on)/lamp,light') (HighPrint 560 9) (ChangeEgoWalk 4 0))
		)
	)
	
	(method (cue)
		(super cue: &rest)
		(if (not (Btst 118)) (HighPrint 560 1) (Bset 118))
	)
)

(instance flame of Prop
	(properties
		noun '/fire,flame,geyser'
		description {the flaming geyser}
		lookStr {The flaming geysers seem to spout at predictable intervals.}
		view 560
		signal $0010
		cycleSpeed 1
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(<= 2 cel)
				(<= cel 4)
				(< (ego distanceTo: self) 24)
			)
			(ego setScript: singeS)
		)
	)
)

(instance flow of Prop
	(properties
		noun '/lava'
		description {lava flow}
		lookStr {The molten lava gives off an intermittent glow and abundant heat.}
		view 560
		loop 1
		signal $0010
		cycleSpeed 1
	)
)

(instance hotFootS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 561
					loop: (Random 0 1)
					cel: 0
					illegalBits: 0
					setCycle: End self
				)
			)
			(1
				(ego
					view: 561
					loop: (Random 0 1)
					cel: 0
					posn: gEgoX gEgoY
					setCycle: End self
				)
			)
			(2
				(if (< (++ local1) 6)
					(self changeState: 1)
				else
					(= local1 0)
					(self cue:)
				)
			)
			(3
				(if (ReduceHP 5)
					(proc1_19)
					(= cycles 4)
				else
					(localproc_000c)
				)
			)
			(4
				(if (not local2) (HighPrint 560 10) (= local2 1))
				(self dispose:)
			)
		)
	)
)

(instance singeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(FaceObject ego client 0 self)
			)
			(1
				(ego view: 19 cel: 0 setCycle: Full 1)
				(= seconds 2)
			)
			(2
				(if (ReduceHP 10)
					(proc1_19)
					(= cycles 4)
				else
					(localproc_000c)
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance flameT of Timer
	(properties)
	
	(method (cue)
		(super cue: &rest)
		(if (> (++ local7) 11) (= local7 0))
		(flame
			posn: [local28 (* local7 2)] [local28 (+ (* local7 2) 1)] 10
			priority: [local52 local7]
			show:
			setCycle: End
		)
		(gMiscMusic number: 561 loop: 1 play:)
		(self setCycle: self [local13 local7])
	)
)

(instance flameT2 of Timer
	(properties)
	
	(method (cue)
		(super cue: &rest)
		(if (> (++ local8) 11) (= local8 0))
		(newFlame
			posn: [local28 (* local8 2)] [local28 (+ (* local8 2) 1)] 10
			priority: [local52 local8]
			show:
			setCycle: End
		)
		(gMiscMusic number: 561 loop: 1 play:)
		(self setCycle: self [local13 local8])
	)
)

(instance flameT3 of Timer
	(properties)
	
	(method (cue)
		(super cue: &rest)
		(if (> (++ local9) 11) (= local9 0))
		(newFlame_2
			posn: [local28 (* local9 2)] [local28 (+ (* local9 2) 1)] 10
			priority: [local52 local9]
			show:
			setCycle: End
		)
		(gMiscMusic number: 561 loop: 1 play:)
		(self setCycle: self [local13 local9])
	)
)

(instance flowT of Timer
	(properties)
	
	(method (cue)
		(super cue: &rest)
		(if (== (++ local10) 8) (= local10 0))
		(flow
			posn: [local64 (* local10 2)] [local64 (+ (* local10 2) 1)]
		)
		(self setCycle: self (Random 6 15))
	)
)

(instance kludge of TargActor
	(properties
		x 100
		y 100
		view 560
		signal $4000
		illegalBits $0000
	)
	
	(method (calmMe &tmp temp0)
		(= temp0 (/ [skills 18] 10))
		(flameT setCycle: flameT 0 setReal: flameT temp0)
		(if (>= arcadeDifficultyLevel 2)
			(flameT2 setCycle: flameT2 0 setReal: flameT2 temp0)
			(if (>= arcadeDifficultyLevel 3)
				(flameT3 setCycle: flameT3 0 setReal: flameT3 temp0)
			)
		)
		(return 1)
	)
	
	(method (detectMe)
		(HighPrint 560 11)
		(return 1)
	)
)
