;;; Sierra Script 1.0 - (do not remove this comment)
(script# 570)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use StairScript)
(use TargActor)
(use Full)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm570 0
)

(local
	local0
	local1
	[local2 2]
	local4
	local5
	local6
	local7
	local8
	local9
)
(instance rm570 of Rm
	(properties
		picture 570
		style $0028
	)
	
	(method (init)
		(LoadMany 129 580 570)
		(LoadMany 128 570 571 575 576 3 585 572 586)
		(LoadMany 132 600 570)
		(ChangeEgoWalk 4 0)
		(= gGDftSC gAllSC)
		(if (Btst 107)
			(rocks cel: 4)
		else
			(air setCycle: Fwd init:)
		)
		(rocks init:)
		(water1 setCycle: Fwd init:)
		(water2 setCycle: Fwd init:)
		(water3 setCycle: Fwd init:)
		(if (>= gSeconds 1)
			(water4 setCycle: Fwd init:)
			(water5 setCycle: Fwd init:)
			(water6 setCycle: Fwd init:)
			(if (>= gSeconds 2)
				(water7 setCycle: Fwd init:)
				(water8 setCycle: Fwd init:)
				(water9 setCycle: Fwd init:)
				(water10 setCycle: Fwd init:)
			)
		)
		(wallShine init: hide:)
		(proc1_31 stairFeat fallFeat1 fallFeat2)
		(ego
			setScript:
				(if (< (ego y?) 85)
					(= defaultPalette 1)
					(super init:)
					(wallShine show:)
					comeBackIn
				else
					(= defaultPalette 0)
					(super init:)
					comeIn
				)
		)
		(self setScript: loggerScript)
		(gCMusic number: 600 loop: -1 playBed:)
		(gMiscMusic number: 570 loop: -1 play:)
	)
	
	(method (doit &tmp temp0)
		(= local0 (ego onControl: 1))
		(= temp0 (not (ego script?)))
		(cond 
			((and (& local0 $0040) temp0) (ego setScript: toDownAirRm))
			((and (& local0 $0002) temp0) (ego setScript: toUpAirRm))
			((and (& local0 $0008) temp0) (ego setScript: rockStairs))
			((and (& local0 $0010) temp0) (ego setScript: downStairs))
			((and (& local0 $0020) temp0) (ego setScript: downStream))
			(
				(and
					(ego inRect: 26 113 91 158)
					(not (Btst 107))
					temp0
				)
				(ego setScript: suckedIn)
			)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/cave,wall,ceiling,roof')
				)
				(HighPrint 570 0)
			)
			(
			(Said 'cast,deposit,use,throw,climb,scale/rope[<magic]')
				(if (ego has: 16)
					(HighPrint 570 1)
				else
					(HighPrint 570 2)
				)
				(pEvent claimed: 1)
			)
			((Said 'cast,throw')
				(if (== (ego view?) 575)
					(HighPrint 570 3)
					(pEvent claimed: 1)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'climb,scale') (HighPrint 570 4))
			((Said 'use,rub,rub,light,(turn<on)/lamp,light') (HighPrint 570 5) (ChangeEgoWalk 4 0))
			((Said 'put,deposit,extinguish,douse/lamp,light') (HighPrint 570 6) (wallShine hide:) (ChangeEgoWalk 0 0))
			((Said 'swim,(go<swim)') (Print 570 7))
			((Said 'block/chasm')
				(cond 
					((Btst 107) (HighPrint 570 8))
					((< (ego y?) 75) (Print 570 9))
					((not local6) (HighPrint 570 10))
					(else (HighPrint 570 11) (Print 570 12))
				)
			)
			((Said 'get,acquire,fill/water,waterbag')
				(if (ego has: 37)
					(HighPrint 570 13)
				else
					(HighPrint 570 14)
				)
			)
			(
				(or
					(Said 'lockpick[/lock]')
					(Said 'use/(lockpick[<lock]),lockpick')
					(Said 'unlock')
					(Said 'use/lockpick,implement,kit')
				)
				(cond 
					((Btst 107) (HighPrint 570 8))
					((not (CanPickLocks 1)))
					(else (ego setScript: pryRocks))
				)
			)
			(
				(or
					(Said 'pry,lockpick/boulder,brick')
					(Said 'use/dagger')
				)
				(cond 
					((Btst 107) (HighPrint 570 8))
					((not (if [invNum 5] else [invNum 56])) (PrintDontHaveIt))
					(else (ego setScript: pryRocks))
				)
			)
			(
				(or
					(Said 'use/strength')
					(Said
						'force,force,shake,move,dislodge/brick,boulder,brick'
					)
				)
				(if (Btst 107)
					(HighPrint 570 8)
				else
					(ego setScript: ramRocks)
				)
			)
			((Said 'cast')
				(if (< (ego x?) 42)
					(HighPrint 570 15)
					(pEvent claimed: 1)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'hop[<on,off][/log]')
				(cond 
					((< (ego y?) 75) (Print 570 16))
					(local6 (ego setScript: jumpInSpot))
					((and local5 local1) (= local1 0) (ego setScript: offBoard))
					((and local1 (< (loggerScript state?) 30)) (HighPrint 570 17))
					(local1 (HighPrint 570 18) (HighPrint 570 19))
					((== local0 2048) (ego setScript: inDrink))
					((not (== local0 128)) (Print 570 20))
					((== arcadeDifficultyLevel 1) (ego setScript: smartOnBoard))
					(
						(and
							(==
								(cond 
									(
										(and
											(<= 12 (loggerScript state?))
											(<= (loggerScript state?) 17)
										)
										1
									)
									((>= (loggerScript state?) 18) 2)
									(else 0)
								)
								0
							)
							(== arcadeDifficultyLevel 2)
						)
						(ego setScript: smartOnBoard)
					)
					(
						(==
							(cond 
								(
									(and
										(<= 12 (loggerScript state?))
										(<= (loggerScript state?) 17)
									)
									1
								)
								((>= (loggerScript state?) 18) 2)
								(else 0)
							)
							1
						)
						(ego setScript: onBoard)
					)
					(else (= local4 1) (= local9 1) (ego setScript: inDrink))
				)
			)
		)
	)
)

(instance loggerScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(log illegalBits: 0 setPri: 14)
				(= cycles 1)
			)
			(1
				(log loop: 0 cel: 0 posn: 65 22)
				(= cycles 1)
			)
			(2
				(log setPri: 14 posn: 73 28)
				(= cycles 1)
			)
			(3
				(log posn: 81 37)
				(= cycles 1)
			)
			(4
				(log cel: 1 posn: 88 45)
				(= cycles 1)
			)
			(5
				(log posn: 94 55)
				(= cycles 1)
			)
			(6
				(log cel: 2 setPri: 4 posn: 96 65)
				(= cycles 1)
			)
			(7
				(log setPri: 4 posn: 97 84)
				(= cycles 1)
			)
			(8
				(log loop: 1 cel: 0 posn: 98 103)
				(= cycles 1)
			)
			(9
				(log cel: 1 posn: 99 104)
				(= cycles 1)
			)
			(10
				(log cel: 2 posn: 99 104)
				(= cycles 1)
			)
			(11
				(log cel: 3 posn: 108 110)
				(= cycles 1)
			)
			(12
				(log loop: 2 cel: 0 posn: 115 112)
				(= cycles 1)
			)
			(13
				(log cel: 0 posn: 120 113)
				(= cycles 1)
			)
			(14
				(log posn: 126 114)
				(= cycles 1)
			)
			(15
				(log posn: 140 115)
				(= cycles 1)
			)
			(16
				(log posn: 142 117)
				(= cycles 1)
			)
			(17
				(log posn: 143 120)
				(= cycles 1)
			)
			(18
				(log posn: 145 122)
				(= cycles 1)
			)
			(19
				(log posn: 147 124)
				(= cycles 1)
			)
			(20
				(log posn: 149 127)
				(= cycles 1)
			)
			(21
				(log posn: 151 129)
				(= cycles 1)
			)
			(22
				(log posn: 153 131)
				(= cycles 1)
			)
			(23
				(log posn: 156 133)
				(= cycles 1)
			)
			(24
				(log posn: 158 135)
				(= cycles 1)
			)
			(25
				(log posn: 161 138)
				(= cycles 1)
			)
			(26
				(log posn: 164 141)
				(= cycles 1)
			)
			(27
				(log posn: 166 143)
				(= cycles 1)
			)
			(28
				(log posn: 168 145)
				(= cycles 1)
			)
			(29
				(log posn: 171 147)
				(= cycles 1)
			)
			(30
				(log posn: 173 149)
				(= local5 1)
				(= cycles 1)
			)
			(31
				(log posn: 180 152)
				(= cycles 1)
			)
			(32
				(log posn: 184 152)
				(= cycles 1)
			)
			(33
				(log posn: 188 152)
				(= cycles 1)
			)
			(34
				(log posn: 193 152)
				(= cycles 1)
			)
			(35
				(log posn: 197 154)
				(= cycles 1)
			)
			(36
				(log cel: 2 posn: 203 155)
				(= cycles 1)
			)
			(37
				(log posn: 208 157)
				(= cycles 1)
			)
			(38
				(log posn: 212 160)
				(= cycles 1)
			)
			(39
				(log posn: 213 162)
				(= cycles 1)
			)
			(40
				(log posn: 214 165)
				(= cycles 1)
			)
			(41
				(log posn: 215 168)
				(= cycles 1)
			)
			(42
				(log posn: 216 172)
				(= cycles 1)
				(= local5 0)
			)
			(43
				(log posn: 217 179)
				(= cycles 1)
			)
			(44
				(log cel: 3 posn: 217 188)
				(= cycles 1)
			)
			(45
				(log
					posn: 217 195
					setStep: 2 12
					setMotion: MoveTo 217 220 self
				)
				(if local1
					(ego
						setLoop: 7
						cel: 0
						setStep: 3 12
						posn: 213 170
						setCycle: Fwd
					)
				)
			)
			(46
				(if local1
					(ego
						setCycle: End
						setStep: 4 12
						setMotion: MoveTo 216 250 self
					)
				else
					(self cue:)
				)
			)
			(47
				(log setMotion: 0 setCycle: 0)
				(if local1
					(if (== (Random 0 1) 0)
						(Die
							0
							{No, dude!__It's down.__Far down.__WIPE OUT!}
							80
							{Surf's up?}
							82
							570
							2
							3
						)
					else
						(Die
							0
							{You have fallen just off screen to the jagged rocks below.}
							80
							{Yeeeooooow!}
							82
							570
							2
							3
						)
					)
				)
				(= seconds (Random 3 7))
			)
			(48 (self changeState: 0))
		)
		(if local1
			(ego setLoop: 2 posn: (+ (log x?) 8) (- (log y?) 13))
		)
	)
)

(instance downStream of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					(local4 (= cycles 8))
					(local6 (self setScript: longStep self))
					(else
						(ego
							illegalBits: 0
							ignoreActors: 1
							view: 575
							setLoop: 4
							cel: 0
							xStep: 2
							yStep: 2
							posn: (- (ego x?) 4) (+ (ego y?) 10)
							setCycle: End self
						)
					)
				)
			)
			(1
				(ego setLoop: 6)
				(cond 
					((< (ego y?) 104) (self cue:))
					((< (ego y?) 110) (self changeState: 4))
					((< (ego y?) 120) (self changeState: 9))
					((< (ego y?) 135) (self changeState: 15))
					((< (ego y?) 155) (self changeState: 26))
					((< (ego y?) 170) (self changeState: 31))
					(else (self changeState: 33))
				)
			)
			(2
				(ego cel: 0 posn: 132 107)
				(= cycles 1)
			)
			(3
				(ego cel: 1 posn: 134 108)
				(= cycles 1)
			)
			(4
				(ego cel: 2 posn: 136 109)
				(= cycles 1)
			)
			(5
				(ego cel: 3 posn: 138 111)
				(= cycles 1)
			)
			(6
				(ego cel: 2 posn: 142 113)
				(= cycles 1)
			)
			(7
				(ego cel: 1 posn: 148 115)
				(= cycles 1)
			)
			(8
				(ego cel: 0 posn: 151 117)
				(= cycles 1)
			)
			(9
				(ego cel: 1 posn: 155 119)
				(= cycles 1)
			)
			(10
				(ego cel: 2 posn: 159 121)
				(= cycles 1)
			)
			(11
				(ego cel: 3 posn: 162 123)
				(= cycles 1)
			)
			(12
				(ego cel: 2 posn: 165 126)
				(= cycles 1)
			)
			(13
				(ego cel: 1 posn: 168 129)
				(= cycles 1)
			)
			(14
				(ego cel: 2 posn: 171 131)
				(= cycles 1)
			)
			(15
				(ego cel: 3 posn: 174 134)
				(= cycles 1)
			)
			(16
				(ego cel: 1 posn: 177 137)
				(= cycles 1)
			)
			(17
				(ego cel: 2 posn: 182 139)
				(= cycles 1)
			)
			(18
				(ego cel: 3 posn: 187 141)
				(= cycles 1)
			)
			(19
				(ego cel: 1 posn: 193 143)
				(= cycles 1)
			)
			(20
				(ego cel: 0 posn: 201 144)
				(= cycles 1)
			)
			(21
				(ego cel: 1 posn: 210 145)
				(= cycles 1)
			)
			(22
				(ego cel: 2 posn: 219 146)
				(= cycles 1)
			)
			(23
				(ego cel: 1 posn: 223 148)
				(= cycles 1)
			)
			(24
				(ego cel: 0 posn: 229 149)
				(= cycles 1)
			)
			(25
				(ego cel: 1 posn: 233 150)
				(= cycles 1)
			)
			(26
				(ego cel: 2 posn: 231 154)
				(= cycles 1)
			)
			(27
				(ego cel: 3 posn: 230 158)
				(= cycles 1)
			)
			(28
				(ego cel: 2 posn: 226 160)
				(= cycles 1)
			)
			(29
				(ego cel: 1 posn: 222 161)
				(= cycles 1)
			)
			(30
				(ego cel: 2 posn: 218 163)
				(= cycles 1)
			)
			(31
				(ego cel: 1 posn: 215 166)
				(= cycles 1)
			)
			(32
				(ego cel: 2 posn: 211 169)
				(= cycles 1)
			)
			(33
				(ego
					setLoop: 7
					cel: 0
					yStep: 14
					posn: 199 204
					setCycle: Fwd
					setMotion: MoveTo 199 230 self
				)
			)
			(34
				(if local9
					(Die
						0
						{Well, would you believe good idea, but bad timing?}
						80
						{Missed it by that much}
						82
						570
						3
						0
					)
				else
					(Die
						0
						{The swift current overwhelms you with emotions as it sweeps you off your feet and carries you away with it.}
						80
						{Swept away}
						82
						570
						3
						0
					)
				)
				(self dispose:)
			)
		)
	)
)

(instance comeIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(log init:)
				(ego
					posn: 319 mouseY
					init:
					illegalBits: 0
					setCycle: Walk
					setMotion: MoveTo 300 mouseY self
				)
			)
			(1 (proc1_19) (self dispose:))
		)
	)
)

(instance comeBackIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local6 1)
				(log init:)
				(ego
					posn: 319 mouseY
					init:
					illegalBits: 0
					setCycle: Walk
					setPri: 2
					setMotion: MoveTo 311 67 self
				)
				(Bset 116)
			)
			(1
				(ego setMotion: MoveTo 291 50 self)
			)
			(2
				(proc1_19)
				(ego setPri: 2)
				(self dispose:)
			)
		)
	)
)

(instance smartOnBoard of HandsOffScript
	(properties)
	
	(method (doit)
		(super doit:)
		(switch state
			(1
				(if
					(!=
						(cond 
							(
								(and
									(<= 12 (loggerScript state?))
									(<= (loggerScript state?) 17)
								)
								1
							)
							((>= (loggerScript state?) 18) 2)
							(else 0)
						)
						2
					)
					(self cue:)
				)
			)
			(2
				(if
					(==
						(cond 
							(
								(and
									(<= 12 (loggerScript state?))
									(<= (loggerScript state?) 17)
								)
								1
							)
							((>= (loggerScript state?) 18) 2)
							(else 0)
						)
						1
					)
					(self cue:)
				)
			)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self
					changeState:
						(cond 
							(
								(<=
									(cond 
										(
											(and
												(<= 12 (loggerScript state?))
												(<= (loggerScript state?) 17)
											)
											1
										)
										((>= (loggerScript state?) 18) 2)
										(else 0)
									)
									0
								)
								2
							)
							(
								(==
									(cond 
										(
											(and
												(<= 12 (loggerScript state?))
												(<= (loggerScript state?) 17)
											)
											1
										)
										((>= (loggerScript state?) 18) 2)
										(else 0)
									)
									2
								)
								1
							)
							(
								(==
									(cond 
										(
											(and
												(<= 12 (loggerScript state?))
												(<= (loggerScript state?) 17)
											)
											1
										)
										((>= (loggerScript state?) 18) 2)
										(else 0)
									)
									1
								)
								(client setScript: onBoard)
							)
						)
				)
			)
			(1 (Print 570 21))
			(2 0)
			(3 (client setScript: onBoard))
		)
	)
)

(instance onBoard of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(SetControl 1)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 575
					setLoop: 0
					cel: 0
					posn: (- (ego x?) 15) (- (ego y?) 2)
					setCycle: End self
				)
			)
			(1
				(ego setLoop: 1 cel: 0 setCycle: End)
				(= local1 1)
				(ego setMotion: MoveTo 158 118 self)
			)
			(2
				(ego
					view: 575
					setLoop: 2
					illegalBits: 0
					ignoreActors:
					setCycle: Fwd
				)
				(loggerScript changeState: 22)
				(self dispose:)
			)
		)
	)
)

(instance offBoard of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo 1)
				(ego
					loop: 3
					cel: 0
					illegalBits: 0
					posn: (- (ego x?) 17) (+ (ego y?) 3)
					setCycle: End
					setMotion: MoveTo 155 150
				)
				(= seconds 2)
			)
			(1
				(ego
					view: 0
					loop: 1
					cel: 0
					illegalBits: -32768
					posn: (- (ego x?) 17) (+ (ego y?) 3)
				)
				(= cycles 1)
			)
			(2
				(= local6 1)
				(proc1_19)
				(SetControl 0)
				(LockEgo)
				(self dispose:)
			)
		)
	)
)

(instance inDrink of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 575
					setLoop: 0
					cel: 0
					illegalBits: 0
					posn: (- (ego x?) 14) (- (ego y?) 3)
					setMotion: MoveTo (- (ego x?) 28) (+ (ego y?) 5)
					setCycle: End self
				)
			)
			(1
				(ego
					setLoop: 4
					cel: 0
					setCycle: End
					setMotion: MoveTo (- (ego x?) 5) (ego y?)
				)
				(= cycles 12)
			)
			(2
				(= local4 1)
				(client setScript: downStream)
			)
		)
	)
)

(instance jumpInSpot of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 575
					loop: 0
					cel: 0
					posn: (- (ego x?) 4) (+ (ego y?) 1)
					setCycle: Full 1 self
				)
			)
			(1
				(ego
					view: 0
					setLoop: 1
					cel: 0
					posn: (+ (ego x?) 4) (- (ego y?) 1)
				)
				(= cycles 1)
			)
			(2 (proc1_19) (self dispose:))
		)
	)
)

(instance suckedIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0 setCycle: 0 setHeading: 270 self)
			)
			(1
				(ego
					view: 575
					setLoop: 9
					setCycle: CT 4 1
					setMotion: MoveTo 27 131 self
				)
			)
			(2
				(if (not local7) (HighPrint 570 22) (= local7 1))
				(ego
					setCel: -1
					cel: 0
					cycleSpeed: 1
					setCycle: CT 2 -1 self
				)
			)
			(3 (ego setCycle: CT 4 1 self))
			(4 (ego setCycle: CT 2 -1 self))
			(5 (ego setCycle: End self))
			(6
				(ego
					view: 585
					setCel: -1
					setLoop: 3
					setCycle: Walk
					cycleSpeed: 0
					setMotion: MoveTo 50 112 self
				)
			)
			(7
				(proc1_19)
				(ego setHeading: 180 self)
			)
			(8
				(HighPrint 570 23)
				(self dispose:)
			)
		)
	)
)

(instance ramRocks of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 41 130 self)
			)
			(1 (ego setHeading: 0 self))
			(2
				(ego view: 576 setLoop: 0 cel: 0 setCycle: End self)
			)
			(3
				(ShakeScreen 1 1)
				(= cycles 8)
			)
			(4
				(ReduceSP 20)
				(if (TestSkill 0 125)
					(self setScript: rocksFall self)
				else
					(self cue:)
				)
			)
			(5 (self cue:))
			(6
				(if (not (Btst 107)) (Print 570 24))
				(ego loop: 3)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance pryRocks of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 39 124 self)
			)
			(1 (ego setHeading: 270 self))
			(2
				(ego
					view: 572
					setLoop: 0
					cel: 0
					setMotion: MoveTo 19 128
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(3
				(ego setLoop: 1 cycleSpeed: 0 setCycle: Fwd)
				(= seconds 3)
			)
			(4
				(ego setLoop: 2 setCycle: 0 cel: 0)
				(if (PickLock 80 1 0)
					(self setScript: rocksFall self)
				else
					(= cycles 1)
				)
			)
			(5
				(ego cycleSpeed: 1 setCycle: End self)
			)
			(6
				(proc1_19)
				(ego
					ignoreActors:
					illegalBits: 0
					setMotion: MoveTo 30 135 self
				)
			)
			(7 (self dispose:))
		)
	)
)

(instance rocksFall of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (rocks setCycle: End self))
			(1
				(rocks
					ignoreActors:
					lookStr: {The rocks lie in a heap, blocking the hole.}
					stopUpd:
				)
				(air dispose:)
				(AddToScore 633 7)
				(Bset 107)
				(= cycles 4)
			)
			(2
				(Print 570 25)
				(self dispose:)
			)
		)
	)
)

(instance knockRocks of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local7 1)
				(SetControl 1)
				(ego illegalBits: 0 setMotion: MoveTo 26 142 self)
			)
			(1 (ego setHeading: 0 self))
			(2
				(ego view: 575 loop: 9 cel: 0 setCycle: End self)
				(++ local8)
			)
			(3
				(if (< local8 3)
					(self changeState: 2)
				else
					(self cue:)
				)
			)
			(4
				(if (< [skills 0] 80)
					(Print 570 26)
				else
					(rocks setCycle: End)
					(air dispose:)
				)
				(= seconds 2)
			)
			(5
				(ego view: 0 setLoop: 3 cel: 0)
				(= cycles 1)
			)
			(6
				(proc1_19)
				(ego
					illegalBits: 0
					setMotion: MoveTo (+ (ego x?) 10) (ego y?) self
				)
			)
			(7
				(SetControl 0)
				(ego illegalBits: -32768)
				(= local8 0)
				(self dispose:)
			)
		)
	)
)

(instance rockStairs of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 41 108 self)
			)
			(1
				(client setScript: climbStairs)
			)
		)
	)
)

(instance climbStairs of StairScript
	(properties
		stairSize 10
		numStairs 7
	)
	
	(method (init)
		(= goingUp 1)
		(super init: &rest)
	)
	
	(method (doit)
		(ego x: (- (ego x?) 1))
		(super doit:)
	)
	
	(method (dispose)
		(= defaultPalette 1)
		(curRoom drawPic: 570 7)
		(wallShine posn: (ego x?) (- (ego y?) 30) show:)
		(super dispose:)
		(proc1_19)
		(ego setPri: 2)
	)
)

(instance downStairs of StairScript
	(properties
		stairSize 10
		numStairs 6
	)
	
	(method (init)
		(ego setPri: -1)
		(wallShine hide:)
		(= next awayFromStepsDown)
		(= goingUp 0)
		(super init: &rest)
	)
	
	(method (doit)
		(ego x: (+ (ego x?) 1))
		(super doit:)
	)
	
	(method (dispose)
		(super dispose:)
	)
)

(instance awayFromStepsDown of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(proc1_19)
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo 55 113 self
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance toUpAirRm of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 313 67 self)
			)
			(1 (ego setHeading: 90 self))
			(2
				(ego setMotion: MoveTo 320 (ego y?) self)
			)
			(3
				(if (!= egoWalkMode 4)
					(ChangeEgoWalk 4 0)
					(HighPrint 570 27)
				)
				(= cycles 2)
			)
			(4
				(= mouseY (ego y?))
				(curRoom newRoom: 580)
			)
		)
	)
)

(instance toDownAirRm of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setLoop: 0 setMotion: MoveTo 320 (ego y?) self)
			)
			(1
				(if (!= egoWalkMode 4)
					(ChangeEgoWalk 4 0)
					(HighPrint 570 27)
				)
				(= cycles 2)
			)
			(2
				(= mouseY (ego y?))
				(curRoom newRoom: 580)
			)
		)
	)
)

(instance longStep of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					illegalBits: 0
					ignoreActors: 1
					view: 575
					setLoop: 5
					cel: 0
					posn: (+ (ego x?) 7) (+ (ego y?) 5)
				)
				(= cycles 1)
			)
			(1
				(ego cel: 1 posn: (+ (ego x?) 5) (- (ego y?) 9))
				(= cycles 1)
			)
			(2
				(ego cel: 2 posn: (+ (ego x?) 5) (ego y?))
				(= cycles 1)
			)
			(3
				(ego cel: 3 posn: (+ (ego x?) 3) (ego y?))
				(= cycles 1)
			)
			(4
				(ego cel: 4 posn: (+ (ego x?) 9) (ego y?))
				(= cycles 1)
			)
			(5 (ego setCycle: End self))
			(6 (self dispose:))
		)
	)
)

(instance log of TargActor
	(properties
		x 59
		y 19
		noun '/log,forest,board,debris'
		description {the log}
		lookStr {The old logs and other debris come from above.__The rushing water carries them deep into the caverns far below.}
		view 570
		signal $4000
		illegalBits $0000
	)
	
	(method (fetchMe)
		(Print 570 28)
		(return 1)
	)
	
	(method (hurtMe param1 param2)
		(return
			(if (== (param2 type?) 25)
				(loggerScript cycles: 0 changeState: 0)
				(self posn: 150 220)
				(return 1)
			else
				0
			)
		)
	)
)

(instance rocks of TargActor
	(properties
		x 12
		y 125
		noun '/brick,boulder,base'
		description {the rocks}
		view 575
		loop 10
		priority 4
		signal $4010
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if local6 (HighPrint 570 29) else (HighPrint 570 30))
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (detectMe)
		(Print 570 31)
		(return 1)
	)
	
	(method (hurtMe param1 param2)
		(switch (param2 type?)
			(25 (Print 570 33))
			(27
				(cond 
					((Btst 107) (HighPrint 570 8))
					((> hitY 109) (self setScript: rocksFall))
					(else (Print 570 34))
				)
			)
			(else  (return 0))
		)
		(return 1)
	)
	
	(method (openMe)
		(Print 570 32)
		(self setScript: rocksFall)
	)
)

(instance air of Prop
	(properties
		x 4
		y 141
		z 30
		noun '/air,wind,chasm,airhole,opening'
		description {the wind}
		lookStr {Great volumes of air are being sucked into this small hole.}
		view 571
		signal $4000
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance water1 of Prop
	(properties
		x 77
		y 26
		description {}
		lookStr 13252
		view 570
		loop 3
		cel 1
		priority 5
		signal $4010
		cycleSpeed 1
	)
)

(instance water2 of Prop
	(properties
		x 176
		y 182
		description {}
		lookStr {The lower cascade falls seemingly forever to the rocks below.}
		view 570
		loop 8
		priority 3
		signal $4010
		cycleSpeed 1
	)
)

(instance water3 of Prop
	(properties
		x 222
		y 184
		description {}
		lookStr {The lower cascade falls seemingly forever to the rocks below.}
		view 570
		loop 8
		cel 1
		priority 3
		signal $4010
		cycleSpeed 1
	)
)

(instance water4 of Prop
	(properties
		x 103
		y 98
		description {}
		lookStr {The rushing river boils furiously.}
		view 570
		loop 5
		cel 2
		priority 3
		signal $4010
		cycleSpeed 1
	)
)

(instance water5 of Prop
	(properties
		x 81
		y 39
		description {}
		lookStr 13252
		view 570
		loop 4
		cel 3
		priority 5
		signal $4010
		cycleSpeed 1
	)
)

(instance water6 of Prop
	(properties
		x 92
		y 61
		description {}
		lookStr 13252
		view 570
		loop 4
		priority 3
		signal $4010
		cycleSpeed 1
	)
)

(instance water7 of Prop
	(properties
		x 81
		y 59
		description {}
		lookStr 13252
		view 570
		loop 4
		cel 2
		priority 5
		signal $4010
		cycleSpeed 1
	)
)

(instance water8 of Prop
	(properties
		x 81
		y 48
		description {}
		lookStr 13252
		view 570
		loop 4
		cel 2
		priority 5
		signal $4010
		cycleSpeed 1
	)
)

(instance water9 of Prop
	(properties
		x 90
		y 75
		description {}
		lookStr 13252
		view 570
		loop 4
		cel 3
		priority 5
		signal $4010
		cycleSpeed 1
	)
)

(instance water10 of Prop
	(properties
		x 94
		y 87
		description {}
		lookStr 13252
		view 570
		loop 4
		priority 5
		signal $4010
		cycleSpeed 1
	)
)

(instance wallShine of Actor
	(properties
		x 43
		y 17
		view 586
		loop 1
		signal $4810
		illegalBits $0000
	)
	
	(method (doit)
		(if
			(and
				(not (& signal $0080))
				(Btst 116)
				(== (ego view?) 585)
			)
			(switch (ego loop?)
				(0
					(self posn: (+ (ego x?) 10) (- (ego y?) 20))
				)
				(1
					(self posn: (- (ego x?) 10) (- (ego y?) 20))
				)
				(2
					(self posn: (ego x?) (- (ego y?) 20))
				)
				(3
					(self posn: (ego x?) (- (ego y?) 30))
				)
				(4
					(self posn: (+ (ego x?) 12) (- (ego y?) 15))
				)
				(5
					(self posn: (- (ego x?) 20) (- (ego y?) 20))
				)
				(6
					(self posn: (+ (ego x?) 12) (- (ego y?) 25))
				)
				(else 
					(self posn: (- (ego x?) 20) (- (ego y?) 20))
				)
			)
		)
		(super doit:)
	)
)

(instance stairFeat of Feature
	(properties
		x 30
		y 80
		noun '/ladder,step'
		nsTop 54
		nsLeft 14
		nsBottom 100
		nsRight 58
		description {the steps}
		lookStr {Near the waterfall, the stone has formed into a natural stairway.}
	)
)

(instance fallFeat1 of Feature
	(properties
		x 90
		y 80
		noun '/cascade,water'
		nsLeft 45
		nsBottom 50
		nsRight 110
		description {the waterfall}
		lookStr {The rushing river surges from above to form a raging waterfall.}
	)
)

(instance fallFeat2 of Feature
	(properties
		x 90
		y 90
		noun '/cascade,cascade'
		nsTop 50
		nsLeft 65
		nsBottom 97
		nsRight 135
		description {the waterfall}
		lookStr {The rushing river surges from above to form a raging waterfall.}
	)
)
