;;; Sierra Script 1.0 - (do not remove this comment)
(script# 600)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TargActor)
(use Intrface)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm600 0
)

(local
	local0
	local1
	local2
	local3
)
(procedure (localproc_000c)
	(HighPrint 600 0)
)

(instance rm600 of Rm
	(properties
		picture 600
		style $0006
	)
	
	(method (init)
		(LoadMany 128 585 586 600 601 602 603)
		(LoadMany 132 601 602 603 551)
		(AddToScore 637 7)
		(treas1 init: stopUpd:)
		(treas2 init: stopUpd:)
		(treas3 init: stopUpd:)
		(treas4 init: stopUpd:)
		(treas5 init: stopUpd:)
		(armor init: stopUpd:)
		(if (Btst 116)
			(glow setPri: 0 init:)
			(floorShine init:)
		else
			(glow setPri: 0 init: stopUpd:)
			(floorShine init: hide:)
		)
		(dr1 init:)
		(dr2 init:)
		(dr3 init: stopUpd:)
		(ego posn: 295 61 init:)
		(= gGDftSC gAllSC)
		(if (Btst 116)
			(= defaultPalette 0)
		else
			(= defaultPalette 2)
		)
		(super init:)
		(self setScript: comeIn)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(Btst 116)
					(< (ego x?) (glow x?))
					(< (ego distanceTo: glow) 30)
				)
				(if (not (== (glow priority?) 1)) (glow setPri: 1))
			)
			((not (== (glow priority?) 0)) (glow setPri: 0))
		)
		(if
		(and (& (ego onControl: 1) $0002) (== local0 0))
			(= local0 1)
			(ego setScript: nextRoom)
		)
		(cond 
			((not local2))
			((-- local2))
			(else (Die 1 600 1))
		)
		(super doit:)
	)
	
	(method (dispose)
		(= defaultPalette 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'search,look,examine[<at,around][/room,area][/!*]') (if (Btst 116) (HighPrint 600 2) else (localproc_000c)))
			((Said 'look,examine>')
				(cond 
					((Said '<up') (if (Btst 116) (HighPrint 600 3) else (localproc_000c)))
					((Said '<down') (if (Btst 116) (HighPrint 600 4) else (localproc_000c)))
				)
			)
			((Said 'walk') (HighPrint 600 5))
			((Said 'run,sneak') (HighPrint 600 6))
			((Said 'use,rub,rub,light,(turn<on)/lamp,light')
				(SetControl 0)
				(= local2 0)
				(Bset 116)
				(cast eachElementDo: #show)
				(ego view: 585 setCycle: Walk)
				(= defaultPalette 0)
				(curRoom drawPic: 600)
			)
			(
				(Said
					'put,deposit,extinguish,douse,(turn<off)/lamp,light'
				)
				(HighPrint 600 7)
				(ego setScript: tooDark)
			)
			(
				(Said
					'grab,acquire,get,acquire/loot,gem,gold,chest,armor'
				)
				(cond 
					((not (Btst 116)) (localproc_000c))
					(
						(or
							(< (ego distanceTo: treas1) 50)
							(< (ego distanceTo: treas2) 50)
							(< (ego distanceTo: treas3) 40)
							(< (ego distanceTo: treas4) 40)
							(< (ego distanceTo: treas5) 50)
						)
						(ego setScript: friedEgo)
					)
					((ego inRect: 113 86 201 108) (ego setScript: downTheTube))
					(else (ego setScript: dropStag))
				)
			)
			((Said 'look,examine<at/loot,gem,gold')
				(if (not (Btst 116))
					(localproc_000c)
				else
					(Print 600 8)
				)
			)
			((Said 'cast/trigger,fetch')
				(cond 
					((not (Btst 116)) (localproc_000c))
					(
						(or
							(< (ego distanceTo: treas1) 60)
							(< (ego distanceTo: treas2) 60)
							(< (ego distanceTo: treas3) 60)
							(< (ego distanceTo: treas4) 60)
							(< (ego distanceTo: treas5) 70)
						)
						(ego setScript: friedEgo)
					)
					((< (ego distanceTo: armor) 35) (ego setScript: downTheTube))
					(else (ego setScript: dropStag))
				)
			)
			((Said 'cast/open,open')
				(if (Btst 116)
					(ego setScript: downTheTube)
				else
					(localproc_000c)
				)
			)
			((Said 'cast/flame') (ego setScript: friedEgo))
			((Said 'cast/bolt') (ego setScript: dropStag))
		)
	)
)

(instance floorShine of Actor
	(properties
		noun '/reflection,glow'
		description {the reflection of your lamp.}
		lookStr {It is the reflection of your lamp light.}
		view 586
		signal $4800
		illegalBits $0000
	)
	
	(method (doit)
		(if (and (Btst 116) (== (ego view?) 585))
			(self setPri: (- (ego priority?) 1))
			(if (or (ego mover?) local3)
				(if local3 (= local3 0))
				(cond 
					((== (ego loop?) 0) (self posn: (+ (ego x?) 10) (+ (ego y?) 5)))
					((== (ego loop?) 1) (self posn: (- (ego x?) 10) (+ (ego y?) 5)))
					((== (ego loop?) 2) (self posn: (ego x?) (+ (ego y?) 5)))
					((== (ego loop?) 3) (self posn: (ego x?) (- (ego y?) 5)))
					((or (== (ego loop?) 4) (== (ego loop?) 6)) (self posn: (+ (ego x?) 12) (ego y?)))
					((or (== (ego loop?) 5) (== (ego loop?) 7)) (self posn: (- (ego x?) 20) (+ (ego y?) 5)))
				)
			)
		)
		(super doit:)
	)
	
	(method (show)
		(= local3 1)
		(super show: &rest)
	)
)

(instance stag of Actor
	(properties
		description {the stalactite}
		lookStr {Part of the stalactite that fell on you.}
		view 601
		signal $4000
		illegalBits $0000
	)
)

(instance stag2 of Actor
	(properties
		description {the stalactite}
		lookStr {Part of the stalactite that fell on you.}
		view 601
		loop 2
		signal $5800
		illegalBits $0000
	)
)

(instance lamp of Actor
	(properties
		noun '/light,lamp'
		description {the lamp}
		lookStr {Its your lamp that you've been carrying around.}
		view 586
		loop 2
		signal $4000
		illegalBits $0000
	)
)

(instance trapDoor of Prop
	(properties
		description {the trapdoor}
		lookStr {Bye bye!!}
		view 603
		signal $4000
	)
)

(instance treas1 of Prop
	(properties
		x 38
		y 152
		noun '/loot,gold,gem'
		description {the jewels and gold}
		view 601
		loop 5
		cel 2
		priority 14
		signal $4010
	)
	
	(method (doit)
		(if (Btst 116)
			(if (and (== (ego loop?) 6) (not cel))
				(self setCycle: End)
			)
			(cond 
				(
					(and
						(< (ego distanceTo: self) 50)
						(!= (ego loop?) 6)
						cel
					)
					(self setCycle: Beg)
				)
				((and (> (ego distanceTo: self) 50) (not cel)) (self setCycle: End))
			)
			(if (and (not cycler) (not (& signal $0000)))
				(self stopUpd:)
			)
		)
		(super doit:)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if cel (Print 600 9) else (Print 600 10))
			)
			(7
				(cond 
					((not (Btst 116)) (localproc_000c))
					(
						(or
							(< (ego distanceTo: treas1) 50)
							(< (ego distanceTo: treas2) 50)
							(< (ego distanceTo: treas3) 40)
							(< (ego distanceTo: treas4) 40)
							(< (ego distanceTo: treas5) 50)
						)
						(ego setScript: friedEgo)
					)
					((ego inRect: 113 86 201 108) (ego setScript: downTheTube))
					(else (ego setScript: dropStag))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance treas2 of Prop
	(properties
		x 66
		y 176
		view 601
		loop 6
		cel 2
		priority 14
		signal $4010
	)
	
	(method (doit)
		(if (Btst 116)
			(if (and (== (ego loop?) 3) (not cel))
				(self setCycle: End)
			)
			(cond 
				(
					(and
						(< (ego distanceTo: self) 50)
						(!= (ego loop?) 3)
						cel
					)
					(self setCycle: Beg)
				)
				((and (> (ego distanceTo: self) 50) (not cel)) (self setCycle: End))
			)
			(if (and (not cycler) (not (& signal $0000)))
				(self stopUpd:)
			)
		)
		(super doit:)
	)
)

(instance treas3 of Prop
	(properties
		x 103
		y 182
		view 601
		loop 7
		cel 2
		priority 14
		signal $4010
	)
	
	(method (doit)
		(if (Btst 116)
			(if (and (== (ego loop?) 3) (not cel))
				(self setCycle: End)
			)
			(cond 
				(
					(and
						(< (ego distanceTo: self) 50)
						(!= (ego loop?) 3)
						cel
					)
					(self setCycle: Beg)
				)
				((and (> (ego distanceTo: self) 50) (not cel)) (self setCycle: End))
			)
			(if (and (not cycler) (not (& signal $0000)))
				(self stopUpd:)
			)
		)
		(super doit:)
	)
)

(instance treas4 of Prop
	(properties
		x 161
		y 189
		view 601
		loop 8
		cel 2
		priority 14
		signal $4010
	)
	
	(method (doit)
		(if (Btst 116)
			(if (and (== (ego loop?) 3) (not cel))
				(self setCycle: End)
			)
			(cond 
				(
					(and
						(< (ego distanceTo: self) 50)
						(!= (ego loop?) 3)
						cel
					)
					(self setCycle: Beg)
				)
				((and (> (ego distanceTo: self) 50) (not cel)) (self setCycle: End))
			)
			(if (and (not cycler) (not (& signal $0000)))
				(self stopUpd:)
			)
		)
		(super doit:)
	)
)

(instance treas5 of Prop
	(properties
		x 275
		y 161
		view 601
		loop 4
		cel 2
		priority 14
		signal $4010
	)
	
	(method (doit)
		(if (Btst 116)
			(if (and (== (ego loop?) 7) (not cel))
				(self setCycle: End)
			)
			(cond 
				(
					(and
						(< (ego distanceTo: self) 50)
						(!= (ego loop?) 7)
						cel
					)
					(self setCycle: Beg)
				)
				((and (> (ego distanceTo: self) 50) (not cel)) (self setCycle: End))
			)
			(if (and (not cycler) (not (& signal $0000)))
				(self stopUpd:)
			)
		)
		(super doit:)
	)
)

(instance armor of Prop
	(properties
		x 159
		y 99
		noun '/loot,gold,armor,gem'
		description {the jewels and gold}
		view 601
		loop 3
		signal $4000
	)
	
	(method (doit)
		(if (Btst 116)
			(if (and (== (ego loop?) 2) cel) (self setCycle: Beg))
			(cond 
				(
					(and
						(< (ego distanceTo: self) 30)
						(!= (ego loop?) 2)
						(not cel)
					)
					(self setCycle: CT 3 1)
				)
				((and (> (ego distanceTo: self) 30) cel) (self setCycle: Beg))
			)
			(if (and (not cycler) (not (& signal $0000)))
				(self stopUpd:)
			)
		)
		(super doit:)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if (== (self cel?) 3)
					(Print 600 11)
				else
					(Print 600 9)
				)
			)
			(7 (treas1 doVerb: theVerb))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance dr1 of TargActor
	(properties
		x 270
		y 57
		noun '/door'
		description {the door}
		lookStr {You cannot return the way you came.}
		view 600
		loop 2
		cel 4
		priority 1
		signal $0010
		cycleSpeed 1
		illegalBits $0000
	)
	
	(method (detectMe)
		(Print 600 12)
		(return 1)
	)
)

(instance dr2 of Prop
	(properties
		x 304
		y 68
		noun '/door'
		description {the door}
		lookStr {You cannot return the way you came.}
		view 600
		loop 1
		cel 4
		priority 1
		signal $0010
		cycleSpeed 1
	)
)

(instance dr3 of Prop
	(properties
		x 69
		y 61
		noun '/door'
		description {the door}
		lookStr {Beyond this door awaits your fortune.}
		view 600
		cycleSpeed 1
	)
)

(instance glow of View
	(properties
		x 263
		y 101
		noun '/reflection,glow'
		description {the reflection of your lamp.}
		lookStr {It is the reflection of your lamp light.}
		view 586
		loop 1
		signal $4000
	)
)

(instance comeIn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 262 78 self)
			)
			(1
				(gMiscMusic number: 551 loop: 1 init: play:)
				(dr1 setCycle: Beg)
				(dr2 setCycle: Beg self)
			)
			(2
				(dr1 stopUpd:)
				(dr2 stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance nextRoom of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (dr3 setCycle: End self))
			(1
				(ego setMotion: MoveTo 22 27 self)
			)
			(2
				(curRoom newRoom: 610)
				(self dispose:)
			)
		)
	)
)

(instance downTheTube of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (self cue:))
			(1
				(gMiscMusic number: 601 loop: 1 play:)
				(if (OneOf (ego loop?) 1 3 5 7)
					(ego loop: 2)
				else
					(ego loop: 3)
				)
				(ego view: 603 cel: 2 cycleSpeed: 1 setCycle: End self)
				(trapDoor
					setPri: (- (ego priority?) 1)
					posn: (+ (ego x?) 4) (+ (ego y?) 8)
					init:
					setCycle: End
				)
				(floorShine hide:)
			)
			(2
				(lamp
					posn: (+ (ego x?) 20) (- (ego y?) 4)
					setLoop: 2
					setCel: 0
					init:
					setMotion: (lamp x?) (+ (lamp y?) 60)
				)
				(trapDoor loop: 1 cel: 0 setCycle: End self)
				(ego setPri: (+ (trapDoor priority?) 1) loop: 4 cel: 0)
			)
			(3
				(floorShine
					setPri: (- (lamp priority?) 1)
					posn: (lamp x?) (+ (lamp y?) 6)
					show:
				)
				(trapDoor hide:)
				(ego hide:)
				(= cycles 10)
			)
			(4
				(Die 0 600 13 82 603 2 6 80 {Tripped by a Trap})
			)
		)
	)
)

(instance friedEgo of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(floorShine hide:)
				(= cycles 1)
			)
			(1
				(gMiscMusic number: 602 loop: 1 play:)
				(ego
					view: 602
					loop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: End self
				)
				(lamp
					posn: (+ (ego x?) 4) (- (ego y?) 21)
					setPri: (+ (ego priority?) 1)
					setLoop: 2
					setCel: 0
					yStep: 5
					init:
					setMotion: MoveTo (+ (ego x?) 18) (+ (ego y?) 6)
				)
			)
			(2
				(ego hide:)
				(floorShine
					posn: (lamp x?) (+ (lamp y?) 6)
					setPri: (- (lamp priority?) 4)
					show:
				)
				(= cycles 5)
			)
			(3
				(Die 0 600 14 82 602 0 3 80 {A Zap for a Permanent Nap})
			)
		)
	)
)

(instance dropStag of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gMiscMusic number: 603 loop: 1 play:)
				(stag setPri: 15 posn: (ego x?) 8 init:)
				(= cycles 1)
			)
			(1
				(stag setPri: 15 posn: (stag x?) (+ (stag y?) 16))
				(= cycles 1)
			)
			(2
				(if (< (stag y?) (- (ego y?) 54))
					(self changeState: 1)
				else
					(if (Btst 116) (ego cel: 1))
					(stag setPri: 15 posn: (ego x?) (- (ego y?) 50))
					(= cycles 1)
				)
			)
			(3
				(if (OneOf (ego loop?) 1 2 5 7)
					(ego view: 601 setLoop: 9)
				else
					(ego view: 601 setLoop: 10)
				)
				(stag cel: 2)
				(= cycles 1)
			)
			(4
				(floorShine hide:)
				(ego cel: 0 setPri: 10 cycleSpeed: 2 setCycle: End)
				(stag
					setPri: 14
					setLoop: 1
					setCel: 0
					posn: (- (stag x?) 23) (+ (stag y?) 3)
				)
				(stag2
					setPri: 14
					posn: (+ (stag x?) 18) (+ (stag y?) 3)
					init:
				)
				(if (Btst 116)
					(lamp posn: (+ (ego x?) 20) (- (ego y?) 15) init:)
				)
				(= cycles 1)
			)
			(5
				(stag
					setPri: 14
					loop: 1
					cel: 0
					posn: (- (stag x?) 12) (+ (stag y?) 23)
				)
				(stag2
					setPri: 14
					posn: (+ (stag2 x?) 5) (+ (stag2 y?) 7)
				)
				(if (Btst 116) (lamp posn: (lamp x?) (- (ego y?) 5)))
				(= cycles 1)
			)
			(6
				(stag
					setPri: 14
					loop: 1
					cel: 0
					posn: (- (stag x?) 11) (- (stag y?) 11)
				)
				(stag2
					setPri: 14
					posn: (+ (stag2 x?) 2) (+ (stag2 y?) 17)
				)
				(if (Btst 116) (lamp posn: (lamp x?) (- (ego y?) 5)))
				(= cycles 1)
			)
			(7
				(stag
					setPri: 14
					loop: 1
					cel: 0
					posn: (- (stag x?) 14) (- (stag y?) 2)
				)
				(stag2
					setPri: 14
					posn: (+ (stag2 x?) 8) (- (stag2 y?) 3)
				)
				(if (Btst 116) (lamp posn: (lamp x?) (- (ego y?) 5)))
				(= cycles 1)
			)
			(8
				(stag
					setPri: 14
					loop: 1
					cel: 0
					posn: (- (stag x?) 12) (+ (stag y?) 6)
				)
				(stag2
					setPri: 14
					posn: (+ (stag2 x?) 9) (- (stag2 y?) 4)
				)
				(if (Btst 116) (lamp posn: (lamp x?) (- (ego y?) 5)))
				(= cycles 1)
			)
			(9
				(stag
					setPri: 14
					loop: 1
					cel: 0
					posn: (- (stag x?) 11) (- (stag y?) 2)
				)
				(stag2
					setPri: 14
					posn: (+ (stag2 x?) 4) (+ (stag2 y?) 6)
				)
				(floorShine posn: (lamp x?) (lamp y?) show:)
				(if (Btst 116) (lamp posn: (lamp x?) (- (ego y?) 5)))
				(= cycles 1)
			)
			(10
				(stag2
					setPri: 14
					posn: (+ (stag2 x?) 14) (- (stag2 y?) 6)
				)
				(= cycles 1)
			)
			(11
				(stag2
					setPri: 14
					posn: (+ (stag2 x?) 7) (+ (stag2 y?) 4)
				)
				(= cycles 1)
			)
			(12
				(Die 0 600 15 82 601 0 2 80 {Knocked by a Rock})
			)
		)
	)
)

(instance tooDark of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SetControl 1)
				(= cycles 12)
			)
			(1
				(cast eachElementDo: #hide)
				(ego setMotion: 0)
				(Bclr 116)
				(curRoom drawPic: 2)
				(= seconds 2)
			)
			(2
				(Print 600 16)
				(= seconds 5)
			)
			(3
				(if (not (Btst 116)) (= local2 50) (Print 600 17))
				(self dispose:)
			)
		)
	)
)
