;;; Sierra Script 1.0 - (do not remove this comment)
(script# 630)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Stage)
(use TargActor)
(use Full)
(use Intrface)
(use PolyPath)
(use Polygon)
(use Feature)
(use LoadMany)
(use Timer)
(use Motion)
(use Actor)
(use System)

(public
	rm630 0
)

(local
	local0
	local1
	local2
	local3
	gEgoX
	gEgoY
	local6
	local7
	local8
	local9
	local10
	[local11 100]
	[local111 16] = [165 144 206 158 273 133 272 82 254 61 217 49 188 60 164 82]
	[local127 12] = [147 142 222 119 279 133 286 144 219 166 193 164]
)
(instance rm630 of Stage
	(properties
		picture 660
		style $0008
		north 665
		east 665
		south 665
		west 665
		picAngle 75
		topFromX 80
		topToX 80
		rightFromY 160
		rightToY 160
		leftFromY 150
		leftToY 150
	)
	
	(method (init)
		(LoadMany 128 15 47 630 632 633 12 637)
		(AddToScore 645 5)
		(= global277 (+ (* currentDay 100) currentTimeZone))
		(= local1 (> beastStatus 1))
		(= local0 (mod beastStatus 2))
		(cond 
			((Btst 42))
			(
			(or (not global279) (< (- global277 global279) 90)) (= local3 1))
			((or local0 local1) (= local3 2))
			(else (= local3 3))
		)
		(if (== gTopExit 3) (= inOut 3))
		(= gGDftSC gAllSC)
		(ego init:)
		(super init:)
		(if isNightTime
			(curRoom overlay: 659 8)
			(DrawFeature stellar1 stellar2)
		)
		(self setRegions: 660)
		(gDirH addToFront: self)
		(gMouseH addToFront: self)
		(cageDoor init:)
		(DrawFeature
			cageFront
			cageBack
			cagePieceLeft
			cagePieceRight
		)
		(cond 
			((== local3 3) (DrawFeature deadBeast))
			((Btst 42))
			(else
				(beastBody init:)
				(beastHead init: setScript: beastWakesUp)
			)
		)
		(proc1_31 cageFeat)
		(theCage points: @local111 size: 8)
		(cageBase points: @local127 size: 6)
		(self addObstacle: cageBase)
		(if (== inOut 3)
			(ego posn: 45 76 setScript: (ScriptID 660 2) self)
		)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			((ego script?))
			((ego edgeHit?) (= gTopExit (ego edgeHit?)))
			((& (ego onControl:) $0004) (ego setScript: (ScriptID 660 3)))
			((& (ego onControl:) $1000)
				(if
					(and
						(ego inRect: 170 142 265 162)
						(not (cageDoor script?))
					)
					(ego setPri: 13)
				else
					(ego setPri: -1)
				)
				(if
					(and
						(or (== local3 1) (== local3 2))
						(not (cageDoor script?))
					)
					(self setScript: beastLunges)
				)
			)
			(else
				(= gEgoX (ego x?))
				(= gEgoY (ego y?))
				(if
					(and
						(ego inRect: 170 142 265 162)
						(not (cageDoor script?))
					)
					(ego setPri: 13)
				else
					(ego setPri: -1)
				)
			)
		)
	)
	
	(method (dispose)
		(if (== gTopExit 3) (ego x: (- 320 (ego x?))))
		(if (or (== local3 1) (== local3 2))
			(if (and (not local0) (not local1)) (HighPrint 630 0))
			(= beastStatus (+ (* local1 2) local0))
			(= global279 global277)
		)
		(timers eachElementDo: #dispose eachElementDo: #delete)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine>')
				(cond 
					(
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
						(if (== local3 3)
							(HighPrint 630 1)
						else
							(HighPrint 630 2)
						)
					)
					((Said '/eye')
						(if (== local3 3)
							(HighPrint 630 3)
						else
							(HighPrint 630 4)
							(= local7 1)
						)
					)
				)
			)
			(
				(or
					(and
						(== (pEvent type?) evJOYSTICK)
						(OneOf (pEvent message?) 8 1 2 3 4)
					)
					(and
						(== (pEvent type?) evMOUSEBUTTON)
						(not (pEvent modifiers?))
						(or
							(> (pEvent x?) (ego x?))
							(< (pEvent y?) (ego y?))
						)
					)
				)
				(if (== egoWalkMode 3)
					(pEvent claimed: 1)
					(HighPrint 630 5)
				)
			)
			((== egoWalkMode 3))
			((Btst 42))
			(
			(Said 'attack,kill/creature,beast,animal,monster')
				(if (== local3 3)
					(HighPrint 630 6)
				else
					(HighPrint 630 7)
				)
			)
			((or (Said 'feed') (Said 'gave/food'))
				(cond 
					((== local3 3) (HighPrint 630 8))
					((not (ego inRect: 125 143 232 178)) (HighPrint 630 9))
					((ego has: 3) (self setScript: beastEats 0 0))
					(else (HighPrint 630 10))
				)
			)
			((or (Said 'water') (Said 'gave/water'))
				(cond 
					((== local3 3) (HighPrint 630 11))
					((not (ego inRect: 125 143 232 178)) (HighPrint 630 9))
					((> currentWater 0) (self setScript: beastEats 0 1))
					(else (HighPrint 630 12))
				)
			)
			((Said 'get,acquire/hair,fur')
				(cond 
					((== local3 3) (HighPrint 630 13))
					(
						(not
							(if (timers contains: beastTimer)
								(> (beastTimer seconds?) 0)
							)
						)
						(HighPrint 630 14)
					)
					((ego has: 21) (self setScript: getFur))
					(else (HighPrint 630 15))
				)
			)
			(
				(or
					(Said 'use,gave,feed/potion')
					(Said 'use,gave,feed//potion')
				)
				(cond 
					((== local3 3) (HighPrint 630 16))
					((not (ego inRect: 125 143 232 178)) (HighPrint 630 9))
					((ego has: 21) (self setScript: usePotion))
					(else (PrintDontHaveIt))
				)
			)
		)
	)
	
	(method (cue)
		(super cue:)
		(if
			(and
				(== egoWalkMode 3)
				(or (== local3 1) (== local3 2))
			)
			(self setScript: saurusBalks 0 gTopExit)
		)
	)
)

(instance getFur of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setPri: -1 setMotion: PolyPath 247 121 self)
			)
			(1
				(ego
					view: 47
					setLoop: 2
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(2
				(beastHead hide:)
				(beastBody
					view: 633
					setLoop: 1
					setCel: 0
					setCycle: CT 1 1 self
				)
			)
			(3 (= cycles 2))
			(4
				(beastBody cycleSpeed: 1 setCycle: End self)
			)
			(5
				(beastBody view: 632 setLoop: 3)
				(beastHead setLoop: 8 setCycle: 0 show:)
				(proc1_19)
				(beastTimer dispose:)
				(= cycles 1)
			)
			(6
				(ego setMotion: PolyPath gEgoX gEgoY self)
			)
			(7
				(HighPrint 630 17)
				(= local8 1)
				(self dispose:)
			)
		)
	)
)

(instance usePotion of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: beastEats self 2)
			)
			(1 (= cycles 15))
			(2
				(if (not local8)
					(= local1 1)
					(HighPrint 630 18)
					(client setScript: beastDoneEating)
				else
					(AddToScore 643 15)
					(SkillUsed 14 50)
					(TestSkill 14 100)
					(= local2 1)
					(beastTimer dispose:)
					(beastHead dispose:)
					(beastBody
						view: 633
						setLoop: 1
						setCel: 0
						setCycle: CT 1 1 self
					)
				)
			)
			(3 (= cycles 12))
			(4
				(beastBody cycleSpeed: 3 setCycle: End self)
			)
			(5
				(beastHead dispose:)
				(beastBody
					view: 632
					setLoop: 4
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(6
				(beastBody dispose:)
				(alScurva init:)
				(= cycles 1)
			)
			(7
				(alScurva
					setLoop: 0
					cycleSpeed: 0
					setCycle: Walk
					setMotion: MoveTo 182 146 self
				)
			)
			(8
				(alScurva x: (- (alScurva x?) 5) setLoop: 1)
				(gestureTimer setCycle: gestureTimer 3)
				(Say alScurva self 630 19)
			)
			(9 (Say alScurva self 630 20))
			(10 (Say alScurva self 630 21))
			(11 (Say alScurva self 630 22))
			(12 (Say alScurva self 630 23))
			(13 (Say alScurva self 630 24))
			(14 (Say alScurva self 630 25))
			(15
				(gestureTimer dispose:)
				(alScurva
					setLoop: 8
					setCel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(16
				(alScurva setLoop: 7 setCel: 0 setCycle: End self)
				(Bset 42)
				(= local3 0)
			)
			(17 (= cycles 8))
			(18
				(alScurvaMouth init: setCycle: Fwd)
				(cond 
					((and local0 local1) (Say alScurva self 630 26))
					(local0 (Say alScurva self 630 27))
					(else (Say alScurva self 630 28))
				)
			)
			(19
				(alScurva dispose:)
				(alScurvaMouth dispose:)
				(self dispose:)
			)
		)
	)
)

(instance beastEats of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (< register 3)
					(self changeState: 2)
				else
					(beastHead setLoop: 6 setCel: 0 setCycle: End self)
				)
			)
			(1
				(beastHead setLoop: 5 cycleSpeed: 1 setCycle: Fwd)
				(self changeState: 8)
			)
			(2
				(UnlockEgo)
				(ego setMotion: MoveTo 170 155 self)
			)
			(3
				(AddToScore 644 5)
				(TestSkill 14 100)
				(switch register
					(0 (ego use: 3 1))
					(1 (-- currentWater))
					(2 (ego use: 21 1))
				)
				(ego
					view: 47
					setLoop: 0
					setCel: 0
					setPri: 15
					setCycle: End self
				)
			)
			(4 (= cycles 4))
			(5
				(ego setCycle: Beg self)
				(if
					(not
						(if (timers contains: beastTimer)
							(> (beastTimer seconds?) 0)
						)
					)
					(beastHead setLoop: 6 setCel: 0 setCycle: End)
				)
			)
			(6
				(ego
					view: 0
					setLoop: -1
					setCycle: Walk
					setMotion: MoveTo 160 165 self
				)
				(if
					(not
						(if (timers contains: beastTimer)
							(> (beastTimer seconds?) 0)
						)
					)
					(beastHead setLoop: 5 cycleSpeed: 1 setCycle: Fwd)
					(proc1_32 beastTimer 15)
				)
			)
			(7
				(proc1_19)
				(ego setHeading: 45 self)
			)
			(8
				(LockEgo)
				(switch register
					(0
						(= local0 1)
						(HighPrint
							(Format
								@local11
								630
								29
								(if local1 {.} else {, gagging a bit from lack of water.})
							)
						)
					)
					(1
						(= local1 1)
						(HighPrint
							(Format
								@local11
								630
								30
								(if local0
									{.}
								else
									{ while watching you with a hungry expression.}
								)
							)
						)
					)
					(2 (HighPrint 630 31))
				)
				(SkillUsed 14 25)
				(= cycles 1)
			)
			(9 (self dispose:))
		)
	)
)

(instance beastDoneEating of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(beastHead setCycle: End self)
			)
			(1
				(beastHead setLoop: 6 setCel: 3 setCycle: Beg self)
			)
			(2
				(beastHead setLoop: 8 setCel: 0)
				(if
					(and
						(timers contains: beastTimer)
						(> (beastTimer seconds?) 0)
					)
					(beastTimer dispose:)
				)
				(self dispose:)
			)
		)
	)
)

(instance beastWakesUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(beastHead setLoop: 7 setCel: 0)
				(= cycles 12)
			)
			(1
				(beastHead setCycle: End self)
			)
			(2
				(beastHead setLoop: 8 setCel: 0)
				(= cycles 3)
			)
			(3
				(if (== local3 2) (HighPrint 630 32))
				(self dispose:)
			)
		)
	)
)

(instance beastLunges of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(= register (* 2 (> (beastHead cel?) 3)))
				(if (< (ego x?) 207)
					(beastHead hide:)
					(beastBody setLoop: 2 setCycle: End self)
				else
					(beastHead setLoop: 9 setCel: register setCycle: End self)
				)
			)
			(1
				(cond 
					((< (ego x?) 174) (= temp0 3))
					((> (ego x?) 235) (= temp0 4))
					(else (= temp0 5))
				)
				(ego view: 633 setLoop: temp0 setCel: 0 setCycle: End)
				(if (< (ego x?) 207)
					(beastBody cycleSpeed: 2 setCycle: Beg self)
				else
					(beastHead cycleSpeed: 1 setCycle: CT register -1 self)
				)
			)
			(2
				(cond 
					((< (ego x?) 174) (= temp1 45) (= temp0 6))
					((> (ego x?) 235) (= temp1 335) (= temp0 7))
					(else (= temp1 0) (= temp0 3))
				)
				(ego posn: gEgoX gEgoY loop: temp0)
				(proc1_19)
				(if (< (ego x?) 207)
					(beastBody setLoop: 3 cycleSpeed: 0)
					(beastHead show:)
				else
					(beastHead setLoop: 8)
				)
				(= cycles 1)
			)
			(3
				(if
					(and
						(timers contains: beastTimer)
						(> (beastTimer seconds?) 0)
					)
					(curRoom setScript: beastEats 0 3)
				)
				(self dispose:)
			)
		)
	)
)

(instance openDoor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== register 0)
					(ego setMotion: MoveTo 170 150 self)
				else
					(self cue:)
				)
			)
			(1
				(if (or (== local3 3) (Btst 42))
					(Print 630 33)
					(self changeState: 5)
				else
					(ego setHeading: 90)
					(cageDoor setCycle: End self)
				)
			)
			(2
				(ego setMotion: MoveTo 180 152 self)
			)
			(3
				(beastBody dispose:)
				(beastHead dispose:)
				(self cue:)
			)
			(4
				(ego
					view: 633
					setLoop: 0
					setCel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(5
				(cond 
					((or (== local3 3) (Btst 42)) (self dispose:))
					(local7 (Die 0 630 34 82 632 0 0))
					(else (Die 0 630 35 82 632 0 0))
				)
			)
		)
	)
)

(instance saurusBalks of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo (+ (ego x?) 20) (ego y?) self)
			)
			(1
				(ego
					view: 15
					setLoop: (> (ego x?) (cageFront x?))
					setCel: 0
					cycleSpeed: 1
					setCycle: CT 2 1
				)
				(= cycles 6)
			)
			(2 (ego setCycle: CT 0 -1 self))
			(3
				(ego view: 12 setLoop: -1 cycleSpeed: 0 setCycle: Walk)
				(= cycles 1)
			)
			(4
				(cond 
					((or (== gTopExit 2) (< (ego x?) 160)) (ego setMotion: MoveTo 40 180 self))
					((== register 4) (ego setMotion: MoveTo (+ (ego x?) 50) (ego y?) self))
					(else (ego setMotion: MoveTo (ego x?) (+ (ego y?) 50) self))
				)
			)
			(5 (ego setHeading: 270 self))
			(6 (self dispose:))
		)
	)
)

(instance beastHurts of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (cast contains: beastHead) (beastHead hide:))
				(beastBody setLoop: 1 setCycle: Full 1 self)
			)
			(1
				(if (cast contains: beastHead) (beastHead show:))
				(beastBody setLoop: 3)
				(if (> (++ local10) 2)
					(HighPrint 630 36)
				else
					(HighPrint 630 37)
				)
				(self dispose:)
			)
		)
	)
)

(instance beastBody of TargActor
	(properties
		x 225
		y 135
		noun '/beast,creature,animal,monster'
		description {the beast}
		view 632
		loop 3
		priority 9
		signal $0010
	)
	
	(method (doit)
		(super doit:)
		(if (and (== loop 1) (== cel 1)) (= z (- 2 z)))
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(HighPrint 630 42)
			(HighPrint 630 43)
			(HighPrint 630 44)
		else
			(super doVerb: theVerb &rest)
		)
	)
	
	(method (calmMe)
		(HighPrint 630 39)
		(return 1)
	)
	
	(method (dazzleMe)
		(HighPrint 630 40)
		(return 1)
	)
	
	(method (detectMe)
		(HighPrint 630 38)
		(return 1)
	)
	
	(method (fetchMe)
		(HighPrint 630 41)
		(return 0)
	)
	
	(method (hurtMe)
		(self setScript: beastHurts)
		(return 1)
	)
)

(instance deadBeast of PicView
	(properties
		x 235
		y 134
		noun '/beast,animal,monster,creature,body'
		description {the dead beast}
		lookStr {You see an ex-beast.__As you stare at it, you seem to hear a voice in your mind, saying "I'm dead.__Go away.___Trust me, I'm dead.__Aaaaahhhhhhh".}
		view 633
		loop 2
		cel 10
		priority 11
		signal $0010
	)
)

(instance beastHead of TargActor
	(properties
		x 208
		y 125
		noun '/beast,creature,animal,monster'
		description {beast}
		view 632
		loop 8
		priority 10
		signal $4010
	)
	
	(method (doit &tmp temp0)
		(= temp0 (GetAngle x y (ego x?) (ego y?)))
		(cond 
			(script)
			((curRoom script?))
			(
				(and
					(timers contains: beastTimer)
					(> (beastTimer seconds?) 0)
				)
			)
			((< temp0 153) (= cel 5))
			((< temp0 170) (= cel 4))
			((< temp0 186) (= cel 3))
			((< temp0 207) (= cel 2))
			((< temp0 233) (= cel 1))
			(else (= cel 0))
		)
		(super doit:)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1) (beastBody doVerb: 1))
	)
	
	(method (hurtMe)
		(self setScript: beastHurts)
		(return 1)
	)
)

(instance alScurva of Talker
	(properties
		x 225
		y 135
		view 637
		priority 9
		signal $0010
		cycleSpeed 2
		tLoop -1
		talkSpeed 1
		myName '//al,al,man,apprentice'
		title {Al Scurva:}
		color 11
		back 1
	)
)

(instance alScurvaMouth of Prop
	(properties
		x 180
		y 115
		view 637
		loop 2
		priority 10
		signal $0010
		cycleSpeed 1
	)
)

(instance gestureTimer of Timer
	(properties)
	
	(method (cue)
		(cond 
			((alScurva cel?) (alScurva setCycle: Beg))
			((> (Random 1 10) 5)
				(alScurva
					setLoop: (Random 3 6)
					setCel: 0
					setCycle: Full 1
				)
			)
			(else (alScurva setLoop: (Random 3 6) setCel: 0 setCycle: End))
		)
		(self setCycle: self (Random 3 5))
	)
)

(instance cageFront of PicView
	(properties
		x 218
		y 158
		view 630
		priority 11
		signal $4010
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance cageBack of PicView
	(properties
		x 216
		y 156
		view 630
		cel 1
		priority 9
		signal $4010
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance cagePieceLeft of PicView
	(properties
		x 172
		y 151
		view 630
		cel 2
		signal $4000
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance cagePieceRight of PicView
	(properties
		x 264
		y 137
		view 630
		cel 3
		priority 10
		signal $4010
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance cageDoor of TargActor
	(properties
		x 207
		y 157
		noun '/door,bar'
		description {the cage door}
		view 630
		loop 1
		priority 12
		signal $4010
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'unlock,lockpick/door,lock') (self doVerb: 1))
			((Said 'free/creature,beast,animal,monster')
				(if (== local3 3)
					(HighPrint 630 47)
				else
					(HighPrint 630 48)
				)
			)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 630 45))
			(2
				(if (ego inRect: 125 143 232 178)
					(curRoom setScript: openDoor 0 0)
				else
					(HighPrint 630 9)
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (openMe &tmp temp0)
		(if (< (ego x?) 207)
			(self setScript: openDoor 0 1)
			(= temp0 1)
		else
			(HighPrint 630 46)
			(= temp0 0)
		)
		(return temp0)
	)
)

(instance cageFeat of Feature
	(properties
		noun '/birdcage'
		description 'the&birdcage'
	)
	
	(method (doVerb theVerb)
		(cond 
			((== theVerb 1) (HighPrint 630 49) (HighPrint 630 45))
			((== theVerb 2) (cageDoor doVerb: theVerb &rest))
			(else (super doVerb: theVerb &rest))
		)
	)
	
	(method (onMe param1)
		(AvoidPath (param1 x?) (param1 y?) theCage)
	)
)

(instance beastTimer of Timer
	(properties)
	
	(method (cue)
		(switch (++ local9)
			(1
				(HighPrint 630 50)
				(proc1_32 self 15)
			)
			(else 
				(curRoom setScript: beastDoneEating)
			)
		)
	)
)

(instance theCage of Polygon
	(properties
		type $0000
	)
)

(instance cageBase of Polygon
	(properties
		type $0002
	)
)

(instance stellar1 of PicView
	(properties
		x 273
		y 65
		noun '/hand,(star,constellation<hand)'
		description {the Dark Hand constellation}
		lookStr {The stars here appear to form a Dark Hand.}
		view 660
		loop 2
		cel 2
		priority 0
		signal $6010
	)
)

(instance stellar2 of PicView
	(properties
		x 67
		y 43
		noun '/star,constellation<saurii'
		description {the Saurus constellation}
		lookStr {This constellation is said to resemble a Saurus.}
		view 660
		loop 2
		cel 3
		priority 0
		signal $6010
	)
)
