;;; Sierra Script 1.0 - (do not remove this comment)
(script# 640)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Stage)
(use TargActor)
(use PolyPath)
(use Polygon)
(use Feature)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	rm640 0
)

(local
	local0
	local1
	[newABranch 12]
	[local14 12] = [-36 -20 -5 2 22 1 44 -60 -37 23 0 -21]
	[local26 12] = [-69 -75 -66 -80 -69 -76 -81 -78 -85 -81 -86 -88]
	[local38 12] = [3 3 3 3 4 4 4 3 3 4 4 3]
	local50
	local51
	local52
	local53
	local54 =  1
	[local55 36] = [0 0 319 0 319 149 97 149 97 142 176 142 192 120 215 101 234 101 235 85 197 82 178 88 155 84 132 85 129 89 86 103 39 107 0 117]
	[local91 8] = [132 163 182 163 182 171 132 171]
	[local99 20] = [191 189 200 187 253 187 253 183 238 183 202 172 203 168 231 161 318 161 318 189]
	[local119 25] = [130 118 108 98 86 0 125 115 110 108 86 0 123 116 110 99 97 90 86 0 123 116 97 86]
	local144
)
(procedure (localproc_000c)
	(if
		(and
			(Btst 77)
			(Btst 81)
			(Btst 78)
			(Btst 76)
			(Btst 79)
			(Btst 80)
			(not (Btst 122))
			(!= (gSpareMusic number?) 643)
		)
		(gSpareMusic number: 643 loop: 1 priority: 8 play:)
	)
)

(procedure (localproc_0079)
	(switch local54
		(1 (HighPrint 640 0))
		(2 (HighPrint 640 1))
		(3 (HighPrint 640 2))
		(4 (HighPrint 640 3))
		(5 (HighPrint 640 4))
	)
	(return (if (< local54 5) (++ local54) else 0))
)

(procedure (localproc_00e5)
	(HighPrint 640 5)
)

(procedure (localproc_00f0)
	(= local0 0)
	(while (< local0 12)
		(= [newABranch local0] (aBranch new:))
		([newABranch local0]
			cel: 3
			palette: (if isNightTime 2 else 1)
			ignoreActors:
			x: (+ 164 [local14 local0])
			y: (+ 169 [local26 local0])
		)
		(DrawFeature [newABranch local0])
		(++ local0)
	)
)

(procedure (localproc_014e)
	(gMiscMusic number: 641 loop: 0 priority: 8 play:)
	(Bset 123)
	(localproc_000c)
	(julanar setCycle: End self)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)

(instance poly2 of Polygon
	(properties
		type $0002
	)
)

(instance poly3 of Polygon
	(properties
		type $0002
	)
)

(instance rm640 of Stage
	(properties
		picture 640
		style $0007
		east 665
		south 665
		west 665
		bottomFromX 70
		bottomFromY 220
		bottomToX 110
		rightFromX 330
		rightFromY 160
		rightToX 230
		rightToY 160
		leftFromX -40
		leftFromY 160
		leftToX 50
		leftToY 160
	)
	
	(method (init)
		(LoadMany 128 22 47 640 645 646)
		(Load rsSOUND 641)
		(proc1_31 wall wall2)
		(self setRegions: 660)
		(proc1_19)
		(ego init:)
		(= gGDftSC gAllSC)
		(= useObstacles 1)
		(curRoom addObstacle: poly1 poly2 poly3)
		(super init:)
		(gMiscMusic number: 645)
		(if (Btst 76) (DrawFeature dirt))
		(cond 
			((Btst 124)
				(julanar cel: 9 palette: (if isNightTime 2 else 1) init:)
				(localproc_00f0)
			)
			((Btst 123) (julanar cel: 9 palette: (if isNightTime 2 else 1) init:))
			(else
				(gMiscMusic number: 640)
				(julanar cel: 0 palette: (if isNightTime 2 else 1) init:)
			)
		)
		(gMiscMusic loop: 0 priority: 8 play:)
		(poly1 points: @local55 size: 18)
		(poly2 points: @local91 size: 4)
		(poly3 points: @local99 size: 10)
	)
	
	(method (doit)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(Said
					'dismount,(climb,scale,get,acquire<off,down)[/saurii,roget]'
				)
				(if (== (ego onControl: 1) 16)
					(HighPrint 640 13)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'ask') (FaceObject ego julanar 0 self) (= local52 1))
			((Said 'get,acquire>')
				(cond 
					((Said '/frond,branch,tree,root') (HighPrint 640 14))
					((Said '/fruit')
						(if (Btst 122)
							(HighPrint 640 15)
						else
							(HighPrint 640 16)
						)
					)
				)
			)
			((Said 'look,examine>')
				(cond 
					(
						(or
							(Said 'search,look,examine[<at,around][/room,area][/!*]')
							(Said '/alcove')
						)
						(HighPrint 640 17)
					)
					((Said '<at/plant,tree')
						(cond 
							((Btst 123) (HighPrint 640 18))
							((Btst 124) (HighPrint 640 19))
							(else (HighPrint 640 20))
						)
					)
					((Said '/frond') (HighPrint 640 21))
				)
			)
			((Said 'rest')
				(cond 
					((Btst 122) (HighPrint 640 22) (Rest 1))
					(isNightTime (Rest 1))
					(else (HighPrint 640 23))
				)
			)
			((Said 'nap')
				(cond 
					((Btst 122)
						(if isNightTime
							(Sleep 5 0)
							(HighPrint 640 24)
						else
							(Sleep 20 0)
							(HighPrint 640 25)
						)
					)
					(isNightTime (Sleep 5 0) (HighPrint 640 26))
					(else (HighPrint 640 23))
				)
			)
			(
				(or
					(Said
						'gave,pour,offer,use/potion[<disenchant,disenchant]'
					)
					(Said
						'gave,pour,offer,use//potion[<disenchant,disenchant]'
					)
				)
				(cond 
					((not (ego has: 21)) (PrintDontHaveIt))
					((Btst 44) (HighPrint 640 27))
					(else (HighPrint 640 28))
				)
			)
			(
				(or
					(Said 'pour,gave/water')
					(Said 'water/tree,plant,julanar,pomegranate,root')
				)
				(cond 
					((== egoWalkMode 3) (localproc_00e5))
					((<= currentWater 0) (HighPrint 640 29))
					(else
						(Bset 77)
						(= local1 1)
						(AddToScore 652 7)
						(SkillUsed 14 25)
						(self setScript: giveGift)
					)
				)
			)
			(
				(or
					(Said 'tell//self,i,hero,heroic,adventure,spielburg')
					(Said 'tell/self,i,hero,heroic,adventure,spielburg')
				)
				(AddToScore 651 5)
				(ego setMotion: PolyPath 139 172 self)
				(= local52 2)
			)
			(
				(Said
					'gave,plant,place,(put<down)/dirt,earth,(elemental[<earth])'
				)
				(cond 
					((== egoWalkMode 3) (localproc_00e5))
					((ego has: 52)
						(Bset 76)
						(= local1 0)
						(AddToScore 646 7)
						(SkillUsed 14 50)
						(self setScript: giveGift)
					)
					((ego has: 32) (= local1 0) (self setScript: giveGift))
					(else (HighPrint 640 30))
				)
			)
			(
				(or
					(Said 'tell//gift,healer,dirt,earth,(elemental[<earth])')
					(Said 'tell/gift,healer,dirt,earth,(elemental[<earth])')
				)
				(if (>= elementalsStatus 6)
					(AddToScore 649 5)
					(ego setMotion: PolyPath 139 172 self)
					(= local52 3)
				else
					(HighPrint 640 31)
				)
			)
			(
				(or
					(Said 'gave/hug')
					(Said 'hug/tree,plant,julanar,pomegranate')
					(Said 'kiss/tree,plant,julanar,pomegranate')
					(Said 'display/affection')
				)
				(cond 
					((== egoWalkMode 3) (localproc_00e5))
					((Btst 80) (HighPrint 640 32))
					(else
						(AddToScore 648 5)
						(SkillUsed 14 25)
						(self setScript: hugHer)
					)
				)
			)
			(
				(or
					(Said 'tell,say/identity,julanar,pomegranate')
					(Said 'tell//julanar,pomegranate')
					(Said '/julanar,pomegranate')
				)
				(AddToScore 650 5)
				(SkillUsed 14 50)
				(FaceObject ego julanar 0 self)
				(= local52 4)
			)
			((Said 'thank/julanar,pomegranate,tree,plant')
				(cond 
					((not (ego has: 36)) (HighPrint 640 33))
					((not local50)
						(= local50 1)
						(HighPrint 640 34)
						(TestSkill 13 100)
						(SkillUsed 14 50)
					)
					(else (HighPrint 640 35))
				)
			)
			((Said 'tell') (HighPrint 640 36))
		)
	)
	
	(method (cue)
		(super cue:)
		(switch local52
			(1 (HighPrint 640 6))
			(2
				(cond 
					((== egoWalkMode 3) (localproc_00e5))
					((not (Btst 77)) (HighPrint 640 7))
					((Btst 78) (HighPrint 640 8))
					((TestSkill 13 (* 10 (- 6 local54))) (self setScript: tellOfSelf))
					(else (localproc_0079))
				)
			)
			(3
				(cond 
					((== egoWalkMode 3) (localproc_00e5))
					((not (Btst 76)) (HighPrint 640 9))
					((Btst 79) (HighPrint 640 10))
					((TestSkill 13 (* 10 (- 6 local54))) (self setScript: tellOfEarth))
					(else (localproc_0079))
				)
			)
			(4
				(cond 
					((== egoWalkMode 3) (localproc_00e5))
					(
						(or
							(not (Btst 77))
							(not (Btst 78))
							(not (Btst 76))
							(not (Btst 79))
						)
						(HighPrint 640 11)
					)
					(else
						(HighPrint 640 12)
						(if (not (Btst 81))
							(Bset 81)
							(TestSkill 13 100)
							(if (and (Btst 80) (not (Btst 122)))
								(localproc_000c)
								(self setScript: fruitFall)
							)
						)
					)
				)
			)
		)
		(= local52 0)
	)
)

(instance dirt of PicView
	(properties
		x 155
		y 174
		noun '/earth,dirt'
		description {the earth you placed on the ground}
		view 640
		signal $4000
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if local51 (HighPrint 640 37) else (HighPrint 640 38))
			)
			(7 (HighPrint 640 39))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance julanar of TargActor
	(properties
		x 164
		y 169
		noun '/tree,plant,julanar,pomegranate'
		description {the tree}
		view 645
		signal $4000
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said 'chop,carve/initial,tree,plant,julanar,pomegranate') (HighPrint 640 42))
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(cond 
					((Btst 80) (HighPrint 640 43))
					((Btst 124) (HighPrint 640 44))
					((Btst 123) (HighPrint 640 45))
					(else (HighPrint 640 46))
				)
			)
			(8 (HighPrint 640 47))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (hurtMe param1 param2 &tmp temp0)
		(= local53 (param2 type?))
		(self setScript: theScreen)
		(ego
			view: 646
			loop: (if (> (ego x?) (julanar x?)) 1 else 2)
			cel: 0
			setCycle: End
		)
		(return 0)
	)
	
	(method (openMe)
		(if (Btst 122)
			(HighPrint 640 40)
		else
			(HighPrint 640 41)
		)
	)
)

(instance branches of View
	(properties
		noun '/branch,twig,branch'
		description {the tree's branches}
		lookStr {The plant's branches reach for the heavens.}
		view 645
		loop 2
	)
)

(instance aBranch of Prop
	(properties
		noun '/branch,twig,branch,frond'
		description {the tree's branches}
		view 645
		loop 3
		priority 14
		signal $0010
		cycleSpeed 1
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 640 48))
			(7 (HighPrint 640 49))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance theFruit of Actor
	(properties
		noun '/fruit[<compassion]'
		description {the Fruit of Compassion}
		yStep 7
		view 645
		loop 5
		signal $4800
		cycleSpeed 1
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 640 50))
			(7 (HighPrint 640 51))
			(4 (HighPrint 640 52))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance giveGift of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(if
			(and
				(Btst 79)
				(Btst 76)
				(Btst 78)
				(Btst 77)
				(not (Btst 124))
			)
			(curRoom setScript: springTime)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego illegalBits: 0 setMotion: PolyPath 139 172 self)
			)
			(1
				(ego
					view: 47
					setLoop: 0
					cel: 0
					x: (+ (ego x?) 5)
					y: (+ (ego y?) 3)
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(2
				(if local1
					(if (< (= currentWater (- currentWater 10)) 0)
						(= currentWater 0)
					)
					(Bclr 3)
					(HighPrint 640 53)
					(= cycles 2)
				else
					(if (ego has: 52)
						(DrawFeature dirt)
						(SetUpEgo)
						(ego use: 52)
						(HighPrint 640 54)
						(= local51 1)
					else
						(ego use: 32)
						(ego get: 35)
						(HighPrint 640 55)
					)
					(= cycles 2)
				)
			)
			(3 (ego setCycle: Beg self))
			(4
				(ego
					x: (- (ego x?) 5)
					y: (- (ego y?) 3)
					setHeading: 45
				)
				(proc1_19)
				(if (and local1 (Btst 78) (not (Btst 123)))
					(localproc_014e)
				else
					(= cycles 4)
				)
			)
			(5
				(localproc_000c)
				(self dispose:)
			)
		)
	)
)

(instance tellOfSelf of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(if
		(and (Btst 76) (Btst 79) (Btst 77) (not (Btst 124)))
			(curRoom setScript: springTime)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== local54 1)
					(HighPrint 640 56 70 290)
					(HighPrint 640 57 70 290)
				else
					(HighPrint 640 58)
				)
				(= local54 1)
				(if (and (Btst 77) (not (Btst 123)))
					(localproc_014e)
				else
					(self cue:)
				)
			)
			(1
				(Bset 78)
				(localproc_000c)
				(self dispose:)
			)
		)
	)
)

(instance tellOfEarth of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(if
		(and (Btst 76) (Btst 78) (Btst 77) (not (Btst 124)))
			(curRoom setScript: springTime)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== local54 1)
					(HighPrint 640 59 70 290)
					(HighPrint 640 60 70 290)
				else
					(HighPrint 640 61)
				)
				(= local54 1)
				(if (and (Btst 76) (not (Btst 123)))
					(localproc_014e)
				else
					(self cue:)
				)
			)
			(1
				(Bset 79)
				(localproc_000c)
				(self dispose:)
			)
		)
	)
)

(instance hugHer of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(if (and (Btst 81) (not (Btst 122)))
			(curRoom setScript: fruitFall)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					illegalBits: 0
					ignoreActors: 1
					setMotion: PolyPath (- (julanar x?) 24) (julanar y?) self
				)
			)
			(1
				(ego
					setPri: (+ (julanar priority?) 1)
					setHeading: 90 self
				)
			)
			(2
				(ego
					view: 646
					loop: 0
					cel: 0
					x: (- (julanar x?) 13)
					setCycle: End self
				)
				(if (and (Btst 124) (not (Btst 80)))
					(branches
						x: 160
						y: 106
						palette: (if isNightTime 2 else 1)
						init:
					)
					(julanar loop: 1 cel: 0 setCycle: End)
				)
			)
			(3 (= seconds 2))
			(4
				(ego setCycle: Beg self)
				(if (== (julanar loop?) 1)
					(julanar setCycle: Beg)
					(Bset 80)
					(localproc_000c)
				else
					(HighPrint 640 62)
				)
			)
			(5
				(ego
					view: 0
					setCycle: Walk
					x: (- (julanar x?) 24)
					setMotion: MoveTo (- (ego x?) 24) (+ (ego y?) 12) self
				)
				(if (== (julanar loop?) 1)
					(branches dispose:)
					(julanar loop: 0 cel: 9)
				)
			)
			(6
				(proc1_19)
				(ego setHeading: 45 self)
			)
			(7 (self dispose:))
		)
	)
)

(instance springTime of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gMiscMusic number: 642 loop: 0 priority: 8 play:)
				(= cycles 1)
			)
			(1
				((= [newABranch local0] (aBranch new:))
					x: (+ 164 [local14 local0])
					y: (+ 169 [local26 local0])
					loop: [local38 local0]
					palette: (if isNightTime 2 else 1)
					init:
					setCycle: End
				)
				(++ local0)
				(= cycles (Random 3 7))
			)
			(2
				(if (<= local0 11)
					(self changeState: 1)
				else
					(= cycles 10)
				)
			)
			(3
				(= local0 0)
				(while (< local0 12)
					([newABranch local0] signal: -32735)
					(++ local0)
				)
				(= local0 0)
				(Bset 124)
				(self dispose:)
			)
		)
	)
)

(instance fruitFall of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(localproc_000c)
				(theFruit
					x: 109
					y: 98
					palette: (if isNightTime 2 else 1)
					init:
					setCycle: End self
				)
			)
			(1
				(ego illegalBits: 0 setMotion: PolyPath 94 172 self)
			)
			(2
				(HighPrint 640 63 103)
				(ego setHeading: 45)
				(= cycles 15)
			)
			(3
				(DisposeDialog)
				(theFruit
					setMotion: MoveTo (theFruit x?) (+ (theFruit y?) 35)
				)
				(ego view: 47 loop: 6 cel: 0 setCycle: End)
				(= cycles 10)
			)
			(4
				(HighPrint 640 64 103 self)
				(AddToScore 647 7)
				(SkillUsed 14 50)
				(theFruit dispose:)
				(ego get: 36 setCycle: Beg)
				(Bset 122)
			)
			(5
				(HighPrint 640 65)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance thang of Actor
	(properties
		x 160
		y 127
		view 641
		priority 15
		signal $4010
		illegalBits $0000
	)
)

(instance theScreen of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(switch local53
					(4
						(thang loop: 0 y: [local119 0] init:)
					)
					(5
						(thang loop: 1 y: [local119 7] init:)
					)
					(27
						(thang loop: 2 y: [local119 13] init:)
					)
					(25
						(thang loop: 3 y: [local119 21] init:)
					)
				)
				(= cycles 2)
			)
			(1
				(if (!= [local119 (= local144 (+ local144 1))] 0)
					(thang cel: local144 y: [local119 local144])
					(= cycles 1)
				else
					(self changeState: 3)
				)
			)
			(2 (self changeState: 1))
			(3
				(if (== local53 5)
					(thang cycleSpeed: 1 setCycle: End self)
				else
					(= cycles 1)
				)
			)
			(4
				(cast eachElementDo: #stopUpd)
				(= cycles 2)
			)
			(5
				(curRoom overlay: 980)
				(UnlockEgo)
				(= cycles 2)
			)
			(6
				(self setScript: awfulNoise)
				(= seconds 8)
			)
			(7
				(Die 1 640 66 80 {You broke the monitor screen!!!})
			)
		)
	)
)

(instance awfulNoise of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gMiscMusic number: 602 loop: 0 priority: 13 play:)
				(= cycles 10)
			)
			(1 (self changeState: 0))
		)
	)
)

(instance wall of Feature
	(properties
		x 160
		y 45
		noun '/wall,cliff,face[<boulder,cliff]'
		nsBottom 91
		nsRight 320
		description {the cliffs}
		lookStr {The steep wall of rock protects this alcove from the desert winds and sun.}
	)
)

(instance wall2 of Feature
	(properties
		x 273
		y 140
		noun '/wall,cliff,face[<boulder,cliff]'
		nsTop 92
		nsLeft 227
		nsBottom 189
		nsRight 319
		description {the cliffs}
		lookStr {The steep incline of rock rises rapidly.}
	)
)
