;;; Sierra Script 1.0 - (do not remove this comment)
(script# 300)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use HandsOffScript)
(use Talker)
(use Plaza)
(use Merchant)
(use KattaMerchant)
(use PlazaDoor)
(use n301)
(use Polygon)
(use ForCount)
(use LoadMany)
(use Extra)
(use Music)
(use Motion)
(use Actor)
(use System)

(public
	rmSPlazaGates 0
	kattaInnSign 1
)

(local
	local0
	[local1 25]
	[local26 10]
	local36
	local37
	local38
	local39
	alichicaTLoop
	local41
	[local42 21] = [16 32 0 300 0 12 31 5 300 1 9 30 3 300 2 5 29 1 300 3 -1]
	[local63 38] = [1 2 3 0 4 5 6 7 8 0 0 10 0 0 11 12 13 0 14 0 15 16 17 18 19 20 23 24 25 26 27 0 28]
	[local101 16] = [35 '//duck,viaduct' 39 '//souvenir' 43 '//map' 44 '//compass' -1 '//stand' 40 '//dinar,cent' -2 '//sock,trashcan,feet,turban,ashtray,guide,keychain,chain,bookend']
	[local117 14] = [29 '//bouquet,plant,merchandise' 32 '//sitar,charmer' 30 '//musician' 31 '//serpent' 33 '//bazaar' -1 '//alichica,ali,alichica']
)
(procedure (localproc_1410)
	(switch (proc3_1 1)
		(2
			(proc3_2 1)
			(SkillUsed 14 10)
			(HighPrint 300 43)
		)
		(1 (HighPrint 300 44))
		(else  (HighPrint 300 45))
	)
)

(procedure (localproc_145a param1 &tmp temp0)
	(= temp0 0)
	(while
		(and
			(!= [local42 temp0] -1)
			(< currentDay [local42 temp0])
		)
		(= temp0 (+ temp0 5))
	)
	(if
		(and
			(!= [local42 temp0] -1)
			(not (Btst [local42 (+ temp0 1)]))
			(!= elementalsStatus 1)
			(> elementalsStatus [local42 (+ temp0 2)])
		)
		(Say
			lisha
			param1
			[local42 (+ temp0 3)]
			[local42 (+ temp0 4)]
		)
		(Bset [local42 (+ temp0 1)])
	else
		(param1 cue:)
	)
)

(instance rmSPlazaGates of Plaza
	(properties
		north 704
		south 290
	)
	
	(method (init)
		(self
			addObstacle:
				(poly1
					init: 0 0 146 0 146 95 87 132 27 181 119 181 120 189 0 189
					yourself:
				)
				(poly2
					init:
						168
						0
						319
						0
						319
						189
						205
						189
						205
						181
						306
						181
						285
						168
						256
						162
						248
						150
						249
						133
						178
						100
						171
						95
					yourself:
				)
		)
		(Bset 16)
		(LoadMany 130 972 969)
		(LoadMany 128 0 300)
		(if (== elementalsStatus 1)
			(LoadMany 128 18 19 61 21 340)
		)
		(if
			(and
				(<= 0 currentTimeZone)
				(<= currentTimeZone 4)
				(<= currentDay 4)
			)
			(Load rsVIEW 305)
			(Load rsTEXT 305)
		)
		(= saveIllegal -32768)
		(if
			(and
				(== currentDay 8)
				(not (Btst 150))
				(ego has: 50)
				(== prevRoomNum 100)
			)
			(proc301_0)
		else
			(= entranceScript scrEntrance)
		)
		(super init:)
		(kattaInnDoor init:)
		(DrawFeature
			alleySign
			leftShadow
			rightShadow
			leftBlock
			rightBlock
		)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(if (<= currentDay 4)
				(++ global307)
				(alichica init:)
				(= saveIllegal (| saveIllegal $0800))
			)
			(if
				(and
					(<= 0 currentTimeZone)
					(<= currentTimeZone 4)
					(not (proc80_0))
				)
				(sitar init:)
				(lisha init:)
				(= saveIllegal (| saveIllegal $3000))
			)
			(if (OneOf currentDay 7 10 15)
				(= local41 1)
				((ScriptID 302 0) init:)
			)
		)
		(if (Btst 181)
			(kattaInnSign
				view: 340
				loop: 9
				cel: 1
				description: {the very burnt sign}
				forceUpd:
				init:
			)
		else
			(kattaInnSign init:)
		)
		(if (== elementalsStatus 1)
			(= topFromY 40)
			(gCMusic number: 140 loop: -1 playBed:)
			((= local0 (ScriptID 309 0)) setCycle: Fwd init:)
		else
			(kattaInnSign addToPic:)
		)
	)
	
	(method (doit)
		(cond 
			(script (script doit:))
			(local39)
			(
				(and
					(or (ego edgeHit?) (& (ego onControl: 1) $0010))
					(cast contains: alichica)
					(== inOut 3)
					(not (Btst 108))
				)
				(if (not local38)
					(= local39 1)
					(ego setMotion: 0)
					(Say alichica self 300 4)
				)
				(Bset 108)
			)
			((and (== elementalsStatus 1) (ego edgeHit?))
				(super doit:)
				(if (< (local0 y?) 75)
					(= inOut 2)
					(= gTopExit 1)
					(curRoom newRoom: 303)
				)
			)
			(else (super doit:))
		)
	)
	
	(method (dispose)
		(DisposeScript 301)
		(DisposeScript 302)
		(DisposeScript 309)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine<in,inner/waterbag')
				(if (ego has: 37)
					(HighPrint 300 5)
				else
					(HighPrint 300 6)
				)
			)
		)
	)
	
	(method (cue)
		(cond 
			(local39 (= local39 0) (super doit:))
			(
				(and
					(== elementalsStatus 1)
					(local0 following?)
					(== inOut 2)
				)
				(= north 303)
				(= inOut 3)
			)
			(else (super cue:))
		)
	)
)

(instance kattaInnDoor of PlazaDoor
	(properties
		x 253
		y 117
		noun '/door[<hotel]'
		description {the door to the Inn}
		lookStr {If you can believe the sign, the door leads to the Katta's Tail Inn.}
		view 301
		loop 3
		priority 6
		signal $4010
		entranceTo 100
		exitDir 1
		xOut 278
		yOut 115
		xIn 230
		yIn 115
	)
	
	(method (isLocked)
		(return 0)
	)
)

(instance alichica of Merchant
	(properties
		x 87
		y 99
		description {Alichica}
		lookStr {This guy looks like he could play the piano, but strangely.}
		view 305
		loop 1
		priority 7
		signal $4010
		illegalBits $0000
		tLoop 1
		myName '//man,merchant,alichica,ali,alichica'
		title {Alichica:}
		color 15
		back 4
		msgFile 305
	)
	
	(method (init)
		(super init:)
		(DrawFeature map alichicaStand backOfStand)
		((curRoom merchants?) add: self)
		(self addWares: mapWare compassWare)
		(if (== currentDay 4) (self setPri: 8))
	)
	
	(method (doit)
		(super doit:)
		(if (curRoom script?) (return))
		(if
			(and
				(not local36)
				(not (Btst 108))
				(< (ego distanceTo: alichica) 60)
			)
			(Say self 300 14 300 15 300 16)
			(= local36 1)
		)
	)
	
	(method (showSelf)
		(Say self 300 7)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//fire') (if (== currentDay 4) (Say alichica 300 13)))
			((or (Said 'why/duck') (Said '/viaduct')) (self showMany: 35 38))
			(else (super handleEvent: pEvent))
		)
		(pEvent claimed?)
	)
	
	(method (atSpec param1)
		(return [local101 param1])
	)
	
	(method (atGen param1)
		(return [local63 param1])
	)
	
	(method (showText param1)
		(switch param1
			(20 (self showMany: param1 22))
			(35 (self showMany: param1 38))
			(4
				(if (== (alichicaStand cel?) 1)
					(Say self msgFile param1)
				else
					(self showText: 0)
				)
			)
			(-1
				(self
					showText: (if (== (alichicaStand cel?) 1) 42 else 41)
				)
			)
			(-2
				(self setScript: alichicaRanOut)
			)
			(else  (super showText: param1))
		)
	)
	
	(method (has)
		(return
			(if (>= currentDay 4)
				(if (Said '/forest')
					(Say self 300 8)
				else
					(Say self 300 9)
				)
				(return -1)
			else
				(return (super has:))
			)
		)
	)
	
	(method (sell)
		(if (== curWare mapWare) (AddToScore 621 7))
		(if (== curWare compassWare) (AddToScore 620 7))
		(super sell: &rest)
	)
	
	(method (sayDoesntHave)
		(self setScript: alichicaRanOut)
	)
	
	(method (sayNotEnoughMoney)
		(Say self 300 10)
	)
	
	(method (sayMoneyNeedsChanging)
		(Say self 300 11)
	)
	
	(method (saySoldBegin)
		(if (== curWare mapWare)
			(self setScript: alichicaBuyMap self (curWare curPrice?))
		else
			(self
				setScript: alichicaBuyCompass self (curWare curPrice?)
			)
		)
	)
	
	(method (saySoldEnd)
		(= local38 1)
	)
	
	(method (sayNotCloseEnough)
		(Say self 300 12)
	)
	
	(method (sayBargainSuccess)
		(Say self self 305 45)
	)
	
	(method (sayBargainFailure)
		(Say self self 305 46)
	)
)

(instance mapWare of Class_84_1
	(properties
		invItem 22
		noun '//map>'
		price 100
		lowPrice 50
		highPrice 150
		canBuyMultiple 0
	)
)

(instance compassWare of Class_84_1
	(properties
		invItem 23
		noun '//compass>'
		price 100
		lowPrice 50
		highPrice 150
		canBuyMultiple 0
	)
)

(instance alichicaStand of PicView
	(properties
		x 77
		y 124
		noun '/stand[<alichica,ali,alichica]'
		description {Alichica's stand}
		view 300
		priority 8
		signal $4010
	)
	
	(method (init)
		(super init:)
		(if (== currentDay 4) (= cel 1))
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if (== (alichicaStand cel?) 1)
					(HighPrint 300 17)
				else
					(HighPrint 300 18)
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance map of PicView
	(properties
		x 60
		y 90
		noun '/map'
		description {the map on the wall}
		lookStr {It is a map of the streets and alleys of Shapeir.}
		view 300
		cel 2
		priority 6
		signal $4010
	)
)

(instance backOfStand of PicView
	(properties
		x 92
		y 118
		z 16
		shiftClick 0
		view 300
		cel 3
		priority 7
		signal $4010
	)
)

(instance lisha of KattaMerchant
	(properties
		x 8
		y 168
		description {Lisha, the Flower Lady}
		lookStr {You see a charming young Katta with a smile for you.}
		priority 12
		signal $4010
		myName '//lisha,catperson,merchant,girl,woman'
		title {Lisha:}
		clothesColor 6
	)
	
	(method (init)
		(super init:)
		(DrawFeature flowerStand)
		(self addWares: flowers)
	)
	
	(method (doit)
		(super doit:)
		(if (curRoom script?) (return))
		(if
		(and (not local37) (< (ego distanceTo: lisha) 60))
			(Say self 300 28)
			(= local37 1)
		)
	)
	
	(method (showSelf)
		(Say self 300 25)
	)
	
	(method (showText param1)
		(switch param1
			(-1
				(if (cast contains: alichica)
					(Say self 300 26)
				else
					(Say self 300 27)
				)
			)
			(else  (super showText: param1))
		)
	)
	
	(method (sell)
		(super sell: &rest)
		(curWare price: 10)
	)
	
	(method (sayNotEnoughMoney)
		(Say self self 300 21)
		(curWare price: 0)
		(= cueMethod 644)
	)
	
	(method (sayMoneyNeedsChanging)
		(if (Btst 185)
			(Say self self 300 19)
		else
			(Bset 185)
			(Say self self 300 20)
			(curWare price: 0)
			(= cueMethod 644)
		)
	)
	
	(method (saySoldBegin)
		(Say self self 300 22)
	)
	
	(method (saySoldEnd)
		(HighPrint 300 23)
	)
	
	(method (sayNotCloseEnough)
		(Say self 300 24)
	)
	
	(method (sayBargainSuccess)
		(Say self self msgFile 34)
	)
	
	(method (sayBargainFailure)
		(Say self self msgFile 35)
	)
	
	(method (atIndividualSpec param1)
		(return [local117 param1])
	)
)

(instance flowers of Class_84_1
	(properties
		invItem 26
		noun '//plant,bouquet>'
		price 10
		lowPrice 5
	)
)

(instance flowerStand of PicView
	(properties
		x 20
		y 172
		noun '/stand,bouquet'
		description {the flower stand}
		lookStr {The flowers at the flower stand are very beautiful indeed, and the charming young Katta girl has a smile for you.}
		view 300
		loop 8
		priority 11
		signal $4010
	)
)

(instance sitar of Prop
	(properties
		x 282
		y 152
		noun '/sitar,charmer,musician,catperson'
		description {Sitar, the snake charmer}
		lookStr {He looks like a charming fellow.}
		view 302
		loop 1
		cel 1
		priority 11
		signal $4210
		cycleSpeed 2
	)
	
	(method (init)
		(super init:)
		(snakeSound init: play:)
		(self setCycle: Fwd)
		(snake init:)
		((curRoom merchants?) add: self)
		(DrawFeature snakeBasket snakeRug)
	)
	
	(method (dispose)
		(snakeSound dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			(
			(Said 'ask,talk,chat/sitar,charmer,musician,catperson') (HighPrint 300 29))
			(
				(Said
					'gave,throw/alm,cent,alm[/sitar,charmer,musician,catperson]'
				)
				(if (not (< (ego distanceTo: sitar) 60))
					(HighPrint 300 30)
					(pEvent claimed: 1)
				else
					(localproc_1410)
				)
			)
			((Said 'get,acquire,grab/alm,cent,alm') (SkillUsed 14 -20) (HighPrint 300 31))
			(
			(Said 'look,examine/sitar,charmer,musician,catperson') (HighPrint 300 32))
			(else (super handleEvent: pEvent))
		)
		(pEvent claimed?)
	)
)

(instance snake of Extra
	(properties
		x 267
		y 143
		noun '/serpent,cobra'
		description {the charmer's snake}
		view 302
		loop 2
		priority 11
		signal $4210
		cycleSpeed 2
		cycleType 2
		hesitation 1
		minCycles 0
		maxCycles 0
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1 (HighPrint 300 33))
			(7 (HighPrint 300 34))
			(9 (HighPrint 300 35))
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance snakeRug of PicView
	(properties
		x 285
		y 158
		noun '/carpet'
		description {the snake charmer's rug}
		lookStr {The rug's design is charming.}
		view 302
		priority 0
		signal $4010
	)
)

(instance snakeBasket of PicView
	(properties
		x 266
		y 149
		noun '/basket'
		description {the snake's basket}
		lookStr {It ain't much, but the snake calls it home.}
		view 302
		cel 1
		priority 11
		signal $0010
	)
)

(instance kattaInnSign of View
	(properties
		x 255
		y 43
		noun '/sign[<hotel]'
		description {the sign of the Katta's Tail Inn}
		view 301
		cel 5
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(if (== view 340)
					(HighPrint 300 36)
				else
					(HighPrint 300 37)
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance alleySign of PicView
	(properties
		x 160
		y 46
		noun '/sign[<alley,bearing,street]'
		description {the alley sign}
		lookStr {The symbol on the sign indicates "North".__The sign itself reads "Junub Tarik," which means "South Street."}
		view 310
		loop 2
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance leftShadow of PicView
	(properties
		x 69
		y 189
		shiftClick 0
		view 300
		loop 5
		priority 0
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rightShadow of PicView
	(properties
		x 257
		y 189
		shiftClick 0
		view 300
		loop 5
		priority 0
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance leftBlock of PicView
	(properties
		x 14
		y 189
		shiftClick 0
		view 300
		loop 6
		priority 15
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rightBlock of PicView
	(properties
		x 305
		y 189
		shiftClick 0
		view 300
		loop 6
		priority 15
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance scrEntrance of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((not (cast contains: alichica)) (self cue:))
					((== (alichicaStand cel?) 1) (Say alichica self 300 38))
					((Btst 108) (Say alichica self 305 (proc1_5 (- global307 1) 29 34)))
					(else (Say alichica self 300 39 300 40 300 41 300 42))
				)
			)
			(1
				(if (cast contains: lisha)
					(localproc_145a self)
				else
					(self cue:)
				)
			)
			(2
				(if local41
					(self setScript: (ScriptID 302 1) self)
				else
					(self cue:)
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance alichicaBuyCompass of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: alichicaLookForNoMap self)
			)
			(1
				(= alichicaTLoop (alichica tLoop?))
				(alichica cycleSpeed: 0 tLoop: -1)
				(Say
					alichica
					self
					(Format
						@local1
						300
						46
						(if (== register 100)
							{one dinar}
						else
							(Format @local26 300 47 register)
						)
					)
				)
			)
			(2
				(HighPrint 300 48 67 -1 40)
				(alichica tLoop: alichicaTLoop)
				(Say alichica self 300 49)
				(self dispose:)
			)
		)
	)
)

(instance alichicaRanOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: alichicaLookForNoMap self)
			)
			(1
				(alichica cycleSpeed: 0)
				(Say alichica 300 50)
				(self dispose:)
			)
		)
	)
)

(instance alichicaLookFor of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say alichica self 300 51))
			(1
				(alichica loop: 4 cel: 255 setCycle: Beg self)
			)
			(2
				(alichica
					loop: 2
					cycleSpeed: 1
					setCycle: ForwardCounter 2 self
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance alichicaLookForNoMap of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: alichicaLookFor self)
			)
			(1
				(alichica loop: 4 cel: 0 setCycle: End self)
			)
			(2
				(alichica loop: 1 cel: 0)
				(self dispose:)
			)
		)
	)
)

(instance alichicaBuyMap of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: alichicaLookFor self)
			)
			(1
				(alichica loop: 3 cel: 0 setCycle: End self)
			)
			(2
				(= alichicaTLoop (alichica tLoop?))
				(alichica cycleSpeed: 0 tLoop: -1)
				(Say
					alichica
					self
					(Format
						@local1
						300
						52
						(if (== register 100)
							{one dinar}
						else
							(Format @local26 300 47 register)
						)
					)
				)
			)
			(3
				(HighPrint 300 53 67 -1 40)
				(alichica tLoop: alichicaTLoop)
				(Say alichica self 300 49)
				(self dispose:)
			)
		)
	)
)

(instance snakeSound of Sound
	(properties
		number 305
		priority 5
		loop -1
	)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)

(instance poly2 of Polygon
	(properties
		type $0002
	)
)
