;;; Sierra Script 1.0 - (do not remove this comment)
(script# 675)
(include sci.sh)
(use Main)
(use Monster)
(use Motion)
(use System)

(public
	tSaurus 0
)

(local
	local0
)
(instance tSaurus of Monster
	(properties
		x 173
		y 110
		noun '/saurii,dinosaur,monster,creature'
		description {the TerrorSaurus}
		lookStr {The Terrorsaurus are extremely quick-footed creatures.}
		yStep 3
		view 675
		priority 5
		xStep 5
		strength 150
		intell 50
		agil 120
		vit 150
		luck 100
		weap 180
		armorValue 5
		weapValue 8
		barX 235
		barMessage {TerrorSaurus}
		chaseDelay 3
		attackRange 100
		battleMusic 54
		endMusic 55
	)
	
	(method (initCombat)
		(= combatScript saurScript)
		(= weap (+ [skills 5] 40))
		(super initCombat: &rest)
	)
)

(instance saurScript of Script
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(= temp1 (Random 4 5))
				(client
					action: 1
					attDirection: (if (== temp1 4) 1 else 0)
					setLoop: temp1
					cel: 0
				)
				(= cycles (Random 5 15))
			)
			(2
				(client cycleSpeed: 1 setCycle: End self)
			)
			(3
				(= clientOpponent (client opponent?))
				(if (client tryAttack: clientOpponent 0)
					(client doDamage: clientOpponent 0 1)
				)
				(= cycles 2)
			)
			(4
				(client cycleSpeed: 1 setCycle: Beg self)
			)
			(5
				(client action: 0 setLoop: 0)
				(self changeState: 1)
			)
		)
	)
)
