;;; Sierra Script 1.0 - (do not remove this comment)
(script# 71)
(include sci.sh)
(use Main)
(use n001)
(use Intrface)
(use Window)
(use Save)

(public
	theInvSheet 0
)

(local
	local0
	local1
	local2
)
(procedure (localproc_062a param1 param2 param3 &tmp temp0 [temp1 8])
	(= temp0 (- param1 19))
	(Display
		(Format @temp1 71 4 [spellCost temp0])
		dsCOORD
		(+ param2 7)
		param3
		dsALIGN
		0
		dsFONT
		smallFont
		dsCOLOR
		1
		dsWIDTH
		20
	)
	(if
		(or
			(and (== param1 23) zapMeleeBonus)
			(and (== param1 28) (Btst 90))
			(and (== param1 29) (Btst 86))
		)
		(Display
			71
			13
			dsCOORD
			(+ param2 22)
			param3
			dsALIGN
			0
			dsFONT
			smallFont
			dsCOLOR
			12
		)
	)
	(Display
		12
		temp0
		100
		(+ param2 33)
		param3
		101
		0
		105
		smallFont
		102
		1
	)
	(Display
		(Format @temp1 71 4 [skills param1])
		dsCOORD
		(+ param2 105)
		param3
		dsALIGN
		0
		dsFONT
		smallFont
		dsCOLOR
		1
	)
)

(procedure (localproc_06fc param1 param2 &tmp theInvNum temp1)
	(Format param1 71 14 (= theInvNum [invNum param2]))
	(if (== param2 37)
		(= temp1 (/ currentWater [invNum 37]))
		(StrCat
			param1
			(cond 
				((<= currentWater 0) {Empty_})
				((<= temp1 3) {Almost empty_})
				((<= temp1 6) {Half Full_})
				((< temp1 10) {Mostly Full_})
				(else {Full_})
			)
		)
	)
	(if (and (== param2 33) (> elementalsStatus 1))
		(StrCat param1 {Magic Lamp})
	else
		(InvPlurals (StrEnd param1) param2)
	)
)

(instance printWindow of Window
	(properties)
	
	(method (dispose)
		(self restore:)
		(if window (DisposeWindow window 1) (= window 0))
		(super dispose:)
	)
)

(instance theInvSheet of Dialog
	(properties)
	
	(method (doit &tmp temp0 temp1 temp2 temp3 [temp4 40] temp44 temp45)
		(= temp0 3)
		(= local0 0)
		(while (<= temp0 58)
			(if [invNum temp0] (++ local0))
			(++ temp0)
		)
		(= local1 0)
		(= local2 0)
		(if (not local0)
			(if (not (= local1 (Memory 2 38)))
				(HighPrint 71 0)
				(self dispose:)
				(return 0)
			)
			(StrCpy local1 {__Nothing})
			(= temp44 (+ local1 37))
		else
			(if
			(not (= local1 (Memory 2 (+ (* local0 37) 1))))
				(HighPrint 71 0)
				(self dispose:)
				(return 0)
			)
			(if (not (= local2 (Memory 2 (* local0 2))))
				(HighPrint 71 0)
				(self dispose:)
				(return 0)
			)
			(= temp0 3)
			(= temp44 local1)
			(= temp45 0)
			(while (<= temp0 58)
				(if [invNum temp0]
					(Memory 6 (+ local2 (* temp45 2)) temp0)
					(localproc_06fc temp44 temp0)
					(= temp44 (+ temp44 37))
					(++ temp45)
				)
				(++ temp0)
			)
		)
		(StrAt temp44 0 0)
		(selectorItem
			text: local1
			font: smallFont
			setSize:
			moveTo: 11 19
		)
		(exitButton setSize:)
		(self
			window: SysWindow
			nsTop: 0
			nsLeft: 0
			nsBottom: 189
			nsRight: 320
			add: selectorItem
			add: exitButton
			open: 0 -1
			setSize:
			center:
		)
		(Display
			71
			1
			dsCOORD
			(selectorItem nsLeft?)
			5
			dsWIDTH
			(- (selectorItem nsRight?) (selectorItem nsLeft?))
			dsALIGN
			1
			dsFONT
			300
			dsCOLOR
			0
		)
		(= temp3 (proc1_22))
		(cond 
			((== temp1 24)
				(Display
					71
					2
					dsCOORD
					40
					(+ temp1 5)
					dsALIGN
					0
					dsFONT
					300
					dsCOLOR
					1
				)
			)
			((>= temp1 174)
				(Display
					71
					3
					dsCOORD
					40
					172
					dsALIGN
					0
					dsFONT
					300
					dsCOLOR
					1
				)
			)
		)
		(= temp2 (if (< colorCount 16) 4 else 12))
		(Display
			(Format @temp4 71 4 [invNum 2])
			dsCOORD
			180
			6
			dsALIGN
			-1
			dsFONT
			300
			dsCOLOR
			temp2
			dsWIDTH
			25
		)
		(Display
			71
			5
			dsCOORD
			217
			6
			dsALIGN
			0
			dsFONT
			300
			dsCOLOR
			temp2
		)
		(= temp2 6)
		(Display
			(Format @temp4 71 4 [invNum 1])
			dsCOORD
			180
			18
			dsALIGN
			-1
			dsFONT
			300
			dsCOLOR
			temp2
			dsWIDTH
			25
		)
		(Display
			71
			6
			dsCOORD
			217
			18
			dsALIGN
			0
			dsFONT
			300
			dsCOLOR
			temp2
		)
		(= temp2
			(cond 
				((< temp3 (/ (* (GetMaxWeight) 90) 100)) 1)
				((< colorCount 16) 4)
				(else 12)
			)
		)
		(Display
			(Format @temp4 71 7 temp3)
			dsCOORD
			180
			30
			dsALIGN
			-1
			dsFONT
			300
			dsCOLOR
			temp2
			dsWIDTH
			25
		)
		(Display
			71
			8
			dsCOORD
			217
			30
			dsALIGN
			0
			dsFONT
			300
			dsCOLOR
			temp2
		)
		(Display
			(Format @temp4 71 7 (GetMaxWeight))
			dsCOORD
			180
			42
			dsALIGN
			-1
			dsFONT
			300
			dsCOLOR
			temp2
			dsWIDTH
			25
		)
		(Display
			71
			9
			dsCOORD
			217
			42
			dsALIGN
			0
			dsFONT
			300
			dsCOLOR
			temp2
		)
		(if [skills 12]
			(Display
				71
				10
				dsCOORD
				185
				59
				dsALIGN
				0
				dsFONT
				300
				dsCOLOR
				1
			)
			(Display
				71
				11
				dsCOORD
				218
				59
				dsALIGN
				0
				dsFONT
				300
				dsCOLOR
				1
			)
			(Display
				71
				12
				dsCOORD
				280
				59
				dsALIGN
				0
				dsFONT
				300
				dsCOLOR
				1
			)
			(= temp1 71)
			(= temp0 19)
			(= temp1 71)
			(while (< temp0 30)
				(if (> [skills temp0] 0)
					(localproc_062a temp0 185 temp1)
					(= temp1 (+ temp1 9))
				)
				(++ temp0)
			)
		)
		(super doit: exitButton)
		(return (self dispose:))
	)
	
	(method (dispose)
		(if local1 (Memory 3 local1))
		(if local2 (Memory 3 local2))
		(super dispose:)
	)
)

(instance exitButton of DButton
	(properties
		nsTop 173
		nsLeft 232
		text { Done_}
	)
)

(instance selectorItem of DSelector
	(properties
		state $0001
		x 37
		y 18
	)
	
	(method (showSelf &tmp temp0 temp1 [temp2 100])
		(if local0
			(= temp0
				(Memory 5 (+ local2 (* (self indexOf: cursor) 2)))
			)
			(InvPlurals @temp2 temp0)
			(= temp1 (+ temp0 temp0 1))
			(if (and (== temp0 33) (>= elementalsStatus 2))
				(= temp1 118)
			)
			(if
				(and
					(== temp0 25)
					(<= 4 elementalsStatus)
					(<= elementalsStatus 8)
				)
				(= temp1 119)
			)
			(Print 11 temp1 80 @temp2 35 printWindow)
		else
			(Print
				{__________________________}
				#title
				{Nothing}
				#window
				printWindow
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(switch (pEvent type?)
			(evKEYBOARD
				(if
				(and (& state $0008) (== (pEvent message?) KEY_RETURN))
					(self showSelf:)
					(return self)
				)
			)
			(evMOUSEBUTTON
				(if
					(and
						(self check: pEvent)
						(< (+ nsTop 10) (pEvent y?))
						(< (pEvent y?) (- nsBottom 10))
					)
					(= temp0 (super handleEvent: pEvent))
					(self showSelf:)
					(return temp0)
				)
			)
		)
		(return (super handleEvent: pEvent))
	)
)
