;;; Sierra Script 1.0 - (do not remove this comment)
(script# 222)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use TargActor)
(use Full)
(use rm220)
(use Motion)
(use Actor)
(use System)

(public
	waterSP 0
	fireSP 1
)

(local
	local0
	[local1 9] = [20 27 14 17 21 32 25 38 -1]
	[local10 9] = [15 47 21 16 17 34 18 25 -1]
	local19
	local20
)
(procedure (localproc_1aec)
	(if (> (curRoom notify: 6) 13)
		(curRoom notify: 6 (if (door cel?) 13 else 12))
	)
)

(instance waterSP of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Load rsSOUND 15)
				(Load rsSOUND 16)
				(bullseye init: view: 224 setLoop: 3 hide:)
				(iceL
					posn: 139 108
					view: 224
					setLoop: 2
					cel: 0
					setStep: 2 1
					palette: 3
					init:
					setMotion: MoveTo 143 109 self
				)
			)
			(1
				(iceL cel: 1 setMotion: MoveTo 151 110 self)
			)
			(2
				(iceL cel: 2 setMotion: MoveTo 159 111 self)
			)
			(3
				(iceL cel: 3 setMotion: MoveTo 170 113 self)
			)
			(4
				(proc1_19)
				(ego setMotion: 0)
				(iceL
					setLoop: 0
					setCel: 0
					posn: 151 114
					setPri: 8
					palette: 1
					stopUpd:
				)
				((= local0 (Clone iceL))
					view: 224
					setLoop: 1
					setCel: 0
					posn: 189 114
					init:
					setPri: 8
					stopUpd:
				)
				(proc220_5)
				(curRoom notify: 6 7)
				(proc1_19)
				(ego illegalBits: -16384)
				(LockEgo 1)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'climb,scale') (self setScript: (ScriptID 220 2)))
		)
	)
)

(instance fireSP of Script
	(properties)
	
	(method (doit)
		(super doit: &rest)
		(cond 
			((== (curRoom notify: 6) 16))
			((!= (ego onControl: 1) 16384))
			((== (door cel?) (door lastCel:)) (client setScript: fryEgoSP))
			((== (curRoom notify: 6) 5) (self changeState: 8))
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door
					posn: 144 108
					view: 227
					setLoop: 11
					cel: 0
					setStep: 2 1
					init:
					setCycle: End
					setMotion: MoveTo 152 111 self
				)
			)
			(1
				(door setMotion: MoveTo 164 115 self)
			)
			(2
				(proc1_19)
				(ego setMotion: 0)
				(door setPri: 8 setLoop: 0 cel: 0 stopUpd:)
				(gSpareMusic number: 140 loop: -1 priority: 5 init: play:)
				(fire
					view: 227
					loop: 7
					posn: 172 114
					setPri: 7
					init:
					cycleSpeed: 0
					setCycle: Fwd
				)
				(curRoom notify: 6 12)
				(proc220_5)
				(LockEgo)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'feel/door') (self setScript: doorSP self 2))
			((Said 'knock/door') (self setScript: doorSP self 1))
			((Said 'force/door') (self setScript: doorSP self 3))
			((Said 'climb,scale') (PrintWarning 222 0))
		)
	)
)

(instance meltIceSP of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(proc1_19)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(iceL forceUpd: palette: 2 stopUpd:)
				(local0 forceUpd: palette: 2 stopUpd:)
				(= cycles 1)
			)
			(1
				(iceL forceUpd: palette: 3)
				(local0 forceUpd: palette: 3)
				(= cycles 2)
			)
			(2
				(iceL forceUpd: palette: 4)
				(local0 forceUpd: palette: 4)
				(if (== (curRoom notify: 6) 7)
					(iceL setMotion: MoveTo 149 114)
					(local0 setMotion: MoveTo 191 114)
				)
				(= cycles 2)
			)
			(3
				(iceL forceUpd: palette: 5)
				(local0 forceUpd: palette: 5)
				(= cycles 2)
			)
			(4
				(atU
					init:
					posn: 176 118
					view: 226
					loop: 0
					cel: 0
					cycleSpeed: (- 6 (curRoom notify: 6))
					setCycle: CT 3 1 self
				)
			)
			(5
				(iceL forceUpd: palette: 2)
				(local0 forceUpd: palette: 2)
				(ego
					setLoop: (ego loop?)
					setCel: (ego cel?)
					setStep: 1 1
					setMotion: MoveTo (+ (ego x?) 4) (+ (ego y?) 3)
				)
				((ScriptID 220 9)
					show:
					view: 226
					posn: 238 148
					loop: 1
					cel: 0
					cycleSpeed: (- 10 (curRoom notify: 6))
					setCycle: End self
				)
				(atU setCycle: End)
				(if (>= (curRoom notify: 6) 9)
					(client setScript: washAwaySP)
				)
			)
			(6
				(switch (curRoom notify: 6)
					(7
						(curRoom notify: 6 8)
						(bullseye show:)
						(HighPrint 222 1)
					)
					(8
						(curRoom notify: 6 9)
						(HighPrint 222 2)
					)
				)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance washAwaySP of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 225
					setLoop: 8
					setCel: 0
					setStep: 4 4
					setMotion: MoveTo 310 280
				)
			)
		)
	)
)

(instance breakIceSP of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(LockEgo 1)
		(proc1_19)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bolt show: posn: (client hitX?) (client hitY?))
				(= local19 0)
				(= local20 0)
				(iceL setStep: 1 1 moveSpeed: 10)
				(local0 setStep: 1 1 moveSpeed: 10)
				(switch (curRoom notify: 6)
					(8
						(iceL setMotion: MoveTo 147 114)
						(local0 setMotion: MoveTo 193 114 self)
						(bolt setScript: bounceBoltS init:)
						(curRoom notify: 6 10)
					)
					(9
						(iceL setMotion: MoveTo 147 114)
						(local0 setMotion: MoveTo 193 114 self)
						(bolt setScript: bounceBoltS)
						(curRoom notify: 6 10)
					)
					(10
						(iceL setMotion: MoveTo 145 114)
						(local0 setMotion: MoveTo 195 114 self)
						(bolt setScript: bounceBoltS)
						(curRoom notify: 6 11)
					)
					(11
						(bolt dispose:)
						(client setScript: iceFallSP)
					)
				)
			)
			(1
				(iceL stopUpd:)
				(local0 stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance iceFallSP of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(iceL moveSpeed: 0 setMotion: MoveTo 139 114 self)
				(local0 moveSpeed: 0 setMotion: MoveTo 201 114)
			)
			(1
				(iceL setStep: 3 8 setMotion: MoveTo 131 152 self)
				(local0 setStep: 3 8 setPri: 1 setMotion: MoveTo 209 152)
			)
			(2
				(iceL setStep: 2 12 setMotion: MoveTo 127 274 self)
				(local0 setStep: 2 12 setMotion: MoveTo 213 274)
			)
			(3
				(UnlockEgo)
				(ego setMotion: MoveTo 246 141 self)
			)
			(4 (ego setHeading: 315 self))
			(5
				(iceL dispose:)
				(local0 dispose:)
				(AddToScore 690 7 1)
				(Bset 69)
				(LockEgo)
				(curRoom setScript: (ScriptID 220 3))
				(client dispose:)
			)
		)
	)
)

(instance bounceBoltS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bolt
					setLoop: 6
					setCycle: Fwd
					setMotion:
						MoveTo
						(+ (iceL x?) [local1 local19])
						(- (iceL y?) [local1 (++ local19)])
						self
				)
			)
			(1
				(bolt setLoop: 7 cel: 0 setCycle: End self)
			)
			(2
				(bolt
					setLoop: 6
					setCycle: Fwd
					setMotion:
						MoveTo
						(- (local0 x?) [local10 local20])
						(- (local0 y?) [local10 (++ local20)])
						self
				)
			)
			(3
				(bolt setLoop: 7 cel: 0 setCycle: End self)
			)
			(4
				(if (!= [local1 (++ local19)] -1)
					(++ local20)
					(self changeState: 0)
				else
					(bolt
						setLoop: 6
						setCycle: Fwd
						setMotion: MoveTo (Random 50 80) (Random 40 76) self
					)
				)
			)
			(5
				(bolt hide:)
				(self dispose:)
			)
		)
	)
)

(instance doorSP of HandsOffScript
	(properties)
	
	(method (dispose)
		(proc1_19)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 198 122 self)
			)
			(1
				(ego
					view: 225
					setLoop: 3
					cel: 0
					cycleSpeed: 1
					setCycle: CT 3 1
					setMotion: MoveTo 208 123 self
				)
				(if (== register 0)
					(door cel: 0 cycleSpeed: 1 setCycle: End)
				)
			)
			(2
				(switch register
					(1
						(HighPrint 222 3)
						(PrintWarning 222 4)
						(HighPrint 222 5)
						(PrintWarning 222 6)
						(HighPrint 222 7)
						(self dispose:)
					)
					(2
						(HighPrint 222 8)
						(self dispose:)
					)
					(3
						((ScriptID 220 8) setPri: 0 init:)
						(Say (ScriptID 220 8) self 222 9)
					)
					(0
						(if (<= (curRoom notify: 6) 13)
							(curRoom setScript: fryEgoSP)
						else
							(self dispose:)
						)
					)
				)
			)
			(3
				((ScriptID 220 8) dispose:)
				(self dispose:)
			)
		)
	)
)

(instance burnDoorSP of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door setLoop: 1 cel: 0 cycleSpeed: 3 setCycle: End self)
			)
			(1
				(door setLoop: 9 cel: 0 setCycle: End self)
			)
			(2
				(door setLoop: 3 setCycle: Fwd)
				(= cycles 12)
			)
			(3
				(PrintWarning 222 10)
				(atU
					view: 227
					init:
					loop: 10
					cel: 0
					posn: 192 115
					cycleSpeed: 2
					setCycle: Full 3 self
				)
			)
			(4 (client setScript: fryEgoSP))
		)
	)
)

(instance walkOverDoorSP of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door setLoop: 1 cel: 0 cycleSpeed: 3 setCycle: End self)
			)
			(1
				(ego
					ignoreActors:
					illegalBits: 0
					setLoop: 7
					setPri: 9
					setMotion: MoveTo 191 120 self
				)
				(door setPri: 8 setCel: 3)
				(gSpareMusic loop: 1 fade:)
				(fire dispose:)
			)
			(2
				(proc220_4)
				(ego cycleSpeed: 0 setCycle: Fwd)
				(door setMotion: MoveTo 212 130 self)
			)
			(3
				(door
					setLoop: 1
					setCel: 2
					setStep: 6 9
					setMotion: MoveTo 235 142 self
				)
			)
			(4
				(door
					setCycle: CT 2 -1 self
					setMotion: MoveTo 290 220 self
				)
			)
			(5
				(AddToScore 689 15 1)
				(Bset 65)
				(SkillUsed 14 100)
				(door setLoop: 11 setCel: 0)
				(SetUpEgo)
				(HighPrint 222 11)
				(= cycles 10)
			)
			(6
				((ScriptID 220 9)
					view: 220
					loop: 5
					cel: 0
					setPri: 15
					posn: (+ (ego x?) 2) (- (ego y?) 20)
					setCycle: CT 2 1 self
				)
			)
			(7
				(ego hide:)
				((ScriptID 220 9) setCycle: End self)
			)
			(8 (curRoom newRoom: 210))
		)
	)
)

(instance calmFireSP of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fire setLoop: 7 cel: 0 cycleSpeed: 3 setCycle: End self)
			)
			(1
				(fire setLoop: 8 cycleSpeed: 1 setCycle: Fwd)
				(= cycles 22)
			)
			(2
				(fire posn: 166 116 setLoop: 6 cycleSpeed: 0)
				(= cycles 18)
			)
			(3
				(PrintWarning 222 12)
				(curRoom notify: 6 14)
				(self dispose:)
			)
		)
	)
)

(instance fryEgoSP of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(atU
					view: 227
					init:
					loop: 10
					cel: 0
					posn: 192 115
					cycleSpeed: 2
					setCycle: Full 4
				)
				(ego view: 225 setLoop: 3 setCycle: End self)
			)
			(1
				((ScriptID 220 9)
					view: 220
					loop: 5
					setPri: 15
					cel: 0
					posn: (+ (ego x?) 14) (- (ego y?) 22)
					setCycle: CT 2 1 self
				)
				(atU dispose:)
			)
			(2
				(ego dispose:)
				((ScriptID 220 9) setCycle: End self)
			)
			(3
				(= gTopExit 3)
				(curRoom newRoom: 229)
			)
		)
	)
)

(instance atU of Prop
	(properties
		view 227
		priority 8
		signal $4010
	)
)

(instance iceL of TargActor
	(properties
		noun '/ice,ice'
		description {the iceberg}
		lookStr {It is a gigantic piece of ice blocking the path.}
		view 226
		priority 9
		signal $4010
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(if (Said 'climb,scale')
			(pEvent claimed: 0)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (dazzleMe)
		(PrintWarning 222 13)
		(return 1)
	)
	
	(method (detectMe)
		(HighPrint 222 14)
		(return 1)
	)
	
	(method (fetchMe)
		(PrintWarning 222 15)
		(return 0)
	)
	
	(method (hurtMe param1 param2 &tmp temp0)
		(cond 
			((== (param2 type?) 25) (self setScript: meltIceSP))
			((!= (param2 type?) 27))
			((!= (curRoom notify: 6) 7)
				(curRoom
					setScript:
						delayPrintS
						0
						{You need to target your spell better to use the Iceberg's weakness against it.}
				)
			)
			(else
				(curRoom
					setScript:
						delayPrintS
						0
						{The Force Bolt has no effect against such a solid mass of ice.}
				)
			)
		)
		(return 1)
	)
	
	(method (triggerMe)
		(PrintWarning 222 13)
		(return 0)
	)
)

(instance bullseye of TargActor
	(properties
		x 172
		y 114
		noun '/crack'
		description {the fissure in the ice}
		lookStr {The fissure in the ice seems to be its weakest spot}
		view 224
		loop 3
		signal $4000
		illegalBits $0000
	)
	
	(method (calmMe)
		(HighPrint 222 17)
		(return 1)
	)
	
	(method (fetchMe)
		(PrintWarning 222 13)
		(return 0)
	)
	
	(method (hurtMe param1 param2 &tmp temp0)
		(switch (param2 type?)
			(27
				(self setScript: breakIceSP)
				(return 1)
			)
			(25 (self setScript: meltIceSP))
		)
		(return 0)
	)
	
	(method (openMe)
		(if (< (curRoom notify: 6) 9)
			(PrintWarning 222 16)
		else
			(self setScript: iceFallSP)
			(return 1)
		)
		(return 0)
	)
)

(instance door of TargActor
	(properties
		noun '/door'
		description {the door}
		lookStr {There is a door blocking the pathway.}
		priority 9
		signal $4010
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(3
				(if
					(and
						(<= 13 (curRoom notify: 6))
						(<= (curRoom notify: 6) 14)
					)
					(PrintWarning 222 18)
				else
					(PrintWarning 222 19)
				)
			)
			(2
				(self setScript: doorSP self 0)
			)
			(else  (super doVerb: theVerb))
		)
	)
	
	(method (calmMe)
		(switch (curRoom notify: 6)
			(12
				(self
					setScript: delayPrintS 0 {The door seems to have absorbed your spell.}
				)
			)
			(13
				(self setScript: calmFireSP)
			)
			(14
				(self
					setScript: delayPrintS 0 {The flames are as calm as they're going to get.}
				)
			)
		)
		(return 1)
	)
	
	(method (dazzleMe)
		(PrintWarning 222 13)
		(return 1)
	)
	
	(method (detectMe)
		(HighPrint 222 20)
		(return 1)
	)
	
	(method (fetchMe)
		(switch (curRoom notify: 6)
			(14
				(if (< hitX 173)
					(self setCycle: Beg)
					(curRoom notify: 6 15)
					(self
						setScript:
							delayPrintS
							0
							{Say, have you figured this out, or are you just playing it by ear?}
					)
				else
					(PrintWarning 222 21)
				)
			)
			(13
				(if (< hitX 173)
					(self setCycle: Beg)
					(curRoom notify: 6 12)
					(self
						setScript:
							delayPrintS
							0
							{That turned down the heat, but the flames are burning through the door again._}
					)
				else
					(PrintWarning 222 21)
				)
			)
			(else  (PrintWarning 222 22))
		)
		(return 0)
	)
	
	(method (hurtMe param1 param2 &tmp temp0)
		(switch (param2 type?)
			(25
				(switch (curRoom notify: 6)
					(12
						(self
							setScript: delayPrintS 0 {The door resists your flame.}
						)
					)
					(15
						(localproc_1aec)
						(fire setLoop: 3)
						(self
							setScript: delayPrintS 0 {The flames seem to burn more intensely.}
						)
					)
					(else 
						(self
							setScript: delayPrintS 0 {The flames seem to burn more intensely.}
						)
					)
				)
			)
			(27
				(switch (curRoom notify: 6)
					(12
						(if (< hitY 84) (self setScript: burnDoorSP))
					)
					(15
						(if (< hitY 84)
							(curRoom notify: 6 16)
							(self setScript: walkOverDoorSP)
						)
					)
					(else 
						(self
							setScript: delayPrintS 0 {The flames seem to burn more intensely.}
						)
					)
				)
			)
		)
		(return 1)
	)
	
	(method (openMe)
		(if (OneOf (curRoom notify: 6) 12 15)
			(self cycleSpeed: 1 setCycle: End)
			(fire setLoop: 3)
			(curRoom notify: 6 13)
			(self
				setScript:
					delayPrintS
					0
					{With the door open, the fire's heat is more intense.}
			)
		else
			(PrintWarning 222 23)
		)
		(return 0)
	)
	
	(method (triggerMe)
		(PrintWarning 222 13)
		(return 0)
	)
)

(instance fire of TargActor
	(properties
		noun '/fire,flame'
		description {the flames}
		lookStr {There are some flames behind the door}
		priority 9
		signal $4010
		illegalBits $0000
	)
	
	(method (calmMe)
		(switch (curRoom notify: 6)
			(12
				(self
					setScript: delayPrintS 0 {The door seems to have absorbed your spell.}
				)
			)
			(13
				(self setLoop: 7)
				(curRoom notify: 6 14)
				(return 1)
			)
			(14
				(self
					setScript: delayPrintS 0 {The flames are as calm as they're going to get.}
				)
			)
		)
		(return 0)
	)
	
	(method (fetchMe)
		(PrintWarning 222 13)
		(return 0)
	)
	
	(method (hurtMe &tmp temp0)
		(localproc_1aec)
		(fire setLoop: 3)
		(self
			setScript: delayPrintS 0 {The flames seem to burn more intensely.}
		)
		(return 1)
	)
	
	(method (openMe)
		(PrintWarning 222 13)
		(return 0)
	)
)

(instance bolt of Actor
	(properties
		noun '/bolt'
		description {the force bolt}
		lookStr {The force bolt bounces within the iceberg}
		yStep 10
		view 32
		priority 9
		signal $4010
		illegalBits $0000
		xStep 10
	)
)

(instance delayPrintS of Script
	(properties)
	
	(method (doit)
		(if (and (not (Btst 87)) register) (self cue:))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(PrintWarning register)
				(= register 0)
				(self dispose:)
			)
		)
	)
)
