;;; Sierra Script 1.0 - (do not remove this comment)
(script# 163)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Motion)
(use System)

(public
	welcomeS 0
	enterS 1
	enterAward 2
	enterEOF 3
	enterHelpNeeded 4
	enterHelpDone 5
	enterCongrats 6
)

(local
	[local0 50]
	[local50 50]
)
(procedure (localproc_0018)
	(switch (Random 0 4)
		(0
			(Say (ScriptID 160 1) welcomeS 163 0)
		)
		(1
			(Say (ScriptID 160 1) welcomeS 163 1)
		)
		(2
			(Say (ScriptID 160 1) welcomeS 163 2)
		)
		(3
			(Say (ScriptID 160 1) welcomeS 163 3)
		)
		(4
			(Say (ScriptID 160 1) welcomeS 163 4)
		)
	)
)

(instance welcomeS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(FaceObject ego (ScriptID 160 3))
				(cond 
					((Btst 177) (localproc_0018))
					((== currentDay 1) (Say (ScriptID 160 1) self 163 5 163 6))
					((== currentDay 2) (Say (ScriptID 160 1) self 163 7))
					(
						(and
							(== elementalsStatus 1)
							(<= 5 currentDay)
							(<= currentDay 6)
						)
						(Say (ScriptID 160 1) self 163 8)
					)
					((and (<= 9 currentDay) (<= currentDay 10))
						(if (< elementalsStatus 4)
							(Say (ScriptID 160 1) self 163 9)
						else
							(Say (ScriptID 160 1) self 163 10)
						)
					)
					((== currentDay 11) (Say (ScriptID 160 1) self 163 11))
					((== currentDay 13)
						(if (== elementalsStatus 6)
							(Say (ScriptID 160 1) self 163 12)
						else
							(Say (ScriptID 160 1) self 163 13)
						)
					)
					(else (localproc_0018))
				)
			)
			(1
				(if (and (== currentDay 2) (not (Btst 177)))
					(FaceObject ego (ScriptID 160 4))
					(Say (ScriptID 160 2) self 163 14)
				else
					(self dispose:)
				)
			)
			(2 (self dispose:))
		)
	)
)

(instance enterS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(FaceObject ego (ScriptID 160 3))
				(Say (ScriptID 160 1) self 163 15)
			)
			(1 (self dispose:))
		)
	)
)

(instance enterAward of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(FaceObject ego (ScriptID 160 2))
				(Say (ScriptID 160 2) self 163 16)
			)
			(1
				(ego setMotion: MoveTo 200 170 self)
			)
			(2
				(FaceObject ego (ScriptID 160 2))
				(= cycles 14)
			)
			(3
				(ego setMotion: MoveTo 220 180 self)
			)
			(4
				(HighPrint 163 17)
				(ego get: 2 50)
				(AddToScore 610 3)
				(SkillUsed 14 50)
				(self cue:)
			)
			(5
				(FaceObject ego (ScriptID 160 2))
				(Say (ScriptID 160 2) self 163 18)
			)
			(6 (self dispose:))
		)
	)
)

(instance enterEOF of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: welcomeS self)
			)
			(1
				(FaceObject ego (ScriptID 160 3))
				(switch currentDay
					(13
						(Say (ScriptID 160 1) self 163 19)
					)
					(14
						(Say (ScriptID 160 1) self 163 20)
					)
					(15
						(Say (ScriptID 160 1) self 163 21)
					)
				)
			)
			(2
				(ego setMotion: MoveTo 220 165 self)
			)
			(3
				(FaceObject ego (ScriptID 160 3))
				(= cycles 14)
			)
			(4
				(ego setMotion: MoveTo 230 180 self)
			)
			(5
				(switch currentDay
					(13 (Format @local0 163 22))
					(14 (Format @local0 163 23))
					(15 (Format @local0 163 24))
				)
				(Format @local50 163 25 @local0)
				(HighPrint @local50)
				(self cue:)
			)
			(6
				(switch currentDay
					(13 (HighPrint 163 26))
					(14 (HighPrint 163 27))
					(15 (HighPrint 163 28))
				)
				(self cue:)
			)
			(7 (self dispose:))
		)
	)
)

(instance enterHelpNeeded of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
					(or
						(== currentDay 2)
						(and (== elementalsStatus 5) (== gHeroType 0))
					)
					(FaceObject ego (ScriptID 160 2))
					(Say (ScriptID 160 2) self 163 29)
				else
					(self changeState: 3)
				)
			)
			(1
				(FaceObject ego (ScriptID 160 3))
				(Say (ScriptID 160 1) self 163 30 163 31)
			)
			(2
				(FaceObject ego (ScriptID 160 2))
				(Say (ScriptID 160 2) self 163 32 163 33)
			)
			(3 (self dispose:))
		)
	)
)

(instance enterHelpDone of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: welcomeS self)
			)
			(1
				(FaceObject ego (ScriptID 160 3))
				(Say (ScriptID 160 1) self 163 34)
			)
			(2
				(if (and (Btst 72) (not (Btst 661)))
					(Say (ScriptID 160 1) self 163 35)
				else
					(self dispose:)
				)
			)
			(3
				(proc1_32 (ScriptID 160 5) 15)
				(self dispose:)
			)
		)
	)
)

(instance enterCongrats of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 100])
		(switch (= state newState)
			(0
				(FaceObject ego (ScriptID 160 2))
				(Say (ScriptID 160 2) self 163 36)
			)
			(1
				(cond 
					((== heroType 3) (Say (ScriptID 160 2) self 163 37))
					((== heroType 0) (Say (ScriptID 160 2) self 163 38))
					((== heroType 2) (Say (ScriptID 160 2) self 163 39))
					((== heroType 1) (Say (ScriptID 160 2) self 163 40))
				)
			)
			(2
				(Say (ScriptID 160 2) self 163 41 163 42)
			)
			(3
				(Say
					(ScriptID 160 2)
					self
					(Format @temp0 163 43 @userName)
				)
			)
			(4
				(FaceObject ego (ScriptID 160 3))
				(Say (ScriptID 160 1) self 163 44)
			)
			(5
				(if (== gHeroType 0)
					(FaceObject ego (ScriptID 160 2))
					(Say (ScriptID 160 2) self 163 45)
				else
					(self cue:)
				)
			)
			(6 (self dispose:))
		)
	)
)
